/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/types","vs/base/common/errors","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/objects","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/diffComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],x=function(B){for(var n=[],M=0,t=B.length;M<t;M++)n[M]=K[B[M]];return n},ke=this,Te=typeof global=="object"?global:{},le;(function(B){B.global=ke;var n=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();B.Environment=n})(le||(le={}));var le;(function(B){var n=function(){function R(o,y,h){this.type=o,this.detail=y,this.timestamp=h}return R}();B.LoaderEvent=n;var M=function(){function R(o){this._events=[new n(1,"",o)]}return R.prototype.record=function(o,y){this._events.push(new n(o,y,B.Utilities.getHighPerformanceTimestamp()))},R.prototype.getEvents=function(){return this._events},R}();B.LoaderEventRecorder=M;var t=function(){function R(){}return R.prototype.record=function(o,y){},R.prototype.getEvents=function(){return[]},R.INSTANCE=new R,R}();B.NullLoaderEventRecorder=t})(le||(le={}));var le;(function(B){var n=function(){function M(){}return M.fileUriToFilePath=function(t,R){if(R=decodeURI(R).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(R))return R.substr(8);if(/^file:\/\//.test(R))return R.substr(5)}else if(/^file:\/\//.test(R))return R.substr(7);return R},M.startsWith=function(t,R){return t.length>=R.length&&t.substr(0,R.length)===R},M.endsWith=function(t,R){return t.length>=R.length&&t.substr(t.length-R.length)===R},M.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},M.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},M.forEachProperty=function(t,R){if(t){var o=void 0;for(o in t)t.hasOwnProperty(o)&&R(o,t[o])}},M.isEmpty=function(t){var R=!0;return M.forEachProperty(t,function(){R=!1}),R},M.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var R=Array.isArray(t)?[]:{};return M.forEachProperty(t,function(o,y){y&&typeof y=="object"?R[o]=M.recursiveClone(y):R[o]=y}),R},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(t){return M.startsWith(t,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();B.Utilities=n})(le||(le={}));var le;(function(B){function n(R){if(R instanceof Error)return R;var o=new Error(R.message||String(R)||"Unknown Error");return R.stack&&(o.stack=R.stack),o}B.ensureError=n;var M=function(){function R(){}return R.validateConfigurationOptions=function(o){function y(a){if(a.phase==="loading"){console.error('Loading "'+a.moduleId+'" failed'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}if(a.phase==="factory"){console.error('The factory function of "'+a.moduleId+'" has thrown an exception'),console.error(a),console.error("Here are the modules that depend on it:"),console.error(a.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError=="undefined"&&(o.catchError=!1),typeof o.recordStats=="undefined"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=y),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(B.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags=="undefined"&&(o.preferScriptTags=!1),Array.isArray(o.nodeModules)||(o.nodeModules=[]),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){var h=n(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",o.onError(h),o.nodeCachedData=void 0}return o},R.mergeConfigurationOptions=function(o,y){o===void 0&&(o=null),y===void 0&&(y=null);var h=B.Utilities.recursiveClone(y||{});return B.Utilities.forEachProperty(o,function(a,c){a==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules!="undefined"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(c):a==="paths"&&typeof h.paths!="undefined"?B.Utilities.forEachProperty(c,function(E,D){return h.paths[E]=D}):a==="config"&&typeof h.config!="undefined"?B.Utilities.forEachProperty(c,function(E,D){return h.config[E]=D}):h[a]=B.Utilities.recursiveClone(c)}),R.validateConfigurationOptions(h)},R}();B.ConfigurationOptionsUtil=M;var t=function(){function R(o,y){if(this._env=o,this.options=M.mergeConfigurationOptions(y),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var h=this.options.nodeRequire.main.filename,a=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,a+1)}if(this.options.nodeMain&&this._env.isNode){var h=this.options.nodeMain,a=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,a+1)}}}return R.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0},R.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var o=0,y=this.options.nodeModules;o<y.length;o++){var h=y[o];this.nodeModulesMap[h]=!0}},R.prototype._createSortedPathsRules=function(){var o=this;this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,function(y,h){Array.isArray(h)?o.sortedPathsRules.push({from:y,to:h}):o.sortedPathsRules.push({from:y,to:[h]})}),this.sortedPathsRules.sort(function(y,h){return h.from.length-y.from.length})},R.prototype.cloneAndMerge=function(o){return new R(this._env,M.mergeConfigurationOptions(o,this.options))},R.prototype.getOptionsLiteral=function(){return this.options},R.prototype._applyPaths=function(o){for(var y,h=0,a=this.sortedPathsRules.length;h<a;h++)if(y=this.sortedPathsRules[h],B.Utilities.startsWith(o,y.from)){for(var c=[],E=0,D=y.to.length;E<D;E++)c.push(y.to[E]+o.substr(y.from.length));return c}return[o]},R.prototype._addUrlArgsToUrl=function(o){return B.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs},R.prototype._addUrlArgsIfNecessaryToUrl=function(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o},R.prototype._addUrlArgsIfNecessaryToUrls=function(o){if(this.options.urlArgs)for(var y=0,h=o.length;y<h;y++)o[y]=this._addUrlArgsToUrl(o[y]);return o},R.prototype.moduleIdToPaths=function(o){if(this._env.isNode){var y=this.nodeModulesMap[o]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o);if(y)return this.isBuild()?["empty:"]:["node|"+o]}var h=o,a;if(!B.Utilities.endsWith(h,".js")&&!B.Utilities.isAbsolutePath(h)){a=this._applyPaths(h);for(var c=0,E=a.length;c<E;c++)this.isBuild()&&a[c]==="empty:"||(B.Utilities.isAbsolutePath(a[c])||(a[c]=this.options.baseUrl+a[c]),!B.Utilities.endsWith(a[c],".js")&&!B.Utilities.containsQueryString(a[c])&&(a[c]=a[c]+".js"))}else!B.Utilities.endsWith(h,".js")&&!B.Utilities.containsQueryString(h)&&(h=h+".js"),a=[h];return this._addUrlArgsIfNecessaryToUrls(a)},R.prototype.requireToUrl=function(o){var y=o;return B.Utilities.isAbsolutePath(y)||(y=this._applyPaths(y)[0],B.Utilities.isAbsolutePath(y)||(y=this.options.baseUrl+y)),this._addUrlArgsIfNecessaryToUrl(y)},R.prototype.isBuild=function(){return this.options.isBuild},R.prototype.isDuplicateMessageIgnoredFor=function(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)},R.prototype.getConfigForModule=function(o){if(this.options.config)return this.options.config[o]},R.prototype.shouldCatchError=function(){return this.options.catchError},R.prototype.shouldRecordStats=function(){return this.options.recordStats},R.prototype.onError=function(o){this.options.onError(o)},R}();B.Configuration=t})(le||(le={}));var le;(function(B){var n=function(){function a(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return a.prototype.load=function(c,E,D,p){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new R;else if(this._env.isElectronRenderer){var e=c.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new M:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new M;var C={callback:D,errorback:p};if(this._callbackMap.hasOwnProperty(E)){this._callbackMap[E].push(C);return}this._callbackMap[E]=[C],this._scriptLoader.load(c,E,function(){return m.triggerCallback(E)},function(N){return m.triggerErrorback(E,N)})},a.prototype.triggerCallback=function(c){var E=this._callbackMap[c];delete this._callbackMap[c];for(var D=0;D<E.length;D++)E[D].callback()},a.prototype.triggerErrorback=function(c,E){var D=this._callbackMap[c];delete this._callbackMap[c];for(var p=0;p<D.length;p++)D[p].errorback(E)},a}(),M=function(){function a(){}return a.prototype.attachListeners=function(c,E,D){var p=function(){c.removeEventListener("load",m),c.removeEventListener("error",e)},m=function(C){p(),E()},e=function(C){p(),D(C)};c.addEventListener("load",m),c.addEventListener("error",e)},a.prototype.load=function(c,E,D,p){if(/^node\|/.test(E)){var m=c.getConfig().getOptionsLiteral(),e=y(c.getRecorder(),m.nodeRequire||B.global.nodeRequire),C=E.split("|"),N=null;try{N=e(C[1])}catch(i){p(i);return}c.enqueueDefineAnonymousModule([],function(){return N}),D()}else{var A=document.createElement("script");A.setAttribute("async","async"),A.setAttribute("type","text/javascript"),this.attachListeners(A,D,p);var u=c.getConfig().getOptionsLiteral().trustedTypesPolicy;u&&(E=u.createScriptURL(E)),A.setAttribute("src",E);var s=c.getConfig().getOptionsLiteral().cspNonce;s&&A.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(A)}},a}();function t(a){var c=a.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var E=c?self.eval(c.createScript("","true")):new Function("true");return E.call(self),!0}catch{return!1}}var R=function(){function a(){this._cachedCanUseEval=null}return a.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(c)),this._cachedCanUseEval},a.prototype.load=function(c,E,D,p){if(/^node\|/.test(E)){var m=c.getConfig().getOptionsLiteral(),e=y(c.getRecorder(),m.nodeRequire||B.global.nodeRequire),C=E.split("|"),N=null;try{N=e(C[1])}catch(s){p(s);return}c.enqueueDefineAnonymousModule([],function(){return N}),D()}else{var A=c.getConfig().getOptionsLiteral().trustedTypesPolicy,u=/^((http:)|(https:)|(file:))/.test(E)&&E.substring(0,self.origin.length)!==self.origin;if(!u&&this._canUseEval(c)){fetch(E).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+E;var i=A?self.eval(A.createScript("",s)):new Function(s);i.call(self),D()}).then(void 0,p);return}try{A&&(E=A.createScriptURL(E)),importScripts(E),D()}catch(s){p(s)}}},a}(),o=function(){function a(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return a.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},a.prototype._initNodeRequire=function(c,E){var D=E.getConfig().getOptionsLiteral().nodeCachedData;if(!D||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var p=this,m=c("module");function e(C){var N=C.constructor,A=function(s){try{return C.require(s)}finally{}};return A.resolve=function(s,i){return N._resolveFilename(s,C,!1,i)},A.resolve.paths=function(s){return N._resolveLookupPaths(s,C)},A.main=process.mainModule,A.extensions=N._extensions,A.cache=N._cache,A}m.prototype._compile=function(C,N){var A=m.wrap(C.replace(/^#!.*/,"")),u=E.getRecorder(),s=p._getCachedDataPath(D,N),i={filename:N},l;try{var g=p._fs.readFileSync(s);l=g.slice(0,16),i.cachedData=g.slice(16),u.record(60,s)}catch{u.record(61,s)}var L=new p._vm.Script(A,i),w=L.runInThisContext(i),d=p._path.dirname(N),v=e(this),_=[this.exports,v,this,N,d,process,Te,Buffer],b=w.apply(this.exports,_);return p._handleCachedData(L,A,s,!i.cachedData,E),p._verifyCachedData(L,A,s,l,E),b}},a.prototype.load=function(c,E,D,p){var m=this,e=c.getConfig().getOptionsLiteral(),C=y(c.getRecorder(),e.nodeRequire||B.global.nodeRequire),N=e.nodeInstrumenter||function(w){return w};this._init(C),this._initNodeRequire(C,c);var A=c.getRecorder();if(/^node\|/.test(E)){var u=E.split("|"),s=null;try{s=C(u[1])}catch(w){p(w);return}c.enqueueDefineAnonymousModule([],function(){return s}),D()}else{E=B.Utilities.fileUriToFilePath(this._env.isWindows,E);var i=this._path.normalize(E),l=this._getElectronRendererScriptPathOrUri(i),g=Boolean(e.nodeCachedData),L=g?this._getCachedDataPath(e.nodeCachedData,E):void 0;this._readSourceAndCachedData(i,L,A,function(w,d,v,_){if(w){p(w);return}var b;d.charCodeAt(0)===a._BOM?b=a._PREFIX+d.substring(1)+a._SUFFIX:b=a._PREFIX+d+a._SUFFIX,b=N(b,i);var f={filename:l,cachedData:v},P=m._createAndEvalScript(c,b,f,D,p);m._handleCachedData(P,b,L,g&&!v,c),m._verifyCachedData(P,b,L,_,c)})}},a.prototype._createAndEvalScript=function(c,E,D,p,m){var e=c.getRecorder();e.record(31,D.filename);var C=new this._vm.Script(E,D),N=C.runInThisContext(D),A=c.getGlobalAMDDefineFunc(),u=!1,s=function(){return u=!0,A.apply(null,arguments)};return s.amd=A.amd,N.call(B.global,c.getGlobalAMDRequireFunc(),s,D.filename,this._path.dirname(D.filename)),e.record(32,D.filename),u?p():m(new Error("Didn't receive define call in "+D.filename+"!")),C},a.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var E=c.match(/^([a-z])\:(.*)/i);return E?"file:///"+(E[1].toUpperCase()+":"+E[2]).replace(/\\/g,"/"):"file://"+c},a.prototype._getCachedDataPath=function(c,E){var D=this._crypto.createHash("md5").update(E,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),p=this._path.basename(E).replace(/\.js$/,"");return this._path.join(c.path,p+"-"+D+".code")},a.prototype._handleCachedData=function(c,E,D,p,m){var e=this;c.cachedDataRejected?this._fs.unlink(D,function(C){m.getRecorder().record(62,D),e._createAndWriteCachedData(c,E,D,m),C&&m.getConfig().onError(C)}):p&&this._createAndWriteCachedData(c,E,D,m)},a.prototype._createAndWriteCachedData=function(c,E,D,p){var m=this,e=Math.ceil(p.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),C=-1,N=0,A=void 0,u=function(){setTimeout(function(){A||(A=m._crypto.createHash("md5").update(E,"utf8").digest());var s=c.createCachedData();if(!(s.length===0||s.length===C||N>=5)){if(s.length<C){u();return}C=s.length,m._fs.writeFile(D,Buffer.concat([A,s]),function(i){i&&p.getConfig().onError(i),p.getRecorder().record(63,D),u()})}},e*Math.pow(4,N++))};u()},a.prototype._readSourceAndCachedData=function(c,E,D,p){if(!E)this._fs.readFile(c,{encoding:"utf8"},p);else{var m=void 0,e=void 0,C=void 0,N=2,A=function(u){u?p(u):--N==0&&p(void 0,m,e,C)};this._fs.readFile(c,{encoding:"utf8"},function(u,s){m=s,A(u)}),this._fs.readFile(E,function(u,s){!u&&s&&s.length>0?(C=s.slice(0,16),e=s.slice(16),D.record(60,E)):D.record(61,E),A()})}},a.prototype._verifyCachedData=function(c,E,D,p,m){var e=this;!p||c.cachedDataRejected||setTimeout(function(){var C=e._crypto.createHash("md5").update(E,"utf8").digest();p.equals(C)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+D+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(D,function(N){N&&m.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random())))},a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`,a}();function y(a,c){if(c.__$__isRecorded)return c;var E=function(p){a.record(33,p);try{return c(p)}finally{a.record(34,p)}};return E.__$__isRecorded=!0,E}B.ensureRecordedNodeRequire=y;function h(a){return new n(a)}B.createScriptLoader=h})(le||(le={}));var le;(function(B){var n=function(){function h(a){var c=a.lastIndexOf("/");c!==-1?this.fromModulePath=a.substr(0,c+1):this.fromModulePath=""}return h._normalizeModuleId=function(a){var c=a,E;for(E=/\/\.\//;E.test(c);)c=c.replace(E,"/");for(c=c.replace(/^\.\//g,""),E=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;E.test(c);)c=c.replace(E,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},h.prototype.resolveModule=function(a){var c=a;return B.Utilities.isAbsolutePath(c)||(B.Utilities.startsWith(c,"./")||B.Utilities.startsWith(c,"../"))&&(c=h._normalizeModuleId(this.fromModulePath+c)),c},h.ROOT=new h(""),h}();B.ModuleIdResolver=n;var M=function(){function h(a,c,E,D,p,m){this.id=a,this.strId=c,this.dependencies=E,this._callback=D,this._errorback=p,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return h._safeInvokeFunction=function(a,c){try{return{returnedValue:a.apply(B.global,c),producedError:null}}catch(E){return{returnedValue:null,producedError:E}}},h._invokeFactory=function(a,c,E,D){return a.isBuild()&&!B.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:a.shouldCatchError()?this._safeInvokeFunction(E,D):{returnedValue:E.apply(B.global,D),producedError:null}},h.prototype.complete=function(a,c,E,D){this._isComplete=!0;var p=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);var m=h._invokeFactory(c,this.strId,this._callback,E);p=m.producedError,a.record(22,this.strId),!p&&typeof m.returnedValue!="undefined"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(p){var e=B.ensureError(p);e.phase="factory",e.moduleId=this.strId,e.neededBy=D(this.id),this.error=e,c.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},h.prototype.onDependencyError=function(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1},h.prototype.isComplete=function(){return this._isComplete},h}();B.Module=M;var t=function(){function h(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return h.prototype.getMaxModuleId=function(){return this._nextId},h.prototype.getModuleId=function(a){var c=this._strModuleIdToIntModuleId.get(a);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(a,c),this._intModuleIdToStrModuleId[c]=a),c},h.prototype.getStrModuleId=function(a){return this._intModuleIdToStrModuleId[a]},h}(),R=function(){function h(a){this.id=a}return h.EXPORTS=new h(0),h.MODULE=new h(1),h.REQUIRE=new h(2),h}();B.RegularDependency=R;var o=function(){function h(a,c,E){this.id=a,this.pluginId=c,this.pluginParam=E}return h}();B.PluginDependency=o;var y=function(){function h(a,c,E,D,p){p===void 0&&(p=0),this._env=a,this._scriptLoader=c,this._loaderAvailableTimestamp=p,this._defineFunc=E,this._requireFunc=D,this._moduleIdProvider=new t,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return h.prototype.reset=function(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},h.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},h.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},h._findRelevantLocationInStack=function(a,c){for(var E=function(i){return i.replace(/\\/g,"/")},D=E(a),p=c.split(/\n/),m=0;m<p.length;m++){var e=p[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){var C=e[1],N=e[2],A=e[3],u=Math.max(C.lastIndexOf(" ")+1,C.lastIndexOf("(")+1);if(C=C.substr(u),C=E(C),C===D){var s={line:parseInt(N,10),col:parseInt(A,10)};return s.line===1&&(s.col-="(function (require, define, __filename, __dirname) { ".length),s}}}throw new Error("Could not correlate define call site for needle "+a)},h.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var a=[],c=0,E=0,D=this._modules2.length;E<D;E++){var p=this._modules2[E];if(!!p){var m=this._buildInfoPath[p.id]||null,e=this._buildInfoDefineStack[p.id]||null,C=this._buildInfoDependencies[p.id];a[c++]={id:p.strId,path:m,defineLocation:m&&e?h._findRelevantLocationInStack(m,e):null,dependencies:C,shim:null,exports:p.exports}}}return a},h.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder},h.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},h.prototype.enqueueDefineAnonymousModule=function(a,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var E=null;this._config.isBuild()&&(E=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:E,dependencies:a,callback:c}},h.prototype.defineModule=function(a,c,E,D,p,m){var e=this;m===void 0&&(m=new n(a));var C=this._moduleIdProvider.getModuleId(a);if(this._modules2[C]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}var N=new M(C,a,this._normalizeDependencies(c,m),E,D,m);this._modules2[C]=N,this._config.isBuild()&&(this._buildInfoDefineStack[C]=p,this._buildInfoDependencies[C]=(N.dependencies||[]).map(function(A){return e._moduleIdProvider.getStrModuleId(A.id)})),this._resolve(N)},h.prototype._normalizeDependency=function(a,c){if(a==="exports")return R.EXPORTS;if(a==="module")return R.MODULE;if(a==="require")return R.REQUIRE;var E=a.indexOf("!");if(E>=0){var D=c.resolveModule(a.substr(0,E)),p=c.resolveModule(a.substr(E+1)),m=this._moduleIdProvider.getModuleId(D+"!"+p),e=this._moduleIdProvider.getModuleId(D);return new o(m,e,p)}return new R(this._moduleIdProvider.getModuleId(c.resolveModule(a)))},h.prototype._normalizeDependencies=function(a,c){for(var E=[],D=0,p=0,m=a.length;p<m;p++)E[D++]=this._normalizeDependency(a[p],c);return E},h.prototype._relativeRequire=function(a,c,E,D){if(typeof c=="string")return this.synchronousRequire(c,a);this.defineModule(B.Utilities.generateAnonymousModule(),c,E,D,null,a)},h.prototype.synchronousRequire=function(a,c){c===void 0&&(c=new n(a));var E=this._normalizeDependency(a,c),D=this._modules2[E.id];if(!D)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!D.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(D.error)throw D.error;return D.exports},h.prototype.configure=function(a,c){var E=this._config.shouldRecordStats();c?this._config=new B.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!E&&(this._recorder=null)},h.prototype.getConfig=function(){return this._config},h.prototype._onLoad=function(a){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),c.dependencies,c.callback,null,c.stack)}},h.prototype._createLoadError=function(a,c){var E=this,D=this._moduleIdProvider.getStrModuleId(a),p=(this._inverseDependencies2[a]||[]).map(function(e){return E._moduleIdProvider.getStrModuleId(e)}),m=B.ensureError(c);return m.phase="loading",m.moduleId=D,m.neededBy=p,m},h.prototype._onLoadError=function(a,c){var E=this._createLoadError(a,c);this._modules2[a]||(this._modules2[a]=new M(a,this._moduleIdProvider.getStrModuleId(a),[],function(){},null,null));for(var D=[],p=0,m=this._moduleIdProvider.getMaxModuleId();p<m;p++)D[p]=!1;var e=!1,C=[];for(C.push(a),D[a]=!0;C.length>0;){var N=C.shift(),A=this._modules2[N];A&&(e=A.onDependencyError(E)||e);var u=this._inverseDependencies2[N];if(u)for(var p=0,m=u.length;p<m;p++){var s=u[p];D[s]||(C.push(s),D[s]=!0)}}e||this._config.onError(E)},h.prototype._hasDependencyPath=function(a,c){var E=this._modules2[a];if(!E)return!1;for(var D=[],p=0,m=this._moduleIdProvider.getMaxModuleId();p<m;p++)D[p]=!1;var e=[];for(e.push(E),D[a]=!0;e.length>0;){var C=e.shift(),N=C.dependencies;if(N)for(var p=0,m=N.length;p<m;p++){var A=N[p];if(A.id===c)return!0;var u=this._modules2[A.id];u&&!D[A.id]&&(D[A.id]=!0,e.push(u))}}return!1},h.prototype._findCyclePath=function(a,c,E){if(a===c||E===50)return[a];var D=this._modules2[a];if(!D)return null;var p=D.dependencies;if(p)for(var m=0,e=p.length;m<e;m++){var C=this._findCyclePath(p[m].id,c,E+1);if(C!==null)return C.push(a),C}return null},h.prototype._createRequire=function(a){var c=this,E=function(D,p,m){return c._relativeRequire(a,D,p,m)};return E.toUrl=function(D){return c._config.requireToUrl(a.resolveModule(D))},E.getStats=function(){return c.getLoaderEvents()},E.hasDependencyCycle=function(){return c._hasDependencyCycle},E.config=function(D,p){p===void 0&&(p=!1),c.configure(D,p)},E.__$__nodeRequire=B.global.nodeRequire,E},h.prototype._loadModule=function(a){var c=this;if(!(this._modules2[a]||this._knownModules2[a])){this._knownModules2[a]=!0;var E=this._moduleIdProvider.getStrModuleId(a),D=this._config.moduleIdToPaths(E),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(E.indexOf("/")===-1||p.test(E))&&D.push("node|"+E);var m=-1,e=function(C){if(m++,m>=D.length)c._onLoadError(a,C);else{var N=D[m],A=c.getRecorder();if(c._config.isBuild()&&N==="empty:"){c._buildInfoPath[a]=N,c.defineModule(c._moduleIdProvider.getStrModuleId(a),[],null,null,null),c._onLoad(a);return}A.record(10,N),c._scriptLoader.load(c,N,function(){c._config.isBuild()&&(c._buildInfoPath[a]=N),A.record(11,N),c._onLoad(a)},function(u){A.record(12,N),e(u)})}};e(null)}},h.prototype._loadPluginDependency=function(a,c){var E=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var D=function(p){E.defineModule(E._moduleIdProvider.getStrModuleId(c.id),[],p,null,null)};D.error=function(p){E._config.onError(E._createLoadError(c.id,p))},a.load(c.pluginParam,this._createRequire(n.ROOT),D,this._config.getOptionsLiteral())}},h.prototype._resolve=function(a){var c=this,E=a.dependencies;if(E)for(var D=0,p=E.length;D<p;D++){var m=E[D];if(m===R.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===R.MODULE){a.unresolvedDependenciesCount--;continue}if(m===R.REQUIRE){a.unresolvedDependenciesCount--;continue}var e=this._modules2[m.id];if(e&&e.isComplete()){if(e.error){a.onDependencyError(e.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");var C=this._findCyclePath(m.id,a.id,0)||[];C.reverse(),C.push(m.id),console.warn(C.map(function(u){return c._moduleIdProvider.getStrModuleId(u)}).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof o){var N=this._modules2[m.pluginId];if(N&&N.isComplete()){this._loadPluginDependency(N.exports,m);continue}var A=this._inversePluginDependencies2.get(m.pluginId);A||(A=[],this._inversePluginDependencies2.set(m.pluginId,A)),A.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)},h.prototype._onModuleComplete=function(a){var c=this,E=this.getRecorder();if(!a.isComplete()){var D=a.dependencies,p=[];if(D)for(var m=0,e=D.length;m<e;m++){var C=D[m];if(C===R.EXPORTS){p[m]=a.exports;continue}if(C===R.MODULE){p[m]={id:a.strId,config:function(){return c._config.getConfigForModule(a.strId)}};continue}if(C===R.REQUIRE){p[m]=this._createRequire(a.moduleIdResolver);continue}var N=this._modules2[C.id];if(N){p[m]=N.exports;continue}p[m]=null}var A=function(g){return(c._inverseDependencies2[g]||[]).map(function(L){return c._moduleIdProvider.getStrModuleId(L)})};a.complete(E,this._config,p,A);var u=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,u)for(var m=0,e=u.length;m<e;m++){var s=u[m],i=this._modules2[s];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var l=this._inversePluginDependencies2.get(a.id);if(l){this._inversePluginDependencies2.delete(a.id);for(var m=0,e=l.length;m<e;m++)this._loadPluginDependency(a.exports,l[m])}}},h}();B.ModuleManager=y})(le||(le={}));var Z,le;(function(B){var n=new B.Environment,M=null,t=function(h,a,c){typeof h!="string"&&(c=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(c=a,a=null),a||(a=["require","exports","module"]),h?M.defineModule(h,a,c,null,null):M.enqueueDefineAnonymousModule(a,c)};t.amd={jQuery:!0};var R=function(h,a){a===void 0&&(a=!1),M.configure(h,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){R(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=R,o.getConfig=function(){return M.getConfig().getOptionsLiteral()},o.reset=function(){M=M.reset()},o.getBuildInfo=function(){return M.getBuildInfo()},o.getStats=function(){return M.getLoaderEvents()},o.define=t;function y(){if(typeof B.global.require!="undefined"||typeof require!="undefined"){var h=B.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){var a=B.ensureRecordedNodeRequire(M.getRecorder(),h);B.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=o,require=o):(n.isElectronRenderer||(B.global.define=t),B.global.require=o)}B.init=y,(typeof B.global.define!="function"||!B.global.define.amd)&&(M=new B.ModuleManager(n,B.createScriptLoader(n),t,o,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require!="undefined"&&typeof B.global.require!="function"&&o.config(B.global.require),Z=function(){return t.apply(null,arguments)},Z.amd=t.amd,typeof doNotInitLoader=="undefined"&&y())})(le||(le={}));var Ue=this,Re;(function(B){var n=Ue||{},M=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,t=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function R(c,E){var D;return E.length===0?D=c:D=c.replace(/\{(\d+)\}/g,function(p,m){var e=m[0];return typeof E[e]!="undefined"?E[e]:p}),t&&(D="\uFF3B"+D.replace(/[aouei]/g,"$&$&")+"\uFF3D"),D}function o(c,E){var D=c[E];return D||(D=c["*"],D)?D:null}function y(c,E){for(var D=[],p=0;p<arguments.length-2;p++)D[p]=arguments[p+2];return R(E,D)}function h(c){return function(E,D){var p=Array.prototype.slice.call(arguments,2);return R(c[E],p)}}var a=function(){function c(){this.localize=y}return c.prototype.setPseudoTranslation=function(E){t=E},c.prototype.create=function(E,D){return{localize:h(D[E])}},c.prototype.load=function(E,D,p,m){if(m=m||{},!E||E.length===0)p({localize:y});else{var e=void 0;if(M&&M.getString)e=".nls.keys",D([E+e],function(A){p({localize:function(u,s){if(!A[u])return"NLS error: unknown key "+u;var i=A[u].keys;if(s>=i.length)return"NLS error unknown index "+s;var l=i[s],g=[];g[0]=u+"_"+l;for(var L=0;L<arguments.length-2;L++)g[L+1]=arguments[L+2];return M.getString.apply(M,g)}})});else if(m.isBuild)D([E+".nls",E+".nls.keys"],function(A,u){c.BUILD_MAP[E]=A,c.BUILD_MAP_KEYS[E]=u,p(A)});else{var C=m["vs/nls"]||{},N=C.availableLanguages?o(C.availableLanguages,E):null;e=".nls",N!==null&&N!==c.DEFAULT_TAG&&(e=e+"."+N),D([E+e],function(A){Array.isArray(A)?A.localize=h(A):A.localize=h(A[E]),p(A)})}}},c.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},c.prototype.write=function(E,D,p){var m=p.getEntryPoint(),e=this._getEntryPointsMap();e[m]=e[m]||[],e[m].push(D),D!==m&&p.asModule(E+"!"+D,"define(['vs/nls', 'vs/nls!"+m+`'], function(nls, data) { return nls.create("`+D+'", data); });')},c.prototype.writeFile=function(E,D,p,m,e){var C=this._getEntryPointsMap();if(C.hasOwnProperty(D)){for(var N=p.toUrl(D+".nls.js"),A=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],u=C[D],s={},i=0;i<u.length;i++)s[u[i]]=c.BUILD_MAP[u[i]];A.push('define("'+D+'.nls", '+JSON.stringify(s,null,"	")+");"),m(N,A.join(`\r
`))}},c.prototype.finishBuild=function(E){E("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();B.NLSPlugin=a,function(){Z("vs/nls",new a)}()})(Re||(Re={})),Z(K[20],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.getClassNamesArray=n.Codicon=n.getCodiconAriaLabel=void 0;function M(y){return y?y.replace(/\$\((.*?)\)/g,(h,a)=>` ${a} `).trim():""}n.getCodiconAriaLabel=M;class t{constructor(h,a,c){this.id=h,this.definition=a,this.description=c,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}n.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(y,h){const a=["codicon","codicon-"+y];return h&&a.push("codicon-modifier-"+h),a}n.getClassNamesArray=R;var o;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const h=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function a(D){if(D instanceof t)return["codicon","codicon-"+D.id];const p=h.exec(D.id);if(!p)return a(t.error);let[,m,e]=p;const C=["codicon","codicon-"+m];return e&&C.push("codicon-modifier-"+e.substr(1)),C}y.asClassNameArray=a;function c(D){return a(D).join(" ")}y.asClassName=c;function E(D){return"."+a(D).join(".")}y.asCSSSelector=E})(o=n.CSSIcon||(n.CSSIcon={}))}),Z(K[21],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class M{constructor(R,o,y,h){this.originalStart=R,this.originalLength=o,this.modifiedStart=y,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=M}),Z(K[9],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(g){setTimeout(()=>{throw g.stack?new Error(g.message+`

`+g.stack):g},0)}}addListener(g){return this.listeners.push(g),()=>{this._removeListener(g)}}emit(g){this.listeners.forEach(L=>{L(g)})}_removeListener(g){this.listeners.splice(this.listeners.indexOf(g),1)}setUnexpectedErrorHandler(g){this.unexpectedErrorHandler=g}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(g){this.unexpectedErrorHandler(g),this.emit(g)}onUnexpectedExternalError(g){this.unexpectedErrorHandler(g)}}n.ErrorHandler=M,n.errorHandler=new M;function t(l){n.errorHandler.setUnexpectedErrorHandler(l)}n.setUnexpectedErrorHandler=t;function R(l){a(l)||n.errorHandler.onUnexpectedError(l)}n.onUnexpectedError=R;function o(l){a(l)||n.errorHandler.onUnexpectedExternalError(l)}n.onUnexpectedExternalError=o;function y(l){if(l instanceof Error){let{name:g,message:L}=l;const w=l.stacktrace||l.stack;return{$isError:!0,name:g,message:L,stack:w}}return l}n.transformErrorForSerialization=y;const h="Canceled";function a(l){return l instanceof c?!0:l instanceof Error&&l.name===h&&l.message===h}n.isCancellationError=a;class c extends Error{constructor(){super(h);this.name=this.message}}n.CancellationError=c;function E(){const l=new Error(h);return l.name=l.message,l}n.canceled=E;function D(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}n.illegalArgument=D;function p(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}n.illegalState=p;function m(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=m;function e(l){const g=new Error(`${l} has been disposed`);return g.name="DISPOSED",g}n.disposed=e;function C(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}n.getErrorMessage=C;class N extends Error{constructor(g){super("NotImplemented");g&&(this.message=g)}}n.NotImplementedError=N;class A extends Error{constructor(g){super("NotSupported");g&&(this.message=g)}}n.NotSupportedError=A;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=u;class s extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(g){if(g&&g instanceof s)return g;if(g&&g instanceof Error){const L=new s;return L.name=g.name,L.message=g.message,L.stack=g.stack,L}return new s(g)}}n.ErrorNoTelemetry=s;class i extends Error{constructor(g){super(g||"An unexpected bug occurred.");Object.setPrototypeOf(this,i.prototype);debugger}}n.BugIndicatingError=i}),Z(K[22],x([0,1,9]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function t(S,k=0){return S[S.length-(1+k)]}n.tail=t;function R(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}n.tail2=R;function o(S,k,T=(W,H)=>W===H){if(S===k)return!0;if(!S||!k||S.length!==k.length)return!1;for(let W=0,H=S.length;W<H;W++)if(!T(S[W],k[W]))return!1;return!0}n.equals=o;function y(S,k,T){return h(S.length,W=>T(S[W],k))}n.binarySearch=y;function h(S,k){let T=0,W=S-1;for(;T<=W;){const H=(T+W)/2|0,ne=k(H);if(ne<0)T=H+1;else if(ne>0)W=H-1;else return H}return-(T+1)}n.binarySearch2=h;function a(S,k){let T=0,W=S.length;if(W===0)return 0;for(;T<W;){const H=Math.floor((T+W)/2);k(S[H])?W=H:T=H+1}return T}n.findFirstInSorted=a;function c(S,k,T){if(S=S|0,S>=k.length)throw new TypeError("invalid index");let W=k[Math.floor(k.length*Math.random())],H=[],ne=[],ie=[];for(let ae of k){const ue=T(ae,W);ue<0?H.push(ae):ue>0?ne.push(ae):ie.push(ae)}return S<H.length?c(S,H,T):S<H.length+ie.length?ie[0]:c(S-(H.length+ie.length),ne,T)}n.quickSelect=c;function E(S,k){const T=[];let W;for(const H of S.slice(0).sort(k))!W||k(W[0],H)!==0?(W=[H],T.push(W)):W.push(H);return T}n.groupBy=E;function D(S,k,T){const W=[];function H(ae,ue,fe){if(ue===0&&fe.length===0)return;const ge=W[W.length-1];ge&&ge.start+ge.deleteCount===ae?(ge.deleteCount+=ue,ge.toInsert.push(...fe)):W.push({start:ae,deleteCount:ue,toInsert:fe})}let ne=0,ie=0;for(;;){if(ne===S.length){H(ne,0,k.slice(ie));break}if(ie===k.length){H(ne,S.length-ne,[]);break}const ae=S[ne],ue=k[ie],fe=T(ae,ue);fe===0?(ne+=1,ie+=1):fe<0?(H(ne,1,[]),ne+=1):fe>0&&(H(ne,0,[ue]),ie+=1)}return W}n.sortedDiff=D;function p(S,k,T){const W=D(S,k,T),H=[],ne=[];for(const ie of W)H.push(...S.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:H,added:ne}}n.delta=p;function m(S,k,T){if(T===0)return[];const W=S.slice(0,T).sort(k);return C(S,k,W,T,S.length),W}n.top=m;function e(S,k,T,W,H){return T===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const ae=S.length,ue=S.slice(0,T).sort(k);for(let fe=T,ge=Math.min(T+W,ae);fe<ae;fe=ge,ge=Math.min(ge+W,ae)){if(fe>T&&await new Promise(Pe=>setTimeout(Pe)),H&&H.isCancellationRequested)throw new M.CancellationError;C(S,k,ue,fe,ge)}return ue})().then(ne,ie)})}n.topAsync=e;function C(S,k,T,W,H){for(const ne=T.length;W<H;W++){const ie=S[W];if(k(ie,T[ne-1])<0){T.pop();const ae=a(T,ue=>k(ie,ue)<0);T.splice(ae,0,ie)}}}function N(S){return S.filter(k=>!!k)}n.coalesce=N;function A(S){let k=0;for(let T=0;T<S.length;T++)S[T]&&(S[k]=S[T],k+=1);S.length=k}n.coalesceInPlace=A;function u(S,k,T){S.splice(T,0,S.splice(k,1)[0])}n.move=u;function s(S){return!Array.isArray(S)||S.length===0}n.isFalsyOrEmpty=s;function i(S){return Array.isArray(S)&&S.length>0}n.isNonEmptyArray=i;function l(S,k=T=>T){const T=new Set;return S.filter(W=>{const H=k(W);return T.has(H)?!1:(T.add(H),!0)})}n.distinct=l;function g(S){const k=new Set;return T=>{const W=S(T);return k.has(W)?!1:(k.add(W),!0)}}n.uniqueFilter=g;function L(S,k){const T=w(S,k);if(T!==-1)return S[T]}n.findLast=L;function w(S,k){for(let T=S.length-1;T>=0;T--){const W=S[T];if(k(W))return T}return-1}n.lastIndex=w;function d(S,k){return S.length>0?S[0]:k}n.firstOrDefault=d;function v(S,k){return S.length>0?S[S.length-1]:k}n.lastOrDefault=v;function _(S,k,T=(W,H)=>W===H){let W=0;for(let H=0,ne=Math.min(S.length,k.length);H<ne&&T(S[H],k[H]);H++)W++;return W}n.commonPrefixLength=_;function b(S){return[].concat(...S)}n.flatten=b;function f(S,k){let T=typeof k=="number"?S:0;typeof k=="number"?T=S:(T=0,k=S);const W=[];if(T<=k)for(let H=T;H<k;H++)W.push(H);else for(let H=T;H>k;H--)W.push(H);return W}n.range=f;function P(S,k,T){return S.reduce((W,H)=>(W[k(H)]=T?T(H):H,W),Object.create(null))}n.index=P;function O(S,k){return S.push(k),()=>U(S,k)}n.insert=O;function U(S,k){const T=S.indexOf(k);if(T>-1)return S.splice(T,1),k}n.remove=U;function q(S,k,T){const W=S.slice(0,k),H=S.slice(k);return W.concat(T,H)}n.arrayInsert=q;function $(S,k){let T;if(typeof k=="number"){let W=k;T=()=>{const H=Math.sin(W++)*179426549;return H-Math.floor(H)}}else T=Math.random;for(let W=S.length-1;W>0;W-=1){const H=Math.floor(T()*(W+1)),ne=S[W];S[W]=S[H],S[H]=ne}}n.shuffle=$;function j(S,k){const T=S.indexOf(k);T>-1&&(S.splice(T,1),S.unshift(k))}n.pushToStart=j;function te(S,k){const T=S.indexOf(k);T>-1&&(S.splice(T,1),S.push(k))}n.pushToEnd=te;function se(S,k){for(const T of k)S.push(T)}n.pushMany=se;function ee(S,k){return Array.isArray(S)?S.map(k):k(S)}n.mapArrayOrNot=ee;function r(S){return Array.isArray(S)?S:[S]}n.asArray=r;function he(S){return S[Math.floor(Math.random()*S.length)]}n.getRandomElement=he;function de(S,k){for(const T of S){const W=k(T);if(W!==void 0)return W}}n.mapFind=de;function Ae(S,k,T){const W=Le(S,k),H=S.length,ne=T.length;S.length=H+ne;for(let ie=H-1;ie>=W;ie--)S[ie+ne]=S[ie];for(let ie=0;ie<ne;ie++)S[ie+W]=T[ie]}n.insertInto=Ae;function pe(S,k,T,W){const H=Le(S,k),ne=S.splice(H,T);return Ae(S,H,W),ne}n.splice=pe;function Le(S,k){return k<0?Math.max(k+S.length,0):Math.min(k,S.length)}var Ne;(function(S){function k(H){return H<0}S.isLessThan=k;function T(H){return H>0}S.isGreaterThan=T;function W(H){return H===0}S.isNeitherLessOrGreaterThan=W,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(Ne=n.CompareResult||(n.CompareResult={}));function Ee(S,k){return(T,W)=>k(S(T),S(W))}n.compareBy=Ee;const Me=(S,k)=>S-k;n.numberComparator=Me;function J(S,k){if(S.length===0)return;let T=S[0];for(let W=1;W<S.length;W++){const H=S[W];k(H,T)>0&&(T=H)}return T}n.findMaxBy=J;function Q(S,k){if(S.length===0)return;let T=S[0];for(let W=1;W<S.length;W++){const H=S[W];k(H,T)>=0&&(T=H)}return T}n.findLastMaxBy=Q;function X(S,k){return J(S,(T,W)=>-k(T,W))}n.findMinBy=X;class Y{constructor(k){this.items=k,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(k){let T=this.firstIdx;for(;T<this.items.length&&k(this.items[T]);)T++;const W=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,W}takeFromEndWhile(k){let T=this.lastIdx;for(;T>=0&&k(this.items[T]);)T--;const W=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,W}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const k=this.items[this.firstIdx];return this.firstIdx++,k}removeLast(){const k=this.items[this.lastIdx];return this.lastIdx--,k}takeCount(k){const T=this.items.slice(this.firstIdx,this.firstIdx+k);return this.firstIdx+=k,T}}n.ArrayQueue=Y}),Z(K[11],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function M(t){const R=this;let o=!1,y;return function(){return o||(o=!0,y=t.apply(R,arguments)),y}}n.once=M}),Z(K[12],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var M;(function(t){function R(L){return L&&typeof L=="object"&&typeof L[Symbol.iterator]=="function"}t.is=R;const o=Object.freeze([]);function y(){return o}t.empty=y;function*h(L){yield L}t.single=h;function a(L){return L||o}t.from=a;function c(L){return!L||L[Symbol.iterator]().next().done===!0}t.isEmpty=c;function E(L){return L[Symbol.iterator]().next().value}t.first=E;function D(L,w){for(const d of L)if(w(d))return!0;return!1}t.some=D;function p(L,w){for(const d of L)if(w(d))return d}t.find=p;function*m(L,w){for(const d of L)w(d)&&(yield d)}t.filter=m;function*e(L,w){let d=0;for(const v of L)yield w(v,d++)}t.map=e;function*C(...L){for(const w of L)for(const d of w)yield d}t.concat=C;function*N(L){for(const w of L)for(const d of w)yield d}t.concatNested=N;function A(L,w,d){let v=d;for(const _ of L)v=w(v,_);return v}t.reduce=A;function u(L,w){let d=0;for(const v of L)w(v,d++)}t.forEach=u;function*s(L,w,d=L.length){for(w<0&&(w+=L.length),d<0?d+=L.length:d>L.length&&(d=L.length);w<d;w++)yield L[w]}t.slice=s;function i(L,w=Number.POSITIVE_INFINITY){const d=[];if(w===0)return[d,L];const v=L[Symbol.iterator]();for(let _=0;_<w;_++){const b=v.next();if(b.done)return[d,t.empty()];d.push(b.value)}return[d,{[Symbol.iterator](){return v}}]}t.consume=i;function l(L){return i(L)[0]}t.collect=l;function g(L,w,d=(v,_)=>v===_){const v=L[Symbol.iterator](),_=w[Symbol.iterator]();for(;;){const b=v.next(),f=_.next();if(b.done!==f.done)return!1;if(b.done)return!0;if(!d(b.value,f.value))return!1}}t.equals=g})(M=n.Iterable||(n.Iterable={}))}),Z(K[23],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var M;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(M=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(C,N){this._keyCodeToStr[C]=N,this._strToKeyCode[N.toLowerCase()]=C}keyCodeToStr(C){return this._keyCodeToStr[C]}strToKeyCode(C){return this._strToKeyCode[C.toLowerCase()]||0}}const o=new R,y=new R,h=new R;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const a=[],c=Object.create(null),E=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>E[e]||0,toEnum:e=>c[e]||0,toString:e=>a[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",C=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let N=[],A=[];for(const u of C){const[s,i,l,g,L,w,d,v,_,b]=u;if(A[l]||(A[l]=!0,a[l]=g,c[g]=l,E[g.toLowerCase()]=l,i&&(n.IMMUTABLE_CODE_TO_KEY_CODE[l]=L,L!==0&&L!==3&&L!==5&&L!==4&&L!==6&&L!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[L]=l))),!N[L]){if(N[L]=!0,!w)throw new Error(`String representation missing for key code ${L} around scan code ${g}`);o.define(L,w),y.define(L,_||w),h.define(L,b||_||w)}d&&(n.EVENT_KEY_CODE_MAP[d]=L),v&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[v]=L)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var D;(function(e){function C(l){return o.keyCodeToStr(l)}e.toString=C;function N(l){return o.strToKeyCode(l)}e.fromString=N;function A(l){return y.keyCodeToStr(l)}e.toUserSettingsUS=A;function u(l){return h.keyCodeToStr(l)}e.toUserSettingsGeneral=u;function s(l){return y.strToKeyCode(l)||h.strToKeyCode(l)}e.fromUserSettings=s;function i(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(l)}e.toElectronAccelerator=i})(D=n.KeyCodeUtils||(n.KeyCodeUtils={}));var p;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(p=n.KeyMod||(n.KeyMod={}));function m(e,C){const N=(C&65535)<<16>>>0;return(e|N)>>>0}n.KeyChord=m}),Z(K[24],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class M{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new M(()=>R(this.getValue()))}}n.Lazy=M}),Z(K[6],x([0,1,11,12]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const R=!1;let o=null;function y(v){o=v}if(n.setDisposableTracker=y,R){const v="__is_disposable_tracked__";y(new class{trackDisposable(_){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[v]||console.log(b)},3e3)}setParent(_,b){if(_&&_!==u.None)try{_[v]=!0}catch{}}markAsDisposed(_){if(_&&_!==u.None)try{_[v]=!0}catch{}}markAsSingleton(_){}})}function h(v){return o?.trackDisposable(v),v}function a(v){o?.markAsDisposed(v)}function c(v,_){o?.setParent(v,_)}function E(v,_){if(!!o)for(const b of v)o.setParent(b,_)}function D(v){return o?.markAsSingleton(v),v}n.markAsSingleton=D;class p extends Error{constructor(_){super(`Encountered errors while disposing of store. Errors: [${_.join(", ")}]`);this.errors=_}}n.MultiDisposeError=p;function m(v){return typeof v.dispose=="function"&&v.dispose.length===0}n.isDisposable=m;function e(v){if(t.Iterable.is(v)){let _=[];for(const b of v)if(b)try{b.dispose()}catch(f){_.push(f)}if(_.length===1)throw _[0];if(_.length>1)throw new p(_);return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}n.dispose=e;function C(...v){const _=N(()=>e(v));return E(v,_),_}n.combinedDisposable=C;function N(v){const _=h({dispose:(0,M.once)(()=>{a(_),v()})});return _}n.toDisposable=N;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,h(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return c(_,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(_),_}}n.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new A,h(this),c(this._store,this)}dispose(){a(this),this._store.dispose()}_register(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(_)}}n.Disposable=u,u.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,h(this)}get value(){return this._isDisposed?void 0:this._value}set value(_){this._isDisposed||_===this._value||(this._value?.dispose(),_&&c(_,this),this._value=_)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,a(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const _=this._value;return this._value=void 0,_&&c(_,null),_}}n.MutableDisposable=s;class i{constructor(_){this._disposable=_,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=i;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(_){let b=_;return this.unset=()=>b=void 0,this.isset=()=>b!==void 0,this.dispose=()=>{b&&(b(),b=void 0,a(this))},this}}n.SafeDisposable=l;class g{constructor(){this.references=new Map}acquire(_,...b){let f=this.references.get(_);f||(f={counter:0,object:this.createReferencedObject(_,...b)},this.references.set(_,f));const{object:P}=f,O=(0,M.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(_,f.object),this.references.delete(_))});return f.counter++,{object:P,dispose:O}}}n.ReferenceCollection=g;class L{constructor(_){this.referenceCollection=_}async acquire(_,...b){const f=this.referenceCollection.acquire(_,...b);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(P){throw f.dispose(),P}}}n.AsyncReferenceCollection=L;class w{constructor(_){this.object=_}dispose(){}}n.ImmortalReference=w;function d(v){const _=new A;try{v(_)}finally{_.dispose()}}n.disposeOnReturn=d}),Z(K[13],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class M{constructor(o){this.element=o,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class t{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let o=this._first;for(;o!==M.Undefined;){const y=o.next;o.prev=M.Undefined,o.next=M.Undefined,o=y}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,y){const h=new M(o);if(this._first===M.Undefined)this._first=h,this._last=h;else if(y){const c=this._last;this._last=h,h.prev=c,c.next=h}else{const c=this._first;this._first=h,h.next=c,c.prev=h}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(h))}}shift(){if(this._first!==M.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==M.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==M.Undefined&&o.next!==M.Undefined){const y=o.prev;y.next=o.next,o.next.prev=y}else o.prev===M.Undefined&&o.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):o.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):o.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==M.Undefined;)yield o.element,o=o.next}}n.LinkedList=t}),Z(K[5],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=void 0;const M="en";let t=!1,R=!1,o=!1,y=!1,h=!1,a=!1,c=!1,E=!1,D=!1,p,m=M,e,C;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let N;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?N=n.globals.vscode.process:typeof process!="undefined"&&(N=process);const A=typeof N?.versions?.electron=="string",u=A&&N?.type==="renderer";if(typeof navigator=="object"&&!u)C=navigator.userAgent,t=C.indexOf("Windows")>=0,R=C.indexOf("Macintosh")>=0,E=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=C.indexOf("Linux")>=0,a=!0,p=navigator.language,m=p;else if(typeof N=="object"){t=N.platform==="win32",R=N.platform==="darwin",o=N.platform==="linux",y=o&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,c=A,D=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=M,m=M;const _=N.env.VSCODE_NLS_CONFIG;if(_)try{const b=JSON.parse(_),f=b.availableLanguages["*"];p=b.locale,m=f||M,e=b._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");var s;(function(_){_[_.Web=0]="Web",_[_.Mac=1]="Mac",_[_.Linux=2]="Linux",_[_.Windows=3]="Windows"})(s=n.Platform||(n.Platform={}));function i(_){switch(_){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=i;let l=0;R?l=1:t?l=3:o&&(l=2),n.isWindows=t,n.isMacintosh=R,n.isLinux=o,n.isLinuxSnap=y,n.isNative=h,n.isElectron=c,n.isWeb=a,n.isWebWorker=a&&typeof n.globals.importScripts=="function",n.isIOS=E,n.isCI=D,n.platform=l,n.userAgent=C,n.language=m;var g;(function(_){function b(){return n.language}_.value=b;function f(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}_.isDefaultVariant=f;function P(){return n.language==="en"}_.isDefault=P})(g=n.Language||(n.Language={})),n.locale=p,n.translationsConfigFile=e,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){let _=[];n.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let P=0,O=_.length;P<O;P++){const U=_[P];if(U.id===f.data.vscodeScheduleAsyncWork){_.splice(P,1),U.callback();return}}});let b=0;return f=>{const P=++b;_.push({id:P,callback:f}),n.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return _=>setTimeout(_)})();var L;(function(_){_[_.Windows=1]="Windows",_[_.Macintosh=2]="Macintosh",_[_.Linux=3]="Linux"})(L=n.OperatingSystem||(n.OperatingSystem={})),n.OS=R||E?2:t?1:3;let w=!0,d=!1;function v(){if(!d){d=!0;const _=new Uint8Array(2);_[0]=1,_[1]=2,w=new Uint16Array(_.buffer)[0]===(2<<8)+1}return w}n.isLittleEndian=v,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Z(K[25],x([0,1,5]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.process!="undefined"){const R=M.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Z(K[26],x([0,1,25]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,R=97,o=90,y=122,h=46,a=47,c=92,E=58,D=63;class p extends Error{constructor(i,l,g){let L;typeof l=="string"&&l.indexOf("not ")===0?(L="must not be",l=l.replace(/^not /,"")):L="must be";const w=i.indexOf(".")!==-1?"property":"argument";let d=`The "${i}" ${w} ${L} of type ${l}`;d+=`. Received type ${typeof g}`;super(d);this.code="ERR_INVALID_ARG_TYPE"}}function m(s,i){if(typeof s!="string")throw new p(i,"string",s)}function e(s){return s===a||s===c}function C(s){return s===a}function N(s){return s>=t&&s<=o||s>=R&&s<=y}function A(s,i,l,g){let L="",w=0,d=-1,v=0,_=0;for(let b=0;b<=s.length;++b){if(b<s.length)_=s.charCodeAt(b);else{if(g(_))break;_=a}if(g(_)){if(!(d===b-1||v===1))if(v===2){if(L.length<2||w!==2||L.charCodeAt(L.length-1)!==h||L.charCodeAt(L.length-2)!==h){if(L.length>2){const f=L.lastIndexOf(l);f===-1?(L="",w=0):(L=L.slice(0,f),w=L.length-1-L.lastIndexOf(l)),d=b,v=0;continue}else if(L.length!==0){L="",w=0,d=b,v=0;continue}}i&&(L+=L.length>0?`${l}..`:"..",w=2)}else L.length>0?L+=`${l}${s.slice(d+1,b)}`:L=s.slice(d+1,b),w=b-d-1;d=b,v=0}else _===h&&v!==-1?++v:v=-1}return L}function u(s,i){if(i===null||typeof i!="object")throw new p("pathObject","Object",i);const l=i.dir||i.root,g=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${g}`:`${l}${s}${g}`:g}n.win32={resolve(...s){let i="",l="",g=!1;for(let L=s.length-1;L>=-1;L--){let w;if(L>=0){if(w=s[L],m(w,"path"),w.length===0)continue}else i.length===0?w=M.cwd():(w=M.env[`=${i}`]||M.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==i.toLowerCase()&&w.charCodeAt(2)===c)&&(w=`${i}\\`));const d=w.length;let v=0,_="",b=!1;const f=w.charCodeAt(0);if(d===1)e(f)&&(v=1,b=!0);else if(e(f))if(b=!0,e(w.charCodeAt(1))){let P=2,O=P;for(;P<d&&!e(w.charCodeAt(P));)P++;if(P<d&&P!==O){const U=w.slice(O,P);for(O=P;P<d&&e(w.charCodeAt(P));)P++;if(P<d&&P!==O){for(O=P;P<d&&!e(w.charCodeAt(P));)P++;(P===d||P!==O)&&(_=`\\\\${U}\\${w.slice(O,P)}`,v=P)}}}else v=1;else N(f)&&w.charCodeAt(1)===E&&(_=w.slice(0,2),v=2,d>2&&e(w.charCodeAt(2))&&(b=!0,v=3));if(_.length>0)if(i.length>0){if(_.toLowerCase()!==i.toLowerCase())continue}else i=_;if(g){if(i.length>0)break}else if(l=`${w.slice(v)}\\${l}`,g=b,b&&i.length>0)break}return l=A(l,!g,"\\",e),g?`${i}\\${l}`:`${i}${l}`||"."},normalize(s){m(s,"path");const i=s.length;if(i===0)return".";let l=0,g,L=!1;const w=s.charCodeAt(0);if(i===1)return C(w)?"\\":s;if(e(w))if(L=!0,e(s.charCodeAt(1))){let v=2,_=v;for(;v<i&&!e(s.charCodeAt(v));)v++;if(v<i&&v!==_){const b=s.slice(_,v);for(_=v;v<i&&e(s.charCodeAt(v));)v++;if(v<i&&v!==_){for(_=v;v<i&&!e(s.charCodeAt(v));)v++;if(v===i)return`\\\\${b}\\${s.slice(_)}\\`;v!==_&&(g=`\\\\${b}\\${s.slice(_,v)}`,l=v)}}}else l=1;else N(w)&&s.charCodeAt(1)===E&&(g=s.slice(0,2),l=2,i>2&&e(s.charCodeAt(2))&&(L=!0,l=3));let d=l<i?A(s.slice(l),!L,"\\",e):"";return d.length===0&&!L&&(d="."),d.length>0&&e(s.charCodeAt(i-1))&&(d+="\\"),g===void 0?L?`\\${d}`:d:L?`${g}\\${d}`:`${g}${d}`},isAbsolute(s){m(s,"path");const i=s.length;if(i===0)return!1;const l=s.charCodeAt(0);return e(l)||i>2&&N(l)&&s.charCodeAt(1)===E&&e(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let i,l;for(let w=0;w<s.length;++w){const d=s[w];m(d,"path"),d.length>0&&(i===void 0?i=l=d:i+=`\\${d}`)}if(i===void 0)return".";let g=!0,L=0;if(typeof l=="string"&&e(l.charCodeAt(0))){++L;const w=l.length;w>1&&e(l.charCodeAt(1))&&(++L,w>2&&(e(l.charCodeAt(2))?++L:g=!1))}if(g){for(;L<i.length&&e(i.charCodeAt(L));)L++;L>=2&&(i=`\\${i.slice(L)}`)}return n.win32.normalize(i)},relative(s,i){if(m(s,"from"),m(i,"to"),s===i)return"";const l=n.win32.resolve(s),g=n.win32.resolve(i);if(l===g||(s=l.toLowerCase(),i=g.toLowerCase(),s===i))return"";let L=0;for(;L<s.length&&s.charCodeAt(L)===c;)L++;let w=s.length;for(;w-1>L&&s.charCodeAt(w-1)===c;)w--;const d=w-L;let v=0;for(;v<i.length&&i.charCodeAt(v)===c;)v++;let _=i.length;for(;_-1>v&&i.charCodeAt(_-1)===c;)_--;const b=_-v,f=d<b?d:b;let P=-1,O=0;for(;O<f;O++){const q=s.charCodeAt(L+O);if(q!==i.charCodeAt(v+O))break;q===c&&(P=O)}if(O!==f){if(P===-1)return g}else{if(b>f){if(i.charCodeAt(v+O)===c)return g.slice(v+O+1);if(O===2)return g.slice(v+O)}d>f&&(s.charCodeAt(L+O)===c?P=O:O===2&&(P=3)),P===-1&&(P=0)}let U="";for(O=L+P+1;O<=w;++O)(O===w||s.charCodeAt(O)===c)&&(U+=U.length===0?"..":"\\..");return v+=P,U.length>0?`${U}${g.slice(v,_)}`:(g.charCodeAt(v)===c&&++v,g.slice(v,_))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const i=n.win32.resolve(s);if(i.length<=2)return s;if(i.charCodeAt(0)===c){if(i.charCodeAt(1)===c){const l=i.charCodeAt(2);if(l!==D&&l!==h)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(N(i.charCodeAt(0))&&i.charCodeAt(1)===E&&i.charCodeAt(2)===c)return`\\\\?\\${i}`;return s},dirname(s){m(s,"path");const i=s.length;if(i===0)return".";let l=-1,g=0;const L=s.charCodeAt(0);if(i===1)return e(L)?s:".";if(e(L)){if(l=g=1,e(s.charCodeAt(1))){let v=2,_=v;for(;v<i&&!e(s.charCodeAt(v));)v++;if(v<i&&v!==_){for(_=v;v<i&&e(s.charCodeAt(v));)v++;if(v<i&&v!==_){for(_=v;v<i&&!e(s.charCodeAt(v));)v++;if(v===i)return s;v!==_&&(l=g=v+1)}}}}else N(L)&&s.charCodeAt(1)===E&&(l=i>2&&e(s.charCodeAt(2))?3:2,g=l);let w=-1,d=!0;for(let v=i-1;v>=g;--v)if(e(s.charCodeAt(v))){if(!d){w=v;break}}else d=!1;if(w===-1){if(l===-1)return".";w=l}return s.slice(0,w)},basename(s,i){i!==void 0&&m(i,"ext"),m(s,"path");let l=0,g=-1,L=!0,w;if(s.length>=2&&N(s.charCodeAt(0))&&s.charCodeAt(1)===E&&(l=2),i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let d=i.length-1,v=-1;for(w=s.length-1;w>=l;--w){const _=s.charCodeAt(w);if(e(_)){if(!L){l=w+1;break}}else v===-1&&(L=!1,v=w+1),d>=0&&(_===i.charCodeAt(d)?--d==-1&&(g=w):(d=-1,g=v))}return l===g?g=v:g===-1&&(g=s.length),s.slice(l,g)}for(w=s.length-1;w>=l;--w)if(e(s.charCodeAt(w))){if(!L){l=w+1;break}}else g===-1&&(L=!1,g=w+1);return g===-1?"":s.slice(l,g)},extname(s){m(s,"path");let i=0,l=-1,g=0,L=-1,w=!0,d=0;s.length>=2&&s.charCodeAt(1)===E&&N(s.charCodeAt(0))&&(i=g=2);for(let v=s.length-1;v>=i;--v){const _=s.charCodeAt(v);if(e(_)){if(!w){g=v+1;break}continue}L===-1&&(w=!1,L=v+1),_===h?l===-1?l=v:d!==1&&(d=1):l!==-1&&(d=-1)}return l===-1||L===-1||d===0||d===1&&l===L-1&&l===g+1?"":s.slice(l,L)},format:u.bind(null,"\\"),parse(s){m(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const l=s.length;let g=0,L=s.charCodeAt(0);if(l===1)return e(L)?(i.root=i.dir=s,i):(i.base=i.name=s,i);if(e(L)){if(g=1,e(s.charCodeAt(1))){let P=2,O=P;for(;P<l&&!e(s.charCodeAt(P));)P++;if(P<l&&P!==O){for(O=P;P<l&&e(s.charCodeAt(P));)P++;if(P<l&&P!==O){for(O=P;P<l&&!e(s.charCodeAt(P));)P++;P===l?g=P:P!==O&&(g=P+1)}}}}else if(N(L)&&s.charCodeAt(1)===E){if(l<=2)return i.root=i.dir=s,i;if(g=2,e(s.charCodeAt(2))){if(l===3)return i.root=i.dir=s,i;g=3}}g>0&&(i.root=s.slice(0,g));let w=-1,d=g,v=-1,_=!0,b=s.length-1,f=0;for(;b>=g;--b){if(L=s.charCodeAt(b),e(L)){if(!_){d=b+1;break}continue}v===-1&&(_=!1,v=b+1),L===h?w===-1?w=b:f!==1&&(f=1):w!==-1&&(f=-1)}return v!==-1&&(w===-1||f===0||f===1&&w===v-1&&w===d+1?i.base=i.name=s.slice(d,v):(i.name=s.slice(d,w),i.base=s.slice(d,v),i.ext=s.slice(w,v))),d>0&&d!==g?i.dir=s.slice(0,d-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...s){let i="",l=!1;for(let g=s.length-1;g>=-1&&!l;g--){const L=g>=0?s[g]:M.cwd();m(L,"path"),L.length!==0&&(i=`${L}/${i}`,l=L.charCodeAt(0)===a)}return i=A(i,!l,"/",C),l?`/${i}`:i.length>0?i:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===a,l=s.charCodeAt(s.length-1)===a;return s=A(s,!i,"/",C),s.length===0?i?"/":l?"./":".":(l&&(s+="/"),i?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===a},join(...s){if(s.length===0)return".";let i;for(let l=0;l<s.length;++l){const g=s[l];m(g,"path"),g.length>0&&(i===void 0?i=g:i+=`/${g}`)}return i===void 0?".":n.posix.normalize(i)},relative(s,i){if(m(s,"from"),m(i,"to"),s===i||(s=n.posix.resolve(s),i=n.posix.resolve(i),s===i))return"";const l=1,g=s.length,L=g-l,w=1,d=i.length-w,v=L<d?L:d;let _=-1,b=0;for(;b<v;b++){const P=s.charCodeAt(l+b);if(P!==i.charCodeAt(w+b))break;P===a&&(_=b)}if(b===v)if(d>v){if(i.charCodeAt(w+b)===a)return i.slice(w+b+1);if(b===0)return i.slice(w+b)}else L>v&&(s.charCodeAt(l+b)===a?_=b:b===0&&(_=0));let f="";for(b=l+_+1;b<=g;++b)(b===g||s.charCodeAt(b)===a)&&(f+=f.length===0?"..":"/..");return`${f}${i.slice(w+_)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const i=s.charCodeAt(0)===a;let l=-1,g=!0;for(let L=s.length-1;L>=1;--L)if(s.charCodeAt(L)===a){if(!g){l=L;break}}else g=!1;return l===-1?i?"/":".":i&&l===1?"//":s.slice(0,l)},basename(s,i){i!==void 0&&m(i,"ext"),m(s,"path");let l=0,g=-1,L=!0,w;if(i!==void 0&&i.length>0&&i.length<=s.length){if(i===s)return"";let d=i.length-1,v=-1;for(w=s.length-1;w>=0;--w){const _=s.charCodeAt(w);if(_===a){if(!L){l=w+1;break}}else v===-1&&(L=!1,v=w+1),d>=0&&(_===i.charCodeAt(d)?--d==-1&&(g=w):(d=-1,g=v))}return l===g?g=v:g===-1&&(g=s.length),s.slice(l,g)}for(w=s.length-1;w>=0;--w)if(s.charCodeAt(w)===a){if(!L){l=w+1;break}}else g===-1&&(L=!1,g=w+1);return g===-1?"":s.slice(l,g)},extname(s){m(s,"path");let i=-1,l=0,g=-1,L=!0,w=0;for(let d=s.length-1;d>=0;--d){const v=s.charCodeAt(d);if(v===a){if(!L){l=d+1;break}continue}g===-1&&(L=!1,g=d+1),v===h?i===-1?i=d:w!==1&&(w=1):i!==-1&&(w=-1)}return i===-1||g===-1||w===0||w===1&&i===g-1&&i===l+1?"":s.slice(i,g)},format:u.bind(null,"/"),parse(s){m(s,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return i;const l=s.charCodeAt(0)===a;let g;l?(i.root="/",g=1):g=0;let L=-1,w=0,d=-1,v=!0,_=s.length-1,b=0;for(;_>=g;--_){const f=s.charCodeAt(_);if(f===a){if(!v){w=_+1;break}continue}d===-1&&(v=!1,d=_+1),f===h?L===-1?L=_:b!==1&&(b=1):L!==-1&&(b=-1)}if(d!==-1){const f=w===0&&l?1:w;L===-1||b===0||b===1&&L===d-1&&L===w+1?i.base=i.name=s.slice(f,d):(i.name=s.slice(f,L),i.base=s.slice(f,d),i.ext=s.slice(L,d))}return w>0?i.dir=s.slice(0,w-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=M.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=M.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=M.platform==="win32"?n.win32.join:n.posix.join,n.resolve=M.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=M.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=M.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=M.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=M.platform==="win32"?n.win32.extname:n.posix.extname,n.format=M.platform==="win32"?n.win32.format:n.posix.format,n.parse=M.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=M.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=M.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=M.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),Z(K[14],x([0,1,5]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=M.globals.performance&&typeof M.globals.performance.now=="function";class R{constructor(y){this._highResolution=t&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new R(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}n.StopWatch=R}),Z(K[7],x([0,1,9,11,6,13,14]),function(B,n,M,t,R,o,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;let h=!1,a=!1;var c;(function(_){_.None=()=>R.Disposable.None;function b(J){if(a){const{onListenerDidAdd:Q}=J,X=e.create();let Y=0;J.onListenerDidAdd=()=>{++Y==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),Q?.()}}}function f(J){return(Q,X=null,Y)=>{let S=!1,k;return k=J(T=>{if(!S)return k?k.dispose():S=!0,Q.call(X,T)},null,Y),S&&k.dispose(),k}}_.once=f;function P(J,Q,X){return te((Y,S=null,k)=>J(T=>Y.call(S,Q(T)),null,k),X)}_.map=P;function O(J,Q,X){return te((Y,S=null,k)=>J(T=>{Q(T),Y.call(S,T)},null,k),X)}_.forEach=O;function U(J,Q,X){return te((Y,S=null,k)=>J(T=>Q(T)&&Y.call(S,T),null,k),X)}_.filter=U;function q(J){return J}_.signal=q;function $(...J){return(Q,X=null,Y)=>(0,R.combinedDisposable)(...J.map(S=>S(k=>Q.call(X,k),null,Y)))}_.any=$;function j(J,Q,X,Y){let S=X;return P(J,k=>(S=Q(S,k),S),Y)}_.reduce=j;function te(J,Q){let X;const Y={onFirstListenerAdd(){X=J(S.fire,S)},onLastListenerRemove(){X.dispose()}};Q||b(Y);const S=new N(Y);return Q&&Q.add(S),S.event}function se(J,Q,X=100,Y=!1,S,k){let T,W,H,ne=0;const ie={leakWarningThreshold:S,onFirstListenerAdd(){T=J(ue=>{ne++,W=Q(W,ue),Y&&!H&&(ae.fire(W),W=void 0),clearTimeout(H),H=setTimeout(()=>{const fe=W;W=void 0,H=void 0,(!Y||ne>1)&&ae.fire(fe),ne=0},X)})},onLastListenerRemove(){T.dispose()}};k||b(ie);const ae=new N(ie);return k&&k.add(ae),ae.event}_.debounce=se;function ee(J,Q=(Y,S)=>Y===S,X){let Y=!0,S;return U(J,k=>{const T=Y||!Q(k,S);return Y=!1,S=k,T},X)}_.latch=ee;function r(J,Q,X){return[_.filter(J,Q,X),_.filter(J,Y=>!Q(Y),X)]}_.split=r;function he(J,Q=!1,X=[]){let Y=X.slice(),S=J(W=>{Y?Y.push(W):T.fire(W)});const k=()=>{Y&&Y.forEach(W=>T.fire(W)),Y=null},T=new N({onFirstListenerAdd(){S||(S=J(W=>T.fire(W)))},onFirstListenerDidAdd(){Y&&(Q?setTimeout(k):k())},onLastListenerRemove(){S&&S.dispose(),S=null}});return T.event}_.buffer=he;class de{constructor(Q){this.event=Q}map(Q){return new de(P(this.event,Q))}forEach(Q){return new de(O(this.event,Q))}filter(Q){return new de(U(this.event,Q))}reduce(Q,X){return new de(j(this.event,Q,X))}latch(){return new de(ee(this.event))}debounce(Q,X=100,Y=!1,S){return new de(se(this.event,Q,X,Y,S))}on(Q,X,Y){return this.event(Q,X,Y)}once(Q,X,Y){return f(this.event)(Q,X,Y)}}function Ae(J){return new de(J)}_.chain=Ae;function pe(J,Q,X=Y=>Y){const Y=(...W)=>T.fire(X(...W)),S=()=>J.on(Q,Y),k=()=>J.removeListener(Q,Y),T=new N({onFirstListenerAdd:S,onLastListenerRemove:k});return T.event}_.fromNodeEventEmitter=pe;function Le(J,Q,X=Y=>Y){const Y=(...W)=>T.fire(X(...W)),S=()=>J.addEventListener(Q,Y),k=()=>J.removeEventListener(Q,Y),T=new N({onFirstListenerAdd:S,onLastListenerRemove:k});return T.event}_.fromDOMEventEmitter=Le;function Ne(J){return new Promise(Q=>f(J)(Q))}_.toPromise=Ne;function Ee(J,Q){return Q(void 0),J(X=>Q(X))}_.runAndSubscribe=Ee;function Me(J,Q){let X=null;function Y(k){X?.dispose(),X=new R.DisposableStore,Q(k,X)}Y(void 0);const S=J(k=>Y(k));return(0,R.toDisposable)(()=>{S.dispose(),X?.dispose()})}_.runAndSubscribeWithStore=Me})(c=n.Event||(n.Event={}));class E{constructor(b){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${b}_${E._idPool++}`}start(b){this._stopWatch=new y.StopWatch(!0),this._listenerCount=b}stop(){if(this._stopWatch){const b=this._stopWatch.elapsed();this._elapsedOverall+=b,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${b.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let D=-1;function p(_){const b=D;return D=_,{dispose(){D=b}}}n.setGlobalLeakWarningThreshold=p;class m{constructor(b,f=Math.random().toString(18).slice(2,5)){this.customThreshold=b,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(b,f){let P=D;if(typeof this.customThreshold=="number"&&(P=this.customThreshold),P<=0||f<P)return;this._stacks||(this._stacks=new Map);const O=this._stacks.get(b.value)||0;if(this._stacks.set(b.value,O+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=P*.5;let U,q=0;for(const[$,j]of this._stacks)(!U||q<j)&&(U=$,q=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${q}):`),console.warn(U)}return()=>{const U=this._stacks.get(b.value)||0;this._stacks.set(b.value,U-1)}}}class e{constructor(b){this.value=b}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(b,f,P){this.callback=b,this.callbackThis=f,this.stack=P,this.subscription=new R.SafeDisposable}invoke(b){this.callback.call(this.callbackThis,b)}}class N{constructor(b){this._disposed=!1,this._options=b,this._leakageMon=D>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(h){const b=Array.from(this._listeners);queueMicrotask(()=>{for(const f of b)f.subscription.isset()&&(f.subscription.unset(),f.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(b,f,P)=>{this._listeners||(this._listeners=new o.LinkedList);const O=this._listeners.isEmpty();O&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let U,q;this._leakageMon&&this._listeners.size>=30&&(q=e.create(),U=this._leakageMon.check(q,this._listeners.size+1)),h&&(q=q??e.create());const $=new C(b,f,q),j=this._listeners.push($);O&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,b,f);const te=$.subscription.set(()=>{U&&U(),this._disposed||(j(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return P instanceof R.DisposableStore?P.add(te):Array.isArray(P)&&P.push(te),te}),this._event}fire(b){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new u);for(let f of this._listeners)this._deliveryQueue.push(this,f,b);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=N;class A{constructor(){this._queue=new o.LinkedList}get size(){return this._queue.size}push(b,f,P){this._queue.push(new s(b,f,P))}clear(b){const f=new o.LinkedList;for(const P of this._queue)P.emitter!==b&&f.push(P);this._queue=f}deliver(){for(;this._queue.size>0;){const b=this._queue.shift();try{b.listener.invoke(b.event)}catch(f){(0,M.onUnexpectedError)(f)}}}}n.EventDeliveryQueue=A;class u extends A{clear(b){this._queue.clear()}}class s{constructor(b,f,P){this.emitter=b,this.listener=f,this.event=P}}class i extends N{async fireAsync(b,f,P){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new o.LinkedList);for(const O of this._listeners)this._asyncDeliveryQueue.push([O,b]);for(;this._asyncDeliveryQueue.size>0&&!f.isCancellationRequested;){const[O,U]=this._asyncDeliveryQueue.shift(),q=[],$={...U,token:f,waitUntil:j=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");P&&(j=P(j,O.callback)),q.push(j)}};try{O.invoke($)}catch(j){(0,M.onUnexpectedError)(j);continue}Object.freeze(q),await Promise.allSettled(q).then(j=>{for(const te of j)te.status==="rejected"&&(0,M.onUnexpectedError)(te.reason)})}}}}n.AsyncEmitter=i;class l extends N{constructor(b){super(b);this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=b?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const b=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(b))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(b){this._listeners&&(this._isPaused!==0?this._eventQueue.push(b):super.fire(b))}}n.PauseableEmitter=l;class g extends l{constructor(b){super(b);this._delay=b.delay??100}fire(b){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(b)}}n.DebounceEmitter=g;class L extends N{constructor(b){super(b);this._queuedEvents=[],this._mergeFn=b?.merge}fire(b){this._queuedEvents.push(b),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(f=>super.fire(f)),this._queuedEvents=[]})}}n.MicrotaskEmitter=L;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new N({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(b){const f={event:b,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const P=()=>{this.hasListeners&&this.unhook(f);const O=this.events.indexOf(f);this.events.splice(O,1)};return(0,R.toDisposable)((0,t.once)(P))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(b=>this.hook(b))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(b=>this.unhook(b))}hook(b){b.listener=b.event(f=>this.emitter.fire(f))}unhook(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=w;class d{constructor(){this.buffers=[]}wrapEvent(b){return(f,P,O)=>b(U=>{const q=this.buffers[this.buffers.length-1];q?q.push(()=>f.call(P,U)):f.call(P,U)},void 0,O)}bufferEvents(b){const f=[];this.buffers.push(f);const P=b();return this.buffers.pop(),f.forEach(O=>O()),P}}n.EventBufferer=d;class v{constructor(){this.listening=!1,this.inputEvent=c.None,this.inputEventListener=R.Disposable.None,this.emitter=new N({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(b){this.inputEvent=b,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=b(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=v}),Z(K[15],x([0,1,7]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(h,a){const c=setTimeout(h.bind(a),0);return{dispose(){clearTimeout(c)}}});var R;(function(h){function a(c){return c===h.None||c===h.Cancelled||c instanceof o?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}h.isCancellationToken=a,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=n.CancellationToken||(n.CancellationToken={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=R.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=R.None}}n.CancellationTokenSource=y}),Z(K[27],x([0,1,15]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new M.CancellationTokenSource,a=this.task(h.token);return this.result={promise:a,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}n.Cache=t;class R{constructor(h){this.fn=h,this.lastCache=void 0,this.lastArgKey=void 0}get(h){const a=JSON.stringify(h);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this.fn(h)),this.lastCache}}n.LRUCachedFunction=R;class o{constructor(h){this.fn=h,this._map=new Map}get cachedValues(){return this._map}get(h){if(this._map.has(h))return this._map.get(h);const a=this.fn(h);return this._map.set(h,a),a}}n.CachedFunction=o}),Z(K[2],x([0,1,27,24]),function(B,n,M,t){"use strict";var R;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function o(F){return!F||typeof F!="string"?!0:F.trim().length===0}n.isFalsyOrWhitespace=o;const y=/{(\d+)}/g;function h(F,...I){return I.length===0?F:F.replace(y,function(V,z){const G=parseInt(z,10);return isNaN(G)||G<0||G>=I.length?V:I[G]})}n.format=h;const a=/{([^}]+)}/g;function c(F,I){return F.replace(a,(V,z)=>I[z]??V)}n.format2=c;function E(F){return F.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}n.escape=E;function D(F){return F.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=D;function p(F,I){let V=0;const z=I.charCodeAt(0);for(let G=F.length-1;G>=0;G--)F.charCodeAt(G)===z&&V++;return V}n.count=p;function m(F,I,V="\u2026"){return F.length<=I?F:`${F.substr(0,I)}${V}`}n.truncate=m;function e(F,I=" "){const V=C(F,I);return N(V,I)}n.trim=e;function C(F,I){if(!F||!I)return F;const V=I.length;if(V===0||F.length===0)return F;let z=0;for(;F.indexOf(I,z)===z;)z=z+V;return F.substring(z)}n.ltrim=C;function N(F,I){if(!F||!I)return F;const V=I.length,z=F.length;if(V===0||z===0)return F;let G=z,re=-1;for(;re=F.lastIndexOf(I,G-1),!(re===-1||re+V!==G);){if(re===0)return"";G=re}return F.substring(0,G)}n.rtrim=N;function A(F){return F.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=A;function u(F){return F.replace(/\*/g,"")}n.stripWildcards=u;function s(F,I,V={}){if(!F)throw new Error("Cannot create regex from empty string");I||(F=D(F)),V.wholeWord&&(/\B/.test(F.charAt(0))||(F="\\b"+F),/\B/.test(F.charAt(F.length-1))||(F=F+"\\b"));let z="";return V.global&&(z+="g"),V.matchCase||(z+="i"),V.multiline&&(z+="m"),V.unicode&&(z+="u"),new RegExp(F,z)}n.createRegExp=s;function i(F){return F.source==="^"||F.source==="^$"||F.source==="$"||F.source==="^\\s*$"?!1:!!(F.exec("")&&F.lastIndex===0)}n.regExpLeadsToEndlessLoop=i;function l(F){return!!F.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=l;function g(F){return(F.global?"g":"")+(F.ignoreCase?"i":"")+(F.multiline?"m":"")+(F.unicode?"u":"")}n.regExpFlags=g;function L(F){return F.split(/\r\n|\r|\n/)}n.splitLines=L;function w(F){for(let I=0,V=F.length;I<V;I++){const z=F.charCodeAt(I);if(z!==32&&z!==9)return I}return-1}n.firstNonWhitespaceIndex=w;function d(F,I=0,V=F.length){for(let z=I;z<V;z++){const G=F.charCodeAt(z);if(G!==32&&G!==9)return F.substring(I,z)}return F.substring(I,V)}n.getLeadingWhitespace=d;function v(F,I=F.length-1){for(let V=I;V>=0;V--){const z=F.charCodeAt(V);if(z!==32&&z!==9)return V}return-1}n.lastNonWhitespaceIndex=v;function _(F,I,V){let z=[],G=0;for(const re of F.matchAll(I)){if(z.push(F.slice(G,re.index)),re.index===void 0)throw new Error("match.index should be defined");G=re.index+re[0].length,z.push(V(re[0],...re.slice(1),re.index,F,re.groups))}return z.push(F.slice(G)),Promise.all(z).then(re=>re.join(""))}n.replaceAsync=_;function b(F,I){return F<I?-1:F>I?1:0}n.compare=b;function f(F,I,V=0,z=F.length,G=0,re=I.length){for(;V<z&&G<re;V++,G++){let be=F.charCodeAt(V),oe=I.charCodeAt(G);if(be<oe)return-1;if(be>oe)return 1}const ce=z-V,Ce=re-G;return ce<Ce?-1:ce>Ce?1:0}n.compareSubstring=f;function P(F,I){return O(F,I,0,F.length,0,I.length)}n.compareIgnoreCase=P;function O(F,I,V=0,z=F.length,G=0,re=I.length){for(;V<z&&G<re;V++,G++){let be=F.charCodeAt(V),oe=I.charCodeAt(G);if(be===oe)continue;if(be>=128||oe>=128)return f(F.toLowerCase(),I.toLowerCase(),V,z,G,re);U(be)&&(be-=32),U(oe)&&(oe-=32);const me=be-oe;if(me!==0)return me}const ce=z-V,Ce=re-G;return ce<Ce?-1:ce>Ce?1:0}n.compareSubstringIgnoreCase=O;function U(F){return F>=97&&F<=122}n.isLowerAsciiLetter=U;function q(F){return F>=65&&F<=90}n.isUpperAsciiLetter=q;function $(F,I){return F.length===I.length&&O(F,I)===0}n.equalsIgnoreCase=$;function j(F,I){const V=I.length;return I.length>F.length?!1:O(F,I,0,V)===0}n.startsWithIgnoreCase=j;function te(F,I){let V,z=Math.min(F.length,I.length);for(V=0;V<z;V++)if(F.charCodeAt(V)!==I.charCodeAt(V))return V;return z}n.commonPrefixLength=te;function se(F,I){let V,z=Math.min(F.length,I.length);const G=F.length-1,re=I.length-1;for(V=0;V<z;V++)if(F.charCodeAt(G-V)!==I.charCodeAt(re-V))return V;return z}n.commonSuffixLength=se;function ee(F){return 55296<=F&&F<=56319}n.isHighSurrogate=ee;function r(F){return 56320<=F&&F<=57343}n.isLowSurrogate=r;function he(F,I){return(F-55296<<10)+(I-56320)+65536}n.computeCodePoint=he;function de(F,I,V){const z=F.charCodeAt(V);if(ee(z)&&V+1<I){const G=F.charCodeAt(V+1);if(r(G))return he(z,G)}return z}n.getNextCodePoint=de;function Ae(F,I){const V=F.charCodeAt(I-1);if(r(V)&&I>1){const z=F.charCodeAt(I-2);if(ee(z))return he(z,V)}return V}class pe{constructor(I,V=0){this._str=I,this._len=I.length,this._offset=V}get offset(){return this._offset}setOffset(I){this._offset=I}prevCodePoint(){const I=Ae(this._str,this._offset);return this._offset-=I>=65536?2:1,I}nextCodePoint(){const I=de(this._str,this._len,this._offset);return this._offset+=I>=65536?2:1,I}eol(){return this._offset>=this._len}}n.CodePointIterator=pe;class Le{constructor(I,V=0){this._iterator=new pe(I,V)}get offset(){return this._iterator.offset}nextGraphemeLength(){const I=ve.getInstance(),V=this._iterator,z=V.offset;let G=I.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const re=V.offset,ce=I.getGraphemeBreakType(V.nextCodePoint());if(Se(G,ce)){V.setOffset(re);break}G=ce}return V.offset-z}prevGraphemeLength(){const I=ve.getInstance(),V=this._iterator,z=V.offset;let G=I.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const re=V.offset,ce=I.getGraphemeBreakType(V.prevCodePoint());if(Se(ce,G)){V.setOffset(re);break}G=ce}return z-V.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=Le;function Ne(F,I){return new Le(F,I).nextGraphemeLength()}n.nextCharLength=Ne;function Ee(F,I){return new Le(F,I).prevGraphemeLength()}n.prevCharLength=Ee;function Me(F,I){I>0&&r(F.charCodeAt(I))&&I--;const V=I+Ne(F,I);return[V-Ee(F,V),V]}n.getCharContainingOffset=Me;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(F){return J.test(F)}n.containsRTL=Q;const X=/^[\t\n\r\x20-\x7E]*$/;function Y(F){return X.test(F)}n.isBasicASCII=Y,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function S(F){return n.UNUSUAL_LINE_TERMINATORS.test(F)}n.containsUnusualLineTerminators=S;function k(F){return F>=11904&&F<=55215||F>=63744&&F<=64255||F>=65281&&F<=65374}n.isFullWidthCharacter=k;function T(F){return F>=127462&&F<=127487||F===8986||F===8987||F===9200||F===9203||F>=9728&&F<=10175||F===11088||F===11093||F>=127744&&F<=128591||F>=128640&&F<=128764||F>=128992&&F<=129008||F>=129280&&F<=129535||F>=129648&&F<=129782}n.isEmojiImprecise=T;function W(F,I){if(F.length<I)return F;const V=/\b/g;let z=0;for(;V.test(F)&&!(F.length-V.lastIndex<I);)z=V.lastIndex,V.lastIndex+=1;return F.substring(z).replace(/^\s/,"")}n.lcut=W;const H=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ae(F){return F&&(F=F.replace(H,""),F=F.replace(ne,""),F=F.replace(ie,"")),F}n.removeAnsiEscapeCodes=ae,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(F){return!!(F&&F.length>0&&F.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ue;function fe(F){return ue(F)?F.substr(1):F}n.stripUTF8BOM=fe;function ge(F,I){if(!F||!I||F.length<I.length)return!1;const V=I.length,z=F.toLowerCase();let G=0,re=-1;for(;G<V;){const ce=z.indexOf(I[G],re+1);if(ce<0)return!1;re=ce,G++}return!0}n.fuzzyContains=ge;function Pe(F,I=!1){return F?(I&&(F=F.replace(/\\./g,"")),F.toLowerCase()!==F):!1}n.containsUppercaseCharacter=Pe;function Oe(F){return F.charAt(0).toUpperCase()+F.slice(1)}n.uppercaseFirstLetter=Oe;function Be(F,I=1){if(I===0)return"";let V=-1;do V=F.indexOf(`
`,V+1),I--;while(I>0&&V>=0);return V===-1?F:(F[V-1]==="\r"&&V--,F.substr(0,V))}n.getNLines=Be;function Ve(F){const I=90-65+1;return F=F%(2*I),F<I?String.fromCharCode(97+F):String.fromCharCode(65+F-I)}n.singleLetterHash=Ve;function We(F){return ve.getInstance().getGraphemeBreakType(F)}n.getGraphemeBreakType=We;function Se(F,I){return F===0?I!==5&&I!==7:F===2&&I===3?!1:F===4||F===2||F===3||I===4||I===2||I===3?!0:!(F===8&&(I===8||I===9||I===11||I===12)||(F===11||F===9)&&(I===9||I===10)||(F===12||F===10)&&I===10||I===5||I===13||I===7||F===1||F===13&&I===14||F===6&&I===6)}var qe;(function(F){F[F.Other=0]="Other",F[F.Prepend=1]="Prepend",F[F.CR=2]="CR",F[F.LF=3]="LF",F[F.Control=4]="Control",F[F.Extend=5]="Extend",F[F.Regional_Indicator=6]="Regional_Indicator",F[F.SpacingMark=7]="SpacingMark",F[F.L=8]="L",F[F.V=9]="V",F[F.T=10]="T",F[F.LV=11]="LV",F[F.LVT=12]="LVT",F[F.ZWJ=13]="ZWJ",F[F.Extended_Pictographic=14]="Extended_Pictographic"})(qe=n.GraphemeBreakType||(n.GraphemeBreakType={}));class ve{constructor(){this._data=He()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const V=this._data,z=V.length/3;let G=1;for(;G<=z;)if(I<V[3*G])G=2*G;else if(I>V[3*G+1])G=2*G+1;else return V[3*G+2];return 0}}ve._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(F,I){if(F===0)return 0;const V=je(F,I);if(V!==void 0)return V;const z=new pe(I,F);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=ze;function je(F,I){const V=new pe(I,F);let z=V.prevCodePoint();for(;$e(z)||z===65039||z===8419;){if(V.offset===0)return;z=V.prevCodePoint()}if(!T(z))return;let G=V.offset;return G>0&&V.prevCodePoint()===8205&&(G=V.offset),G}function $e(F){return 127995<=F&&F<=127999}var Ie;(function(F){F[F.zwj=8205]="zwj",F[F.emojiVariantSelector=65039]="emojiVariantSelector",F[F.enclosingKeyCap=8419]="enclosingKeyCap"})(Ie||(Ie={})),n.noBreakWhitespace="\xA0";class _e{constructor(I){this.confusableDictionary=I}static getInstance(I){return _e.cache.get(Array.from(I))}static getLocales(){return _e._locales.getValue()}isAmbiguous(I){return this.confusableDictionary.has(I)}getPrimaryConfusable(I){return this.confusableDictionary.get(I)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=_e,R=_e,_e.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new M.LRUCachedFunction(F=>{function I(oe){const me=new Map;for(let we=0;we<oe.length;we+=2)me.set(oe[we],oe[we+1]);return me}function V(oe,me){const we=new Map(oe);for(const[De,Fe]of me)we.set(De,Fe);return we}function z(oe,me){if(!oe)return me;const we=new Map;for(const[De,Fe]of oe)me.has(De)&&we.set(De,Fe);return we}const G=R.ambiguousCharacterData.getValue();let re=F.filter(oe=>!oe.startsWith("_")&&oe in G);re.length===0&&(re=["_default"]);let ce;for(const oe of re){const me=I(G[oe]);ce=z(ce,me)}const Ce=I(G._common),be=V(Ce,ce);return new _e(be)}),_e._locales=new t.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(F=>!F.startsWith("_")));class ye{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ye.getRawData())),this._data}static isInvisibleCharacter(I){return ye.getData().has(I)}static get codePoints(){return ye.getData()}}n.InvisibleCharacters=ye,ye._data=void 0}),Z(K[28],x([0,1,2]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(A){return R(A,0)}n.hash=t;function R(A,u){switch(typeof A){case"object":return A===null?o(349,u):Array.isArray(A)?a(A,u):c(A,u);case"string":return h(A,u);case"boolean":return y(A,u);case"number":return o(A,u);case"undefined":return o(937,u);default:return o(617,u)}}n.doHash=R;function o(A,u){return(u<<5)-u+A|0}n.numberHash=o;function y(A,u){return o(A?433:863,u)}function h(A,u){u=o(149417,u);for(let s=0,i=A.length;s<i;s++)u=o(A.charCodeAt(s),u);return u}n.stringHash=h;function a(A,u){return u=o(104579,u),A.reduce((s,i)=>R(i,s),u)}function c(A,u){return u=o(181387,u),Object.keys(A).sort().reduce((s,i)=>(s=h(i,s),R(A[i],s)),u)}class E{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=R(u,this._value),this._value}}n.Hasher=E;var D;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function p(A,u,s=32){const i=s-u,l=~((1<<i)-1);return(A<<u|(l&A)>>>i)>>>0}function m(A,u=0,s=A.byteLength,i=0){for(let l=0;l<s;l++)A[u+l]=i}function e(A,u,s="0"){for(;A.length<u;)A=s+A;return A}function C(A,u=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(s=>s.toString(16).padStart(2,"0")).join(""):e((A>>>0).toString(16),u/4)}n.toHexString=C;class N{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const s=u.length;if(s===0)return;const i=this._buff;let l=this._buffLen,g=this._leftoverHighSurrogate,L,w;for(g!==0?(L=g,w=-1,g=0):(L=u.charCodeAt(0),w=0);;){let d=L;if(M.isHighSurrogate(L))if(w+1<s){const v=u.charCodeAt(w+1);M.isLowSurrogate(v)?(w++,d=M.computeCodePoint(L,v)):d=65533}else{g=L;break}else M.isLowSurrogate(L)&&(d=65533);if(l=this._push(i,l,d),w++,w<s)L=u.charCodeAt(w);else break}this._buffLen=l,this._leftoverHighSurrogate=g}_push(u,s,i){return i<128?u[s++]=i:i<2048?(u[s++]=192|(i&1984)>>>6,u[s++]=128|(i&63)>>>0):i<65536?(u[s++]=224|(i&61440)>>>12,u[s++]=128|(i&4032)>>>6,u[s++]=128|(i&63)>>>0):(u[s++]=240|(i&1835008)>>>18,u[s++]=128|(i&258048)>>>12,u[s++]=128|(i&4032)>>>6,u[s++]=128|(i&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),C(this._h0)+C(this._h1)+C(this._h2)+C(this._h3)+C(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=N._bigBlock32,s=this._buffDV;for(let b=0;b<64;b+=4)u.setUint32(b,s.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)u.setUint32(b,p(u.getUint32(b-12,!1)^u.getUint32(b-32,!1)^u.getUint32(b-56,!1)^u.getUint32(b-64,!1),1),!1);let i=this._h0,l=this._h1,g=this._h2,L=this._h3,w=this._h4,d,v,_;for(let b=0;b<80;b++)b<20?(d=l&g|~l&L,v=1518500249):b<40?(d=l^g^L,v=1859775393):b<60?(d=l&g|l&L|g&L,v=2400959708):(d=l^g^L,v=3395469782),_=p(i,5)+d+w+v+u.getUint32(b*4,!1)&4294967295,w=L,L=g,g=p(l,30),l=i,i=_;this._h0=this._h0+i&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+g&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+w&4294967295}}n.StringSHA1=N,N._bigBlock32=new DataView(new ArrayBuffer(320))}),Z(K[16],x([0,1,21,28]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class R{constructor(p){this.source=p}getElements(){const p=this.source,m=new Int32Array(p.length);for(let e=0,C=p.length;e<C;e++)m[e]=p.charCodeAt(e);return m}}n.StringDiffSequence=R;function o(D,p,m){return new E(new R(D),new R(p)).ComputeDiff(m).changes}n.stringDiff=o;class y{static Assert(p,m){if(!p)throw new Error(m)}}n.Debug=y;class h{static Copy(p,m,e,C,N){for(let A=0;A<N;A++)e[C+A]=p[m+A]}static Copy2(p,m,e,C,N){for(let A=0;A<N;A++)e[C+A]=p[m+A]}}n.MyArray=h;var a;(function(D){D[D.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(p,m){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(p,m){this.m_originalStart=Math.min(this.m_originalStart,p),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class E{constructor(p,m,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=p,this._modifiedSequence=m;const[C,N,A]=E._getElements(p),[u,s,i]=E._getElements(m);this._hasStrings=A&&i,this._originalStringElements=C,this._originalElementsOrHash=N,this._modifiedStringElements=u,this._modifiedElementsOrHash=s,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(p){return p.length>0&&typeof p[0]=="string"}static _getElements(p){const m=p.getElements();if(E._isStringArray(m)){const e=new Int32Array(m.length);for(let C=0,N=m.length;C<N;C++)e[C]=(0,t.stringHash)(m[C],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(p,m){return this._originalElementsOrHash[p]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[p]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(p,m){if(!this.ElementsAreEqual(p,m))return!1;const e=E._getStrictElement(this._originalSequence,p),C=E._getStrictElement(this._modifiedSequence,m);return e===C}static _getStrictElement(p,m){return typeof p.getStrictElement=="function"?p.getStrictElement(m):null}OriginalElementsAreEqual(p,m){return this._originalElementsOrHash[p]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[p]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(p,m){return this._modifiedElementsOrHash[p]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[p]===this._modifiedStringElements[m]:!0}ComputeDiff(p){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,p)}_ComputeDiff(p,m,e,C,N){const A=[!1];let u=this.ComputeDiffRecursive(p,m,e,C,A);return N&&(u=this.PrettifyChanges(u)),{quitEarly:A[0],changes:u}}ComputeDiffRecursive(p,m,e,C,N){for(N[0]=!1;p<=m&&e<=C&&this.ElementsAreEqual(p,e);)p++,e++;for(;m>=p&&C>=e&&this.ElementsAreEqual(m,C);)m--,C--;if(p>m||e>C){let g;return e<=C?(y.Assert(p===m+1,"originalStart should only be one more than originalEnd"),g=[new M.DiffChange(p,0,e,C-e+1)]):p<=m?(y.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),g=[new M.DiffChange(p,m-p+1,e,0)]):(y.Assert(p===m+1,"originalStart should only be one more than originalEnd"),y.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}const A=[0],u=[0],s=this.ComputeRecursionPoint(p,m,e,C,A,u,N),i=A[0],l=u[0];if(s!==null)return s;if(!N[0]){const g=this.ComputeDiffRecursive(p,i,e,l,N);let L=[];return N[0]?L=[new M.DiffChange(i+1,m-(i+1)+1,l+1,C-(l+1)+1)]:L=this.ComputeDiffRecursive(i+1,m,l+1,C,N),this.ConcatenateChanges(g,L)}return[new M.DiffChange(p,m-p+1,e,C-e+1)]}WALKTRACE(p,m,e,C,N,A,u,s,i,l,g,L,w,d,v,_,b,f){let P=null,O=null,U=new c,q=m,$=e,j=w[0]-_[0]-C,te=-1073741824,se=this.m_forwardHistory.length-1;do{const ee=j+p;ee===q||ee<$&&i[ee-1]<i[ee+1]?(g=i[ee+1],d=g-j-C,g<te&&U.MarkNextChange(),te=g,U.AddModifiedElement(g+1,d),j=ee+1-p):(g=i[ee-1]+1,d=g-j-C,g<te&&U.MarkNextChange(),te=g-1,U.AddOriginalElement(g,d+1),j=ee-1-p),se>=0&&(i=this.m_forwardHistory[se],p=i[0],q=1,$=i.length-1)}while(--se>=-1);if(P=U.getReverseChanges(),f[0]){let ee=w[0]+1,r=_[0]+1;if(P!==null&&P.length>0){const he=P[P.length-1];ee=Math.max(ee,he.getOriginalEnd()),r=Math.max(r,he.getModifiedEnd())}O=[new M.DiffChange(ee,L-ee+1,r,v-r+1)]}else{U=new c,q=A,$=u,j=w[0]-_[0]-s,te=1073741824,se=b?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ee=j+N;ee===q||ee<$&&l[ee-1]>=l[ee+1]?(g=l[ee+1]-1,d=g-j-s,g>te&&U.MarkNextChange(),te=g+1,U.AddOriginalElement(g+1,d+1),j=ee+1-N):(g=l[ee-1],d=g-j-s,g>te&&U.MarkNextChange(),te=g,U.AddModifiedElement(g+1,d+1),j=ee-1-N),se>=0&&(l=this.m_reverseHistory[se],N=l[0],q=1,$=l.length-1)}while(--se>=-1);O=U.getChanges()}return this.ConcatenateChanges(P,O)}ComputeRecursionPoint(p,m,e,C,N,A,u){let s=0,i=0,l=0,g=0,L=0,w=0;p--,e--,N[0]=0,A[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=m-p+(C-e),v=d+1,_=new Int32Array(v),b=new Int32Array(v),f=C-e,P=m-p,O=p-e,U=m-C,$=(P-f)%2==0;_[f]=p,b[P]=m,u[0]=!1;for(let j=1;j<=d/2+1;j++){let te=0,se=0;l=this.ClipDiagonalBound(f-j,j,f,v),g=this.ClipDiagonalBound(f+j,j,f,v);for(let r=l;r<=g;r+=2){r===l||r<g&&_[r-1]<_[r+1]?s=_[r+1]:s=_[r-1]+1,i=s-(r-f)-O;const he=s;for(;s<m&&i<C&&this.ElementsAreEqual(s+1,i+1);)s++,i++;if(_[r]=s,s+i>te+se&&(te=s,se=i),!$&&Math.abs(r-P)<=j-1&&s>=b[r])return N[0]=s,A[0]=i,he<=b[r]&&1447>0&&j<=1447+1?this.WALKTRACE(f,l,g,O,P,L,w,U,_,b,s,m,N,i,C,A,$,u):null}const ee=(te-p+(se-e)-j)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(te,ee))return u[0]=!0,N[0]=te,A[0]=se,ee>0&&1447>0&&j<=1447+1?this.WALKTRACE(f,l,g,O,P,L,w,U,_,b,s,m,N,i,C,A,$,u):(p++,e++,[new M.DiffChange(p,m-p+1,e,C-e+1)]);L=this.ClipDiagonalBound(P-j,j,P,v),w=this.ClipDiagonalBound(P+j,j,P,v);for(let r=L;r<=w;r+=2){r===L||r<w&&b[r-1]>=b[r+1]?s=b[r+1]-1:s=b[r-1],i=s-(r-P)-U;const he=s;for(;s>p&&i>e&&this.ElementsAreEqual(s,i);)s--,i--;if(b[r]=s,$&&Math.abs(r-f)<=j&&s<=_[r])return N[0]=s,A[0]=i,he>=_[r]&&1447>0&&j<=1447+1?this.WALKTRACE(f,l,g,O,P,L,w,U,_,b,s,m,N,i,C,A,$,u):null}if(j<=1447){let r=new Int32Array(g-l+2);r[0]=f-l+1,h.Copy2(_,l,r,1,g-l+1),this.m_forwardHistory.push(r),r=new Int32Array(w-L+2),r[0]=P-L+1,h.Copy2(b,L,r,1,w-L+1),this.m_reverseHistory.push(r)}}return this.WALKTRACE(f,l,g,O,P,L,w,U,_,b,s,m,N,i,C,A,$,u)}PrettifyChanges(p){for(let m=0;m<p.length;m++){const e=p[m],C=m<p.length-1?p[m+1].originalStart:this._originalElementsOrHash.length,N=m<p.length-1?p[m+1].modifiedStart:this._modifiedElementsOrHash.length,A=e.originalLength>0,u=e.modifiedLength>0;for(;e.originalStart+e.originalLength<C&&e.modifiedStart+e.modifiedLength<N&&(!A||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!u||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const i=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!i)break;e.originalStart++,e.modifiedStart++}let s=[null];if(m<p.length-1&&this.ChangesOverlap(p[m],p[m+1],s)){p[m]=s[0],p.splice(m+1,1),m--;continue}}for(let m=p.length-1;m>=0;m--){const e=p[m];let C=0,N=0;if(m>0){const g=p[m-1];C=g.originalStart+g.originalLength,N=g.modifiedStart+g.modifiedLength}const A=e.originalLength>0,u=e.modifiedLength>0;let s=0,i=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let g=1;;g++){const L=e.originalStart-g,w=e.modifiedStart-g;if(L<C||w<N||A&&!this.OriginalElementsAreEqual(L,L+e.originalLength)||u&&!this.ModifiedElementsAreEqual(w,w+e.modifiedLength))break;const v=(L===C&&w===N?5:0)+this._boundaryScore(L,e.originalLength,w,e.modifiedLength);v>i&&(i=v,s=g)}e.originalStart-=s,e.modifiedStart-=s;const l=[null];if(m>0&&this.ChangesOverlap(p[m-1],p[m],l)){p[m-1]=l[0],p.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,e=p.length;m<e;m++){const C=p[m-1],N=p[m],A=N.originalStart-C.originalStart-C.originalLength,u=C.originalStart,s=N.originalStart+N.originalLength,i=s-u,l=C.modifiedStart,g=N.modifiedStart+N.modifiedLength,L=g-l;if(A<5&&i<20&&L<20){const w=this._findBetterContiguousSequence(u,i,l,L,A);if(w){const[d,v]=w;(d!==C.originalStart+C.originalLength||v!==C.modifiedStart+C.modifiedLength)&&(C.originalLength=d-C.originalStart,C.modifiedLength=v-C.modifiedStart,N.originalStart=d+A,N.modifiedStart=v+A,N.originalLength=s-N.originalStart,N.modifiedLength=g-N.modifiedStart)}}}return p}_findBetterContiguousSequence(p,m,e,C,N){if(m<N||C<N)return null;const A=p+m-N+1,u=e+C-N+1;let s=0,i=0,l=0;for(let g=p;g<A;g++)for(let L=e;L<u;L++){const w=this._contiguousSequenceScore(g,L,N);w>0&&w>s&&(s=w,i=g,l=L)}return s>0?[i,l]:null}_contiguousSequenceScore(p,m,e){let C=0;for(let N=0;N<e;N++){if(!this.ElementsAreEqual(p+N,m+N))return 0;C+=this._originalStringElements[p+N].length}return C}_OriginalIsBoundary(p){return p<=0||p>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[p])}_OriginalRegionIsBoundary(p,m){if(this._OriginalIsBoundary(p)||this._OriginalIsBoundary(p-1))return!0;if(m>0){const e=p+m;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(p){return p<=0||p>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[p])}_ModifiedRegionIsBoundary(p,m){if(this._ModifiedIsBoundary(p)||this._ModifiedIsBoundary(p-1))return!0;if(m>0){const e=p+m;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(p,m,e,C){const N=this._OriginalRegionIsBoundary(p,m)?1:0,A=this._ModifiedRegionIsBoundary(e,C)?1:0;return N+A}ConcatenateChanges(p,m){let e=[];if(p.length===0||m.length===0)return m.length>0?m:p;if(this.ChangesOverlap(p[p.length-1],m[0],e)){const C=new Array(p.length+m.length-1);return h.Copy(p,0,C,0,p.length-1),C[p.length-1]=e[0],h.Copy(m,1,C,p.length,m.length-1),C}else{const C=new Array(p.length+m.length);return h.Copy(p,0,C,0,p.length),h.Copy(m,0,C,p.length,m.length),C}}ChangesOverlap(p,m,e){if(y.Assert(p.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),y.Assert(p.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),p.originalStart+p.originalLength>=m.originalStart||p.modifiedStart+p.modifiedLength>=m.modifiedStart){const C=p.originalStart;let N=p.originalLength;const A=p.modifiedStart;let u=p.modifiedLength;return p.originalStart+p.originalLength>=m.originalStart&&(N=m.originalStart+m.originalLength-p.originalStart),p.modifiedStart+p.modifiedLength>=m.modifiedStart&&(u=m.modifiedStart+m.modifiedLength-p.modifiedStart),e[0]=new M.DiffChange(C,N,A,u),!0}else return e[0]=null,!1}ClipDiagonalBound(p,m,e,C){if(p>=0&&p<C)return p;const N=e,A=C-e-1,u=m%2==0;if(p<0){const s=N%2==0;return u===s?0:1}else{const s=A%2==0;return u===s?C-1:C-2}}}n.LcsDiff=E}),Z(K[8],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function M(b){return Array.isArray(b)}n.isArray=M;function t(b){return typeof b=="string"}n.isString=t;function R(b){return Array.isArray(b)&&b.every(f=>t(f))}n.isStringArray=R;function o(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}n.isObject=o;function y(b){return typeof b=="object"&&(b instanceof Uint8Array||b instanceof Uint16Array||b instanceof Uint32Array||b instanceof Float32Array||b instanceof Float64Array||b instanceof Int8Array||b instanceof Int16Array||b instanceof Int32Array||b instanceof BigInt64Array||b instanceof BigUint64Array||b instanceof Uint8ClampedArray)}n.isTypedArray=y;function h(b){return typeof b=="number"&&!isNaN(b)}n.isNumber=h;function a(b){return!!b&&typeof b[Symbol.iterator]=="function"}n.isIterable=a;function c(b){return b===!0||b===!1}n.isBoolean=c;function E(b){return typeof b=="undefined"}n.isUndefined=E;function D(b){return!p(b)}n.isDefined=D;function p(b){return E(b)||b===null}n.isUndefinedOrNull=p;function m(b,f){if(!b)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}n.assertType=m;function e(b){if(p(b))throw new Error("Assertion Failed: argument is undefined or null");return b}n.assertIsDefined=e;function C(...b){const f=[];for(let P=0;P<b.length;P++){const O=b[P];if(p(O))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);f.push(O)}return f}n.assertAllDefined=C;const N=Object.prototype.hasOwnProperty;function A(b){if(!o(b))return!1;for(let f in b)if(N.call(b,f))return!1;return!0}n.isEmptyObject=A;function u(b){return typeof b=="function"}n.isFunction=u;function s(...b){return b.length>0&&b.every(u)}n.areFunctions=s;function i(b,f){const P=Math.min(b.length,f.length);for(let O=0;O<P;O++)l(b[O],f[O])}n.validateConstraints=i;function l(b,f){if(t(f)){if(typeof b!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(u(f)){try{if(b instanceof f)return}catch{}if(!p(b)&&b.constructor===f||f.length===1&&f.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=l;function g(b){let f=[],P=Object.getPrototypeOf(b);for(;Object.prototype!==P;)f=f.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return f}n.getAllPropertyNames=g;function L(b){const f=[];for(const P of g(b))typeof b[P]=="function"&&f.push(P);return f}n.getAllMethodNames=L;function w(b,f){const P=U=>function(){const q=Array.prototype.slice.call(arguments,0);return f(U,q)};let O={};for(const U of b)O[U]=P(U);return O}n.createProxyObject=w;function d(b){return b===null?void 0:b}n.withNullAsUndefined=d;function v(b){return typeof b=="undefined"?null:b}n.withUndefinedAsNull=v;function _(b,f="Unreachable"){throw new Error(f)}n.assertNever=_}),Z(K[29],x([0,1,8]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.filter=n.getCaseInsensitive=n.distinct=n.getOrDefault=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const N=Array.isArray(C)?[]:{};return Object.keys(C).forEach(A=>{C[A]&&typeof C[A]=="object"?N[A]=t(C[A]):N[A]=C[A]}),N}n.deepClone=t;function R(C){if(!C||typeof C!="object")return C;const N=[C];for(;N.length>0;){const A=N.shift();Object.freeze(A);for(const u in A)if(o.call(A,u)){const s=A[u];typeof s=="object"&&!Object.isFrozen(s)&&!(0,M.isTypedArray)(s)&&N.push(s)}}return C}n.deepFreeze=R;const o=Object.prototype.hasOwnProperty;function y(C,N){return h(C,N,new Set)}n.cloneAndChange=y;function h(C,N,A){if((0,M.isUndefinedOrNull)(C))return C;const u=N(C);if(typeof u!="undefined")return u;if((0,M.isArray)(C)){const s=[];for(const i of C)s.push(h(i,N,A));return s}if((0,M.isObject)(C)){if(A.has(C))throw new Error("Cannot clone recursive data-structure");A.add(C);const s={};for(let i in C)o.call(C,i)&&(s[i]=h(C[i],N,A));return A.delete(C),s}return C}function a(C,N,A=!0){return(0,M.isObject)(C)?((0,M.isObject)(N)&&Object.keys(N).forEach(u=>{u in C?A&&((0,M.isObject)(C[u])&&(0,M.isObject)(N[u])?a(C[u],N[u],A):C[u]=N[u]):C[u]=N[u]}),C):N}n.mixin=a;function c(C,N){if(C===N)return!0;if(C==null||N===null||N===void 0||typeof C!=typeof N||typeof C!="object"||Array.isArray(C)!==Array.isArray(N))return!1;let A,u;if(Array.isArray(C)){if(C.length!==N.length)return!1;for(A=0;A<C.length;A++)if(!c(C[A],N[A]))return!1}else{const s=[];for(u in C)s.push(u);s.sort();const i=[];for(u in N)i.push(u);if(i.sort(),!c(s,i))return!1;for(A=0;A<s.length;A++)if(!c(C[s[A]],N[s[A]]))return!1}return!0}n.equals=c;function E(C){const N=new Set;return JSON.stringify(C,(A,u)=>{if((0,M.isObject)(u)||Array.isArray(u)){if(N.has(u))return"[Circular]";N.add(u)}return u})}n.safeStringify=E;function D(C,N,A){const u=N(C);return typeof u=="undefined"?A:u}n.getOrDefault=D;function p(C,N){const A=Object.create(null);return!C||!N||Object.keys(N).forEach(s=>{const i=C[s],l=N[s];c(i,l)||(A[s]=l)}),A}n.distinct=p;function m(C,N){const A=N.toLowerCase(),u=Object.keys(C).find(s=>s.toLowerCase()===A);return u?C[u]:C[N]}n.getCaseInsensitive=m;function e(C,N){const A=Object.create(null);for(const[u,s]of Object.entries(C))N(u,s)&&(A[u]=s);return A}n.filter=e}),Z(K[17],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var M;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(M=n.Constants||(n.Constants={}));function t(o){return o<0?0:o>255?255:o|0}n.toUint8=t;function R(o){return o<0?0:o>4294967295?4294967295:o|0}n.toUint32=R}),Z(K[10],x([0,1,26,5]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const R=/^\w[\w\d+.-]*$/,o=/^\//,y=/^\/\//;function h(w,d){if(!w.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${w.authority}", path: "${w.path}", query: "${w.query}", fragment: "${w.fragment}"}`);if(w.scheme&&!R.test(w.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(w.path){if(w.authority){if(!o.test(w.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(w.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(w,d){return!w&&!d?"file":w}function c(w,d){switch(w){case"https":case"http":case"file":d?d[0]!==D&&(d=D+d):d=D;break}return d}const E="",D="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(d,v,_,b,f,P=!1){typeof d=="object"?(this.scheme=d.scheme||E,this.authority=d.authority||E,this.path=d.path||E,this.query=d.query||E,this.fragment=d.fragment||E):(this.scheme=a(d,P),this.authority=v||E,this.path=c(this.scheme,_||E),this.query=b||E,this.fragment=f||E,h(this,P))}static isUri(d){return d instanceof m?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return s(this,!1)}with(d){if(!d)return this;let{scheme:v,authority:_,path:b,query:f,fragment:P}=d;return v===void 0?v=this.scheme:v===null&&(v=E),_===void 0?_=this.authority:_===null&&(_=E),b===void 0?b=this.path:b===null&&(b=E),f===void 0?f=this.query:f===null&&(f=E),P===void 0?P=this.fragment:P===null&&(P=E),v===this.scheme&&_===this.authority&&b===this.path&&f===this.query&&P===this.fragment?this:new C(v,_,b,f,P)}static parse(d,v=!1){const _=p.exec(d);return _?new C(_[2]||E,L(_[4]||E),L(_[5]||E),L(_[7]||E),L(_[9]||E),v):new C(E,E,E,E,E)}static file(d){let v=E;if(t.isWindows&&(d=d.replace(/\\/g,D)),d[0]===D&&d[1]===D){const _=d.indexOf(D,2);_===-1?(v=d.substring(2),d=D):(v=d.substring(2,_),d=d.substring(_)||D)}return new C("file",v,d,E,E)}static from(d){const v=new C(d.scheme,d.authority,d.path,d.query,d.fragment);return h(v,!0),v}static joinPath(d,...v){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let _;return t.isWindows&&d.scheme==="file"?_=m.file(M.win32.join(s(d,!0),...v)).path:_=M.posix.join(d.path,...v),d.with({path:_})}toString(d=!1){return i(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof m)return d;{const v=new C(d);return v._formatted=d.external,v._fsPath=d._sep===e?d.fsPath:null,v}}else return d}}n.URI=m;const e=t.isWindows?1:void 0;class C extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(d=!1){return d?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=e),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const N={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(w,d){let v,_=-1;for(let b=0;b<w.length;b++){const f=w.charCodeAt(b);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||d&&f===47)_!==-1&&(v+=encodeURIComponent(w.substring(_,b)),_=-1),v!==void 0&&(v+=w.charAt(b));else{v===void 0&&(v=w.substr(0,b));const P=N[f];P!==void 0?(_!==-1&&(v+=encodeURIComponent(w.substring(_,b)),_=-1),v+=P):_===-1&&(_=b)}}return _!==-1&&(v+=encodeURIComponent(w.substring(_))),v!==void 0?v:w}function u(w){let d;for(let v=0;v<w.length;v++){const _=w.charCodeAt(v);_===35||_===63?(d===void 0&&(d=w.substr(0,v)),d+=N[_]):d!==void 0&&(d+=w[v])}return d!==void 0?d:w}function s(w,d){let v;return w.authority&&w.path.length>1&&w.scheme==="file"?v=`//${w.authority}${w.path}`:w.path.charCodeAt(0)===47&&(w.path.charCodeAt(1)>=65&&w.path.charCodeAt(1)<=90||w.path.charCodeAt(1)>=97&&w.path.charCodeAt(1)<=122)&&w.path.charCodeAt(2)===58?d?v=w.path.substr(1):v=w.path[1].toLowerCase()+w.path.substr(2):v=w.path,t.isWindows&&(v=v.replace(/\//g,"\\")),v}n.uriToFsPath=s;function i(w,d){const v=d?u:A;let _="",{scheme:b,authority:f,path:P,query:O,fragment:U}=w;if(b&&(_+=b,_+=":"),(f||b==="file")&&(_+=D,_+=D),f){let q=f.indexOf("@");if(q!==-1){const $=f.substr(0,q);f=f.substr(q+1),q=$.indexOf(":"),q===-1?_+=v($,!1):(_+=v($.substr(0,q),!1),_+=":",_+=v($.substr(q+1),!1)),_+="@"}f=f.toLowerCase(),q=f.indexOf(":"),q===-1?_+=v(f,!1):(_+=v(f.substr(0,q),!1),_+=f.substr(q))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const q=P.charCodeAt(1);q>=65&&q<=90&&(P=`/${String.fromCharCode(q+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const q=P.charCodeAt(0);q>=65&&q<=90&&(P=`${String.fromCharCode(q+32)}:${P.substr(2)}`)}_+=v(P,!0)}return O&&(_+="?",_+=v(O,!1)),U&&(_+="#",_+=d?U:A(U,!1)),_}function l(w){try{return decodeURIComponent(w)}catch{return w.length>3?w.substr(0,3)+l(w.substr(3)):w}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(w){return w.match(g)?w.replace(g,d=>l(d)):w}}),Z(K[44],x([0,1,9,7,6,5,8,2]),function(B,n,M,t,R,o,y,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let c=!1;function E(w){!o.isWeb||(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(w.message))}n.logOnceWebWorkerWarning=E;var D;(function(w){w[w.Request=0]="Request",w[w.Reply=1]="Reply",w[w.SubscribeEvent=2]="SubscribeEvent",w[w.Event=3]="Event",w[w.UnsubscribeEvent=4]="UnsubscribeEvent"})(D||(D={}));class p{constructor(d,v,_,b){this.vsWorker=d,this.req=v,this.method=_,this.args=b,this.type=0}}class m{constructor(d,v,_,b){this.vsWorker=d,this.seq=v,this.res=_,this.err=b,this.type=1}}class e{constructor(d,v,_,b){this.vsWorker=d,this.req=v,this.eventName=_,this.arg=b,this.type=2}}class C{constructor(d,v,_){this.vsWorker=d,this.req=v,this.event=_,this.type=3}}class N{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class A{constructor(d){this._workerId=-1,this._handler=d,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(d){this._workerId=d}sendMessage(d,v){const _=String(++this._lastSentReq);return new Promise((b,f)=>{this._pendingReplies[_]={resolve:b,reject:f},this._send(new p(this._workerId,_,d,v))})}listen(d,v){let _=null;const b=new t.Emitter({onFirstListenerAdd:()=>{_=String(++this._lastSentReq),this._pendingEmitters.set(_,b),this._send(new e(this._workerId,_,d,v))},onLastListenerRemove:()=>{this._pendingEmitters.delete(_),this._send(new N(this._workerId,_)),_=null}});return b.event}handleMessage(d){!d||!d.vsWorker||this._workerId!==-1&&d.vsWorker!==this._workerId||this._handleMessage(d)}_handleMessage(d){switch(d.type){case 1:return this._handleReplyMessage(d);case 0:return this._handleRequestMessage(d);case 2:return this._handleSubscribeEventMessage(d);case 3:return this._handleEventMessage(d);case 4:return this._handleUnsubscribeEventMessage(d)}}_handleReplyMessage(d){if(!this._pendingReplies[d.seq]){console.warn("Got reply to unknown seq");return}let v=this._pendingReplies[d.seq];if(delete this._pendingReplies[d.seq],d.err){let _=d.err;d.err.$isError&&(_=new Error,_.name=d.err.name,_.message=d.err.message,_.stack=d.err.stack),v.reject(_);return}v.resolve(d.res)}_handleRequestMessage(d){let v=d.req;this._handler.handleMessage(d.method,d.args).then(b=>{this._send(new m(this._workerId,v,b,void 0))},b=>{b.detail instanceof Error&&(b.detail=(0,M.transformErrorForSerialization)(b.detail)),this._send(new m(this._workerId,v,void 0,(0,M.transformErrorForSerialization)(b)))})}_handleSubscribeEventMessage(d){const v=d.req,_=this._handler.handleEvent(d.eventName,d.arg)(b=>{this._send(new C(this._workerId,v,b))});this._pendingEvents.set(v,_)}_handleEventMessage(d){if(!this._pendingEmitters.has(d.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(d.req).fire(d.event)}_handleUnsubscribeEventMessage(d){if(!this._pendingEvents.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(d.req).dispose(),this._pendingEvents.delete(d.req)}_send(d){let v=[];if(d.type===0)for(let _=0;_<d.args.length;_++)d.args[_]instanceof ArrayBuffer&&v.push(d.args[_]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this._handler.sendMessage(d,v)}}class u extends R.Disposable{constructor(d,v,_){super();let b=null;this._worker=this._register(d.create("vs/base/common/worker/simpleWorker",q=>{this._protocol.handleMessage(q)},q=>{b&&b(q)})),this._protocol=new A({sendMessage:(q,$)=>{this._worker.postMessage(q,$)},handleMessage:(q,$)=>{if(typeof _[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(_[q].apply(_,$))}catch(j){return Promise.reject(j)}},handleEvent:(q,$)=>{if(i(q)){const j=_[q].call(_,$);if(typeof j!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return j}if(s(q)){const j=_[q];if(typeof j!="function")throw new Error(`Missing event ${q} on main thread host.`);return j}throw new Error(`Malformed event name ${q}`)}}),this._protocol.setWorkerId(this._worker.getId());let f=null;typeof o.globals.require!="undefined"&&typeof o.globals.require.getConfig=="function"?f=o.globals.require.getConfig():typeof o.globals.requirejs!="undefined"&&(f=o.globals.requirejs.s.contexts._.config);const P=y.getAllMethodNames(_);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(f)),v,P]);const O=(q,$)=>this._request(q,$),U=(q,$)=>this._protocol.listen(q,$);this._lazyProxy=new Promise((q,$)=>{b=$,this._onModuleLoaded.then(j=>{q(l(j,O,U))},j=>{$(j),this._onError("Worker failed to load "+v,j)})})}getProxyObject(){return this._lazyProxy}_request(d,v){return new Promise((_,b)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(d,v).then(_,b)},b)})}_onError(d,v){console.error(d),console.info(v)}}n.SimpleWorkerClient=u;function s(w){return w[0]==="o"&&w[1]==="n"&&h.isUpperAsciiLetter(w.charCodeAt(2))}function i(w){return/^onDynamic/.test(w)&&h.isUpperAsciiLetter(w.charCodeAt(9))}function l(w,d,v){const _=P=>function(){const O=Array.prototype.slice.call(arguments,0);return d(P,O)},b=P=>function(O){return v(P,O)};let f={};for(const P of w){if(i(P)){f[P]=b(P);continue}if(s(P)){f[P]=v(P,void 0);continue}f[P]=_(P)}return f}class g{constructor(d,v){this._requestHandlerFactory=v,this._requestHandler=null,this._protocol=new A({sendMessage:(_,b)=>{d(_,b)},handleMessage:(_,b)=>this._handleMessage(_,b),handleEvent:(_,b)=>this._handleEvent(_,b)})}onmessage(d){this._protocol.handleMessage(d)}_handleMessage(d,v){if(d===a)return this.initialize(v[0],v[1],v[2],v[3]);if(!this._requestHandler||typeof this._requestHandler[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._requestHandler[d].apply(this._requestHandler,v))}catch(_){return Promise.reject(_)}}_handleEvent(d,v){if(!this._requestHandler)throw new Error("Missing requestHandler");if(i(d)){const _=this._requestHandler[d].call(this._requestHandler,v);if(typeof _!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return _}if(s(d)){const _=this._requestHandler[d];if(typeof _!="function")throw new Error(`Missing event ${d} on request handler.`);return _}throw new Error(`Malformed event name ${d}`)}initialize(d,v,_,b){this._protocol.setWorkerId(d);const O=l(b,(U,q)=>this._protocol.sendMessage(U,q),(U,q)=>this._protocol.listen(U,q));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(O),Promise.resolve(y.getAllMethodNames(this._requestHandler))):(v&&(typeof v.baseUrl!="undefined"&&delete v.baseUrl,typeof v.paths!="undefined"&&typeof v.paths.vs!="undefined"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,o.globals.require.config(v)),new Promise((U,q)=>{(o.globals.require||B)([_],j=>{if(this._requestHandler=j.create(O),!this._requestHandler){q(new Error("No RequestHandler!"));return}U(y.getAllMethodNames(this._requestHandler))},q)}))}}n.SimpleWorkerServer=g;function L(w){return new g(w,null)}n.create=L}),Z(K[18],x([0,1,17]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(h){const a=(0,M.toUint8)(h);this._defaultValue=a,this._asciiMap=t._createAsciiMap(a),this._map=new Map}static _createAsciiMap(h){const a=new Uint8Array(256);for(let c=0;c<256;c++)a[c]=h;return a}set(h,a){const c=(0,M.toUint8)(a);h>=0&&h<256?this._asciiMap[h]=c:this._map.set(h,c)}get(h){return h>=0&&h<256?this._asciiMap[h]:this._map.get(h)||this._defaultValue}}n.CharacterClassifier=t;var R;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(R||(R={}));class o{constructor(){this._actual=new t(0)}add(h){this._actual.set(h,1)}has(h){return this._actual.get(h)===1}}n.CharacterSet=o}),Z(K[3],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class M{constructor(R,o){this.lineNumber=R,this.column=o}with(R=this.lineNumber,o=this.column){return R===this.lineNumber&&o===this.column?this:new M(R,o)}delta(R=0,o=0){return this.with(this.lineNumber+R,this.column+o)}equals(R){return M.equals(this,R)}static equals(R,o){return!R&&!o?!0:!!R&&!!o&&R.lineNumber===o.lineNumber&&R.column===o.column}isBefore(R){return M.isBefore(this,R)}static isBefore(R,o){return R.lineNumber<o.lineNumber?!0:o.lineNumber<R.lineNumber?!1:R.column<o.column}isBeforeOrEqual(R){return M.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,o){return R.lineNumber<o.lineNumber?!0:o.lineNumber<R.lineNumber?!1:R.column<=o.column}static compare(R,o){const y=R.lineNumber|0,h=o.lineNumber|0;if(y===h){const a=R.column|0,c=o.column|0;return a-c}return y-h}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new M(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}n.Position=M}),Z(K[4],x([0,1,3]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(o,y,h,a){o>h||o===h&&y>a?(this.startLineNumber=h,this.startColumn=a,this.endLineNumber=o,this.endColumn=y):(this.startLineNumber=o,this.startColumn=y,this.endLineNumber=h,this.endColumn=a)}isEmpty(){return t.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return t.containsPosition(this,o)}static containsPosition(o,y){return!(y.lineNumber<o.startLineNumber||y.lineNumber>o.endLineNumber||y.lineNumber===o.startLineNumber&&y.column<o.startColumn||y.lineNumber===o.endLineNumber&&y.column>o.endColumn)}static strictContainsPosition(o,y){return!(y.lineNumber<o.startLineNumber||y.lineNumber>o.endLineNumber||y.lineNumber===o.startLineNumber&&y.column<=o.startColumn||y.lineNumber===o.endLineNumber&&y.column>=o.endColumn)}containsRange(o){return t.containsRange(this,o)}static containsRange(o,y){return!(y.startLineNumber<o.startLineNumber||y.endLineNumber<o.startLineNumber||y.startLineNumber>o.endLineNumber||y.endLineNumber>o.endLineNumber||y.startLineNumber===o.startLineNumber&&y.startColumn<o.startColumn||y.endLineNumber===o.endLineNumber&&y.endColumn>o.endColumn)}strictContainsRange(o){return t.strictContainsRange(this,o)}static strictContainsRange(o,y){return!(y.startLineNumber<o.startLineNumber||y.endLineNumber<o.startLineNumber||y.startLineNumber>o.endLineNumber||y.endLineNumber>o.endLineNumber||y.startLineNumber===o.startLineNumber&&y.startColumn<=o.startColumn||y.endLineNumber===o.endLineNumber&&y.endColumn>=o.endColumn)}plusRange(o){return t.plusRange(this,o)}static plusRange(o,y){let h,a,c,E;return y.startLineNumber<o.startLineNumber?(h=y.startLineNumber,a=y.startColumn):y.startLineNumber===o.startLineNumber?(h=y.startLineNumber,a=Math.min(y.startColumn,o.startColumn)):(h=o.startLineNumber,a=o.startColumn),y.endLineNumber>o.endLineNumber?(c=y.endLineNumber,E=y.endColumn):y.endLineNumber===o.endLineNumber?(c=y.endLineNumber,E=Math.max(y.endColumn,o.endColumn)):(c=o.endLineNumber,E=o.endColumn),new t(h,a,c,E)}intersectRanges(o){return t.intersectRanges(this,o)}static intersectRanges(o,y){let h=o.startLineNumber,a=o.startColumn,c=o.endLineNumber,E=o.endColumn,D=y.startLineNumber,p=y.startColumn,m=y.endLineNumber,e=y.endColumn;return h<D?(h=D,a=p):h===D&&(a=Math.max(a,p)),c>m?(c=m,E=e):c===m&&(E=Math.min(E,e)),h>c||h===c&&a>E?null:new t(h,a,c,E)}equalsRange(o){return t.equalsRange(this,o)}static equalsRange(o,y){return!!o&&!!y&&o.startLineNumber===y.startLineNumber&&o.startColumn===y.startColumn&&o.endLineNumber===y.endLineNumber&&o.endColumn===y.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(o){return new M.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(o){return new M.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,y){return new t(this.startLineNumber,this.startColumn,o,y)}setStartPosition(o,y){return new t(o,y,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(o){return new t(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}static fromPositions(o,y=o){return new t(o.lineNumber,o.column,y.lineNumber,y.column)}static lift(o){return o?new t(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,y){return!(o.endLineNumber<y.startLineNumber||o.endLineNumber===y.startLineNumber&&o.endColumn<y.startColumn||y.endLineNumber<o.startLineNumber||y.endLineNumber===o.startLineNumber&&y.endColumn<o.startColumn)}static areIntersecting(o,y){return!(o.endLineNumber<y.startLineNumber||o.endLineNumber===y.startLineNumber&&o.endColumn<=y.startColumn||y.endLineNumber<o.startLineNumber||y.endLineNumber===o.startLineNumber&&y.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,y){if(o&&y){const c=o.startLineNumber|0,E=y.startLineNumber|0;if(c===E){const D=o.startColumn|0,p=y.startColumn|0;if(D===p){const m=o.endLineNumber|0,e=y.endLineNumber|0;if(m===e){const C=o.endColumn|0,N=y.endColumn|0;return C-N}return m-e}return D-p}return c-E}return(o?1:0)-(y?1:0)}static compareRangesUsingEnds(o,y){return o.endLineNumber===y.endLineNumber?o.endColumn===y.endColumn?o.startLineNumber===y.startLineNumber?o.startColumn-y.startColumn:o.startLineNumber-y.startLineNumber:o.endColumn-y.endColumn:o.endLineNumber-y.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}n.Range=t}),Z(K[30],x([0,1,3,4]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var R;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(R=n.SelectionDirection||(n.SelectionDirection={}));class o extends t.Range{constructor(h,a,c,E){super(h,a,c,E);this.selectionStartLineNumber=h,this.selectionStartColumn=a,this.positionLineNumber=c,this.positionColumn=E}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return o.selectionsEqual(this,h)}static selectionsEqual(h,a){return h.selectionStartLineNumber===a.selectionStartLineNumber&&h.selectionStartColumn===a.selectionStartColumn&&h.positionLineNumber===a.positionLineNumber&&h.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,h,a):new o(h,a,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,a){return this.getDirection()===0?new o(h,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,h,a)}static fromPositions(h,a=h){return new o(h.lineNumber,h.column,a.lineNumber,a.column)}static fromRange(h,a){return a===0?new o(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new o(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new o(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,a){if(h&&!a||!h&&a)return!1;if(!h&&!a)return!0;if(h.length!==a.length)return!1;for(let c=0,E=h.length;c<E;c++)if(!this.selectionsEqual(h[c],a[c]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,a,c,E,D){return D===0?new o(h,a,c,E):new o(c,E,h,a)}}n.Selection=o}),Z(K[31],x([0,1,18]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class R extends M.CharacterClassifier{constructor(h){super(0);for(let a=0,c=h.length;a<c;a++)this.set(h.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=R;function o(y){const h={};return a=>(h.hasOwnProperty(a)||(h[a]=y(a)),h[a])}n.getMapForWordSeparators=o(y=>new R(y))}),Z(K[19],x([0,1,12,6,13]),function(B,n,M,t,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(D=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const m of n.USUAL_WORD_SEPARATORS)D.indexOf(m)>=0||(p+="\\"+m);return p+="\\s]+)",new RegExp(p,"g")}n.DEFAULT_WORD_REGEXP=o();function y(D){let p=n.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)p=D;else{let m="g";D.ignoreCase&&(m+="i"),D.multiline&&(m+="m"),D.unicode&&(m+="u"),p=new RegExp(D.source,m)}return p.lastIndex=0,p}n.ensureValidWordDefinition=y;const h=new R.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(D){const p=h.unshift(D);return(0,t.toDisposable)(p)}n.setDefaultGetWordAtTextConfig=a;function c(D,p,m,e,C){if(C||(C=M.Iterable.first(h)),m.length>C.maxLen){let i=D-C.maxLen/2;return i<0?i=0:e+=i,m=m.substring(i,D+C.maxLen/2),c(D,p,m,e,C)}const N=Date.now(),A=D-1-e;let u=-1,s=null;for(let i=1;!(Date.now()-N>=C.timeBudget);i++){const l=A-C.windowSize*i;p.lastIndex=Math.max(0,l);const g=E(p,m,A,u);if(!g&&s||(s=g,l<=0))break;u=l}if(s){const i={word:s[0],startColumn:e+1+s.index,endColumn:e+1+s.index+s[0].length};return p.lastIndex=0,i}return null}n.getWordAtText=c;function E(D,p,m,e){let C;for(;C=D.exec(p);){const N=C.index||0;if(N<=m&&D.lastIndex>=m)return C;if(e>0&&N>e)return null}return null}}),Z(K[32],x([0,1,16,2]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const R=3;function o(C,N,A,u){return new M.LcsDiff(C,N,A).ComputeDiff(u)}class y{constructor(N){const A=[],u=[];for(let s=0,i=N.length;s<i;s++)A[s]=p(N[s],1),u[s]=m(N[s],1);this.lines=N,this._startColumns=A,this._endColumns=u}getElements(){const N=[];for(let A=0,u=this.lines.length;A<u;A++)N[A]=this.lines[A].substring(this._startColumns[A]-1,this._endColumns[A]-1);return N}getStrictElement(N){return this.lines[N]}getStartLineNumber(N){return N+1}getEndLineNumber(N){return N+1}createCharSequence(N,A,u){const s=[],i=[],l=[];let g=0;for(let L=A;L<=u;L++){const w=this.lines[L],d=N?this._startColumns[L]:1,v=N?this._endColumns[L]:w.length+1;for(let _=d;_<v;_++)s[g]=w.charCodeAt(_-1),i[g]=L+1,l[g]=_,g++}return new h(s,i,l)}}class h{constructor(N,A,u){this._charCodes=N,this._lineNumbers=A,this._columns=u}getElements(){return this._charCodes}getStartLineNumber(N){return this._lineNumbers[N]}getStartColumn(N){return this._columns[N]}getEndLineNumber(N){return this._lineNumbers[N]}getEndColumn(N){return this._columns[N]+1}}class a{constructor(N,A,u,s,i,l,g,L){this.originalStartLineNumber=N,this.originalStartColumn=A,this.originalEndLineNumber=u,this.originalEndColumn=s,this.modifiedStartLineNumber=i,this.modifiedStartColumn=l,this.modifiedEndLineNumber=g,this.modifiedEndColumn=L}static createFromDiffChange(N,A,u){let s,i,l,g,L,w,d,v;return N.originalLength===0?(s=0,i=0,l=0,g=0):(s=A.getStartLineNumber(N.originalStart),i=A.getStartColumn(N.originalStart),l=A.getEndLineNumber(N.originalStart+N.originalLength-1),g=A.getEndColumn(N.originalStart+N.originalLength-1)),N.modifiedLength===0?(L=0,w=0,d=0,v=0):(L=u.getStartLineNumber(N.modifiedStart),w=u.getStartColumn(N.modifiedStart),d=u.getEndLineNumber(N.modifiedStart+N.modifiedLength-1),v=u.getEndColumn(N.modifiedStart+N.modifiedLength-1)),new a(s,i,l,g,L,w,d,v)}}function c(C){if(C.length<=1)return C;const N=[C[0]];let A=N[0];for(let u=1,s=C.length;u<s;u++){const i=C[u],l=i.originalStart-(A.originalStart+A.originalLength),g=i.modifiedStart-(A.modifiedStart+A.modifiedLength);Math.min(l,g)<R?(A.originalLength=i.originalStart+i.originalLength-A.originalStart,A.modifiedLength=i.modifiedStart+i.modifiedLength-A.modifiedStart):(N.push(i),A=i)}return N}class E{constructor(N,A,u,s,i){this.originalStartLineNumber=N,this.originalEndLineNumber=A,this.modifiedStartLineNumber=u,this.modifiedEndLineNumber=s,this.charChanges=i}static createFromDiffResult(N,A,u,s,i,l,g){let L,w,d,v,_;if(A.originalLength===0?(L=u.getStartLineNumber(A.originalStart)-1,w=0):(L=u.getStartLineNumber(A.originalStart),w=u.getEndLineNumber(A.originalStart+A.originalLength-1)),A.modifiedLength===0?(d=s.getStartLineNumber(A.modifiedStart)-1,v=0):(d=s.getStartLineNumber(A.modifiedStart),v=s.getEndLineNumber(A.modifiedStart+A.modifiedLength-1)),l&&A.originalLength>0&&A.originalLength<20&&A.modifiedLength>0&&A.modifiedLength<20&&i()){const b=u.createCharSequence(N,A.originalStart,A.originalStart+A.originalLength-1),f=s.createCharSequence(N,A.modifiedStart,A.modifiedStart+A.modifiedLength-1);let P=o(b,f,i,!0).changes;g&&(P=c(P)),_=[];for(let O=0,U=P.length;O<U;O++)_.push(a.createFromDiffChange(P[O],b,f))}return new E(L,w,d,v,_)}}class D{constructor(N,A,u){this.shouldComputeCharChanges=u.shouldComputeCharChanges,this.shouldPostProcessCharChanges=u.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=u.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=u.shouldMakePrettyDiff,this.originalLines=N,this.modifiedLines=A,this.original=new y(N),this.modified=new y(A),this.continueLineDiff=e(u.maxComputationTime),this.continueCharDiff=e(u.maxComputationTime===0?0:Math.min(u.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const N=o(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),A=N.changes,u=N.quitEarly;if(this.shouldIgnoreTrimWhitespace){const g=[];for(let L=0,w=A.length;L<w;L++)g.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,A[L],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:u,changes:g}}const s=[];let i=0,l=0;for(let g=-1,L=A.length;g<L;g++){const w=g+1<L?A[g+1]:null,d=w?w.originalStart:this.originalLines.length,v=w?w.modifiedStart:this.modifiedLines.length;for(;i<d&&l<v;){const _=this.originalLines[i],b=this.modifiedLines[l];if(_!==b){{let f=p(_,1),P=p(b,1);for(;f>1&&P>1;){const O=_.charCodeAt(f-2),U=b.charCodeAt(P-2);if(O!==U)break;f--,P--}(f>1||P>1)&&this._pushTrimWhitespaceCharChange(s,i+1,1,f,l+1,1,P)}{let f=m(_,1),P=m(b,1);const O=_.length+1,U=b.length+1;for(;f<O&&P<U;){const q=_.charCodeAt(f-1),$=_.charCodeAt(P-1);if(q!==$)break;f++,P++}(f<O||P<U)&&this._pushTrimWhitespaceCharChange(s,i+1,f,O,l+1,P,U)}}i++,l++}w&&(s.push(E.createFromDiffResult(this.shouldIgnoreTrimWhitespace,w,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=w.originalLength,l+=w.modifiedLength)}return{quitEarly:u,changes:s}}_pushTrimWhitespaceCharChange(N,A,u,s,i,l,g){if(this._mergeTrimWhitespaceCharChange(N,A,u,s,i,l,g))return;let L;this.shouldComputeCharChanges&&(L=[new a(A,u,A,s,i,l,i,g)]),N.push(new E(A,A,i,i,L))}_mergeTrimWhitespaceCharChange(N,A,u,s,i,l,g){const L=N.length;if(L===0)return!1;const w=N[L-1];return w.originalEndLineNumber===0||w.modifiedEndLineNumber===0?!1:w.originalEndLineNumber+1===A&&w.modifiedEndLineNumber+1===i?(w.originalEndLineNumber=A,w.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&w.charChanges&&w.charChanges.push(new a(A,u,A,s,i,l,i,g)),!0):!1}}n.DiffComputer=D;function p(C,N){const A=t.firstNonWhitespaceIndex(C);return A===-1?N:A+1}function m(C,N){const A=t.lastNonWhitespaceIndex(C);return A===-1?N:A+2}function e(C){if(C===0)return()=>!0;const N=Date.now();return()=>Date.now()-N<C}}),Z(K[33],x([0,1,18]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var t;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class R{constructor(e,C,N){const A=new Uint8Array(e*C);for(let u=0,s=e*C;u<s;u++)A[u]=N;this._data=A,this.rows=e,this.cols=C}get(e,C){return this._data[e*this.cols+C]}set(e,C,N){this._data[e*this.cols+C]=N}}n.Uint8Matrix=R;class o{constructor(e){let C=0,N=0;for(let u=0,s=e.length;u<s;u++){const[i,l,g]=e[u];l>C&&(C=l),i>N&&(N=i),g>N&&(N=g)}C++,N++;const A=new R(N,C,0);for(let u=0,s=e.length;u<s;u++){const[i,l,g]=e[u];A.set(i,l,g)}this._states=A,this._maxCharCode=C}nextState(e,C){return C<0||C>=this._maxCharCode?0:this._states.get(e,C)}}n.StateMachine=o;let y=null;function h(){return y===null&&(y=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var a;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let c=null;function E(){if(c===null){c=new M.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let C=0;C<m.length;C++)c.set(m.charCodeAt(C),1);const e=".,;:";for(let C=0;C<e.length;C++)c.set(e.charCodeAt(C),2)}return c}class D{static _createLink(e,C,N,A,u){let s=u-1;do{const i=C.charCodeAt(s);if(e.get(i)!==2)break;s--}while(s>A);if(A>0){const i=C.charCodeAt(A-1),l=C.charCodeAt(s);(i===40&&l===41||i===91&&l===93||i===123&&l===125)&&s--}return{range:{startLineNumber:N,startColumn:A+1,endLineNumber:N,endColumn:s+2},url:C.substring(A,s+1)}}static computeLinks(e,C=h()){const N=E(),A=[];for(let u=1,s=e.getLineCount();u<=s;u++){const i=e.getLineContent(u),l=i.length;let g=0,L=0,w=0,d=1,v=!1,_=!1,b=!1,f=!1;for(;g<l;){let P=!1;const O=i.charCodeAt(g);if(d===13){let U;switch(O){case 40:v=!0,U=0;break;case 41:U=v?0:1;break;case 91:b=!0,_=!0,U=0;break;case 93:b=!1,U=_?0:1;break;case 123:f=!0,U=0;break;case 125:U=f?0:1;break;case 39:U=w===34||w===96?0:1;break;case 34:U=w===39||w===96?0:1;break;case 96:U=w===39||w===34?0:1;break;case 42:U=w===42?1:0;break;case 124:U=w===124?1:0;break;case 32:U=b?0:1;break;default:U=N.get(O)}U===1&&(A.push(D._createLink(N,i,u,L,g)),P=!0)}else if(d===12){let U;O===91?(_=!0,U=0):U=N.get(O),U===1?P=!0:d=13}else d=C.nextState(d,O),d===0&&(P=!0);P&&(d=1,v=!1,_=!1,f=!1,L=g+1,w=O),g++}d===13&&A.push(D._createLink(N,i,u,L,l))}return A}}n.LinkComputer=D;function p(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:D.computeLinks(m)}n.computeLinks=p}),Z(K[34],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(R,o,y,h,a){if(R&&o){const c=this.doNavigateValueSet(o,a);if(c)return{range:R,value:c}}if(y&&h){const c=this.doNavigateValueSet(h,a);if(c)return{range:y,value:c}}return null}doNavigateValueSet(R,o){const y=this.numberReplace(R,o);return y!==null?y:this.textReplace(R,o)}numberReplace(R,o){const y=Math.pow(10,R.length-(R.lastIndexOf(".")+1));let h=Number(R),a=parseFloat(R);return!isNaN(h)&&!isNaN(a)&&h===a?h===0&&!o?null:(h=Math.floor(h*y),h+=o?y:-y,String(h/y)):null}textReplace(R,o){return this.valueSetsReplace(this._defaultValueSet,R,o)}valueSetsReplace(R,o,y){let h=null;for(let a=0,c=R.length;h===null&&a<c;a++)h=this.valueSetReplace(R[a],o,y);return h}valueSetReplace(R,o,y){let h=R.indexOf(o);return h>=0?(h+=y?1:-1,h<0?h=R.length-1:h%=R.length,R[h]):null}}n.BasicInplaceReplace=M,M.INSTANCE=new M}),Z(K[35],x([0,1,29]),function(B,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var R;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(R=n.MinimapPosition||(n.MinimapPosition={}));var o;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(o=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var y;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(y=n.EndOfLinePreference||(n.EndOfLinePreference={}));var h;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var a;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(a=n.EndOfLineSequence||(n.EndOfLineSequence={}));class c{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}n.TextModelResolvedOptions=c;class E{constructor(s,i){this._findMatchBrand=void 0,this.range=s,this.matches=i}}n.FindMatch=E;var D;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var p;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(p=n.PositionAffinity||(n.PositionAffinity={}));var m;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m=n.ModelConstants||(n.ModelConstants={}));class e{constructor(s,i,l,g,L,w){this.identifier=s,this.range=i,this.text=l,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=L,this._isTracked=w}}n.ValidAnnotatedEditOperation=e;class C{constructor(s,i,l){this.regex=s,this.wordSeparators=i,this.simpleSearch=l}}n.SearchData=C;class N{constructor(s,i,l){this.reverseEdits=s,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}n.ApplyEditsResult=N;function A(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}n.shouldSynchronizeModel=A}),Z(K[36],x([0,1,22,17]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class R{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(a,c){a=(0,t.toUint32)(a);const E=this.values,D=this.prefixSum,p=c.length;return p===0?!1:(this.values=new Uint32Array(E.length+p),this.values.set(E.subarray(0,a),0),this.values.set(E.subarray(a),a+p),this.values.set(c,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,c){return a=(0,t.toUint32)(a),c=(0,t.toUint32)(c),this.values[a]===c?!1:(this.values[a]=c,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,c){a=(0,t.toUint32)(a),c=(0,t.toUint32)(c);const E=this.values,D=this.prefixSum;if(a>=E.length)return!1;const p=E.length-a;return c>=p&&(c=p),c===0?!1:(this.values=new Uint32Array(E.length-c),this.values.set(E.subarray(0,a),0),this.values.set(E.subarray(a+c),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,t.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let c=this.prefixSumValidIndex[0]+1;c===0&&(this.prefixSum[0]=this.values[0],c++),a>=this.values.length&&(a=this.values.length-1);for(let E=c;E<=a;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let c=0,E=this.values.length-1,D=0,p=0,m=0;for(;c<=E;)if(D=c+(E-c)/2|0,p=this.prefixSum[D],m=p-this.values[D],a<m)E=D-1;else if(a>=p)c=D+1;else break;return new y(D,a-m)}}n.PrefixSumComputer=R;class o{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const c=this._indexBySum[a],E=c>0?this._prefixSum[c-1]:0;return new y(c,a-E)}removeValues(a,c){this._values.splice(a,c),this._invalidate(a)}insertValues(a,c){this._values=(0,M.arrayInsert)(this._values,a,c),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,c=this._values.length;a<c;a++){const E=this._values[a],D=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=D+E;for(let p=0;p<E;p++)this._indexBySum[D+p]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,c){this._values[a]!==c&&(this._values[a]=c,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=o;class y{constructor(a,c){this.index=a,this.remainder=c,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=c}}n.PrefixSumIndexOfResult=y}),Z(K[37],x([0,1,2,3,36]),function(B,n,M,t,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(h,a,c,E){this._uri=h,this._lines=a,this._eol=c,this._versionId=E,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(h){h.eol&&h.eol!==this._eol&&(this._eol=h.eol,this._lineStarts=null);const a=h.changes;for(const c of a)this._acceptDeleteRange(c.range),this._acceptInsertText(new t.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=h.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const h=this._eol.length,a=this._lines.length,c=new Uint32Array(a);for(let E=0;E<a;E++)c[E]=this._lines[E].length+h;this._lineStarts=new R.PrefixSumComputer(c)}}_setLineText(h,a){this._lines[h]=a,this._lineStarts&&this._lineStarts.setValue(h,this._lines[h].length+this._eol.length)}_acceptDeleteRange(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.startLineNumber-1].substring(h.endColumn-1));return}this._setLineText(h.startLineNumber-1,this._lines[h.startLineNumber-1].substring(0,h.startColumn-1)+this._lines[h.endLineNumber-1].substring(h.endColumn-1)),this._lines.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}_acceptInsertText(h,a){if(a.length===0)return;const c=(0,M.splitLines)(a);if(c.length===1){this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+c[0]+this._lines[h.lineNumber-1].substring(h.column-1));return}c[c.length-1]+=this._lines[h.lineNumber-1].substring(h.column-1),this._setLineText(h.lineNumber-1,this._lines[h.lineNumber-1].substring(0,h.column-1)+c[0]);const E=new Uint32Array(c.length-1);for(let D=1;D<c.length;D++)this._lines.splice(h.lineNumber+D-1,0,c[D]),E[D-1]=c[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(h.lineNumber,E)}}n.MirrorTextModel=o}),Z(K[38],x([0,1,2,31,3,4,35]),function(B,n,M,t,R,o,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const h=999;class a{constructor(u,s,i,l){this.searchString=u,this.isRegex=s,this.matchCase=i,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=c(this.searchString):u=this.searchString.indexOf(`
`)>=0;let s=null;try{s=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch{return null}if(!s)return null;let i=!this.isRegex&&!u;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new y.SearchData(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}}n.SearchParams=a;function c(A){if(!A||A.length===0)return!1;for(let u=0,s=A.length;u<s;u++)if(A.charCodeAt(u)===92){if(u++,u>=s)break;const l=A.charCodeAt(u);if(l===110||l===114||l===87)return!0}return!1}n.isMultilineRegexSource=c;function E(A,u,s){if(!s)return new y.FindMatch(A,null);const i=[];for(let l=0,g=u.length;l<g;l++)i[l]=u[l];return new y.FindMatch(A,i)}n.createFindMatch=E;class D{constructor(u){const s=[];let i=0;for(let l=0,g=u.length;l<g;l++)u.charCodeAt(l)===10&&(s[i++]=l);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(u){const s=this._lineFeedsOffsets;let i=0,l=s.length-1;if(l===-1||u<=s[0])return 0;for(;i<l;){const g=i+((l-i)/2>>0);s[g]>=u?l=g-1:s[g+1]>=u?(i=g,l=g):i=g+1}return i+1}}class p{static findMatches(u,s,i,l,g){const L=s.parseSearchRequest();return L?L.regex.multiline?this._doFindMatchesMultiline(u,i,new N(L.wordSeparators,L.regex),l,g):this._doFindMatchesLineByLine(u,i,L,l,g):[]}static _getMultilineMatchRange(u,s,i,l,g,L){let w,d=0;l?(d=l.findLineFeedCountBeforeOffset(g),w=s+g+d):w=s+g;let v;if(l){const P=l.findLineFeedCountBeforeOffset(g+L.length)-d;v=w+L.length+P}else v=w+L.length;const _=u.getPositionAt(w),b=u.getPositionAt(v);return new o.Range(_.lineNumber,_.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(u,s,i,l,g){const L=u.getOffsetAt(s.getStartPosition()),w=u.getValueInRange(s,1),d=u.getEOL()===`\r
`?new D(w):null,v=[];let _=0,b;for(i.reset(0);b=i.next(w);)if(v[_++]=E(this._getMultilineMatchRange(u,L,w,d,b.index,b[0]),b,l),_>=g)return v;return v}static _doFindMatchesLineByLine(u,s,i,l,g){const L=[];let w=0;if(s.startLineNumber===s.endLineNumber){const v=u.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return w=this._findMatchesInLine(i,v,s.startLineNumber,s.startColumn-1,w,L,l,g),L}const d=u.getLineContent(s.startLineNumber).substring(s.startColumn-1);w=this._findMatchesInLine(i,d,s.startLineNumber,s.startColumn-1,w,L,l,g);for(let v=s.startLineNumber+1;v<s.endLineNumber&&w<g;v++)w=this._findMatchesInLine(i,u.getLineContent(v),v,0,w,L,l,g);if(w<g){const v=u.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);w=this._findMatchesInLine(i,v,s.endLineNumber,0,w,L,l,g)}return L}static _findMatchesInLine(u,s,i,l,g,L,w,d){const v=u.wordSeparators;if(!w&&u.simpleSearch){const f=u.simpleSearch,P=f.length,O=s.length;let U=-P;for(;(U=s.indexOf(f,U+P))!==-1;)if((!v||C(v,s,O,U,P))&&(L[g++]=new y.FindMatch(new o.Range(i,U+1+l,i,U+1+P+l),null),g>=d))return g;return g}const _=new N(u.wordSeparators,u.regex);let b;_.reset(0);do if(b=_.next(s),b&&(L[g++]=E(new o.Range(i,b.index+1+l,i,b.index+1+b[0].length+l),b,w),g>=d))return g;while(b);return g}static findNextMatch(u,s,i,l){const g=s.parseSearchRequest();if(!g)return null;const L=new N(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(u,i,L,l):this._doFindNextMatchLineByLine(u,i,L,l)}static _doFindNextMatchMultiline(u,s,i,l){const g=new R.Position(s.lineNumber,1),L=u.getOffsetAt(g),w=u.getLineCount(),d=u.getValueInRange(new o.Range(g.lineNumber,g.column,w,u.getLineMaxColumn(w)),1),v=u.getEOL()===`\r
`?new D(d):null;i.reset(s.column-1);let _=i.next(d);return _?E(this._getMultilineMatchRange(u,L,d,v,_.index,_[0]),_,l):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(u,new R.Position(1,1),i,l):null}static _doFindNextMatchLineByLine(u,s,i,l){const g=u.getLineCount(),L=s.lineNumber,w=u.getLineContent(L),d=this._findFirstMatchInLine(i,w,L,s.column,l);if(d)return d;for(let v=1;v<=g;v++){const _=(L+v-1)%g,b=u.getLineContent(_+1),f=this._findFirstMatchInLine(i,b,_+1,1,l);if(f)return f}return null}static _findFirstMatchInLine(u,s,i,l,g){u.reset(l-1);const L=u.next(s);return L?E(new o.Range(i,L.index+1,i,L.index+1+L[0].length),L,g):null}static findPreviousMatch(u,s,i,l){const g=s.parseSearchRequest();if(!g)return null;const L=new N(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(u,i,L,l):this._doFindPreviousMatchLineByLine(u,i,L,l)}static _doFindPreviousMatchMultiline(u,s,i,l){const g=this._doFindMatchesMultiline(u,new o.Range(1,1,s.lineNumber,s.column),i,l,10*h);if(g.length>0)return g[g.length-1];const L=u.getLineCount();return s.lineNumber!==L||s.column!==u.getLineMaxColumn(L)?this._doFindPreviousMatchMultiline(u,new R.Position(L,u.getLineMaxColumn(L)),i,l):null}static _doFindPreviousMatchLineByLine(u,s,i,l){const g=u.getLineCount(),L=s.lineNumber,w=u.getLineContent(L).substring(0,s.column-1),d=this._findLastMatchInLine(i,w,L,l);if(d)return d;for(let v=1;v<=g;v++){const _=(g+L-v-1)%g,b=u.getLineContent(_+1),f=this._findLastMatchInLine(i,b,_+1,l);if(f)return f}return null}static _findLastMatchInLine(u,s,i,l){let g=null,L;for(u.reset(0);L=u.next(s);)g=E(new o.Range(i,L.index+1,i,L.index+1+L[0].length),L,l);return g}}n.TextModelSearch=p;function m(A,u,s,i,l){if(i===0)return!0;const g=u.charCodeAt(i-1);if(A.get(g)!==0||g===13||g===10)return!0;if(l>0){const L=u.charCodeAt(i);if(A.get(L)!==0)return!0}return!1}function e(A,u,s,i,l){if(i+l===s)return!0;const g=u.charCodeAt(i+l);if(A.get(g)!==0||g===13||g===10)return!0;if(l>0){const L=u.charCodeAt(i+l-1);if(A.get(L)!==0)return!0}return!1}function C(A,u,s,i,l){return m(A,u,s,i,l)&&e(A,u,s,i,l)}n.isValidMatch=C;class N{constructor(u,s){this._wordSeparators=u,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const s=u.length;let i;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(i=this._searchRegex.exec(u),!i))return null;const l=i.index,g=i[0].length;if(l===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){M.getNextCodePoint(u,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=g,!this._wordSeparators||C(this._wordSeparators,u,s,l,g))return i}while(i);return null}}n.Searcher=N}),Z(K[39],x([0,1,4,38,2,8,19]),function(B,n,M,t,R,o,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,C,N){const A=N?N.startLineNumber:1,u=N?N.endLineNumber:e.getLineCount(),s=new E(C),i=s.getCandidateCodePoints();let l;i==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${a(Array.from(i))}`,"g");const g=new t.Searcher(null,l),L=[];let w=!1,d,v=0,_=0,b=0;e:for(let f=A,P=u;f<=P;f++){const O=e.getLineContent(f),U=O.length;g.reset(0);do if(d=g.next(O),d){let q=d.index,$=d.index+d[0].length;if(q>0){const ee=O.charCodeAt(q-1);R.isHighSurrogate(ee)&&q--}if($+1<U){const ee=O.charCodeAt($-1);R.isHighSurrogate(ee)&&$++}const j=O.substring(q,$),te=(0,y.getWordAtText)(q+1,y.DEFAULT_WORD_REGEXP,O,0),se=s.shouldHighlightNonBasicASCII(j,te?te.word:null);if(se!==0){se===3?v++:se===2?_++:se===1?b++:(0,o.assertNever)(se);const ee=1e3;if(L.length>=ee){w=!0;break e}L.push(new M.Range(f,q+1,f,$+1))}}while(d)}return{ranges:L,hasMore:w,ambiguousCharacterCount:v,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(e,C){const N=new E(C);switch(N.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const u=e.codePointAt(0),s=N.ambiguousCharacters.getPrimaryConfusable(u),i=R.AmbiguousCharacters.getLocales().filter(l=>!R.AmbiguousCharacters.getInstance(new Set([...C.allowedLocales,l])).isAmbiguous(u));return{kind:0,confusableWith:String.fromCodePoint(s),notAmbiguousInLocales:i}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=h;function a(m,e){return`[${R.escapeRegExpCharacters(m.map(N=>String.fromCodePoint(N)).join(""))}]`}var c;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(c=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class E{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=R.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const C of R.InvisibleCharacters.codePoints)D(String.fromCodePoint(C))||e.add(C);if(this.options.ambiguousCharacters)for(const C of this.ambiguousCharacters.getConfusableCodePoints())e.add(C);for(const C of this.allowedCodePoints)e.delete(C);return e}shouldHighlightNonBasicASCII(e,C){const N=e.codePointAt(0);if(this.allowedCodePoints.has(N))return 0;if(this.options.nonBasicASCII)return 1;let A=!1,u=!1;if(C)for(let s of C){const i=s.codePointAt(0),l=R.isBasicASCII(s);A=A||l,!l&&!this.ambiguousCharacters.isAmbiguous(i)&&!R.InvisibleCharacters.isInvisibleCharacter(i)&&(u=!0)}return!A&&u?0:this.options.invisibleCharacters&&!D(e)&&R.InvisibleCharacters.isInvisibleCharacter(N)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(N)?3:0}}function D(m){return m===" "||m===`
`||m==="	"}var p;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(p||(p={}))}),Z(K[40],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var M;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(M=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(t=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var R;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(R=n.CompletionItemKind||(n.CompletionItemKind={}));var o;(function(r){r[r.Deprecated=1]="Deprecated"})(o=n.CompletionItemTag||(n.CompletionItemTag={}));var y;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var h;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(h=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var a;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(a=n.CursorChangeReason||(n.CursorChangeReason={}));var c;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(c=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var E;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(E=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var D;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(D=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var p;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.enableDropIntoEditor=32]="enableDropIntoEditor",r[r.emptySelectionClipboard=33]="emptySelectionClipboard",r[r.extraEditorClassName=34]="extraEditorClassName",r[r.fastScrollSensitivity=35]="fastScrollSensitivity",r[r.find=36]="find",r[r.fixedOverflowWidgets=37]="fixedOverflowWidgets",r[r.folding=38]="folding",r[r.foldingStrategy=39]="foldingStrategy",r[r.foldingHighlight=40]="foldingHighlight",r[r.foldingImportsByDefault=41]="foldingImportsByDefault",r[r.foldingMaximumRegions=42]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=44]="fontFamily",r[r.fontInfo=45]="fontInfo",r[r.fontLigatures=46]="fontLigatures",r[r.fontSize=47]="fontSize",r[r.fontWeight=48]="fontWeight",r[r.formatOnPaste=49]="formatOnPaste",r[r.formatOnType=50]="formatOnType",r[r.glyphMargin=51]="glyphMargin",r[r.gotoLocation=52]="gotoLocation",r[r.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",r[r.hover=54]="hover",r[r.inDiffEditor=55]="inDiffEditor",r[r.inlineSuggest=56]="inlineSuggest",r[r.letterSpacing=57]="letterSpacing",r[r.lightbulb=58]="lightbulb",r[r.lineDecorationsWidth=59]="lineDecorationsWidth",r[r.lineHeight=60]="lineHeight",r[r.lineNumbers=61]="lineNumbers",r[r.lineNumbersMinChars=62]="lineNumbersMinChars",r[r.linkedEditing=63]="linkedEditing",r[r.links=64]="links",r[r.matchBrackets=65]="matchBrackets",r[r.minimap=66]="minimap",r[r.mouseStyle=67]="mouseStyle",r[r.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=69]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",r[r.multiCursorModifier=71]="multiCursorModifier",r[r.multiCursorPaste=72]="multiCursorPaste",r[r.occurrencesHighlight=73]="occurrencesHighlight",r[r.overviewRulerBorder=74]="overviewRulerBorder",r[r.overviewRulerLanes=75]="overviewRulerLanes",r[r.padding=76]="padding",r[r.parameterHints=77]="parameterHints",r[r.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",r[r.quickSuggestions=80]="quickSuggestions",r[r.quickSuggestionsDelay=81]="quickSuggestionsDelay",r[r.readOnly=82]="readOnly",r[r.renameOnType=83]="renameOnType",r[r.renderControlCharacters=84]="renderControlCharacters",r[r.renderFinalNewline=85]="renderFinalNewline",r[r.renderLineHighlight=86]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=88]="renderValidationDecorations",r[r.renderWhitespace=89]="renderWhitespace",r[r.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",r[r.roundedSelection=91]="roundedSelection",r[r.rulers=92]="rulers",r[r.scrollbar=93]="scrollbar",r[r.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=95]="scrollBeyondLastLine",r[r.scrollPredominantAxis=96]="scrollPredominantAxis",r[r.selectionClipboard=97]="selectionClipboard",r[r.selectionHighlight=98]="selectionHighlight",r[r.selectOnLineNumbers=99]="selectOnLineNumbers",r[r.showFoldingControls=100]="showFoldingControls",r[r.showUnused=101]="showUnused",r[r.snippetSuggestions=102]="snippetSuggestions",r[r.smartSelect=103]="smartSelect",r[r.smoothScrolling=104]="smoothScrolling",r[r.stickyTabStops=105]="stickyTabStops",r[r.stopRenderingLineAfter=106]="stopRenderingLineAfter",r[r.suggest=107]="suggest",r[r.suggestFontSize=108]="suggestFontSize",r[r.suggestLineHeight=109]="suggestLineHeight",r[r.suggestOnTriggerCharacters=110]="suggestOnTriggerCharacters",r[r.suggestSelection=111]="suggestSelection",r[r.tabCompletion=112]="tabCompletion",r[r.tabIndex=113]="tabIndex",r[r.unicodeHighlighting=114]="unicodeHighlighting",r[r.unusualLineTerminators=115]="unusualLineTerminators",r[r.useShadowDOM=116]="useShadowDOM",r[r.useTabStops=117]="useTabStops",r[r.wordSeparators=118]="wordSeparators",r[r.wordWrap=119]="wordWrap",r[r.wordWrapBreakAfterCharacters=120]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=121]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=122]="wordWrapColumn",r[r.wordWrapOverride1=123]="wordWrapOverride1",r[r.wordWrapOverride2=124]="wordWrapOverride2",r[r.wrappingIndent=125]="wrappingIndent",r[r.wrappingStrategy=126]="wrappingStrategy",r[r.showDeprecated=127]="showDeprecated",r[r.inlayHints=128]="inlayHints",r[r.editorClassName=129]="editorClassName",r[r.pixelRatio=130]="pixelRatio",r[r.tabFocusMode=131]="tabFocusMode",r[r.layoutInfo=132]="layoutInfo",r[r.wrappingInfo=133]="wrappingInfo"})(p=n.EditorOption||(n.EditorOption={}));var m;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(m=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var C;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(C=n.IndentAction||(n.IndentAction={}));var N;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(N=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var A;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(A=n.InlayHintKind||(n.InlayHintKind={}));var u;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(u=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(s=n.KeyCode||(n.KeyCode={}));var i;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var l;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(l=n.MarkerTag||(n.MarkerTag={}));var g;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(g=n.MinimapPosition||(n.MinimapPosition={}));var L;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(L=n.MouseTargetType||(n.MouseTargetType={}));var w;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(w=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var d;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(d=n.OverviewRulerLane||(n.OverviewRulerLane={}));var v;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(v=n.PositionAffinity||(n.PositionAffinity={}));var _;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(_=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var b;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(b=n.RenderMinimap||(n.RenderMinimap={}));var f;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(f=n.ScrollType||(n.ScrollType={}));var P;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(P=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var O;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(O=n.SelectionDirection||(n.SelectionDirection={}));var U;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(U=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var q;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(q=n.SymbolKind||(n.SymbolKind={}));var $;(function(r){r[r.Deprecated=1]="Deprecated"})($=n.SymbolTag||(n.SymbolTag={}));var j;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(j=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var te;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(te=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var se;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(se=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var ee;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ee=n.WrappingIndent||(n.WrappingIndent={}))}),Z(K[41],x([0,1,7,6]),function(B,n,M,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class R{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(h){this._onDidChange.fire({changedLanguages:h,changedColorMap:!1})}register(h,a){return this._map.set(h,a),this.fire([h]),(0,t.toDisposable)(()=>{this._map.get(h)===a&&(this._map.delete(h),this.fire([h]))})}registerFactory(h,a){this._factories.get(h)?.dispose();const c=new o(this,h,a);return this._factories.set(h,c),(0,t.toDisposable)(()=>{const E=this._factories.get(h);!E||E!==c||(this._factories.delete(h),E.dispose())})}async getOrCreate(h){const a=this.get(h);if(a)return a;const c=this._factories.get(h);return!c||c.isResolved?null:(await c.resolve(),this.get(h))}get(h){return this._map.get(h)||null}isResolved(h){if(this.get(h))return!0;const c=this._factories.get(h);return!!(!c||c.isResolved)}setColorMap(h){this._colorMap=h,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=R;class o extends t.Disposable{constructor(h,a,c){super();this._registry=h,this._languageId=a,this._factory=c,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const h=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,h&&!this._isDisposed&&this._register(this._registry.register(this._languageId,h))}}}),Z(K[42],x([0,1,20,10,4,41]),function(B,n,M,t,R,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class y{constructor(P,O,U){this._tokenBrand=void 0,this.offset=P,this.type=O,this.language=U}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=y;class h{constructor(P,O){this._tokenizationResultBrand=void 0,this.tokens=P,this.endState=O}}n.TokenizationResult=h;class a{constructor(P,O){this._encodedTokenizationResultBrand=void 0,this.tokens=P,this.endState=O}}n.EncodedTokenizationResult=a;var c;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(c=n.CompletionItemKind||(n.CompletionItemKind={}));var E;(function(f){const P=new Map;P.set(0,M.Codicon.symbolMethod),P.set(1,M.Codicon.symbolFunction),P.set(2,M.Codicon.symbolConstructor),P.set(3,M.Codicon.symbolField),P.set(4,M.Codicon.symbolVariable),P.set(5,M.Codicon.symbolClass),P.set(6,M.Codicon.symbolStruct),P.set(7,M.Codicon.symbolInterface),P.set(8,M.Codicon.symbolModule),P.set(9,M.Codicon.symbolProperty),P.set(10,M.Codicon.symbolEvent),P.set(11,M.Codicon.symbolOperator),P.set(12,M.Codicon.symbolUnit),P.set(13,M.Codicon.symbolValue),P.set(15,M.Codicon.symbolEnum),P.set(14,M.Codicon.symbolConstant),P.set(15,M.Codicon.symbolEnum),P.set(16,M.Codicon.symbolEnumMember),P.set(17,M.Codicon.symbolKeyword),P.set(27,M.Codicon.symbolSnippet),P.set(18,M.Codicon.symbolText),P.set(19,M.Codicon.symbolColor),P.set(20,M.Codicon.symbolFile),P.set(21,M.Codicon.symbolReference),P.set(22,M.Codicon.symbolCustomColor),P.set(23,M.Codicon.symbolFolder),P.set(24,M.Codicon.symbolTypeParameter),P.set(25,M.Codicon.account),P.set(26,M.Codicon.issues);function O($){let j=P.get($);return j||(console.info("No codicon found for CompletionItemKind "+$),j=M.Codicon.symbolProperty),j}f.toIcon=O;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function q($,j){let te=U.get($);return typeof te=="undefined"&&!j&&(te=9),te}f.fromString=q})(E=n.CompletionItemKinds||(n.CompletionItemKinds={}));var D;(function(f){f[f.Deprecated=1]="Deprecated"})(D=n.CompletionItemTag||(n.CompletionItemTag={}));var p;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(p=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var m;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var C;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(C=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var N;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(N=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var A;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(A=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function u(f){return f&&t.URI.isUri(f.uri)&&R.Range.isIRange(f.range)&&(R.Range.isIRange(f.originSelectionRange)||R.Range.isIRange(f.targetSelectionRange))}n.isLocationLink=u;var s;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(s=n.SymbolKind||(n.SymbolKind={}));var i;(function(f){f[f.Deprecated=1]="Deprecated"})(i=n.SymbolTag||(n.SymbolTag={}));var l;(function(f){const P=new Map;P.set(0,M.Codicon.symbolFile),P.set(1,M.Codicon.symbolModule),P.set(2,M.Codicon.symbolNamespace),P.set(3,M.Codicon.symbolPackage),P.set(4,M.Codicon.symbolClass),P.set(5,M.Codicon.symbolMethod),P.set(6,M.Codicon.symbolProperty),P.set(7,M.Codicon.symbolField),P.set(8,M.Codicon.symbolConstructor),P.set(9,M.Codicon.symbolEnum),P.set(10,M.Codicon.symbolInterface),P.set(11,M.Codicon.symbolFunction),P.set(12,M.Codicon.symbolVariable),P.set(13,M.Codicon.symbolConstant),P.set(14,M.Codicon.symbolString),P.set(15,M.Codicon.symbolNumber),P.set(16,M.Codicon.symbolBoolean),P.set(17,M.Codicon.symbolArray),P.set(18,M.Codicon.symbolObject),P.set(19,M.Codicon.symbolKey),P.set(20,M.Codicon.symbolNull),P.set(21,M.Codicon.symbolEnumMember),P.set(22,M.Codicon.symbolStruct),P.set(23,M.Codicon.symbolEvent),P.set(24,M.Codicon.symbolOperator),P.set(25,M.Codicon.symbolTypeParameter);function O(U){let q=P.get(U);return q||(console.info("No codicon found for SymbolKind "+U),q=M.Codicon.symbolProperty),q}f.toIcon=O})(l=n.SymbolKinds||(n.SymbolKinds={}));class g{constructor(P){this.value=P}}n.FoldingRangeKind=g,g.Comment=new g("comment"),g.Imports=new g("imports"),g.Region=new g("region");var L;(function(f){function P(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}f.is=P})(L=n.Command||(n.Command={}));var w;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(w=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var d;(function(f){f[f.Unresolved=0]="Unresolved",f[f.Resolved=1]="Resolved"})(d=n.CommentThreadState||(n.CommentThreadState={}));var v;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(v=n.CommentMode||(n.CommentMode={}));var _;(function(f){f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(_=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new o.TokenizationRegistry;var b;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(b=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Z(K[43],x([0,1,15,7,23,10,3,4,30,42,40]),function(B,n,M,t,R,o,y,h,a,c,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class D{static chord(e,C){return(0,R.KeyChord)(e,C)}}n.KeyMod=D,D.CtrlCmd=2048,D.Shift=1024,D.Alt=512,D.WinCtrl=256;function p(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:t.Emitter,KeyCode:E.KeyCode,KeyMod:D,Position:y.Position,Range:h.Range,Selection:a.Selection,SelectionDirection:E.SelectionDirection,MarkerSeverity:E.MarkerSeverity,MarkerTag:E.MarkerTag,Uri:o.URI,Token:c.Token}}n.createMonacoBaseAPI=p}),Z(K[45],x([0,1,16,5,10,3,4,32,37,19,33,34,43,8,14,39]),function(B,n,M,t,R,o,y,h,a,c,E,D,p,m,e,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class N extends a.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,l){const g=(0,c.getWordAtText)(i.column,(0,c.ensureValidWordDefinition)(l),this._lines[i.lineNumber-1],0);return g?new y.Range(i.lineNumber,g.startColumn,i.lineNumber,g.endColumn):null}getWordUntilPosition(i,l){const g=this.getWordAtPosition(i,l);return g?{word:this._lines[i.lineNumber-1].substring(g.startColumn-1,i.column-1),startColumn:g.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this._lines,g=this._wordenize.bind(this);let L=0,w="",d=0,v=[];return{*[Symbol.iterator](){for(;;)if(d<v.length){const _=w.substring(v[d].start,v[d].end);d+=1,yield _}else if(L<l.length)w=l[L],v=g(w,i),d=0,L+=1;else break}}}getLineWords(i,l){const g=this._lines[i-1],L=this._wordenize(g,l),w=[];for(const d of L)w.push({word:g.substring(d.start,d.end),startColumn:d.start+1,endColumn:d.end+1});return w}_wordenize(i,l){const g=[];let L;for(l.lastIndex=0;(L=l.exec(i))&&L[0].length!==0;)g.push({start:L.index,end:L.index+L[0].length});return g}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this._eol,g=i.startLineNumber-1,L=i.endLineNumber-1,w=[];w.push(this._lines[g].substring(i.startColumn-1));for(let d=g+1;d<L;d++)w.push(this._lines[d]);return w.push(this._lines[L].substring(0,i.endColumn-1)),w.join(l)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();const l=this._lineStarts.getIndexOf(i),g=this._lines[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,g)}}_validateRange(i){const l=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),g=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||g.lineNumber!==i.endLineNumber||g.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:g.lineNumber,endColumn:g.column}:i}_validatePosition(i){if(!o.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:g}=i,L=!1;if(l<1)l=1,g=1,L=!0;else if(l>this._lines.length)l=this._lines.length,g=this._lines[l-1].length+1,L=!0;else{const w=this._lines[l-1].length+1;g<1?(g=1,L=!0):g>w&&(g=w,L=!0)}return L?{lineNumber:l,column:g}:i}}n.MirrorModel=N;class A{constructor(i,l){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=l,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){const i=[];return Object.keys(this._models).forEach(l=>i.push(this._models[l])),i}acceptNewModel(i){this._models[i.url]=new N(R.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this._models[i])return;this._models[i].onEvents(l)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeUnicodeHighlights(i,l,g){const L=this._getModel(i);return L?C.UnicodeTextModelHighlighter.computeUnicodeHighlights(L,l,g):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,g,L){const w=this._getModel(i),d=this._getModel(l);if(!w||!d)return null;const v=w.getLinesContent(),_=d.getLinesContent(),f=new h.DiffComputer(v,_,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:g,shouldMakePrettyDiff:!0,maxComputationTime:L}).computeDiff(),P=f.changes.length>0?!1:this._modelsAreIdentical(w,d);return{quitEarly:f.quitEarly,identical:P,changes:f.changes}}_modelsAreIdentical(i,l){const g=i.getLineCount(),L=l.getLineCount();if(g!==L)return!1;for(let w=1;w<=g;w++){const d=i.getLineContent(w),v=l.getLineContent(w);if(d!==v)return!1}return!0}async computeDirtyDiff(i,l,g){const L=this._getModel(i),w=this._getModel(l);if(!L||!w)return null;const d=L.getLinesContent(),v=w.getLinesContent();return new h.DiffComputer(d,v,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:g,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,l){const g=this._getModel(i);if(!g)return l;const L=[];let w;l=l.slice(0).sort((d,v)=>{if(d.range&&v.range)return y.Range.compareRangesUsingStarts(d.range,v.range);const _=d.range?0:1,b=v.range?0:1;return _-b});for(let{range:d,text:v,eol:_}of l){if(typeof _=="number"&&(w=_),y.Range.isEmpty(d)&&!v)continue;const b=g.getValueInRange(d);if(v=v.replace(/\r\n|\n|\r/g,g.eol),b===v)continue;if(Math.max(v.length,b.length)>A._diffLimit){L.push({range:d,text:v});continue}const f=(0,M.stringDiff)(b,v,!1),P=g.offsetAt(y.Range.lift(d).getStartPosition());for(const O of f){const U=g.positionAt(P+O.originalStart),q=g.positionAt(P+O.originalStart+O.originalLength),$={text:v.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:U.lineNumber,startColumn:U.column,endLineNumber:q.lineNumber,endColumn:q.column}};g.getValueInRange($.range)!==$.text&&L.push($)}}return typeof w=="number"&&L.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),L}async computeLinks(i){const l=this._getModel(i);return l?(0,E.computeLinks)(l):null}async textualSuggest(i,l,g,L){const w=new e.StopWatch(!0),d=new RegExp(g,L),v=new Set;e:for(let _ of i){const b=this._getModel(_);if(!!b){for(let f of b.words(d))if(!(f===l||!isNaN(Number(f)))&&(v.add(f),v.size>A._suggestionsLimit))break e}}return{words:Array.from(v),duration:w.elapsed()}}async computeWordRanges(i,l,g,L){const w=this._getModel(i);if(!w)return Object.create(null);const d=new RegExp(g,L),v=Object.create(null);for(let _=l.startLineNumber;_<l.endLineNumber;_++){const b=w.getLineWords(_,d);for(const f of b){if(!isNaN(Number(f.word)))continue;let P=v[f.word];P||(P=[],v[f.word]=P),P.push({startLineNumber:_,startColumn:f.startColumn,endLineNumber:_,endColumn:f.endColumn})}}return v}async navigateValueSet(i,l,g,L,w){const d=this._getModel(i);if(!d)return null;const v=new RegExp(L,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const _=d.getValueInRange(l),b=d.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},v);if(!b)return null;const f=d.getValueInRange(b);return D.BasicInplaceReplace.INSTANCE.navigateValueSet(l,_,b,f,g)}loadForeignModule(i,l,g){const L=(v,_)=>this._host.fhr(v,_),d={host:m.createProxyObject(g,L),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(d,l),Promise.resolve(m.getAllMethodNames(this._foreignModule))):new Promise((v,_)=>{B([i],b=>{this._foreignModule=b.create(d,l),v(m.getAllMethodNames(this._foreignModule))},_)})}fmr(i,l){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,l))}catch(g){return Promise.reject(g)}}}n.EditorSimpleWorker=A,A._diffLimit=1e5,A._suggestionsLimit=1e4;function u(s){return new A(s,null)}n.create=u,typeof importScripts=="function"&&(t.globals.monaco=(0,p.createMonacoBaseAPI)())}),function(){const B=self.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../",M=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:a=>a,createScript:(a,...c)=>{const E=c.slice(0,-1).join(","),D=c.pop().toString();return`(function anonymous(${E}) {
${D}
})`}}):void 0;function t(){try{return(M?self.eval(M.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function R(){return new Promise((a,c)=>{if(typeof self.define=="function"&&self.define.amd)return a();const E=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(E)&&E.substring(0,self.origin.length)!==self.origin)&&t()){fetch(E).then(p=>{if(p.status!==200)throw new Error(p.statusText);return p.text()}).then(p=>{p=`${p}
//# sourceURL=${E}`,(M?self.eval(M.createScript("",p)):new Function(p)).call(self),a()}).then(void 0,c);return}M?importScripts(M.createScriptURL(E)):importScripts(E),a()})}const o=function(a){R().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//}),require([a],function(c){setTimeout(function(){let E=c.create((D,p)=>{self.postMessage(D,p)},null);for(self.onmessage=D=>E.onmessage(D.data,D.ports);h.length>0;)self.onmessage(h.shift())},0)})})};let y=!0,h=[];self.onmessage=a=>{if(!y){h.push(a);return}y=!1,o(a.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4af164ea3a06f701fe3e89a2bcbb421d2026b68f/core/vs/base/worker/workerMain.js.map
