/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/types","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/resources","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/normalization","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(X){for(var e=[],D=0,n=X.length;D<n;D++)e[D]=re[X[D]];return e};define(re[107],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(re[48],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(P,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(P,E,b){this.id=P,this.definition=E,this.description=b,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(A,P){const E=["codicon","codicon-"+A];return P&&E.push("codicon-modifier-"+P),E}e.getClassNamesArray=L;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(I){if(I instanceof n)return["codicon","codicon-"+I.id];const v=P.exec(I.id);if(!v)return E(n.error);let[,y,m]=v;const p=["codicon","codicon-"+y];return m&&p.push("codicon-modifier-"+m.substr(1)),p}A.asClassNameArray=E;function b(I){return E(I).join(" ")}A.asClassName=b;function R(I){return"."+E(I).join(".")}A.asCSSSelector=R})(T=e.CSSIcon||(e.CSSIcon={}))}),define(re[71],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(R){const I=[];for(let v in R)D.call(R,v)&&I.push(R[v]);return I}e.values=n;function L(R,I){for(let v in R)if(D.call(R,v)&&I({key:v,value:R[v]},function(){delete R[v]})===!1)return}e.forEach=L;function T(R,I){const v=Object.create(null);for(const y of R){const m=I(y);let p=v[m];p||(p=v[m]=[]),p.push(y)}return v}e.groupBy=T;function A(R){const I=Object.create(null);return R&&R.forEach((v,y)=>{I[y]=v}),I}e.fromMap=A;function P(R,I){const v=[],y=[];for(let m of R)I.has(m)||v.push(m);for(let m of I)R.has(m)||y.push(m);return{removed:v,added:y}}e.diffSets=P;function E(R,I){const v=[],y=[];for(let[m,p]of R)I.has(m)||v.push(p);for(let[m,p]of I)R.has(m)||y.push(p);return{removed:v,added:y}}e.diffMaps=E;class b{constructor(){this.map=new Map}add(I,v){let y=this.map.get(I);y||(y=new Set,this.map.set(I,y)),y.add(v)}delete(I,v){const y=this.map.get(I);!y||(y.delete(v),y.size===0&&this.map.delete(I))}forEach(I,v){const y=this.map.get(I);!y||y.forEach(v)}}e.SetMap=b}),define(re[57],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(P,E,b)=>{let R=null,I=null;if(typeof b.value=="function"?(R="value",I=b.value):typeof b.get=="function"&&(R="get",I=b.get),!I)throw new Error("not supported");b[R]=A(I,E)}}e.createDecorator=D;function n(A,P,E){let b=null,R=null;if(typeof E.value=="function"?(b="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${P}`;E[b]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,v)}),this[I]}}e.memoize=n;function L(A,P,E){return D((b,R)=>{const I=`$debounce$${R}`,v=`$debounce$result$${R}`;return function(...y){this[v]||(this[v]=E?E():void 0),clearTimeout(this[I]),P&&(this[v]=P(this[v],...y),y=[this[v]]),this[I]=setTimeout(()=>{b.apply(this,y),this[v]=E?E():void 0},A)}})}e.debounce=L;function T(A,P,E){return D((b,R)=>{const I=`$throttle$timer$${R}`,v=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,m=`$throttle$pending$${R}`;return function(...p){if(this[v]||(this[v]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...p)),this[m])return;const f=this[y]+A;f<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[v]]),this[v]=E?E():void 0):(this[m]=!0,this[I]=setTimeout(()=>{this[m]=!1,this[y]=Date.now(),b.apply(this,[this[v]]),this[v]=E?E():void 0},f-Date.now()))}})}e.throttle=T}),define(re[9],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function L(u){E(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=L;function T(u){E(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=T;function A(u){if(u instanceof Error){let{name:t,message:r}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:t,message:r,stack:i}}return u}e.transformErrorForSerialization=A;const P="Canceled";function E(u){return u instanceof b?!0:u instanceof Error&&u.name===P&&u.message===P}e.isCancellationError=E;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function R(){const u=new Error(P);return u.name=u.message,u}e.canceled=R;function I(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=I;function v(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=v;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function m(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=m;function p(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=p;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class d extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=d;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;class w extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(t){if(t&&t instanceof w)return t;if(t&&t instanceof Error){const r=new w;return r.name=t.name,r.message=t.message,r.stack=t.stack,r}return new w(t)}}e.ErrorNoTelemetry=w;class g extends Error{constructor(t){super(t||"An unexpected bug occurred.");Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(re[16],se([0,1,9]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(z,V=0){return z[z.length-(1+V)]}e.tail=n;function L(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=L;function T(z,V,ee=(ie,ae)=>ie===ae){if(z===V)return!0;if(!z||!V||z.length!==V.length)return!1;for(let ie=0,ae=z.length;ie<ae;ie++)if(!ee(z[ie],V[ie]))return!1;return!0}e.equals=T;function A(z,V,ee){return P(z.length,ie=>ee(z[ie],V))}e.binarySearch=A;function P(z,V){let ee=0,ie=z-1;for(;ee<=ie;){const ae=(ee+ie)/2|0,fe=V(ae);if(fe<0)ee=ae+1;else if(fe>0)ie=ae-1;else return ae}return-(ee+1)}e.binarySearch2=P;function E(z,V){let ee=0,ie=z.length;if(ie===0)return 0;for(;ee<ie;){const ae=Math.floor((ee+ie)/2);V(z[ae])?ie=ae:ee=ae+1}return ee}e.findFirstInSorted=E;function b(z,V,ee){if(z=z|0,z>=V.length)throw new TypeError("invalid index");let ie=V[Math.floor(V.length*Math.random())],ae=[],fe=[],pe=[];for(let we of V){const ge=ee(we,ie);ge<0?ae.push(we):ge>0?fe.push(we):pe.push(we)}return z<ae.length?b(z,ae,ee):z<ae.length+pe.length?pe[0]:b(z-(ae.length+pe.length),fe,ee)}e.quickSelect=b;function R(z,V){const ee=[];let ie;for(const ae of z.slice(0).sort(V))!ie||V(ie[0],ae)!==0?(ie=[ae],ee.push(ie)):ie.push(ae);return ee}e.groupBy=R;function I(z,V,ee){const ie=[];function ae(we,ge,Ee){if(ge===0&&Ee.length===0)return;const Ce=ie[ie.length-1];Ce&&Ce.start+Ce.deleteCount===we?(Ce.deleteCount+=ge,Ce.toInsert.push(...Ee)):ie.push({start:we,deleteCount:ge,toInsert:Ee})}let fe=0,pe=0;for(;;){if(fe===z.length){ae(fe,0,V.slice(pe));break}if(pe===V.length){ae(fe,z.length-fe,[]);break}const we=z[fe],ge=V[pe],Ee=ee(we,ge);Ee===0?(fe+=1,pe+=1):Ee<0?(ae(fe,1,[]),fe+=1):Ee>0&&(ae(fe,0,[ge]),pe+=1)}return ie}e.sortedDiff=I;function v(z,V,ee){const ie=I(z,V,ee),ae=[],fe=[];for(const pe of ie)ae.push(...z.slice(pe.start,pe.start+pe.deleteCount)),fe.push(...pe.toInsert);return{removed:ae,added:fe}}e.delta=v;function y(z,V,ee){if(ee===0)return[];const ie=z.slice(0,ee).sort(V);return p(z,V,ie,ee,z.length),ie}e.top=y;function m(z,V,ee,ie,ae){return ee===0?Promise.resolve([]):new Promise((fe,pe)=>{(async()=>{const we=z.length,ge=z.slice(0,ee).sort(V);for(let Ee=ee,Ce=Math.min(ee+ie,we);Ee<we;Ee=Ce,Ce=Math.min(Ce+ie,we)){if(Ee>ee&&await new Promise(Re=>setTimeout(Re)),ae&&ae.isCancellationRequested)throw new D.CancellationError;p(z,V,ge,Ee,Ce)}return ge})().then(fe,pe)})}e.topAsync=m;function p(z,V,ee,ie,ae){for(const fe=ee.length;ie<ae;ie++){const pe=z[ie];if(V(pe,ee[fe-1])<0){ee.pop();const we=E(ee,ge=>V(pe,ge)<0);ee.splice(we,0,pe)}}}function f(z){return z.filter(V=>!!V)}e.coalesce=f;function d(z){let V=0;for(let ee=0;ee<z.length;ee++)z[ee]&&(z[V]=z[ee],V+=1);z.length=V}e.coalesceInPlace=d;function S(z,V,ee){z.splice(ee,0,z.splice(V,1)[0])}e.move=S;function w(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=w;function g(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=g;function u(z,V=ee=>ee){const ee=new Set;return z.filter(ie=>{const ae=V(ie);return ee.has(ae)?!1:(ee.add(ae),!0)})}e.distinct=u;function t(z){const V=new Set;return ee=>{const ie=z(ee);return V.has(ie)?!1:(V.add(ie),!0)}}e.uniqueFilter=t;function r(z,V){const ee=i(z,V);if(ee!==-1)return z[ee]}e.findLast=r;function i(z,V){for(let ee=z.length-1;ee>=0;ee--){const ie=z[ee];if(V(ie))return ee}return-1}e.lastIndex=i;function a(z,V){return z.length>0?z[0]:V}e.firstOrDefault=a;function c(z,V){return z.length>0?z[z.length-1]:V}e.lastOrDefault=c;function s(z,V,ee=(ie,ae)=>ie===ae){let ie=0;for(let ae=0,fe=Math.min(z.length,V.length);ae<fe&&ee(z[ae],V[ae]);ae++)ie++;return ie}e.commonPrefixLength=s;function o(z){return[].concat(...z)}e.flatten=o;function l(z,V){let ee=typeof V=="number"?z:0;typeof V=="number"?ee=z:(ee=0,V=z);const ie=[];if(ee<=V)for(let ae=ee;ae<V;ae++)ie.push(ae);else for(let ae=ee;ae>V;ae--)ie.push(ae);return ie}e.range=l;function h(z,V,ee){return z.reduce((ie,ae)=>(ie[V(ae)]=ee?ee(ae):ae,ie),Object.create(null))}e.index=h;function C(z,V){return z.push(V),()=>M(z,V)}e.insert=C;function M(z,V){const ee=z.indexOf(V);if(ee>-1)return z.splice(ee,1),V}e.remove=M;function O(z,V,ee){const ie=z.slice(0,V),ae=z.slice(V);return ie.concat(ee,ae)}e.arrayInsert=O;function U(z,V){let ee;if(typeof V=="number"){let ie=V;ee=()=>{const ae=Math.sin(ie++)*179426549;return ae-Math.floor(ae)}}else ee=Math.random;for(let ie=z.length-1;ie>0;ie-=1){const ae=Math.floor(ee()*(ie+1)),fe=z[ie];z[ie]=z[ae],z[ae]=fe}}e.shuffle=U;function k(z,V){const ee=z.indexOf(V);ee>-1&&(z.splice(ee,1),z.unshift(V))}e.pushToStart=k;function F(z,V){const ee=z.indexOf(V);ee>-1&&(z.splice(ee,1),z.push(V))}e.pushToEnd=F;function _(z,V){for(const ee of V)z.push(ee)}e.pushMany=_;function $(z,V){return Array.isArray(z)?z.map(V):V(z)}e.mapArrayOrNot=$;function H(z){return Array.isArray(z)?z:[z]}e.asArray=H;function ne(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=ne;function K(z,V){for(const ee of z){const ie=V(ee);if(ie!==void 0)return ie}}e.mapFind=K;function N(z,V,ee){const ie=x(z,V),ae=z.length,fe=ee.length;z.length=ae+fe;for(let pe=ae-1;pe>=ie;pe--)z[pe+fe]=z[pe];for(let pe=0;pe<fe;pe++)z[pe+ie]=ee[pe]}e.insertInto=N;function W(z,V,ee,ie){const ae=x(z,V),fe=z.splice(ae,ee);return N(z,ae,ie),fe}e.splice=W;function x(z,V){return V<0?Math.max(V+z.length,0):Math.min(V,z.length)}var J;(function(z){function V(ae){return ae<0}z.isLessThan=V;function ee(ae){return ae>0}z.isGreaterThan=ee;function ie(ae){return ae===0}z.isNeitherLessOrGreaterThan=ie,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function G(z,V){return(ee,ie)=>V(z(ee),z(ie))}e.compareBy=G;const Q=(z,V)=>z-V;e.numberComparator=Q;function Z(z,V){if(z.length===0)return;let ee=z[0];for(let ie=1;ie<z.length;ie++){const ae=z[ie];V(ae,ee)>0&&(ee=ae)}return ee}e.findMaxBy=Z;function q(z,V){if(z.length===0)return;let ee=z[0];for(let ie=1;ie<z.length;ie++){const ae=z[ie];V(ae,ee)>=0&&(ee=ae)}return ee}e.findLastMaxBy=q;function B(z,V){return Z(z,(ee,ie)=>-V(ee,ie))}e.findMinBy=B;class j{constructor(V){this.items=V,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(V){let ee=this.firstIdx;for(;ee<this.items.length&&V(this.items[ee]);)ee++;const ie=ee===this.firstIdx?null:this.items.slice(this.firstIdx,ee);return this.firstIdx=ee,ie}takeFromEndWhile(V){let ee=this.lastIdx;for(;ee>=0&&V(this.items[ee]);)ee--;const ie=ee===this.lastIdx?null:this.items.slice(ee+1,this.lastIdx+1);return this.lastIdx=ee,ie}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const V=this.items[this.firstIdx];return this.firstIdx++,V}removeLast(){const V=this.items[this.lastIdx];return this.lastIdx--,V}takeCount(V){const ee=this.items.slice(this.firstIdx,this.firstIdx+V);return this.firstIdx+=V,ee}}e.ArrayQueue=j}),define(re[72],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(L,arguments)),A}}e.once=D}),define(re[49],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=L;const T=Object.freeze([]);function A(){return T}n.empty=A;function*P(r){yield r}n.single=P;function E(r){return r||T}n.from=E;function b(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=b;function R(r){return r[Symbol.iterator]().next().value}n.first=R;function I(r,i){for(const a of r)if(i(a))return!0;return!1}n.some=I;function v(r,i){for(const a of r)if(i(a))return a}n.find=v;function*y(r,i){for(const a of r)i(a)&&(yield a)}n.filter=y;function*m(r,i){let a=0;for(const c of r)yield i(c,a++)}n.map=m;function*p(...r){for(const i of r)for(const a of i)yield a}n.concat=p;function*f(r){for(const i of r)for(const a of i)yield a}n.concatNested=f;function d(r,i,a){let c=a;for(const s of r)c=i(c,s);return c}n.reduce=d;function S(r,i){let a=0;for(const c of r)i(c,a++)}n.forEach=S;function*w(r,i,a=r.length){for(i<0&&(i+=r.length),a<0?a+=r.length:a>r.length&&(a=r.length);i<a;i++)yield r[i]}n.slice=w;function g(r,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,r];const c=r[Symbol.iterator]();for(let s=0;s<i;s++){const o=c.next();if(o.done)return[a,n.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return c}}]}n.consume=g;function u(r){return g(r)[0]}n.collect=u;function t(r,i,a=(c,s)=>c===s){const c=r[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const o=c.next(),l=s.next();if(o.done!==l.done)return!1;if(o.done)return!0;if(!a(o.value,l.value))return!1}}n.equals=t})(D=e.Iterable||(e.Iterable={}))}),define(re[33],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,a=t.length,c="",s=0,o=16,l=0;function h(_){let $=0,H=0;for(;$<_;){const ne=t.charCodeAt(i);if(ne>=48&&ne<=57)H=H*16+ne-48;else if(ne>=65&&ne<=70)H=H*16+ne-65+10;else if(ne>=97&&ne<=102)H=H*16+ne-97+10;else break;i++,$++}return $<_&&(H=-1),H}function C(_){i=_,c="",s=0,o=16,l=0}function M(){const _=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&b(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&b(t.charCodeAt(i)))for(i++;i<t.length&&b(t.charCodeAt(i));)i++;else return l=3,t.substring(_,i);let $=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&b(t.charCodeAt(i))){for(i++;i<t.length&&b(t.charCodeAt(i));)i++;$=i}else l=3;return t.substring(_,$)}function O(){let _="",$=i;for(;;){if(i>=a){_+=t.substring($,i),l=2;break}const H=t.charCodeAt(i);if(H===34){_+=t.substring($,i),i++;break}if(H===92){if(_+=t.substring($,i),i++,i>=a){l=2;break}switch(t.charCodeAt(i++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const K=h(4);K>=0?_+=String.fromCharCode(K):l=4;break}default:l=5}$=i;continue}if(H>=0&&H<=31)if(E(H)){_+=t.substring($,i),l=2;break}else l=6;i++}return _}function U(){if(c="",l=0,s=i,i>=a)return s=a,o=17;let _=t.charCodeAt(i);if(P(_)){do i++,c+=String.fromCharCode(_),_=t.charCodeAt(i);while(P(_));return o=15}if(E(_))return i++,c+=String.fromCharCode(_),_===13&&t.charCodeAt(i)===10&&(i++,c+=`
`),o=14;switch(_){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,c=O(),o=10;case 47:{const $=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!E(t.charCodeAt(i));)i++;return c=t.substring($,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const H=a-1;let ne=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ne=!0;break}i++}return ne||(i++,l=1),c=t.substring($,i),o=13}return c+=String.fromCharCode(_),i++,o=16}case 45:if(c+=String.fromCharCode(_),i++,i===a||!b(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=M(),o=11;default:for(;i<a&&k(_);)i++,_=t.charCodeAt(i);if(s!==i){switch(c=t.substring(s,i),c){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return c+=String.fromCharCode(_),i++,o=16}}function k(_){if(P(_)||E(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let _;do _=U();while(_>=12&&_<=15);return _}return{setPosition:C,getPosition:()=>i,scan:r?F:U,getToken:()=>o,getTokenValue:()=>c,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>l}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,r){const i=[],a=new Object;let c;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function l(h,C,M,O){s.value=h,s.offset=C,s.length=M,s.type=O,s.colonOffset=void 0,c=s}try{w(t,{onObjectBegin:(h,C)=>{if(r<=h)throw a;c=void 0,o=r>h,i.push("")},onObjectProperty:(h,C,M)=>{if(r<C||(l(h,C,M,"property"),i[i.length-1]=h,r<=C+M))throw a},onObjectEnd:(h,C)=>{if(r<=h)throw a;c=void 0,i.pop()},onArrayBegin:(h,C)=>{if(r<=h)throw a;c=void 0,i.push(0)},onArrayEnd:(h,C)=>{if(r<=h)throw a;c=void 0,i.pop()},onLiteralValue:(h,C,M)=>{if(r<C||(l(h,C,M,u(h)),r<=C+M))throw a},onSeparator:(h,C,M)=>{if(r<=C)throw a;if(h===":"&&c&&c.type==="property")c.colonOffset=C,o=!1,c=void 0;else if(h===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(o=!0,i[i.length-1]=""),c=void 0}}})}catch(h){if(h!==a)throw h}return{path:i,previousNode:c,isAtPropertyKey:o,matches:h=>{let C=0;for(let M=0;C<h.length&&M<i.length;M++)if(h[C]===i[M]||h[C]==="*")C++;else if(h[C]!=="**")return!1;return C===h.length}}}e.getLocation=I;function v(t,r=[],i=T.DEFAULT){let a=null,c=[];const s=[];function o(h){Array.isArray(c)?c.push(h):a!==null&&(c[a]=h)}return w(t,{onObjectBegin:()=>{const h={};o(h),s.push(c),c=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{const h=[];o(h),s.push(c),c=h,a=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:o,onError:(h,C,M)=>{r.push({error:h,offset:C,length:M})}},i),c[0]}e.parse=v;function y(t,r=[],i=T.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function s(h){return a.children.push(h),h}w(t,{onObjectBegin:h=>{a=s({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,C,M)=>{a=s({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:C,length:M,parent:a})},onObjectEnd:(h,C)=>{a.length=h+C-a.offset,a=a.parent,c(h+C)},onArrayBegin:(h,C)=>{a=s({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,C)=>{a.length=h+C-a.offset,a=a.parent,c(h+C)},onLiteralValue:(h,C,M)=>{s({type:u(h),offset:C,length:M,parent:a,value:h}),c(C+M)},onSeparator:(h,C,M)=>{a.type==="property"&&(h===":"?a.colonOffset=C:h===","&&c(C))},onError:(h,C,M)=>{r.push({error:h,offset:C,length:M})}},i);const l=a.children[0];return l&&delete l.parent,l}e.parseTree=y;function m(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===a){i=s.children[1],c=!0;break}if(!c)return}else{const c=a;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=m;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=p;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=f(a))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function d(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=d;function S(t,r,i=!1){if(d(t,r,i)){const a=t.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=r;c++){const s=S(a[c],r,i);if(s)return s}return t}}e.findNodeAtOffset=S;function w(t,r,i=T.DEFAULT){const a=A(t,!1);function c(Q){return Q?()=>Q(a.getTokenOffset(),a.getTokenLength()):()=>!0}function s(Q){return Q?Z=>Q(Z,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=c(r.onObjectBegin),l=s(r.onObjectProperty),h=c(r.onObjectEnd),C=c(r.onArrayBegin),M=c(r.onArrayEnd),O=s(r.onLiteralValue),U=s(r.onSeparator),k=c(r.onComment),F=s(r.onError),_=i&&i.disallowComments,$=i&&i.allowTrailingComma;function H(){for(;;){const Q=a.scan();switch(a.getTokenError()){case 4:ne(14);break;case 5:ne(15);break;case 3:ne(13);break;case 1:_||ne(11);break;case 2:ne(12);break;case 6:ne(16);break}switch(Q){case 12:case 13:_?ne(10):k();break;case 16:ne(1);break;case 15:case 14:break;default:return Q}}}function ne(Q,Z=[],q=[]){if(F(Q),Z.length+q.length>0){let B=a.getToken();for(;B!==17;){if(Z.indexOf(B)!==-1){H();break}else if(q.indexOf(B)!==-1)break;B=H()}}}function K(Q){const Z=a.getTokenValue();return Q?O(Z):l(Z),H(),!0}function N(){switch(a.getToken()){case 11:{let Q=0;try{Q=JSON.parse(a.getTokenValue()),typeof Q!="number"&&(ne(2),Q=0)}catch{ne(2)}O(Q);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function W(){return a.getToken()!==10?(ne(3,[],[2,5]),!1):(K(!1),a.getToken()===6?(U(":"),H(),G()||ne(4,[],[2,5])):ne(5,[],[2,5]),!0)}function x(){o(),H();let Q=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(Q||ne(4,[],[]),U(","),H(),a.getToken()===2&&$)break}else Q&&ne(6,[],[]);W()||ne(4,[],[2,5]),Q=!0}return h(),a.getToken()!==2?ne(7,[2],[]):H(),!0}function J(){C(),H();let Q=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(Q||ne(4,[],[]),U(","),H(),a.getToken()===4&&$)break}else Q&&ne(6,[],[]);G()||ne(4,[],[4,5]),Q=!0}return M(),a.getToken()!==4?ne(8,[4],[]):H(),!0}function G(){switch(a.getToken()){case 3:return J();case 1:return x();case 10:return K(!0);default:return N()}}return H(),a.getToken()===17?i.allowEmptyContent?!0:(ne(4,[],[]),!1):G()?(a.getToken()!==17&&ne(9,[],[]),!0):(ne(4,[],[]),!1)}e.visit=w;function g(t,r){let i=A(t),a=[],c,s=0,o;do switch(o=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:s!==o&&a.push(t.substring(s,o)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),s=i.getPosition();break}while(c!==17);return a.join("")}e.stripComments=g;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(re[50],se([0,1,33]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(b,R,I){let v,y,m,p,f;if(R){for(p=R.offset,f=p+R.length,m=p;m>0&&!E(b,m-1);)m--;let o=f;for(;o<b.length&&!E(b,o);)o++;y=b.substring(m,o),v=A(y,I)}else y=b,v=0,m=0,p=0,f=b.length;const d=P(I,b);let S=!1,w=0,g;I.insertSpaces?g=T(" ",I.tabSize||4):g="	";const u=(0,D.createScanner)(y,!1);let t=!1;function r(){return d+T(g,v+w)}function i(){let o=u.scan();for(S=!1;o===15||o===14;)S=S||o===14,o=u.scan();return t=o===16||u.getTokenError()!==0,o}const a=[];function c(o,l,h){!t&&l<f&&h>p&&b.substring(l,h)!==o&&a.push({offset:l,length:h-l,content:o})}let s=i();if(s!==17){const o=u.getTokenOffset()+m,l=T(g,v);c(l,m,o)}for(;s!==17;){let o=u.getTokenOffset()+u.getTokenLength()+m,l=i(),h="";for(;!S&&(l===12||l===13);){const M=u.getTokenOffset()+m;c(" ",o,M),o=u.getTokenOffset()+u.getTokenLength()+m,h=l===12?r():"",l=i()}if(l===2)s!==1&&(w--,h=r());else if(l===4)s!==3&&(w--,h=r());else{switch(s){case 3:case 1:w++,h=r();break;case 5:case 12:h=r();break;case 13:S?h=r():h=" ";break;case 6:h=" ";break;case 10:if(l===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?h=" ":l!==5&&l!==17&&(t=!0);break;case 16:t=!0;break}S&&(l===12||l===13)&&(h=r())}const C=u.getTokenOffset()+m;c(h,o,C),s=l}return a}e.format=n;function L(b,R){const I=JSON.stringify(b,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?I.replace(/\r\n|\r|\n/g,R.eol):I}e.toFormattedString=L;function T(b,R){let I="";for(let v=0;v<R;v++)I+=b;return I}function A(b,R){let I=0,v=0;const y=R.tabSize||4;for(;I<b.length;){const m=b.charAt(I);if(m===" ")v++;else if(m==="	")v+=y;else break;I++}return Math.floor(v/y)}function P(b,R){for(let I=0;I<R.length;I++){const v=R.charAt(I);if(v==="\r")return I+1<R.length&&R.charAt(I+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=P;function E(b,R){return`\r
`.indexOf(b.charAt(R))!==-1}e.isEOL=E}),define(re[73],se([0,1,33,50]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(b,R,I){return T(b,R,void 0,I)}e.removeProperty=L;function T(b,R,I,v,y){const m=R.slice(),p=[],f=(0,D.parseTree)(b,p);let d,S;for(;m.length>0&&(S=m.pop(),d=(0,D.findNodeAtLocation)(f,m),d===void 0&&I!==void 0);)typeof S=="string"?I={[S]:I}:I=[I];if(d)if(d.type==="object"&&typeof S=="string"&&Array.isArray(d.children)){const w=(0,D.findNodeAtLocation)(d,[S]);if(w!==void 0)if(I===void 0){if(!w.parent)throw new Error("Malformed AST");const g=d.children.indexOf(w.parent);let u,t=w.parent.offset+w.parent.length;if(g>0){const r=d.children[g-1];u=r.offset+r.length}else u=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return A(b,{offset:u,length:t-u,content:""},v)}else return A(b,{offset:w.offset,length:w.length,content:JSON.stringify(I)},v);else{if(I===void 0)return[];const g=`${JSON.stringify(S)}: ${JSON.stringify(I)}`,u=y?y(d.children.map(r=>r.children[0].value)):d.children.length;let t;if(u>0){const r=d.children[u-1];t={offset:r.offset+r.length,length:0,content:","+g}}else d.children.length===0?t={offset:d.offset+1,length:0,content:g}:t={offset:d.offset+1,length:0,content:g+","};return A(b,t,v)}}else if(d.type==="array"&&typeof S=="number"&&Array.isArray(d.children))if(I!==void 0){const w=`${JSON.stringify(I)}`;let g;if(d.children.length===0||S===0)g={offset:d.offset+1,length:0,content:d.children.length===0?w:w+","};else{const u=S===-1||S>d.children.length?d.children.length:S,t=d.children[u-1];g={offset:t.offset+t.length,length:0,content:","+w}}return A(b,g,v)}else{const w=S,g=d.children[w];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===w){const t=d.children[w-1],r=t.offset+t.length,i=d.offset+d.length;u={offset:r,length:i-2-r,content:""}}else u={offset:g.offset,length:d.children[w+1].offset-g.offset,content:""};return A(b,u,v)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${d.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(b,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(I)},v)}}e.setProperty=T;function A(b,R,I){let v=P(b,R),y=R.offset,m=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;y>0&&!(0,n.isEOL)(v,y-1);)y--;for(;m<v.length&&!(0,n.isEOL)(v,m);)m++}const p=(0,n.format)(v,{offset:y,length:m-y},I);for(let d=p.length-1;d>=0;d--){const S=p[d];v=P(v,S),y=Math.min(y,S.offset),m=Math.max(m,S.offset+S.length),m+=S.content.length-S.length}const f=b.length-(v.length-m)-y;return[{offset:y,length:f,content:v.substring(y,m)}]}e.withFormatting=A;function P(b,R){return b.substring(0,R.offset)+R.content+b.substring(R.offset+R.length)}e.applyEdit=P;function E(b,R){let I=R.slice(0).sort((y,m)=>{const p=y.offset-m.offset;return p===0?y.length-m.length:p}),v=b.length;for(let y=I.length-1;y>=0;y--){let m=I[y];if(m.offset+m.length<=v)b=P(b,m);else throw new Error("Overlapping edit");v=m.offset}return b}e.applyEdits=E}),define(re[108],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(re[2],se([0,1,72,49]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let T=null;function A(c){T=c}if(e.setDisposableTracker=A,L){const c="__is_disposable_tracked__";A(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[c]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==S.None)try{s[c]=!0}catch{}}markAsDisposed(s){if(s&&s!==S.None)try{s[c]=!0}catch{}}markAsSingleton(s){}})}function P(c){return T?.trackDisposable(c),c}function E(c){T?.markAsDisposed(c)}function b(c,s){T?.setParent(c,s)}function R(c,s){if(!!T)for(const o of c)T.setParent(o,s)}function I(c){return T?.markAsSingleton(c),c}e.markAsSingleton=I;class v extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=v;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function m(c){if(n.Iterable.is(c)){let s=[];for(const o of c)if(o)try{o.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new v(s);return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=m;function p(...c){const s=f(()=>m(c));return R(c,s),s}e.combinedDisposable=p;function f(c){const s=P({dispose:(0,D.once)(()=>{E(s),c()})});return s}e.toDisposable=f;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new d,P(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=w;class g{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=g;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(s){let o=s;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,E(this))},this}}e.SafeDisposable=u;class t{constructor(){this.references=new Map}acquire(s,...o){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,l));const{object:h}=l,C=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:h,dispose:C}}}e.ReferenceCollection=t;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const l=this.referenceCollection.acquire(s,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(h){throw l.dispose(),h}}}e.AsyncReferenceCollection=r;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function a(c){const s=new d;try{c(s)}finally{s.dispose()}}e.disposeOnReturn=a}),define(re[109],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const A=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(A){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function X(L){const T=[];typeof L=="number"&&T.push("code/timeOrigin",L);function A(E){T.push(E,Date.now())}function P(){const E=[];for(let b=0;b<T.length;b+=2)E.push({name:T[b],startTime:T[b+1]});return E}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(L+A.startTime)});return T}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(re[4],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const D="en";let n=!1,L=!1,T=!1,A=!1,P=!1,E=!1,b=!1,R=!1,I=!1,v,y=D,m,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const d=typeof f?.versions?.electron=="string",S=d&&f?.type==="renderer";if(typeof navigator=="object"&&!S)p=navigator.userAgent,n=p.indexOf("Windows")>=0,L=p.indexOf("Macintosh")>=0,R=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=p.indexOf("Linux")>=0,E=!0,v=navigator.language,y=v;else if(typeof f=="object"){n=f.platform==="win32",L=f.platform==="darwin",T=f.platform==="linux",A=T&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,b=d,I=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=D,y=D;const s=f.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),l=o.availableLanguages["*"];v=o.locale,y=l||D,m=o._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let u=0;L?u=1:n?u=3:T&&(u=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=A,e.isNative=P,e.isElectron=b,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isCI=I,e.platform=u,e.userAgent=p,e.language=y;var t;(function(s){function o(){return e.language}s.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function h(){return e.language==="en"}s.isDefault=h})(t=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let s=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let h=0,C=s.length;h<C;h++){const M=s[h];if(M.id===l.data.vscodeScheduleAsyncWork){s.splice(h,1),M.callback();return}}});let o=0;return l=>{const h=++o;s.push({id:h,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||R?2:n?1:3;let i=!0,a=!1;function c(){if(!a){a=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,i=new Uint16Array(s.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[34],se([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(re[10],se([0,1,34]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,T=90,A=122,P=46,E=47,b=92,R=58,I=63;class v extends Error{constructor(g,u,t){let r;typeof u=="string"&&u.indexOf("not ")===0?(r="must not be",u=u.replace(/^not /,"")):r="must be";const i=g.indexOf(".")!==-1?"property":"argument";let a=`The "${g}" ${i} ${r} of type ${u}`;a+=`. Received type ${typeof t}`;super(a);this.code="ERR_INVALID_ARG_TYPE"}}function y(w,g){if(typeof w!="string")throw new v(g,"string",w)}function m(w){return w===E||w===b}function p(w){return w===E}function f(w){return w>=n&&w<=T||w>=L&&w<=A}function d(w,g,u,t){let r="",i=0,a=-1,c=0,s=0;for(let o=0;o<=w.length;++o){if(o<w.length)s=w.charCodeAt(o);else{if(t(s))break;s=E}if(t(s)){if(!(a===o-1||c===1))if(c===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const l=r.lastIndexOf(u);l===-1?(r="",i=0):(r=r.slice(0,l),i=r.length-1-r.lastIndexOf(u)),a=o,c=0;continue}else if(r.length!==0){r="",i=0,a=o,c=0;continue}}g&&(r+=r.length>0?`${u}..`:"..",i=2)}else r.length>0?r+=`${u}${w.slice(a+1,o)}`:r=w.slice(a+1,o),i=o-a-1;a=o,c=0}else s===P&&c!==-1?++c:c=-1}return r}function S(w,g){if(g===null||typeof g!="object")throw new v("pathObject","Object",g);const u=g.dir||g.root,t=g.base||`${g.name||""}${g.ext||""}`;return u?u===g.root?`${u}${t}`:`${u}${w}${t}`:t}e.win32={resolve(...w){let g="",u="",t=!1;for(let r=w.length-1;r>=-1;r--){let i;if(r>=0){if(i=w[r],y(i,"path"),i.length===0)continue}else g.length===0?i=D.cwd():(i=D.env[`=${g}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==g.toLowerCase()&&i.charCodeAt(2)===b)&&(i=`${g}\\`));const a=i.length;let c=0,s="",o=!1;const l=i.charCodeAt(0);if(a===1)m(l)&&(c=1,o=!0);else if(m(l))if(o=!0,m(i.charCodeAt(1))){let h=2,C=h;for(;h<a&&!m(i.charCodeAt(h));)h++;if(h<a&&h!==C){const M=i.slice(C,h);for(C=h;h<a&&m(i.charCodeAt(h));)h++;if(h<a&&h!==C){for(C=h;h<a&&!m(i.charCodeAt(h));)h++;(h===a||h!==C)&&(s=`\\\\${M}\\${i.slice(C,h)}`,c=h)}}}else c=1;else f(l)&&i.charCodeAt(1)===R&&(s=i.slice(0,2),c=2,a>2&&m(i.charCodeAt(2))&&(o=!0,c=3));if(s.length>0)if(g.length>0){if(s.toLowerCase()!==g.toLowerCase())continue}else g=s;if(t){if(g.length>0)break}else if(u=`${i.slice(c)}\\${u}`,t=o,o&&g.length>0)break}return u=d(u,!t,"\\",m),t?`${g}\\${u}`:`${g}${u}`||"."},normalize(w){y(w,"path");const g=w.length;if(g===0)return".";let u=0,t,r=!1;const i=w.charCodeAt(0);if(g===1)return p(i)?"\\":w;if(m(i))if(r=!0,m(w.charCodeAt(1))){let c=2,s=c;for(;c<g&&!m(w.charCodeAt(c));)c++;if(c<g&&c!==s){const o=w.slice(s,c);for(s=c;c<g&&m(w.charCodeAt(c));)c++;if(c<g&&c!==s){for(s=c;c<g&&!m(w.charCodeAt(c));)c++;if(c===g)return`\\\\${o}\\${w.slice(s)}\\`;c!==s&&(t=`\\\\${o}\\${w.slice(s,c)}`,u=c)}}}else u=1;else f(i)&&w.charCodeAt(1)===R&&(t=w.slice(0,2),u=2,g>2&&m(w.charCodeAt(2))&&(r=!0,u=3));let a=u<g?d(w.slice(u),!r,"\\",m):"";return a.length===0&&!r&&(a="."),a.length>0&&m(w.charCodeAt(g-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(w){y(w,"path");const g=w.length;if(g===0)return!1;const u=w.charCodeAt(0);return m(u)||g>2&&f(u)&&w.charCodeAt(1)===R&&m(w.charCodeAt(2))},join(...w){if(w.length===0)return".";let g,u;for(let i=0;i<w.length;++i){const a=w[i];y(a,"path"),a.length>0&&(g===void 0?g=u=a:g+=`\\${a}`)}if(g===void 0)return".";let t=!0,r=0;if(typeof u=="string"&&m(u.charCodeAt(0))){++r;const i=u.length;i>1&&m(u.charCodeAt(1))&&(++r,i>2&&(m(u.charCodeAt(2))?++r:t=!1))}if(t){for(;r<g.length&&m(g.charCodeAt(r));)r++;r>=2&&(g=`\\${g.slice(r)}`)}return e.win32.normalize(g)},relative(w,g){if(y(w,"from"),y(g,"to"),w===g)return"";const u=e.win32.resolve(w),t=e.win32.resolve(g);if(u===t||(w=u.toLowerCase(),g=t.toLowerCase(),w===g))return"";let r=0;for(;r<w.length&&w.charCodeAt(r)===b;)r++;let i=w.length;for(;i-1>r&&w.charCodeAt(i-1)===b;)i--;const a=i-r;let c=0;for(;c<g.length&&g.charCodeAt(c)===b;)c++;let s=g.length;for(;s-1>c&&g.charCodeAt(s-1)===b;)s--;const o=s-c,l=a<o?a:o;let h=-1,C=0;for(;C<l;C++){const O=w.charCodeAt(r+C);if(O!==g.charCodeAt(c+C))break;O===b&&(h=C)}if(C!==l){if(h===-1)return t}else{if(o>l){if(g.charCodeAt(c+C)===b)return t.slice(c+C+1);if(C===2)return t.slice(c+C)}a>l&&(w.charCodeAt(r+C)===b?h=C:C===2&&(h=3)),h===-1&&(h=0)}let M="";for(C=r+h+1;C<=i;++C)(C===i||w.charCodeAt(C)===b)&&(M+=M.length===0?"..":"\\..");return c+=h,M.length>0?`${M}${t.slice(c,s)}`:(t.charCodeAt(c)===b&&++c,t.slice(c,s))},toNamespacedPath(w){if(typeof w!="string")return w;if(w.length===0)return"";const g=e.win32.resolve(w);if(g.length<=2)return w;if(g.charCodeAt(0)===b){if(g.charCodeAt(1)===b){const u=g.charCodeAt(2);if(u!==I&&u!==P)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(f(g.charCodeAt(0))&&g.charCodeAt(1)===R&&g.charCodeAt(2)===b)return`\\\\?\\${g}`;return w},dirname(w){y(w,"path");const g=w.length;if(g===0)return".";let u=-1,t=0;const r=w.charCodeAt(0);if(g===1)return m(r)?w:".";if(m(r)){if(u=t=1,m(w.charCodeAt(1))){let c=2,s=c;for(;c<g&&!m(w.charCodeAt(c));)c++;if(c<g&&c!==s){for(s=c;c<g&&m(w.charCodeAt(c));)c++;if(c<g&&c!==s){for(s=c;c<g&&!m(w.charCodeAt(c));)c++;if(c===g)return w;c!==s&&(u=t=c+1)}}}}else f(r)&&w.charCodeAt(1)===R&&(u=g>2&&m(w.charCodeAt(2))?3:2,t=u);let i=-1,a=!0;for(let c=g-1;c>=t;--c)if(m(w.charCodeAt(c))){if(!a){i=c;break}}else a=!1;if(i===-1){if(u===-1)return".";i=u}return w.slice(0,i)},basename(w,g){g!==void 0&&y(g,"ext"),y(w,"path");let u=0,t=-1,r=!0,i;if(w.length>=2&&f(w.charCodeAt(0))&&w.charCodeAt(1)===R&&(u=2),g!==void 0&&g.length>0&&g.length<=w.length){if(g===w)return"";let a=g.length-1,c=-1;for(i=w.length-1;i>=u;--i){const s=w.charCodeAt(i);if(m(s)){if(!r){u=i+1;break}}else c===-1&&(r=!1,c=i+1),a>=0&&(s===g.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=c))}return u===t?t=c:t===-1&&(t=w.length),w.slice(u,t)}for(i=w.length-1;i>=u;--i)if(m(w.charCodeAt(i))){if(!r){u=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":w.slice(u,t)},extname(w){y(w,"path");let g=0,u=-1,t=0,r=-1,i=!0,a=0;w.length>=2&&w.charCodeAt(1)===R&&f(w.charCodeAt(0))&&(g=t=2);for(let c=w.length-1;c>=g;--c){const s=w.charCodeAt(c);if(m(s)){if(!i){t=c+1;break}continue}r===-1&&(i=!1,r=c+1),s===P?u===-1?u=c:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||r===-1||a===0||a===1&&u===r-1&&u===t+1?"":w.slice(u,r)},format:S.bind(null,"\\"),parse(w){y(w,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return g;const u=w.length;let t=0,r=w.charCodeAt(0);if(u===1)return m(r)?(g.root=g.dir=w,g):(g.base=g.name=w,g);if(m(r)){if(t=1,m(w.charCodeAt(1))){let h=2,C=h;for(;h<u&&!m(w.charCodeAt(h));)h++;if(h<u&&h!==C){for(C=h;h<u&&m(w.charCodeAt(h));)h++;if(h<u&&h!==C){for(C=h;h<u&&!m(w.charCodeAt(h));)h++;h===u?t=h:h!==C&&(t=h+1)}}}}else if(f(r)&&w.charCodeAt(1)===R){if(u<=2)return g.root=g.dir=w,g;if(t=2,m(w.charCodeAt(2))){if(u===3)return g.root=g.dir=w,g;t=3}}t>0&&(g.root=w.slice(0,t));let i=-1,a=t,c=-1,s=!0,o=w.length-1,l=0;for(;o>=t;--o){if(r=w.charCodeAt(o),m(r)){if(!s){a=o+1;break}continue}c===-1&&(s=!1,c=o+1),r===P?i===-1?i=o:l!==1&&(l=1):i!==-1&&(l=-1)}return c!==-1&&(i===-1||l===0||l===1&&i===c-1&&i===a+1?g.base=g.name=w.slice(a,c):(g.name=w.slice(a,i),g.base=w.slice(a,c),g.ext=w.slice(i,c))),a>0&&a!==t?g.dir=w.slice(0,a-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...w){let g="",u=!1;for(let t=w.length-1;t>=-1&&!u;t--){const r=t>=0?w[t]:D.cwd();y(r,"path"),r.length!==0&&(g=`${r}/${g}`,u=r.charCodeAt(0)===E)}return g=d(g,!u,"/",p),u?`/${g}`:g.length>0?g:"."},normalize(w){if(y(w,"path"),w.length===0)return".";const g=w.charCodeAt(0)===E,u=w.charCodeAt(w.length-1)===E;return w=d(w,!g,"/",p),w.length===0?g?"/":u?"./":".":(u&&(w+="/"),g?`/${w}`:w)},isAbsolute(w){return y(w,"path"),w.length>0&&w.charCodeAt(0)===E},join(...w){if(w.length===0)return".";let g;for(let u=0;u<w.length;++u){const t=w[u];y(t,"path"),t.length>0&&(g===void 0?g=t:g+=`/${t}`)}return g===void 0?".":e.posix.normalize(g)},relative(w,g){if(y(w,"from"),y(g,"to"),w===g||(w=e.posix.resolve(w),g=e.posix.resolve(g),w===g))return"";const u=1,t=w.length,r=t-u,i=1,a=g.length-i,c=r<a?r:a;let s=-1,o=0;for(;o<c;o++){const h=w.charCodeAt(u+o);if(h!==g.charCodeAt(i+o))break;h===E&&(s=o)}if(o===c)if(a>c){if(g.charCodeAt(i+o)===E)return g.slice(i+o+1);if(o===0)return g.slice(i+o)}else r>c&&(w.charCodeAt(u+o)===E?s=o:o===0&&(s=0));let l="";for(o=u+s+1;o<=t;++o)(o===t||w.charCodeAt(o)===E)&&(l+=l.length===0?"..":"/..");return`${l}${g.slice(i+s)}`},toNamespacedPath(w){return w},dirname(w){if(y(w,"path"),w.length===0)return".";const g=w.charCodeAt(0)===E;let u=-1,t=!0;for(let r=w.length-1;r>=1;--r)if(w.charCodeAt(r)===E){if(!t){u=r;break}}else t=!1;return u===-1?g?"/":".":g&&u===1?"//":w.slice(0,u)},basename(w,g){g!==void 0&&y(g,"ext"),y(w,"path");let u=0,t=-1,r=!0,i;if(g!==void 0&&g.length>0&&g.length<=w.length){if(g===w)return"";let a=g.length-1,c=-1;for(i=w.length-1;i>=0;--i){const s=w.charCodeAt(i);if(s===E){if(!r){u=i+1;break}}else c===-1&&(r=!1,c=i+1),a>=0&&(s===g.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=c))}return u===t?t=c:t===-1&&(t=w.length),w.slice(u,t)}for(i=w.length-1;i>=0;--i)if(w.charCodeAt(i)===E){if(!r){u=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":w.slice(u,t)},extname(w){y(w,"path");let g=-1,u=0,t=-1,r=!0,i=0;for(let a=w.length-1;a>=0;--a){const c=w.charCodeAt(a);if(c===E){if(!r){u=a+1;break}continue}t===-1&&(r=!1,t=a+1),c===P?g===-1?g=a:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||t===-1||i===0||i===1&&g===t-1&&g===u+1?"":w.slice(g,t)},format:S.bind(null,"/"),parse(w){y(w,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(w.length===0)return g;const u=w.charCodeAt(0)===E;let t;u?(g.root="/",t=1):t=0;let r=-1,i=0,a=-1,c=!0,s=w.length-1,o=0;for(;s>=t;--s){const l=w.charCodeAt(s);if(l===E){if(!c){i=s+1;break}continue}a===-1&&(c=!1,a=s+1),l===P?r===-1?r=s:o!==1&&(o=1):r!==-1&&(o=-1)}if(a!==-1){const l=i===0&&u?1:i;r===-1||o===0||o===1&&r===a-1&&r===i+1?g.base=g.name=w.slice(l,a):(g.name=w.slice(l,r),g.base=w.slice(l,a),g.ext=w.slice(r,a))}return i>0?g.dir=w.slice(0,i-1):u&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[110],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(I){I.text="text/plain",I.binary="application/octet-stream",I.unknown="application/unknown",I.markdown="text/markdown",I.latex="text/latex",I.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const v=(0,D.extname)(I),y=L[v.toLowerCase()];return y!==void 0?y:P(I)}e.getMediaOrTextMime=A;function P(I){const v=(0,D.extname)(I);return T[v.toLowerCase()]}e.getMediaMime=P;function E(I){for(const v in T)if(T[v]===I)return v}e.getExtensionForMimeType=E;const b=/^(.+)\/(.+?)(;.+)?$/;function R(I,v){const y=b.exec(I);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:v?void 0:I}e.normalizeMimeType=R}),define(re[74],se([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var L;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(P,...E){const b=E.reduce((v,y)=>(v[y]=!0,v),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!b[v]).forEach(v=>{for(let y=0;y<R.length;y++)if(v.search(R[y])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=T;function A(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:X)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return X[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=X,D.c=e,D.d=function(n,L,T){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:T})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var A in n)D.d(T,A,function(P){return n[P]}.bind(null,A));return T},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(X,e,D){(function(n){var L;e=X.exports=q,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],b=0,R=b++;E[R]="0|[1-9]\\d*";var I=b++;E[I]="[0-9]+";var v=b++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;E[y]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var m=b++;E[m]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=b++;E[p]="(?:"+E[R]+"|"+E[v]+")";var f=b++;E[f]="(?:"+E[I]+"|"+E[v]+")";var d=b++;E[d]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var S=b++;E[S]="(?:-?("+E[f]+"(?:\\."+E[f]+")*))";var w=b++;E[w]="[0-9A-Za-z-]+";var g=b++;E[g]="(?:\\+("+E[w]+"(?:\\."+E[w]+")*))";var u=b++,t="v?"+E[y]+E[d]+"?"+E[g]+"?";E[u]="^"+t+"$";var r="[v=\\s]*"+E[m]+E[S]+"?"+E[g]+"?",i=b++;E[i]="^"+r+"$";var a=b++;E[a]="((?:<|>)?=?)";var c=b++;E[c]=E[I]+"|x|X|\\*";var s=b++;E[s]=E[R]+"|x|X|\\*";var o=b++;E[o]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[d]+")?"+E[g]+"?)?)?";var l=b++;E[l]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[S]+")?"+E[g]+"?)?)?";var h=b++;E[h]="^"+E[a]+"\\s*"+E[o]+"$";var C=b++;E[C]="^"+E[a]+"\\s*"+E[l]+"$";var M=b++;E[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;E[O]="(?:~>?)";var U=b++;E[U]="(\\s*)"+E[O]+"\\s+",P[U]=new RegExp(E[U],"g");var k=b++;E[k]="^"+E[O]+E[o]+"$";var F=b++;E[F]="^"+E[O]+E[l]+"$";var _=b++;E[_]="(?:\\^)";var $=b++;E[$]="(\\s*)"+E[_]+"\\s+",P[$]=new RegExp(E[$],"g");var H=b++;E[H]="^"+E[_]+E[o]+"$";var ne=b++;E[ne]="^"+E[_]+E[l]+"$";var K=b++;E[K]="^"+E[a]+"\\s*("+r+")$|^$";var N=b++;E[N]="^"+E[a]+"\\s*("+t+")$|^$";var W=b++;E[W]="(\\s*)"+E[a]+"\\s*("+r+"|"+E[o]+")",P[W]=new RegExp(E[W],"g");var x=b++;E[x]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var J=b++;E[J]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var G=b++;E[G]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)L(Q,E[Q]),P[Q]||(P[Q]=new RegExp(E[Q]));function Z(oe,le){if(oe instanceof q)return oe;if(typeof oe!="string"||oe.length>T||!(le?P[i]:P[u]).test(oe))return null;try{return new q(oe,le)}catch{return null}}function q(oe,le){if(oe instanceof q){if(oe.loose===le)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof q))return new q(oe,le);L("SemVer",oe,le),this.loose=le;var ue=oe.trim().match(le?P[i]:P[u]);if(!ue)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<A)return Ie}return be}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Z,e.valid=function(oe,le){var ue=Z(oe,le);return ue?ue.version:null},e.clean=function(oe,le){var ue=Z(oe.trim().replace(/^[=v]+/,""),le);return ue?ue.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(oe){return L("SemVer.compare",this.version,this.loose,oe),oe instanceof q||(oe=new q(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},q.prototype.compareMain=function(oe){return oe instanceof q||(oe=new q(oe,this.loose)),j(this.major,oe.major)||j(this.minor,oe.minor)||j(this.patch,oe.patch)},q.prototype.comparePre=function(oe){if(oe instanceof q||(oe=new q(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var le=0;do{var ue=this.prerelease[le],be=oe.prerelease[le];if(L("prerelease compare",le,ue,be),ue===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ue===void 0)return-1;if(ue!==be)return j(ue,be)}while(++le)},q.prototype.inc=function(oe,le){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,le,ue,be){typeof ue=="string"&&(be=ue,ue=void 0);try{return new q(oe,ue).inc(le,be).version}catch{return null}},e.diff=function(oe,le){if(ie(oe,le))return null;var ue=Z(oe),be=Z(le);if(ue.prerelease.length||be.prerelease.length){for(var Ie in ue)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ue[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ue)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ue[Ie]!==be[Ie])return Ie},e.compareIdentifiers=j;var B=/^[0-9]+$/;function j(oe,le){var ue=B.test(oe),be=B.test(le);return ue&&be&&(oe=+oe,le=+le),ue&&!be?-1:be&&!ue?1:oe<le?-1:oe>le?1:0}function z(oe,le,ue){return new q(oe,ue).compare(new q(le,ue))}function V(oe,le,ue){return z(oe,le,ue)>0}function ee(oe,le,ue){return z(oe,le,ue)<0}function ie(oe,le,ue){return z(oe,le,ue)===0}function ae(oe,le,ue){return z(oe,le,ue)!==0}function fe(oe,le,ue){return z(oe,le,ue)>=0}function pe(oe,le,ue){return z(oe,le,ue)<=0}function we(oe,le,ue,be){var Ie;switch(le){case"===":typeof oe=="object"&&(oe=oe.version),typeof ue=="object"&&(ue=ue.version),Ie=oe===ue;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ue=="object"&&(ue=ue.version),Ie=oe!==ue;break;case"":case"=":case"==":Ie=ie(oe,ue,be);break;case"!=":Ie=ae(oe,ue,be);break;case">":Ie=V(oe,ue,be);break;case">=":Ie=fe(oe,ue,be);break;case"<":Ie=ee(oe,ue,be);break;case"<=":Ie=pe(oe,ue,be);break;default:throw new TypeError("Invalid operator: "+le)}return Ie}function ge(oe,le){if(oe instanceof ge){if(oe.loose===le)return oe;oe=oe.value}if(!(this instanceof ge))return new ge(oe,le);L("comparator",oe,le),this.loose=le,this.parse(oe),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(oe,le){return j(le,oe)},e.major=function(oe,le){return new q(oe,le).major},e.minor=function(oe,le){return new q(oe,le).minor},e.patch=function(oe,le){return new q(oe,le).patch},e.compare=z,e.compareLoose=function(oe,le){return z(oe,le,!0)},e.rcompare=function(oe,le,ue){return z(le,oe,ue)},e.sort=function(oe,le){return oe.sort(function(ue,be){return e.compare(ue,be,le)})},e.rsort=function(oe,le){return oe.sort(function(ue,be){return e.rcompare(ue,be,le)})},e.gt=V,e.lt=ee,e.eq=ie,e.neq=ae,e.gte=fe,e.lte=pe,e.cmp=we,e.Comparator=ge;var Ee={};function Ce(oe,le){if(oe instanceof Ce)return oe.loose===le?oe:new Ce(oe.raw,le);if(oe instanceof ge)return new Ce(oe.value,le);if(!(this instanceof Ce))return new Ce(oe,le);if(this.loose=le,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Re(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function _e(oe,le,ue,be,Ie,Ue,Le,Fe,Ae,Oe,te,ce,he){return((le=Re(ue)?"":Re(be)?">="+ue+".0.0":Re(Ie)?">="+ue+"."+be+".0":">="+le)+" "+(Fe=Re(Ae)?"":Re(Oe)?"<"+(+Ae+1)+".0.0":Re(te)?"<"+Ae+"."+(+Oe+1)+".0":ce?"<="+Ae+"."+Oe+"."+te+"-"+ce:"<="+Fe)).trim()}function je(oe,le){for(var ue=0;ue<oe.length;ue++)if(!oe[ue].test(le))return!1;if(le.prerelease.length){for(ue=0;ue<oe.length;ue++)if(L(oe[ue].semver),oe[ue].semver!==Ee&&oe[ue].semver.prerelease.length>0){var be=oe[ue].semver;if(be.major===le.major&&be.minor===le.minor&&be.patch===le.patch)return!0}return!1}return!0}function Ge(oe,le,ue){try{le=new Ce(le,ue)}catch{return!1}return le.test(oe)}function Ke(oe,le,ue,be){var Ie,Ue,Le,Fe,Ae;switch(oe=new q(oe,be),le=new Ce(le,be),ue){case">":Ie=V,Ue=pe,Le=ee,Fe=">",Ae=">=";break;case"<":Ie=ee,Ue=fe,Le=V,Fe="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ge(oe,le,be))return!1;for(var Oe=0;Oe<le.set.length;++Oe){var te=le.set[Oe],ce=null,he=null;if(te.forEach(function(me){me.semver===Ee&&(me=new ge(">=0.0.0")),ce=ce||me,he=he||me,Ie(me.semver,ce.semver,be)?ce=me:Le(me.semver,he.semver,be)&&(he=me)}),ce.operator===Fe||ce.operator===Ae||(!he.operator||he.operator===Fe)&&Ue(oe,he.semver)||he.operator===Ae&&Le(oe,he.semver))return!1}return!0}ge.prototype.parse=function(oe){var le=this.loose?P[K]:P[N],ue=oe.match(le);if(!ue)throw new TypeError("Invalid comparator: "+oe);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new q(ue[2],this.loose):this.semver=Ee},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(oe){return L("Comparator.test",oe,this.loose),this.semver===Ee||(typeof oe=="string"&&(oe=new q(oe,this.loose)),we(oe,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(oe,le){if(!(oe instanceof ge))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ce(oe.value,le),Ge(this.value,ue,le);if(oe.operator==="")return ue=new Ce(this.value,le),Ge(oe.semver,ue,le);var be=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Ue=this.semver.version===oe.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Fe=we(this.semver,"<",oe.semver,le)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ae=we(this.semver,">",oe.semver,le)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return be||Ie||Ue&&Le||Fe||Ae},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(oe){var le=this.loose;oe=oe.trim(),L("range",oe,le);var ue=le?P[J]:P[x];oe=oe.replace(ue,_e),L("hyphen replace",oe),oe=oe.replace(P[W],"$1$2$3"),L("comparator trim",oe,P[W]),oe=(oe=(oe=oe.replace(P[U],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var be=le?P[K]:P[N],Ie=oe.split(" ").map(function(Ue){return function(Le,Fe){return L("comp",Le),Le=function(Ae,Oe){return Ae.trim().split(/\s+/).map(function(te){return function(ce,he){L("caret",ce,he);var me=he?P[ne]:P[H];return ce.replace(me,function(ye,ve,Pe,ke,Te){var De;return L("caret",ce,ye,ve,Pe,ke,Te),Re(ve)?De="":Re(Pe)?De=">="+ve+".0.0 <"+(+ve+1)+".0.0":Re(ke)?De=ve==="0"?">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+".0 <"+(+ve+1)+".0.0":Te?(L("replaceCaret pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),De=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+ke+Te+" <"+ve+"."+Pe+"."+(+ke+1):">="+ve+"."+Pe+"."+ke+Te+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+ke+Te+" <"+(+ve+1)+".0.0"):(L("no pr"),De=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+ke+" <"+ve+"."+Pe+"."+(+ke+1):">="+ve+"."+Pe+"."+ke+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+ke+" <"+(+ve+1)+".0.0"),L("caret return",De),De})}(te,Oe)}).join(" ")}(Le,Fe),L("caret",Le),Le=function(Ae,Oe){return Ae.trim().split(/\s+/).map(function(te){return function(ce,he){var me=he?P[F]:P[k];return ce.replace(me,function(ye,ve,Pe,ke,Te){var De;return L("tilde",ce,ye,ve,Pe,ke,Te),Re(ve)?De="":Re(Pe)?De=">="+ve+".0.0 <"+(+ve+1)+".0.0":Re(ke)?De=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":Te?(L("replaceTilde pr",Te),Te.charAt(0)!=="-"&&(Te="-"+Te),De=">="+ve+"."+Pe+"."+ke+Te+" <"+ve+"."+(+Pe+1)+".0"):De=">="+ve+"."+Pe+"."+ke+" <"+ve+"."+(+Pe+1)+".0",L("tilde return",De),De})}(te,Oe)}).join(" ")}(Le,Fe),L("tildes",Le),Le=function(Ae,Oe){return L("replaceXRanges",Ae,Oe),Ae.split(/\s+/).map(function(te){return function(ce,he){ce=ce.trim();var me=he?P[C]:P[h];return ce.replace(me,function(ye,ve,Pe,ke,Te,De){L("xRange",ce,ye,ve,Pe,ke,Te,De);var ze=Re(Pe),Ne=ze||Re(ke),qe=Ne||Re(Te);return ve==="="&&qe&&(ve=""),ze?ye=ve===">"||ve==="<"?"<0.0.0":"*":ve&&qe?(Ne&&(ke=0),qe&&(Te=0),ve===">"?(ve=">=",Ne?(Pe=+Pe+1,ke=0,Te=0):qe&&(ke=+ke+1,Te=0)):ve==="<="&&(ve="<",Ne?Pe=+Pe+1:ke=+ke+1),ye=ve+Pe+"."+ke+"."+Te):Ne?ye=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":qe&&(ye=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),L("xRange return",ye),ye})}(te,Oe)}).join(" ")}(Le,Fe),L("xrange",Le),Le=function(Ae,Oe){return L("replaceStars",Ae,Oe),Ae.trim().replace(P[G],"")}(Le,Fe),L("stars",Le),Le}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ue){return!!Ue.match(be)})),Ie=Ie.map(function(Ue){return new ge(Ue,le)})},Ce.prototype.intersects=function(oe,le){if(!(oe instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(be){return oe.set.some(function(Ie){return Ie.every(function(Ue){return be.intersects(Ue,le)})})})})},e.toComparators=function(oe,le){return new Ce(oe,le).set.map(function(ue){return ue.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new q(oe,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],oe))return!0;return!1},e.satisfies=Ge,e.maxSatisfying=function(oe,le,ue){var be=null,Ie=null;try{var Ue=new Ce(le,ue)}catch{return null}return oe.forEach(function(Le){Ue.test(Le)&&(be&&Ie.compare(Le)!==-1||(Ie=new q(be=Le,ue)))}),be},e.minSatisfying=function(oe,le,ue){var be=null,Ie=null;try{var Ue=new Ce(le,ue)}catch{return null}return oe.forEach(function(Le){Ue.test(Le)&&(be&&Ie.compare(Le)!==1||(Ie=new q(be=Le,ue)))}),be},e.validRange=function(oe,le){try{return new Ce(oe,le).range||"*"}catch{return null}},e.ltr=function(oe,le,ue){return Ke(oe,le,"<",ue)},e.gtr=function(oe,le,ue){return Ke(oe,le,">",ue)},e.outside=Ke,e.prerelease=function(oe,le){var ue=Z(oe,le);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(oe,le,ue){return oe=new Ce(oe,ue),le=new Ce(le,ue),oe.intersects(le)},e.coerce=function(oe){if(oe instanceof q)return oe;if(typeof oe!="string")return null;var le=oe.match(P[M]);return le==null?null:Z((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,D(1))},function(X,e){var D,n,L=X.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(f){if(D===setTimeout)return setTimeout(f,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var E,b=[],R=!1,I=-1;function v(){R&&E&&(R=!1,E.length?b=E.concat(b):I=-1,b.length&&y())}function y(){if(!R){var f=P(v);R=!0;for(var d=b.length;d;){for(E=b,b=[];++I<d;)E&&E[I].run();I=-1,d=b.length}E=null,R=!1,function(S){if(n===clearTimeout)return clearTimeout(S);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(S);try{n(S)}catch{try{return n.call(null,S)}catch{return n.call(this,S)}}}(f)}}function m(f,d){this.fun=f,this.array=d}function p(){}L.nextTick=function(f){var d=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)d[S-1]=arguments[S];b.push(new m(f,d)),b.length!==1||R||P(y)},m.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(re[111],se([0,1]),function(X,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(P,E,b){this.level=P,this.key=E,this.value=b,this.forward=[]}}const L=void 0;class T{constructor(P,E=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(P){return Boolean(T._search(this,P,this.comparator))}get(P){return T._search(this,P,this.comparator)?.value}set(P,E){return T._insert(this,P,E,this.comparator)&&(this._size+=1),this}delete(P){const E=T._delete(this,P,this.comparator);return E&&(this._size-=1),E}forEach(P,E){let b=this._header.forward[0];for(;b;)P.call(E,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",E=this._header.forward[0];for(;E;)P+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return P}static _search(P,E,b){let R=P._header;for(let I=P._level-1;I>=0;I--)for(;R.forward[I]&&b(R.forward[I].key,E)<0;)R=R.forward[I];if(R=R.forward[0],R&&b(R.key,E)===0)return R}static _insert(P,E,b,R){let I=[],v=P._header;for(let y=P._level-1;y>=0;y--){for(;v.forward[y]&&R(v.forward[y].key,E)<0;)v=v.forward[y];I[y]=v}if(v=v.forward[0],v&&R(v.key,E)===0)return v.value=b,!1;{let y=T._randomLevel(P);if(y>P._level){for(let m=P._level;m<y;m++)I[m]=P._header;P._level=y}v=new n(y,E,b);for(let m=0;m<y;m++)v.forward[m]=I[m].forward[m],I[m].forward[m]=v;return!0}}static _randomLevel(P,E=.5){let b=1;for(;Math.random()<E&&b<P._maxLevel;)b+=1;return b}static _delete(P,E,b){let R=[],I=P._header;for(let v=P._level-1;v>=0;v--){for(;I.forward[v]&&b(I.forward[v].key,E)<0;)I=I.forward[v];R[v]=I}if(I=I.forward[0],!I||b(I.key,E)!==0)return!1;for(let v=0;v<P._level&&R[v].forward[v]===I;v++)R[v].forward[v]=I.forward[v];for(;P._level>0&&P._header.forward[P._level-1]===L;)P._level-=1;return!0}}e.SkipList=T}),define(re[112],se([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new L(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(re[3],se([0,1,9,72,2,109,112]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let P=!1,E=!1;var b;(function(s){s.None=()=>L.Disposable.None;function o(Z){if(E){const{onListenerDidAdd:q}=Z,B=m.create();let j=0;Z.onListenerDidAdd=()=>{++j==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),q?.()}}}function l(Z){return(q,B=null,j)=>{let z=!1,V;return V=Z(ee=>{if(!z)return V?V.dispose():z=!0,q.call(B,ee)},null,j),z&&V.dispose(),V}}s.once=l;function h(Z,q,B){return F((j,z=null,V)=>Z(ee=>j.call(z,q(ee)),null,V),B)}s.map=h;function C(Z,q,B){return F((j,z=null,V)=>Z(ee=>{q(ee),j.call(z,ee)},null,V),B)}s.forEach=C;function M(Z,q,B){return F((j,z=null,V)=>Z(ee=>q(ee)&&j.call(z,ee),null,V),B)}s.filter=M;function O(Z){return Z}s.signal=O;function U(...Z){return(q,B=null,j)=>(0,L.combinedDisposable)(...Z.map(z=>z(V=>q.call(B,V),null,j)))}s.any=U;function k(Z,q,B,j){let z=B;return h(Z,V=>(z=q(z,V),z),j)}s.reduce=k;function F(Z,q){let B;const j={onFirstListenerAdd(){B=Z(z.fire,z)},onLastListenerRemove(){B.dispose()}};q||o(j);const z=new f(j);return q&&q.add(z),z.event}function _(Z,q,B=100,j=!1,z,V){let ee,ie,ae,fe=0;const pe={leakWarningThreshold:z,onFirstListenerAdd(){ee=Z(ge=>{fe++,ie=q(ie,ge),j&&!ae&&(we.fire(ie),ie=void 0),clearTimeout(ae),ae=setTimeout(()=>{const Ee=ie;ie=void 0,ae=void 0,(!j||fe>1)&&we.fire(Ee),fe=0},B)})},onLastListenerRemove(){ee.dispose()}};V||o(pe);const we=new f(pe);return V&&V.add(we),we.event}s.debounce=_;function $(Z,q=(j,z)=>j===z,B){let j=!0,z;return M(Z,V=>{const ee=j||!q(V,z);return j=!1,z=V,ee},B)}s.latch=$;function H(Z,q,B){return[s.filter(Z,q,B),s.filter(Z,j=>!q(j),B)]}s.split=H;function ne(Z,q=!1,B=[]){let j=B.slice(),z=Z(ie=>{j?j.push(ie):ee.fire(ie)});const V=()=>{j&&j.forEach(ie=>ee.fire(ie)),j=null},ee=new f({onFirstListenerAdd(){z||(z=Z(ie=>ee.fire(ie)))},onFirstListenerDidAdd(){j&&(q?setTimeout(V):V())},onLastListenerRemove(){z&&z.dispose(),z=null}});return ee.event}s.buffer=ne;class K{constructor(q){this.event=q}map(q){return new K(h(this.event,q))}forEach(q){return new K(C(this.event,q))}filter(q){return new K(M(this.event,q))}reduce(q,B){return new K(k(this.event,q,B))}latch(){return new K($(this.event))}debounce(q,B=100,j=!1,z){return new K(_(this.event,q,B,j,z))}on(q,B,j){return this.event(q,B,j)}once(q,B,j){return l(this.event)(q,B,j)}}function N(Z){return new K(Z)}s.chain=N;function W(Z,q,B=j=>j){const j=(...ie)=>ee.fire(B(...ie)),z=()=>Z.on(q,j),V=()=>Z.removeListener(q,j),ee=new f({onFirstListenerAdd:z,onLastListenerRemove:V});return ee.event}s.fromNodeEventEmitter=W;function x(Z,q,B=j=>j){const j=(...ie)=>ee.fire(B(...ie)),z=()=>Z.addEventListener(q,j),V=()=>Z.removeEventListener(q,j),ee=new f({onFirstListenerAdd:z,onLastListenerRemove:V});return ee.event}s.fromDOMEventEmitter=x;function J(Z){return new Promise(q=>l(Z)(q))}s.toPromise=J;function G(Z,q){return q(void 0),Z(B=>q(B))}s.runAndSubscribe=G;function Q(Z,q){let B=null;function j(V){B?.dispose(),B=new L.DisposableStore,q(V,B)}j(void 0);const z=Z(V=>j(V));return(0,L.toDisposable)(()=>{z.dispose(),B?.dispose()})}s.runAndSubscribeWithStore=Q})(b=e.Event||(e.Event={}));class R{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${R._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let I=-1;function v(s){const o=I;return I=s,{dispose(){I=o}}}e.setGlobalLeakWarningThreshold=v;class y{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,l){let h=I;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||l<h)return;this._stacks||(this._stacks=new Map);const C=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,C+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let M,O=0;for(const[U,k]of this._stacks)(!M||O<k)&&(M=U,O=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${O}):`),console.warn(M)}return()=>{const M=this._stacks.get(o.value)||0;this._stacks.set(o.value,M-1)}}}class m{constructor(o){this.value=o}static create(){return new m(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(o,l,h){this.callback=o,this.callbackThis=l,this.stack=h,this.subscription=new L.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class f{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=I>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const l of o)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,l,h)=>{this._listeners||(this._listeners=new T.LinkedList);const C=this._listeners.isEmpty();C&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let M,O;this._leakageMon&&this._listeners.size>=30&&(O=m.create(),M=this._leakageMon.check(O,this._listeners.size+1)),P&&(O=O??m.create());const U=new p(o,l,O),k=this._listeners.push(U);C&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const F=U.subscription.set(()=>{M&&M(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof L.DisposableStore?h.add(F):Array.isArray(h)&&h.push(F),F}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S);for(let l of this._listeners)this._deliveryQueue.push(this,l,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=f;class d{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(o,l,h){this._queue.push(new w(o,l,h))}clear(o){const l=new T.LinkedList;for(const h of this._queue)h.emitter!==o&&l.push(h);this._queue=l}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(l){(0,D.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=d;class S extends d{clear(o){this._queue.clear()}}class w{constructor(o,l,h){this.emitter=o,this.listener=l,this.event=h}}class g extends f{async fireAsync(o,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const C of this._listeners)this._asyncDeliveryQueue.push([C,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[C,M]=this._asyncDeliveryQueue.shift(),O=[],U={...M,token:l,waitUntil:k=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");h&&(k=h(k,C.callback)),O.push(k)}};try{C.invoke(U)}catch(k){(0,D.onUnexpectedError)(k);continue}Object.freeze(O),await Promise.allSettled(O).then(k=>{for(const F of k)F.status==="rejected"&&(0,D.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=g;class u extends f{constructor(o){super(o);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=u;class t extends u{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=t;class r extends f{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const C=this.events.indexOf(l);this.events.splice(C,1)};return(0,L.toDisposable)((0,n.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class a{constructor(){this.buffers=[]}wrapEvent(o){return(l,h,C)=>o(M=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>l.call(h,M)):l.call(h,M)},void 0,C)}bufferEvents(o){const l=[];this.buffers.push(l);const h=o();return this.buffers.pop(),l.forEach(C=>C()),h}}e.EventBufferer=a;class c{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(re[23],se([0,1,3]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(P,E){const b=setTimeout(P.bind(E),0);return{dispose(){clearTimeout(b)}}});var L;(function(P){function E(b){return b===P.None||b===P.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=E,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=L.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=A}),define(re[113],se([0,1,23]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,E=this.task(P.token);return this.result={promise:E,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=n;class L{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const E=JSON.stringify(P);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=L;class T{constructor(P){this.fn=P,this._map=new Map}get cachedValues(){return this._map}get(P){if(this._map.has(P))return this._map.get(P);const E=this.fn(P);return this._map.set(P,E),E}}e.CachedFunction=T}),define(re[75],se([0,1,3,2]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const L=A=>({onDidChange:D.Event.None,value:A});e.staticObservableValue=L;class T extends n.Disposable{constructor(P){super();this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}}e.MutableObservableValue=T}),define(re[40],se([0,1,9,2]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function L(g){const u=g;return u?typeof u.read=="function":!1}e.isReadable=L;function T(g){const u=g;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=T;function A(g){const u=g;return u?T(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(g,u){return new E(g,u)}e.newWriteableStream=P;class E{constructor(u,t){this.reducer=u,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(t=>t(u))}emitError(u){this.listeners.error.length===0?(0,D.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(t=>t(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,t){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(u,t){if(this.state.destroyed)return;let r;switch(u){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const i=r.indexOf(t);i>=0&&r.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(g,u){const t=[];let r;for(;(r=g.read())!==null;)t.push(r);return u(t)}e.consumeReadable=b;function R(g,u,t){const r=[];let i;for(;(i=g.read())!==null&&r.length<t;)r.push(i);return i===null&&r.length>0?u(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i!="undefined"){const a=i;return i=void 0,a}return g.read()}}}e.peekReadable=R;function I(g,u){return new Promise((t,r)=>{const i=[];v(g,{onData:a=>{u&&i.push(a)},onError:a=>{u?r(a):t(void 0)},onEnd:()=>{t(u?u(i):void 0)}})})}e.consumeStream=I;function v(g,u){let t=!1;return g.on("error",r=>{t||u.onError(r)}),g.on("end",()=>{t||u.onEnd()}),g.on("data",r=>{t||u.onData(r)}),(0,n.toDisposable)(()=>t=!0)}e.listenStream=v;function y(g,u){return new Promise((t,r)=>{const i=new n.DisposableStore,a=[],c=l=>{if(a.push(l),a.length>u)return i.dispose(),g.pause(),t({stream:g,buffer:a,ended:!1})},s=l=>r(l),o=()=>t({stream:g,buffer:a,ended:!0});i.add((0,n.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),i.add((0,n.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),i.add((0,n.toDisposable)(()=>g.removeListener("data",c))),g.on("data",c)})}e.peekStream=y;function m(g,u){const t=P(u);return t.end(g),t}e.toStream=m;function p(){const g=P(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=p;function f(g){let u=!1;return{read:()=>u?null:(u=!0,g)}}e.toReadable=f;function d(g,u,t){const r=P(t);return v(g,{onData:i=>r.write(u.data(i)),onError:i=>r.error(u.error?u.error(i):i),onEnd:()=>r.end()}),r}e.transform=d;function S(g,u,t){let r=!1;return{read:()=>{const i=u.read();return r?i:(r=!0,i!==null?t([g,i]):g)}}}e.prefixedReadable=S;function w(g,u,t){let r=!1;const i=P(t);return v(u,{onData:a=>r?i.write(a):(r=!0,i.write(t([g,a]))),onError:a=>i.error(a),onEnd:()=>{r||(r=!0,i.write(g)),i.end()}}),i}e.prefixedStream=w}),define(re[17],se([0,1,40]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,T;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(l)):(L||(L=new TextEncoder),new A(L.encode(l)))}static fromByteArray(l){const h=A.alloc(l.length);for(let C=0,M=l.length;C<M;C++)h.buffer[C]=l[C];return h}static concat(l,h){if(typeof h=="undefined"){h=0;for(let O=0,U=l.length;O<U;O++)h+=l[O].byteLength}const C=A.alloc(h);let M=0;for(let O=0,U=l.length;O<U;O++){const k=l[O];C.set(k,M),M+=k.byteLength}return C}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(l,h){return new A(this.buffer.subarray(l,h))}set(l,h){if(l instanceof A)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return b(this.buffer,l)}writeUInt32BE(l,h){R(this.buffer,l,h)}readUInt32LE(l){return I(this.buffer,l)}writeUInt32LE(l,h){v(this.buffer,l,h)}readUInt8(l){return y(this.buffer,l)}writeUInt8(l,h){m(this.buffer,l,h)}}e.VSBuffer=A;function P(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0}e.readUInt16LE=P;function E(o,l,h){o[h+0]=l&255,l=l>>>8,o[h+1]=l&255}e.writeUInt16LE=E;function b(o,l){return o[l]*2**24+o[l+1]*2**16+o[l+2]*2**8+o[l+3]}e.readUInt32BE=b;function R(o,l,h){o[h+3]=l,l=l>>>8,o[h+2]=l,l=l>>>8,o[h+1]=l,l=l>>>8,o[h]=l}e.writeUInt32BE=R;function I(o,l){return o[l+0]<<0>>>0|o[l+1]<<8>>>0|o[l+2]<<16>>>0|o[l+3]<<24>>>0}e.readUInt32LE=I;function v(o,l,h){o[h+0]=l&255,l=l>>>8,o[h+1]=l&255,l=l>>>8,o[h+2]=l&255,l=l>>>8,o[h+3]=l&255}e.writeUInt32LE=v;function y(o,l){return o[l]}e.readUInt8=y;function m(o,l,h){o[h]=l}e.writeUInt8=m;function p(o){return D.consumeReadable(o,l=>A.concat(l))}e.readableToBuffer=p;function f(o){return D.toReadable(o)}e.bufferToReadable=f;function d(o){return D.consumeStream(o,l=>A.concat(l))}e.streamToBuffer=d;async function S(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await d(o.stream)])}e.bufferedStreamToBuffer=S;function w(o){return D.toStream(o,l=>A.concat(l))}e.bufferToStream=w;function g(o){return D.transform(o,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=g;function u(o){return D.newWriteableStream(l=>A.concat(l),o)}e.newWriteableBufferStream=u;function t(o,l){return D.prefixedReadable(o,l,h=>A.concat(h))}e.prefixedBufferReadable=t;function r(o,l){return D.prefixedStream(o,l,h=>A.concat(h))}e.prefixedBufferStream=r;function i(o){let l=0,h=0,C=0;const M=new Uint8Array(Math.floor(o.length/4*3)),O=k=>{switch(h){case 3:M[C++]=l|k,h=0;break;case 2:M[C++]=l|k>>>2,l=k<<6,h=3;break;case 1:M[C++]=l|k>>>4,l=k<<4,h=2;break;default:l=k<<2,h=1}};for(let k=0;k<o.length;k++){const F=o.charCodeAt(k);if(F>=65&&F<=90)O(F-65);else if(F>=97&&F<=122)O(F-97+26);else if(F>=48&&F<=57)O(F-48+52);else if(F===43||F===45)O(62);else if(F===47||F===95)O(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${o[k]}`)}}const U=C;for(;h>0;)O(0);return A.wrap(M).slice(0,U)}e.decodeBase64=i;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:o},l=!0,h=!1){const C=h?c:a;let M="";const O=o.byteLength%3;let U=0;for(;U<o.byteLength-O;U+=3){const k=o[U+0],F=o[U+1],_=o[U+2];M+=C[k>>>2],M+=C[(k<<4|F>>>4)&63],M+=C[(F<<2|_>>>6)&63],M+=C[_&63]}if(O===1){const k=o[U+0];M+=C[k>>>2],M+=C[k<<4&63],l&&(M+="==")}else if(O===2){const k=o[U+0],F=o[U+1];M+=C[k>>>2],M+=C[(k<<4|F>>>4)&63],M+=C[F<<2&63],l&&(M+="=")}return M}e.encodeBase64=s}),define(re[26],se([0,1,113,108]),function(X,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function P(te,...ce){return ce.length===0?te:te.replace(A,function(he,me){const ye=parseInt(me,10);return isNaN(ye)||ye<0||ye>=ce.length?he:ce[ye]})}e.format=P;const E=/{([^}]+)}/g;function b(te,ce){return te.replace(E,(he,me)=>ce[me]??he)}e.format2=b;function R(te){return te.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=R;function I(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function v(te,ce){let he=0;const me=ce.charCodeAt(0);for(let ye=te.length-1;ye>=0;ye--)te.charCodeAt(ye)===me&&he++;return he}e.count=v;function y(te,ce,he="\u2026"){return te.length<=ce?te:`${te.substr(0,ce)}${he}`}e.truncate=y;function m(te,ce=" "){const he=p(te,ce);return f(he,ce)}e.trim=m;function p(te,ce){if(!te||!ce)return te;const he=ce.length;if(he===0||te.length===0)return te;let me=0;for(;te.indexOf(ce,me)===me;)me=me+he;return te.substring(me)}e.ltrim=p;function f(te,ce){if(!te||!ce)return te;const he=ce.length,me=te.length;if(he===0||me===0)return te;let ye=me,ve=-1;for(;ve=te.lastIndexOf(ce,ye-1),!(ve===-1||ve+he!==ye);){if(ve===0)return"";ye=ve}return te.substring(0,ye)}e.rtrim=f;function d(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function S(te){return te.replace(/\*/g,"")}e.stripWildcards=S;function w(te,ce,he={}){if(!te)throw new Error("Cannot create regex from empty string");ce||(te=I(te)),he.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=w;function g(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function u(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function t(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=t;function r(te){return te.split(/\r\n|\r|\n/)}e.splitLines=r;function i(te){for(let ce=0,he=te.length;ce<he;ce++){const me=te.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function a(te,ce=0,he=te.length){for(let me=ce;me<he;me++){const ye=te.charCodeAt(me);if(ye!==32&&ye!==9)return te.substring(ce,me)}return te.substring(ce,he)}e.getLeadingWhitespace=a;function c(te,ce=te.length-1){for(let he=ce;he>=0;he--){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=c;function s(te,ce,he){let me=[],ye=0;for(const ve of te.matchAll(ce)){if(me.push(te.slice(ye,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");ye=ve.index+ve[0].length,me.push(he(ve[0],...ve.slice(1),ve.index,te,ve.groups))}return me.push(te.slice(ye)),Promise.all(me).then(ve=>ve.join(""))}e.replaceAsync=s;function o(te,ce){return te<ce?-1:te>ce?1:0}e.compare=o;function l(te,ce,he=0,me=te.length,ye=0,ve=ce.length){for(;he<me&&ye<ve;he++,ye++){let Te=te.charCodeAt(he),De=ce.charCodeAt(ye);if(Te<De)return-1;if(Te>De)return 1}const Pe=me-he,ke=ve-ye;return Pe<ke?-1:Pe>ke?1:0}e.compareSubstring=l;function h(te,ce){return C(te,ce,0,te.length,0,ce.length)}e.compareIgnoreCase=h;function C(te,ce,he=0,me=te.length,ye=0,ve=ce.length){for(;he<me&&ye<ve;he++,ye++){let Te=te.charCodeAt(he),De=ce.charCodeAt(ye);if(Te===De)continue;if(Te>=128||De>=128)return l(te.toLowerCase(),ce.toLowerCase(),he,me,ye,ve);M(Te)&&(Te-=32),M(De)&&(De-=32);const ze=Te-De;if(ze!==0)return ze}const Pe=me-he,ke=ve-ye;return Pe<ke?-1:Pe>ke?1:0}e.compareSubstringIgnoreCase=C;function M(te){return te>=97&&te<=122}e.isLowerAsciiLetter=M;function O(te){return te>=65&&te<=90}e.isUpperAsciiLetter=O;function U(te,ce){return te.length===ce.length&&C(te,ce)===0}e.equalsIgnoreCase=U;function k(te,ce){const he=ce.length;return ce.length>te.length?!1:C(te,ce,0,he)===0}e.startsWithIgnoreCase=k;function F(te,ce){let he,me=Math.min(te.length,ce.length);for(he=0;he<me;he++)if(te.charCodeAt(he)!==ce.charCodeAt(he))return he;return me}e.commonPrefixLength=F;function _(te,ce){let he,me=Math.min(te.length,ce.length);const ye=te.length-1,ve=ce.length-1;for(he=0;he<me;he++)if(te.charCodeAt(ye-he)!==ce.charCodeAt(ve-he))return he;return me}e.commonSuffixLength=_;function $(te){return 55296<=te&&te<=56319}e.isHighSurrogate=$;function H(te){return 56320<=te&&te<=57343}e.isLowSurrogate=H;function ne(te,ce){return(te-55296<<10)+(ce-56320)+65536}e.computeCodePoint=ne;function K(te,ce,he){const me=te.charCodeAt(he);if($(me)&&he+1<ce){const ye=te.charCodeAt(he+1);if(H(ye))return ne(me,ye)}return me}e.getNextCodePoint=K;function N(te,ce){const he=te.charCodeAt(ce-1);if(H(he)&&ce>1){const me=te.charCodeAt(ce-2);if($(me))return ne(me,he)}return he}class W{constructor(ce,he=0){this._str=ce,this._len=ce.length,this._offset=he}get offset(){return this._offset}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=N(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=K(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class x{constructor(ce,he=0){this._iterator=new W(ce,he)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ce=ue.getInstance(),he=this._iterator,me=he.offset;let ye=ce.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const ve=he.offset,Pe=ce.getGraphemeBreakType(he.nextCodePoint());if(oe(ye,Pe)){he.setOffset(ve);break}ye=Pe}return he.offset-me}prevGraphemeLength(){const ce=ue.getInstance(),he=this._iterator,me=he.offset;let ye=ce.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const ve=he.offset,Pe=ce.getGraphemeBreakType(he.prevCodePoint());if(oe(Pe,ye)){he.setOffset(ve);break}ye=Pe}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=x;function J(te,ce){return new x(te,ce).nextGraphemeLength()}e.nextCharLength=J;function G(te,ce){return new x(te,ce).prevGraphemeLength()}e.prevCharLength=G;function Q(te,ce){ce>0&&H(te.charCodeAt(ce))&&ce--;const he=ce+J(te,ce);return[he-G(te,he),he]}e.getCharContainingOffset=Q;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function q(te){return Z.test(te)}e.containsRTL=q;const B=/^[\t\n\r\x20-\x7E]*$/;function j(te){return B.test(te)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=z;function V(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=V;function ee(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=ee;function ie(te,ce){if(te.length<ce)return te;const he=/\b/g;let me=0;for(;he.test(te)&&!(te.length-he.lastIndex<ce);)me=he.lastIndex,he.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ie;const ae=/\x1B\x5B[12]?K/g,fe=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function we(te){return te&&(te=te.replace(ae,""),te=te.replace(fe,""),te=te.replace(pe,"")),te}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function Ee(te){return ge(te)?te.substr(1):te}e.stripUTF8BOM=Ee;function Ce(te,ce){if(!te||!ce||te.length<ce.length)return!1;const he=ce.length,me=te.toLowerCase();let ye=0,ve=-1;for(;ye<he;){const Pe=me.indexOf(ce[ye],ve+1);if(Pe<0)return!1;ve=Pe,ye++}return!0}e.fuzzyContains=Ce;function Re(te,ce=!1){return te?(ce&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Re;function _e(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=_e;function je(te,ce=1){if(ce===0)return"";let he=-1;do he=te.indexOf(`
`,he+1),ce--;while(ce>0&&he>=0);return he===-1?te:(te[he-1]==="\r"&&he--,te.substr(0,he))}e.getNLines=je;function Ge(te){const ce=90-65+1;return te=te%(2*ce),te<ce?String.fromCharCode(97+te):String.fromCharCode(65+te-ce)}e.singleLetterHash=Ge;function Ke(te){return ue.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=Ke;function oe(te,ce){return te===0?ce!==5&&ce!==7:te===2&&ce===3?!1:te===4||te===2||te===3||ce===4||ce===2||ce===3?!0:!(te===8&&(ce===8||ce===9||ce===11||ce===12)||(te===11||te===9)&&(ce===9||ce===10)||(te===12||te===10)&&ce===10||ce===5||ce===13||ce===7||te===1||te===13&&ce===14||te===6&&ce===6)}var le;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(le=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ue{constructor(){this._data=be()}static getInstance(){return ue._INSTANCE||(ue._INSTANCE=new ue),ue._INSTANCE}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const he=this._data,me=he.length/3;let ye=1;for(;ye<=me;)if(ce<he[3*ye])ye=2*ye;else if(ce>he[3*ye+1])ye=2*ye+1;else return he[3*ye+2];return 0}}ue._INSTANCE=null;function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(te,ce){if(te===0)return 0;const he=Ue(te,ce);if(he!==void 0)return he;const me=new W(ce,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ie;function Ue(te,ce){const he=new W(ce,te);let me=he.prevCodePoint();for(;Le(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!ee(me))return;let ye=he.offset;return ye>0&&he.prevCodePoint()===8205&&(ye=he.offset),ye}function Le(te){return 127995<=te&&te<=127999}var Fe;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class Ae{constructor(ce){this.confusableDictionary=ce}static getInstance(ce){return Ae.cache.get(Array.from(ce))}static getLocales(){return Ae._locales.getValue()}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ae,L=Ae,Ae.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ae.cache=new D.LRUCachedFunction(te=>{function ce(De){const ze=new Map;for(let Ne=0;Ne<De.length;Ne+=2)ze.set(De[Ne],De[Ne+1]);return ze}function he(De,ze){const Ne=new Map(De);for(const[qe,tt]of ze)Ne.set(qe,tt);return Ne}function me(De,ze){if(!De)return ze;const Ne=new Map;for(const[qe,tt]of De)ze.has(qe)&&Ne.set(qe,tt);return Ne}const ye=L.ambiguousCharacterData.getValue();let ve=te.filter(De=>!De.startsWith("_")&&De in ye);ve.length===0&&(ve=["_default"]);let Pe;for(const De of ve){const ze=ce(ye[De]);Pe=me(Pe,ze)}const ke=ce(ye._common),Te=he(ke,Pe);return new Ae(Te)}),Ae._locales=new n.Lazy(()=>Object.keys(Ae.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(ce){return Oe.getData().has(ce)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe,Oe._data=void 0}),define(re[76],se([0,1,26]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(d){return L(d,0)}e.hash=n;function L(d,S){switch(typeof d){case"object":return d===null?T(349,S):Array.isArray(d)?E(d,S):b(d,S);case"string":return P(d,S);case"boolean":return A(d,S);case"number":return T(d,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=L;function T(d,S){return(S<<5)-S+d|0}e.numberHash=T;function A(d,S){return T(d?433:863,S)}function P(d,S){S=T(149417,S);for(let w=0,g=d.length;w<g;w++)S=T(d.charCodeAt(w),S);return S}e.stringHash=P;function E(d,S){return S=T(104579,S),d.reduce((w,g)=>L(g,w),S)}function b(d,S){return S=T(181387,S),Object.keys(d).sort().reduce((w,g)=>(w=P(g,w),L(d[g],w)),S)}class R{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=L(S,this._value),this._value}}e.Hasher=R;var I;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(d,S,w=32){const g=w-S,u=~((1<<g)-1);return(d<<S|(u&d)>>>g)>>>0}function y(d,S=0,w=d.byteLength,g=0){for(let u=0;u<w;u++)d[S+u]=g}function m(d,S,w="0"){for(;d.length<S;)d=w+d;return d}function p(d,S=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(w=>w.toString(16).padStart(2,"0")).join(""):m((d>>>0).toString(16),S/4)}e.toHexString=p;class f{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const w=S.length;if(w===0)return;const g=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,r,i;for(t!==0?(r=t,i=-1,t=0):(r=S.charCodeAt(0),i=0);;){let a=r;if(D.isHighSurrogate(r))if(i+1<w){const c=S.charCodeAt(i+1);D.isLowSurrogate(c)?(i++,a=D.computeCodePoint(r,c)):a=65533}else{t=r;break}else D.isLowSurrogate(r)&&(a=65533);if(u=this._push(g,u,a),i++,i<w)r=S.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(S,w,g){return g<128?S[w++]=g:g<2048?(S[w++]=192|(g&1984)>>>6,S[w++]=128|(g&63)>>>0):g<65536?(S[w++]=224|(g&61440)>>>12,S[w++]=128|(g&4032)>>>6,S[w++]=128|(g&63)>>>0):(S[w++]=240|(g&1835008)>>>18,S[w++]=128|(g&258048)>>>12,S[w++]=128|(g&4032)>>>6,S[w++]=128|(g&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=f._bigBlock32,w=this._buffDV;for(let o=0;o<64;o+=4)S.setUint32(o,w.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)S.setUint32(o,v(S.getUint32(o-12,!1)^S.getUint32(o-32,!1)^S.getUint32(o-56,!1)^S.getUint32(o-64,!1),1),!1);let g=this._h0,u=this._h1,t=this._h2,r=this._h3,i=this._h4,a,c,s;for(let o=0;o<80;o++)o<20?(a=u&t|~u&r,c=1518500249):o<40?(a=u^t^r,c=1859775393):o<60?(a=u&t|u&r|t&r,c=2400959708):(a=u^t^r,c=3395469782),s=v(g,5)+a+i+c+S.getUint32(o*4,!1)&4294967295,i=r,r=t,t=v(u,30),u=g,g=s;this._h0=this._h0+g&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=f,f._bigBlock32=new DataView(new ArrayBuffer(320))});var Ct=this&&this.__classPrivateFieldSet||function(X,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(X,D):L?L.value=D:e.set(X,D),D},He=this&&this.__classPrivateFieldGet||function(X,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!n:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(X):n?n.value:e.get(X)};define(re[39],se([0,1,16,26]),function(X,e,D,n){"use strict";var L,T,A,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function E(c,s,o){let l=c.get(s);return l===void 0&&(l=o,c.set(s,l)),l}e.getOrSet=E;function b(c){const s=[];return c.forEach((o,l)=>{s.push(`${l} => ${o}`)}),`Map(${c.size}) {${s.join(", ")}}`}e.mapToString=b;function R(c){const s=[];return c.forEach(o=>{s.push(o)}),`Set(${c.size}) {${s.join(", ")}}`}e.setToString=R;class I{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const o=s.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=I;class v{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,n.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class y{constructor(s=!0,o=!0){this._splitOnBackslash=s,this._caseSensitive=o}reset(s){this._from=0,this._to=0,this._value=s,this._valueLen=s.length;for(let o=s.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let s=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,n.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var m;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(m||(m={}));class p{constructor(s,o){this._ignorePathCasing=s,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(s)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,n.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(d||(d={}));class S{constructor(s){this._iter=s}static forUris(s=()=>!1,o=()=>!1){return new S(new p(s,o))}static forPaths(s=!1){return new S(new y(void 0,!s))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new v)}clear(){this._root=void 0}fill(s,o){if(o){const l=o.slice(0);(0,D.shuffle)(l);for(let h of l)this.set(h,s)}else{const l=s.slice(0);(0,D.shuffle)(l);for(let h of l)this.set(h[0],h[1])}}set(s,o){const l=this._iter.reset(s);let h;this._root||(this._root=new f,this._root.segment=l.value());const C=[];for(h=this._root;;){const O=l.cmp(h.segment);if(O>0)h.left||(h.left=new f,h.left.segment=l.value()),C.push([-1,h]),h=h.left;else if(O<0)h.right||(h.right=new f,h.right.segment=l.value()),C.push([1,h]),h=h.right;else if(l.hasNext())l.next(),h.mid||(h.mid=new f,h.mid.segment=l.value()),C.push([0,h]),h=h.mid;else break}const M=h.value;h.value=o,h.key=s;for(let O=C.length-1;O>=0;O--){const U=C[O][1];U.updateHeight();const k=U.balanceFactor();if(k<-1||k>1){const F=C[O][0],_=C[O+1][0];if(F===1&&_===1)C[O][1]=U.rotateLeft();else if(F===-1&&_===-1)C[O][1]=U.rotateRight();else if(F===1&&_===-1)U.right=C[O+1][1]=C[O+1][1].rotateRight(),C[O][1]=U.rotateLeft();else if(F===-1&&_===1)U.left=C[O+1][1]=C[O+1][1].rotateLeft(),C[O][1]=U.rotateRight();else throw new Error;if(O>0)switch(C[O-1][0]){case-1:C[O-1][1].left=C[O][1];break;case 1:C[O-1][1].right=C[O][1];break;case 0:C[O-1][1].mid=C[O][1];break}else this._root=C[0][1]}}return M}get(s){return this._getNode(s)?.value}_getNode(s){const o=this._iter.reset(s);let l=this._root;for(;l;){const h=o.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(s){const o=this._getNode(s);return!(o?.value===void 0&&o?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,o){const l=this._iter.reset(s),h=[];let C=this._root;for(;C;){const M=l.cmp(C.segment);if(M>0)h.push([-1,C]),C=C.left;else if(M<0)h.push([1,C]),C=C.right;else if(l.hasNext())l.next(),h.push([0,C]),C=C.mid;else break}if(!!C){if(o?(C.left=void 0,C.mid=void 0,C.right=void 0,C.height=1):(C.key=void 0,C.value=void 0),!C.mid&&!C.value)if(C.left&&C.right){const M=this._min(C.right),{key:O,value:U,segment:k}=M;this._delete(M.key,!1),C.key=O,C.value=U,C.segment=k}else{const M=C.left??C.right;if(h.length>0){const[O,U]=h[h.length-1];switch(O){case-1:U.left=M;break;case 0:U.mid=M;break;case 1:U.right=M;break}}else this._root=M}for(let M=h.length-1;M>=0;M--){const O=h[M][1];O.updateHeight();const U=O.balanceFactor();if(U>1?(O.right.balanceFactor()>=0||(O.right=O.right.rotateRight()),h[M][1]=O.rotateLeft()):U<-1&&(O.left.balanceFactor()<=0||(O.left=O.left.rotateLeft()),h[M][1]=O.rotateRight()),M>0)switch(h[M-1][0]){case-1:h[M-1][1].left=h[M][1];break;case 1:h[M-1][1].right=h[M][1];break;case 0:h[M-1][1].mid=h[M][1];break}else this._root=h[0][1]}}}_min(s){for(;s.left;)s=s.left;return s}findSubstr(s){const o=this._iter.reset(s);let l=this._root,h;for(;l;){const C=o.cmp(l.segment);if(C>0)l=l.left;else if(C<0)l=l.right;else if(o.hasNext())o.next(),h=l.value||h,l=l.mid;else break}return l&&l.value||h}findSuperstr(s){const o=this._iter.reset(s);let l=this._root;for(;l;){const h=o.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(s){for(const[o,l]of this)s(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){!s||(s.left&&(yield*this._entries(s.left)),s.value&&(yield[s.key,s.value]),s.mid&&(yield*this._entries(s.mid)),s.right&&(yield*this._entries(s.right)))}_isBalanced(){const s=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:s(o.left)&&s(o.right)};return s(this._root)}}e.TernarySearchTree=S;class w{constructor(s,o){this.uri=s,this.value=o}}class g{constructor(s,o){this[L]="ResourceMap",s instanceof g?(this.map=new Map(s.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=s??g.defaultToKey)}set(s,o){return this.map.set(this.toKey(s),new w(s,o)),this}get(s){return this.map.get(this.toKey(s))?.value}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,o){typeof o!="undefined"&&(s=s.bind(o));for(let[l,h]of this.map)s(h.value,h.uri,this)}*values(){for(let s of this.map.values())yield s.value}*keys(){for(let s of this.map.values())yield s.uri}*entries(){for(let s of this.map.values())yield[s.uri,s.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,s]of this.map)yield[s.uri,s.value]}}e.ResourceMap=g,g.defaultToKey=c=>c.toString();class u{constructor(s,o){this[T]="ResourceSet",!s||typeof s=="function"?this._map=new g(s):(this._map=new g(o),s.forEach(this.add,this))}get size(){return this._map.size}add(s){return this._map.set(s,s),this}clear(){this._map.clear()}delete(s){return this._map.delete(s)}forEach(s,o){this._map.forEach((l,h)=>s.call(o,h,h,this))}has(s){return this._map.has(s)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=u;var t;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(t=e.Touch||(e.Touch={}));class r{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,o=0){const l=this._map.get(s);if(!!l)return o!==0&&this.touch(l,o),l.value}set(s,o,l=0){let h=this._map.get(s);if(h)h.value=o,l!==0&&this.touch(h,l);else{switch(h={key:s,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(s,h),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const o=this._map.get(s);if(!!o)return this._map.delete(s),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,o){const l=this._state;let h=this._head;for(;h;){if(o?s.bind(o)(h.value,h.key,this):s(h.value,h.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const s=this,o=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:l.key,done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return h}values(){const s=this,o=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:l.value,done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return h}entries(){const s=this,o=this._state;let l=this._head;const h={[Symbol.iterator](){return h},next(){if(s._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const C={value:[l.key,l.value],done:!1};return l=l.next,C}else return{value:void 0,done:!0}}};return h}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>s;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const o=s.next,l=s.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}s.next=void 0,s.previous=void 0,this._state++}touch(s,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(s===this._head)return;const l=s.next,h=s.previous;s===this._tail?(h.next=void 0,this._tail=h):(l.previous=h,h.next=l),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(o===2){if(s===this._tail)return;const l=s.next,h=s.previous;s===this._head?(l.previous=void 0,this._head=l):(l.previous=h,h.next=l),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((o,l)=>{s.push([l,o])}),s}fromJSON(s){this.clear();for(const[o,l]of s)this.set(o,l)}}e.LinkedMap=r;class i extends r{constructor(s,o=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,o=2){return super.get(s,o)}peek(s){return super.get(s,0)}set(s,o){return super.set(s,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class a{constructor(s){P.set(this,void 0),Ct(this,P,s,"f")}get size(){return He(this,P,"f").size}forEach(s,o){He(this,P,"f").forEach(s,o)}get(s){return He(this,P,"f").get(s)}has(s){return He(this,P,"f").has(s)}entries(){return He(this,P,"f").entries()}keys(){return He(this,P,"f").keys()}values(){return He(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return He(this,P,"f").entries()}}e.ReadonlyMapView=a}),define(re[77],se([0,1,39]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(b){return E(b,"NFC",n)}e.normalizeNFC=L;const T=new D.LRUCache(1e4);function A(b){return E(b,"NFD",T)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function E(b,R,I){if(!b)return b;const v=I.get(b);if(v)return v;let y;return P.test(b)?y=b.normalize(R):y=b,I.set(b,y),y}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(R){return A(R).replace(b,"")}}()}),define(re[78],se([0,1,26]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(n||(n={})),function(L){const T="error",A="warning",P="warn",E="info",b="ignore";function R(v){return v?D.equalsIgnoreCase(T,v)?L.Error:D.equalsIgnoreCase(A,v)||D.equalsIgnoreCase(P,v)?L.Warning:D.equalsIgnoreCase(E,v)?L.Info:L.Ignore:L.Ignore}L.fromValue=R;function I(v){switch(v){case L.Error:return T;case L.Warning:return A;case L.Info:return E;default:return b}}L.toString=I}(n||(n={})),e.default=n}),define(re[13],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(o){return Array.isArray(o)}e.isArray=D;function n(o){return typeof o=="string"}e.isString=n;function L(o){return Array.isArray(o)&&o.every(l=>n(l))}e.isStringArray=L;function T(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=T;function A(o){return typeof o=="object"&&(o instanceof Uint8Array||o instanceof Uint16Array||o instanceof Uint32Array||o instanceof Float32Array||o instanceof Float64Array||o instanceof Int8Array||o instanceof Int16Array||o instanceof Int32Array||o instanceof BigInt64Array||o instanceof BigUint64Array||o instanceof Uint8ClampedArray)}e.isTypedArray=A;function P(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=P;function E(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=E;function b(o){return o===!0||o===!1}e.isBoolean=b;function R(o){return typeof o=="undefined"}e.isUndefined=R;function I(o){return!v(o)}e.isDefined=I;function v(o){return R(o)||o===null}e.isUndefinedOrNull=v;function y(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=y;function m(o){if(v(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=m;function p(...o){const l=[];for(let h=0;h<o.length;h++){const C=o[h];if(v(C))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);l.push(C)}return l}e.assertAllDefined=p;const f=Object.prototype.hasOwnProperty;function d(o){if(!T(o))return!1;for(let l in o)if(f.call(o,l))return!1;return!0}e.isEmptyObject=d;function S(o){return typeof o=="function"}e.isFunction=S;function w(...o){return o.length>0&&o.every(S)}e.areFunctions=w;function g(o,l){const h=Math.min(o.length,l.length);for(let C=0;C<h;C++)u(o[C],l[C])}e.validateConstraints=g;function u(o,l){if(n(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(S(l)){try{if(o instanceof l)return}catch{}if(!v(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function t(o){let l=[],h=Object.getPrototypeOf(o);for(;Object.prototype!==h;)l=l.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return l}e.getAllPropertyNames=t;function r(o){const l=[];for(const h of t(o))typeof o[h]=="function"&&l.push(h);return l}e.getAllMethodNames=r;function i(o,l){const h=M=>function(){const O=Array.prototype.slice.call(arguments,0);return l(M,O)};let C={};for(const M of o)C[M]=h(M);return C}e.createProxyObject=i;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function c(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=c;function s(o,l="Unreachable"){throw new Error(l)}e.assertNever=s}),define(re[41],se([0,1,10,4,26,13]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(c){return c===47||c===92}e.isPathSeparator=A;function P(c){return c.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function E(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=E;function b(c,s=D.posix.sep){if(!c)return"";const o=c.length,l=c.charCodeAt(0);if(A(l)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let C=3;const M=C;for(;C<o&&!A(c.charCodeAt(C));C++);if(M!==C&&!A(c.charCodeAt(C+1))){for(C+=1;C<o;C++)if(A(c.charCodeAt(C)))return c.slice(0,C+1).replace(/[\\/]/g,s)}}return s}else if(d(l)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+s:c.slice(0,2);let h=c.indexOf("://");if(h!==-1){for(h+=3;h<o;h++)if(A(c.charCodeAt(h)))return c.slice(0,h+1)}return""}e.getRoot=b;function R(c){if(!n.isWindows||!c||c.length<5)return!1;let s=c.charCodeAt(0);if(s!==92||(s=c.charCodeAt(1),s!==92))return!1;let o=2;const l=o;for(;o<c.length&&(s=c.charCodeAt(o),s!==92);o++);return!(l===o||(s=c.charCodeAt(o+1),isNaN(s)||s===92))}e.isUNC=R;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(c,s=n.isWindows){const o=s?I:v;return!(!c||c.length===0||/^\s+$/.test(c)||(o.lastIndex=0,o.test(c))||s&&y.test(c)||c==="."||c===".."||s&&c[c.length-1]==="."||s&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=m;function p(c,s,o){const l=c===s;return!o||l?l:!c||!s?!1:(0,L.equalsIgnoreCase)(c,s)}e.isEqual=p;function f(c,s,o,l=D.sep){if(c===s)return!0;if(!c||!s||s.length>c.length)return!1;if(o){if(!(0,L.startsWithIgnoreCase)(c,s))return!1;if(s.length===c.length)return!0;let C=s.length;return s.charAt(s.length-1)===l&&C--,c.charAt(C)===l}return s.charAt(s.length-1)!==l&&(s+=l),c.indexOf(s)===0}e.isEqualOrParent=f;function d(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=d;function S(c,s){return n.isWindows&&c.endsWith(":")&&(c+=D.sep),(0,D.isAbsolute)(c)||(c=(0,D.join)(s,c)),c=(0,D.normalize)(c),n.isWindows?(c=(0,L.rtrim)(c,D.sep),c.endsWith(":")&&(c+=D.sep)):(c=(0,L.rtrim)(c,D.sep),c||(c=D.sep)),c}e.sanitizeFilePath=S;function w(c){const s=(0,D.normalize)(c);return n.isWindows?c.length>3?!1:g(s)&&(c.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=w;function g(c,s=n.isWindows){return s?d(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function u(c){return g(c)?c[0]:void 0}e.getDriveLetter=u;function t(c,s,o){return s.length>c.length?-1:c===s?0:(o&&(c=c.toLowerCase(),s=s.toLowerCase()),c.indexOf(s))}e.indexOfPath=t;function r(c){const s=c.split(":");let o,l,h;for(const C of s){const M=Number(C);(0,T.isNumber)(M)?l===void 0?l=M:h===void 0&&(h=M):o=o?[o,C].join(":"):C}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:l!==void 0?l:void 0,column:h!==void 0?h:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(c,s,o=8){let l="";for(let C=0;C<o;C++)l+=i.charAt(Math.floor(Math.random()*i.length));let h;return s?h=`${s}-${l}`:h=l,c?(0,D.join)(c,h):h}e.randomPath=a}),define(re[28],se([0,1,13]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const f=Array.isArray(p)?[]:{};return Object.keys(p).forEach(d=>{p[d]&&typeof p[d]=="object"?f[d]=n(p[d]):f[d]=p[d]}),f}e.deepClone=n;function L(p){if(!p||typeof p!="object")return p;const f=[p];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const S in d)if(T.call(d,S)){const w=d[S];typeof w=="object"&&!Object.isFrozen(w)&&!(0,D.isTypedArray)(w)&&f.push(w)}}return p}e.deepFreeze=L;const T=Object.prototype.hasOwnProperty;function A(p,f){return P(p,f,new Set)}e.cloneAndChange=A;function P(p,f,d){if((0,D.isUndefinedOrNull)(p))return p;const S=f(p);if(typeof S!="undefined")return S;if((0,D.isArray)(p)){const w=[];for(const g of p)w.push(P(g,f,d));return w}if((0,D.isObject)(p)){if(d.has(p))throw new Error("Cannot clone recursive data-structure");d.add(p);const w={};for(let g in p)T.call(p,g)&&(w[g]=P(p[g],f,d));return d.delete(p),w}return p}function E(p,f,d=!0){return(0,D.isObject)(p)?((0,D.isObject)(f)&&Object.keys(f).forEach(S=>{S in p?d&&((0,D.isObject)(p[S])&&(0,D.isObject)(f[S])?E(p[S],f[S],d):p[S]=f[S]):p[S]=f[S]}),p):f}e.mixin=E;function b(p,f){if(p===f)return!0;if(p==null||f===null||f===void 0||typeof p!=typeof f||typeof p!="object"||Array.isArray(p)!==Array.isArray(f))return!1;let d,S;if(Array.isArray(p)){if(p.length!==f.length)return!1;for(d=0;d<p.length;d++)if(!b(p[d],f[d]))return!1}else{const w=[];for(S in p)w.push(S);w.sort();const g=[];for(S in f)g.push(S);if(g.sort(),!b(w,g))return!1;for(d=0;d<w.length;d++)if(!b(p[w[d]],f[w[d]]))return!1}return!0}e.equals=b;function R(p){const f=new Set;return JSON.stringify(p,(d,S)=>{if((0,D.isObject)(S)||Array.isArray(S)){if(f.has(S))return"[Circular]";f.add(S)}return S})}e.safeStringify=R;function I(p,f,d){const S=f(p);return typeof S=="undefined"?d:S}e.getOrDefault=I;function v(p,f){const d=Object.create(null);return!p||!f||Object.keys(f).forEach(w=>{const g=p[w],u=f[w];b(g,u)||(d[w]=u)}),d}e.distinct=v;function y(p,f){const d=f.toLowerCase(),S=Object.keys(p).find(w=>w.toLowerCase()===d);return S?p[S]:p[f]}e.getCaseInsensitive=y;function m(p,f){const d=Object.create(null);for(const[S,w]of Object.entries(p))f(S,w)&&(d[S]=w);return d}e.filter=m}),define(re[7],se([0,1,10,4]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function P(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,a){return!i&&!a?"file":i}function b(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const R="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(a,c,s,o,l,h=!1){typeof a=="object"?(this.scheme=a.scheme||R,this.authority=a.authority||R,this.path=a.path||R,this.query=a.query||R,this.fragment=a.fragment||R):(this.scheme=E(a,h),this.authority=c||R,this.path=b(this.scheme,s||R),this.query=o||R,this.fragment=l||R,P(this,h))}static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return w(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:s,path:o,query:l,fragment:h}=a;return c===void 0?c=this.scheme:c===null&&(c=R),s===void 0?s=this.authority:s===null&&(s=R),o===void 0?o=this.path:o===null&&(o=R),l===void 0?l=this.query:l===null&&(l=R),h===void 0?h=this.fragment:h===null&&(h=R),c===this.scheme&&s===this.authority&&o===this.path&&l===this.query&&h===this.fragment?this:new p(c,s,o,l,h)}static parse(a,c=!1){const s=v.exec(a);return s?new p(s[2]||R,r(s[4]||R),r(s[5]||R),r(s[7]||R),r(s[9]||R),c):new p(R,R,R,R,R)}static file(a){let c=R;if(n.isWindows&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const s=a.indexOf(I,2);s===-1?(c=a.substring(2),a=I):(c=a.substring(2,s),a=a.substring(s)||I)}return new p("file",c,a,R,R)}static from(a){const c=new p(a.scheme,a.authority,a.path,a.query,a.fragment);return P(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&a.scheme==="file"?s=y.file(D.win32.join(w(a,!0),...c)).path:s=D.posix.join(a.path,...c),a.with({path:s})}toString(a=!1){return g(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const c=new p(a);return c._formatted=a.external,c._fsPath=a._sep===m?a.fsPath:null,c}}else return a}}e.URI=y;const m=n.isWindows?1:void 0;class p extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(a=!1){return a?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=m),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,a){let c,s=-1;for(let o=0;o<i.length;o++){const l=i.charCodeAt(o);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||a&&l===47)s!==-1&&(c+=encodeURIComponent(i.substring(s,o)),s=-1),c!==void 0&&(c+=i.charAt(o));else{c===void 0&&(c=i.substr(0,o));const h=f[l];h!==void 0?(s!==-1&&(c+=encodeURIComponent(i.substring(s,o)),s=-1),c+=h):s===-1&&(s=o)}}return s!==-1&&(c+=encodeURIComponent(i.substring(s))),c!==void 0?c:i}function S(i){let a;for(let c=0;c<i.length;c++){const s=i.charCodeAt(c);s===35||s===63?(a===void 0&&(a=i.substr(0,c)),a+=f[s]):a!==void 0&&(a+=i[c])}return a!==void 0?a:i}function w(i,a){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,n.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=w;function g(i,a){const c=a?S:d;let s="",{scheme:o,authority:l,path:h,query:C,fragment:M}=i;if(o&&(s+=o,s+=":"),(l||o==="file")&&(s+=I,s+=I),l){let O=l.indexOf("@");if(O!==-1){const U=l.substr(0,O);l=l.substr(O+1),O=U.indexOf(":"),O===-1?s+=c(U,!1):(s+=c(U.substr(0,O),!1),s+=":",s+=c(U.substr(O+1),!1)),s+="@"}l=l.toLowerCase(),O=l.indexOf(":"),O===-1?s+=c(l,!1):(s+=c(l.substr(0,O),!1),s+=l.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}s+=c(h,!0)}return C&&(s+="?",s+=c(C,!1)),M&&(s+="#",s+=a?M:d(M,!1)),s}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>u(a)):i}}),define(re[114],se([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=n;function L(b){const R=[];let I;try{const v=JSON.parse(b.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),I=y.__$stack),R.push(...v)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:I}}e.parse=L;function T(b){if(typeof b!="string")return T(L(b).stack);const R=b;if(R){const I=A(R),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=T;function A(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function P(b,R){const{args:I,stack:v}=L(b),y=typeof I[0]=="string"&&I.length===1;let m=A(v);m&&(m=`(${m.trim()})`);let p=[];if(typeof I[0]=="string"?m&&y?p=[`%c[${R}] %c${I[0]} %c${m}`,E("blue"),E(""),E("grey")]:p=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${R}]%`,E("blue"),...I],m&&!y&&p.push(m),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=P;function E(b){return`color: ${b}`}}),define(re[79],se([0,1,17,26,7]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(b){return JSON.stringify(b,P)}e.stringify=T;function A(b){let R=JSON.parse(b);return R=E(R),R}e.parse=A;function P(b,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,n.regExpFlags)(R)}:R}function E(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return L.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof D.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let I=0;I<b.length;++I)b[I]=E(b[I],R+1);else for(const I in b)Object.hasOwnProperty.call(b,I)&&(b[I]=E(b[I],R+1))}return b}e.revive=E}),define(re[19],se([0,1,4,7]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${L.vscodeRemoteResource}`}set(E,b,R){this._hosts[E]=b,this._ports[E]=R}setConnectionToken(E,b){this._connectionTokens[E]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const b=E.authority;let R=this._hosts[b];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const I=this._ports[b],v=this._connectionTokens[b];let y=`path=${encodeURIComponent(E.path)}`;return typeof v=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${R}:${I}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new T;class A{asBrowserUri(E,b){const R=this.toUri(E,b);return R.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===L.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${L.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,b){const R=this.toUri(E,b);return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==A.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,b){return n.URI.isUri(E)?E:n.URI.parse(b.toUrl(E))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(re[20],se([0,1,41,19,10,4,26,7]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=E;class b{constructor(m){this._ignorePathCasing=m}compare(m,p,f=!1){return m===p?0:(0,A.compare)(this.getComparisonKey(m,f),this.getComparisonKey(p,f))}isEqual(m,p,f=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,f)===this.getComparisonKey(p,f)}getComparisonKey(m,p=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,p,f=!1){if(m.scheme===p.scheme){if(m.scheme===n.Schemas.file)return D.isEqualOrParent(E(m),E(p),this._ignorePathCasing(m))&&m.query===p.query&&(f||m.fragment===p.fragment);if((0,e.isEqualAuthority)(m.authority,p.authority))return D.isEqualOrParent(m.path,p.path,this._ignorePathCasing(m),"/")&&m.query===p.query&&(f||m.fragment===p.fragment)}return!1}joinPath(m,...p){return P.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return L.posix.basename(m.path)}extname(m){return L.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===n.Schemas.file?p=P.URI.file(L.dirname(E(m))).path:(p=L.posix.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===n.Schemas.file?p=P.URI.file(L.normalize(E(m))).path:p=L.posix.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.isEqualAuthority)(m.authority,p.authority))return;if(m.scheme===n.Schemas.file){const S=L.relative(E(m),E(p));return T.isWindows?D.toSlashes(S):S}let f=m.path||"/",d=p.path||"/";if(this._ignorePathCasing(m)){let S=0;for(const w=Math.min(f.length,d.length);S<w&&!(f.charCodeAt(S)!==d.charCodeAt(S)&&f.charAt(S).toLowerCase()!==d.charAt(S).toLowerCase());S++);f=d.substr(0,S)+f.substr(S)}return L.posix.relative(f,d)}resolvePath(m,p){if(m.scheme===n.Schemas.file){const f=P.URI.file(L.resolve(E(m),p));return m.with({authority:f.authority,path:f.path})}return p=D.toPosixPath(p),m.with({path:L.posix.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,A.equalsIgnoreCase)(m,p)}hasTrailingPathSeparator(m,p=L.sep){if(m.scheme===n.Schemas.file){const f=E(m);return f.length>D.getRoot(f).length&&f[f.length-1]===p}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=L.sep){return(0,e.hasTrailingPathSeparator)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=L.sep){let f=!1;if(m.scheme===n.Schemas.file){const d=E(m);f=d!==void 0&&d.length===D.getRoot(d).length&&d[d.length-1]===p}else{p="/";const d=m.path;f=d.length===1&&d.charCodeAt(d.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(m,p)?m.with({path:m.path+"/"}):m}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(y=>y.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,m){const p=[];for(let f=0;f<y.length;f++){const d=m(y[f]);y.some((S,w)=>w===f?!1:(0,e.isEqualOrParent)(d,m(S)))||p.push(y[f])}return p}e.distinctParents=R;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function m(p){const f=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(w=>{const[g,u]=w.split(":");g&&u&&f.set(g,u)});const S=p.path.substring(0,p.path.indexOf(";"));return S&&f.set(y.META_DATA_MIME,S),f}y.parseMetaData=m})(I=e.DataUri||(e.DataUri={}));function v(y,m,p){if(m){let f=y.path;return f&&f[0]!==L.posix.sep&&(f=L.posix.sep+f),y.with({scheme:p,authority:m,path:f})}return y.with({scheme:p})}e.toLocalResource=v}),define(re[5],se([0,1,23,9,3,2,20,4]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=E;function b(Z){const q=new D.CancellationTokenSource,B=Z(q.token),j=new Promise((z,V)=>{const ee=q.token.onCancellationRequested(()=>{ee.dispose(),q.dispose(),V(new n.CancellationError)});Promise.resolve(B).then(ie=>{ee.dispose(),q.dispose(),z(ie)},ie=>{ee.dispose(),q.dispose(),V(ie)})});return new class{cancel(){q.cancel()}then(z,V){return j.then(z,V)}catch(z){return this.then(void 0,z)}finally(z){return j.finally(z)}}}e.createCancelablePromise=b;function R(Z,q,B){return new Promise((j,z)=>{const V=q.onCancellationRequested(()=>{V.dispose(),j(B)});Z.then(j,z).finally(()=>V.dispose())})}e.raceCancellation=R;function I(Z,q){return new Promise((B,j)=>{const z=q.onCancellationRequested(()=>{z.dispose(),j(new n.CancellationError)});Z.then(B,j).finally(()=>z.dispose())})}e.raceCancellationError=I;async function v(Z){let q=-1;const B=Z.map((z,V)=>z.then(ee=>(q=V,ee))),j=await Promise.race(B);return Z.forEach((z,V)=>{V!==q&&z.cancel()}),j}e.raceCancellablePromises=v;function y(Z,q,B){let j;const z=setTimeout(()=>{j?.(void 0),B?.()},q);return Promise.race([Z.finally(()=>clearTimeout(z)),new Promise(V=>j=V)])}e.raceTimeout=y;function m(Z){return new Promise((q,B)=>{const j=Z();E(j)?j.then(q,B):q(j)})}e.asPromise=m;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(B,B).then(j)})}return new Promise((B,j)=>{this.queuedPromise.then(B,j)})}return this.activePromise=q(),new Promise((B,j)=>{this.activePromise.then(z=>{this.activePromise=null,B(z)},z=>{this.activePromise=null,j(z)})})}}e.Throttler=p;class f{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=f;class d{constructor(){this.promiseMap=new Map}queue(q,B){const z=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(q)===z&&this.promiseMap.delete(q)});return this.promiseMap.set(q,z),z}}e.SequencerByKey=d;const S=(Z,q)=>{let B=!0;const j=setTimeout(()=>{B=!1,q()},Z);return{isTriggered:()=>B,dispose:()=>{clearTimeout(j),B=!1}}},w=Z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,Z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(q){this.defaultDelay=q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,B=this.defaultDelay){this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,V)=>{this.doResolve=z,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=B===e.MicrotaskDelay?w(j):S(B,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class u{constructor(q){this.delayer=new g(q),this.throttler=new p}trigger(q,B){return this.delayer.trigger(()=>this.throttler.queue(q),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class t{constructor(){this._isOpen=!1,this._promise=new Promise((q,B)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class r extends t{constructor(q){super();this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function i(Z,q){return q?new Promise((B,j)=>{const z=setTimeout(()=>{V.dispose(),B()},Z),V=q.onCancellationRequested(()=>{clearTimeout(z),V.dispose(),j(new n.CancellationError)})}):b(B=>i(Z,B))}e.timeout=i;function a(Z,q=0){const B=setTimeout(Z,q);return(0,T.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=a;function c(Z){const q=[];let B=0;const j=Z.length;function z(){return B<j?Z[B++]():null}function V(ee){ee!=null&&q.push(ee);const ie=z();return ie?ie.then(V):Promise.resolve(q)}return Promise.resolve(null).then(V)}e.sequence=c;function s(Z,q=j=>!!j,B=null){let j=0;const z=Z.length,V=()=>{if(j>=z)return Promise.resolve(B);const ee=Z[j++];return Promise.resolve(ee()).then(ae=>q(ae)?Promise.resolve(ae):V())};return V()}e.first=s;function o(Z,q=j=>!!j,B=null){if(Z.length===0)return Promise.resolve(B);let j=Z.length;const z=()=>{j=-1;for(const V of Z)V.cancel?.()};return new Promise((V,ee)=>{for(const ie of Z)ie.then(ae=>{--j>=0&&q(ae)?(z(),V(ae)):j===0&&V(B)}).catch(ae=>{--j>=0&&(z(),ee(ae))})})}e.firstParallel=o;class l{constructor(q){this._size=0,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new L.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(q){return this._size++,new Promise((B,j)=>{this.outstandingPromises.push({factory:q,c:B,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const B=q.factory();B.then(q.c,q.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class h extends l{constructor(){super(1)}}e.Queue=h;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const q=new N;return this.drainers.add(q),q.p}isDrained(){for(const[,q]of this.queues)if(q.size>0)return!1;return!0}queueFor(q,B=A.extUri){const j=B.getComparisonKey(q);let z=this.queues.get(j);return z||(z=new h,L.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,z)),z}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const q of this.drainers)q.complete();this.drainers.clear()}dispose(){for(const[,q]of this.queues)q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class M{constructor(q,B){this._token=-1,typeof q=="function"&&typeof B=="number"&&this.setIfNotSet(q,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},B)}setIfNotSet(q,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},B))}}e.TimeoutTimer=M;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(q,B){this.cancel(),this._token=setInterval(()=>{q()},B)}}e.IntervalTimer=O;class U{constructor(q,B){this.timeoutToken=-1,this.runner=q,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class k{constructor(q,B){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=q,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(q=this.timeout){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class F extends U{constructor(q,B){super(q,B);this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner&&this.runner(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class _ extends T.Disposable{constructor(q,B){super();this.options=q,this.handler=B,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.options.maxBufferedWork)return!1}else if(this.pending+q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,P.setTimeout0)(()=>{if(q)return;const B=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.runWhenIdle=(Z,q)=>{const B=requestIdleCallback(Z,typeof q=="number"?{timeout:q}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(B))}}}}();class ${constructor(q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function H(Z,q,B){let j;for(let z=0;z<B;z++)try{return await Z()}catch(V){j=V,await i(q)}throw j}e.retry=H;class ne{hasPending(q){return this._pending?typeof q=="number"?this._pending.taskId===q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(q,B,j){return this._pending={taskId:q,cancel:()=>j?.(),promise:B},B.then(()=>this.donePending(q),()=>this.donePending(q)),B}donePending(q){this._pending&&q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const q=this._next;this._next=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this._next)this._next.run=q;else{let B,j;const z=new Promise((V,ee)=>{B=V,j=ee});this._next={run:q,promise:z,promiseResolve:B,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=ne;class K{constructor(q,B=()=>Date.now()){this.interval=q,this.nowFn=B,this.lastIncrementTime=0,this.value=0}increment(){const q=this.nowFn();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((q,B)=>{this.completeCallback=q,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(q){return new Promise(B=>{this.completeCallback(q),this.resolved=!0,B()})}error(q){return new Promise(B=>{this.errorCallback(q),this.rejected=!0,B()})}cancel(){new Promise(q=>{this.errorCallback(new n.CancellationError),this.rejected=!0,q()})}}e.DeferredPromise=N;var W;(function(Z){async function q(j){let z;const V=await Promise.all(j.map(ee=>ee.then(ie=>ie,ie=>{z||(z=ie)})));if(typeof z!="undefined")throw z;return V}Z.settled=q;function B(j){return new Promise(async(z,V)=>{try{await j(z,V)}catch(ee){V(ee)}})}Z.withAsyncBody=B})(W=e.Promises||(e.Promises={}));var x;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(x||(x={}));class J{constructor(q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const B={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(q(B)),this.resolve()}catch(j){this.reject(j)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}static fromArray(q){return new J(B=>{B.emitMany(q)})}static fromPromise(q){return new J(async B=>{B.emitMany(await q)})}static fromPromises(q){return new J(async B=>{await Promise.all(q.map(async j=>B.emitOne(await j)))})}static merge(q){return new J(async B=>{await Promise.all(q.map(async j=>{for await(const z of j)B.emitOne(z)}))})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(q<this._results.length)return{done:!1,value:this._results[q++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(q,B){return new J(async j=>{for await(const z of q)j.emitOne(B(z))})}map(q){return J.map(this,q)}static filter(q,B){return new J(async j=>{for await(const z of q)B(z)&&j.emitOne(z)})}filter(q){return J.filter(this,q)}static coalesce(q){return J.filter(q,B=>!!B)}coalesce(){return J.coalesce(this)}static async toPromise(q){const B=[];for await(const j of q)B.push(j);return B}toPromise(){return J.toPromise(this)}emitOne(q){this._state===0&&(this._results.push(q),this._onStateChanged.fire())}emitMany(q){this._state===0&&(this._results=this._results.concat(q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(q){this._state===0&&(this._state=2,this._error=q,this._onStateChanged.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class G extends J{constructor(q,B){super(B);this._source=q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=G;function Q(Z){const q=new D.CancellationTokenSource,B=Z(q.token);return new G(q,async j=>{const z=q.token.onCancellationRequested(()=>{z.dispose(),q.dispose(),j.reject(new n.CancellationError)});try{for await(const V of B){if(q.token.isCancellationRequested)return;j.emitOne(V)}z.dispose(),q.dispose()}catch(V){z.dispose(),q.dispose(),j.reject(V)}})}e.createCancelableAsyncIterable=Q}),define(re[80],se([0,1,16,5,41,39,10,4,26]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",I="[^/\\\\]",v=/\//g;function y(N,W){switch(N){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${W?`|${R}${I}+`:""})*?`}}function m(N,W){if(!N)return[];const x=[];let J=!1,G=!1,Q="";for(const Z of N){switch(Z){case W:if(!J&&!G){x.push(Q),Q="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":G=!0;break;case"]":G=!1;break}Q+=Z}return Q&&x.push(Q),x}e.splitGlobAware=m;function p(N){if(!N)return"";let W="";const x=m(N,e.GLOB_SPLIT);if(x.every(J=>J===e.GLOBSTAR))W=".*";else{let J=!1;x.forEach((G,Q)=>{if(G===e.GLOBSTAR){if(J)return;W+=y(2,Q===x.length-1)}else{let Z=!1,q="",B=!1,j="";for(const z of G){if(z!=="}"&&Z){q+=z;continue}if(B&&(z!=="]"||!j)){let V;z==="-"?V=z:(z==="^"||z==="!")&&!j?V="^":z===e.GLOB_SPLIT?V="":V=(0,E.escapeRegExpCharacters)(z),j+=V;continue}switch(z){case"{":Z=!0;continue;case"[":B=!0;continue;case"}":{W+=`(?:${m(q,",").map(ie=>p(ie)).join("|")})`,Z=!1,q="";break}case"]":{W+="["+j+"]",B=!1,j="";break}case"?":W+=I;continue;case"*":W+=y(1);continue;default:W+=(0,E.escapeRegExpCharacters)(z)}}Q<x.length-1&&(x[Q+1]!==e.GLOBSTAR||Q+2<x.length)&&(W+=R)}J=G===e.GLOBSTAR})}return W}const f=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(N,W){if(!N)return i;let x;typeof N!="string"?x=N.pattern:x=N,x=x.trim();const J=`${x}_${!!W.trimForExclusions}`;let G=t.get(J);if(G)return c(G,N);let Q;return f.test(x)?G=o(x.substr(4),x):(Q=d.exec(s(x,W)))?G=l(Q[1],x):(W.trimForExclusions?w:S).test(x)?G=h(x,W):(Q=g.exec(s(x,W)))?G=C(Q[1].substr(1),x,!0):(Q=u.exec(s(x,W)))?G=C(Q[1],x,!1):G=M(x),t.set(J,G),c(G,N)}function c(N,W){if(typeof W=="string")return N;const x=function(J,G){return(0,L.isEqualOrParent)(J,W.base,!P.isLinux)?N(J.substr(W.base.length+1),G):null};return x.allBasenames=N.allBasenames,x.allPaths=N.allPaths,x.basenames=N.basenames,x.patterns=N.patterns,x}function s(N,W){return W.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function o(N,W){return function(x,J){return typeof x=="string"&&x.endsWith(N)?W:null}}function l(N,W){const x=`/${N}`,J=`\\${N}`,G=function(Z,q){return typeof Z!="string"?null:q?q===N?W:null:Z===N||Z.endsWith(x)||Z.endsWith(J)?W:null},Q=[N];return G.basenames=Q,G.patterns=[W],G.allBasenames=Q,G}function h(N,W){const x=ne(N.slice(1,-1).split(",").map(q=>a(q,W)).filter(q=>q!==i),N),J=x.length;if(!J)return i;if(J===1)return x[0];const G=function(q,B){for(let j=0,z=x.length;j<z;j++)if(x[j](q,B))return N;return null},Q=x.find(q=>!!q.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const Z=x.reduce((q,B)=>B.allPaths?q.concat(B.allPaths):q,[]);return Z.length&&(G.allPaths=Z),G}function C(N,W,x){const J=A.sep===A.posix.sep,G=J?N:N.replace(v,A.sep),Q=A.sep+G,Z=A.posix.sep+N;let q;return x?q=function(B,j){return typeof B=="string"&&(B===G||B.endsWith(Q)||!J&&(B===N||B.endsWith(Z)))?W:null}:q=function(B,j){return typeof B=="string"&&(B===G||!J&&B===N)?W:null},q.allPaths=[(x?"*/":"./")+N],q}function M(N){try{const W=new RegExp(`^${p(N)}$`);return function(x){return W.lastIndex=0,typeof x=="string"&&W.test(x)?N:null}}catch{return i}}function O(N,W,x){return!N||typeof W!="string"?!1:U(N)(W,void 0,x)}e.match=O;function U(N,W={}){if(!N)return r;if(typeof N=="string"||k(N)){const x=a(N,W);if(x===i)return r;const J=function(G,Q){return!!x(G,Q)};return x.allBasenames&&(J.allBasenames=x.allBasenames),x.allPaths&&(J.allPaths=x.allPaths),J}return $(N,W)}e.parse=U;function k(N){const W=N;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=k;function F(N){return N.allBasenames||[]}e.getBasenameTerms=F;function _(N){return N.allPaths||[]}e.getPathTerms=_;function $(N,W){const x=ne(Object.getOwnPropertyNames(N).map(q=>H(q,N[q],W)).filter(q=>q!==i)),J=x.length;if(!J)return i;if(!x.some(q=>!!q.requiresSiblings)){if(J===1)return x[0];const q=function(z,V){let ee;for(let ie=0,ae=x.length;ie<ae;ie++){const fe=x[ie](z,V);if(typeof fe=="string")return fe;(0,n.isThenable)(fe)&&(ee||(ee=[]),ee.push(fe))}return ee?(async()=>{for(const ie of ee){const ae=await ie;if(typeof ae=="string")return ae}return null})():null},B=x.find(z=>!!z.allBasenames);B&&(q.allBasenames=B.allBasenames);const j=x.reduce((z,V)=>V.allPaths?z.concat(V.allPaths):z,[]);return j.length&&(q.allPaths=j),q}const G=function(q,B,j){let z,V;for(let ee=0,ie=x.length;ee<ie;ee++){const ae=x[ee];ae.requiresSiblings&&j&&(B||(B=(0,A.basename)(q)),z||(z=B.substr(0,B.length-(0,A.extname)(q).length)));const fe=ae(q,B,z,j);if(typeof fe=="string")return fe;(0,n.isThenable)(fe)&&(V||(V=[]),V.push(fe))}return V?(async()=>{for(const ee of V){const ie=await ee;if(typeof ie=="string")return ie}return null})():null},Q=x.find(q=>!!q.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const Z=x.reduce((q,B)=>B.allPaths?q.concat(B.allPaths):q,[]);return Z.length&&(G.allPaths=Z),G}function H(N,W,x){if(W===!1)return i;const J=a(N,x);if(J===i)return i;if(typeof W=="boolean")return J;if(W){const G=W.when;if(typeof G=="string"){const Q=(Z,q,B,j)=>{if(!j||!J(Z,q))return null;const z=G.replace("$(basename)",B),V=j(z);return(0,n.isThenable)(V)?V.then(ee=>ee?N:null):V?N:null};return Q.requiresSiblings=!0,Q}}return J}function ne(N,W){const x=N.filter(q=>!!q.basenames);if(x.length<2)return N;const J=x.reduce((q,B)=>{const j=B.basenames;return j?q.concat(j):q},[]);let G;if(W){G=[];for(let q=0,B=J.length;q<B;q++)G.push(W)}else G=x.reduce((q,B)=>{const j=B.patterns;return j?q.concat(j):q},[]);const Q=function(q,B){if(typeof q!="string")return null;if(!B){let z;for(z=q.length;z>0;z--){const V=q.charCodeAt(z-1);if(V===47||V===92)break}B=q.substr(z)}const j=J.indexOf(B);return j!==-1?G[j]:null};Q.basenames=J,Q.patterns=G,Q.allBasenames=J;const Z=N.filter(q=>!q.basenames);return Z.push(Q),Z}function K(N,W){return(0,D.equals)(N,W,(x,J)=>typeof x=="string"&&typeof J=="string"?x===J:typeof x!="string"&&typeof J!="string"?x.base===J.base&&x.pattern===J.pattern:!1)}e.patternsEquals=K}),define(re[115],se([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(R){return R.toJSON()}class L{constructor(I){this._uriTransformer=I}transformIncoming(I){const v=this._uriTransformer.transformIncoming(I);return v===I?I:n(D.URI.from(v))}transformOutgoing(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:n(D.URI.from(v))}transformOutgoingURI(I){const v=this._uriTransformer.transformOutgoing(I);return v===I?I:D.URI.from(v)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function T(R,I,v){if(!R||v>200)return null;if(typeof R=="object"){if(R instanceof D.URI)return I.transformOutgoing(R);for(let y in R)if(Object.hasOwnProperty.call(R,y)){const m=T(R[y],I,v+1);m!==null&&(R[y]=m)}}return null}function A(R,I){const v=T(R,I,0);return v===null?R:v}e.transformOutgoingURIs=A;function P(R,I,v,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return v?D.URI.revive(I.transformIncoming(R)):I.transformIncoming(R);for(let m in R)if(Object.hasOwnProperty.call(R,m)){const p=P(R[m],I,v,y+1);p!==null&&(R[m]=p)}}return null}function E(R,I){const v=P(R,I,!1,0);return v===null?R:v}e.transformIncomingURIs=E;function b(R,I){const v=P(R,I,!0,0);return v===null?R:v}e.transformAndReviveIncomingURIs=b}),define(re[30],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(L){return D.test(L)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const T=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){L(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let E=0,b="";return b+=A[T[E++]],b+=A[T[E++]],b+=A[T[E++]],b+=A[T[E++]],b+="-",b+=A[T[E++]],b+=A[T[E++]],b+="-",b+=A[T[E++]],b+=A[T[E++]],b+="-",b+=A[T[E++]],b+=A[T[E++]],b+="-",b+=A[T[E++]],b+=A[T[E++]],b+=A[T[E++]],b+=A[T[E++]],b+=A[T[E++]],b+=A[T[E++]],b}}()}),define(re[116],se([0,1,259]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return A;let E=0,b,R=E;for(;R<P.length;)if(b=P.charCodeAt(R),b===13||b===10){if(A.push(P.substring(E,R)),R++,R<P.length){const I=b;b=P.charCodeAt(R),(I===13&&b===10||I===10&&b===13)&&R++}E=R}else R++;return this.remaining=E<P.length?P.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(re[117],se([0,1,35]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(A){const P=A.replace(/\-/g,":").toLowerCase();return!n.has(P)}function T(){const A=(0,D.networkInterfaces)();for(let P in A){const E=A[P];if(E){for(const{mac:b}of E)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(re[118],se([0,1,35,9,39,30,117]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(R){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(R)}value(){if(this._value===void 0){let R=0,I=0;const v=(0,D.networkInterfaces)();for(let y in v){const m=v[y];if(m)for(const{mac:p,internal:f}of m)f||(I+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(R+=1))}this._value=I>0?R/I:0}return this._value}};let P;async function E(){return P||(P=(async()=>await b()||T.generateUuid())()),P}e.getMachineId=E;async function b(){try{const R=await new Promise((v,y)=>{X(["crypto"],v,y)}),I=(0,A.getMac)();return R.createHash("sha256").update(I,"utf8").digest("hex")}catch(R){n.onUnexpectedError(R);return}}}),define(re[27],se([0,1,51,35,260,5,41,77,10,4,20,7]),function(X,e,D,n,L,T,A,P,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function y(_,$=v.UNLINK){if((0,A.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return $===v.UNLINK?p(_):m(_)}async function m(_){try{const $=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename(_,$)}catch{return p(_)}p($).catch(H=>{})}catch($){if($.code!=="ENOENT")throw $}}async function p(_){return(0,L.promisify)(D.rm)(_,{recursive:!0,force:!0,maxRetries:3})}function f(_){if((0,A.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function d(_,$){return g(await($?S(_):(0,L.promisify)(D.readdir)(_)))}async function S(_){try{return await(0,L.promisify)(D.readdir)(_,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const $=[],H=await d(_);for(const ne of H){let K=!1,N=!1,W=!1;try{const x=await e.Promises.lstat((0,E.join)(_,ne));K=x.isFile(),N=x.isDirectory(),W=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}$.push({name:ne,isFile:()=>K,isDirectory:()=>N,isSymbolicLink:()=>W})}return $}function w(_){return g(D.readdirSync(_))}e.readdirSync=w;function g(_){return _.map($=>typeof $=="string"?b.isMacintosh?(0,P.normalizeNFC)($):$:($.name=b.isMacintosh?(0,P.normalizeNFC)($.name):$.name,$))}async function u(_){const $=await d(_),H=[];for(const ne of $)await r.existsDirectory((0,E.join)(_,ne))&&H.push(ne);return H}function t(_,$=1e3){return new Promise(H=>{let ne=!1;const K=setInterval(()=>{ne||(ne=!0,D.access(_,N=>{ne=!1,N&&(clearInterval(K),H(void 0))}))},$)})}e.whenDeleted=t;var r;(function(_){async function $(K){let N;try{if(N=await e.Promises.lstat(K),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(b.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw x}throw W}}_.stat=$;async function H(K){try{const{stat:N,symbolicLink:W}=await _.stat(K);return N.isFile()&&W?.dangling!==!0}catch{}return!1}_.existsFile=H;async function ne(K){try{const{stat:N,symbolicLink:W}=await _.stat(K);return N.isDirectory()&&W?.dangling!==!0}catch{}return!1}_.existsDirectory=ne})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function a(_,$,H){return i.queueFor(I.URI.file(_),R.extUriBiasedIgnorePathCase).queue(()=>{const ne=l(H);return new Promise((K,N)=>s(_,$,ne,W=>W?N(W):K()))})}let c=!0;function s(_,$,H,ne){if(!c)return D.writeFile(_,$,{mode:H.mode,flag:H.flag},ne);D.open(_,H.flag,H.mode,(K,N)=>{if(K)return ne(K);D.writeFile(N,$,W=>{if(W)return D.close(N,()=>ne(W));D.fdatasync(N,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),c=!1),D.close(N,J=>ne(J))))})})}function o(_,$,H){const ne=l(H);if(!c)return D.writeFileSync(_,$,{mode:ne.mode,flag:ne.flag});const K=D.openSync(_,ne.flag,ne.mode);try{D.writeFileSync(K,$);try{D.fdatasyncSync(K)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),c=!1}}finally{D.closeSync(K)}}e.writeFileSync=o;function l(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function h(_,$){if(_!==$)try{await e.Promises.rename(_,$)}catch(H){if(_.toLowerCase()!==$.toLowerCase()&&H.code==="EXDEV"||_.endsWith("."))await C(_,$,{preserveSymlinks:!1}),await y(_,v.MOVE);else throw H}}async function C(_,$,H){return O(_,$,{root:{source:_,target:$},options:H,handledSourcePaths:new Set})}const M=511;async function O(_,$,H){if(H.handledSourcePaths.has(_))return;H.handledSourcePaths.add(_);const{stat:ne,symbolicLink:K}=await r.stat(_);if(K){if(H.options.preserveSymlinks)try{return await F(_,$,H)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(K.dangling)return}return ne.isDirectory()?U(_,$,ne.mode&M,H):k(_,$,ne.mode&M)}async function U(_,$,H,ne){await e.Promises.mkdir($,{recursive:!0,mode:H});const K=await d(_);for(const N of K)await O((0,E.join)(_,N),(0,E.join)($,N),ne)}async function k(_,$,H){await e.Promises.copyFile(_,$),await e.Promises.chmod($,H)}async function F(_,$,H){let ne=await e.Promises.readlink(_);(0,A.isEqualOrParent)(ne,H.root.source,!b.isLinux)&&(ne=(0,E.join)(H.root.target,ne.substr(H.root.source.length+1))),await e.Promises.symlink(ne,$)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(_,$,H,ne,K)=>new Promise((N,W)=>{D.read(_,$,H,ne,K,(x,J,G)=>x?W(x):N({bytesRead:J,buffer:G}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(_,$,H,ne,K)=>new Promise((N,W)=>{D.write(_,$,H,ne,K,(x,J,G)=>x?W(x):N({bytesWritten:J,buffer:G}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return a}get rm(){return y}get move(){return h}get copy(){return C}}}),define(re[119],se([0,1,51,10,4,26,27]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(L.isLinux)return v;const y=(0,n.dirname)(v);if(v===y)return v;const m=((0,n.basename)(v)||v).toLowerCase();try{const f=(0,A.readdirSync)(y).filter(d=>d.toLowerCase()===m);if(f.length===1){const d=P(y);if(d)return(0,n.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(m);if(d>=0){const S=P(y);if(S)return(0,n.join)(S,f[d])}}}catch{}return null}e.realcaseSync=P;async function E(v){if(L.isLinux)return v;const y=(0,n.dirname)(v);if(v===y)return v;const m=((0,n.basename)(v)||v).toLowerCase();try{const f=(await A.Promises.readdir(y)).filter(d=>d.toLowerCase()===m);if(f.length===1){const d=await E(y);if(d)return(0,n.join)(d,f[0])}else if(f.length>1){const d=f.indexOf(m);if(d>=0){const S=await E(y);if(S)return(0,n.join)(S,f[d])}}}catch{}return null}e.realcase=E;async function b(v){try{return await A.Promises.realpath(v)}catch{const m=I(v);return await A.Promises.access(m,D.constants.R_OK),m}}e.realpath=b;function R(v){try{return D.realpathSync(v)}catch{const m=I(v);return D.accessSync(m,D.constants.R_OK),m}}e.realpathSync=R;function I(v){return(0,T.rtrim)((0,n.normalize)(v),n.sep)}}),define(re[120],se([0,1,58]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(P,E,b,R=1){let I=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!I)return I=!0,v(0)},b);L(P,E,R,m=>{if(!I)return I=!0,clearTimeout(y),v(m)})})}e.findFreePort=n;function L(P,E,b,R){if(E===0)return R(0);const I=new D.Socket;I.once("connect",()=>(A(I),L(P+b,E-1,b,R))),I.once("data",()=>{}),I.once("error",v=>(A(I),v.code!=="ECONNREFUSED"?L(P+b,E-1,b,R):R(P))),I.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(P,E,b){let R=!1,I,v=1;const y=D.createServer({pauseOnConnect:!0});function m(p,f){R||(R=!0,y.removeAllListeners(),y.close(),I&&clearTimeout(I),f(p))}return new Promise(p=>{I=setTimeout(()=>{m(0,p)},b),y.on("listening",()=>{m(P,p)}),y.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&v<E?(P++,v++,y.listen(P,"127.0.0.1")):m(0,p)}),y.on("close",()=>{m(0,p)}),y.listen(P,"127.0.0.1")})}e.findFreePortFaster=T;function A(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(E){console.error(E)}}}),define(re[81],se([0,1,35,10,27]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var E;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class I{constructor(u,t,r){this.exePath=u,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:g=!1}={}){return g?b===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:g=!1,findPreview:u=!1}={}){const t=v({useAlternateBitness:g});if(!t)return null;const r=n.join(t,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const o of await L.Promises.readdir(r)){let l=-1;if(u){const C=o.indexOf("-");if(C<0)continue;const M=o.substring(0,C);if(!T.test(M)||o.substring(C+1)!=="preview")continue;l=parseInt(M,10)}else{if(!T.test(o))continue;l=parseInt(o,10)}if(l<=i)continue;const h=n.join(r,o,"pwsh.exe");!await L.SymlinkSupport.existsFile(h)||(a=h,i=l)}if(!a)return null;const c=t.includes("x86")?" (x86)":"",s=u?" Preview":"";return new I(a,`PowerShell${s}${c}`,!0)}async function m({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const u=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=g?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(u))if(t.test(i)){const a=n.join(u,i,"pwsh.exe");return new I(a,r)}return null}function p(){const g=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new I(g,".NET Core PowerShell Global Tool")}function f(){const g=n.join(process.env.windir,b===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(g,"Windows PowerShell",!0)}async function*d(){let g=await y();g&&(yield g),g=await y({useAlternateBitness:!0}),g&&(yield g),g=await m(),g&&(yield g),g=p(),g&&(yield g),g=await y({findPreview:!0}),g&&(yield g),g=await m({findPreview:!0}),g&&(yield g),g=await y({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=f(),g&&(yield g)}async function*S(){for await(const g of d())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=S;async function w(){for await(const g of S())return g;return null}e.getFirstAvailablePowerShellInstallation=w}),define(re[121],se([0,1,45,19]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(A){return new Promise((P,E)=>{let b;const R=new Map;function I(y,m,p,f,d){const S=R.get(m);if(y===A||S){const w={name:v(p),cmd:p,pid:y,ppid:m,load:f,mem:d};R.set(y,w),y===A&&(b=w),S&&(S.children||(S.children=[]),S.children.push(w),S.children.length>1&&(S.children=S.children.sort((g,u)=>g.pid-u.pid)))}}function v(y){const m=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,S=/--crashes-directory/,w=/\\pipe\\winpty-control/,g=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(S.exec(y))return"electron-crash-reporter";if(w.exec(y))return"winpty-process";if(g.exec(y))return"console-window-host (Windows internal process)";let t=u.exec(y);if(t&&t.length===2)return t[1]==="renderer"?m.exec(y)?"shared-process":p.exec(y)?"issue-reporter":f.exec(y)?"process-explorer":"window":t[1]==="utility"&&d.exec(y)?"utility-network-service":t[1];const r=/[a-zA-Z-]+\.js/g;let i="";do t=r.exec(y),t&&(i+=t+" ");while(t);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,p)=>{X(["windows-process-tree"],m,p)}).then(m=>{m.getProcessList(A,p=>{if(!p){E(new Error(`Root process ${A} not found`));return}m.getProcessCpuUsage(p,f=>{const d=new Map;f.forEach(S=>{const w=y(S.commandLine||"");d.set(S.pid,{name:v(w),cmd:w,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),b=d.get(A),b?(d.forEach(S=>{const w=d.get(S.ppid);w&&(w.children||(w.children=[]),w.children.push(S))}),d.forEach(S=>{S.children&&(S.children=S.children.sort((w,g)=>w.pid-g.pid))}),P(b)):E(new Error(`Root process ${A} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let y=function(){let m=[b];const p=[];for(;m.length;){const d=m.shift();d&&(p.push(d.pid),d.children&&(m=m.concat(d.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);f+=" "+p.join(" "),(0,D.exec)(f,{},(d,S,w)=>{if(d||w)E(d||new Error(w.toString()));else{const g=S.toString().split(`
`);for(let u=0;u<p.length;u++){const t=R.get(p[u]);t.load=parseFloat(g[u])}if(!b){E(new Error(`Root process ${A} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(m,p,f)=>{if(m||f)if(process.platform!=="linux")E(m||new Error(f.toString()));else{const d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,D.exec)(d,{},(S,w,g)=>{S||g?E(S||new Error(g.toString())):(T(w,I),y())})}else{const d=p.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${d} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,g,u)=>{w||u&&!u.includes("screen size is bogus")?E(w||new Error(u.toString())):(T(g,I),process.platform==="linux"?y():b?P(b):E(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=L;function T(A,P){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=A.toString().split(`
`);for(const R of b){const I=E.exec(R.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}});var de=this&&this.__decorate||function(X,e,D,n){var L=arguments.length,T=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(X,e,D,n);else for(var P=X.length-1;P>=0;P--)(A=X[P])&&(T=(L<3?A(T):L>3?A(e,D,T):A(e,D))||T);return L>3&&T&&Object.defineProperty(e,D,T),T};define(re[36],se([0,1,16,5,17,23,57,9,3,2,79,26,13]),function(X,e,D,n,L,T,A,P,E,b,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function m(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function f(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(d||(d={}));class S{constructor(W){this.buffer=W,this.pos=0}read(W){const x=this.buffer.slice(this.pos,this.pos+W);return this.pos+=x.byteLength,x}}class w{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(W){this.buffers.push(W)}}var g;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(g||(g={}));function u(N){const W=L.VSBuffer.alloc(4);return W.writeUInt32BE(N,0),W}function t(N){return N.read(4).readUInt32BE(0)}function r(N){const W=L.VSBuffer.alloc(1);return W.writeUInt8(N,0),W}const i={Undefined:r(g.Undefined),String:r(g.String),Buffer:r(g.Buffer),VSBuffer:r(g.VSBuffer),Array:r(g.Array),Object:r(g.Object)},a=typeof Buffer!="undefined";function c(N,W){if(typeof W=="undefined")N.write(i.Undefined);else if(typeof W=="string"){const x=L.VSBuffer.fromString(W);N.write(i.String),N.write(u(x.byteLength)),N.write(x)}else if(a&&Buffer.isBuffer(W)){const x=L.VSBuffer.wrap(W);N.write(i.Buffer),N.write(u(x.byteLength)),N.write(x)}else if(W instanceof L.VSBuffer)N.write(i.VSBuffer),N.write(u(W.byteLength)),N.write(W);else if(Array.isArray(W)){N.write(i.Array),N.write(u(W.length));for(const x of W)c(N,x)}else{const x=L.VSBuffer.fromString(JSON.stringify(W));N.write(i.Object),N.write(u(x.byteLength)),N.write(x)}}function s(N){switch(N.read(1).readUInt8(0)){case g.Undefined:return;case g.String:return N.read(t(N)).toString();case g.Buffer:return N.read(t(N)).buffer;case g.VSBuffer:return N.read(t(N));case g.Array:{const x=t(N),J=[];for(let G=0;G<x;G++)J.push(s(N));return J}case g.Object:return JSON.parse(N.read(t(N)).toString())}}class o{constructor(W,x,J=null,G=1e3){this.protocol=W,this.ctx=x,this.logger=J,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(W,x){this.channels.set(W,x),setTimeout(()=>this.flushPendingRequests(W),0)}sendResponse(W){switch(W.type){case 200:{const x=this.send([W.type]);this.logger?.logOutgoing(x,0,1,f(W.type));return}case 201:case 202:case 204:case 203:{const x=this.send([W.type,W.id],W.data);this.logger?.logOutgoing(x,W.id,1,f(W.type),W.data);return}}}send(W,x=void 0){const J=new w;return c(J,W),c(J,x),this.sendBuffer(J.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onRawMessage(W){const x=new S(W),J=s(x),G=s(x),Q=J[0];switch(Q){case 100:return this.logger?.logIncoming(W.byteLength,J[1],1,`${m(Q)}: ${J[2]}.${J[3]}`,G),this.onPromise({type:Q,id:J[1],channelName:J[2],name:J[3],arg:G});case 102:return this.logger?.logIncoming(W.byteLength,J[1],1,`${m(Q)}: ${J[2]}.${J[3]}`,G),this.onEventListen({type:Q,id:J[1],channelName:J[2],name:J[3],arg:G});case 101:return this.logger?.logIncoming(W.byteLength,J[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:J[1]});case 103:return this.logger?.logIncoming(W.byteLength,J[1],1,`${m(Q)}`),this.disposeActiveRequest({type:Q,id:J[1]})}}onPromise(W){const x=this.channels.get(W.channelName);if(!x){this.collectPendingRequest(W);return}const J=new T.CancellationTokenSource;let G;try{G=x.call(this.ctx,W.name,W.arg,J.token)}catch(q){G=Promise.reject(q)}const Q=W.id;G.then(q=>{this.sendResponse({id:Q,data:q,type:201}),this.activeRequests.delete(W.id)},q=>{q instanceof Error?this.sendResponse({id:Q,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:Q,data:q,type:203}),this.activeRequests.delete(W.id)});const Z=(0,b.toDisposable)(()=>J.cancel());this.activeRequests.set(W.id,Z)}onEventListen(W){const x=this.channels.get(W.channelName);if(!x){this.collectPendingRequest(W);return}const J=W.id,Q=x.listen(this.ctx,W.name,W.arg)(Z=>this.sendResponse({id:J,data:Z,type:204}));this.activeRequests.set(W.id,Q)}disposeActiveRequest(W){const x=this.activeRequests.get(W.id);x&&(x.dispose(),this.activeRequests.delete(W.id))}collectPendingRequest(W){let x=this.pendingRequests.get(W.channelName);x||(x=[],this.pendingRequests.set(W.channelName,x));const J=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.sendResponse({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:W,timeoutTimer:J})}flushPendingRequests(W){const x=this.pendingRequests.get(W);if(x){for(const J of x)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.onPromise(J.request);break;case 102:this.onEventListen(J.request);break}this.pendingRequests.delete(W)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var l;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class h{constructor(W,x=null){this.protocol=W,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(J=>this.onBuffer(J)),this.logger=x}getChannel(W){const x=this;return{call(J,G,Q){return x.isDisposed?Promise.reject(P.canceled()):x.requestPromise(W,J,G,Q)},listen(J,G){return x.isDisposed?E.Event.None:x.requestEvent(W,J,G)}}}requestPromise(W,x,J,G=T.CancellationToken.None){const Q=this.lastRequestId++,q={id:Q,type:100,channelName:W,name:x,arg:J};if(G.isCancellationRequested)return Promise.reject(P.canceled());let B;return new Promise((z,V)=>{if(G.isCancellationRequested)return V(P.canceled());const ee=()=>{const pe=we=>{switch(we.type){case 201:this.handlers.delete(Q),z(we.data);break;case 202:{this.handlers.delete(Q);const ge=new Error(we.data.message);ge.stack=we.data.stack,ge.name=we.data.name,V(ge);break}case 203:this.handlers.delete(Q),V(we.data);break}};this.handlers.set(Q,pe),this.sendRequest(q)};let ie=null;this.state===d.Idle?ee():(ie=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ie.then(()=>{ie=null,ee()}));const ae=()=>{ie?(ie.cancel(),ie=null):this.sendRequest({id:Q,type:101}),V(P.canceled())},fe=G.onCancellationRequested(ae);B=(0,b.combinedDisposable)((0,b.toDisposable)(ae),fe),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(W,x,J){const G=this.lastRequestId++,Z={id:G,type:102,channelName:W,name:x,arg:J};let q=null;const B=new E.Emitter({onFirstListenerAdd:()=>{q=(0,n.createCancelablePromise)(z=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(B),this.sendRequest(Z)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(B),this.sendRequest({id:G,type:103}))}}),j=z=>B.fire(z.data);return this.handlers.set(G,j),B.event}sendRequest(W){switch(W.type){case 100:case 102:{const x=this.send([W.type,W.id,W.channelName,W.name],W.arg);this.logger&&this.logger.logOutgoing(x,W.id,0,`${m(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const x=this.send([W.type,W.id]);this.logger&&this.logger.logOutgoing(x,W.id,0,m(W.type));return}}}send(W,x=void 0){const J=new w;return c(J,W),c(J,x),this.sendBuffer(J.buffer)}sendBuffer(W){try{return this.protocol.send(W),W.byteLength}catch{return 0}}onBuffer(W){const x=new S(W),J=s(x),G=s(x),Q=J[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(W.byteLength,0,0,f(Q)),this.onResponse({type:J[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(W.byteLength,J[1],0,f(Q),G),this.onResponse({type:J[0],id:J[1],data:G})}}onResponse(W){if(W.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(W.id);x&&x(W)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([A.memoize],h.prototype,"onDidInitializePromise",null),e.ChannelClient=h;class C{constructor(W){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,W(({protocol:x,onDidClientDisconnect:J})=>{E.Event.once(x.onMessage)(Q=>{const Z=new S(Q),q=s(Z),B=new o(x,q),j=new h(x);this.channels.forEach((V,ee)=>B.registerChannel(ee,V));const z={channelServer:B,channelClient:j,ctx:q};this._connections.add(z),this._onDidAddConnection.fire(z),J(()=>{B.dispose(),j.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const W=[];return this._connections.forEach(x=>W.push(x)),W}getChannel(W,x){const J=this;return{call(G,Q,Z){let q;if((0,v.isFunction)(x)){let j=(0,D.getRandomElement)(J.connections.filter(x));q=j?Promise.resolve(j):E.Event.toPromise(E.Event.filter(J.onDidAddConnection,x))}else q=x.routeCall(J,G,Q);const B=q.then(j=>j.channelClient.getChannel(W));return O(B).call(G,Q,Z)},listen(G,Q){if((0,v.isFunction)(x))return J.getMulticastEvent(W,x,G,Q);const Z=x.routeEvent(J,G,Q).then(q=>q.channelClient.getChannel(W));return O(Z).listen(G,Q)}}}getMulticastEvent(W,x,J,G){const Q=this;let Z=new b.DisposableStore;const q=new E.Emitter({onFirstListenerAdd:()=>{Z=new b.DisposableStore;const B=new E.EventMultiplexer,j=new Map,z=ee=>{const ae=ee.channelClient.getChannel(W).listen(J,G),fe=B.add(ae);j.set(ee,fe)},V=ee=>{const ie=j.get(ee);!ie||(ie.dispose(),j.delete(ee))};Q.connections.filter(x).forEach(z),E.Event.filter(Q.onDidAddConnection,x)(z,void 0,Z),Q.onDidRemoveConnection(V,void 0,Z),B.event(q.fire,q,Z),Z.add(B)},onLastListenerRemove:()=>{Z.dispose()}});return q.event}registerChannel(W,x){this.channels.set(W,x),this._connections.forEach(J=>{J.channelServer.registerChannel(W,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class M{constructor(W,x,J=null){const G=new w;c(G,x),W.send(G.buffer),this.channelClient=new h(W,J),this.channelServer=new o(W,x,J)}getChannel(W){return this.channelClient.getChannel(W)}registerChannel(W,x){this.channelServer.registerChannel(W,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function O(N){return{call(W,x,J){return N.then(G=>G.call(W,x,J))},listen(W,x){const J=new E.Relay;return N.then(G=>J.input=G.listen(W,x)),J.event}}}e.getDelayedChannel=O;function U(N){let W=!1;return{call(x,J,G){return W?N.call(x,J,G):(0,n.timeout)(0).then(()=>W=!0).then(()=>N.call(x,J,G))},listen(x,J){if(W)return N.listen(x,J);const G=new E.Relay;return(0,n.timeout)(0).then(()=>W=!0).then(()=>G.input=N.listen(x,J)),G.event}}}e.getNextTickChannel=U;class k{constructor(W){this.fn=W}routeCall(W){return this.route(W)}routeEvent(W){return this.route(W)}async route(W){for(const x of W.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await E.Event.toPromise(W.onDidAddConnection),await this.route(W)}}e.StaticRouter=k;var F;(function(N){function W(Q,Z){const q=Q,B=Z&&Z.disableMarshalling,j=new Map;for(const z in q)J(z)&&j.set(z,E.Event.buffer(q[z],!0));return new class{listen(z,V,ee){const ie=j.get(V);if(ie)return ie;if(G(V)){const ae=q[V];if(typeof ae=="function")return ae.call(q,ee)}throw new Error(`Event not found: ${V}`)}call(z,V,ee){const ie=q[V];if(typeof ie=="function"){if(!B&&Array.isArray(ee))for(let ae=0;ae<ee.length;ae++)ee[ae]=(0,R.revive)(ee[ae]);return ie.apply(q,ee)}throw new Error(`Method not found: ${V}`)}}}N.fromService=W;function x(Q,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(B,j){if(typeof j=="string")return Z?.properties?.has(j)?Z.properties.get(j):G(j)?function(z){return Q.listen(j,z)}:J(j)?Q.listen(j):async function(...z){let V;Z&&!(0,v.isUndefinedOrNull)(Z.context)?V=[Z.context,...z]:V=z;const ee=await Q.call(j,V);return q?ee:(0,R.revive)(ee)};throw new Error(`Property not found: ${String(j)}`)}})}N.toService=x;function J(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function G(Q){return/^onDynamic/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let W=N.toString();if(W!=="[object Object]")return W}return N}function H(N){return Array.isArray(N)?N.map($):$(N)}function ne(N,W,x,J,G,Q,Z){Z=H(Z);const q=_[G],B=q[J%q.length];let j=[`%c[${N}]%c[${String(W).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(Q)?(j=j.concat(Z),j.push(")")):j.push(Z),console.log.apply(console,j)}e.logWithColors=ne;class K{constructor(W,x){this._outgoingPrefix=W,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(W,x,J,G,Q){this._totalOutgoing+=W,ne(this._outgoingPrefix,this._totalOutgoing,W,x,J,G,Q)}logIncoming(W,x,J,G,Q){this._totalIncoming+=W,ne(this._incomingPrefix,this._totalIncoming,W,x,J,G,Q)}}e.IPCLogger=K}),define(re[122],se([0,1,17,3,36]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(E){this.port=E,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends L.IPCClient{constructor(E,b){const R=new T(E);super(R,b);this.protocol=R}dispose(){this.protocol.disconnect()}}e.Client=A}),define(re[82],se([0,1,17,3,2,36]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const c=new WeakMap;let s=0;function o(h,C){if(!c.has(h)){const M=String(++s);c.set(h,M)}return c.get(h)}function l(h,C,M,O){if(!a.enableDiagnostics)return;const U=o(h,C);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const k=D.VSBuffer.alloc(O.byteLength);k.set(O),a.records.push({timestamp:Date.now(),id:U,label:C,type:M,buff:k})}else a.records.push({timestamp:Date.now(),id:U,label:C,type:M,data:O})}a.traceSocketEvent=l})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function R(){return b||(b=D.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(c){this._chunks.push(c),this._totalLength+=c.byteLength}read(c){return this._read(c,!0)}peek(c){return this._read(c,!1)}_read(c,s){if(c===0)return R();if(c>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===c){const C=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=c),C}if(this._chunks[0].byteLength>c){const C=this._chunks[0].slice(0,c);return s&&(this._chunks[0]=this._chunks[0].slice(c),this._totalLength-=c),C}let o=D.VSBuffer.alloc(c),l=0,h=0;for(;c>0;){const C=this._chunks[h];if(C.byteLength>c){const M=C.slice(0,c);o.set(M,l),l+=c,s&&(this._chunks[h]=C.slice(c),this._totalLength-=c),c-=c}else o.set(C,l),l+=C.byteLength,s?(this._chunks.shift(),this._totalLength-=C.byteLength):h++,c-=C.byteLength}return o}}e.ChunkStream=I;var v;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume"})(v||(v={}));function y(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var m;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(c,s,o,l){this.type=c,this.id=s,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.Disposable{constructor(c){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=c,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,l=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new p(o,l,h,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(c){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=c,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(c){if(this._isDisposed)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(c.type,0),s.writeUInt32BE(c.id,1),s.writeUInt32BE(c.ack,5),s.writeUInt32BE(c.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",c.data),this._writeSoon(s,c.data)}_bufferAdd(c,s){const o=this._totalLength===0;return this._data.push(c,s),this._totalLength+=c.byteLength+s.byteLength,o}_bufferTake(){const c=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,c}_writeSoon(c,s){this._bufferAdd(c,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const c=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this._socket.write(c)}}class S extends L.Disposable{constructor(c){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=c,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(c){this._socketWriter.write(new p(1,0,0,c))}}e.Protocol=S;class w extends T.IPCClient{constructor(c,s,o=null){super(c,s,o);this.protocol=c}static fromSocket(c,s){return new w(new S(c),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const c=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),c.end()}}e.Client=w;class g{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(c){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(c):this._emitter.fire(c):this._bufferedMessages.push(c)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=g;class u{constructor(c){this.data=c,this.next=null}}class t{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let c=[],s=0,o=this._first;for(;o;)c[s++]=o.data,o=o.next;return c}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(c){const s=new u(c);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class r{constructor(){this.lastRuns=[];const c=Date.now();for(let s=0;s<r._HISTORY_LENGTH;s++)this.lastRuns[s]=c-1e3*s;setInterval(()=>{for(let s=r._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const c=Date.now(),s=(1+r._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<r._HISTORY_LENGTH;l++)c-this.lastRuns[l]<=s&&o++;return 1-o/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class i{constructor(c,s=null,o=r.getInstance()){this._onControlMessage=new g,this.onControlMessage=this._onControlMessage.event,this._onMessage=new g,this.onMessage=this._onMessage.event,this._onDidDispose=new g,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new g,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new g,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=c,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const c=new p(5,0,0,R());this._socketWriter.write(c),this._socketWriter.flush()}sendPause(){const c=new p(7,0,0,R());this._socketWriter.write(c)}sendResume(){const c=new p(8,0,0,R());this._socketWriter.write(c)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(c,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=c,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const c=new p(3,0,this._incomingAckId,R());this._socketWriter.write(c);const s=this._outgoingUnackMsg.toArray();for(let o=0,l=s.length;o<l;o++)this._socketWriter.write(s[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(c){if(c.ack>this._outgoingAckId){this._outgoingAckId=c.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=c.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this._incomingMsgId)if(c.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new p(6,0,0,R())))}else this._incomingMsgId=c.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(c.data);break}case 2:{this._onControlMessage.fire(c.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let o=0,l=s.length;o<l;o++)this._socketWriter.write(s[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(c){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new p(1,s,this._incomingAckId,c);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(c){const s=new p(2,0,0,c);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const c=Date.now()-this._incomingMsgLastTime;if(c>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-c+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const c=this._outgoingUnackMsg.peek(),s=Date.now()-c.writtenTime,o=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&o>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const h=Math.max(2e4-s,2e4-o,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},h)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const c=new p(3,0,this._incomingAckId,R());this._socketWriter.write(c)}}e.PersistentProtocol=i}),define(re[123],se([0,1,83,3,36,122]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends L.IPCServer{static getOnDidClientConnect(){const E=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,R)=>R);return n.Event.map(E,b=>{const{port1:R,port2:I}=new MessageChannel,y={protocol:new T.Protocol(R),onDidClientDisconnect:n.Event.fromDOMEventEmitter(R,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[I]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(re[124],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function n(T){return T instanceof L?!0:T instanceof Error&&T.name===D&&T.message===D}e.isOfflineError=n;class L extends Error{constructor(){super(D);this.name=this.message}}e.OfflineError=L}),define(re[125],se([0,1,17,9,124]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(E,b){if(!navigator.onLine)throw new L.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const R=new XMLHttpRequest;return new Promise((I,v)=>{R.open(E.type||"GET",E.url||"",!0,E.user,E.password),A(R,E),R.responseType="arraybuffer",R.onerror=y=>v(new Error(R.statusText&&"XHR failed: "+R.statusText||"XHR failed")),R.onload=y=>{I({res:{statusCode:R.status,headers:P(R)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(R.response)))})},R.ontimeout=y=>v(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(R.timeout=E.timeout),R.send(E.data),b.onCancellationRequested(()=>{R.abort(),v((0,n.canceled)())})})}e.request=T;function A(E,b){if(b.headers){e:for(let R in b.headers){switch(R){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(R,b.headers[R])}}}function P(E){const b=Object.create(null);for(const R of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(R){const I=R.indexOf(":");b[R.substr(0,I).trim().toLowerCase()]=R.substr(I+1).trim()}return b}}),define(re[84],se([0,1,5,3,2,13]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function P(I){const v=I;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var E;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends L.Disposable{constructor(v,y=Object.create(null)){super();this.database=v,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((y,m)=>this.accept(m,y)),v.deleted?.forEach(y=>this.accept(y,void 0))}accept(v,y){if(this.state===E.Closed)return;let m=!1;(0,T.isUndefinedOrNull)(y)?m=this.cache.delete(v):this.cache.get(v)!==y&&(this.cache.set(v,y),m=!0),m&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,y){const m=this.cache.get(v);return(0,T.isUndefinedOrNull)(m)?y:m}getBoolean(v,y){const m=this.get(v);return(0,T.isUndefinedOrNull)(m)?y:m==="true"}getNumber(v,y){const m=this.get(v);return(0,T.isUndefinedOrNull)(m)?y:parseInt(m,10)}async set(v,y){if(this.state===E.Closed)return;if((0,T.isUndefinedOrNull)(y))return this.delete(v);const m=String(y);if(this.cache.get(v)!==m)return this.cache.set(v,m),this.pendingInserts.set(v,m),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===E.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class R{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((y,m)=>this.items.set(m,y)),v.delete&&v.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=R}),define(re[126],se([11,12]),function(X,e){return X.create("vs/base/common/date",e)}),define(re[59],se([0,1,126]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,T=L*24,A=T*7,P=T*30,E=T*365;function b(I,v,y){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,D.localize)(0,null,b(new Date().getTime()+m*1e3,!1));if(m<30)return(0,D.localize)(1,null);let p;return m<n?(p=m,v?p===1?y?(0,D.localize)(2,null,p):(0,D.localize)(3,null,p):y?(0,D.localize)(4,null,p):(0,D.localize)(5,null,p):p===1?y?(0,D.localize)(6,null,p):(0,D.localize)(7,null,p):y?(0,D.localize)(8,null,p):(0,D.localize)(9,null,p)):m<L?(p=Math.floor(m/n),v?p===1?y?(0,D.localize)(10,null,p):(0,D.localize)(11,null,p):y?(0,D.localize)(12,null,p):(0,D.localize)(13,null,p):p===1?y?(0,D.localize)(14,null,p):(0,D.localize)(15,null,p):y?(0,D.localize)(16,null,p):(0,D.localize)(17,null,p)):m<T?(p=Math.floor(m/L),v?p===1?y?(0,D.localize)(18,null,p):(0,D.localize)(19,null,p):y?(0,D.localize)(20,null,p):(0,D.localize)(21,null,p):p===1?y?(0,D.localize)(22,null,p):(0,D.localize)(23,null,p):y?(0,D.localize)(24,null,p):(0,D.localize)(25,null,p)):m<A?(p=Math.floor(m/T),v?p===1?(0,D.localize)(26,null,p):(0,D.localize)(27,null,p):p===1?(0,D.localize)(28,null,p):(0,D.localize)(29,null,p)):m<P?(p=Math.floor(m/A),v?p===1?y?(0,D.localize)(30,null,p):(0,D.localize)(31,null,p):y?(0,D.localize)(32,null,p):(0,D.localize)(33,null,p):p===1?y?(0,D.localize)(34,null,p):(0,D.localize)(35,null,p):y?(0,D.localize)(36,null,p):(0,D.localize)(37,null,p)):m<E?(p=Math.floor(m/P),v?p===1?y?(0,D.localize)(38,null,p):(0,D.localize)(39,null,p):y?(0,D.localize)(40,null,p):(0,D.localize)(41,null,p):p===1?y?(0,D.localize)(42,null,p):(0,D.localize)(43,null,p):y?(0,D.localize)(44,null,p):(0,D.localize)(45,null,p)):(p=Math.floor(m/E),v?p===1?y?(0,D.localize)(46,null,p):(0,D.localize)(47,null,p):y?(0,D.localize)(48,null,p):(0,D.localize)(49,null,p):p===1?y?(0,D.localize)(50,null,p):(0,D.localize)(51,null,p):y?(0,D.localize)(52,null,p):(0,D.localize)(53,null,p))}e.fromNow=b;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(re[127],se([11,12]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(re[37],se([0,1,16,13,127]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(I,v){return v&&(I.stack||I.stacktrace)?L.localize(0,null,P(I),A(I.stack)||A(I.stacktrace)):P(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?L.localize(1,null,I.message):I.message||L.localize(2,null)}function E(I=null,v=!1){if(!I)return L.localize(3,null);if(Array.isArray(I)){const y=D.coalesce(I),m=E(y[0],v);return y.length>1?L.localize(4,null,m,y.length):m}if(n.isString(I))return I;if(I.detail){const y=I.detail;if(y.error)return T(y.error,v);if(y.exception)return T(y.exception,v)}return I.stack?T(I,v):I.message?I.message:L.localize(5,null)}e.toErrorMessage=E;function b(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=b;function R(I,v){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=v,y}e.createErrorWithActions=R}),define(re[128],se([11,12]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(re[129],se([0,1,128]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(re[130],se([11,12]),function(X,e){return X.create("vs/base/node/processes",e)}),define(re[85],se([0,1,45,41,19,28,10,4,34,74,13,116,27,130]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function m(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(u,t){if(P.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const i=D.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],r);return new Promise(a=>{i.once("error",c=>{a({success:!1,error:c})}),i.once("exit",(c,s)=>{a(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?m(r.status):1})}else if(P.isLinux||P.isMacintosh)try{const r=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(i=>{D.execFile(r,[u.pid.toString()],{encoding:"utf8",shell:!0},(a,c,s)=>{i(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function f(u=E.env){return u.comspec||"cmd.exe"}e.getWindowsShell=f;class d{constructor(t,r,i,a){if(r!==void 0&&i!==void 0&&a!==void 0)this.cmd=t,this.args=r,this.shell=i,this.options=a;else{const c=t;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(E.env).forEach(s=>{c[s]=E.env[s]}),Object.keys(this.options.env).forEach(s=>{c[s]=this.options.env[s]}),this.options.env=c}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(A.sep);return r!==-1&&(t=t.substring(r+1)),d.WellKnowCommands[t]?t:"other"}start(t){return P.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(E.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(r=>{let i,a;const c=new Promise((s,o)=>{i=s,a=o});if(r){let s=this.cmd;this.args&&(s=s+" "+this.args.join(" ")),this.childProcess=D.exec(s,this.options,(o,l,h)=>{this.childProcess=null;const C=o;C&&C.killed?a({killed:this.terminateRequested,stdout:l.toString(),stderr:h.toString()}):this.handleExec(i,t,o,l,h)})}else{let s=null;const o=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,i,t,a);const h={terminated:this.terminateRequested};R.isNumber(l)&&(h.cmdCode=l),i(h)};if(this.shell&&P.isWindows){const l=T.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let h=!1,C=!1;const M=[];let O=this.ensureQuotes(this.cmd);M.push(O.value),h=O.quoted,this.args&&this.args.forEach(k=>{O=this.ensureQuotes(k),M.push(O.value),C=C&&O.quoted});const U=["/s","/c"];h?C?U.push('"'+M.join(" ")+'"'):M.length>1?U.push('"'+M[0]+'" '+M.slice(1).join(" ")):U.push('"'+M[0]+'"'):U.push(M.join(" ")),s=D.spawn(f(),U,l)}else this.cmd&&(s=D.spawn(this.cmd,this.args,this.options));s&&(this.childProcess=s,this.childProcessPromise=Promise.resolve(s),this.pidResolve&&(this.pidResolve(R.isNumber(s.pid)?s.pid:-1),this.pidResolve=void 0),s.on("error",l=>{this.childProcess=null,a({terminated:this.terminateRequested,error:l})}),s.pid&&(this.childProcess.on("close",o),this.handleSpawn(s,i,t,a,!0)))}return c})}handleClose(t,r,i,a){}ensureQuotes(t){return d.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!P.isWindows)return t(!1);const r=D.spawn(f(),["/s","/c"]);r.on("error",i=>t(!0)),r.on("exit",i=>t(!1))})}}e.AbstractProcess=d,d.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},d.regexp=/^[^"].* .*[^"]/;class S extends d{constructor(t,r,i,a){super(t,r,i,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,i,a,c){[a,c].forEach((s,o)=>{const l=new I.LineDecoder;l.write(s).forEach(M=>{r({line:M,source:o===0?0:1})});const C=l.end();C&&r({line:C,source:o===0?0:1})}),t({terminated:this.terminateRequested,error:i})}handleSpawn(t,r,i,a,c){const s=new I.LineDecoder,o=new I.LineDecoder;t.stdout.on("data",l=>{s.write(l).forEach(C=>i({line:C,source:0}))}),t.stderr.on("data",l=>{o.write(l).forEach(C=>i({line:C,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(t,r,i,a){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&i({line:c,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}}e.LineProcess=S;function w(u){let t=[],r=!1;const i=function(a){if(r){t.push(a);return}(!u.send(a,s=>{if(s&&console.error(s),r=!1,t.length>0){const o=t.slice(0);t=[],o.forEach(l=>i(l))}})||P.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=w;var g;(function(u){async function t(r,i,a){if(A.isAbsolute(r))return r;if(i===void 0&&(i=E.cwd()),A.dirname(r)!=="."||(a===void 0&&R.isString(E.env.PATH)&&(a=E.env.PATH.split(A.delimiter)),a===void 0||a.length===0))return A.join(i,r);async function s(o){if(await v.Promises.exists(o)){let l;try{l=await v.Promises.stat(o)}catch(h){h.message.startsWith("EACCES")&&(l=await v.Promises.lstat(o))}return l?!l.isDirectory():!1}return!1}for(let o of a){let l;if(A.isAbsolute(o)?l=A.join(o,r):l=A.join(i,o,r),await s(l))return l;let h=l+".com";if(await s(h)||(h=l+".exe",await s(h)))return h}return A.join(i,r)}u.findExecutable=t})(g=e.win32||(e.win32={}))}),define(re[131],se([0,1,35,4,81,85]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,m){return y===1?n.isWindows?I():T.getWindowsShell(m):b(y,m)}e.getSystemShell=A;function P(y,m){return y===1?n.isWindows?v(m):T.getWindowsShell(m):b(y,m)}e.getSystemShellSync=P;let E=null;function b(y,m){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!E){let p;if(n.isWindows)p="/bin/bash";else{if(p=m.SHELL,!p)try{p=(0,D.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}E=p}return E}let R=null;async function I(){return R||(R=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),R}function v(y){if(R)return R;const m=n.isWindows&&parseFloat((0,D.release)())>=10,p=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${y.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?f:T.getWindowsShell(y)}}),define(re[60],se([0,1,45,5,17,23,114,9,3,2,28,85,74,36]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends y.ChannelServer{constructor(d){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",S=>L.VSBuffer.wrap(Buffer.from(S,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=m;class p{constructor(d,S){this.modulePath=d,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const S=this;return{call(w,g,u){return S.requestPromise(d,w,g,u)},listen(w,g){return S.requestEvent(d,w,g)}}}requestPromise(d,S,w,g=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(d),t=(0,n.createCancelablePromise)(a=>u.call(S,w,a)),r=g.onCancellationRequested(()=>t.cancel()),i=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(d,S,w){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let g;const u=new E.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(d).listen(S,w)(u.fire,u),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),(0,v.removeDangerousEnvVariables)(S.env),this.child=(0,D.fork)(this.modulePath,d,S);const w=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,A.isRemoteConsoleLog)(c)){(0,A.log)(c,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(c,"base64")))});const u=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&u.send(c.buffer.toString("base64")),r=w.event,i={send:t,onMessage:r};this._client=new y.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,s)=>{process.removeListener("exit",a),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),c!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:s})})}return this._client}getCachedChannel(d){let S=this.channels.get(d);return S||(S=this.client.getChannel(d),this.channels.set(d,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(re[132],se([11,12]),function(X,e){return X.create("vs/base/node/zip",e)}),define(re[133],se([11,12]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[134],se([11,12]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(re[135],se([11,12]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(re[136],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[137],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[138],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[139],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[140],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[141],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[142],se([11,12]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[143],se([11,12]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(re[144],se([11,12]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(re[145],se([11,12]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(re[146],se([11,12]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[147],se([11,12]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[148],se([11,12]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(re[149],se([11,12]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(re[150],se([11,12]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[151],se([11,12]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[152],se([11,12]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[153],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[154],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[155],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[156],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[157],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[158],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[86],se([0,1,59,57,19,10,34,20,7]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(p,f,d){this._args=p,this.paths=f,this.productService=d}get appRoot(){return(0,T.dirname)(L.FileAccess.asFileUri("",X).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(E.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=A.env.VSCODE_PORTABLE;return p?E.URI.file((0,T.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,T.resolve)(p):(0,T.normalize)((0,T.join)(L.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,T.resolve)(p):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,T.resolve)(p);const f=A.env.VSCODE_EXTENSIONS;if(f)return f;const d=A.env.VSCODE_PORTABLE;return d?(0,T.join)(d,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(f=>/^[^:/?#]+?:\/\//.test(f)?E.URI.parse(f):E.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?E.URI.parse(p):E.URI.file((0,T.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=A.env.VSCODE_PORTABLE;return p?E.URI.file((0,T.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}de([n.memoize],b.prototype,"appRoot",null),de([n.memoize],b.prototype,"userHome",null),de([n.memoize],b.prototype,"userDataPath",null),de([n.memoize],b.prototype,"appSettingsHome",null),de([n.memoize],b.prototype,"tmpDir",null),de([n.memoize],b.prototype,"cacheHome",null),de([n.memoize],b.prototype,"userRoamingDataHome",null),de([n.memoize],b.prototype,"settingsResource",null),de([n.memoize],b.prototype,"userDataSyncHome",null),de([n.memoize],b.prototype,"userDataSyncLogResource",null),de([n.memoize],b.prototype,"sync",null),de([n.memoize],b.prototype,"machineSettingsResource",null),de([n.memoize],b.prototype,"globalStorageHome",null),de([n.memoize],b.prototype,"workspaceStorageHome",null),de([n.memoize],b.prototype,"localHistoryHome",null),de([n.memoize],b.prototype,"keybindingsResource",null),de([n.memoize],b.prototype,"keyboardLayoutResource",null),de([n.memoize],b.prototype,"argvResource",null),de([n.memoize],b.prototype,"snippetsHome",null),de([n.memoize],b.prototype,"isExtensionDevelopment",null),de([n.memoize],b.prototype,"untitledWorkspacesHome",null),de([n.memoize],b.prototype,"installSourcePath",null),de([n.memoize],b.prototype,"builtinExtensionsPath",null),de([n.memoize],b.prototype,"extensionsPath",null),de([n.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],b.prototype,"extensionDevelopmentKind",null),de([n.memoize],b.prototype,"extensionTestsLocationURI",null),de([n.memoize],b.prototype,"debugExtensionHost",null),de([n.memoize],b.prototype,"serviceMachineIdResource",null),de([n.memoize],b.prototype,"telemetryLogResource",null),de([n.memoize],b.prototype,"disableWorkspaceTrust",null),de([n.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function R(m,p){return y(m["inspect-extensions"],m["inspect-brk-extensions"],5870,p,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=R;function I(m,p){return y(m["inspect-search"],m["inspect-brk-search"],5876,p,m.extensionEnvironment)}e.parseSearchPort=I;function v(m,p){return y(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,p,m.extensionEnvironment)}e.parsePtyHostPort=v;function y(m,p,f,d,S,w){const u=Number(p||m)||(d?null:f),t=u?Boolean(!!p):!1;let r;if(w)try{r=JSON.parse(w)}catch{}return{port:u,break:t,debugId:S,env:r}}}),define(re[159],se([0,1,261,4,134]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,p,f=A){const d={},S=["_"],w=[];for(let r in p){const i=p[r];i.alias&&(d[r]=i.alias),i.type==="string"||i.type==="string[]"?(S.push(r),i.deprecates&&S.push(...i.deprecates)):i.type==="boolean"&&(w.push(r),i.deprecates&&w.push(...i.deprecates))}const g=D(m,{string:S,boolean:w,alias:d}),u={},t=g;u._=g._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in p){const i=p[r];i.alias&&delete t[i.alias];let a=t[r];if(i.deprecates)for(const c of i.deprecates)t.hasOwnProperty(c)&&(a||(a=t[c],a&&f.onDeprecatedOption(c,i.deprecationMessage||(0,L.localize)(33,null,r))),delete t[c]);if(typeof a!="undefined"){if(i.type==="string[]"){if(Array.isArray(a)||(a=[a]),!i.allowEmptyValue){const c=a.filter(s=>s.length>0);c.length!==a.length&&(f.onEmptyValue(r),a=c.length>0?c:void 0)}}else i.type==="string"&&(Array.isArray(a)?(a=a.pop(),f.onMultipleValues(r,a)):!a&&!i.allowEmptyValue&&(f.onEmptyValue(r),a=void 0));u[r]=a,i.deprecationMessage&&f.onDeprecatedOption(r,i.deprecationMessage)}delete t[r]}for(let r in t)f.onUnknownOption(r);return u}e.parseArgs=P;function E(m,p){let f="";return p.args&&(Array.isArray(p.args)?f=` <${p.args.join("> <")}>`:f=` <${p.args}>`),p.alias?`-${p.alias} --${m}${f}`:`--${m}${f}`}function b(m,p){let f=0,d=[];for(const u in m){const t=m[u],r=E(u,t);f=Math.max(f,r.length),d.push([r,t.description])}let S=f+2+1;if(p-S<25)return d.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let w=p-S-1,g=[];for(const u of d){let t=u[0],r=I(u[1],w),i=R(S-t.length-2);g.push("  "+t+i+r[0]);for(let a=1;a<r.length;a++)g.push(R(S)+r[a])}return g}e.formatOptions=b;function R(m){return" ".repeat(m)}function I(m,p){let f=[];for(;m.length;){let d=m.length<p?m.length:m.lastIndexOf(" ",p),S=m.slice(0,d).trim();m=m.slice(d),f.push(S)}return f}function v(m,p,f,d,S){const w=process.stdout.isTTY&&process.stdout.columns||80,g=S?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",u=[`${m} ${f}`];u.push(""),u.push(`${(0,L.localize)(35,null)}: ${p} [${(0,L.localize)(36,null)}]${g}`),u.push(""),S?.noPipe!==!0&&(n.isWindows?u.push((0,L.localize)(37,null,p)):u.push((0,L.localize)(38,null,p)),u.push(""));const t={};for(const r in d){const i=d[r];if(i.description&&i.cat){let a=t[i.cat];a||(t[i.cat]=a={}),a[r]=i}}for(let r in t){const i=r;let a=t[i];a&&(u.push(T[i]),u.push(...b(a,w)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=v;function y(m,p){return`${m||(0,L.localize)(39,null)}
${p||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),define(re[160],se([0,1,262,135,159]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(v,y){const m={onUnknownOption:f=>{console.warn((0,n.localize)(0,null,f))},onMultipleValues:(f,d)=>{console.warn((0,n.localize)(1,null,f,d))},onEmptyValue:f=>{console.warn((0,n.localize)(2,null,f))},onDeprecatedOption:(f,d)=>{console.warn((0,n.localize)(3,null,f,d))}},p=(0,L.parseArgs)(v,L.OPTIONS,y?m:void 0);return p.goto&&p._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,n.localize)(4,null))),p["max-memory"]&&D(parseInt(p["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),p}function P(v){const y=v.findIndex(m=>!/^-/.test(m));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function E(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=P(y)||[]);const m=!I(process.env);return A(y,m)}e.parseMainProcessArgv=E;function b(v){const[,,...y]=v;return A(y,!0)}e.parseCLIProcessArgv=b;function R(v,...y){const m=v.indexOf("--");return m===-1?v.push(...y):v.splice(m,0,...y),v}e.addArg=R;function I(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function X(e,D,n,L){function T(P){const E=A(P),b=[E];return e.isAbsolute(E)||b.unshift(L),e.resolve(...b)}function A(P){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,n);const R=P["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,n)}return{getUserDataPath:T}}if(typeof define=="function")define(re[161],se([0,263,35,19,20,34]),function(e,D,n,L,T,A){const P=T.dirname(L.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return X(D,n,E.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=X(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[162],se([0,1,35,86,161]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(P,E){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(P)},E)}}e.NativeEnvironmentService=T}),define(re[163],se([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(f){const d=f.match(A);return d?d[1]:null}function R(f){if(f.indexOf("://")===-1){const d=f.match(n);return d?b(d[2]):null}try{const d=D.URI.parse(f);if(d.authority)return b(d.authority)}catch{}return null}function I(f,d){const S=new Set;let w;for(;w=P.exec(f);){const u=R(w[1]);u&&S.add(u)}const g=new Set(d);return Array.from(S).map(u=>g.has(u)?u:u.replace(E,"a"))}e.getDomainsOfRemotes=I;function v(f){const d=f.match(T);return d?d[2]:null}function y(f,d,S){return f&&d?(S&&d.endsWith(".git")&&(d=d.substr(0,d.length-4)),d.indexOf("/")===0?`${f}${d}`:`${f}/${d}`):null}function m(f,d){if(f.indexOf("://")===-1){const S=f.match(L);if(S)return y(S[2],S[3],d)}try{const S=D.URI.parse(f);if(S.authority)return y(v(S.authority),S.path,d)}catch{}return null}function p(f,d=!1){const S=[];let w;for(;w=P.exec(f);){const g=m(w[1],d);g&&S.push(g)}return S}e.getRemotes=p}),define(re[164],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,P,E){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,P,E])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(re[61],se([0,1,20,78,142,52]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=E;function b(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=d.match(A);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=b;function R(d){if(!d)return null;let S=d.majorBase,w=d.majorMustEqual,g=d.minorBase,u=d.minorMustEqual,t=d.patchBase,r=d.patchMustEqual;d.hasCaret&&(S===0||(u=!1),r=!1);let i=0;if(d.preRelease){const a=P.exec(d.preRelease);if(a){const[,c,s,o]=a;i=Date.UTC(Number(c),Number(s)-1,Number(o))}}return{majorBase:S,majorMustEqual:w,minorBase:g,minorMustEqual:u,patchBase:t,patchMustEqual:r,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=R;function I(d,S,w){let g;typeof d=="string"?g=R(b(d)):g=d;let u;S instanceof Date?u=S.getTime():typeof S=="string"&&(u=new Date(S).getTime());let t;if(typeof w=="string"?t=R(b(w)):t=w,!g||!t)return!1;let r=g.majorBase,i=g.minorBase,a=g.patchBase,c=t.majorBase,s=t.minorBase,o=t.patchBase,l=t.notBefore,h=t.majorMustEqual,C=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:i>s?!0:i<s||u&&u<l?!1:a>=o:(r===1&&c===0&&(!h||!C||!M)&&(c=1,s=0,o=0,h=!0,C=!1,M=!1),r<c?!1:r>c?!h:i<s?!1:i>s?!C:a<o?!1:a>o?!M:!(u&&u<l))}e.isValidVersion=I;function v(d,S,w,g,u){const t=[];if(typeof g.publisher!="undefined"&&typeof g.publisher!="string")return t.push([n.default.Error,L.localize(0,null)]),t;if(typeof g.name!="string")return t.push([n.default.Error,L.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([n.default.Error,L.localize(2,null,"version")]),t;if(!g.engines)return t.push([n.default.Error,L.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([n.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies!="undefined"&&!f(g.extensionDependencies))return t.push([n.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents!="undefined"){if(!f(g.activationEvents))return t.push([n.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof g.main=="undefined"&&typeof g.browser=="undefined")return t.push([n.default.Error,L.localize(7,null,"activationEvents","main")]),t}if(typeof g.extensionKind!="undefined"&&typeof g.main=="undefined"&&t.push([n.default.Warning,L.localize(8,null,"extensionKind")]),typeof g.main!="undefined"){if(typeof g.main!="string")return t.push([n.default.Error,L.localize(9,null,"main")]),t;{const a=(0,D.joinPath)(w,g.main);(0,D.isEqualOrParent)(a,w)||t.push([n.default.Warning,L.localize(10,null,a.path,w.path)])}if(typeof g.activationEvents=="undefined")return t.push([n.default.Error,L.localize(11,null,"activationEvents","main")]),t}if(typeof g.browser!="undefined"){if(typeof g.browser!="string")return t.push([n.default.Error,L.localize(12,null,"browser")]),t;{const a=(0,D.joinPath)(w,g.browser);(0,D.isEqualOrParent)(a,w)||t.push([n.default.Warning,L.localize(13,null,a.path,w.path)])}if(typeof g.activationEvents=="undefined")return t.push([n.default.Error,L.localize(14,null,"activationEvents","browser")]),t}if(!T.valid(g.version))return t.push([n.default.Error,L.localize(15,null)]),t;const r=[];if(!y(d,S,g,u,r))for(const a of r)t.push([n.default.Error,a]);return t}e.validateExtensionManifest=v;function y(d,S,w,g,u){return g||typeof w.main=="undefined"&&typeof w.browser=="undefined"?!0:p(d,S,w.engines.vscode,u)}e.isValidExtensionVersion=y;function m(d,S,w){return d==="*"||p(S,w,d)}e.isEngineValid=m;function p(d,S,w,g=[]){let u=R(b(w));if(!u)return g.push(L.localize(16,null,w)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return g.push(L.localize(17,null,w)),!1}else if(!u.majorMustEqual)return g.push(L.localize(18,null,w)),!1;return I(d,S,u)?!0:(g.push(L.localize(19,null,d,w)),!1)}function f(d){if(!Array.isArray(d))return!1;for(let S=0,w=d.length;S<w;S++)if(typeof d[S]!="string")return!1;return!0}}),define(re[46],se([0,1,17,30]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(T,A,P){let E=P&&P.get("storage.serviceMachineId",0)||null;if(E)return E;try{const R=(await A.readFile(T.serviceMachineIdResource)).value.toString();E=(0,n.isUUID)(R)?R:null}catch{E=null}if(!E){E=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(E))}catch{}}return P&&P.store("storage.serviceMachineId",E,0,1),E}e.getServiceMachineId=L}),define(re[53],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,T=[],A=!1){this.ctor=L,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(re[87],se([0,1,53]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(A,P,E){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],E)),n.push([A,P])}e.registerSingleton=L;function T(){return n}e.getSingletonServiceDescriptors=T}),define(re[165],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const P=this.lookupOrInsertNode(T),E=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(T),P)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let P=this._nodes.get(A);return P||(P=new D(T),this._nodes.set(A,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,P]of this._nodes)T.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const P=new Set([T]),E=this._findCycle(A,P);if(E)return E}}_findCycle(T,A){for(let[P,E]of T.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const b=this._findCycle(E,A);if(b)return b;A.delete(P)}}}e.Graph=n}),define(re[6],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(A,P,E){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:A,index:E}):(P[D.DI_DEPENDENCIES]=[{id:A,index:E}],P[D.DI_TARGET]=P)}function L(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const P=function(E,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(P,E,R)};return P.toString=()=>A,D.serviceIds.set(A,P),P}e.createDecorator=L;function T(A){return A}e.refineServiceDecorator=T}),define(re[166],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(re[18],se([0,1,13,7,6]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(d,S){const w=Object.create(null);for(let g in d)R(w,g,d[g],S);return w}e.toValuesTree=b;function R(d,S,w,g){const u=S.split("."),t=u.pop();let r=d;for(let i=0;i<u.length;i++){let a=u[i],c=r[a];switch(typeof c){case"undefined":c=r[a]=Object.create(null);break;case"object":break;default:g(`Ignoring ${S} as ${u.slice(0,i+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=w}catch{g(`Ignoring ${S} as ${u.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${S} as ${u.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=R;function I(d,S){const w=S.split(".");v(d,w)}e.removeFromValueTree=I;function v(d,S){const w=S.shift();if(S.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const g=d[w];typeof g=="object"&&!Array.isArray(g)&&(v(g,S),Object.keys(g).length===0&&delete d[w])}}function y(d,S,w){function g(r,i){let a=r;for(const c of i){if(typeof a!="object"||a===null)return;a=a[c]}return a}const u=S.split("."),t=g(d,u);return typeof t=="undefined"?w:t}e.getConfigurationValue=y;function m(d,S,w){Object.keys(S).forEach(g=>{g!=="__proto__"&&(g in d?D.isObject(d[g])&&D.isObject(S[g])?m(d[g],S[g],w):w&&(d[g]=S[g]):d[g]=S[g])})}e.merge=m;function p(d,S,w){const g=d.inspect(S),u=d.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:g.defaultValue}e.getMigratedSettingValue=p;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(re[167],se([0,1,4,26,6]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var P;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return I.INSTANCE}static true(){return v.INSTANCE}static has(k){return y.create(k)}static equals(k,F){return m.create(k,F)}static notEquals(k,F){return d.create(k,F)}static regex(k,F){return i.create(k,F)}static in(k,F){return p.create(k,F)}static not(k){return S.create(k)}static and(...k){return s.create(k,null)}static or(...k){return o.create(k,null,!0)}static greater(k,F){return g.create(k,F)}static greaterEquals(k,F){return u.create(k,F)}static smaller(k,F){return t.create(k,F)}static smallerEquals(k,F){return r.create(k,F)}static deserialize(k,F=!1){if(!!k)return this._deserializeOrExpression(k,F)}static _deserializeOrExpression(k,F){let _=k.split("||");return o.create(_.map($=>this._deserializeAndExpression($,F)),null,!0)}static _deserializeAndExpression(k,F){let _=k.split("&&");return s.create(_.map($=>this._deserializeOne($,F)),null)}static _deserializeOne(k,F){if(k=k.trim(),k.indexOf("!=")>=0){let _=k.split("!=");return d.create(_[0].trim(),this._deserializeValue(_[1],F))}if(k.indexOf("==")>=0){let _=k.split("==");return m.create(_[0].trim(),this._deserializeValue(_[1],F))}if(k.indexOf("=~")>=0){let _=k.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],F))}if(k.indexOf(" in ")>=0){let _=k.split(" in ");return p.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const _=k.split(">=");return u.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const _=k.split(">");return g.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const _=k.split("<=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const _=k.split("<");return t.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(k)?S.create(k.substr(1).trim()):y.create(k)}static _deserializeValue(k,F){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let _=/^'([^']*)'$/.exec(k);return _?_[1].trim():k}static _deserializeRegexValue(k,F){if((0,n.isFalsyOrWhitespace)(k)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=k.indexOf("/"),$=k.lastIndexOf("/");if(_===$||_<0){if(F)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let H=k.slice(_+1,$),ne=k[$+1]==="i"?"i":"";try{return new RegExp(H,ne)}catch(K){if(F)throw new Error(`bad regexp-value '${k}', parse error: ${K}`);return console.warn(`bad regexp-value '${k}', parse error: ${K}`),null}}}e.ContextKeyExpr=E;function b(U,k){const F=U?U.substituteConstants():void 0,_=k?k.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}e.expressionsAreEqualWithConstantSubstitution=b;function R(U,k){return U.cmp(k)}class I{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class v{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class y{constructor(k,F){this.key=k,this.negated=F,this.type=2}static create(k,F=null){const _=T.get(k);return typeof _=="boolean"?_?v.INSTANCE:I.INSTANCE:new y(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:h(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?v.INSTANCE:I.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=S.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class m{constructor(k,F,_){this.key=k,this.value=F,this.negated=_,this.type=4}static create(k,F,_=null){if(typeof F=="boolean")return F?y.create(k,_):S.create(k,_);const $=T.get(k);return typeof $=="boolean"?F===($?"true":"false")?v.INSTANCE:I.INSTANCE:new m(k,F,_)}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const F=k?"true":"false";return this.value===F?v.INSTANCE:I.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class p{constructor(k,F){this.key=k,this.valueKey=F,this.type=10,this.negated=null}static create(k,F){return new p(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.valueKey),_=k.getValue(this.key);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?A.call(F,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=f.create(this)),this.negated}}e.ContextKeyInExpr=p;class f{constructor(k){this._actual=k,this.type=11}static create(k){return new f(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new f(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=f;class d{constructor(k,F,_){this.key=k,this.value=F,this.negated=_,this.type=5}static create(k,F,_=null){if(typeof F=="boolean")return F?S.create(k,_):y.create(k,_);const $=T.get(k);return typeof $=="boolean"?F===($?"true":"false")?I.INSTANCE:v.INSTANCE:new d(k,F,_)}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const F=k?"true":"false";return this.value===F?I.INSTANCE:v.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class S{constructor(k,F){this.key=k,this.negated=F,this.type=3}static create(k,F=null){const _=T.get(k);return typeof _=="boolean"?_?I.INSTANCE:v.INSTANCE:new S(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:h(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?I.INSTANCE:v.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=S;function w(U,k){if(typeof U=="string"){const F=parseFloat(U);isNaN(F)||(U=F)}return typeof U=="string"||typeof U=="number"?k(U):I.INSTANCE}class g{constructor(k,F,_){this.key=k,this.value=F,this.negated=_,this.type=12}static create(k,F,_=null){return w(F,$=>new g(k,$,_))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class u{constructor(k,F,_){this.key=k,this.value=F,this.negated=_,this.type=13}static create(k,F,_=null){return w(F,$=>new u(k,$,_))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class t{constructor(k,F,_){this.key=k,this.value=F,this.negated=_,this.type=14}static create(k,F,_=null){return w(F,$=>new t(k,$,_))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class r{constructor(k,F,_){this.key=k,this.value=F,this.negated=_,this.type=15}static create(k,F,_=null){return w(F,$=>new r(k,$,_))}cmp(k){return k.type!==this.type?this.type-k.type:C(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(k,F){this.key=k,this.regexp=F,this.type=7,this.negated=null}static create(k,F){return new i(k,F)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const F=this.regexp?this.regexp.source:"",_=k.regexp?k.regexp.source:"";return F<_?-1:F>_?1:0}equals(k){if(k.type===this.type){const F=this.regexp?this.regexp.source:"",_=k.regexp?k.regexp.source:"";return this.key===k.key&&F===_}return!1}substituteConstants(){return this}evaluate(k){let F=k.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class a{constructor(k){this._actual=k,this.type=8}static create(k){return new a(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new a(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function c(U){let k=null;for(let F=0,_=U.length;F<_;F++){const $=U[F].substituteConstants();if(U[F]!==$&&k===null){k=[];for(let H=0;H<F;H++)k[H]=U[H]}k!==null&&(k[F]=$)}return k===null?U:k}class s{constructor(k,F){this.expr=k,this.negated=F,this.type=6}static create(k,F){return s._normalizeArr(k,F)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const $=R(this.expr[F],k.expr[F]);if($!==0)return $}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=c(this.expr);return k===this.expr?this:s.create(k,this.negated)}evaluate(k){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(k))return!1;return!0}static _normalizeArr(k,F){const _=[];let $=!1;for(const H of k)if(!!H){if(H.type===1){$=!0;continue}if(H.type===0)return I.INSTANCE;if(H.type===6){_.push(...H.expr);continue}_.push(H)}if(_.length===0&&$)return v.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(R);for(let H=1;H<_.length;H++)_[H-1].equals(_[H])&&(_.splice(H,1),H--);if(_.length===1)return _[0];for(;_.length>1;){const H=_[_.length-1];if(H.type!==9)break;_.pop();const ne=_.pop(),K=_.length===0,N=o.create(H.expr.map(W=>s.create([W,ne],null)),null,K);N&&(_.push(N),_.sort(R))}return _.length===1?_[0]:new s(_,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let F of this.expr)k.push(...F.keys());return k}map(k){return new s(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.negated){const k=[];for(let F of this.expr)k.push(F.negate());this.negated=o.create(k,this,!0)}return this.negated}}class o{constructor(k,F){this.expr=k,this.negated=F,this.type=9}static create(k,F,_){return o._normalizeArr(k,F,_)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const $=R(this.expr[F],k.expr[F]);if($!==0)return $}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=c(this.expr);return k===this.expr?this:o.create(k,this.negated,!1)}evaluate(k){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(k))return!0;return!1}static _normalizeArr(k,F,_){let $=[],H=!1;if(k){for(let ne=0,K=k.length;ne<K;ne++){const N=k[ne];if(!!N){if(N.type===0){H=!0;continue}if(N.type===1)return v.INSTANCE;if(N.type===9){$=$.concat(N.expr);continue}$.push(N)}}if($.length===0&&H)return I.INSTANCE;$.sort(R)}if($.length!==0){if($.length===1)return $[0];for(let ne=1;ne<$.length;ne++)$[ne-1].equals($[ne])&&($.splice(ne,1),ne--);if($.length===1)return $[0];if(_){for(let ne=0;ne<$.length;ne++)for(let K=ne+1;K<$.length;K++)M($[ne],$[K])&&($.splice(K,1),K--);if($.length===1)return $[0]}return new o($,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let F of this.expr)k.push(...F.keys());return k}map(k){return new o(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.negated){let k=[];for(let F of this.expr)k.push(F.negate());for(;k.length>1;){const F=k.shift(),_=k.shift(),$=[];for(const ne of O(F))for(const K of O(_))$.push(s.create([ne,K],null));const H=k.length===0;k.unshift(o.create($,null,H))}this.negated=k[0]}return this.negated}}class l extends y{constructor(k,F,_){super(k,null);this._defaultValue=F,typeof _=="object"?l._info.push({..._,key:k}):_!==!0&&l._info.push({key:k,description:_,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return m.create(this.key,k)}notEqualsTo(k){return d.create(this.key,k)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(U,k){return U<k?-1:U>k?1:0}function C(U,k,F,_){return U<F?-1:U>F?1:k<_?-1:k>_?1:0}function M(U,k){if(k.type===6&&U.type!==9&&U.type!==6){for(const $ of k.expr)if(U.equals($))return!0}const F=U.negate(),_=O(F).concat(O(k));_.sort(R);for(let $=0;$<_.length;$++){const ne=_[$].negate();for(let K=$+1;K<_.length;K++){const N=_[K];if(ne.equals(N))return!0}}return!1}e.implies=M;function O(U){return U.type===9?U.expr:[U]}}),define(re[88],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=n;class L{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=L}),define(re[89],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(re[14],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],se([0,1,137,6]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function L(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function T(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(d,S){switch(d){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(d,S){return S==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(d,S,w){return P(S,w)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===w?!0:b(w).includes(d)}e.isTargetPlatformCompatible=E;function b(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function R(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=R;var I;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var y;(function(d){d.Install="install",d.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var m;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var p;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(S,w){super(S);this.code=w,this.name=w}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService")}),define(re[168],se([0,1,3,2,28,7,115,29]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(p,f){return T.URI.revive(f?f.transformIncoming(p):p)}function b(p,f){return f?f.transformOutgoingURI(p):p}function R(p,f){f=f||A.DefaultURITransformer;const d=p.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...p,manifest:void 0},f),manifest:d}}function I(p,f){return f?(0,L.cloneAndChange)(p,d=>d instanceof T.URI?f.transformOutgoingURI(d):void 0):p}class v{constructor(f,d){this.service=f,this.getUriTransformer=d,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,d){const S=this.getUriTransformer(f);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,w=>w.map(g=>({...g,local:g.local?I(g.local,S):g.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,d,S){const w=this.getUriTransformer(f);switch(d){case"zip":return this.service.zip(R(S[0],w)).then(g=>b(g,w));case"unzip":return this.service.unzip(E(S[0],w));case"install":return this.service.install(E(S[0],w),S[1]);case"getManifest":return this.service.getManifest(E(S[0],w));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(S[0]);case"installFromGallery":return this.service.installFromGallery(S[0],S[1]);case"uninstall":return this.service.uninstall(R(S[0],w),S[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(R(S[0],w));case"getInstalled":return this.service.getInstalled(S[0]).then(g=>g.map(u=>I(u,w)));case"updateMetadata":return this.service.updateMetadata(R(S[0],w),S[1]).then(g=>I(g,w));case"updateExtensionScope":return this.service.updateExtensionScope(R(S[0],w),S[1]).then(g=>I(g,w));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class y extends n.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(d=>this._onInstallExtension.fire({identifier:d.identifier,source:this.isUriComponents(d.source)?T.URI.revive(d.source):d.source}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this._onDidInstallExtensions.fire(d.map(S=>({...S,local:S.local?R(S.local,null):S.local,source:this.isUriComponents(S.source)?T.URI.revive(S.source):S.source}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this._onUninstallExtension.fire(d))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this._onDidUninstallExtension.fire(d)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const d=await this.getTargetPlatform();return f.allTargetPlatforms.some(S=>(0,P.isTargetPlatformCompatible)(S,f.allTargetPlatforms,d))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(d=>T.URI.revive(d)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,d){return Promise.resolve(this.channel.call("install",[f,d])).then(S=>R(S,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,d){return Promise.resolve(this.channel.call("installFromGallery",[f,d])).then(S=>R(S,null))}uninstall(f,d){return Promise.resolve(this.channel.call("uninstall",[f,d]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(d=>d.map(S=>R(S,null)))}updateMetadata(f,d){return Promise.resolve(this.channel.call("updateMetadata",[f,d])).then(S=>R(S,null))}updateExtensionScope(f,d){return Promise.resolve(this.channel.call("updateExtensionScope",[f,d])).then(S=>R(S,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class m{constructor(f){this.service=f}listen(f,d){throw new Error("Invalid listen")}call(f,d,S){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(S[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(re[90],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[15],se([0,1,9,39,10,26,13,7,144,6]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function R(K){return K.create===!0}e.isFileOpenForWriteOptions=R;var I;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var v;(function(K){K[K.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var y;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=m;function p(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=p;function f(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=f;function d(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function S(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=S;function w(K){return m(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var g;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(N,W){super(N);this.code=W}}e.FileSystemProviderError=u;function t(K,N){const W=new u(K.toString(),N);return i(W,N),W}e.createFileSystemProviderError=t;function r(K){return K||t((0,E.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=r;function i(K,N){return K.name=N?`${N} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=i;function a(K){if(!K)return g.Unknown;if(K instanceof u)return K.code;const N=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!N)return g.Unknown;switch(N[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=a;function c(K){if(K instanceof M)return K.fileOperationResult;switch(a(K)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class o{constructor(N,W,x){this.resource=N,this.operation=W,this.target=x}isOperation(N){return this.operation===N}}e.FileOperationEvent=o;var l;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class h{constructor(N,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=N;const x=new Map;for(const J of N){const G=x.get(J.type);switch(G?G.push([J.resource,J]):x.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,G]of x)switch(J){case 1:this.added=n.TernarySearchTree.forUris(()=>W),this.added.fill(G);break;case 0:this.updated=n.TernarySearchTree.forUris(()=>W),this.updated.fill(G);break;case 2:this.deleted=n.TernarySearchTree.forUris(()=>W),this.deleted.fill(G);break}}contains(N,...W){return this.doContains(N,{includeChildren:!1},...W)}affects(N,...W){return this.doContains(N,{includeChildren:!0},...W)}doContains(N,W,...x){if(!N)return!1;const J=x.length>0;return!!((!J||x.includes(1))&&(this.added?.get(N)||W.includeChildren&&this.added?.findSuperstr(N))||(!J||x.includes(0))&&(this.updated?.get(N)||W.includeChildren&&this.updated?.findSuperstr(N))||(!J||x.includes(2))&&(this.deleted?.findSubstr(N)||W.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function C(K,N,W){return!K||!N||K===N||N.length>K.length?!1:(N.charAt(N.length-1)!==L.sep&&(N+=L.sep),W?(0,T.startsWithIgnoreCase)(K,N):K.indexOf(N)===0)}e.isParent=C;class M extends D.ErrorNoTelemetry{constructor(N,W,x){super(N);this.fileOperationResult=W,this.options=x}}e.FileOperationError=M;class O extends M{constructor(N,W,x){super(N,2,x);this.stat=W}}e.NotModifiedSinceFileOperationError=O;var U;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=F;async function _(K,N){if(!N.hasProvider(P.URI.from({scheme:K.scheme})))return new Promise(W=>{const x=N.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===K.scheme&&J.added&&(x.dispose(),W())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(N){return(0,A.isNumber)(N)||(N=0),N<$.KB?(0,E.localize)(1,null,N.toFixed(0)):N<$.MB?(0,E.localize)(2,null,(N/$.KB).toFixed(2)):N<$.GB?(0,E.localize)(3,null,(N/$.MB).toFixed(2)):N<$.TB?(0,E.localize)(4,null,(N/$.GB).toFixed(2)):(0,E.localize)(5,null,(N/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var H;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function ne(K){return{maxFileSize:K===0?300*$.MB:16*$.GB,maxHeapSize:K===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=ne});var Y=this&&this.__param||function(X,e){return function(D,n){e(D,n,X)}};define(re[169],se([0,1,91,40,15]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}async checksum(P){const E=(await this.fileService.readFileStream(P)).value;return new Promise((b,R)=>{const I=(0,D.createHash)("md5");(0,n.listenStream)(E,{onData:v=>I.update(v.buffer),onError:v=>R(v),onEnd:()=>b(I.digest("base64").replace(/=+$/,""))})})}};T=de([Y(0,L.IFileService)],T),e.ChecksumService=T}),define(re[170],se([0,1,17,37,9,3,2,40,7,30,15]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends A.Disposable{constructor(y,m){super();this.channel=y,this.extraCapabilities=m,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,m){const{buffer:p}=await this.channel.call("readFile",[y,m]);return p}readFileStream(y,m,p){const f=(0,P.newWriteableStream)(S=>D.VSBuffer.concat(S.map(w=>D.VSBuffer.wrap(w))).buffer),d=this.channel.listen("readFileStream",[y,m])(S=>{if(S instanceof D.VSBuffer)f.write(S.buffer);else{if(S==="end")f.end();else{let w=S;w instanceof Error||(w=(0,R.createFileSystemProviderError)((0,n.toErrorMessage)(w),R.FileSystemProviderErrorCode.Unknown)),f.error(w),f.end()}d.dispose()}});return p.onCancellationRequested(()=>{f.error((0,L.canceled)()),f.end(),d.dispose()}),f}writeFile(y,m,p){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(m),p])}open(y,m){return this.channel.call("open",[y,m])}close(y){return this.channel.call("close",[y])}async read(y,m,p,f,d){const[S,w]=await this.channel.call("read",[y,m,d]);return p.set(S.buffer.slice(0,w),f),w}write(y,m,p,f,d){return this.channel.call("write",[y,m,D.VSBuffer.wrap(p),f,d])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,m){return this.channel.call("delete",[y,m])}rename(y,m,p){return this.channel.call("rename",[y,m,p])}copy(y,m,p){return this.channel.call("copy",[y,m,p])}cloneFile(y,m){return this.channel.call("cloneFile",[y,m])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const m=y;this._onDidChange.fire(m.map(p=>({resource:E.URI.revive(p.resource),type:p.type})))}else{const m=y;this._onDidWatchError.fire(m)}}))}watch(y,m){const p=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,p,y,m]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=I}),define(re[92],se([0,1,17,9,145,15]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(R,I,v,y,m,p){let f;try{await P(R,I,v,y,m,p)}catch(d){f=d}finally{f&&m.errorTransformer&&(f=m.errorTransformer(f)),typeof f!="undefined"&&v.error(f),v.end()}}e.readFileIntoStream=A;async function P(R,I,v,y,m,p){E(p);const f=await R.open(I,{create:!1});try{E(p);let d=0,S=0,w=m&&typeof m.length=="number"?m.length:void 0,g=D.VSBuffer.alloc(Math.min(m.bufferSize,typeof w=="number"?w:m.bufferSize)),u=m&&typeof m.position=="number"?m.position:0,t=0;do S=await R.read(f,u,g.buffer,t,g.byteLength-t),u+=S,t+=S,d+=S,typeof w=="number"&&(w-=S),t===g.byteLength&&(await v.write(y(g)),g=D.VSBuffer.alloc(Math.min(m.bufferSize,typeof w=="number"?w:m.bufferSize)),t=0);while(S>0&&(typeof w!="number"||w>0)&&E(p)&&b(d,m));if(t>0){let r=t;typeof w=="number"&&(r=Math.min(t,w)),v.write(y(g.slice(0,r)))}}catch(d){throw(0,T.ensureFileSystemProviderError)(d)}finally{await R.close(f)}}function E(R){if(R.isCancellationRequested)throw(0,n.canceled)();return!0}function b(R,I){if(I?.limits){if(typeof I.limits.memory=="number"&&R>I.limits.memory)throw(0,T.createFileSystemProviderError)((0,L.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&R>I.limits.size)throw(0,T.createFileSystemProviderError)((0,L.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[54],se([0,1,80,2,10,4,7,15]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(f){return f.recursive===!0}e.isRecursiveWatchRequest=E;class b extends n.Disposable{constructor(d,S,w,g){super();this.onFileChanges=d,this.onLogMessage=S,this.verboseLogging=w,this.options=g,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new n.DisposableStore;this.watcherDisposables.value=d,this.watcher=this.createWatcher(d),this.watcher.setVerboseLogging(this.verboseLogging),d.add(this.watcher.onDidChangeFile(S=>this.onFileChanges(S))),d.add(this.watcher.onDidLogMessage(S=>this.onLogMessage(S))),d.add(this.watcher.onDidError(S=>this.onError(S)))}onError(d){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`):this.error(d)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.watcher?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.watcher?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${d}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class R extends b{constructor(d,S,w){super(d,S,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class I extends b{constructor(d,S,w){super(d,S,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function v(f){return f.map(d=>({type:d.type,resource:A.URI.file(d.path)}))}e.toFileChanges=v;function y(f){const d=new p;for(const S of f)d.processEvent(S);return d.coalesce()}e.coalesceEvents=y;function m(f,d){const S=[];for(const w of d){let g=w;typeof g=="string"&&!g.startsWith(D.GLOBSTAR)&&!(0,L.isAbsolute)(g)&&(g={base:f,pattern:g}),S.push((0,D.parse)(g))}return S}e.parseWatcherPatterns=m;class p{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return T.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const S=this.mapPathToChange.get(this.toKey(d));let w=!1;if(S){const g=S.type,u=d.type;S.path!==d.path&&(d.type===2||d.type===1)?w=!0:g===1&&u===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(S)):g===2&&u===1?S.type=0:g===1&&u===0||(S.type=u)}else w=!0;w&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],S=[];return Array.from(this.coalesced).filter(w=>w.type!==2?(d.push(w),!1):!0).sort((w,g)=>w.path.length-g.path.length).filter(w=>S.some(g=>(0,P.isParent)(w.path,g,!T.isLinux))?!1:(S.push(w.path),!0)).concat(d)}}}),define(re[171],se([0,1,51,5,23,41,2,77,10,4,119,27,54]),function(X,e,D,n,L,T,A,P,E,b,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(f,d,S,w){super();this.request=f,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=w,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},g=>this.onDidFilesChange(g)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const f=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const d=await I.Promises.stat(f);this._register(await this.doWatch(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.error(f):this.trace(f)}}async normalizePath(f){let d=f.path;try{d=await I.Promises.realpath(f.path),f.path===d&&(d=await(0,R.realcase)(f.path)??f.path),f.path!==d&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async doWatch(f,d){if(b.isMacintosh&&(0,T.isEqualOrParent)(f,"/Volumes/",!0))return this.error(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const S=new L.CancellationTokenSource(this.cts.token);let w=new A.DisposableStore;try{const g=(0,E.basename)(f),u=(0,D.watch)(f);w.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${f}'`);const t=new Set;if(d)try{for(const i of await I.Promises.readdir(f))t.add(i)}catch(i){this.error(i)}const r=new Map;w.add((0,A.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),u.on("error",(i,a)=>{this.error(`Failed to watch ${f} for changes using fs.watch() (${i}, ${a})`),this.dispose()}),u.on("change",(i,a)=>{if(S.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${a}`);let c="";if(a&&(c=a.toString(),b.isMacintosh&&(c=(0,P.normalizeNFC)(c))),!(!c||i!=="change"&&i!=="rename"))if(d)if(i==="rename"){r.get(c)?.dispose();const s=setTimeout(async()=>{if(r.delete(c),c===g&&!await I.Promises.exists(f)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.existsChildStrictCase((0,E.join)(f,c));if(S.token.isCancellationRequested)return;let l;o?t.has(c)?l=0:(l=1,t.add(c)):(t.delete(c),l=2),this.onFileChange({path:(0,E.join)(this.request.path,c),type:l})},y.FILE_DELETE_HANDLER_DELAY);r.set(c,(0,A.toDisposable)(()=>clearTimeout(s)))}else{let s;t.has(c)?s=0:(s=1,t.add(c)),this.onFileChange({path:(0,E.join)(this.request.path,c),type:s})}else if(i==="rename"||c!==g){const s=setTimeout(async()=>{const o=await I.Promises.exists(f);S.token.isCancellationRequested||(o?(this.onFileChange({path:this.request.path,type:0},!0),w.add(await this.doWatch(f,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);w.clear(),w.add((0,A.toDisposable)(()=>clearTimeout(s)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(g){await I.Promises.exists(f)&&!S.token.isCancellationRequested&&this.error(`Failed to watch ${f} for changes using fs.watch() (${g.toString()})`)}return(0,A.toDisposable)(()=>{S.dispose(!0),w.dispose()})}async onFileChange(f,d=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!d&&this.excludes.some(S=>S(f.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${f.path}`):!d&&this.includes&&this.includes.length>0&&!this.includes.some(S=>S(f.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${f.path}`):this.fileChangesBuffer.push(f);try{await this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,v.coalesceEvents)(S);if(w.length>0){if(this.verboseLogging)for(const u of w)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(w)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${w.length}, most recent change: ${w[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(f){if(b.isLinux)return I.Promises.exists(f);try{const d=(0,E.basename)(f);return(await I.Promises.readdir((0,E.dirname)(f))).some(w=>w===d)}catch(d){return this.trace(d),!1}}setVerboseLogging(f){this.verboseLogging=f}error(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}warn(f){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}trace(f){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function m(p,f,d,S,w=512){const g=await I.Promises.open(p,"r"),u=Buffer.allocUnsafe(w),t=new L.CancellationTokenSource(S);let r,i=!1;const a={path:p,excludes:[],recursive:!1},c=new y(a,s=>{(async()=>{for(const{type:o}of s)if(o===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:l}=await I.Promises.read(g,u,0,w,null);if(!l||t.token.isCancellationRequested)break;f(u.slice(0,l))}}catch(l){r=new Error(l),t.dispose(!0)}finally{i=!1}}})()});return await c.ready,d(),new Promise((s,o)=>{t.token.onCancellationRequested(async()=>{c.dispose();try{await I.Promises.close(g)}catch(l){r=new Error(l)}r?o(r):s()})})}e.watchFileContents=m}),define(re[172],se([0,1,3,80,2,4,171]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const R=this.normalizeRequests(b),I=R.filter(y=>{const m=this.watchers.get(y.path);return m?!(0,n.patternsEquals)(m.request.excludes,y.excludes)||!(0,n.patternsEquals)(m.request.includes,y.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:y})=>!R.find(m=>m.path===y.path&&(0,n.patternsEquals)(m.excludes,y.excludes)&&(0,n.patternsEquals)(m.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.trace(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?y.includes:"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.stopWatching(y);for(const y of I)this.startWatching(y)}startWatching(b){const R=new A.NodeJSFileWatcherLibrary(b,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),I={request:b,instance:R};this.watchers.set(b.path,I)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const R=this.watchers.get(b);R&&(this.watchers.delete(b),R.instance.dispose())}normalizeRequests(b){const R=new Map;for(const I of b){const v=T.isLinux?I.path:I.path.toLowerCase();R.set(v,I)}return Array.from(R.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,R]of this.watchers)R.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,R){return R?`[File Watcher (node.js)] ${b} (path: ${R.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(re[173],se([0,1,54,172]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends D.AbstractNonRecursiveWatcherClient{constructor(A,P,E){super(A,P,E);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(re[174],se([0,1,19,36,60,54]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(E,b,R){super(E,b,R);this.init()}createWatcher(E){const b=E.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:R,signal:I})=>this.onError(`terminated by itself with code ${R}, signal: ${I}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(re[93],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[T,A]of L)this.set(T,A)}set(L,T){const A=this._entries.get(L);return this._entries.set(L,T),A}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(re[175],se([0,1,5,9,53,165,6,93]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(m){super("cyclic dependency between services");this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class R{constructor(m=new P.ServiceCollection,p=!1,f){this._activeInstantiations=new Set,this._services=m,this._strict=p,this._parent=f,this._services.set(A.IInstantiationService,this)}createChild(m){return new R(m,this._strict,this)}invokeFunction(m,...p){let f=v.traceInvocation(m),d=!1;try{return m({get:w=>{if(d)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(w,f);if(!g)throw new Error(`[invokeFunction] unknown service '${w}'`);return g}},...p)}finally{d=!0,f.stop()}}createInstance(m,...p){let f,d;return m instanceof L.SyncDescriptor?(f=v.traceCreation(m.ctor),d=this._createInstance(m.ctor,m.staticArguments.concat(p),f)):(f=v.traceCreation(m),d=this._createInstance(m,p,f)),f.stop(),d}_createInstance(m,p=[],f){let d=A._util.getServiceDependencies(m).sort((g,u)=>g.index-u.index),S=[];for(const g of d){let u=this._getOrCreateServiceInstance(g.id,f);u||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${g.id}.`,!1),S.push(u)}let w=d.length>0?d[0].index:p.length;if(p.length!==w){console.trace(`[createInstance] First service dependency of ${m.name} at position ${w+1} conflicts with ${p.length} static arguments`);let g=w-p.length;g>0?p=p.concat(new Array(g)):p=p.slice(0,w)}return new m(...[...p,...S])}_setServiceInstance(m,p){if(this._services.get(m)instanceof L.SyncDescriptor)this._services.set(m,p);else if(this._parent)this._parent._setServiceInstance(m,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){let p=this._services.get(m);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):p}_getOrCreateServiceInstance(m,p){let f=this._getServiceInstanceOrDescriptor(m);return f instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,f,p.branch(m,!0)):(p.branch(m,!1),f)}_safeCreateAndCacheServiceInstance(m,p,f){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,p,f)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,p,f){const d=new T.Graph(g=>g.id.toString());let S=0;const w=[{id:m,desc:p,_trace:f}];for(;w.length;){const g=w.pop();if(d.lookupOrInsertNode(g),S++>1e3)throw new b(d);for(let u of A._util.getServiceDependencies(g.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(t||this._throwIfStrict(`[createInstance] ${m} depends on ${u.id} which is NOT registered.`,!0),t instanceof L.SyncDescriptor){const r={id:u.id,desc:t,_trace:g._trace.branch(u.id,!0)};d.insertEdge(g,r),w.push(r)}}}for(;;){const g=d.roots();if(g.length===0){if(!d.isEmpty())throw new b(d);break}for(const{data:u}of g){if(this._getServiceInstanceOrDescriptor(u.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,r)}d.removeNode(u)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,p,f=[],d,S){if(this._services.get(m)instanceof L.SyncDescriptor)return this._createServiceInstance(p,f,d,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,p,f,d,S);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(m,p=[],f,d){if(f){const S=new D.IdleValue(()=>this._createInstance(m,p,d));return new Proxy(Object.create(null),{get(w,g){if(g in w)return w[g];let u=S.value,t=u[g];return typeof t!="function"||(t=t.bind(u),w[g]=t),t},set(w,g,u){return S.value[g]=u,!0}})}else return this._createInstance(m,p,d)}_throwIfStrict(m,p){if(p&&console.warn(p),this._strict)throw new Error(m)}}e.InstantiationService=R;var I;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(I||(I={}));class v{constructor(m,p){this.type=m,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(m){return E?new v(1,m.name||m.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(m){return E?new v(0,m.name):v._None}branch(m,p){let f=new v(2,m.toString());return this._dep.push([m,p,f]),f}stop(){let m=Date.now()-this._start;v._totals+=m;let p=!1;function f(S,w){let g=[],u=new Array(S+1).join("	");for(const[t,r,i]of w._dep)if(r&&i){p=!0,g.push(`${u}CREATES -> ${t}`);let a=f(S+1,i);a&&g.push(a)}else g.push(`${u}uses -> ${t}`);return g.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(m>2||p)&&console.log(d.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(re[176],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,T){this.server=L,this.router=T}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,T){this.server.registerChannel(L,T)}}e.MessagePortMainProcessService=D}),define(re[177],se([0,1,36,53,87,6]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,m,p){const f=p.getChannel(y);return P(m)?new m.channelClientCtor(f):D.ProxyChannel.toService(f,m?.proxyOptions)}}function P(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let E=class extends A{constructor(y,m,p){super(y,m,p)}};E=de([Y(2,e.IMainProcessService)],E);function b(v,y,m){(0,L.registerSingleton)(v,new n.SyncDescriptor(E,[y,m],m?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let R=class extends A{constructor(y,m,p){super(y,m,p)}};R=de([Y(2,e.ISharedProcessService)],R);function I(v,y,m){(0,L.registerSingleton)(v,new n.SyncDescriptor(R,[y,m],m?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(re[62],se([0,1,23,2,4,147,29,6]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let E=class extends n.Disposable{constructor(R){super();this.extensionGalleryService=R}async getAvailableLanguages(){const R=new D.CancellationTokenSource;setTimeout(()=>R.cancel(),1e3);let I;try{I=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const y=I.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(p=>p.startsWith("lp-"))).map(m=>{const p=m.properties.localizedLanguages?.[0],f=m.tags.find(S=>S.startsWith("lp-")).split("lp-")[1];return{...this.createQuickPickItem({locale:f,label:p}),extensionId:m.identifier.id,galleryExtension:m}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}createQuickPickItem(R){const I=R.label??R.locale;let v=R.locale!==R.label?R.locale:void 0;return R.locale.toLowerCase()===L.language.toLowerCase()&&(v||(v=""),v+=(0,T.localize)(0,null)),{id:R.locale,label:I,description:v}}};E=de([Y(0,A.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(re[178],se([0,1,2,62]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,n.ILanguagePackService)],L),e.LocalizationsUpdater=L}),define(re[8],se([0,1,37,3,2,4,6]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var E;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(r,i,a){switch(i){case E.Trace:r.trace(a);break;case E.Debug:r.debug(a);break;case E.Info:r.info(a);break;case E.Warning:r.warn(a);break;case E.Error:r.error(a);break;case E.Critical:r.critical(a);break;default:throw new Error("Invalid log level")}}e.log=b;function R(r){let i="";for(let a=0;a<r.length;a++){let c=r[a];if(typeof c=="object")try{c=JSON.stringify(c)}catch{}i+=(a>0?" ":"")+c}return i}e.format=R;class I extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class v extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([i,...a]))}debug(i,...a){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([i,...a]))}info(i,...a){this.checkLogLevel(E.Info)&&this.log(E.Info,R([i,...a]))}warn(i,...a){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([i,...a]))}error(i,...a){if(this.checkLogLevel(E.Error))if(i instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=i.stack,this.log(E.Error,R(c))}else this.log(E.Error,R([i,...a]))}critical(i,...a){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([i,...a]))}flush(){}}e.AbstractMessageLogger=v;class y extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...a){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...a):console.log(`[main ${P()}]`,i,...a))}debug(i,...a){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...a):console.log(`[main ${P()}]`,i,...a))}info(i,...a){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...a):console.log(`[main ${P()}]`,i,...a))}warn(i,...a){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...a):console.warn(`[main ${P()}]`,i,...a))}error(i,...a){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...a):console.error(`[main ${P()}]`,i,...a))}critical(i,...a){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...a):console.error(`[main ${P()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class m extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=m;class p extends I{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class f extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const c of this.logServices)c.trace(i,...a)}debug(i,...a){for(const c of this.logServices)c.debug(i,...a)}info(i,...a){for(const c of this.logServices)c.info(i,...a)}warn(i,...a){for(const c of this.logServices)c.warn(i,...a)}error(i,...a){for(const c of this.logServices)c.error(i,...a)}critical(i,...a){for(const c of this.logServices)c.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=f;class d extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=d;class S extends L.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(c))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let c=this.loggers.get(i.toString());return c||(c=this.doCreateLogger(i,a?.always?E.Trace:this.logLevel,a),this.loggers.set(i.toString(),c),a?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=w;function g(r){if(r.verbose)return E.Trace;if(typeof r.logLevel=="string"){const i=u(r.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function u(r){switch(r){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=u;function t(r){switch(r){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(re[179],se([0,1,5,9,2,10,27,14,8]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends L.Disposable{constructor(I,v){super();this.environmentService=I,this.logService=v,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,T.basename)(this.environmentService.logsPath),v=(0,T.dirname)(this.environmentService.logsPath),p=(await A.Promises.readdir(v)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==I),f=p.slice(0,Math.max(0,p.length-9));f.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(d=>A.Promises.rm((0,T.join)(v,d)))))}catch(I){(0,n.onUnexpectedError)(I)}}};b=de([Y(0,P.IEnvironmentService),Y(1,E.ILogService)],b),e.LogsDataCleaner=b}),define(re[180],se([0,1,5,9,2,10,27,14,8]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class ft extends L.Disposable{constructor(I,v,y){super();this.backupWorkspacesPath=I,this.environmentService=v,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const I=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(I).emptyWorkspaceInfos.map(p=>p.backupFolder),m=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(m.map(async p=>{p.length===ft.NON_EMPTY_WORKSPACE_ID_LENGTH||p===ft.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(p)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(I){(0,n.onUnexpectedError)(I)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=de([Y(1,P.INativeEnvironmentService),Y(2,E.ILogService)],b),e.StorageDataCleaner=b}),define(re[181],se([0,1,45,5,37,3,2,19,10,27,14,8]),function(X,e,D,n,L,T,A,P,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends A.Disposable{constructor(m,p){super();this.environmentService=m,this.logService=p,this.processesLimiter=new n.Limiter(5)}async postUninstall(m){const p=this.parseScript(m,"uninstall");return p&&(this.logService.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,m).then(()=>this.logService.info(m.identifier.id,m.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(m.identifier.id,m.manifest.version,`Failed to run post uninstall script: ${f}`)))),b.Promises.rm(this.getExtensionStoragePath(m)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(m,p){const f=`vscode:${p}`;if(m.location.scheme===P.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[f]=="string"){const d=m.manifest.scripts[f].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(m.identifier.id,m.manifest.version,`${f} should be a node script`),null):{script:(0,E.join)(m.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(m,p,f,d,S){return new Promise((w,g)=>{const u=this.start(m,p,f,S);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?g(i):w(void 0)};u.on("error",i=>{r((0,L.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,a)=>{r(i?`post-${p} process exited with code ${i}`:void 0)}),d&&(t=setTimeout(()=>{t=null,u.kill(),g("timed out")},5e3))})}start(m,p,f,d){const S={silent:!0,execArgv:void 0},w=(0,D.fork)(m,[`--type=extension-post-${p}`,...f],S);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const g=T.Event.fromNodeEventEmitter(w.stdout,"data"),u=T.Event.fromNodeEventEmitter(w.stderr,"data");g(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${p}`,i)),u(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${p}`,i));const t=T.Event.any(T.Event.map(g,i=>({data:`%c${i}`,format:[""]})),T.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}getExtensionStoragePath(m){return(0,E.join)(this.environmentService.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};v=de([Y(0,R.IEnvironmentService),Y(1,I.ILogService)],v),e.ExtensionsLifecycle=v}),define(re[182],se([0,1,16,5,9,3,2,10,54,8]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends A.Disposable{constructor(v,y){super();this.logService=v,this.options=y,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(v,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,y):this.watchNonRecursive(v,y)}watchUniversal(v,y){const m={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive},p=(0,D.insert)(this.universalPathsToWatch,m);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,L.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,E.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(y)&&v.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,y){const m={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:!1},p=(0,D.insert)(this.nonRecursivePathsToWatch,m);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,L.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,E.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(re[183],se([0,1,16,5,17,23,3,76,49,2,39,19,184,20,40,143,15,92,8]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends b.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(u,t){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${u}`);const r=new b.DisposableStore;return this.provider.set(u,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:t}),r.add(t.onDidChangeFile(i=>this._onDidFilesChange.fire(new f.FileChangesEvent(i,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:u}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:t}),this.provider.delete(u),(0,b.dispose)(r)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(r){t.push(r)}}),!this.provider.has(u)&&await n.Promises.settled(t)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,t){const r=this.provider.get(u.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return E.Iterable.map(this.provider,([u,t])=>({scheme:u,capabilities:t.capabilities}))}async withProvider(u){if(!(0,y.isAbsolutePath)(u))throw new f.FileOperationError((0,p.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const t=this.provider.get(u.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,p.localize)(1,null,u.toString()),r}return t}async withReadProvider(u){const t=await this.withProvider(u);if((0,f.hasOpenReadWriteCloseCapability)(t)||(0,f.hasReadWriteCapability)(t)||(0,f.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const t=await this.withProvider(u);if((0,f.hasOpenReadWriteCloseCapability)(t)||(0,f.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,t){try{return await this.doResolveFile(u,t)}catch(r){throw(0,f.toFileSystemProviderErrorCode)(r)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,p.localize)(2,null,this.resourceForError(u)),1):(0,f.ensureFileSystemProviderError)(r)}}async doResolveFile(u,t){const r=await this.withProvider(u),i=this.isPathCaseSensitive(r),a=t?.resolveTo,c=t?.resolveSingleChildDescendants,s=t?.resolveMetadata,o=await r.stat(u);let l;return this.toFileStat(r,u,o,void 0,!!s,(h,C)=>(l||(l=R.TernarySearchTree.forUris(()=>!i),l.set(u,!0),a&&l.fill(!0,a)),l.get(h.resource)||l.findSuperstr(h.resource.with({query:null,fragment:null}))?!0:h.isDirectory&&c?C===1:!1))}async toFileStat(u,t,r,i,a,c){const{providerExtUri:s}=this.getExtUri(u),o={resource:t,name:s.basename(t),isFile:(r.type&f.FileType.File)!=0,isDirectory:(r.type&f.FileType.Directory)!=0,isSymbolicLink:(r.type&f.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&f.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,f.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(o.isDirectory&&c(o,i)){try{const l=await u.readdir(t),h=await n.Promises.settled(l.map(async([C,M])=>{try{const O=s.joinPath(t,C),U=a?await u.stat(O):{type:M};return await this.toFileStat(u,O,U,l.length,a,c)}catch(O){return this.logService.trace(O),null}}));o.children=(0,D.coalesce)(h)}catch(l){this.logService.trace(l),o.children=[]}return o}return o}async resolveAll(u){return n.Promises.settled(u.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(u){const t=await this.withProvider(u),r=await t.stat(u);return this.toFileStat(t,u,r,void 0,!0,()=>!1)}async exists(u){const t=await this.withProvider(u);try{return!!await t.stat(u)}catch{return!1}}async canCreateFile(u,t){try{await this.doValidateCreateFile(u,t)}catch(r){return r}return!0}async doValidateCreateFile(u,t){if(!t?.overwrite&&await this.exists(u))throw new f.FileOperationError((0,p.localize)(3,null,this.resourceForError(u)),3,t)}async createFile(u,t=L.VSBuffer.fromString(""),r){await this.doValidateCreateFile(u,r);const i=await this.writeFile(u,t);return this._onDidRunOperation.fire(new f.FileOperationEvent(u,0,i)),i}async writeFile(u,t,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:a}=this.getExtUri(i);try{await this.validateWriteFile(i,u,r)||await this.mkdirp(i,a.dirname(u));let s;if((0,f.hasReadWriteCapability)(i)&&!(t instanceof L.VSBuffer))if((0,m.isReadableStream)(t)){const o=await(0,m.peekStream)(t,3);o.ended?s=L.VSBuffer.concat(o.buffer):s=o}else s=(0,m.peekReadable)(t,o=>L.VSBuffer.concat(o),3);else s=t;!(0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasReadWriteCapability)(i)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(i,u,r,s):await this.doWriteBuffered(i,u,r,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s),this._onDidRunOperation.fire(new f.FileOperationEvent(u,4))}catch(c){throw new f.FileOperationError((0,p.localize)(4,null,this.resourceForError(u),(0,f.ensureFileSystemProviderError)(c).toString()),(0,f.toFileOperationResult)(c),r)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,t,r){if(!!r?.unlock&&!(u.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(t)));let a;try{a=await u.stat(t)}catch{return}if((a.type&f.FileType.Directory)!=0)throw new f.FileOperationError((0,p.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,a),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==f.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&r.mtime<a.mtime&&r.etag!==(0,f.etag)({mtime:r.mtime,size:a.size}))throw new f.FileOperationError((0,p.localize)(7,null),3,r);return a}async readFile(u,t,r){const i=await this.withReadProvider(u);return t?.atomic?this.doReadFileAtomic(i,u,t,r):this.doReadFile(i,u,t,r)}async doReadFileAtomic(u,t,r,i){return new Promise((a,c)=>{this.writeQueue.queueFor(t,this.getExtUri(u).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(u,t,r,i);a(s)}catch(s){c(s)}})})}async doReadFile(u,t,r,i){const a=await this.doReadFileStream(u,t,{...r,preferUnbuffered:!0},i);return{...a,value:await(0,L.streamToBuffer)(a.value)}}async readFileStream(u,t,r){const i=await this.withReadProvider(u);return this.doReadFileStream(i,u,t,r)}async doReadFileStream(u,t,r,i){const a=new T.CancellationTokenSource(i),c=this.validateReadFile(t,r).then(o=>o,o=>{throw a.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==f.ETAG_DISABLED&&await c,r?.atomic&&(0,f.hasFileAtomicReadCapability)(u)||!((0,f.hasOpenReadWriteCloseCapability)(u)||(0,f.hasFileReadStreamCapability)(u))||(0,f.hasReadWriteCapability)(u)&&r?.preferUnbuffered?s=this.readFileUnbuffered(u,t,r):(0,f.hasFileReadStreamCapability)(u)?s=this.readFileStreamed(u,t,a.token,r):s=this.readFileBuffered(u,t,a.token,r),{...await c,value:s}}catch(o){s&&await(0,m.consumeStream)(s);const l=(0,p.localize)(8,null,this.resourceForError(t),(0,f.ensureFileSystemProviderError)(o).toString());throw o instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(l,o.stat,r):new f.FileOperationError(l,(0,f.toFileOperationResult)(o),r)}}readFileStreamed(u,t,r,i=Object.create(null)){const a=u.readFileStream(t,i,r);return(0,m.transform)(a,{data:c=>c instanceof L.VSBuffer?c:L.VSBuffer.wrap(c),error:c=>new f.FileOperationError((0,p.localize)(9,null,this.resourceForError(t),(0,f.ensureFileSystemProviderError)(c).toString()),(0,f.toFileOperationResult)(c),i)},c=>L.VSBuffer.concat(c))}readFileBuffered(u,t,r,i=Object.create(null)){const a=(0,L.newWriteableBufferStream)();return(0,d.readFileIntoStream)(u,t,a,c=>c,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new f.FileOperationError((0,p.localize)(10,null,this.resourceForError(t),(0,f.ensureFileSystemProviderError)(c).toString()),(0,f.toFileOperationResult)(c),i)},r),a}readFileUnbuffered(u,t,r){const i=(0,m.newWriteableStream)(a=>L.VSBuffer.concat(a));return(async()=>{try{let a;r?.atomic&&(0,f.hasFileAtomicReadCapability)(u)?a=await u.readFile(t,{atomic:!0}):a=await u.readFile(t),typeof r?.position=="number"&&(a=a.slice(r.position)),typeof r?.length=="number"&&(a=a.slice(0,r.length)),this.validateReadFileLimits(t,a.byteLength,r),i.end(L.VSBuffer.wrap(a))}catch(a){i.error(a),i.end()}})(),i}async validateReadFile(u,t){const r=await this.resolve(u,{resolveMetadata:!0});if(r.isDirectory)throw new f.FileOperationError((0,p.localize)(11,null,this.resourceForError(u)),0,t);if(typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&t.etag===r.etag)throw new f.NotModifiedSinceFileOperationError((0,p.localize)(12,null),r,t);return this.validateReadFileLimits(u,r.size,t),r}validateReadFileLimits(u,t,r){if(r?.limits){let i;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(i=9),typeof r.limits.size=="number"&&t>r.limits.size&&(i=7),typeof i=="number")throw new f.FileOperationError((0,p.localize)(13,null,this.resourceForError(u)),i)}}async canMove(u,t,r){return this.doCanMoveCopy(u,t,"move",r)}async canCopy(u,t,r){return this.doCanMoveCopy(u,t,"copy",r)}async doCanMoveCopy(u,t,r,i){if(u.toString()!==t.toString())try{const a=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(a,u,c,t,r,i)}catch(a){return a}return!0}async move(u,t,r){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(i,u,a,t,"move",!!r),s=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,c==="move"?2:3,s)),s}async copy(u,t,r){const i=await this.withReadProvider(u),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),c=await this.doMoveCopy(i,u,a,t,"copy",!!r),s=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,c==="copy"?3:2,s)),s}async doMoveCopy(u,t,r,i,a,c){if(t.toString()===i.toString())return a;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(u,t,r,i,a,c);if(s&&!o&&c&&await this.del(i,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(i)),a==="copy"){if(u===r&&(0,f.hasFileFolderCopyCapability)(u))await u.copy(t,i,{overwrite:c});else{const l=await this.resolve(t);l.isDirectory?await this.doCopyFolder(u,l,r,i):await this.doCopyFile(u,t,r,i)}return a}else return u===r?(await u.rename(t,i,{overwrite:c}),a):(await this.doMoveCopy(u,t,r,i,"copy",c),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(u,t,r,i){if((0,f.hasOpenReadWriteCloseCapability)(u)&&(0,f.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(u,t,r,i);if((0,f.hasOpenReadWriteCloseCapability)(u)&&(0,f.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(u,t,r,i);if((0,f.hasReadWriteCapability)(u)&&(0,f.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(u,t,r,i);if((0,f.hasReadWriteCapability)(u)&&(0,f.hasReadWriteCapability)(r))return this.doPipeUnbuffered(u,t,r,i)}async doCopyFolder(u,t,r,i){await r.mkdir(i),Array.isArray(t.children)&&await n.Promises.settled(t.children.map(async a=>{const c=this.getExtUri(r).providerExtUri.joinPath(i,a.name);return a.isDirectory?this.doCopyFolder(u,await this.resolve(a.resource),r,c):this.doCopyFile(u,a.resource,r,c)}))}async doValidateMoveCopy(u,t,r,i,a,c){let s=!1;if(u===r){const{providerExtUri:l,isPathCaseSensitive:h}=this.getExtUri(u);if(h||(s=l.isEqual(t,i)),s&&a==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(t),this.resourceForError(i)));if(!s&&l.isEqualOrParent(i,t))throw new Error((0,p.localize)(15,null,this.resourceForError(t),this.resourceForError(i)))}const o=await this.exists(i);if(o&&!s){if(!c)throw new f.FileOperationError((0,p.localize)(16,null,this.resourceForError(t),this.resourceForError(i)),4);if(u===r){const{providerExtUri:l}=this.getExtUri(u);if(l.isEqualOrParent(t,i))throw new Error((0,p.localize)(17,null,this.resourceForError(t),this.resourceForError(i)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(u){const t=this.isPathCaseSensitive(u);return{providerExtUri:t?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(t,u);const r=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new f.FileOperationEvent(u,0,r)),r}async mkdirp(u,t){const r=[],{providerExtUri:i}=this.getExtUri(u);for(;!i.isEqual(t,i.dirname(t));)try{if(((await u.stat(t)).type&f.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(t)));break}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileNotFound)throw a;r.push(i.basename(t)),t=i.dirname(t)}for(let a=r.length-1;a>=0;a--){t=i.joinPath(t,r[a]);try{await u.mkdir(t)}catch(c){if((0,f.toFileSystemProviderErrorCode)(c)!==f.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(u,t){try{await this.doValidateDelete(u,t)}catch(r){return r}return!0}async doValidateDelete(u,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(u)));let a;try{a=await r.stat(u)}catch{}if(a)this.throwIfFileIsReadonly(u,a);else throw new f.FileOperationError((0,p.localize)(20,null,this.resourceForError(u)),1);if(!!!t?.recursive){const s=await this.resolve(u);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(u)))}return r}async del(u,t){const r=await this.doValidateDelete(u,t),i=!!t?.useTrash,a=!!t?.recursive;await r.delete(u,{recursive:a,useTrash:i}),this._onDidRunOperation.fire(new f.FileOperationEvent(u,1))}async cloneFile(u,t){const r=await this.withProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(r===i&&this.getExtUri(r).providerExtUri.isEqual(u,t))return;if(r===i&&(0,f.hasFileCloneCapability)(r))return r.cloneFile(u,t);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t));const a=this.writeQueue.queueFor(u,this.getExtUri(r).providerExtUri);return r===i&&(0,f.hasFileFolderCopyCapability)(r)?a.queue(()=>r.copy(u,t,{overwrite:!0})):a.queue(()=>this.doCopyFile(r,u,i,t))}watch(u,t={recursive:!1,excludes:[]}){const r=new b.DisposableStore;let i=!1,a=()=>{i=!0};return r.add((0,b.toDisposable)(()=>a())),(async()=>{try{const c=await this.doWatch(u,t);i?(0,b.dispose)(c):a=()=>(0,b.dispose)(c)}catch(c){this.logService.error(c)}})(),r}async doWatch(u,t){const r=await this.withProvider(u),i=(0,P.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(u),t]);let a=this.activeWatchers.get(i);return a||(a={count:0,disposable:r.watch(u,t)},this.activeWatchers.set(i,a)),a.count+=1,(0,b.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,b.dispose)(a.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,b.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,t,r,i){return this.writeQueue.queueFor(t,this.getExtUri(u).providerExtUri).queue(async()=>{const a=await u.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,m.isReadableStream)(i)||(0,m.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(u,a,i):await this.doWriteReadableBufferedQueued(u,a,i)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await u.close(a)}})}async doWriteStreamBufferedQueued(u,t,r){let i=0,a;if((0,m.isReadableBufferedStream)(r)){if(r.buffer.length>0){const c=L.VSBuffer.concat(r.buffer);await this.doWriteBuffer(u,t,c,c.byteLength,i,0),i+=c.byteLength}if(r.ended)return;a=r.stream}else a=r;return new Promise((c,s)=>{(0,m.listenStream)(a,{onData:async o=>{a.pause();try{await this.doWriteBuffer(u,t,o,o.byteLength,i,0)}catch(l){return s(l)}i+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>s(o),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(u,t,r){let i=0,a;for(;(a=r.read())!==null;)await this.doWriteBuffer(u,t,a,a.byteLength,i,0),i+=a.byteLength}async doWriteBuffer(u,t,r,i,a,c){let s=0;for(;s<i;)s+=await u.write(t,a+s,r.buffer,c+s,i-s)}async doWriteUnbuffered(u,t,r,i){return this.writeQueue.queueFor(t,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,t,r,i))}async doWriteUnbufferedQueued(u,t,r,i){let a;i instanceof L.VSBuffer?a=i:(0,m.isReadableStream)(i)?a=await(0,L.streamToBuffer)(i):(0,m.isReadableBufferedStream)(i)?a=await(0,L.bufferedStreamToBuffer)(i):a=(0,L.readableToBuffer)(i),await u.writeFile(t,a.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(u,t,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,t,r,i))}async doPipeBufferedQueued(u,t,r,i){let a,c;try{a=await u.open(t,{create:!1}),c=await r.open(i,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,h=0;do h=await u.read(a,o,s.buffer,l,s.byteLength-l),await this.doWriteBuffer(r,c,s,h,o,l),o+=h,l+=h,l===s.byteLength&&(l=0);while(h>0)}catch(s){throw(0,f.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof a=="number"?u.close(a):Promise.resolve(),typeof c=="number"?r.close(c):Promise.resolve()])}}async doPipeUnbuffered(u,t,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,t,r,i))}async doPipeUnbufferedQueued(u,t,r,i){return r.writeFile(i,await u.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,t,r,i){return this.writeQueue.queueFor(i,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,t,r,i))}async doPipeUnbufferedToBufferedQueued(u,t,r,i){const a=await r.open(i,{create:!0,unlock:!1});try{const c=await u.readFile(t);await this.doWriteBuffer(r,a,L.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await r.close(a)}}async doPipeBufferedToUnbuffered(u,t,r,i){const a=await(0,L.streamToBuffer)(this.readFileBuffered(u,t,T.CancellationToken.None));await this.doWriteUnbuffered(r,i,void 0,a)}throwIfFileSystemIsReadonly(u,t){if(u.capabilities&2048)throw new f.FileOperationError((0,p.localize)(22,null,this.resourceForError(t)),6);return u}throwIfFileIsReadonly(u,t){if((t.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,p.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===I.Schemas.file?u.fsPath:u.toString(!0)}};w=de([Y(0,S.ILogService)],w),e.FileService=w}),define(re[185],se([0,1,51,264,5,39,17,3,41,2,10,4,20,40,27,146,15,92,182,37,174,173]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(r)}`)}})();class t extends S.AbstractDiskFileSystemProvider{constructor(i,a){super(i,a);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new T.ResourceMap(c=>v.extUriBiasedIgnorePathCase.getComparisonKey(c)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:c}=await m.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await m.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async s=>{try{let o;s.isSymbolicLink()?o=(await this.stat((0,v.joinPath)(i,s.name))).type:o=this.toType(s),c.push([s.name,o])}catch(o){this.logService.trace(o)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let c;return a?.dangling?c=f.FileType.Unknown:i.isFile()?c=f.FileType.File:i.isDirectory()?c=f.FileType.Directory:c=f.FileType.Unknown,a&&(c|=f.FileType.SymbolicLink),c}async createResourceLock(i){const a=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let c;for(;c=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await c.wait();const s=new L.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.resourceLocks.get(i)===s&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),s.open()})}async readFile(i,a){let c;try{a?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),c=await this.createResourceLock(i));const s=this.toFilePath(i);return await m.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{c?.dispose()}}readFileStream(i,a,c){const s=(0,y.newWriteableStream)(o=>A.VSBuffer.concat(o.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,d.readFileIntoStream)(this,i,s,o=>o.buffer,{...a,bufferSize:256*1024},c),s}async writeFile(i,a,c){let s;try{const o=this.toFilePath(i);if(!c.create||!c.overwrite){if(await m.Promises.exists(o)){if(!c.overwrite)throw(0,f.createFileSystemProviderError)((0,p.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,f.createFileSystemProviderError)((0,p.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:c.unlock}),await this.write(s,0,a,0,a.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(i,o)}finally{typeof s=="number"&&await this.close(s)}}async open(i,a){const c=this.toFilePath(i);let s;(0,f.isFileOpenForWriteOptions)(a)&&(s=await this.createResourceLock(i));let o;try{if((0,f.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(c);h.mode&128||await m.Promises.chmod(c,h.mode|128)}catch(h){this.logService.trace(h)}let l;if((0,f.isFileOpenForWriteOptions)(a)){if(I.isWindows)try{await m.Promises.truncate(c,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}l||(l="w")}else l="r";o=await m.Promises.open(c,l)}catch(l){throw s?.dispose(),(0,f.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(o,0),(0,f.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(o,i),s){const l=this.mapHandleToLock.get(o);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${c})`),this.mapHandleToLock.set(o,s),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${c})`),l.dispose())}return o}async close(i){const a=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await m.Promises.fdatasync(i)}catch(c){this.canFlush=!1,this.logService.error(c)}return await m.Promises.close(i)}catch(c){throw this.toFileSystemProviderError(c)}finally{a&&(this.mapHandleToLock.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),a.dispose())}}async read(i,a,c,s,o){const l=this.normalizePos(i,a);let h=null;try{h=(await m.Promises.read(i,c,s,o,l)).bytesRead}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(i,l,h)}return h}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,c){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(i,s+c):this.mapHandleToPos.delete(i)))}async write(i,a,c,s,o){return(0,L.retry)(()=>this.doWrite(i,a,c,s,o),100,3)}async doWrite(i,a,c,s,o){const l=this.normalizePos(i,a);let h=null;try{h=(await m.Promises.write(i,c,s,o,l)).bytesWritten}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),C)}finally{this.updatePos(i,l,h)}return h}async mkdir(i){try{await m.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const c=this.toFilePath(i);a.recursive?await m.Promises.rm(c,m.RimRafMode.MOVE):await m.Promises.unlink(c)}catch(c){throw this.toFileSystemProviderError(c)}}async rename(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a);if(s!==o)try{await this.validateTargetDeleted(i,a,"move",c.overwrite),await m.Promises.move(s,o)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(2,null,(0,R.basename)(s),(0,R.basename)((0,R.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a);if(s!==o)try{await this.validateTargetDeleted(i,a,"copy",c.overwrite),await m.Promises.copy(s,o,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(3,null,(0,R.basename)(s),(0,R.basename)((0,R.dirname)(o)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(i,a,c,s){const o=this.toFilePath(i),l=this.toFilePath(a);let h=!1;if(!!(this.capabilities&1024)||(h=(0,E.isEqual)(o,l,!0)),h&&c==="copy")throw(0,f.createFileSystemProviderError)((0,p.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!h&&await m.Promises.exists(l)){if(!s)throw(0,f.createFileSystemProviderError)((0,p.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(i,a){return this.doCloneFile(i,a,!1)}async doCloneFile(i,a,c){const s=this.toFilePath(i),o=this.toFilePath(a),l=!!(this.capabilities&1024);if((0,E.isEqual)(s,o,!l))return;const h=new b.DisposableStore;try{const[C,M]=await Promise.all([this.createResourceLock(i),this.createResourceLock(a)]);h.add(C),h.add(M),c&&await m.Promises.mkdir((0,R.dirname)(o),{recursive:!0}),await m.Promises.copyFile(s,o)}catch(C){if(C.code==="ENOENT"&&!c)return this.doCloneFile(i,a,!0);throw this.toFileSystemProviderError(C)}finally{h.dispose()}}createUniversalWatcher(i,a,c){return new g.UniversalWatcherClient(s=>i(s),s=>a(s),c)}createNonRecursiveWatcher(i,a,c){return new u.NodeJSWatcherClient(s=>i(s),s=>a(s),c)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let c=this.toFileSystemProviderError(a);if(i&&c.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await m.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(c=(0,f.createFileSystemProviderError)(a,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return c}}e.DiskFileSystemProvider=t}),define(re[94],se([0,1,3,7,8]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(v){this.service=v,this.onDidChangeLogLevel=D.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(v,y,m){switch(y){case"setLevel":return this.service.setLevel(m)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=T;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,y){return v.call("setLevel",y)}}e.LogLevelChannelClient=A;class P{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,y){throw new Error(`Event not found: ${y}`)}async call(v,y,m){switch(y){case"createLogger":this.createLogger(n.URI.revive(m[0]),m[1]);return;case"log":return this.log(n.URI.revive(m[0]),m[1]);case"consoleLog":return this.consoleLog(m[0],m[1])}throw new Error(`Call not found: ${y}`)}createLogger(v,y){this.loggers.set(v.toString(),this.loggerService.createLogger(v,y))}consoleLog(v,y){let m=console.log;switch(v){case L.LogLevel.Error:m=console.error;break;case L.LogLevel.Warning:m=console.warn;break;case L.LogLevel.Info:m=console.info;break}m.call(console,...y)}log(v,y){const m=this.loggers.get(v.toString());if(!m)throw new Error("Create the logger before logging");for(const[p,f]of y)(0,L.log)(m,p,f)}}e.LoggerChannel=P;class E extends L.AbstractLoggerService{constructor(v,y,m){super(v,y);this.channel=m}createConsoleMainLogger(){return new L.AdapterLogger({log:(v,y)=>{this.channel.call("consoleLog",[v,y])}})}doCreateLogger(v,y,m){return new b(this.channel,v,y,m)}}e.LoggerChannelClient=E;class b extends L.AbstractMessageLogger{constructor(v,y,m,p){super(p?.always);this.channel=v,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.channel.call("createLogger",[y,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,y){const m=[[v,y]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(v){this.channel.call("log",[this.file,v])}}class R extends L.LogService{constructor(v,y){super(y);this.parent=v,this._register(v.onDidChangeLogLevel(m=>y.setLevel(m)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=R}),define(re[63],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(re[55],se([0,1,3,49,2,6]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class A extends L.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const R=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},R!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),n.Iterable.reduce(this.policies.entries(),(I,[v,y])=>({...I,[v]:y}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return n.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[R,I])=>({...b,[R]:{definition:I,value:this.policies.get(R)}}),{})}}e.AbstractPolicyService=A;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[186],se([0,1,3,2,55]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(E){this.service=E,this.disposables=new n.DisposableStore}listen(E,b){switch(b){case"onDidChange":return D.Event.map(this.service.onDidChange,R=>R.reduce((I,v)=>({...I,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${b}`)}call(E,b,R){switch(b){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(R)}throw new Error(`Call not found: ${b}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class A extends L.AbstractPolicyService{constructor(E,b){super();this.channel=b;for(const R in E){const{definition:I,value:v}=E[R];this.policyDefinitions[R]=I,v!==void 0&&this.policies.set(R,v)}this.channel.listen("onDidChange")(R=>{for(const I in R){const v=R[I];v===null?this.policies.delete(I):this.policies.set(I,v)}this._onDidChange.fire(Object.keys(R))})}async initializePolicies(E){const b=await this.channel.call("registerPolicyDefinitions",E);for(const R in b)this.policies.set(R,b[R])}}e.PolicyChannelClient=A}),define(re[95],se([0,1,19,4,34,20]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const P=n.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",X));A=X.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const E=X.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[24],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[187],se([0,1,5,9,2,10,27,8,24]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends L.Disposable{constructor(I,v,y){super();this.productService=v,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),y=(0,T.dirname)(I),m=(0,T.basename)(I),p=await A.Promises.readdir(y);await Promise.all(p.map(async f=>{if(f===m)return;const d=(0,T.join)(y,f),S=await A.Promises.stat(d);if(S.isDirectory()&&v-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),A.Promises.rm(d)}))}catch(v){(0,n.onUnexpectedError)(v)}}};b=de([Y(1,E.IProductService),Y(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(re[188],se([0,1,5,9,2,10,27,14,8,24]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=class extends L.Disposable{constructor(v,y,m){super();this.environmentService=v,this.logService=y,this.productService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let S of Object.keys(y)){const w=y[S];v[`${w.hash}.${S}`]=!0}const m=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(m))return;const f=await A.Promises.readdir(m);for(const S of f){if(v[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await A.Promises.rm((0,T.join)(m,S))}const d=Date.now();for(const S of Object.keys(v)){const w=(0,T.join)(m,S),g=await A.Promises.readdir(w);for(const u of g){if(u==="tcf.json")continue;const t=(0,T.join)(w,u),r=await A.Promises.stat(t);r.isDirectory()&&d-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(S,u)}`),await A.Promises.rm(t))}}}catch(v){(0,n.onUnexpectedError)(v)}}};R=de([Y(0,P.INativeEnvironmentService),Y(1,E.ILogService),Y(2,b.IProductService)],R),e.LanguagePackCachedDataCleaner=R}),define(re[189],se([0,1,10,6]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(T){function A(P,E="noAbsolutePaths"){for(const b of P.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(E,(0,D.basename)(b.callFrame.url)));return P}T.rewriteAbsolutePaths=A})(L=e.Utils||(e.Utils={}))}),define(re[190],se([0,1,30]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const P=await(await new Promise((b,R)=>{X(["v8-inspect-profiler"],b,R)})).startProfiling({port:T.port,checkForPaused:!0}),E=(0,D.generateUuid)();return this._sessions.set(E,P),E}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const P=await A.stop();return this._sessions.delete(T),P.profile}}e.InspectProfilingService=n}),define(re[38],se([0,1,107,13]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(A,P){D.ok(n.isString(A)),D.ok(n.isObject(P)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new L}),define(re[96],se([0,1,3,38]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[L(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(re[42],se([0,1,16,3,13,133,18,96,38]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=E.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const i=this.doRegisterConfigurations(t,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const r=this.doDeregisterConfigurations(t);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const i=[];i.push(...this.doDeregisterConfigurations(r)),i.push(...this.doRegisterConfigurations(t,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(i)})}registerDefaultConfigurations(t){const r=[],i=[];for(const{overrides:a,source:c}of t)for(const s in a)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o=this.configurationDefaultsOverrides.get(s),l=o?.valuesSources??new Map;if(c)for(const O of Object.keys(a[s]))l.set(O,c);const h={...o?.value||{},...a[s]};this.configurationDefaultsOverrides.set(s,{source:c,value:h,valuesSources:l});const C=(0,A.getLanguageTagSettingPlainKey)(s),M={type:"object",default:h,description:T.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:L.isString(c)?void 0:c,defaultValueSource:c};i.push(...p(s)),this.configurationProperties[s]=M,this.defaultLanguageConfigurationOverridesNode.properties[s]=M}else{this.configurationDefaultsOverrides.set(s,{value:a[s],source:c});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const r=[];for(const{overrides:i,source:a}of t)for(const c in i){const s=this.configurationDefaultsOverrides.get(c),o=L.isString(a)?a:a?.id,l=L.isString(s?.source)?s?.source:s?.source?.id;if(o===l)if(r.push(c),this.configurationDefaultsOverrides.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const h=this.configurationProperties[c];h&&(this.updatePropertyDefaultValue(c,h),this.updateSchema(c,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r){const i=[];return t.forEach(a=>{i.push(...this.validateAndRegisterProperties(a,r,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),i}doDeregisterConfigurations(t){const r=[],i=a=>{if(a.properties)for(const c in a.properties){r.push(c);const s=this.configurationProperties[c];s?.policy?.name&&this.policyConfigurations.delete(s.policy.name),delete this.configurationProperties[c],this.removeFromSchema(c,a.properties[c])}a.allOf&&a.allOf.forEach(c=>i(c))};for(const a of t){i(a);const c=this.configurationContributors.indexOf(a);c!==-1&&this.configurationContributors.splice(c,1)}return r}validateAndRegisterProperties(t,r=!0,i,a,c=3){c=L.isUndefinedOrNull(t.scope)?c:t.scope;let s=[],o=t.properties;if(o)for(let h in o){const C=o[h];if(r&&w(h,C)){delete o[h];continue}if(C.source=i,C.defaultDefaultValue=o[h].default,this.updatePropertyDefaultValue(h,C),e.OVERRIDE_PROPERTY_REGEX.test(h)?C.scope=void 0:(C.scope=L.isUndefinedOrNull(C.scope)?c:C.scope,C.restricted=L.isUndefinedOrNull(C.restricted)?!!a?.includes(h):C.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.excludedConfigurationProperties[h]=o[h],delete o[h];continue}else this.configurationProperties[h]=o[h],o[h].policy?.name&&this.policyConfigurations.set(o[h].policy.name,h);!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),s.push(h)}let l=t.allOf;if(l)for(let h of l)s.push(...this.validateAndRegisterProperties(h,r,i,a,c));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=i=>{let a=i.properties;if(a)for(const s in a)this.updateSchema(s,a[s]);let c=i.allOf;c&&c.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,i={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const i=this.configurationDefaultsOverrides.get(t);let a=i?.value,c=i?.source;L.isUndefined(a)&&(a=r.defaultDefaultValue,c=void 0),L.isUndefined(a)&&(a=d(r.type)),r.default=a,r.defaultValueSource=c}}const y="\\[([^\\]]+)\\]",m=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(u){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let r=m.exec(u);for(;r?.length;){const i=r[1].trim();i&&t.push(i),r=m.exec(u)}}return(0,D.distinct)(t)}e.overrideIdentifiersFromKey=p;function f(u){return u.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=f;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const S=new v;E.Registry.add(e.Extensions.Configuration,S);function w(u,t){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?T.localize(7,null,u):S.getConfigurationProperties()[u]!==void 0?T.localize(8,null,u):t.policy?.name&&S.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,u,t.policy?.name,S.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}e.validateProperty=w;function g(){const u=[],t=S.getConfigurationProperties();for(const r of Object.keys(t))u.push([r,t[r].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=g}),define(re[64],se([0,1,16,3,33,2,39,28,13,7,18,42,38]),function(X,e,D,n,L,T,A,P,E,b,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},i=[],a=[]){this._contents=r,this._keys=i,this._overrides=a,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,R.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const a=this.getContentsForOverrideIdentifer(i);return a?r?(0,R.getConfigurationValue)(a,r):a:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const a of this.overrides)a.identifiers.includes(r)&&i.push(...a.keys);return D.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return D.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=P.deepClone(this.contents),a=P.deepClone(this.overrides),c=[...this.keys];for(const s of r){this.mergeContents(i,s.contents);for(const o of s.overrides){const[l]=a.filter(h=>D.equals(h.identifiers,o.identifiers));l?(this.mergeContents(l.contents,o.contents),l.keys.push(...o.keys),l.keys=D.distinct(l.keys)):a.push(P.deepClone(o))}for(const o of s.keys)c.indexOf(o)===-1&&c.push(o)}return new y(i,c,a)}freeze(){return this.frozen=!0,this}clone(){return new y(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let a={};for(const c of D.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[c],o=i[c];o&&(typeof s=="object"&&typeof o=="object"?(s=P.deepClone(s),this.mergeContents(s,o)):s=o),a[c]=s}return new y(a,this.keys,this.overrides)}mergeContents(r,i){for(const a of Object.keys(i)){if(a in r&&E.isObject(r[a])&&E.isObject(i[a])){this.mergeContents(r[a],i[a]);continue}r[a]=P.deepClone(i[a])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?P.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,a=null;const c=s=>{s&&(a?this.mergeContents(a,s):a=P.deepClone(s))};for(const s of this.overrides)D.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&c(s.contents);return c(i),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,R.addToValueTree)(this.contents,r,i,a=>{throw new Error(a)})}removeValue(r){this.removeKey(r)&&(0,R.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let a=0;a<i;a++)r.indexOf(this.keys[a])===0&&(i=a);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=y;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!E.isUndefinedOrNull(r)){const a=this.doParseContent(r);this.parseRaw(a,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:a,keys:c,overrides:s,restricted:o}=this.doParseRaw(r,i);this._configurationModel=new y(a,c,s),this._restrictedConfigurations=o||[]}doParseContent(r){let i={},a=null,c=[],s=[],o=[];function l(C){Array.isArray(c)?c.push(C):a!==null&&(c[a]=C)}let h={onObjectBegin:()=>{let C={};l(C),s.push(c),c=C,a=null},onObjectProperty:C=>{a=C},onObjectEnd:()=>{c=s.pop()},onArrayBegin:()=>{let C=[];l(C),s.push(c),c=C,a=null},onArrayEnd:()=>{c=s.pop()},onLiteralValue:l,onError:(C,M,O)=>{o.push({error:C,offset:M,length:O})}};if(r)try{L.visit(r,h),i=c[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return i}doParseRaw(r,i){const a=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),c=this.filter(r,a,!0,i);r=c.raw;const s=(0,R.toValuesTree)(r,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),o=Object.keys(r),l=this.toOverrides(r,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:s,keys:o,overrides:l,restricted:c.restricted}}filter(r,i,a,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:r,restricted:[]};const s={},o=[];for(let l in r)if(I.OVERRIDE_PROPERTY_REGEX.test(l)&&a){const h=this.filter(r[l],i,!1,c);s[l]=h.raw,o.push(...h.restricted)}else{const h=i[l],C=h?typeof h.scope!="undefined"?h.scope:3:void 0;h?.restricted&&o.push(l),(C===void 0||c.scopes===void 0||c.scopes.includes(C))&&(c.skipRestricted&&h?.restricted||(s[l]=r[l]))}return{raw:s,restricted:o}}toOverrides(r,i){const a=[];for(const c of Object.keys(r))if(I.OVERRIDE_PROPERTY_REGEX.test(c)){const s={};for(const o in r[c])s[o]=r[c][o];a.push({identifiers:(0,I.overrideIdentifiersFromKey)(c),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,i)})}return a}}e.ConfigurationModelParser=m;class p extends T.Disposable{constructor(r,i,a,c){super();this.userSettingsResource=r,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&a.isEqual(s.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class f{constructor(r,i,a,c=new y,s=new y,o=new A.ResourceMap,l=new y,h=new A.ResourceMap,C=!0){this._defaultConfiguration=r,this._policyConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=c,this._workspaceConfiguration=s,this._folderConfigurations=o,this._memoryConfiguration=l,this._memoryConfigurationByResource=h,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,i,a){return this.getConsolidatedConfigurationModel(r,i,a).getValue(r)}updateValue(r,i,a={}){let c;a.resource?(c=this._memoryConfigurationByResource.get(a.resource),c||(c=new y,this._memoryConfigurationByResource.set(a.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(r):c.setValue(r,i),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,a){const c=this.getConsolidatedConfigurationModel(r,i,a),s=this.getFolderConfigurationModelForResource(i.resource,a),o=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,l=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),C=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),M=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),U=a?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,k=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(r):s.freeze().getValue(r):void 0,F=i.overrideIdentifier?o.override(i.overrideIdentifier).getValue(r):o.getValue(r),_=c.getValue(r),$=D.distinct(c.overrides.map(H=>H.identifiers).flat()).filter(H=>c.getOverrideValue(r,H)!==void 0);return{defaultValue:l,policyValue:h,userValue:C,userLocalValue:M,userRemoteValue:O,workspaceValue:U,workspaceFolderValue:k,memoryValue:F,value:_,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,policy:h!==void 0?{value:h}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:M!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:s?.freeze().getValue(r),override:i.overrideIdentifier?s?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:o.getValue(r),override:i.overrideIdentifier?o.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const a=[];if(!i){const{added:c,updated:s,removed:o}=g(this._defaultConfiguration,r);i=[...c,...s,...o]}for(const c of i)for(const s of(0,I.overrideIdentifiersFromKey)(c)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=r.getKeysForOverrideIdentifier(s),h=[...l.filter(C=>o.indexOf(C)===-1),...o.filter(C=>l.indexOf(C)===-1),...o.filter(C=>!P.equals(this._defaultConfiguration.override(s).getValue(C),r.override(s).getValue(C)))];a.push([s,h])}return this.updateDefaultConfiguration(r),{keys:i,overrides:a}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:a,removed:c}=g(this._policyConfiguration,r),s=[...i,...a,...c];return s.length&&this.updatePolicyConfiguration(r),{keys:s,overrides:[]}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=g(this.localUserConfiguration,r),o=[...i,...a,...c];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=g(this.remoteUserConfiguration,r);let o=[...i,...a,...c];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:a,removed:c,overrides:s}=g(this.workspaceConfiguration,r);let o=[...i,...a,...c];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const a=this.folderConfigurations.get(r),{added:c,updated:s,removed:o,overrides:l}=g(a,i);let h=[...c,...s,...o];return(h.length||!a)&&this.updateFolderConfiguration(r,i),{keys:h,overrides:l}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:a,updated:c,removed:s,overrides:o}=g(i,void 0);return{keys:[...a,...c,...s],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,i,a){let c=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(c=c.merge(this._policyConfiguration)),c}getConsolidatedConfigurationModelForResource({resource:r},i){let a=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const c=i.getFolder(r);c&&(a=this.getFolderConsolidatedConfiguration(c.uri)||a);const s=this._memoryConfigurationByResource.get(r);s&&(a=a.merge(s))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const a=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(r);c?(i=a.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=a}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const a=i.getFolder(r);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:a,overrides:c,keys:s}=this._folderConfigurations.get(i);return r.push([i,{contents:a,overrides:c,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(a=>r.add(a))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(a=>r.add(a))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(r).forEach(c=>i.add(c))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),a=this.parseConfigurationModel(r.policy),c=this.parseConfigurationModel(r.user),s=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((l,h)=>(l.set(b.URI.revive(h[0]),this.parseConfigurationModel(h[1])),l),new A.ResourceMap);return new f(i,a,c,new y,s,o,new y,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=f;function d(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const r=new Set,i=new Map;for(const c of t)c.keys.forEach(s=>r.add(s)),c.overrides.forEach(([s,o])=>{const l=(0,A.getOrSet)(i,s,new Set);o.forEach(h=>l.add(h))});const a=[];return i.forEach((c,s)=>a.push([s,[...c.values()]])),{keys:[...r.values()],overrides:a}}e.mergeChanges=d;class S{constructor(r,i,a,c){this.change=r,this.previous=i,this.currentConfiguraiton=a,this.currentWorkspace=c,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(l=>s.add(l)),r.overrides.forEach(([,l])=>l.forEach(h=>s.add(h))),this.affectedKeys=[...s.values()];const o=new y;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!P.equals(a,c)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let a=(0,R.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof a=="object"&&(c=Object.keys(a)[0]);){if(r=r[c],!r)return!1;a=a[c]}return!0}}e.ConfigurationChangeEvent=S;class w extends S{constructor(r,i,a,c){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=a,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=w;function g(t,r){const{added:i,removed:a,updated:c}=u(r,t),s=[],o=t?.getAllOverrideIdentifiers()||[],l=r?.getAllOverrideIdentifiers()||[];if(r){const h=l.filter(C=>!o.includes(C));for(const C of h)s.push([C,r.getKeysForOverrideIdentifier(C)])}if(t){const h=o.filter(C=>!l.includes(C));for(const C of h)s.push([C,t.getKeysForOverrideIdentifier(C)])}if(r&&t){for(const h of o)if(l.includes(h)){const C=u({contents:t.getOverrideValue(void 0,h)||{},keys:t.getKeysForOverrideIdentifier(h)},{contents:r.getOverrideValue(void 0,h)||{},keys:r.getKeysForOverrideIdentifier(h)});s.push([h,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:a,updated:c,overrides:s}}function u(t,r){const i=t?r?t.keys.filter(s=>r.keys.indexOf(s)===-1):[...t.keys]:[],a=r?t?r.keys.filter(s=>t.keys.indexOf(s)===-1):[...r.keys]:[],c=[];if(t&&r){for(const s of r.keys)if(t.keys.indexOf(s)!==-1){const o=(0,R.getConfigurationValue)(r.contents,s),l=(0,R.getConfigurationValue)(t.contents,s);P.equals(o,l)||c.push(s)}}return{added:i,removed:a,updated:c}}}),define(re[191],se([0,1,16,3,2,28,13,18,64,42,8,55,38]),function(X,e,D,n,L,T,A,P,E,b,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends L.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new m(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(v.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:w})=>this.onDidUpdateConfiguration(S,w))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(S,w){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:S})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class m extends E.ConfigurationModel{constructor(S={}){const w=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),g=Object.keys(w),u=Object.create(null),t=[];for(const r in w){const i=S[r],a=i!==void 0?i:w[r].default;(0,P.addToValueTree)(u,r,a,c=>console.error(`Conflict in default settings: ${c}`))}for(const r of Object.keys(u))b.OVERRIDE_PROPERTY_REGEX.test(r)&&t.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(u[r]),contents:(0,P.toValuesTree)(u[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(u,g,t)}}e.DefaultConfigurationModel=m;class p{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let f=class extends L.Disposable{constructor(S,w,g){super();this.defaultConfiguration=S,this.policyService=w,this.logService=g,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(S=>this.onDidChangePolicies(S))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:S})=>this.update(await this.registerPolicyDefinitions(S),!0))),this._configurationModel}async registerPolicyDefinitions(S){const w={},g=[],u=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const t of S){const r=u[t];if(!r){g.push(t);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}g.push(t),w[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(w)||await this.policyService.registerPolicyDefinitions(w),g}onDidChangePolicies(S){const w=v.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),g=(0,D.coalesce)(S.map(u=>w.get(u)));this.update(g,!0)}update(S,w){const g=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),u=[],t=this._configurationModel.isEmpty();for(const r of S){const i=g[r]?.policy?.name;if(i){const a=this.policyService.getPolicyValue(i);(t?a!==void 0:!(0,T.equals)(this._configurationModel.getValue(r),a))&&u.push([r,a])}else this._configurationModel.getValue(r)!==void 0&&u.push([r,void 0])}if(u.length){const r=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const i of r.keys)this._configurationModel.setValue(i,r.getValue(i));for(const[i,a]of u)a===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,a);w&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};f=de([Y(1,I.IPolicyService),Y(2,R.ILogService)],f),e.PolicyConfiguration=f}),define(re[192],se([0,1,5,3,2,20,18,64,191,55]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends L.Disposable{constructor(v,y,m,p){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=m instanceof b.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,m,p)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:f,properties:d})=>this.onDidDefaultConfigurationChange(f,d))),this._register(this.policyConfiguration.onDidChangeConfiguration(f=>this.onDidPolicyConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,y,m]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(v,y,m)}getConfigurationData(){return this.configuration.toData()}getValue(v,y){const m=typeof v=="string"?v:void 0,p=(0,A.isConfigurationOverrides)(v)?v:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(m,p,void 0)}updateValue(v,y,m,p){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const y=this.configuration.toData(),m=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(m,y,1)}onDidDefaultConfigurationChange(v,y){const m=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(v,y);this.trigger(p,m,6)}onDidPolicyConfigurationChange(v){const y=this.configuration.toData(),m=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(m,y,6)}trigger(v,y,m){const p=new P.ConfigurationChangeEvent(v,{data:y},this.configuration);p.source=m,p.sourceConfig=this.getTargetConfiguration(m),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(re[193],se([0,1,9,6]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var L;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends D.ErrorNoTelemetry{constructor(P,E=L.Unknown,b){super(P);this._message=P,this._code=E,this._detail=b,this.isHandled=E===L.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(P){return P instanceof T&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof T&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof T&&P.isHandled}}e.RemoteAuthorityResolverError=T}),define(re[97],se([0,1,19]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(A){return A.scheme===D.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=n;function L(A){if(!A)return;const P=A.indexOf("+");return P<0?A:A.substr(0,P)}e.getRemoteName=L;function T(A){return`/${A.quality??"oss"}-${A.commit??"dev"}`}e.getRemoteServerRootPath=T}),define(re[65],se([0,1,26,6,97]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.getWorkspaceSupportTypeMessage=T;function A(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var E;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,p){if(typeof m=="undefined"||m===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof m=="string"||typeof p=="string"){let f=typeof m=="string"?m:m.value,d=typeof p=="string"?p:p.value;return D.equalsIgnoreCase(f,d)}return m._lower===p._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=b;function R(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function I(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function v(y,m){if(m){const p=`onResolveRemoteAuthority:${(0,L.getRemoteName)(m)}`;return y.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[31],se([0,1,26,29,65,4,7,9,34]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,a){return i.uuid&&a.uuid?i.uuid===a.uuid:i.id===a.id?!0:(0,D.compareIgnoreCase)(i.id,a.id)===0}e.areSameExtensions=b;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{constructor(a,c,s="undefined"){this.version=c,this.targetPlatform=s,this.id=a.id}static create(a){const c=a.manifest?a.manifest.version:a.version,s=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new I(a.identifier,c,s)}static parse(a){const c=R.exec(a);return c&&c[1]&&c[2]?new I({id:c[1]},c[2],c[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof I?b(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=I;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const a=v.exec(i);return a&&a[1]?[p(a[1]),a[2]]:[p(i),void 0]}e.getIdAndVersion=y;function m(i,a){return`${i}.${a}`}e.getExtensionId=m;function p(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function f(i,a){return p(m(i,a))}e.getGalleryExtensionId=f;function d(i,a){const c=[],s=o=>{for(const l of c)if(l.some(h=>b(a(h),a(o))))return l;return null};for(const o of i){const l=s(o);l?l.push(o):c.push([o])}return c}e.groupByExtension=d;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function w(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),...i.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function g(i){const a=new Set;if(i.malicious)for(const c of i.malicious)a.add(c.id);return a}e.getMaliciousExtensionsSet=g;function u(i,a){const c=[],s=a.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const o=s.shift();if(o&&c.every(l=>!b(l.identifier,{id:o}))){const l=i.filter(h=>b(h.identifier,{id:o}));l.length===1&&(c.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=u;async function t(i,a){if(!T.isLinux)return!1;let c;try{c=(await i.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await i.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){a.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(o))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function r(i,a){const c=await t(i,a),s=(0,n.getTargetPlatform)(c?"alpine":T.platform,E.arch);return a.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=r}),define(re[66],se([0,1,16,5,28,17,9,33,129,2,19,10,4,20,52,78,13,7,138,14,31,65,61,15,6,8,24,3,79]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u,t,r,i,a,c,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var l;(function(F){function _($,H){if($===H)return!0;let ne=Object.keys($),K=new Set;for(let N of Object.keys(H))K.add(N);if(ne.length!==K.size)return!1;for(let N of ne){if($[N]!==H[N])return!1;K.delete(N)}return K.size===0}F.equals=_})(l=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let h=class extends b.Disposable{constructor(_,$,H,ne,K,N,W,x){super();this.systemExtensionsLocation=_,this.userExtensionsLocation=$,this.extensionsControlLocation=H,this.cacheLocation=ne,this.fileService=K,this.logService=N,this.environmentService=W,this.productService=x,this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.systemExtensionsCachedScanner=this._register(new O((0,y.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.userExtensionsCachedScanner=this._register(new O((0,y.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.fileService,this.logService)),this.extensionsScanner=this._register(new M(this.fileService,this.logService)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,g.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(_){const[$,H]=await Promise.all([this.scanSystemExtensions(_),this.scanUserExtensions(_)]),ne=await this.scanExtensionsUnderDevelopment(_,[...$,...H]);return this.dedupExtensions([...$,...H,...ne],await this.getTargetPlatform(),!0)}async scanSystemExtensions(_){const $=[];$.push(this.scanDefaultSystemExtensions(!!_.useCache,_.language)),$.push(this.scanDevSystemExtensions(_.language,!!_.checkControlFile));const[H,ne]=await Promise.all($);return this.applyScanOptions([...H,...ne],_,!1)}async scanUserExtensions(_){this.logService.trace("Started scanning user extensions");const $=await this.createExtensionScannerInput(this.userExtensionsLocation,1,!_.includeUninstalled,_.language);let ne=await(_.useCache&&!$.devMode&&$.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions($);return ne=await this.applyScanOptions(ne,_,!0),this.logService.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(_,$){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const H=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(ne=>ne.scheme===R.Schemas.file).map(async ne=>{const K=await this.createExtensionScannerInput(ne,1,!0,_.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(K)).map(W=>(W.type=$.find(x=>(0,g.areSameExtensions)(x.identifier,W.identifier))?.type??W.type,this.extensionsScanner.validate(W,K)))}))).flat();return this.applyScanOptions(H,_,!0)}return[]}async scanExistingExtension(_,$,H){const ne=await this.createExtensionScannerInput(_,$,!0,H.language),K=await this.extensionsScanner.scanExtension(ne);return!K||!H.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(_,$,H){const ne=await this.createExtensionScannerInput(_,$,!0,H.language),K=await this.extensionsScanner.scanOneOrMultipleExtensions(ne);return this.applyScanOptions(K,H,!0)}async updateMetadata(_,$){const H=(0,y.joinPath)(_,"package.json"),ne=(await this.fileService.readFile(H)).value.toString(),K=JSON.parse(ne);$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,$.installedTimestamp=$.installedTimestamp||void 0,K.__metadata={...K.__metadata,...$},await this.fileService.writeFile((0,y.joinPath)(_,"package.json"),T.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async applyScanOptions(_,$,H){return $.includeAllVersions||(_=this.dedupExtensions(_,await this.getTargetPlatform(),H)),$.includeInvalid||(_=_.filter(ne=>ne.isValid)),_.sort((ne,K)=>{const N=I.basename(ne.location.fsPath),W=I.basename(K.location.fsPath);return N<W?-1:N>W?1:0})}dedupExtensions(_,$,H){const ne=new Map;for(const K of _){const N=u.ExtensionIdentifier.toKey(K.identifier.id),W=ne.get(N);if(W){if(W.isValid&&!K.isValid)continue;if(W.isValid===K.isValid){if(H&&m.gt(W.manifest.version,K.manifest.version)){this.logService.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version}.`);continue}if(m.eq(W.manifest.version,K.manifest.version)&&W.targetPlatform===$){this.logService.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`);continue}}W.type===0?this.logService.debug(`Overwriting system extension ${W.location.path} with ${K.location.path}.`):this.logService.warn(`Overwriting user extension ${W.location.path} with ${K.location.path}.`)}ne.set(N,K)}return[...ne.values()]}async scanDefaultSystemExtensions(_,$){this.logService.trace("Started scanning system extensions");const H=await this.createExtensionScannerInput(this.systemExtensionsLocation,0,!0,$),K=await(_&&!H.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(H);return this.logService.trace("Scanned system extensions:",K.length),K}async scanDevSystemExtensions(_,$){const H=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!H?.length)return[];this.logService.trace("Started scanning dev system extensions");const ne=$?await this.getBuiltInExtensionControl():{},K=[],N=d.URI.file(I.normalize(I.join(R.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions")));for(const x of H){const J=ne[x.name]||"marketplace";switch(J){case"disabled":break;case"marketplace":K.push((0,y.joinPath)(N,x.name));break;default:K.push(d.URI.file(J));break}}const W=await Promise.all(K.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,0,!0,_))));return this.logService.trace("Scanned dev system extensions:",W.length),(0,D.coalesce)(W)}async getBuiltInExtensionControl(){try{const _=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(_.value.toString())}catch{return{}}}async createExtensionScannerInput(_,$,H,ne,K=!0){const N=await this.getTranslations(ne??v.language);let W;try{const x=await this.fileService.stat(_);typeof x.mtime=="number"&&(W=x.mtime)}catch{}return new C(_,W,$,H,K,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ne,N)}};h=de([Y(4,r.IFileService),Y(5,a.ILogService),Y(6,w.IEnvironmentService),Y(7,c.IProductService)],h),e.AbstractExtensionsScannerService=h;class C{constructor(_,$,H,ne,K,N,W,x,J,G,Q){this.location=_,this.mtime=$,this.type=H,this.excludeObsolete=ne,this.validate=K,this.productVersion=N,this.productDate=W,this.productCommit=x,this.devMode=J,this.language=G,this.translations=Q}static createNlsConfiguration(_){return{language:_.language,pseudo:_.language==="pseudo",devMode:_.devMode,translations:_.translations}}static equals(_,$){return(0,y.isEqual)(_.location,$.location)&&_.mtime===$.mtime&&_.type===$.type&&_.excludeObsolete===$.excludeObsolete&&_.validate===$.validate&&_.productVersion===$.productVersion&&_.productDate===$.productDate&&_.productCommit===$.productCommit&&_.devMode===$.devMode&&_.language===$.language&&l.equals(_.translations,$.translations)}}class M extends b.Disposable{constructor(_,$){super();this.fileService=_,this.logService=$}async scanExtensions(_){const $=await this.fileService.resolve(_.location);if($.children){let H={};if(_.excludeObsolete&&_.type===1)try{const K=(await this.fileService.readFile((0,y.joinPath)(_.location,".obsolete"))).value.toString();H=JSON.parse(K)}catch{}const ne=await Promise.all($.children.map(async K=>{if(!K.isDirectory||_.type===1&&(0,y.basename)(K.resource).indexOf(".")===0)return null;const N=new C(K.resource,_.mtime,_.type,_.excludeObsolete,_.validate,_.productVersion,_.productDate,_.productCommit,_.devMode,_.language,_.translations),W=await this.scanExtension(N);return W&&!H[g.ExtensionKey.create(W).toString()]?W:null}));return(0,D.coalesce)(ne)}return[]}async scanOneOrMultipleExtensions(_){try{if(await this.fileService.exists((0,y.joinPath)(_.location,"package.json"))){const $=await this.scanExtension(_);return $?[$]:[]}else return await this.scanExtensions(_)}catch($){return this.logService.error(`Error scanning extensions at ${_.location.path}:`,(0,A.getErrorMessage)($)),[]}}async scanExtension(_){try{let $=await this.scanExtensionManifest(_.location);if($){$.publisher||($.publisher=u.UNDEFINED_PUBLISHER);const H=$.__metadata;delete $.__metadata;const ne=(0,g.getGalleryExtensionId)($.publisher,$.name),K=H?.id?{id:ne,uuid:H.id}:{id:ne},N=H?.isSystem?0:_.type,W=N===0||!!H?.isBuiltin;$=await this.translateManifest(_.location,$,C.createNlsConfiguration(_));const x={type:N,identifier:K,manifest:$,location:_.location,isBuiltin:W,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return _.validate?this.validate(x,_):x}}catch($){_.type!==0&&this.logService.error($)}return null}validate(_,$){let H=!0;const ne=(0,t.validateExtensionManifest)($.productVersion,$.productDate,$.location,_.manifest,_.isBuiltin);for(const[K,N]of ne)K===p.default.Error&&(H=!1,this.logService.error(this.formatMessage($.location,N)));return _.isValid=H,_.validations=ne,_}async scanExtensionManifest(_){const $=(0,y.joinPath)(_,"package.json");let H;try{H=(await this.fileService.readFile($)).value.toString()}catch(K){return(0,r.toFileOperationResult)(K)!==1&&this.logService.error(this.formatMessage(_,(0,S.localize)(0,null,$.path,K.message))),null}let ne;try{ne=JSON.parse(H)}catch{const N=[];(0,P.parse)(H,N);for(const W of N)this.logService.error(this.formatMessage(_,(0,S.localize)(1,null,$.path,W.offset,W.length,(0,E.getParseErrorMessage)(W.error))));return null}return(0,P.getNodeType)(ne)!=="object"?(this.logService.error(this.formatMessage(_,(0,S.localize)(2,null,$.path))),null):ne}async translateManifest(_,$,H){const ne=await this.getLocalizedMessages(_,$,H);if(ne)try{const K=[],N=await this.resolveOriginalMessageBundle(ne.default,K);if(K.length>0)return K.forEach(x=>{this.logService.error(this.formatMessage(_,(0,S.localize)(3,null,ne.default?.path,(0,E.getParseErrorMessage)(x.error))))}),$;if((0,P.getNodeType)(ne)!=="object")return this.logService.error(this.formatMessage(_,(0,S.localize)(4,null,ne.default?.path))),$;const W=ne.values||Object.create(null);this.replaceNLStrings(H.pseudo,$,W,N,_)}catch{}return $}async getLocalizedMessages(_,$,H){const ne=(0,y.joinPath)(_,"package.nls.json"),K=(J,G)=>{G.forEach(Q=>{this.logService.error(this.formatMessage(_,(0,S.localize)(5,null,J?.path,(0,E.getParseErrorMessage)(Q.error))))})},N=J=>{this.logService.error(this.formatMessage(_,(0,S.localize)(6,null,J?.path)))},W=`${$.publisher}.${$.name}`,x=H.translations[W];if(x)try{const J=d.URI.file(x),G=(await this.fileService.readFile(J)).value.toString();let Q=[],Z=(0,P.parse)(G,Q);return Q.length>0?(K(J,Q),{values:void 0,default:ne}):(0,P.getNodeType)(Z)!=="object"?(N(J),{values:void 0,default:ne}):{values:Z.contents?Z.contents.package:void 0,default:ne}}catch{return{values:void 0,default:ne}}else{if(!await this.fileService.exists(ne))return;let G;try{G=await this.findMessageBundles(_,H)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const Q=(await this.fileService.readFile(G.localized)).value.toString();let Z=[],q=(0,P.parse)(Q,Z);return Z.length>0?(K(G.localized,Z),{values:void 0,default:G.original}):(0,P.getNodeType)(q)!=="object"?(N(G.localized),{values:void 0,default:G.original}):{values:q,default:G.original}}catch{return{values:void 0,default:G.original}}}}async resolveOriginalMessageBundle(_,$){if(_)try{const H=(await this.fileService.readFile(_)).value.toString();return(0,P.parse)(H,$)}catch{return null}else return null}findMessageBundles(_,$){return new Promise((H,ne)=>{const K=N=>{let W=(0,y.joinPath)(_,`package.nls.${N}.json`);this.fileService.exists(W).then(x=>{x&&H({localized:W,original:(0,y.joinPath)(_,"package.nls.json")});let J=N.lastIndexOf("-");J===-1?H({localized:(0,y.joinPath)(_,"package.nls.json"),original:null}):(N=N.substring(0,J),K(N))})};if($.devMode||$.pseudo||!$.language)return H({localized:(0,y.joinPath)(_,"package.nls.json"),original:null});K($.language)})}replaceNLStrings(_,$,H,ne,K){const N=(W,x,J)=>{const G=W[x];if((0,f.isString)(G)){const Q=G,Z=Q.length;if(Z>1&&Q[0]==="%"&&Q[Z-1]==="%"){const q=Q.substr(1,Z-2);let B=H[q];B===void 0&&ne&&(B=ne[q]);let j=typeof B=="string"?B:typeof B?.message=="string"?B.message:void 0;j!==void 0?(_&&(j="\uFF3B"+j.replace(/[aouei]/g,"$&$&")+"\uFF3D"),W[x]=J&&(x==="title"||x==="category")&&ne?{value:j,original:ne[q]}:j):this.logService.warn(this.formatMessage(K,(0,S.localize)(7,null,q)))}}else if((0,f.isObject)(G))for(let Q in G)G.hasOwnProperty(Q)&&(Q==="commands"?N(G,Q,!0):N(G,Q,J));else if((0,f.isArray)(G))for(let Q=0;Q<G.length;Q++)N(G,Q,J)};for(let W in $)$.hasOwnProperty(W)&&N($,W)}formatMessage(_,$){return`[${_.path}]: ${$}`}}class O extends M{constructor(_,$,H){super($,H);this.cacheFile=_,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new s.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(_){const $=await this.readExtensionCache();if(this.input=_,$&&$.input&&C.equals($.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),$.result.map(ne=>(ne.location=d.URI.revive(ne.location),ne));const H=await super.scanExtensions(_);return await this.writeExtensionCache({input:_,result:H}),H}async readExtensionCache(){try{const _=await this.fileService.readFile(this.cacheFile),$=JSON.parse(_.value.toString());return{result:$.result,input:(0,o.revive)($.input)}}catch(_){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(_))}return null}async writeExtensionCache(_){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(_)))}catch($){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)($))}}async validateCache(){if(!this.input)return;const _=await this.readExtensionCache();if(!_)return;const $=_.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!L.equals(H,$))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(ne){this.logService.error(ne)}}}function U(F,_){const $=(0,g.getExtensionId)(F.manifest.publisher,F.manifest.name);return{id:$,identifier:new u.ExtensionIdentifier($),isBuiltin:F.type===0,isUserBuiltin:F.type===1&&F.isBuiltin,isUnderDevelopment:_,extensionLocation:F.location,uuid:F.identifier.uuid,targetPlatform:F.targetPlatform,...F.manifest}}e.toExtensionDescription=U;class k extends h{constructor(_,$,H,ne,K,N,W,x){super(_,$,(0,y.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(ne,u.MANIFEST_CACHE_FOLDER),K,N,W,x);this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const J=await this.fileService.readFile(d.URI.file(v.translationsConfigFile));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}getTranslations(_){return this.translationsPromise}}e.NativeExtensionsScannerService=k}),define(re[194],se([0,1,23,31]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(T,A,P,E,b){try{const R=await T.getExtensionsControlManifest();if(!R.deprecated)return;const I=await T.getInstalled(1);for(const[v,y]of Object.entries(R.deprecated)){if(!y?.extension)continue;const{id:m,autoMigrate:p,preRelease:f}=y.extension;if(!p)continue;const d=I.find(w=>(0,n.areSameExtensions)(w.identifier,{id:v}));if(!d)continue;const S=(await A.getExtensions([{id:m,preRelease:f}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!S){b.info(`Skipping migrating '${d.identifier.id}' extension because, the comaptible target '${m}' extension is not found`);continue}try{b.info(`Migrating '${d.identifier.id}' extension to '${m}' extension...`);const w=!E.getDisabledExtensions().some(u=>(0,n.areSameExtensions)(u,d.identifier));await T.uninstall(d),b.info(`Uninstalled the unsupported extension '${d.identifier.id}'`);let g=I.find(u=>(0,n.areSameExtensions)(u.identifier,{id:m}));(!g||!g.isPreReleaseVersion&&w)&&(g=await T.installFromGallery(S,{installPreReleaseVersion:!0,isMachineScoped:d.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${g.identifier.id}'`),w||(await E.disableExtension(g.identifier),b.info(`Disabled the pre-release extension '${g.identifier.id}' because the unsupported extension '${d.identifier.id}' is disabled`)),p.storage&&(P.addToMigrationList((0,n.getExtensionId)(d.manifest.publisher,d.manifest.name),(0,n.getExtensionId)(g.manifest.publisher,g.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${d.identifier.id}' extension to '${m}' extension.`)}catch(w){b.error(w)}}}catch(R){b.error(R)}}e.migrateUnsupportedExtensions=L}),define(re[195],se([0,1,5,9,2,4,20,52,7,30,27,14,29,31,15,8]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends L.Disposable{constructor(S,w,g,u){super();this.fileService=w,this.extensionGalleryService=g,this.logService=u,this.extensionsDownloadDir=E.URI.file(S.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(S,w){await this.cleanUpPromise;const g=this.getName(S),u=(0,A.joinPath)(this.extensionsDownloadDir,g);if(!await this.fileService.exists(u)){const t=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(S,t,w);try{await this.rename(t,u,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(t)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",S.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,t.path),r}}return u}async delete(S){await this.cleanUpPromise,await this.fileService.del(S)}async rename(S,w,g){try{await R.Promises.rename(S.fsPath,w.fsPath)}catch(u){if(T.isWindows&&u&&u.code==="EPERM"&&Date.now()<g)return this.logService.info(`Failed renaming ${S} to ${w} with 'EPERM' error. Trying again...`),this.rename(S,w,g);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const S=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(S.children){const w=[],g=[];for(const r of S.children){const i=y.ExtensionKey.parse(r.name);i&&g.push([i,r])}const u=(0,y.groupByExtension)(g,([r])=>r),t=[];for(const r of u)r.sort((i,a)=>P.rcompare(i[0].version,a[0].version)),w.push(...r.slice(1).map(i=>i[1].resource)),t.push(r[0][1]);t.sort((r,i)=>r.mtime-i.mtime),w.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(w.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(S){this.logService.error(S)}}getName(S){return this.cache?y.ExtensionKey.create(S).toString().toLowerCase():(0,b.generateUuid)()}};f=de([Y(0,I.INativeEnvironmentService),Y(1,m.IFileService),Y(2,v.IExtensionGalleryService),Y(3,p.ILogService)],f),e.ExtensionsDownloader=f}),define(re[196],se([0,1,2,10,27,65]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(E,b){super();this.environmentService=E,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(R=>this.onDidInstallExtensions(R))),this._register(b.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(re[197],se([0,1,7,14,66,15,8,24]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends L.NativeExtensionsScannerService{constructor(R,I,v,y){super(D.URI.file(v.builtinExtensionsPath),D.URI.file(v.extensionsPath),v.userHome,D.URI.file(v.userDataPath),R,I,v,y)}};E=de([Y(0,T.IFileService),Y(1,A.ILogService),Y(2,n.INativeEnvironmentService),Y(3,P.IProductService)],E),e.ExtensionsScannerService=E}),define(re[198],se([0,1,91,16,5,2,19,10,27,14,29,31,8,62]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let m=class extends y.LanguagePackBaseService{constructor(S,w,g,u){super(g);this.extensionManagementService=S,this.logService=u,this.cache=this._register(new p(w,u)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getInstalledLanguages(){const S=await this.cache.getLanguagePacks(),w=Object.keys(S).map(g=>{const u=S[g];return{...this.createQuickPickItem({locale:g,label:u.label}),extensionId:u.extensions[0].extensionIdentifier.id}});return w.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),w}async postInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",S.identifier.id),await this.update())}async postUninstallExtension(S){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(u=>(0,I.areSameExtensions)(u.extensionIdentifier,S.identifier)))&&(this.logService.info("Removing language packs from the extension",S.identifier.id),await this.update())}async update(){const[S,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,n.equals)(Object.keys(S),Object.keys(g))}};m=de([Y(0,R.IExtensionManagementService),Y(1,b.INativeEnvironmentService),Y(2,R.IExtensionGalleryService),Y(3,v.ILogService)],m),e.NativeLanguagePackService=m;let p=class extends T.Disposable{constructor(S,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,g);Object.keys(S).forEach(g=>this.updateHash(S[g]))}createLanguagePacksFromExtension(S,w){const g=w.identifier,u=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const t of u)if(w.location.scheme===A.Schemas.file&&f(t)){let r=S[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},S[t.languageId]=r);let i=r.extensions.filter(a=>(0,I.areSameExtensions)(a.extensionIdentifier,g))[0];i?i.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const a of t.translations)r.translations[a.id]=(0,P.join)(w.location.fsPath,a.path)}}updateHash(S){if(S){const w=(0,D.createHash)("md5");for(const g of S.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);S.hash=w.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(w=S(g),g)).then(g=>{for(const t of Object.keys(g))g[t]||delete g[t];this.languagePacks=g,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),E.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>w,g=>this.logService.error(g))})}};p=de([Y(0,b.INativeEnvironmentService),Y(1,v.ILogService)],p);function f(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const S of d.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(re[199],se([0,1,5,17,23,9,3,2,30,82,193,97]),function(X,e,D,n,L,T,A,P,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var y;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function m(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p(G){const Q=new L.CancellationTokenSource;return setTimeout(()=>Q.cancel(),G),Q.token}function f(G,Q){if(G.isCancellationRequested||Q.isCancellationRequested)return L.CancellationToken.Cancelled;const Z=new L.CancellationTokenSource;return G.onCancellationRequested(()=>Z.cancel()),Q.onCancellationRequested(()=>Z.cancel()),Z.token}class d{constructor(Q){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((Z,q)=>{this._resolvePromise=Z,this._rejectPromise=q}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function S(G,Q){const Z=new d(Q);return Z.registerDisposable(G.onControlMessage(q=>{const B=JSON.parse(q.toString()),j=K(B);j?Z.reject(j):Z.resolve(B)})),Z.promise}function w(G,Q,Z,q,B,j,z,V){const ee=new d(V);return Q.connect(Z,q,B,j,z,(ie,ae)=>{ee.didTimeout?(ie&&G.error(ie),ae?.dispose()):ie||!ae?ee.reject(ie):ee.resolve(ae)}),ee.promise}function g(G,Q){const Z=new d(Q);return G.then(q=>{Z.didTimeout||Z.resolve(q)},q=>{Z.didTimeout||Z.reject(q)}),Z.promise}async function u(G,Q,Z,q){const B=x(G,Q);G.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let j;try{j=await w(G.logService,G.socketFactory,G.host,G.port,(0,I.getRemoteServerRootPath)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,`renderer-${m(Q)}-${G.reconnectionToken}`,q)}catch(ae){throw G.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ae),ae}G.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let z,V;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(j,null),z=G.reconnectionProtocol,V=!1):(z=new b.PersistentProtocol(j,null),V=!0),G.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const ee=await g(G.signService.createNewMessage((0,E.generateUuid)()),q),ie={type:"auth",auth:G.connectionToken||"00000000000000000000",data:ee.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const ae=await S(z,f(q,p(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(G.logService.trace(`${B} 4/6. received SignRequest control message.`),!await g(G.signService.validate(ee,ae.signedData),q)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const pe=await g(G.signService.sign(ae.data),q),we={type:"connectionType",commit:G.commit,signedData:pe,desiredConnectionType:Q};return Z&&(we.args=Z),G.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(we))),{protocol:z,ownsProtocol:V}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(G.logService.error(`${B} the handshake timed out. Error:`),G.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${B} received error control message when negotiating connection. Error:`),G.logService.error(ae)),V&&ne(z),ae}}async function t(G,Q,Z,q){const B=Date.now(),j=x(G,Q),{protocol:z,ownsProtocol:V}=await u(G,Q,Z,q),ee=new d(q);return ee.registerDisposable(z.onControlMessage(ie=>{const ae=JSON.parse(ie.toString()),fe=K(ae);fe?(G.logService.error(`${j} received error control message when negotiating connection. Error:`),G.logService.error(fe),V&&ne(z),ee.reject(fe)):(G.reconnectionProtocol&&G.reconnectionProtocol.endAcceptReconnection(),G.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${J(B)}!`),ee.resolve({protocol:z,firstMessage:ae}))})),ee.promise}async function r(G,Q){const{protocol:Z}=await t(G,1,void 0,Q);return{protocol:Z}}async function i(G,Q,Z){const{protocol:q,firstMessage:B}=await t(G,2,Q,Z),j=B&&B.debugPort;return{protocol:q,debugPort:j}}async function a(G,Q,Z){const q=Date.now(),B=x(G,3),{protocol:j}=await u(G,3,Q,Z);return G.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${J(q)}!`),j}async function c(G,Q,Z){const{host:q,port:B,connectionToken:j}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,host:q,port:B,connectionToken:j,reconnectionToken:Q,reconnectionProtocol:Z,socketFactory:G.socketFactory,signService:G.signService,logService:G.logService}}async function s(G,Q,Z){try{const q=(0,E.generateUuid)(),B=await c(G,q,null),{protocol:j}=await r(B,L.CancellationToken.None);return new $(G,Q,Z,q,j)}catch(q){throw G.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),G.logService.error(q),_.triggerPermanentFailure(0,0,R.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=s;async function o(G,Q){try{const Z=(0,E.generateUuid)(),q=await c(G,Z,null),{protocol:B,debugPort:j}=await i(q,Q,L.CancellationToken.None);return new H(G,Q,Z,B,j)}catch(Z){throw G.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),G.logService.error(Z),_.triggerPermanentFailure(0,0,R.RemoteAuthorityResolverError.isHandled(Z)),Z}}e.connectRemoteAgentExtensionHost=o;async function l(G,Q,Z){const q=await c(G,(0,E.generateUuid)(),null);return await a(q,{host:Q,port:Z},L.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function h(G){return(0,D.createCancelablePromise)(Q=>new Promise((Z,q)=>{const B=setTimeout(Z,G*1e3);Q.onCancellationRequested(()=>{clearTimeout(B),Z()})}))}var C;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(C=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(Q,Z){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.type=0}}e.ConnectionLostEvent=M;class O{constructor(Q,Z,q,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.durationSeconds=q,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class U{constructor(Q,Z,q){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=U;class k{constructor(Q,Z,q){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=q,this.type=4}}e.ConnectionGainEvent=k;class F{constructor(Q,Z,q,B){this.reconnectionToken=Q,this.millisSinceLastIncomingData=Z,this.attempt=q,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=F;class _ extends P.Disposable{constructor(Q,Z,q,B,j){super();this._connectionType=Q,this._options=Z,this.reconnectionToken=q,this.protocol=B,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new k(this.reconnectionToken,0,0)),this._register(B.onSocketClose(z=>{const V=W(this._connectionType,this.reconnectionToken,!0);z?z.type===0?(this._options.logService.info(`${V} received socket close event (hadError: ${z.hadError}).`),z.error&&this._options.logService.error(z.error)):(this._options.logService.info(`${V} received socket close event (wasClean: ${z.wasClean}, code: ${z.code}, reason: ${z.reason}).`),z.event&&this._options.logService.error(z.event)):this._options.logService.info(`${V} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(()=>{const z=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} received socket timeout event.`),this._beginReconnecting()})),_._instances.push(this),this._register((0,P.toDisposable)(()=>{const z=_._instances.indexOf(this);z>=0&&_._instances.splice(z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(_._permanentFailureMillisSinceLastIncomingData,_._permanentFailureAttempt,_._permanentFailureHandled)}static triggerPermanentFailure(Q,Z,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=Z,this._permanentFailureHandled=q,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||_._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const Q=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Z=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const B=q<Z.length?Z[q]:Z[Z.length-1];try{if(B>0){const z=h(B);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,z)),this._options.logService.info(`${Q} waiting for ${B} seconds before reconnecting...`);try{await z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${Q} resolving connection...`);const j=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,p(v)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(R.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,T.isCancellationError)(j)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof R.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,R.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(Q,Z,q){this._reconnectionFailureIsFatal?_.triggerPermanentFailure(Q,Z,q):this._gotoPermanentFailure(Q,Z,q)}_gotoPermanentFailure(Q,Z,q){this._onDidStateChange.fire(new F(this.reconnectionToken,Q,Z,q)),ne(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=_,_._permanentFailure=!1,_._permanentFailureMillisSinceLastIncomingData=0,_._permanentFailureAttempt=0,_._permanentFailureHandled=!1,_._instances=[];class $ extends _{constructor(Q,Z,q,B,j){super(1,Q,B,j,!0);this.client=this._register(new b.Client(j,{remoteAuthority:Z,clientId:q},Q.ipcLogger))}async _reconnect(Q,Z){await r(Q,Z)}}e.ManagementPersistentConnection=$;class H extends _{constructor(Q,Z,q,B,j){super(2,Q,q,B,!1);this._startArguments=Z,this.debugPort=j}async _reconnect(Q,Z){await i(Q,this._startArguments,Z)}}e.ExtensionHostPersistentConnection=H;function ne(G){try{G.acceptDisconnect();const Q=G.getSocket();G.dispose(),Q.dispose()}catch(Q){(0,T.onUnexpectedError)(Q)}}function K(G){if(G&&G.type==="error"){const Q=new Error(`Connection error: ${G.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function N(G,Q){for(;G.length<Q;)G+=" ";return G}function W(G,Q,Z){return`[remote-connection][${N(m(G),13)}][${Q.substr(0,5)}\u2026][${Z?"reconnect":"initial"}]`}function x(G,Q){return`${W(Q,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.host}:${G.port}]`}function J(G){return`${Date.now()-G} ms`}}),define(re[200],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[201],se([0,1,125,18,8]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,E){this.configurationService=P,this.logService=E}async request(P,E){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const b=await(0,D.request)(P,E);return this.logService.trace("RequestService#request (browser) - success",P.url),b}catch(b){throw this.logService.error("RequestService#request (browser) - error",P.url,b),b}}async resolveProxy(P){}};T=de([Y(0,n.IConfigurationService),Y(1,L.ILogService)],T),e.RequestService=T}),define(re[43],se([0,1,17,148,42,6,38]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function E(p){return p.res.statusCode===204}async function b(p){return E(p)?null:(await(0,D.streamToBuffer)(p.stream)).toString()}e.asText=b;async function R(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return b(p)}e.asTextOrError=R;async function I(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(E(p))return null;const d=(await(0,D.streamToBuffer)(p.stream)).toString();try{return JSON.parse(d)}catch(S){throw S.message+=`:
`+d,S}}e.asJson=I;function v(p){m(p)}e.updateProxyConfigurationsScope=v;let y;function m(p){const f=A.Registry.as(L.Extensions.Configuration),d=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[y],remove:d?[d]:[]})}m(2)}),define(re[202],se([0,1,23,19,15,43]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,R=D.CancellationToken.None){if(E.scheme===n.Schemas.file||E.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const I={type:"GET",url:E.toString()},v=await this.requestService.request(I,R);if(v.res.statusCode===200)await this.fileService.writeFile(b,v.stream);else{const y=await(0,T.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${y}`)}}};A=de([Y(0,T.IRequestService),Y(1,L.IFileService)],A),e.DownloadService=A}),define(re[203],se([0,1,16,23,71,2,20,163,15,8,24,43]),function(X,e,D,n,L,T,A,P,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=class extends T.Disposable{constructor(m,p,f,d){super();this.fileService=m,this.productService=p,this.requestService=f,this.logService=d,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:S})=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(m){return this.getValidConfigBasedTips(m)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(m){const p=[];for(const[f,d]of this.allConfigBasedTips)if(!(d.configScheme&&d.configScheme!==m.scheme))try{const S=await this.fileService.readFile((0,A.joinPath)(m,f)),w=new Map;(0,L.forEach)(d.recommendations,({key:u,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)w.set(r,{extensionId:u,extensionName:t.name,configName:d.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled});else p.push({extensionId:u,extensionName:t.name,configName:d.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack,whenNotInstalled:t.whenNotInstalled})});const g=(0,P.getDomainsOfRemotes)(S.value.toString(),[...w.keys()]);for(const u of g){const t=w.get(u);t&&p.push(t)}}catch{}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const m=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(m.res.statusCode!==200)return[];const p=await(0,I.asJson)(m);return p?p.workspaceRecommendations||[]:[]}catch(m){return this.logService.error(m),[]}}};v=de([Y(0,E.IFileService),Y(1,R.IProductService),Y(2,I.IRequestService),Y(3,b.ILogService)],v),e.ExtensionTipsService=v}),define(re[98],se([0,1,76,6]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[204],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[205],se([0,1,83,5,23,3,2,19,30,8,98,204]),function(X,e,D,n,L,T,A,P,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(p){this.logService=p,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(p){const f=`window: ${p.reply.windowId}, moduleId: ${p.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${f})`);const d=(0,R.hash)(p);this.processeDisposables.has(d)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.doDisposeWorker(p));const S=new L.CancellationTokenSource;let w,g,u;this.processeDisposables.set(d,a=>{S.dispose(!0),w?.terminate(p,L.CancellationToken.None),g?.close(),u?.close(),this.processeDisposables.delete(d);const c=this.processResolvers.get(d);c&&(this.processResolvers.delete(d),c({reason:a}))}),w=await this.getOrCreateWebWorker(p);const t=new Promise(a=>{this.processResolvers.set(d,a)});if(S.token.isCancellationRequested)return t;const{port1:r,port2:i}=new MessageChannel;return g=r,u=i,await w.spawn(p,u,S.token),S.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${f})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",p,[g])),t}getOrCreateWebWorker(p){let f=this.workers.get(p.process.moduleId);if(!f){this.logService.trace(`SharedProcess: creating new web worker (${p.process.moduleId})`);const d=new y(p.process.type,this.logService);f=d.init(),d.onDidProcessSelfTerminate(({configuration:S,reason:w})=>{this.doDisposeWorker(S,w)}),this.workers.set(p.process.moduleId,f)}return f}async disposeWorker(p){return this.doDisposeWorker(p)}doDisposeWorker(p,f){const d=this.processeDisposables.get((0,R.hash)(p));d&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${p.reply.windowId}, moduleId: ${p.process.moduleId})`),d(f))}};v=de([Y(0,b.ILogService)],v),e.SharedProcessWorkerService=v;class y extends A.Disposable{constructor(p,f){super();this.type=p,this.logService=f,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const p=new n.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return f.onerror=d=>{this.logService.error(`SharedProcess: worker error (${this.type})`,d.message)},f.onmessageerror=d=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,d)},f.onmessage=d=>{const{id:S,message:w,configuration:g,nonce:u}=d.data;switch(S){case I.SharedProcessWorkerMessages.Ready:p.complete(f);break;case I.SharedProcessWorkerMessages.Ack:if(u){const t=this.mapMessageNonceToPendingMessageResolve.get(u);t&&(this.mapMessageNonceToPendingMessageResolve.delete(u),t())}break;case I.SharedProcessWorkerMessages.SelfTerminated:g&&w&&this._onDidProcessSelfTerminate.fire({configuration:g,reason:JSON.parse(w)});break;case I.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,w);break;case I.SharedProcessWorkerMessages.Info:w&&this.logService.info(w);break;case I.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,w);break;case I.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,w);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,d)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),p.p}async send(p,f,d){const S=await this.workerReady;if(!f.isCancellationRequested)return new Promise(w=>{const g=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(g,w);const u={...p,nonce:g};d?S.postMessage(u,[d]):S.postMessage(u),f.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(g)&&w()})})}spawn(p,f,d){const S={id:I.SharedProcessWorkerMessages.Spawn,configuration:p,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",X).fsPath}};return this.send(S,d,f)}terminate(p,f){const d={id:I.SharedProcessWorkerMessages.Terminate,configuration:p};return this.send(d,f)}}}),define(re[206],se([0,1,57,19,162]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}de([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(re[207],se([0,1,45,10,149,23,37,9,4,30,131,160,5]),function(X,e,D,n,L,T,A,P,E,b,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let m;async function p(d,S,w){return S["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(w)&&!S["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(w)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=v.Promises.withAsyncBody(async(g,u)=>{const t=new T.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),u(new Error((0,L.localize)(0,null)))},y);try{g(await f(d,t.token))}catch(i){!(0,P.isCancellationError)(i)&&!t.token.isCancellationRequested?u(new Error((0,L.localize)(1,null,(0,A.toErrorMessage)(i)))):g({})}finally{clearTimeout(r),t.dispose()}})),m)}e.getResolvedShellEnv=p;async function f(d,S){const w=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",w);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",g);const u=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"(.*)"+u),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",r);const i=await(0,R.getSystemShell)(E.OS,r);return d.trace("getUnixShellEnvironment#shell",i),new Promise((a,c)=>{if(S.isCancellationRequested)return c((0,P.canceled)());const s=(0,n.basename)(i);let o,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(o=`& '${process.execPath}' ${h} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,l=["-Login","-Command"]):(o=`'${process.execPath}' ${h} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,s==="tcsh"?l=["-ic"]:l=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),o);const C=(0,D.spawn)(i,[...l,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});S.onCancellationRequested(()=>(C.kill(),c((0,P.canceled)()))),C.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(U)),c(U)});const M=[];C.stdout.on("data",U=>M.push(U));const O=[];C.stderr.on("data",U=>O.push(U)),C.on("close",(U,k)=>{const F=Buffer.concat(M).toString("utf8");d.trace("getUnixShellEnvironment#raw",F);const _=Buffer.concat(O).toString("utf8");if(_.trim()&&d.trace("getUnixShellEnvironment#stderr",_),U||k)return c(new Error((0,L.localize)(2,null,U,k)));const $=t.exec(F),H=$?$[1]:"{}";try{const ne=JSON.parse(H);w?ne.ELECTRON_RUN_AS_NODE=w:delete ne.ELECTRON_RUN_AS_NODE,g?ne.ELECTRON_NO_ATTACH_CONSOLE=g:delete ne.ELECTRON_NO_ATTACH_CONSOLE,delete ne.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ne),a(ne)}catch(ne){d.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(ne)),c(ne)}})})}}),define(re[99],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[208],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,T)=>X(["vsda"],L,T))}async createNewMessage(L){try{const T=await this.vsda(),A=new T.validator;if(A){const P=String(D._nextId++);return this.validators.set(P,A),{id:P,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,T){if(!L.id)return!0;const A=this.validators.get(L.id);if(!A)return!1;this.validators.delete(L.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(L){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(re[21],se([0,1,5,3,2,184,13,84,6]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var R;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(R=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var v;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));class y extends L.Disposable{constructor(d={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,S){S===b?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:S,target:this.getKeyTargets(d)[S]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,S,w){return this.getStorage(S)?.get(d,w)}getBoolean(d,S,w){return this.getStorage(S)?.getBoolean(d,w)}getNumber(d,S,w){return this.getStorage(S)?.getNumber(d,w)}store(d,S,w,g){if((0,A.isUndefinedOrNull)(S)){this.remove(d,w);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,w,g),this.getStorage(w)?.set(d,S)})}remove(d,S){this.withPausedEmitters(()=>{this.updateKeyTarget(d,S,void 0),this.getStorage(S)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,S){const w=[],g=this.getKeyTargets(d);for(const u of Object.keys(g))g[u]===S&&w.push(u);return w}updateKeyTarget(d,S,w){const g=this.getKeyTargets(S);typeof w=="number"?g[d]!==w&&(g[d]=w,this.getStorage(S)?.set(b,JSON.stringify(g))):typeof g[d]=="number"&&(delete g[d],this.getStorage(S)?.set(b,JSON.stringify(g)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const S=this.get(b,d);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=R.NONE){this._onWillSaveState.fire({reason:d});const S=this.getStorage(0),w=this.getStorage(1);switch(d){case R.NONE:await D.Promises.settled([S?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([S?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve()]);break}}async logStorage(){const d=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return p(d,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}e.InMemoryStorageService=m;async function p(f,d,S,w){const g=s=>{try{return JSON.parse(s)}catch{return s}},u=new Map,t=new Map;f.forEach((s,o)=>{u.set(o,s),t.set(o,g(s))});const r=new Map,i=new Map;d.forEach((s,o)=>{r.set(o,s),i.set(o,g(s))}),console.group(`Storage: Global (path: ${S})`);let a=[];u.forEach((s,o)=>{a.push({key:o,value:s})}),console.table(a),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${w})`);let c=[];r.forEach((s,o)=>{c.push({key:o,value:s})}),console.table(c),console.groupEnd(),console.log(i)}e.logStorage=p}),define(re[209],se([0,1,3,2,13,29,31,21]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends n.Disposable{constructor(I,v){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(I)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(v.onDidInstallExtensions(y=>y.forEach(({local:m,operation:p})=>{m&&p===4&&this._removeFromDisabledExtensions(m.identifier)})))}async enableExtension(I,v){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:v}),!0):!1}async disableExtension(I,v){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let v=this.getDisabledExtensions();return v.every(y=>!(0,A.areSameExtensions)(y,I))?(v.push(I),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(I){let v=this.getDisabledExtensions();for(let y=0;y<v.length;y++){const m=v[y];if((0,A.areSameExtensions)(m,I))return v.splice(y,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(I){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,v){this.storageManger.set(I,v,0)}};E=de([Y(0,P.IStorageService),Y(1,T.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class b extends n.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(I,v){let y;return v===0?((0,L.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,v)),y=this.storage[I]):y=this._get(I,v),JSON.parse(y)}set(I,v,y){let m=JSON.stringify(v.map(({id:f,uuid:d})=>({id:f,uuid:d})));this._get(I,y)!==m&&(y===0&&(v.length?this.storage[I]=m:delete this.storage[I]),this._set(I,v.length?m:void 0,y))}onDidStorageChange(I){if(I.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const y=this.get(I.key,I.scope);delete this.storage[I.key];const m=this.get(I.key,I.scope),p=y.filter(d=>!m.some(S=>(0,A.areSameExtensions)(d,S))),f=m.filter(d=>!y.some(S=>(0,A.areSameExtensions)(S,d)));(p.length||f.length)&&this._onDidChange.fire([...p,...f])}}_get(I,v){return this.storageService.get(I,v,"[]")}_set(I,v,y){v?this.storageService.store(I,v,y,1):this.storageService.remove(I,y)}}e.StorageManager=b}),define(re[67],se([0,1,6,3,2,21,31,24,16,8,13]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const I=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=class Qe extends L.Disposable{constructor(m,p,f){super();this.storageService=m,this.productService=p,this.logService=f,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(m),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}static toKey(m){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(m.id)}@${m.version}`}static fromKey(m){const p=I.exec(m);if(p&&p[1])return{id:p[1],version:p[2]}}static async removeOutdatedExtensionVersions(m,p){const f=await m.getInstalled(),d=[];for(const[S,w]of Qe.readAllExtensionsWithKeysForSync(p)){const g=f.find(u=>(0,A.areSameExtensions)(u.identifier,{id:S}))?.manifest.version;for(const u of w)g!==u&&d.push(Qe.toKey({id:S,version:u}))}for(const S of d)p.remove(S,0)}static readAllExtensionsWithKeysForSync(m){const p=new Map,f=m.keys(0,1);for(const d of f){const S=Qe.fromKey(d);if(S){let w=p.get(S.id.toLowerCase());w||p.set(S.id.toLowerCase(),w=[]),w.push(S.version)}}return p}onDidChangeStorageValue(m){if(m.scope!==0)return;if(this.extensionsWithKeysForSync.has(m.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const p=Qe.fromKey(m.key);if(p){if(this.storageService.get(m.key,0)===void 0)this.extensionsWithKeysForSync.delete(p.id.toLowerCase());else{let f=this.extensionsWithKeysForSync.get(p.id.toLowerCase());f||this.extensionsWithKeysForSync.set(p.id.toLowerCase(),f=[]),f.push(p.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(m){if((0,R.isString)(m))return m;const p=m.manifest?m.manifest.publisher:m.publisher,f=m.manifest?m.manifest.name:m.name;return(0,A.getExtensionId)(p,f)}getExtensionState(m,p){const f=this.getExtensionId(m),d=this.storageService.get(f,p?0:1);if(d)try{return JSON.parse(d)}catch(S){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${p}): ${S}`)}}setExtensionState(m,p,f){const d=this.getExtensionId(m);p===void 0?this.storageService.remove(d,f?0:1):this.storageService.store(d,JSON.stringify(p),f?0:1,1)}setKeysForSync(m,p){this.storageService.store(Qe.toKey(m),JSON.stringify(p),0,1)}getKeysForSync(m){const p=this.productService.extensionSyncedKeys?.[m.id.toLowerCase()],f=this.storageService.get(Qe.toKey(m),0),d=f?JSON.parse(f):void 0;return d&&p?(0,E.distinct)([...d,...p]):d||p}addToMigrationList(m,p){if(m!==p){const f=this.migrationList.filter(d=>!d.includes(m)&&!d.includes(p));f.push([m,p]),this.migrationList=f}}getSourceExtensionToMigrate(m){const p=this.migrationList.find(([,f])=>m===f);return p?p[0]:void 0}get migrationList(){const m=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const p=JSON.parse(m);if((0,R.isArray)(p))return p}catch{}return[]}set migrationList(m){m.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(m),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};v=de([Y(0,T.IStorageService),Y(1,P.IProductService),Y(2,b.ILogService)],v),e.ExtensionStorageService=v}),define(re[210],se([0,1,2,29,67,194,8,21]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let E=class extends D.Disposable{constructor(R,I,v,y,m,p){super();R.removeDeprecatedExtensions(),(0,T.migrateUnsupportedExtensions)(R,I,v,y,p),L.ExtensionStorageService.removeOutdatedExtensionVersions(R,m)}};E=de([Y(0,n.IExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,L.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,A.ILogService)],E),e.ExtensionsCleaner=E}),define(re[211],se([0,1,3,2]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(b,R){super();this.channel=b,this.workspace=R}async getItems(){const b={workspace:this.workspace},R=await this.channel.call("getItems",b);return new Map(R)}updateItems(b){const R={workspace:this.workspace};return b.insert&&(R.insert=Array.from(b.insert.entries())),b.delete&&(R.delete=Array.from(b.delete.values())),this.channel.call("updateItems",R)}}class T extends L{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class A extends L{constructor(b,R){super(b,R);this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}class P extends n.Disposable{constructor(b,R){super();this.channel=b,this.workspace=R,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(re[212],se([0,1,5,2,20,84,21,211]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends A.AbstractStorageService{constructor(R,I,v){super();this.mainProcessService=I,this.environmentService=v,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(R)}createGlobalStorage(){const R=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),I=new T.Storage(R.globalStorage);return this._register(I.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),I}createWorkspaceStorage(R){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),R);if(I.workspaceStorage){const v=new T.Storage(I.workspaceStorage);return this.workspaceStorageDisposable.value=v.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=R?.id,v}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(R){return R===0?this.globalStorage:this.workspaceStorage}getLogDetails(R){return R===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(R){const I=this.workspaceStorage,v=I?.items??new Map;I&&(await I.close(),I.dispose()),this.workspaceStorage=this.createWorkspaceStorage(R),await this.workspaceStorage.init();for(const[y,m]of v)this.workspaceStorage.set(y,m)}}e.NativeStorageService=E}),define(re[213],se([0,1,4,34,7,30]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,R,I,v,y,m,p,f,d,S){const w=Object.create(null);w["common.machineId"]=p,w.sessionID=(0,T.generateUuid)()+Date.now(),w.commitHash=y,w.version=m,w["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,D.PlatformToString)(D.platform),w["common.nodePlatform"]=n.platform,w["common.nodeArch"]=v,w["common.product"]=S||"desktop";const g=E(f||[]);g&&(w["common.msftInternal"]=g);let u=0;const t=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.isLinuxSnap&&(w["common.snap"]="true");const r=A(I);r&&(w["common.platformDetail"]=r);try{const i=await b.readFile(L.URI.file(d));w["common.source"]=i.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=P;function E(b){const R=n.env.USERDNSDOMAIN;if(!R)return!1;const I=R.toLowerCase();return b.some(v=>I===v)}e.verifyMicrosoftInternalDomain=E}),define(re[22],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[214],se([0,1,35,49,5,33,19,10,4,7,118,27,121,88,15,24,22]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const d=new Map;async function S(r,i){const a=`${r}::${i.join(":")}`,c=d.get(a);if(c)return c;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,l=new Map,h=2e4;function C(O,U,k,F){const _=U.substring(O.length+1);return L.Promises.withAsyncBody(async $=>{let H;try{H=await I.Promises.readdir(U,{withFileTypes:!0})}catch{$();return}if(F.count>=h){F.count+=H.length,F.maxReached=!0,$();return}let ne=H.length;if(ne===0){$();return}let K=H;F.count+H.length>h&&(F.maxReached=!0,ne=h-F.count,K=H.slice(0,ne)),F.count+=H.length;for(const N of K)if(N.isDirectory()){if(k.includes(N.name)||await C(O,(0,P.join)(U,N.name),k,F),--ne==0){$();return}}else{const W=N.name.lastIndexOf(".");if(W>=0){const x=N.name.substring(W+1);x&&o.set(x,(o.get(x)??0)+1)}for(const x of s)x.relativePathPattern?.test(_)!==!1&&x.filePattern.test(N.name)&&l.set(x.tag,(l.get(x.tag)??0)+1);if(--ne==0){$();return}}})}const M=L.Promises.withAsyncBody(async O=>{const U={count:0,maxReached:!1};await C(r,r,i,U);const k=await u(r);O({configFiles:w(l),fileTypes:w(o),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:k})});return d.set(a,M),M}e.collectWorkspaceStats=S;function w(r){return[...n.Iterable.map(r.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function g(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},i=D.cpus();return i&&i.length>0&&(r.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),r}e.getMachineInfo=g;async function u(r){try{const i=new Map,a=(0,P.join)(r,".vscode","launch.json"),c=await I.Promises.readFile(a),s=[],o=(0,T.parse)(c.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,T.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const h=l.type;h&&(i.has(h)?i.set(h,i.get(h)+1):i.set(h,1))}return w(i)}catch{return[]}}e.collectLaunchConfigs=u;let t=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const c=D.cpus();return c&&c.length>0&&a.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),a.push(`Memory (System):  ${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||a.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,v.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async c=>{let[s,o]=c,l=this.formatProcessList(i,s);return a.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))l+=`
${h.errorMessage}`,o+=`
${h.errorMessage}`;else if(l+=`

Remote: ${h.hostName}`,h.processes&&(l+=`
${this.formatProcessList(i,h.processes)}`),h.workspaceMetadata){o+=`
|  Remote: ${h.hostName}`;for(const C of Object.keys(h.workspaceMetadata)){const M=h.workspaceMetadata[C];let O=`${M.fileCount} files`;M.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${C}): ${O}`,o+=this.formatWorkspaceStats(M)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(i,a){const{memory:c,vmHint:s,os:o,cpus:l}=g(),h={os:o,memory:c,cpus:l,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return E.isWindows||(h.load=`${D.loadavg().map(C=>Math.round(C)).join(", ")}`),E.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(i,a){const c=[];return(0,v.listProcesses)(i.mainPID).then(async s=>(c.push(""),c.push(this.formatEnvironment(i)),c.push(""),c.push(this.formatProcessList(i,s)),i.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(i))),a.forEach(o=>{if((0,y.isRemoteDiagnosticError)(o))c.push(`
${o.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${o.hostName}`),c.push(this.formatMachineInfo(o.machineInfo)),o.processes&&c.push(this.formatProcessList(i,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const h=o.workspaceMetadata[l];let C=`${h.fileCount} files`;h.maxFilesReached&&(C=`more than ${C}`),c.push(`Folder (${l}): ${C}`),c.push(this.formatWorkspaceStats(h))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(i){const a=[],c=60;let s=0;const o=(M,O)=>{const U=` ${M}(${O})`;s+U.length>c?(a.push(l),l="|                 ",s=l.length):s+=U.length,l+=U};let l="|      File types:";const h=10;let C=i.fileTypes.length>h?h:i.fileTypes.length;for(let M=0;M<C;M++){const O=i.fileTypes[M];o(O.name,O.count)}if(a.push(l),i.configFiles.length>=0&&(l="|      Conf files:",s=0,i.configFiles.forEach(M=>{o(M.name,M.count)}),a.push(l)),i.launchConfigFiles.length>0){let M="|      Launch Configs:";i.launchConfigFiles.forEach(O=>{M+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),a.push(M)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(c=>c.length));return Object.keys(i).map(c=>`${c}:  ${" ".repeat(a-c.length)}  ${i[c]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],c=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const l=b.URI.revive(o);if(l.scheme===A.Schemas.file){const h=l.fsPath;c.push(S(h,["node_modules",".git"]).then(C=>{let M=`${C.fileCount} files`;C.maxFilesReached&&(M=`more than ${M}`),a.push(`|    Folder (${(0,P.basename)(h)}): ${M}`),a.push(this.formatWorkspaceStats(C))}).catch(C=>{a.push(`|      Error: Unable to collect workspace stats for folder ${h} (${C.toString()})`)}))}else a.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const c=new Map;i.windows.forEach(o=>c.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,c,s,a,0),s.join(`
`)}formatProcessItem(i,a,c,s,o){const l=o===0;let h;l?h=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(h=`${h} (${a.get(s.pid)})`));const C=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);c.push(`${s.load.toFixed(0).padStart(5," ")}	${(C/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(M=>this.formatProcessItem(i,a,c,M,o+1))}async getWorkspaceFileExtensions(i){const a=new Set;for(const{uri:c}of i.folders){const s=b.URI.revive(c);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{(await S(o,["node_modules",".git"])).fileTypes.forEach(h=>a.add(h.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const c=b.URI.revive(a);if(c.scheme!==A.Schemas.file)continue;const s=c.fsPath;try{const o=await S(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};t=de([Y(0,f.ITelemetryService),Y(1,p.IProductService)],t),e.DiagnosticsService=t}),define(re[215],se([0,1,16,5,23,9,3,2,4,7,136,29,31,8,24,22]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{constructor(t,r,i,a){super();this.galleryService=t,this.telemetryService=r,this.logService=i,this.productService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(c=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(i=>(0,I.isTargetPlatformCompatible)(i,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new I.ExtensionManagementError(R.localize(0,null),I.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,r)}catch(i){throw w(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(t),error:i}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(i),S(i)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(R.localize(1,null));const r=await this.getTargetPlatform(),[i]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},L.CancellationToken.None);if(!i)throw new Error(R.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,i){if(!b.URI.isUri(r)){let l=this.installingExtensions.get(v.ExtensionKey.create(r).toString());if(l)return this.logService.info("Extensions is already requested to install",r.identifier.id),l.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],c=[],s=this.createInstallExtensionTask(t,r,i);b.URI.isUri(r)||this.installingExtensions.set(v.ExtensionKey.create(r).toString(),s),this._onInstallExtension.fire({identifier:s.identifier,source:r}),this.logService.info("Installing extension:",s.identifier.id),a.push({task:s,manifest:t});let o=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",s.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(s.identifier,t,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:C,manifest:M}of h){o=o||!!M.extensionDependencies?.some(U=>(0,v.areSameExtensions)({id:U},s.identifier));const O=v.ExtensionKey.create(C).toString();if(this.installingExtensions.has(O))this.logService.info("Extension is already requested to install",C.identifier.id);else{const U=this.createInstallExtensionTask(M,C,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(O,U),this._onInstallExtension.fire({identifier:U.identifier,source:C}),this.logService.info("Installing extension:",U.identifier.id),a.push({task:U,manifest:M})}}}catch(h){if(b.URI.isUri(s.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",s.identifier.id,h.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",s.identifier.id,h.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",s.identifier.id),h}const l=a.reduce((h,{task:C,manifest:M})=>(h.set(C.identifier.id.toLowerCase(),{task:C,manifest:M}),h),new Map);for(;l.size;){let h;const C=[...l.values()].filter(({manifest:M})=>!M.extensionDependencies?.some(O=>l.has(O.toLowerCase())));C.length?h=l.size===1?C:C.filter(({task:M})=>!(M===s&&!o)):(this.logService.info("Found extensions with circular dependencies",C.map(({task:M})=>M.identifier.id)),h=[...l.values()]),await this.joinAllSettled(h.map(async({task:M})=>{const O=new Date().getTime();try{const U=await M.run();if(await this.joinAllSettled(this.participants.map(k=>k.postInstall(U,M.source,i,L.CancellationToken.None))),!b.URI.isUri(M.source)){const k=M.operation===3;if(w(this.telemetryService,k?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-O,durationSinceUpdate:k?void 0:new Date().getTime()-M.source.lastUpdated}),E.isWeb&&M.operation!==3)try{await this.galleryService.reportStatistic(U.manifest.publisher,U.manifest.name,U.manifest.version,"install")}catch{}}c.push({local:U,identifier:M.identifier,operation:M.operation,source:M.source})}catch(U){throw b.URI.isUri(M.source)||w(this.telemetryService,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(M.source),duration:new Date().getTime()-O,error:U}),this.logService.error("Error while installing the extension:",M.identifier.id),U}finally{l.delete(M.identifier.id.toLowerCase())}}))}return c.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(c),c.filter(({identifier:h})=>(0,v.areSameExtensions)(h,s.identifier))[0].local}catch(l){if(a.forEach(({task:h})=>h.cancel()),c.length)try{const h=await Promise.allSettled(c.map(({local:C})=>this.createUninstallExtensionTask(C,{versionOnly:!0}).run()));for(let C=0;C<h.length;C++){const M=h[C],{identifier:O}=c[C];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,T.getErrorMessage)(M.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(h),c.map(({identifier:C})=>C.id))}throw this._onDidInstallExtensions.fire(a.map(({task:h})=>({identifier:h.identifier,operation:2,source:h.source}))),l}finally{for(const{task:l}of a)if(!b.URI.isUri(l.source)){const h=v.ExtensionKey.create(l.source).toString();this.installingExtensions.delete(h)||this.logService.warn("Installation task is not found in the cache",h)}}}async joinAllSettled(t){const r=[],i=[],a=await Promise.allSettled(t);for(const c of a)c.status==="fulfilled"?r.push(c.value):i.push(c.reason);if(i.length)throw d(i);return r}async getAllDepsAndPackExtensionsToInstall(t,r,i,a){if(!this.galleryService.isEnabled())return[];let c=await this.getInstalled();const s=[t,...c.map(h=>h.identifier)],o=[],l=async(h,C)=>{const M=C.extensionDependencies||[],O=[...M];if(C.extensionPack){const U=i?c.find(k=>(0,v.areSameExtensions)(k.identifier,h)):void 0;for(const k of C.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(F=>(0,v.areSameExtensions)({id:F},{id:k}))||O.every(F=>!(0,v.areSameExtensions)({id:F},{id:k}))&&O.push(k)}if(O.length){const U=[...s,...o.map(F=>F.gallery.identifier)],k=O.filter(F=>U.every(_=>!(0,v.areSameExtensions)(_,{id:F})));if(k.length){const F=await this.galleryService.getExtensions(k.map(_=>({id:_,preRelease:a})),L.CancellationToken.None);for(const _ of F){if(U.find(ne=>(0,v.areSameExtensions)(ne,_.identifier)))continue;const $=M.some(ne=>(0,v.areSameExtensions)({id:ne},_.identifier));let H;try{H=await this.checkAndGetCompatibleVersion(_,!1,a)}catch(ne){if(ne instanceof I.ExtensionManagementError&&ne.code===I.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.logService.info("Skipping the packed extension as it cannot be installed",_.identifier.id);continue}else throw ne}o.push({gallery:H.extension,manifest:H.manifest}),await l(H.extension.identifier,H.manifest)}}}};return await l(t,r),c=await this.getInstalled(),o.filter(h=>!c.some(C=>(0,v.areSameExtensions)(C.identifier,h.gallery.identifier)))}async checkAndGetCompatibleVersion(t,r,i){const a=await this.getExtensionsControlManifest();if((0,v.getMaliciousExtensionsSet)(a).has(t.identifier.id))throw new I.ExtensionManagementError(R.localize(3,null,t.identifier.id),I.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const o=await this.getTargetPlatform();throw new I.ExtensionManagementError(R.localize(4,null,t.identifier.id,this.productService.nameLong,(0,I.TargetPlatformToString)(o)),I.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(t,r,i);if(c){if(i&&!r&&t.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new I.ExtensionManagementError(R.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],L.CancellationToken.None))[0]?new I.ExtensionManagementError(R.localize(6,null,t.identifier.id),I.ExtensionManagementErrorCode.ReleaseVersionNotFound):new I.ExtensionManagementError(R.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),I.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const s=await this.galleryService.getManifest(c,L.CancellationToken.None);if(s===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);if(s.version!==c.version)throw new I.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:s}}async getCompatibleVersion(t,r,i){const a=await this.getTargetPlatform();let c=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==i&&(c=(await this.galleryService.getExtensions([{...t.identifier,preRelease:i}],{targetPlatform:a,compatible:!0},L.CancellationToken.None))[0]||null),!c&&await this.galleryService.isExtensionCompatible(t,i,a)&&(c=t),c||(r?c=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:a,compatible:!0},L.CancellationToken.None))[0]||null:c=await this.galleryService.getCompatibleExtension(t,i,a)),c}async unininstallExtension(t,r){const i=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),i.waitUntilTaskIsFinished();const a=(l,h)=>{const C=this.createUninstallExtensionTask(l,h);return this.uninstallingExtensions.set(C.extension.identifier.id.toLowerCase(),C),this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier),C},c=(l,h)=>{h?this.logService.error("Failed to uninstall extension:",l.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",l.identifier.id),w(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(l),error:h}),this._onDidUninstallExtension.fire({identifier:l.identifier,error:h?.code})},s=[],o=[];try{s.push(a(t,{}));const l=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const h=this.getAllPackExtensionsToUninstall(t,l);for(const C of h)this.uninstallingExtensions.has(C.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",C.identifier.id):s.push(a(C,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(s.map(h=>h.extension),l,t),await this.joinAllSettled(s.map(async h=>{try{if(await h.run(),await this.joinAllSettled(this.participants.map(C=>C.postUninstall(h.extension,r,L.CancellationToken.None))),h.extension.identifier.uuid)try{await this.galleryService.reportStatistic(h.extension.manifest.publisher,h.extension.manifest.name,h.extension.manifest.version,"uninstall")}catch{}c(h.extension)}catch(C){const M=C instanceof I.ExtensionManagementError?C:new I.ExtensionManagementError((0,T.getErrorMessage)(C),I.ExtensionManagementErrorCode.Internal);throw c(h.extension,M),M}finally{o.push(h)}}))}catch(l){const h=l instanceof I.ExtensionManagementError?l:new I.ExtensionManagementError((0,T.getErrorMessage)(l),I.ExtensionManagementErrorCode.Internal);for(const C of s){try{C.cancel()}catch{}o.includes(C)||c(C.extension,h)}throw h}finally{for(const l of s)this.uninstallingExtensions.delete(l.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",l.extension.identifier.id)}}checkForDependents(t,r,i){for(const a of t){const c=this.getDependents(a,r);if(c.length){const s=c.filter(o=>!t.some(l=>(0,v.areSameExtensions)(l.identifier,o.identifier)));if(s.length)throw new Error(this.getDependentsErrorMessage(a,s,i))}}}getDependentsErrorMessage(t,r,i){return i===t?r.length===1?R.localize(8,null,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?R.localize(9,null,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):R.localize(10,null,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?R.localize(11,null,i.manifest.displayName||i.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?R.localize(12,null,i.manifest.displayName||i.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):R.localize(13,null,i.manifest.displayName||i.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,i=[]){if(i.indexOf(t)!==-1)return[];i.push(t);const a=t.manifest.extensionPack?t.manifest.extensionPack:[];if(a.length){const c=r.filter(o=>!o.isBuiltin&&a.some(l=>(0,v.areSameExtensions)({id:l},o.identifier))),s=[];for(const o of c)s.push(...this.getAllPackExtensionsToUninstall(o,r,i));return[...c,...s]}return[]}getDependents(t,r){return r.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(a=>(0,v.areSameExtensions)({id:a},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};f=de([Y(0,I.IExtensionGalleryService),Y(1,p.ITelemetryService),Y(2,y.ILogService),Y(3,m.IProductService)],f),e.AbstractExtensionManagementService=f;function d(u){const t=Array.isArray(u)?u:[u];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,i)=>new Error(`${r.message}${r.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=d;function S(u){if(u instanceof I.ExtensionManagementError)return u;const t=new I.ExtensionManagementError(u.message,I.ExtensionManagementErrorCode.Internal);return t.stack=u.stack,t}function w(u,t,{extensionData:r,duration:i,error:a,durationSinceUpdate:c}){const s=a?a instanceof I.ExtensionManagementError?a.code:I.ExtensionManagementErrorCode.Internal:void 0;u.publicLog(t,{...r,success:!a,duration:i,errorcode:s,durationSinceUpdate:c})}e.reportTelemetry=w;class g{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((r,i)=>{const a=t.onCancellationRequested(()=>{a.dispose(),i(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=g}),define(re[216],se([0,1,16,5,71,3,10,4,34,7,139,14,29,31,203,90,15,8,63,24,43,21,22]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let a=class extends m.ExtensionTipsService{constructor(s,o,l,h,C,M,O,U,k,F){super(O,U,k,F);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=l,this.storageService=h,this.nativeHostService=C,this.extensionRecommendationNotificationService=M,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,L.forEach)(U.exeBasedExtensionTips,({key:_,value:$})=>{const H=[],ne=[],K=[];(0,L.forEach)($.recommendations,({key:N,value:W})=>{W.important?$.important?H.push({extensionId:N,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):ne.push({extensionId:N,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):K.push({extensionId:N,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),H.length&&this.highImportanceExecutableTips.set(_,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H}),ne.length&&this.mediumImportanceExecutableTips.set(_,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:ne}),K.length&&this.allOtherExecutableTips.set(_,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:K})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,l)}groupImportantTipsByExe(s,o){const l=new Map;s.forEach(U=>l.set(U.extensionId.toLowerCase(),U));const{installed:h,uninstalled:C}=this.groupByInstalled([...l.keys()],o);for(const U of h){const k=l.get(U);k&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:k.exeName})}for(const U of C){const k=l.get(U);k&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:k.exeName})}const M=this.getPromptedExecutableTips(),O=new Map;for(const U of C){const k=l.get(U);if(k&&(!M[k.exeName]||!M[k.exeName].includes(k.extensionId))){let F=O.get(k.exeName);F||(F=[],O.set(k.exeName,F)),F.push(k)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const h=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,l=7*24*60*60*1e3;if(o<l){const M=this._register((0,n.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},l-o));return}const[h,C]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(C).then(M=>{switch(M){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(C[0].exeName,C);const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(s){const o=await this.extensionManagementService.getInstalled(1),l=s.filter(C=>!C.whenNotInstalled||C.whenNotInstalled.every(M=>o.every(O=>!(0,y.areSameExtensions)(O.identifier,{id:M})))).map(({extensionId:C})=>C.toLowerCase()),h=(0,R.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,h,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(i,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(i,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const l=this.getPromptedExecutableTips();l[s]=o.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(r,JSON.stringify(l),0,0)}groupByInstalled(s,o){const l=[],h=[],C=o.reduce((M,O)=>(M.add(O.identifier.id.toLowerCase()),M),new Set);return s.forEach(M=>{C.has(M.toLowerCase())?l.push(M):h.push(M)}),{installed:l,uninstalled:h}}async getValidExecutableBasedExtensionTips(s){const o=[],l=new Map;for(const h of s.keys()){const C=s.get(h);if(!C||!(0,D.isNonEmptyArray)(C.recommendations))continue;const M=[];P.isWindows?C.windowsPath&&M.push(C.windowsPath.replace("%USERPROFILE%",E.env.USERPROFILE).replace("%ProgramFiles(x86)%",E.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",E.env.ProgramFiles).replace("%APPDATA%",E.env.APPDATA).replace("%WINDIR%",E.env.WINDIR)):(M.push((0,A.join)("/usr/local/bin",h)),M.push((0,A.join)("/usr/bin",h)),M.push((0,A.join)(this.environmentService.userHome.fsPath,h)));for(const O of M){let U=l.get(O);if(U===void 0&&(U=await this.fileService.exists(b.URI.file(O)),l.set(O,U)),U)for(const{extensionId:k,extensionName:F,isExtensionPack:_,whenNotInstalled:$}of C.recommendations)o.push({extensionId:k,extensionName:F,isExtensionPack:_,exeName:h,exeFriendlyName:C.exeFriendlyName,windowsPath:C.windowsPath,whenNotInstalled:$})}}return o}};a=de([Y(0,I.INativeEnvironmentService),Y(1,t.ITelemetryService),Y(2,v.IExtensionManagementService),Y(3,u.IStorageService),Y(4,S.INativeHostService),Y(5,p.IExtensionRecommendationNotificationService),Y(6,f.IFileService),Y(7,w.IProductService),Y(8,g.IRequestService),Y(9,d.ILogService)],a),e.ExtensionTipsService=a}),define(re[100],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:P,data:E}){return this.appenders.forEach(b=>b.log(P,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(re[47],se([0,1,28,75,13,18,22]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(g,u){return Promise.resolve(void 0)}publicLog2(g,u){return this.publicLog(g,u)}publicLogError(g,u){return Promise.resolve(void 0)}publicLogError2(g,u){return this.publicLogError(g,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class E{async publicLog(g,u,t){}async publicLogError(g,u,t){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(w,g){return g.onDidChangeConfiguration(u=>{u.source!==6&&w.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(u.source),configurationKeys:f(u.sourceConfig)})})}e.configurationTelemetry=b;function R(w,g){return!(g.disableTelemetry||!w.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=R;function I(w){const g=w.getValue(A.TELEMETRY_SETTING_ID),u=w.getValue("telemetry.enableCrashReporter");if(w.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function v(w){const g=Object.create(null),u=Object.create(null),t=Object.create(null);p(w,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const i=t[r];typeof i=="number"?u[r]=i:typeof i=="boolean"?u[r]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${i.length}`),g[r]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(g[r]=i)}return{properties:g,measurements:u}}e.validateTelemetryData=v;const y=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(w){if(!w)return"none";for(const g of y)if(w.startsWith(`${g}+`))return g;return"other"}e.cleanRemoteAuthority=m;function p(w,g,u=0,t){if(!!w)for(let r of Object.getOwnPropertyNames(w)){const i=w[r],a=t?t+r:r;Array.isArray(i)?g[a]=(0,D.safeStringify)(i):i instanceof Date?g[a]=i.toISOString():(0,L.isObject)(i)?u<2?p(i,g,u+1,a+"."):g[a]=(0,D.safeStringify)(i):g[a]=i}}function f(w){if(!w)return[];const g=[];return d(g,"",w),g}function d(w,g,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(t=>d(w,g?`${g}.${t}`:t,u[t])):w.push(g)}function S(w){return[w.appRoot,w.extensionsPath,w.userHome.fsPath,w.tmpDir.fsPath,w.userDataPath]}e.getPiiPathsFromEnvironment=S}),define(re[217],se([0,1,46,47]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(T,A,P,E,b,R){const I={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},v=await(0,D.getServiceMachineId)(P,b,R);return(0,n.supportsTelemetry)(A,P)&&(0,n.getTelemetryLevel)(E)===3&&(I["X-Market-User-Id"]=v),I}e.resolveMarketplaceHeaders=L}),define(re[218],se([0,1,16,23,9,28,4,34,13,7,18,14,29,31,61,15,8,24,43,217,21,22]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=A.isWeb?"web":(0,v.getTargetPlatform)(A.platform,P.arch);var r;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function i(...B){return String(B.reduce((j,z)=>j|z,0))}var a;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class h{constructor(j=l){this.state=j}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(j,z=this.state.pageSize){return new h({...this.state,pageNumber:j,pageSize:z})}withFilter(j,...z){const V=[...this.state.criteria,...z.length?z.map(ee=>({filterType:j,value:ee})):[{filterType:j}]];return new h({...this.state,criteria:V})}withSortBy(j){return new h({...this.state,sortBy:j})}withSortOrder(j){return new h({...this.state,sortOrder:j})}withFlags(...j){return new h({...this.state,flags:j.reduce((z,V)=>z|V,0)})}withAssetTypes(...j){return new h({...this.state,assetTypes:j})}withSource(j){return new h({...this.state,source:j})}get raw(){const{criteria:j,pageNumber:z,pageSize:V,sortBy:ee,sortOrder:ie,flags:ae,assetTypes:fe}=this.state;return{filters:[{criteria:j,pageNumber:z,pageSize:V,sortBy:ee,sortOrder:ie}],assetTypes:fe,flags:ae}}get searchText(){const j=this.state.criteria.filter(z=>z.filterType===a.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(j=>String(j.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function C(B,j){const z=(B||[]).filter(V=>V.statisticName===j)[0];return z?z.value:0}function M(B){const j="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(V=>V.assetType.indexOf(j)===0).reduce((V,ee)=>{const ie=k(B,ee.assetType);return ie&&V.push([ee.assetType.substring(j.length),ie]),V},[])}function O(B){if(B.properties){const j=B.properties.filter(ee=>ee.key===c.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=j.filter(ee=>z.test(ee.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return k(B,c.Repository)}function U(B){return{uri:`${B.fallbackAssetUri}/${c.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${c.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function k(B,j){return B.files.filter(V=>V.assetType===j)[0]?{uri:`${B.assetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function F(B,j){const z=B.properties?B.properties.filter(ee=>ee.key===j):[],V=z.length>0&&z[0].value;return V?V.split(",").map(ee=>(0,y.adoptToGalleryExtensionId)(ee)):[]}function _(B){const j=B.properties?B.properties.filter(z=>z.key===s.Engine):[];return j.length>0&&j[0].value||""}function $(B){const j=B.properties?B.properties.filter(z=>z.key===s.PreRelease):[];return j.length>0&&j[0].value==="true"}function H(B){const j=B.properties?B.properties.filter(V=>V.key===s.LocalizedLanguages):[],z=j.length>0&&j[0].value||"";return z?z.split(","):[]}function ne(B){return B.properties?.find(j=>j.key===s.SponsorLink)?.value}function K(B){return B.indexOf("preview")!==-1}function N(B){return B.targetPlatform?(0,v.toTargetPlatform)(B.targetPlatform):"undefined"}function W(B){const j=(0,D.distinct)(B.versions.map(N)),z=!!B.tags?.includes(v.WEB_EXTENSION_TAG),V=j.indexOf("web");return z?V===-1&&j.push("web"):V!==-1&&j.splice(V,1),j}function x(B,j){const z=(0,v.getFallbackTargetPlarforms)(j);for(let V=0;V<B.length;V++){const ee=B[V];if(ee.version===B[V-1]?.version){let ie=V;const ae=N(ee);if(ae===j)for(;ie>0&&B[ie-1].version===ee.version;)ie--;else if(z.includes(ae))for(;ie>0&&B[ie-1].version===ee.version&&N(B[ie-1])!==j;)ie--;ie!==V&&(B.splice(V,1),B.splice(ie,0,ee))}}return B}e.sortExtensionVersions=x;function J(B,j,z){B.telemetryData={index:j,querySource:z}}function G(B,j,z){const V=B.versions[0],ee={manifest:k(j,c.Manifest),readme:k(j,c.Details),changelog:k(j,c.Changelog),license:k(j,c.License),repository:O(j),download:U(j),icon:k(j,c.Icon),coreTranslations:M(j)};return{identifier:{id:(0,y.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:j.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:ne(V),description:B.shortDescription||"",installCount:C(B.statistics,"install"),rating:C(B.statistics,"averagerating"),ratingCount:C(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:z,assets:ee,properties:{dependencies:F(j,s.Dependency),extensionPack:F(j,s.ExtensionPack),engine:_(j),localizedLanguages:H(j),targetPlatform:N(j),isPreReleaseVersion:$(j)},hasPreReleaseVersion:$(V),hasReleaseVersion:!0,preview:K(B.flags)}}let Q=class{constructor(j,z,V,ee,ie,ae,fe,pe){this.requestService=z,this.logService=V,this.environmentService=ee,this.telemetryService=ie,this.fileService=ae,this.productService=fe,this.configurationService=pe;const we=fe.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=(0,w.resolveMarketplaceHeaders)(fe.version,fe,this.environmentService,this.configurationService,this.fileService,j)}api(j=""){return`${this.extensionsGalleryUrl}${j}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(j,z,V){const ee=n.CancellationToken.isCancellationToken(z)?{}:z,ie=n.CancellationToken.isCancellationToken(z)?z:V,ae=[],fe=[],pe=[],we=[];let ge=!0;for(const Re of j){Re.uuid?fe.push(Re.uuid):ae.push(Re.id);const _e=!!(Re.version||Re.preRelease);pe.push({id:Re.id,uuid:Re.uuid,includePreRelease:_e}),Re.version&&we.push({id:Re.id,uuid:Re.uuid,version:Re.version}),ge=ge&&!!Re.hasPreRelease&&!_e}if(!fe.length&&!ae.length)return[];let Ee=new h().withPage(1,j.length);fe.length&&(Ee=Ee.withFilter(a.ExtensionId,...fe)),ae.length&&(Ee=Ee.withFilter(a.ExtensionName,...ae)),(ee.queryAllVersions||ge)&&(Ee=Ee.withFlags(Ee.flags,r.IncludeVersions)),ee.source&&(Ee=Ee.withSource(ee.source));const{extensions:Ce}=await this.queryGalleryExtensions(Ee,{targetPlatform:ee.targetPlatform??t,includePreRelease:pe,versions:we,compatible:!!ee.compatible},ie);return ee.source&&Ce.forEach((Re,_e)=>J(Re,_e,ee.source)),Ce}async getCompatibleExtension(j,z,V){if((0,v.isNotWebExtensionInWebTargetPlatform)(j.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(j,z,V))return j;const ee=new h().withFlags(r.IncludeVersions).withPage(1,1).withFilter(a.ExtensionId,j.identifier.uuid),{extensions:ie}=await this.queryGalleryExtensions(ee,{targetPlatform:V,compatible:!0,includePreRelease:z},n.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(j,z,V){if(!(0,v.isTargetPlatformCompatible)(j.properties.targetPlatform,j.allTargetPlatforms,V)||!z&&j.properties.isPreReleaseVersion)return!1;let ee=j.properties.engine;if(!ee){const ie=await this.getManifest(j,n.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");ee=ie.engines.vscode}return(0,m.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(j,z,V,ee,ie){if(!(0,v.isTargetPlatformCompatible)(N(j),ee,ie)||z!=="any"&&$(j)!==(z==="prerelease"))return!1;if(V)try{const ae=await this.getEngine(j);if(!(0,m.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${j.version}.`,(0,L.getErrorMessage)(ae)),!1}return!0}async query(j,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=j.text||"";const ee=(0,T.getOrDefault)(j,ge=>ge.pageSize,50);let ie=new h().withPage(1,ee);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ce)=>(ie=ie.withFilter(a.Category,Ce||Ee),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,Ee,Ce)=>(ie=ie.withFilter(a.Tag,Ce||Ee),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(a.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),ie=ie.withFilter(a.SearchText,V)),ie=ie.withSortBy(0)):j.ids?ie=ie.withFilter(a.ExtensionId,...j.ids):j.names?ie=ie.withFilter(a.ExtensionName,...j.names):ie=ie.withSortBy(4),typeof j.sortBy=="number"&&(ie=ie.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(ie=ie.withSortOrder(j.sortOrder)),j.source&&(ie=ie.withSource(j.source));const ae=async(ge,Ee)=>{const{extensions:Ce,total:Re}=await this.queryGalleryExtensions(ge,{targetPlatform:t,compatible:!1,includePreRelease:!!j.includePreRelease},Ee);return Ce.forEach((_e,je)=>J(_e,(ge.pageNumber-1)*ge.pageSize+je,j.source)),{extensions:Ce,total:Re}},{extensions:fe,total:pe}=await ae(ie,z),we=async(ge,Ee)=>{if(Ee.isCancellationRequested)throw new L.CancellationError;const{extensions:Ce}=await ae(ie.withPage(ge+1),Ee);return Ce};return{firstPage:fe,total:pe,pageSize:ie.pageSize,getPage:we}}async queryGalleryExtensions(j,z,V){const ee=j.flags;!!(j.flags&r.IncludeLatestVersionOnly)&&!!(j.flags&r.IncludeVersions)&&(j=j.withFlags(j.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(j.flags&r.IncludeLatestVersionOnly)&&!(j.flags&r.IncludeVersions)&&(j=j.withFlags(j.flags,r.IncludeLatestVersionOnly)),z.versions?.length&&(j=j.withFlags(j.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),j=j.withFlags(j.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:ie,total:ae}=await this.queryRawGalleryExtensions(j,V);if(!(j.flags&r.IncludeLatestVersionOnly)){const ge=[];for(const Ee of ie){const Ce=await this.toGalleryExtensionWithCriteria(Ee,z);Ce&&ge.push(Ce)}return{extensions:ge,total:ae}}const pe=[],we=new Map;for(let ge=0;ge<ie.length;ge++){const Ee=ie[ge],Ce={id:(0,y.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Re=(0,E.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(je=>(0,y.areSameExtensions)(je,Ce))?.includePreRelease;if(z.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(W(Ee),z.targetPlatform))continue;const _e=await this.toGalleryExtensionWithCriteria(Ee,z);!_e||_e.properties.isPreReleaseVersion&&(!Re||!_e.hasReleaseVersion)||!_e.properties.isPreReleaseVersion&&_e.properties.targetPlatform!==z.targetPlatform&&_e.hasPreReleaseVersion?we.set(Ee.extensionId,ge):pe.push([ge,_e])}if(we.size){const ge=new Date().getTime(),Ee=new h().withFlags(ee&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,we.size).withFilter(a.ExtensionId,...we.keys()),{extensions:Ce}=await this.queryGalleryExtensions(Ee,z,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:we.size});for(const Re of Ce){const _e=we.get(Re.identifier.uuid);pe.push([_e,Re])}}return{extensions:pe.sort((ge,Ee)=>ge[0]-Ee[0]).map(([,ge])=>ge),total:ae}}async toGalleryExtensionWithCriteria(j,z){const V={id:(0,y.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},ee=z.versions?.find(pe=>(0,y.areSameExtensions)(pe,V))?.version,ie=(0,E.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(pe=>(0,y.areSameExtensions)(pe,V))?.includePreRelease,ae=W(j),fe=x(j.versions,z.targetPlatform);if(z.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(ae,z.targetPlatform))return null;for(let pe=0;pe<fe.length;pe++){const we=fe[pe];if(!(ee&&we.version!==ee)){if(await this.isValidVersion(we,ie?"any":"release",z.compatible,ae,z.targetPlatform))return G(j,we,ae);if(ee&&we.version===ee)return null}}return ee||z.compatible?null:G(j,j.versions[0],ae)}async queryRawGalleryExtensions(j,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,r.ExcludeNonValidated).withFilter(a.Target,"Microsoft.VisualStudio.Code").withFilter(a.ExcludeWithFlags,i(r.Unpublished));const V=await this.commonHeadersPromise,ee=JSON.stringify(j.raw),ie={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},ae=new Date().getTime();let fe,pe,we=0;try{if(fe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ee,headers:ie},z),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:we};const ge=await(0,S.asJson)(fe);if(ge){const Ee=ge.results[0],Ce=Ee.extensions,Re=Ee.resultMetadata&&Ee.resultMetadata.filter(_e=>_e.metadataType==="ResultCount")[0];return we=Re&&Re.metadataItems.filter(_e=>_e.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:we}}return{galleryExtensions:[],total:we}}catch(ge){throw pe=ge,ge}finally{this.telemetryService.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-ae,success:!!fe&&(0,S.isSuccess)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:pe?(0,L.isCancellationError)(pe)?"canceled":(0,L.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(we)})}}async reportStatistic(j,z,V,ee){if(!this.isEnabled())return;const ie=A.isWeb?this.api(`/itemName/${j}.${z}/version/${V}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${j}/extensions/${z}/${V}/stats?statType=${ee}`),ae=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:ie,headers:pe},n.CancellationToken.None)}catch{}}async download(j,z,V){this.logService.trace("ExtensionGalleryService#download",j.identifier.id);const ee=(0,y.getGalleryExtensionTelemetryData)(j),ie=new Date().getTime(),ae=ge=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:ge}),fe=V===2?"install":V===3?"update":"",pe=fe?{uri:`${j.assets.download.uri}${b.URI.parse(j.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${j.assets.download.fallbackUri}${b.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:j.assets.download,we=await this.getAsset(pe);await this.fileService.writeFile(z,we.stream),ae(new Date().getTime()-ie)}async getReadme(j,z){if(j.assets.readme){const V=await this.getAsset(j.assets.readme,{},z);return await(0,S.asTextOrError)(V)||""}return""}async getManifest(j,z){if(j.assets.manifest){const V=await this.getAsset(j.assets.manifest,{},z),ee=await(0,S.asTextOrError)(V);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(j,z){const V=k(j,c.Manifest);if(!V)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},ie=await this.getAsset(V,{headers:ee});return await(0,S.asJson)(ie)}async getCoreTranslation(j,z){const V=j.assets.coreTranslations.filter(ee=>ee[0]===z.toUpperCase())[0];if(V){const ee=await this.getAsset(V[1]),ie=await(0,S.asTextOrError)(ee);return ie?JSON.parse(ie):null}return null}async getChangelog(j,z){if(j.assets.changelog){const V=await this.getAsset(j.assets.changelog,{},z);return await(0,S.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(j,z,V){let ee=new h().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?ee=ee.withFilter(a.ExtensionId,j.identifier.uuid):ee=ee.withFilter(a.ExtensionName,j.identifier.id);const{galleryExtensions:ie}=await this.queryRawGalleryExtensions(ee,n.CancellationToken.None);if(!ie.length)return[];const ae=W(ie[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(ae,V))return[];const fe=[];await Promise.all(ie[0].versions.map(async ge=>{try{await this.isValidVersion(ge,z?"any":"release",!0,ae,V)&&fe.push(ge)}catch{}}));const pe=[],we=new Set;for(const ge of x(fe,V))we.has(ge.version)||(we.add(ge.version),pe.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:$(ge)}));return pe}async getAsset(j,z={},V=n.CancellationToken.None){const ee=await this.commonHeadersPromise,ie={type:"GET"},ae={...ee,...z.headers||{}};z={...z,...ie,headers:ae};const fe=j.uri,pe=j.fallbackUri,we={...z,url:fe};try{const ge=await this.requestService.request(we,V);if(ge.res.statusCode===200)return ge;const Ee=await(0,S.asTextOrError)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${Ee}`)}catch(ge){if((0,L.isCancellationError)(ge))throw ge;const Ee=(0,L.getErrorMessage)(ge);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:Ee});const Ce={...z,url:pe};return this.requestService.request(Ce,V)}}async getEngine(j){let z=_(j);if(!z){const V=await this.getManifestFromRawExtensionVersion(j,n.CancellationToken.None);if(!V)throw new Error("Manifest was not found");z=V.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const j=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,S.asJson)(j),V=[],ee={};if(z){for(const ie of z.malicious)V.push({id:ie});if(z.migrateToPreRelease)for(const[ie,ae]of Object.entries(z.migrateToPreRelease))(!ae.engine||(0,m.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(ee[ie.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[ie,ae]of Object.entries(z.deprecated))ae&&(ee[ie.toLowerCase()]=(0,E.isBoolean)(ae)?{}:ae)}return{malicious:V,deprecated:ee}}};Q=de([Y(1,S.IRequestService),Y(2,f.ILogService),Y(3,I.IEnvironmentService),Y(4,u.ITelemetryService),Y(5,p.IFileService),Y(6,d.IProductService),Y(7,R.IConfigurationService)],Q);let Z=class extends Q{constructor(j,z,V,ee,ie,ae,fe,pe){super(j,z,V,ee,ie,ae,fe,pe)}};Z=de([Y(0,g.IStorageService),Y(1,S.IRequestService),Y(2,f.ILogService),Y(3,I.IEnvironmentService),Y(4,u.ITelemetryService),Y(5,p.IFileService),Y(6,d.IProductService),Y(7,R.IConfigurationService)],Z),e.ExtensionGalleryService=Z;let q=class extends Q{constructor(j,z,V,ee,ie,ae,fe){super(void 0,j,z,V,ee,ie,ae,fe)}};q=de([Y(0,S.IRequestService),Y(1,f.ILogService),Y(2,I.IEnvironmentService),Y(3,u.ITelemetryService),Y(4,p.IFileService),Y(5,d.IProductService),Y(6,R.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q}),define(re[101],se([0,1,2,14,8,47]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(E,b,R=""){super();this.prefix=R;const I=E.getLogger(b.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(E.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,b){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,T.validateTelemetryData)(b))}};A=de([Y(0,L.ILoggerService),Y(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(re[102],se([0,1,2,28,75,4,26,150,18,42,95,24,38,22,47]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(S,w,g){this._configurationService=w,this._productService=g,this._experimentProperties={},this.telemetryLevel=new L.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(S,w){this._experimentProperties[S]=w}_updateTelemetryLevel(){let S=(0,m.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const g=w.usage?3:w.error?2:0;S=Math.min(S,g)}this.telemetryLevel.value=S}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const S=await this._commonProperties;let w=S.sessionID,g=S["common.machineId"],u=S["common.firstSessionDate"],t=S["common.msftInternal"];return{sessionId:w,machineId:g,firstSessionDate:u,msftInternal:t}}dispose(){this._disposables.dispose()}_log(S,w,g,u){return this.telemetryLevel.value<w?Promise.resolve(void 0):this._commonProperties.then(t=>{g=(0,n.mixin)(g,t),g=(0,n.mixin)(g,this._experimentProperties),g=(0,n.cloneAndChange)(g,r=>{if(typeof r=="string")return this._cleanupInfo(r,u)}),this._appenders.forEach(r=>r.log(S,g))},t=>{console.error(t)})}publicLog(S,w,g){return this._log(S,3,w,g)}publicLog2(S,w,g){return this.publicLog(S,w,g)}publicLogError(S,w){return this._sendErrorTelemetry?this._log(S,2,w,!0):Promise.resolve(void 0)}publicLogError2(S,w){return this.publicLogError(S,w)}_anonymizeFilePaths(S){let w=S;const g=[];for(let i of this._cleanupPatterns)for(;;){const a=i.exec(S);if(!a)break;g.push([a.index,i.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,t=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(w="";;){const i=t.exec(S);if(!i)break;!u.test(i[0])&&g.every(([a,c])=>i.index<a||i.index>=c)&&(w+=S.substring(r,i.index)+"<REDACTED: user-file-path>",r=t.lastIndex)}return r<S.length&&(w+=S.substr(r)),w}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const w=S.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of g)if(u.regex.test(w))return`<REDACTED: ${u.label}>`;return S}_cleanupInfo(S,w){let g=S;w&&(g=this._anonymizeFilePaths(g));for(let u of this._cleanupPatterns)g=g.replace(u,"");return g=this._removePropertiesWithPossibleUserInfo(g),g}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([Y(1,E.IConfigurationService),Y(2,I.IProductService)],p),e.TelemetryService=p;function f(){const d=(0,P.localize)(0,null,R.default.nameLong),S=R.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",R.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=T.isWeb?"":(0,P.localize)(3,null),g=(0,P.localize)(4,null),u=(0,P.localize)(5,null),t=(0,P.localize)(6,null),r=(0,P.localize)(7,null),i=`
|       | ${g} | ${u} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,P.localize)(8,null);return`
${d} ${S} ${w}

&nbsp;

${r}
${i}

&nbsp;

${a}
`}v.Registry.as(b.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(b.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:R.default.privacyStatementUrl?(0,P.localize)(16,null,R.default.nameLong,R.default.privacyStatementUrl):(0,P.localize)(15,null,R.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[219],se([0,1,9,28,47]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P){const E=await new Promise((R,I)=>{X(["applicationinsights"],R,I)});let b;return E.defaultClient?(b=new E.TelemetryClient(P),b.channel.setUseDiskRetryCaching(!0)):(E.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=E.defaultClient),P.indexOf("AIF-")===0&&(b.config.endpointUrl="https://mobile.events.data.microsoft.com/collect/v1"),b}class A{constructor(E,b,R){this._eventPrefix=E,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(E){if(!!this._aiClient){if(typeof this._aiClient!="string"){E(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(b=>{E(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(E,b){if(!!this._aiClient){b=(0,n.mixin)(b,this._defaultData),b=(0,L.validateTelemetryData)(b);try{this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+E,properties:b.properties,measurements:b.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(E=>{this._withAIClient(b=>{try{b.flush({callback:()=>{this._aiClient=void 0,E(void 0)}})}catch{}})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(re[220],se([0,1,19,60,18,14,8,24,22,100,101,102]),function(X,e,D,n,L,T,A,P,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(m,p,f,d,S){this.configurationService=m,this.telemetryService=p,this.loggerService=f,this.environmentService=d,this.productService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(m){if(!this.customTelemetryServices.has(m.id)){const{machineId:p,sessionId:f}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=p,d["common.vscodesessionid"]=f;const S=[m.id,JSON.stringify(d),m.aiKey],g=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:S,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new b.TelemetryAppenderClient(g),new R.TelemetryLogAppender(this.loggerService,this.environmentService,`[${m.id}] `)];this.customTelemetryServices.set(m.id,new I.TelemetryService({appenders:u,sendErrorTelemetry:m.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(m.id)}async publicLog(m,p,f){await(await this.getCustomTelemetryService(m)).publicLog(p,f)}async publicLogError(m,p,f){await(await this.getCustomTelemetryService(m)).publicLogError(p,f)}};v=de([Y(0,L.IConfigurationService),Y(1,E.ITelemetryService),Y(2,A.ILoggerService),Y(3,T.IEnvironmentService),Y(4,P.IProductService)],v),e.CustomEndpointTelemetryService=v}),define(re[221],se([0,1,5,23,3,2,8]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(b,R){super();this._logService=R,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((R,I)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,R),this._onCreateRequest.fire({requestId:v,...b});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>I(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,T.toDisposable)(()=>y.cancel())])})}acceptReply(b,R){const I=this._pendingRequests.get(b);I?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),I(R)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=de([Y(1,A.ILogService)],P),e.RequestStore=P}),define(re[103],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",f.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",f.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var A;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var R;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(R=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(f){f.TerminalView="view",f.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(re[222],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(re[223],se([0,1,35,19,28,10,4,34,26,13,27]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let u=0;return g&&g.length===4&&(u=parseInt(g[3])),u}e.getWindowsBuildNumber=I;async function v(g,u,t,r=P.env,i=R.Promises.exists){if(T.isAbsolute(g))return await i(g)?g:void 0;if(u===void 0&&(u=P.cwd()),T.dirname(g)!=="."){const o=T.join(u,g);return await i(o)?o:void 0}const c=(0,L.getCaseInsensitive)(r,"PATH");if(t===void 0&&(0,b.isString)(c)&&(t=c.split(T.delimiter)),t===void 0||t.length===0){const o=T.join(u,g);return await i(o)?o:void 0}for(let o of t){let l;if(T.isAbsolute(o)?l=T.join(o,g):l=T.join(u,o,g),await i(l))return l;if(A.isWindows){let h=l+".com";if(await i(h)||(h=l+".exe",await i(h)))return h}}const s=T.join(u,g);return await i(s)?s:void 0}e.findExecutable=v;function y(g,u,t){if(!u.enabled||!g.executable||g.isFeatureTerminal||g.hideFromUser)return;const r=g.args,i=P.platform==="win32"?T.basename(g.executable).toLowerCase():T.basename(g.executable),a=T.dirname(n.FileAccess.asFileUri("",X).fsPath);let c;if(A.isWindows){if(i==="pwsh.exe")return!r||S(r)?c=e.shellIntegrationArgs.get(m.WindowsPwsh):d(r)&&(c=e.shellIntegrationArgs.get(m.WindowsPwshLogin)),c?(c&&(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],a,"")),{newArgs:c}):void 0;t.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args);return}const s={};switch(i){case"bash":return!r||r.length===0?c=e.shellIntegrationArgs.get(m.Bash):w(r)&&(s.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(m.Bash)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],a),{newArgs:c,envMixin:s}):void 0;case"pwsh":return!r||S(r)?c=e.shellIntegrationArgs.get(m.Pwsh):d(r)&&(c=e.shellIntegrationArgs.get(m.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],a,""),{newArgs:c}):void 0;case"zsh":{if(!r||r.length===0?c=e.shellIntegrationArgs.get(m.Zsh):w(r)?c=e.shellIntegrationArgs.get(m.ZshLogin):(r===e.shellIntegrationArgs.get(m.Zsh)||r===e.shellIntegrationArgs.get(m.ZshLogin))&&(c=r),!c)return;c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],a);const o=T.join(D.tmpdir(),"vscode-zsh");s.ZDOTDIR=o;const l=[];return l.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(o,".zshrc")}),l.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(o,".zprofile")}),l.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(o,".zshenv")}),l.push({source:T.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(o,".zlogin")}),{newArgs:c,envMixin:s,filesToCopy:l}}}t.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args)}e.getShellIntegrationInjection=y;var m;(function(g){g.WindowsPwsh="windows-pwsh",g.WindowsPwshLogin="windows-pwsh-login",g.Pwsh="pwsh",g.PwshLogin="pwsh-login",g.Zsh="zsh",g.ZshLogin="zsh-login",g.Bash="bash"})(m=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(m.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(m.Zsh,["-i"]),e.shellIntegrationArgs.set(m.ZshLogin,["-il"]),e.shellIntegrationArgs.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],f=["-nol","-nologo"];function d(g){return typeof g=="string"?p.includes(g.toLowerCase()):g.length===1&&p.includes(g[0].toLowerCase())||g.length===2&&(p.includes(g[0].toLowerCase())||p.includes(g[1].toLowerCase()))&&(f.includes(g[0].toLowerCase())||f.includes(g[1].toLowerCase()))}function S(g){return typeof g=="string"?f.includes(g.toLowerCase()):g.length===0||g?.length===1&&f.includes(g[0].toLowerCase())}function w(g){return g==="string"&&p.includes(g.toLowerCase())||typeof g!="string"&&g.length===1&&p.includes(g[0].toLowerCase())}}),define(re[224],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function n(T){return T===D.HIGH_CONTRAST_DARK||T===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function L(T){return T===D.DARK||T===D.HIGH_CONTRAST_DARK}e.isDark=L}),define(re[104],se([0,1,48,3,2,6,38,224]),function(X,e,D,n,L,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var E;(function(f){function d(S){return S&&typeof S=="object"&&typeof S.id=="string"}f.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function b(f){return{id:f}}e.themeColorFromId=b;var R;(function(f){function d(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||E.isThemeColor(a.color))}f.isThemeIcon=d;const S=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function w(a){const c=S.exec(a);if(!c)return;let[,s]=c;return{id:s}}f.fromString=w;function g(a){return{id:a}}f.fromId=g;function u(a,c){let s=a.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),c&&(s=`${s}~${c}`),{id:s}}f.modify=u;function t(a){const c=a.id.lastIndexOf("~");if(c!==-1)return a.id.substring(c+1)}f.getModifier=t;function r(a,c){return a.id===c.id&&a.color?.id===c.color?.id}f.isEqual=r;function i(a,c){return{id:a.id,color:c?b(c):void 0}}f.asThemeIcon=i,f.asClassNameArray=D.CSSIcon.asClassNameArray,f.asClassName=D.CSSIcon.asClassName,f.asCSSSelector=D.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(f){switch(f){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,L.toDisposable)(()=>{const S=this.themingParticipants.indexOf(d);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new v;A.Registry.add(e.Extensions.ThemingContribution,y);function m(f){return y.onColorThemeChange(f)}e.registerThemingParticipant=m;class p extends L.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,S){let w=this.theme.getColor(d);return w&&S&&(w=S(w,this.theme)),w?w.toString():null}}e.Themable=p}),define(re[225],se([0,1,48,7,152,104]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(v,y){const m=[{name:null,description:(0,L.localize)(0,null)}];return m.push(...v.map(p=>({name:p.profileName,description:P(p)}))),y&&m.push(...y.map(p=>({name:p.title,description:E(p)}))),{values:m.map(p=>p.name),markdownDescriptions:m.map(p=>p.description)}}e.createProfileSchemaEnums=A;function P(v){let y=`$(${T.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?y+=`
- args: "${v.args}"`:y+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(y+=`
- overrideName: ${v.overrideName}`),v.color&&(y+=`
- color: ${v.color}`),v.env&&(y+=`
- env: ${JSON.stringify(v.env)}`),y}function E(v){return`$(${T.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function b(v,y){if(!v&&!y)return!0;if(typeof v=="string"&&typeof y=="string")return v===y;if(Array.isArray(v)&&Array.isArray(y)){if(v.length!==y.length)return!1;for(let m=0;m<v.length;m++)if(v[m]!==y[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function R(v,y){if(!v&&!y)return!0;if(!v||!y)return!1;if(T.ThemeIcon.isThemeIcon(v)&&T.ThemeIcon.isThemeIcon(y))return v.id===y.id&&v.color===y.color;if(typeof v=="object"&&v&&"light"in v&&"dark"in v&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const m=v,p=y;if((n.URI.isUri(m.light)||I(m.light))&&(n.URI.isUri(m.dark)||I(m.dark))&&(n.URI.isUri(p.light)||I(p.light))&&(n.URI.isUri(p.dark)||I(p.dark)))return m.light.path===p.light.path&&m.dark.path===p.dark.path}if(n.URI.isUri(v)&&n.URI.isUri(y)||I(v)||I(y)){const m=v,p=y;return m.path===p.path&&m.scheme===p.scheme}return!1}e.terminalIconsEqual=R;function I(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=I}),define(re[226],se([0,1,48,151,42,38,225]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),g=>g.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),g=>`$(${g.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...P}},R=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...P}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){T.Registry.as(L.Extensions.Configuration).registerConfiguration(f),w()}e.registerTerminalPlatformConfiguration=d;let S;function w(g,u){const t=T.Registry.as(L.Extensions.Configuration);let r;g&&(r=(0,A.createProfileSchemaEnums)(g?.profiles,u));const i=S;S={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:g?.os===3?r?.values:void 0,markdownEnumDescriptions:g?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:g?.os===2?r?.values:void 0,markdownEnumDescriptions:g?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:g?.os===1?r?.values:void 0,markdownEnumDescriptions:g?.os===1?r?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[S],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(re[227],se([0,1,45,48,10,4,27,81,223,104]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let R,I=!0;function v(r,i,a,c,s=process.env,o,l,h,C){return o=o||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?y(a,o,s,l,c.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:c.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:c.getValue("terminal.integrated.defaultProfile.windows"),C,h):g(o,l,a,r&&typeof r=="object"?{...r}:c.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:c.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),C,h,s)}e.detectAvailableProfiles=v;async function y(r,i,a,c,s,o,l,h,C){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let U=!1;(0,E.getWindowsBuildNumber)()>=16299&&(U=!0),await f(h);const k=new Map;r&&(k.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),k.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),u(o,k);const F=await m(k.entries(),l,i,a,c,C);if(r||!r&&s)try{const _=await S(`${O}\\${U?"wsl":"bash"}.exe`,l);for(const $ of _)(!o||!($.profileName in o))&&F.push($)}catch{I&&(c?.info("WSL is not installed, so could not detect WSL profiles"),I=!1)}return F}async function m(r,i,a,c=process.env,s,o){const l=[];for(const[h,C]of r){if(C===null)continue;let M,O,U;if("source"in C){const _=R?.get(C.source);if(!_)continue;M=_.paths,O=C.args||_.args,C.icon?U=p(C.icon):_.icon&&(U=_.icon)}else M=Array.isArray(C.path)?C.path:[C.path],O=T.isWindows||Array.isArray(C.args)?C.args:void 0,U=p(C.icon);const k=await o?.(M)||M.slice(),F=await t(h,i,k,a,c,O,C.env,C.overrideName,C.isAutoDetected,s);F?(F.isAutoDetected=C.isAutoDetected,F.icon=U,F.color=C.color,l.push(F)):s?.trace("profile not validated",h,M)}return l}function p(r){return typeof r=="string"?{id:r}:r}async function f(r){R&&!r||(R=new Map,R.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),R.set("PowerShell",{profileName:"PowerShell",paths:r||await d(),icon:b.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function d(){const r=[];for await(const i of(0,P.enumeratePowerShellInstallations)())r.push(i.exePath);return r}async function S(r,i){const a=[],c=await new Promise((l,h)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(C,M)=>{if(C)return h("Problem occurred when getting wsl distros");l(M)})});if(!c)return[];const s=new RegExp(/[\r?\n]/),o=c.split(s).filter(l=>l.trim().length>0&&l!=="");for(const l of o){if(l===""||l.startsWith("docker-desktop"))continue;const h=`${l} (WSL)`,C={profileName:h,path:r,args:["-d",`${l}`],isDefault:h===i,icon:w(l),isAutoDetected:!1};a.push(C)}return a}function w(r){return r.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):r.includes("Debian")?b.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function g(r,i,a,c,s,o,l,h){const C=new Map;if(a){const M=(await r.readFile("/etc/shells")).toString(),O=o||M.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),U=new Map;for(const k of O){let F=(0,L.basename)(k),_=U.get(F)||0;_++,_>1&&(F=`${F} (${_})`),U.set(F,_),C.set(F,{path:k,isAutoDetected:!0})}}return u(c,C),await m(C.entries(),s,r,h,i,l)}function u(r,i){if(!!r)for(const[a,c]of Object.entries(r))c===null||!("path"in c)&&!("source"in c)?i.delete(a):(c.icon=c.icon||i.get(a)?.icon,i.set(a,c))}async function t(r,i,a,c,s,o,l,h,C,M){if(a.length===0)return Promise.resolve(void 0);const O=a.shift();if(O==="")return t(r,i,a,c,s,o,l,h,C);const U={profileName:r,path:O,args:o,env:l,overrideName:h,isAutoDetected:C,isDefault:r===i};if((0,L.basename)(O)===O){const F=s.PATH?s.PATH.split(L.delimiter):void 0,_=await(0,E.findExecutable)(O,void 0,F,void 0,c.existsFile);return _?(U.path=_,U.isFromPath=!0,U):t(r,i,a,c,s,o)}return await c.existsFile((0,L.normalize)(O))?U:t(r,i,a,c,s,o,l,h,C)}}),define(re[228],se([0,1,3,2,19,4,36,60,18,14,86,207,8,94,221,103,226,227]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var S;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(S||(S={}));let w=0,g=class extends n.Disposable{constructor(t,r,i,a){super();this._reconnectConstants=t,this._configurationService=r,this._environmentService=i,this._logService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,f.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new m.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,I.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(t){return this._logService.error("ptyHost was unable to resolve shell environment",t),{}}}_startPtyHost(){const t={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:w,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,R.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?t.debugBrk=r.port:!r.break&&r.port&&(t.debug=r.port));const i=new P.Client(L.FileAccess.asFileUri("bootstrap-fork",X).fsPath,t);this._onPtyHostStart.fire(),A.ProxyChannel.toService(i.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(o=>{this._onPtyHostExit.fire(o.code),this._isDisposed||(this._restartCount<=S.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const c=i.getChannel(p.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const s=A.ProxyChannel.toService(i.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(s.onProcessData(o=>this._onProcessData.fire(o))),this._register(s.onProcessReady(o=>this._onProcessReady.fire(o))),this._register(s.onProcessExit(o=>this._onProcessExit.fire(o))),this._register(s.onDidChangeProperty(o=>this._onDidChangeProperty.fire(o))),this._register(s.onProcessReplay(o=>this._onProcessReplay.fire(o))),this._register(s.onProcessOrphanQuestion(o=>this._onProcessOrphanQuestion.fire(o))),this._register(s.onDidRequestDetach(o=>this._onDidRequestDetach.fire(o))),[i,s]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(t,r,i,a,c,s,o,l,h,C,M){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(t,r,i,a,c,s,o,l,h,C,M);return clearTimeout(O),w=Math.max(w,U),U}updateTitle(t,r,i){return this._proxy.updateTitle(t,r,i)}updateIcon(t,r,i){return this._proxy.updateIcon(t,r,i)}attachToProcess(t){return this._proxy.attachToProcess(t)}detachFromProcess(t){return this._proxy.detachFromProcess(t)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(t){return this._proxy.start(t)}shutdown(t,r){return this._proxy.shutdown(t,r)}input(t,r){return this._proxy.input(t,r)}processBinary(t,r){return this._proxy.processBinary(t,r)}resize(t,r,i){return this._proxy.resize(t,r,i)}acknowledgeDataEvent(t,r){return this._proxy.acknowledgeDataEvent(t,r)}setUnicodeVersion(t,r){return this._proxy.setUnicodeVersion(t,r)}getInitialCwd(t){return this._proxy.getInitialCwd(t)}getCwd(t){return this._proxy.getCwd(t)}getLatency(t){return this._proxy.getLatency(t)}orphanQuestionReply(t){return this._proxy.orphanQuestionReply(t)}installAutoReply(t,r){return this._proxy.installAutoReply(t,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(t){return this._proxy.uninstallAutoReply(t)}getDefaultSystemShell(t){return this._proxy.getDefaultSystemShell(t)}async getProfiles(t,r,i,a=!1){const c=await this._shellEnv;return(0,d.detectAvailableProfiles)(r,i,a,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,t))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(t){return this._proxy.getWslPath(t)}setTerminalLayoutInfo(t){return this._proxy.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this._proxy.getTerminalLayoutInfo(t)}async requestDetachInstance(t,r){return this._proxy.requestDetachInstance(t,r)}async acceptDetachInstanceReply(t,r){return this._proxy.acceptDetachInstanceReply(t,r)}async serializeTerminalState(t){return this._proxy.serializeTerminalState(t)}async reviveTerminalProcesses(t,r){return this._proxy.reviveTerminalProcesses(t,r)}async refreshProperty(t,r){return this._proxy.refreshProperty(t,r)}async updateProperty(t,r,i){return this._proxy.updateProperty(t,r,i)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(t,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:t,originalText:r})}async acceptPtyHostResolvedVariables(t,r){this._resolveVariablesRequestStore.acceptReply(t,r)}};g=de([Y(1,E.IConfigurationService),Y(2,b.IEnvironmentService),Y(3,v.ILogService)],g),e.PtyHostService=g}),define(re[68],se([0,1,3,4,6,8]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var A;(function(m){m.Http="http",m.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=I;function v(m,p){return p?p!==1&&m<1024:!n.isWindows&&m<1024}e.isPortPrivileged=v;let y=class{constructor(p){this.logService=p,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p){return this._tunnelProvider=p,p?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(p){this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],f=Array.from(this._tunnels.values());for(let d of f){const S=Array.from(d.values());for(let w of S){const g=await w.value;g&&p.push(g)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:f}of p.values())await f.then(d=>d?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,f,d,S,w=!1,g,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${S}.`),!p)return;if(f||(f="localhost"),this._tunnelProvider&&this._factoryInProgress.has(d)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.retainOrCreateTunnel(p,f,d,S,w,g,u);return t?t.then(r=>{if(!r){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const f=this._tunnels.get(p.tunnelRemoteHost);if(f){const d=f.get(p.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,d))}}}}async tryDisposeTunnel(p,f,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${f}.`);const S=d.value.then(async w=>{w&&(await w.dispose(!0),this._onTunnelClosed.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(f),S}}async closeTunnel(p,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${f} `);const d=this._tunnels.get(p);if(d&&d.has(f)){const S=d.get(f);S.refcount=0,await this.tryDisposeTunnel(p,f,S)}}addTunnelToMap(p,f,d){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(f,{refcount:1,value:d})}async removeEmptyTunnelFromMap(p,f){const d=this._tunnels.get(p);d&&(await d.get(f)||d.delete(f),d.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,f){let d=[p];R(p)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):I(p)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const S=d.map(w=>this._tunnels.get(w));for(const w of S){const g=w?.get(f);if(g)return g}}canTunnel(p){return!!b(p)}createWithProvider(p,f,d,S,w,g,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${S}.`);const t=d;this._factoryInProgress.add(t);const i={elevationRequired:w?v(S===void 0?d:S):!1},a={remoteAddress:{host:f,port:d},localAddressPort:S,privacy:g,public:g?g!==P.Private:void 0,protocol:u},c=p.forwardPort(a,i);return c?(this.addTunnelToMap(f,d,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(t)})):this._factoryInProgress.delete(t),c}};y=de([Y(0,T.ILogService)],y),e.AbstractTunnelService=y}),define(re[229],se([0,1,8,68,2,9,5]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(R){this._address=R,this._addressPromise&&(this._addressPromise.complete(R),this._addressPromise=null)}setTunnel(R){this._register(R)}}let E=class bt extends L.Disposable{constructor(R,I){super();this._tunnelService=R,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(R=>R.dispose())}async createTunnel(){return{id:String(++bt._lastId)}}async startTunnel(R,I,v,y,m,p){const f=new P,d=await Promise.resolve(this._tunnelService.openTunnel(R,f,v,y,m,p));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${y} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(I))throw this._disposedTunnels.delete(I),f.dispose(),await d.dispose(),(0,T.canceled)();return f.setTunnel(d),this._tunnels.set(I,f),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${I}: ${d.localAddress} (local) to ${v}:${y} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(R,I){const v=this._tunnels.get(R);!v||v.setAddress(I)}async destroyTunnel(R){const I=this._tunnels.get(R);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${R}.`),this._tunnels.delete(R),await I.dispose();return}this._disposedTunnels.add(R)}};E._lastId=0,E=de([Y(0,n.ISharedTunnelsService),Y(1,D.ILogService)],E),e.SharedProcessTunnelService=E}),define(re[32],se([0,1,6]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(re[230],se([0,1,3,2,7,14,31,15,8,32]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let R=class extends n.Disposable{constructor(v,y,m,p,f){super();this.extensionsManagementService=v,this.logService=p,this.uriIdentityService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(S=>{this.installedExtensions=S.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(S=>this.onInstallExtension(S))),this._register(v.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(v.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const d=L.URI.file(m.extensionsPath);this._register(y.watch(d)),this._register(D.Event.filter(y.onDidFilesChange,S=>S.rawChanges.some(w=>this.doesChangeAffects(w,d)))(()=>this.onDidChange()))}doesChangeAffects(v,y){return v.type!==1&&v.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),y)?!1:this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(v.resource).startsWith(".")}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const y of v)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),y=v.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,A.areSameExtensions)(f,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),m=this.installedExtensions.filter(p=>this.installingExtensions.some(f=>(0,A.areSameExtensions)(f,p))?!1:v.every(f=>!(0,A.areSameExtensions)(f.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=v.map(p=>p.identifier),(y.length||m.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:m})}}};R=de([Y(1,P.IFileService),Y(2,T.INativeEnvironmentService),Y(3,E.ILogService),Y(4,b.IUriIdentityService)],R),e.ExtensionsWatcher=R}),define(re[231],se([0,1,32,87,15,20,111,3,2]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(v){this.uri=v,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let R=class{constructor(v){this._fileService=v,this._dispooables=new E.DisposableStore,this._limit=2**16;const y=new Map,m=p=>{let f=y.get(p.scheme);return f===void 0&&(f=v.hasProvider(p)&&!this._fileService.hasCapability(p,1024),y.set(p.scheme,f)),f};this._dispooables.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{y.delete(p.scheme)})),this.extUri=new T.ExtUri(m),this._canonicalUris=new A.SkipList((p,f)=>this.extUri.compare(p,f,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,T.normalizePath)(v));let y=this._canonicalUris.get(v);return y?y.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new b(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((m,p)=>m[1].touch<p[1].touch?1:m[1].touch>p[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let m=0;m<y;m++)this._canonicalUris.set(v[m][0],v[m][1].touch())}};R=de([Y(0,L.IFileService)],R),e.UriIdentityService=R,(0,n.registerSingleton)(D.IUriIdentityService,R,!0)}),define(re[232],se([0,1,3,2,40,39,17]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{constructor(b,R,I,v){super();this.fileSystemScheme=b,this.fileSystemProvider=R,this.userDataScheme=I,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(y=>this.handleFileChanges(y)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(b,R){this.watchResources.set(b,b);const I=this.fileSystemProvider.watch(this.toFileSystemResource(b),R);return(0,n.toDisposable)(()=>{this.watchResources.delete(b),I.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,R,I){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(R),I)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,R,I){const v=(0,L.newWriteableStream)(y=>A.VSBuffer.concat(y.map(m=>A.VSBuffer.wrap(m))).buffer);return(async()=>{try{const y=await this.readFile(b);v.end(y)}catch(y){v.error(y),v.end()}})(),v}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,R,I){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),R,I)}delete(b,R){return this.fileSystemProvider.delete(this.toFileSystemResource(b),R)}handleFileChanges(b){const R=[];for(const I of b){if(I.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(I.resource);this.watchResources.findSubstr(v)&&R.push({resource:v,type:I.type})}R.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(R))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(re[56],se([0,1,73]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,P,E,b){const R=(0,D.setProperty)(A,P,E,b)[0];return R&&(A=A.substring(0,R.offset)+R.content+A.substring(R.offset+R.length)),A}e.edit=n;function L(A,P,E){let b=E;for(;b>=0;){if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&A.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=L;function T(A,P,E){let b=E;for(;b>=0;)if(A.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&A.charAt(b)===P.charAt(1)))return b;return A.length-1}e.getLineEndOffset=T}),define(re[233],se([0,1,28,52,13]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(v,y,m,p,f){const d=[],S=[],w=[];if(!y){const O=v.filter(({identifier:U})=>f.every(k=>k.toLowerCase()!==U.id.toLowerCase()));return{local:{added:d,removed:S,updated:w},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}v=v.map(R),y=y.map(R),m=m?m.map(R):null;const g=new Map,u=O=>{O.uuid&&g.set(O.id.toLowerCase(),O.uuid)};v.forEach(({identifier:O})=>u(O)),y.forEach(({identifier:O})=>u(O)),m&&m.forEach(({identifier:O})=>u(O));const t=O=>{const U=O.identifier.uuid||g.get(O.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${O.identifier.id.toLowerCase()}`},r=(O,U)=>(O.set(t(U),U),O),i=v.reduce(r,new Map),a=y.reduce(r,new Map),c=y.reduce((O,U)=>{const k=t(U);U=(0,D.deepClone)(U);const F=i.get(k);return F&&(F.installed&&(U.installed=!0),U.version||(U.version=F.version)),r(O,U)},new Map),s=m?m.reduce(r,new Map):null,o=p.reduce(r,new Map),l=f.reduce((O,U)=>{const k=g.get(U.toLowerCase());return O.add(k?`uuid:${k}`:`id:${U.toLowerCase()}`)},new Set),h=A(i,a,l);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const O=A(s,i,l),U=A(s,a,l),k=(F,_)=>{const $=i.get(F);if($){const H=a.get(F),ne=_?H:$;return{...ne,version:H.version&&(!$.installed||n.gt(H.version,$.version))?H.version:$.version,state:P($,H,s?.get(F)),preRelease:(0,L.isUndefined)(ne.preRelease)?$.preRelease:$.installed?ne.preRelease:H.preRelease}}};for(const F of U.removed.values()){const _=i.get(F);_&&S.push(_.identifier)}for(const F of U.added.values())if(O.added.has(F)){if(h.updated.has(F)){const _=k(F,!0);_&&(w.push(I(_,F)),c.set(F,_))}}else{const _=a.get(F);_.installed&&d.push(I(_,F))}for(const F of U.updated.values()){const _=k(F,!0);_&&(w.push(I(_,F)),c.set(F,_))}for(const F of O.added.values())U.added.has(F)||c.set(F,i.get(F));for(const F of O.updated.values())if(!U.removed.has(F)&&!U.updated.has(F)){const _=k(F,!1);_&&(c.get(F)?.installed&&(_.installed=!0),c.set(F,_))}for(const F of O.removed.values())!o.has(F)&&!U.updated.has(F)&&s?.get(F)?.installed&&c.delete(F)}const C=[],M=A(a,c,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(M.added.size>0||M.updated.size>0||M.removed.size>0)&&c.forEach((O,U)=>C.push(I(O,U))),{local:{added:d,removed:S,updated:w},remote:C.length?{added:[...M.added].map(O=>c.get(O)),updated:[...M.updated].map(O=>c.get(O)),removed:[...M.removed].map(O=>a.get(O)),all:C}:null}}e.merge=T;function A(v,y,m,{checkInstalledProperty:p,checkVersionProperty:f}={checkInstalledProperty:!1,checkVersionProperty:!1}){const d=v?[...v.keys()].filter(t=>!m.has(t)):[],S=[...y.keys()].filter(t=>!m.has(t)),w=S.filter(t=>d.indexOf(t)===-1).reduce((t,r)=>(t.add(r),t),new Set),g=d.filter(t=>S.indexOf(t)===-1).reduce((t,r)=>(t.add(r),t),new Set),u=new Set;for(const t of d){if(g.has(t))continue;const r=v.get(t),i=y.get(t);(!i||r.disabled!==i.disabled||r.installed&&i.installed&&r.preRelease!==i.preRelease||!b(r.state,i.state)||f&&r.version!==i.version||p&&r.installed!==i.installed)&&u.add(t)}return{added:w,removed:g,updated:u}}function P(v,y,m){const p=v.state,f=y.state,d=m?.state;if(!y.version||p&&n.gt(v.version,y.version))return p;if(f&&n.gt(y.version,v.version)||!p)return f;if(!f)return p;const S=(0,D.deepClone)(p),w=d?E(d,f):{added:Object.keys(f).reduce((u,t)=>(u.add(t),u),new Set),removed:new Set,updated:new Set},g=d?E(d,p):{added:Object.keys(p).reduce((u,t)=>(u.add(t),u),new Set),removed:new Set,updated:new Set};for(const u of[...w.added.values(),...w.updated.values()])S[u]=f[u];for(const u of w.removed.values())g.updated.has(u)||delete S[u];return S}function E(v,y){const m=Object.keys(v),p=Object.keys(y),f=p.filter(w=>m.indexOf(w)===-1).reduce((w,g)=>(w.add(g),w),new Set),d=m.filter(w=>p.indexOf(w)===-1).reduce((w,g)=>(w.add(g),w),new Set),S=new Set;for(const w of m){if(d.has(w))continue;const g=v[w],u=y[w];(0,D.equals)(g,u)||S.add(w)}return{added:f,removed:d,updated:S}}function b(v={},y={}){const{added:m,removed:p,updated:f}=E(v,y);return m.size===0&&p.size===0&&f.size===0}function R(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function I(v,y){const m={identifier:{id:v.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!v.preRelease};return v.version&&(m.version=v.version),v.disabled&&(m.disabled=!0),v.installed&&(m.installed=!0),v.state&&(m.state=v.state),m}}),define(re[105],se([0,1,16,18,6]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==P&&R!==`-${P}`),E&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==P&&R!==`-${P}`),E&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const E=P.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),R=[],I=[];if(Array.isArray(b))for(const v of b)v.startsWith("-")?I.push(v.substring(1)):R.push(v);return(0,D.distinct)([...E,...R].filter(v=>I.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};T=de([Y(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(re[234],se([0,1,16,33,28,167,56]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(g){return(0,n.parse)(g)||[]}e.parseKeybindings=P;async function E(g,u,t,r,i){const a=P(g),c=P(u),s=t?P(t):null,o=[...a,...c,...s||[]].map(H=>H.key),l=await i.resolveUserBindings(o);let h=R(a,c,s,l);if(!h.hasLocalForwarded&&!h.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!h.hasLocalForwarded&&h.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(h.hasLocalForwarded&&!h.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const C=v(a),M=v(c),O=s?v(s):null,U=m(C,M,l),k=O?m(O,C,l):{added:[...C.keys()].reduce((H,ne)=>(H.add(ne),H),new Set),removed:new Set,updated:new Set},F=O?m(O,M,l):{added:[...M.keys()].reduce((H,ne)=>(H.add(ne),H),new Set),removed:new Set,updated:new Set},_=b(U,k,F);let $=g;for(const H of _.removed.values())_.conflicts.has(H)||($=S($,H,r));for(const H of _.added.values()){if(_.conflicts.has(H))continue;const ne=M.get(H);if(ne.some(K=>K.command!==`-${H}`&&h.conflicts.has(l[K.key]))){_.conflicts.add(H);continue}$=d($,ne,r)}for(const H of _.updated.values()){if(_.conflicts.has(H))continue;const ne=M.get(H);if(ne.some(K=>K.command!==`-${H}`&&h.conflicts.has(l[K.key]))){_.conflicts.add(H);continue}$=w($,H,ne,r)}return{mergeContent:$,hasChanges:!0,hasConflicts:_.conflicts.size>0}}e.merge=E;function b(g,u,t){const r=new Set,i=new Set,a=new Set,c=new Set;for(const s of u.removed.values())t.updated.has(s)&&c.add(s);for(const s of t.removed.values())c.has(s)||(u.updated.has(s)?c.add(s):i.add(s));for(const s of u.added.values())c.has(s)||t.added.has(s)&&g.updated.has(s)&&c.add(s);for(const s of t.added.values())c.has(s)||(u.added.has(s)?g.updated.has(s)&&c.add(s):r.add(s));for(const s of u.updated.values())c.has(s)||t.updated.has(s)&&g.updated.has(s)&&c.add(s);for(const s of t.updated.values())c.has(s)||(u.updated.has(s)?g.updated.has(s)&&c.add(s):a.add(s));return{added:r,removed:i,updated:a,conflicts:c}}function R(g,u,t,r){const i=new Set,a=I(g,r),c=I(u,r),s=t?I(t,r):null,o=y(a,c);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const l=s?y(s,a):{added:[...a.keys()].reduce((k,F)=>(k.add(F),k),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const h=s?y(s,c):{added:[...c.keys()].reduce((k,F)=>(k.add(F),k),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:C,removed:M,updated:O,conflicts:U}=b(o,l,h);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:M,updated:O,conflicts:U}}function I(g,u){const t=new Map;for(const r of g){const i=u[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function v(g){const u=new Map;for(const t of g){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=u.get(r);i||(i=[],u.set(r,i)),i.push(t)}return u}function y(g,u){const t=[...g.keys()],r=[...u.keys()],i=r.filter(s=>t.indexOf(s)===-1).reduce((s,o)=>(s.add(o),s),new Set),a=t.filter(s=>r.indexOf(s)===-1).reduce((s,o)=>(s.add(o),s),new Set),c=new Set;for(const s of t){if(a.has(s))continue;const o=g.get(s).map(h=>({...h,key:s})),l=u.get(s).map(h=>({...h,key:s}));(0,D.equals)(o,l,(h,C)=>f(h,C))||c.add(s)}return{added:i,removed:a,updated:c}}function m(g,u,t){const r=[...g.keys()],i=[...u.keys()],a=i.filter(o=>r.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),c=r.filter(o=>i.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),s=new Set;for(const o of r){if(c.has(o))continue;const l=g.get(o).map(C=>({...C,key:t[C.key]})),h=u.get(o).map(C=>({...C,key:t[C.key]}));p(l,h)||s.add(o)}return{added:a,removed:c,updated:s}}function p(g,u){return!(!(0,D.equals)(g.filter(({command:t})=>t[0]!=="-"),u.filter(({command:t})=>t[0]!=="-"),(t,r)=>f(t,r))||!(0,D.equals)(g.filter(({command:t})=>t[0]==="-"),u.filter(({command:t})=>t[0]==="-"),(t,r)=>f(t,r)))}function f(g,u){if(g.command!==u.command||g.key!==u.key)return!1;const t=T.ContextKeyExpr.deserialize(g.when),r=T.ContextKeyExpr.deserialize(u.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!L.equals(g.args,u.args))}function d(g,u,t){for(const r of u)g=A.edit(g,[-1],r,t);return g}function S(g,u,t){const r=P(g);for(let i=r.length-1;i>=0;i--)(r[i].command===u||r[i].command===`-${u}`)&&(g=A.edit(g,[i],void 0,t));return g}function w(g,u,t,r){const i=P(g),a=i.findIndex(c=>c.command===u||c.command===`-${u}`);for(let c=i.length-1;c>=0;c--)(i[c].command===u||i[c].command===`-${u}`)&&(g=A.edit(g,[c],void 0,r));for(let c=t.length-1;c>=0;c--)g=A.edit(g,[a],t[c],r);return g}}),define(re[235],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,A,P){const E={},b={},R=new Set;if(!A)return{local:{added:E,updated:b,removed:[...R.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const I=n(T,A);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:E,updated:b,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=n(P,T),y=n(P,A),m={},p={},f=new Set,d=new Set;for(const S of v.removed.values())y.updated.has(S)?E[S]=A[S]:f.add(S);for(const S of y.removed.values())d.has(S)||(v.updated.has(S)?d.add(S):R.add(S));for(const S of v.updated.values())d.has(S)||(y.updated.has(S)?I.updated.has(S)&&d.add(S):p[S]=T[S]);for(const S of y.updated.values())d.has(S)||(v.updated.has(S)?I.updated.has(S)&&d.add(S):T[S]!==void 0&&(b[S]=A[S]));for(const S of v.added.values())d.has(S)||(y.added.has(S)?I.updated.has(S)&&d.add(S):m[S]=T[S]);for(const S of y.added.values())d.has(S)||(v.added.has(S)?I.updated.has(S)&&d.add(S):E[S]=A[S]);return{local:{added:E,removed:[...R.values()],updated:b},remote:{added:m,removed:[...f.values()],updated:p},conflicts:[...d.values()]}}e.merge=D;function n(T,A){const P=T?Object.keys(T):[],E=A?Object.keys(A):[],b=E.filter(v=>P.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),R=P.filter(v=>E.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),I=new Set;for(const v of P){if(R.has(v))continue;const y=T[v],m=A[v];y!==m&&I.add(v)}return{added:b,removed:R,updated:I}}function L(T,A){const{added:P,removed:E,updated:b}=n(T,A);return P.size===0&&E.size===0&&b.size===0}e.areSame=L}),define(re[25],se([0,1,16,20,13,157,42,29,6,96,38]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const s=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function v(){const s=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(C=>!!s[C].ignoreSync),l=Object.keys(s).filter(C=>s[C].scope===2||s[C].scope===6),h=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...l,...h])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const s="vscode://schemas/ignoredSettings",o=R.Registry.as(A.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=R.Registry.as(b.Extensions.JSONContribution),h=()=>{const C=I(),M=v().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(F=>M.indexOf(F)===-1),U=M.filter(F=>C.indexOf(F)===-1),k={items:{type:"string",enum:[...O,...U.map(F=>`-${F}`)]}};l.registerSchema(s,k)};return o.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=y;function m(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=m;var p;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function f(s,o,l){return l.joinPath(o.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=d;var S;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(S=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class w extends Error{constructor(o,l,h,C){super(o);this.code=l,this.resource=h,this.operationId=C,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=w;class g extends w{constructor(o,l,h,C,M){super(o,h,void 0,M);this.url=l,this.serverCode=C}}e.UserDataSyncStoreError=g;class u extends w{constructor(o,l){super(o,l)}}e.UserDataAutoSyncError=u,function(s){function o(l){if(l instanceof s)return l;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(h&&h[1]){const C=h[2]==="unknown"?void 0:h[2],M=h[3]==="unknown"?void 0:h[3];return new s(l.message,h[1],C,M)}return new s(l.message,"Unknown")}s.toUserDataSyncError=o}(w=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(s){return`sync.enable.${s}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function c(s,o){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:o.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(o.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=c}),define(re[44],se([0,1,16,5,17,23,3,33,2,26,13,7,153,18,14,15,8,46,21,22,32,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function t(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=t;let r=class extends E.Disposable{constructor(o,l,h,C,M,O,U,k,F,_,$){super();this.resource=o,this.fileService=l,this.environmentService=h,this.userDataSyncStoreService=M,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=U,this.telemetryService=k,this.logService=F,this.configurationService=_,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=$.extUri,this.syncFolder=this.extUri.joinPath(h.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(o,h,this.extUri),this.currentMachineIdPromise=(0,d.getServiceMachineId)(h,l,C)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?await this.hasRemoteChanged(o):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){this._status!==o&&(this._status=o,this._onDidChangStatus.fire(o))}async sync(o,l={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),l)}async preview(o,l,h={}){return this._sync(o,!1,l,h)}async apply(o,l={}){try{this.syncHeaders={...l};const h=await this.doApply(o);return this.setStatus(h),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,l,h,C){try{if(this.syncHeaders={...C},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let M="idle";try{const O=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(o,O);return M=await this.performSync(U,O,l,h),M==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(M)}}finally{this.syncHeaders={}}}async replace(o){const l=await this.resolveContent(o);if(!l)return!1;const h=this.parseSyncData(l);if(!h)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const C=await this.getLastSyncUserData(),M=await this.getLatestRemoteUserData(null,C),O=await this.isRemoteDataFromCurrentMachine(M),U=await this.generateSyncPreview({ref:M.ref,syncData:h},C,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),k=[];for(const F of U){const _=await this.getAcceptResult(F,F.remoteResource,void 0,T.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,T.CancellationToken.None);k.push([F,{..._,remoteChange:$!==0?$:2}])}await this.applyResult(M,C,k,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const l=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===l}async getLatestRemoteUserData(o,l){if(l){const h=o&&o.latest?o.latest[this.resource]:void 0;if(l.ref===h||h===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(o,l,h,C){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,l,h,C)}catch(M){if(M instanceof u.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,l,h,C);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(o,l,h,C)}throw M}}async doSync(o,l,h,C){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(o,l,h,C,O)));const M=await this.syncPreviewPromise;return this.updateConflicts(M.resourcePreviews),M.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":h?await this.doApply(!1):"syncing"}catch(M){throw this.syncPreviewPromise=null,M}}async merge(o){return await this.updateSyncResourcePreview(o,async l=>{const h=await this.getMergeResult(l,T.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(h?.content||""));const C=h&&!h.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,T.CancellationToken.None):void 0;return l.acceptResult=C,l.mergeState=h.hasConflicts?"conflict":C?"accepted":"preview",l.localChange=C?C.localChange:h.localChange,l.remoteChange=C?C.remoteChange:h.remoteChange,l}),this.syncPreviewPromise}async accept(o,l){return await this.updateSyncResourcePreview(o,async h=>{const C=await this.getAcceptResult(h,o,l,T.CancellationToken.None);return h.acceptResult=C,h.mergeState="accepted",h.localChange=C.localChange,h.remoteChange=C.remoteChange,h}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async l=>{const h=await this.getMergeResult(l,T.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(h.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=h.localChange,l.remoteChange=h.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(o,l){if(!this.syncPreviewPromise)return;let h=await this.syncPreviewPromise;const C=h.resourcePreviews.findIndex(({localResource:M,remoteResource:O,previewResource:U})=>this.extUri.isEqual(M,o)||this.extUri.isEqual(O,o)||this.extUri.isEqual(U,o));C!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async M=>{const O=[...h.resourcePreviews];return O[C]=await l(O[C]),{...h,resourcePreviews:O}}),h=await this.syncPreviewPromise,this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:h})=>h==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:h})=>h!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(h=>[h,h.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(o){const l=o.filter(({mergeState:h})=>h==="conflict");(0,D.equals)(this._conflicts,l,(h,C)=>this.extUri.isEqual(h.previewResource,C.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){const o=await this.getLastSyncUserData();return!!o&&o.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:h})=>({created:l,uri:this.toRemoteBackupResource(h)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:h})=>({created:l,uri:this.toLocalBackupResource(h)}))}toRemoteBackupResource(o){return I.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return I.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const l=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(l))){const{content:h}=await this.getUserData(l);if(h)return this.parseSyncData(h)?.machineId}}async resolveContent(o){const l=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(l))){const{content:h}=await this.getUserData(l);return h}return this.extUri.isEqual(o,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(o){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const h of l.resourcePreviews){if(this.extUri.isEqual(h.acceptedResource,o))return h.acceptResult?h.acceptResult.content:null;if(this.extUri.isEqual(h.remoteResource,o))return h.remoteContent;if(this.extUri.isEqual(h.localResource,o))return h.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(o,l,h,C,M){const O=await this.isRemoteDataFromCurrentMachine(o),U=await this.generateSyncPreview(o,l,O,C,M),k=[];for(const F of U){const _=F.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)k.push({...F,acceptedResource:_,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=h?await this.getMergeResult(F,M):void 0;if(M.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,L.VSBuffer.fromString($?.content||""));const H=$&&!$.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,M):void 0;k.push({...F,acceptResult:H,mergeState:$?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:$?$.localChange:F.localChange,remoteChange:H?H.remoteChange:$?$.remoteChange:F.remoteChange})}}return{remoteUserData:o,lastSyncUserData:l,resourcePreviews:k,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(o.value.toString()),h=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&h&&l.version!==h,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${h}.`),await this.resetLocal(),null;const C=l;if(C.content===null)return{ref:l.ref,syncData:null};const M=JSON.parse(C.content);if(t(M))return{...l,syncData:M,content:void 0}}catch(o){o instanceof p.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const h=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),C={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:h,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(C)))}async getRemoteUserData(o){const{ref:l,content:h}=await this.getUserData(o);let C=null;return h!==null&&(C=this.parseSyncData(h)),{ref:l,syncData:C}}parseSyncData(o){try{const l=JSON.parse(o);if(t(l))return l}catch(l){this.logService.error(l)}throw new u.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,R.isString)(o)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:l}}else{const l=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(o,l){const h=await this.currentMachineIdPromise,C={version:this.version,machineId:h,content:o};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(C),l,this.syncHeaders),{ref:l,syncData:C}}async backupLocal(o){const l={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};r=de([Y(1,p.IFileService),Y(2,m.IEnvironmentService),Y(3,S.IStorageService),Y(4,u.IUserDataSyncStoreService),Y(5,u.IUserDataSyncBackupStoreService),Y(6,u.IUserDataSyncEnablementService),Y(7,w.ITelemetryService),Y(8,u.IUserDataSyncLogService),Y(9,y.IConfigurationService),Y(10,g.IUriIdentityService)],r),e.AbstractSynchroniser=r;let i=class extends r{constructor(o,l,h,C,M,O,U,k,F,_,$,H){super(l,h,C,M,O,U,k,F,_,$,H);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(ne=>this.onFileChanges(ne)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(o,l,h){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(o),h?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(o),{overwrite:h})}catch(C){throw C instanceof p.FileOperationError&&C.fileOperationResult===1||C instanceof p.FileOperationError&&C.fileOperationResult===3?new u.UserDataSyncError(C.message,"LocalPreconditionFailed"):C}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};i=de([Y(2,p.IFileService),Y(3,m.IEnvironmentService),Y(4,S.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncEnablementService),Y(8,w.ITelemetryService),Y(9,u.IUserDataSyncLogService),Y(10,y.IConfigurationService),Y(11,g.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let a=class extends i{constructor(o,l,h,C,M,O,U,k,F,_,$,H,ne){super(o,l,h,C,M,O,U,k,F,_,H,ne);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(o,l){const h=[],C=(0,P.parse)(o,h,{allowEmptyContent:!0,allowTrailingComma:!0});return h.length>0||!(0,R.isUndefined)(C)&&l!==Array.isArray(C)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};a=de([Y(2,p.IFileService),Y(3,m.IEnvironmentService),Y(4,S.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,u.IUserDataSyncEnablementService),Y(8,w.ITelemetryService),Y(9,u.IUserDataSyncLogService),Y(10,u.IUserDataSyncUtilService),Y(11,y.IConfigurationService),Y(12,g.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let c=class{constructor(o,l,h,C,M){this.resource=o,this.environmentService=l,this.logService=h,this.fileService=C,this.extUri=M.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,l,this.extUri)}async initialize({ref:o,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const h=this.parseSyncData(l);if(!!h)try{await this.doInitialize({ref:o,syncData:h})}catch(C){this.logService.error(C)}}parseSyncData(o){try{const l=JSON.parse(o);if(t(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,l={}){const h={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(h)))}};c=de([Y(1,m.IEnvironmentService),Y(2,f.ILogService),Y(3,p.IFileService),Y(4,g.IUriIdentityService)],c),e.AbstractInitializer=c}),define(re[236],se([0,1,5,23,9,3,50,26,7,18,14,29,31,67,15,8,21,22,32,44,233,105,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function r(c,s){const o=JSON.parse(c.content);if(c.version===1||c.version===2){const l=(await s.getInstalled(0)).filter(h=>h.isBuiltin);for(const h of o)c.version===1&&(h.enabled===!1&&(h.disabled=!0),delete h.enabled),c.version===2&&l.every(C=>!(0,v.areSameExtensions)(C.identifier,h.identifier))&&(h.installed=!0)}return o}let i=class gt extends w.AbstractSynchroniser{constructor(s,o,l,h,C,M,O,U,k,F,_,$,H,ne,K){super("extensions",o,s,l,h,C,$,H,k,_,K);this.extensionManagementService=M,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=U,this.extensionGalleryService=F,this.extensionStorageService=ne,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:t.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,N=>N.some(({local:W})=>!!W)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,N=>!N.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,o){const l=s.syncData?await r(s.syncData,this.extensionManagementService):null,h=o?.skippedExtensions||[],C=o?.syncData?await r(o.syncData,this.extensionManagementService):null,M=await this.extensionManagementService.getInstalled(void 0),O=this.getLocalExtensions(M),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(M);l?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:k,remote:F}=(0,g.merge)(O,l,C,h,U),_={local:k,remote:F,content:this.getPreviewContent(O,k.added,k.updated,k.removed),localChange:k.added.length>0||k.removed.length>0||k.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:h,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:l?this.stringify(l,!1):null,previewResource:this.previewResource,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const o=s.syncData?await r(s.syncData,this.extensionManagementService):null,l=await this.extensionManagementService.getInstalled(void 0),h=this.getLocalExtensions(l),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),{remote:M}=(0,g.merge)(h,o,o,s.skippedExtensions||[],C);return M!==null}getPreviewContent(s,o,l,h){const C=[...o,...l],M=new Set,O=U=>{M.add(U.id.toLowerCase()),U.uuid&&M.add(U.uuid)};C.forEach(({identifier:U})=>O(U)),h.forEach(O);for(const U of s)M.has(U.identifier.id.toLowerCase())||U.identifier.uuid&&M.has(U.identifier.uuid)||C.push(U);return this.stringify(C,!1)}async getMergeResult(s,o){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,o,l,h){if(this.extUri.isEqual(o,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(o,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(o,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${o.toString()}`)}async acceptLocal(s){const o=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(o),h=(0,g.merge)(s.localExtensions,null,null,s.skippedExtensions,l),{local:C,remote:M}=h;return{content:s.localContent,local:C,remote:M,localChange:C.added.length>0||C.removed.length>0||C.updated.length>0?2:0,remoteChange:M!==null?2:0}}async acceptRemote(s){const o=await this.extensionManagementService.getInstalled(),l=this.ignoredExtensionsManagementService.getIgnoredExtensions(o),h=s.remoteContent?JSON.parse(s.remoteContent):null;if(h!==null){const C=(0,g.merge)(s.localExtensions,h,s.localExtensions,[],l),{local:M,remote:O}=C;return{content:s.remoteContent,local:M,remote:O,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,o,l,h){let{skippedExtensions:C,localExtensions:M}=l[0][0],{local:O,remote:U,localChange:k,remoteChange:F}=l[0][1];if(k===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),k!==0&&(await this.backupLocal(JSON.stringify(M)),C=await this.updateLocalExtensions(O.added,O.removed,O.updated,C)),U){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const _=JSON.stringify(U.all);s=await this.updateRemoteUserData(_,h?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${U.added.length?` Added: ${JSON.stringify(U.added.map($=>$.identifier.id))}.`:""}${U.updated.length?` Updated: ${JSON.stringify(U.updated.map($=>$.identifier.id))}.`:""}${U.removed.length?` Removed: ${JSON.stringify(U.removed.map($=>$.identifier.id))}.`:""}`)}o?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:C}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${C.length?` Skipped: ${JSON.stringify(C.map(_=>_.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,gt.EXTENSIONS_DATA_URI)){const l=await this.extensionManagementService.getInstalled(),h=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),C=this.getLocalExtensions(l).filter(M=>!h.some(O=>(0,v.areSameExtensions)({id:O},M.identifier)));return this.stringify(C,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const l=await this.resolvePreviewContent(s);return l&&this.stringify(JSON.parse(l),!0)}let o=await super.resolveContent(s);if(o)return o;if(o=await super.resolveContent(this.extUri.dirname(s)),o){const l=this.parseSyncData(o);if(l)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(l),!0)}}return null}stringify(s,o){return s.sort((l,h)=>!l.identifier.uuid&&h.identifier.uuid?-1:l.identifier.uuid&&!h.identifier.uuid?1:(0,P.compare)(l.identifier.id,h.identifier.id)),o?(0,A.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(l=>l.installed||l.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,o,l,h){const C=[],M=[],O=await this.extensionManagementService.getInstalled();if(o.length){const k=O.filter(({identifier:F,isBuiltin:_})=>!_&&o.some($=>(0,v.areSameExtensions)(F,$)));await D.Promises.settled(k.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),C.push(F.identifier)}))}(s.length||l.length)&&await D.Promises.settled([...s,...l].map(async k=>{const F=O.find($=>(0,v.areSameExtensions)($.identifier,k.identifier));if(F&&F.isBuiltin){k.state&&F.manifest.version===k.version&&this.updateExtensionState(k.state,F,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,v.areSameExtensions)(H,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id),await this.extensionEnablementService.disableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id),await this.extensionEnablementService.enableExtension(k.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id))),C.push(k.identifier);return}const _=(await this.extensionGalleryService.getExtensions([{...k.identifier,preRelease:k.preRelease}],n.CancellationToken.None))[0];if(k.state&&(F?F.manifest.version===k.version:!!_)&&this.updateExtensionState(k.state,F||_,F?.manifest.version),_)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,v.areSameExtensions)(H,k.identifier))!==!!k.disabled&&(k.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,k.identifier.id,_.version),await this.extensionEnablementService.disableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,k.identifier.id,_.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,k.identifier.id,_.version),await this.extensionEnablementService.enableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,k.identifier.id,_.version))),(!F||F.preRelease!==k.preRelease)&&(await this.extensionManagementService.canInstall(_)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,k.identifier.id,_.version),await this.extensionManagementService.installFromGallery(_,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:k.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,k.identifier.id,_.version),C.push(_.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,_.displayName||_.identifier.id),M.push(k)))}catch($){M.push(k),$ instanceof I.ExtensionManagementError&&[I.ExtensionManagementErrorCode.Incompatible,I.ExtensionManagementErrorCode.IncompatiblePreRelease,I.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes($.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,_.displayName||_.identifier.id):(this.logService.error($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,_.displayName||_.identifier.id))}else M.push(k),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}));const U=[];for(const k of h)C.some(F=>(0,v.areSameExtensions)(F,k.identifier))||U.push(k);for(const k of M)U.some(F=>(0,v.areSameExtensions)(F.identifier,k.identifier))||U.push(k);return U}updateExtensionState(s,o,l){const h=this.extensionStorageService.getExtensionState(o,!0)||{},C=l?this.extensionStorageService.getKeysForSync({id:o.identifier.id,version:l}):void 0;C?C.forEach(M=>{h[M]=s[M]}):Object.keys(s).forEach(M=>h[M]=s[M]),this.extensionStorageService.setExtensionState(o,h,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const o=this.extensionEnablementService.getDisabledExtensions();return s.map(l=>{const{identifier:h,isBuiltin:C,manifest:M,preRelease:O}=l,U={identifier:h,preRelease:O,version:M.version};o.some(k=>(0,v.areSameExtensions)(k,h))&&(U.disabled=!0),C||(U.installed=!0);try{const k=this.extensionStorageService.getKeysForSync({id:h.id,version:M.version});if(k){const F=this.extensionStorageService.getExtensionState(l,!0)||{};U.state=Object.keys(F).reduce((_,$)=>(k.includes($)&&(_[$]=F[$]),_),{})}}catch(k){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(k))}return U})}};i.EXTENSIONS_DATA_URI=E.URI.from({scheme:t.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,R.IEnvironmentService),Y(1,m.IFileService),Y(2,f.IStorageService),Y(3,t.IUserDataSyncStoreService),Y(4,t.IUserDataSyncBackupStoreService),Y(5,I.IExtensionManagementService),Y(6,I.IGlobalExtensionEnablementService),Y(7,u.IIgnoredExtensionsManagementService),Y(8,t.IUserDataSyncLogService),Y(9,I.IExtensionGalleryService),Y(10,b.IConfigurationService),Y(11,t.IUserDataSyncEnablementService),Y(12,d.ITelemetryService),Y(13,y.IExtensionStorageService),Y(14,S.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let a=class extends w.AbstractInitializer{constructor(s,o,l,h,C,M){super("extensions",h,C,l,M);this.extensionManagementService=s,this.ignoredExtensionsManagementService=o}async parseExtensions(s){return s.syncData?await r(s.syncData,this.extensionManagementService):null}generatePreview(s,o){const l=[],h=[],C=[];for(const M of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(M.identifier.id))continue;const O=o.find(U=>(0,v.areSameExtensions)(U.identifier,M.identifier));O?(l.push(O),M.disabled&&C.push(M.identifier)):M.installed&&(h.push({...M.identifier,preRelease:!!M.preRelease}),M.disabled&&C.push(M.identifier))}return{installedExtensions:l,newExtensions:h,disabledExtensions:C,remoteExtensions:s}}};a=de([Y(0,I.IExtensionManagementService),Y(1,u.IIgnoredExtensionsManagementService),Y(2,m.IFileService),Y(3,R.IEnvironmentService),Y(4,p.ILogService),Y(5,S.IUriIdentityService)],a),e.AbstractExtensionsInitializer=a}),define(re[237],se([0,1,28,25]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(P,E,b,R,I){if(!E)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const v=T(P,E);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=b?T(b,E):{added:Object.keys(E).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},m=b?T(b,P):{added:Object.keys(P).reduce((S,w)=>(S.add(w),S),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},f=D.deepClone(E),d=!b;for(const S of m.added.values())S!==n.SYNC_SERVICE_URL_TYPE&&d&&y.added.has(S)||(f[S]=P[S]);for(const S of m.updated.values())f[S]=P[S];for(const S of m.removed.values())R.unregistered.includes(S)||delete f[S];for(const S of y.added.values()){const w=E[S];if(R.machine.includes(S)){I.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(b&&m.added.has(S))continue;const g=P[S];g&&g.value===w.value||S===n.SYNC_SERVICE_URL_TYPE&&d&&m.added.has(S)||(g?p.updated[S]=w:p.added[S]=w)}for(const S of y.updated.values()){const w=E[S];if(R.machine.includes(S)){I.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(S)||m.removed.has(S))continue;const g=P[S];g&&g.value===w.value||(p.updated[S]=w)}for(const S of y.removed.values()){if(R.machine.includes(S)){I.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}m.updated.has(S)||m.removed.has(S)||p.removed.push(S)}return{local:p,remote:A(f,E)?null:f}}e.merge=L;function T(P,E){const b=Object.keys(P),R=Object.keys(E),I=R.filter(m=>b.indexOf(m)===-1).reduce((m,p)=>(m.add(p),m),new Set),v=b.filter(m=>R.indexOf(m)===-1).reduce((m,p)=>(m.add(p),m),new Set),y=new Set;for(const m of b){if(v.has(m))continue;const p=P[m],f=E[m];D.equals(p,f)||y.add(m)}return{added:I,removed:v,updated:y}}function A(P,E){const{added:b,removed:R,updated:I}=T(P,E);return b.size===0&&R.size===0&&I.size===0}}),define(re[238],se([0,1,17,9,3,33,50,4,7,30,18,14,15,8,46,21,22,32,44,56,237,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",r=["locale"];function i(l,h){const C=l.storage?Object.keys(l.storage).sort():[],M={};return C.forEach(O=>M[O]=l.storage[O]),l.storage=M,h?(0,A.toFormattedString)(l,{}):JSON.stringify(l)}const a=1;let c=class mt extends S.AbstractSynchroniser{constructor(h,C,M,O,U,k,F,_,$,H){super("globalState",h,U,$,C,M,k,F,O,_,H);this.storageService=$,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(h.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(h.onDidFilesChange,ne=>ne.contains(this.environmentService.argvResource)),L.Event.filter($.onDidChangeValue,ne=>ne.scope===0&&ne.target!==void 0?ne.target===0:$.keys(0,0).includes(ne.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(h,C,M){const O=h.syncData?JSON.parse(h.syncData.content):null;C=C===null&&M?h:C;const U=C&&C.syncData?JSON.parse(C.syncData.content):null,k=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(U),{local:_,remote:$}=(0,g.merge)(k.storage,O?O.storage:null,U?U.storage:null,F,this.logService),H={content:null,local:_,remote:$,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:i(k,!1),localUserData:k,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async hasRemoteChanged(h){const C=h.syncData?JSON.parse(h.syncData.content):null;if(C===null)return!0;const M=await this.getLocalGlobalState(),O=this.getStorageKeys(C),{remote:U}=(0,g.merge)(M.storage,C.storage,C.storage,O,this.logService);return U!==null}async getMergeResult(h,C){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,C,M,O){if(this.extUri.isEqual(C,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(C,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(C,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async acceptLocal(h){return{content:h.localContent,local:{added:{},removed:[],updated:{}},remote:h.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(h){if(h.remoteContent!==null){const C=JSON.parse(h.remoteContent),{local:M,remote:O}=(0,g.merge)(h.localUserData.storage,C.storage,null,h.storageKeys,this.logService);return{content:h.remoteContent,local:M,remote:O,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:h.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(h,C,M,O){let{localUserData:U}=M[0][0],{local:k,remote:F,localChange:_,remoteChange:$}=M[0][1];if(_===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(U)),await this.writeLocalGlobalState(k),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:F});h=await this.updateRemoteUserData(H,O?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}C?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,mt.GLOBAL_STATE_DATA_URI)){const M=await this.getLocalGlobalState();return i(M,!0)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const M=await this.resolvePreviewContent(h);return M&&i(JSON.parse(M),!0)}let C=await super.resolveContent(h);if(C)return C;if(C=await super.resolveContent(this.extUri.dirname(h)),C){const M=this.parseSyncData(C);if(M)switch(this.extUri.basename(h)){case"globalState.json":return i(JSON.parse(M.content),!0)}}return null}async hasLocalData(){try{const{storage:h}=await this.getLocalGlobalState();if(Object.keys(h).length>1||h[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const h={},C=await this.getLocalArgvContent(),M=(0,T.parse)(C);for(const O of r)M[O]!==void 0&&(h[`${t}${O}`]={version:1,value:M[O]});for(const O of this.storageService.keys(0,0)){const U=this.storageService.get(O,0);U&&(h[O]={version:1,value:U})}return{storage:h}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const h=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),h.value.toString()}catch(h){this.logService.debug((0,n.getErrorMessage)(h))}return"{}"}async writeLocalGlobalState({added:h,removed:C,updated:M}){const O={},U={},k=(_,$)=>{for(const H of _){if(H.startsWith(t)){O[H.substring(t.length)]=$?$[H].value:void 0;continue}if($){const ne=$[H];ne.value!==String(this.storageService.get(H,0))&&(U[H]=ne.value)}else this.storageService.get(H,0)!==void 0&&(U[H]=void 0)}};if(k(Object.keys(h),h),k(Object.keys(M),M),k(C),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(U).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys(U))this.storageService.store(_,U[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(U))}}async updateArgv(h){const C=await this.getLocalArgvContent();let M=C;for(const O of Object.keys(h))M=(0,w.edit)(M,[O],h[O],{});C!==M&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(M)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(h){const C=this.storageService.keys(0,0),M=this.storageService.keys(0,1),O=[...C,...M],U=h?.storage?Object.keys(h.storage).filter(k=>!k.startsWith(t)&&!O.includes(k)&&this.storageService.get(k,0)!==void 0):[];if(!P.isWeb){const k=[...u.ALL_SYNC_RESOURCES.map(F=>(0,u.getEnablementKey)(F)),u.SYNC_SERVICE_URL_TYPE];U.push(...k),M.push(...k)}return{user:C,machine:M,unregistered:U}}};c.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=de([Y(0,v.IFileService),Y(1,u.IUserDataSyncStoreService),Y(2,u.IUserDataSyncBackupStoreService),Y(3,u.IUserDataSyncLogService),Y(4,I.IEnvironmentService),Y(5,u.IUserDataSyncEnablementService),Y(6,f.ITelemetryService),Y(7,R.IConfigurationService),Y(8,p.IStorageService),Y(9,d.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let s=class extends S.AbstractInitializer{constructor(h,C,M,O,U){super("globalState",M,O,C,U);this.storageService=h}async doInitialize(h){const C=h.syncData?JSON.parse(h.syncData.content):null;if(!C){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},O={};for(const U of Object.keys(C.storage))U.startsWith(t)?M[U.substring(t.length)]=C.storage[U].value:this.storageService.get(U,0)===void 0&&(O[U]=C.storage[U].value);if(Object.keys(M).length){let U="{}";try{U=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const k of Object.keys(M))U=(0,w.edit)(U,[k],M[k],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(O).length)for(const U of Object.keys(O))this.storageService.store(U,O[U],0,0)}};s=de([Y(0,p.IStorageService),Y(1,v.IFileService),Y(2,I.IEnvironmentService),Y(3,u.IUserDataSyncLogService),Y(4,d.IUriIdentityService)],s),e.GlobalStateInitializer=s;let o=class{constructor(h,C,M,O,U){this.userDataSyncStoreClient=h,this.storageService=C,this.environmentService=M,this.fileService=O,this.logService=U}getSyncStoreType(h){return this.parseGlobalState(h)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(h){const C=(0,u.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(h,C)}catch(M){if(M instanceof u.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(h,C)}throw M}}async doSync(h,C){const M=await this.userDataSyncStoreClient.read("globalState",null,C),O=this.parseGlobalState(M)||{storage:{}};O.storage[u.SYNC_SERVICE_URL_TYPE]={value:h,version:a};const U=await(0,m.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),k={version:a,machineId:U,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(k),M.ref,C)}parseGlobalState({content:h}){if(!h)return null;const C=JSON.parse(h);if((0,S.isSyncData)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};o=de([Y(1,p.IStorageService),Y(2,I.IEnvironmentService),Y(3,v.IFileService),Y(4,y.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(re[239],se([0,1,16,17,3,33,4,13,154,18,14,15,21,22,32,44,234,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function S(u,t,r){try{const i=JSON.parse(u);if(!t)return(0,P.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,P.isUndefined)(i.mac)?null:i.mac;case 3:return(0,P.isUndefined)(i.linux)?null:i.linux;case 1:return(0,P.isUndefined)(i.windows)?null:i.windows}}catch(i){return r.error(i),null}}e.getKeybindingsContentFromSyncContent=S;let w=class extends p.AbstractJsonFileSynchroniser{constructor(t,r,i,a,c,s,o,l,h,C,M){super(o.keybindingsResource,"keybindings",s,o,l,t,r,c,C,i,h,a,M);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(a.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(t,r,i,a){const c=t.syncData?S(t.syncData.content,a.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;r=r===null&&i?t:r;const s=r?this.getKeybindingsContentFromLastSyncUserData(r):null,o=await this.getLocalFileContent(),l=await this.getFormattingOptions();let h=null,C=!1,M=!1,O=!1;if(c){let k=o?o.value.toString():"[]";if(k=k||"[]",this.hasErrors(k,!0))throw new d.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==k||s!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const F=await(0,f.merge)(k,c,s,l,this.userDataSyncUtilService);F.hasChanges&&(h=F.mergeContent,O=F.hasConflicts,C=O||F.mergeContent!==k,M=O||F.mergeContent!==c)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=o.value.toString(),M=!0);const U={content:h,localChange:C?o?2:1:0,remoteChange:M?2:0,hasConflicts:O};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const r=this.getKeybindingsContentFromLastSyncUserData(t);if(r===null)return!0;const i=await this.getLocalFileContent(),a=i?i.value.toString():"",c=await this.getFormattingOptions(),s=await(0,f.merge)(a||"[]",r,r,c,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==r}async getMergeResult(t,r){return t.previewResult}async getAcceptResult(t,r,i,a){if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?t.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:c}=i[0][0];let{content:s,localChange:o,remoteChange:l}=i[0][1];if(o===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s,!0)))throw new d.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(s||"[]",c,a),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const h=this.toSyncContent(s||"[]",t.syncData?.content);t=await this.updateRemoteUserData(h,a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(t,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=(0,T.parse)(t.value.toString());if((0,D.isNonEmptyArray)(r))return!0}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"keybindings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i)switch(this.extUri.basename(t)){case"keybindings.json":return S(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(t){return!t.syncData||t.platformSpecific!==void 0&&t.platformSpecific!==this.syncKeybindingsPerPlatform()?null:S(t.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(t,r){let i={};try{i=JSON.parse(r||"{}")}catch(a){this.logService.error(a)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=t,A.OS){case 2:i.mac=t;break;case 3:i.linux=t;break;case 1:i.windows=t;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};w=de([Y(0,d.IUserDataSyncStoreService),Y(1,d.IUserDataSyncBackupStoreService),Y(2,d.IUserDataSyncLogService),Y(3,b.IConfigurationService),Y(4,d.IUserDataSyncEnablementService),Y(5,I.IFileService),Y(6,R.IEnvironmentService),Y(7,v.IStorageService),Y(8,d.IUserDataSyncUtilService),Y(9,y.ITelemetryService),Y(10,m.IUriIdentityService)],w),e.KeybindingsSynchroniser=w;let g=class extends p.AbstractInitializer{constructor(t,r,i,a){super("keybindings",r,i,t,a)}async doInitialize(t){const r=t.syncData?this.getKeybindingsContentFromSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(r)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource),r=(0,T.parse)(t.value.toString());return!(0,D.isNonEmptyArray)(r)}catch(t){return t.fileOperationResult===1}}getKeybindingsContentFromSyncContent(t){try{return S(t,!0,this.logService)}catch(r){return this.logService.error(r),null}}};g=de([Y(0,I.IFileService),Y(1,R.IEnvironmentService),Y(2,d.IUserDataSyncLogService),Y(3,m.IUriIdentityService)],g),e.KeybindingsInitializer=g}),define(re[240],se([0,1,16,33,73,50,28,56,25]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(o,l,h){let C=[];h?C=I(h):C=R(l);const M=[],O=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(C))for(const U of C)U.startsWith("-")?O.push(U.substring(1)):M.push(U);return(0,D.distinct)([...o,...M].filter(U=>O.indexOf(U)===-1))}e.getIgnoredSettings=b;function R(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function I(o){const l=(0,n.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function v(o,l){const h=(0,n.parse)(o)||{};let C="{}";for(const M of Object.keys(h)){const O=(0,L.setProperty)(C,[M],h[M],l);C=(0,L.applyEdits)(C,O)}return C}e.removeComments=v;function y(o,l,h,C){if(h.length){const M=s(l),O=(0,n.parse)(l)||{},U=(0,n.parse)(o);if(!U)return o;const k=[];for(const F of h){const _=O[F],$=U[F];_===void 0?o=P.edit(o,[F],void 0,C):$!==void 0?o=P.edit(o,[F],_,C):k.push(t(F,M))}k.sort((F,_)=>F.startOffset-_.startOffset),k.forEach(F=>o=S(F.setting.key,l,o,C))}return o}e.updateIgnoredSettings=y;function m(o,l,h,C,M,O){const U=y(o,l,C,O),k=h!==U,F=h!==l;if(!k&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!F)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(F&&!k)return{conflictsSettings:[],localContent:y(l,o,C,O),remoteContent:null,hasConflicts:!1};if(h===null&&f(o)){const z=p(o,l,C)?null:y(l,o,C,O);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let _=o,$=l;const H=(0,n.parse)(o),ne=(0,n.parse)(l),K=h?(0,n.parse)(h):null,N=C.reduce((z,V)=>(z.add(V),z),new Set),W=d(H,ne,N),x=d(K,H,N),J=d(K,ne,N),G=new Map,Q=new Set,Z=z=>{Q.add(z);const V=M.filter(({key:ee})=>ee===z)[0];V?(_=P.edit(_,[z],V.value,O),$=P.edit($,[z],V.value,O)):G.set(z,{key:z,localValue:H[z],remoteValue:ne[z]})};for(const z of x.removed.values())J.updated.has(z)?Z(z):$=P.edit($,[z],void 0,O);for(const z of J.removed.values())Q.has(z)||(x.updated.has(z)?Z(z):_=P.edit(_,[z],void 0,O));for(const z of x.updated.values())Q.has(z)||(J.updated.has(z)?W.updated.has(z)&&Z(z):$=P.edit($,[z],H[z],O));for(const z of J.updated.values())Q.has(z)||(x.updated.has(z)?W.updated.has(z)&&Z(z):_=P.edit(_,[z],ne[z],O));for(const z of x.added.values())Q.has(z)||(J.added.has(z)?W.updated.has(z)&&Z(z):$=S(z,_,$,O));for(const z of J.added.values())Q.has(z)||(x.added.has(z)?W.updated.has(z)&&Z(z):_=S(z,$,_,O));const q=G.size>0||!p(_,$,C),B=q||!p(_,o,[]),j=q||!p($,l,[]);return{localContent:B?_:null,remoteContent:j?$:null,conflictsSettings:[...G.values()],hasConflicts:q}}e.merge=m;function p(o,l,h){if(o===l)return!0;const C=(0,n.parse)(o),M=(0,n.parse)(l),O=h.reduce((F,_)=>(F.add(_),F),new Set),U=s(o).filter(F=>!(F.setting&&O.has(F.setting.key))),k=s(l).filter(F=>!(F.setting&&O.has(F.setting.key)));if(U.length!==k.length)return!1;for(let F=0;F<U.length;F++){const _=U[F],$=k[F];if(_.setting&&$.setting){if(_.setting.key!==$.setting.key||!A.equals(C[_.setting.key],M[_.setting.key]))return!1}else if(!_.setting&&!$.setting){if(_.value!==$.value)return!1}else return!1}return!0}e.areSame=p;function f(o){return o?s(o).length===0:!0}e.isEmpty=f;function d(o,l,h){const C=o?Object.keys(o).filter(F=>!h.has(F)):[],M=Object.keys(l).filter(F=>!h.has(F)),O=M.filter(F=>C.indexOf(F)===-1).reduce((F,_)=>(F.add(_),F),new Set),U=C.filter(F=>M.indexOf(F)===-1).reduce((F,_)=>(F.add(_),F),new Set),k=new Set;if(o)for(const F of C){if(U.has(F))continue;const _=o[F],$=l[F];A.equals(_,$)||k.add(F)}return{added:O,removed:U,updated:k}}function S(o,l,h,C){const M=(0,n.parse)(l),O=s(l),U=s(h),k=w(o,O,U);return g(h,o,M[o],k,U,C)}e.addSetting=S;function w(o,l,h){const C=l.findIndex(O=>O.setting?.key===o),M=l[C-1];if(M){if(M.setting){const U=t(M.setting.key,h);if(U)return{index:h.indexOf(U),insertAfter:!0}}else{const U=r(C,l);if(U){const k=t(U.setting.key,h);if(k){const F=i(h.indexOf(k),h),_=a(l,U,l[C]);if(F){const $=a(h,k,F),H=c(_,$);return H?{index:h.indexOf(H),insertAfter:!0}:{index:h.indexOf(F),insertAfter:!1}}else{const $=a(h,k,h[h.length-1]),H=c(_,$);return H?{index:h.indexOf(H),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const O=l[C+1];if(O)if(O.setting){const U=t(O.setting.key,h);if(U)return{index:h.indexOf(U),insertAfter:!1}}else{const U=i(C,l);if(U){const k=t(U.setting.key,h);if(k){const F=r(h.indexOf(k),h),_=a(l,l[C],U);if(F){const $=a(h,F,k),H=c(_.reverse(),$.reverse());return H?{index:h.indexOf(H),insertAfter:!1}:{index:h.indexOf(F),insertAfter:!0}}else{const $=a(h,h[0],k),H=c(_.reverse(),$.reverse());return H?{index:h.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function g(o,l,h,C,M,O){let U;return C.index===-1?U=(0,L.setProperty)(o,[l],h,O):U=u(o,l,h,C,M,O).map(k=>(0,L.withFormatting)(o,k,O)[0]),(0,L.applyEdits)(o,U)}function u(o,l,h,C,M,O){const U=`${JSON.stringify(l)}: ${JSON.stringify(h)}`,k=(0,T.getEOL)(O,o),F=M[C.index];if(C.insertAfter){const _=[];if(F.setting)_.push({offset:F.endOffset,length:0,content:","+U});else{const $=i(C.index,M),H=r(C.index,M),ne=H?.setting?.commaOffset;H&&ne===void 0&&_.push({offset:H.endOffset,length:0,content:","});const K=ne!==void 0&&ne>F.endOffset;_.push({offset:K?ne+1:F.endOffset,length:0,content:$?k+U+",":k+U})}return _}else{if(F.setting)return[{offset:F.startOffset,length:0,content:U+","}];const _=(M[C.index-1]&&!M[C.index-1].setting?k:"")+U+(i(C.index,M)?",":"")+k;return[{offset:F.startOffset,length:0,content:_}]}}function t(o,l){return l.filter(h=>h.setting?.key===o)[0]}function r(o,l){for(let h=o-1;h>=0;h--)if(l[h].setting)return l[h]}function i(o,l){for(let h=o+1;h<l.length;h++)if(l[h].setting)return l[h]}function a(o,l,h){const C=o.indexOf(l),M=o.indexOf(h);return o.filter((O,U)=>C<U&&U<M)}function c(o,l){if(o.length&&l.length){let h=0;for(;h<l.length&&h<o.length;h++)if(o[h].value!==l[h].value)return l[h-1];return l[h-1]}}function s(o){const l=[];let h=-1,C,M;const O={onObjectBegin:U=>{h++},onObjectProperty:(U,k,F)=>{h===0&&(C=k,M=U)},onObjectEnd:(U,k)=>{h--,h===0&&l.push({startOffset:C,endOffset:U+k,value:o.substring(C,U+k),setting:{key:M,commaOffset:void 0}})},onArrayBegin:(U,k)=>{h++},onArrayEnd:(U,k)=>{h--,h===0&&l.push({startOffset:C,endOffset:U+k,value:o.substring(C,U+k),setting:{key:M,commaOffset:void 0}})},onLiteralValue:(U,k,F)=>{h===0&&l.push({startOffset:C,endOffset:k+F,value:o.substring(C,k+F),setting:{key:M,commaOffset:void 0}})},onSeparator:(U,k,F)=>{if(h===0&&U===","){let _=l.length-1;for(;_>=0&&!l[_].setting;_--);const $=l[_];$&&l.splice(_,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:k}})}},onComment:(U,k)=>{h===0&&l.push({startOffset:U,endOffset:U+k,value:o.substring(U,U+k)})}};return(0,n.visit)(o,O),l}}),define(re[241],se([0,1,17,3,155,18,64,14,29,15,21,22,32,44,56,240,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function S(u){const t=JSON.parse(u);return d(t)?t:{settings:u}}e.parseSettingsSyncContent=S;let w=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,i,a,c,s,o,l,h,C,M,O){super(r.settingsResource,"settings",t,r,i,a,c,h,C,s,o,l,O);this.extensionManagementService=M,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(t,r),a=this.getSettingsSyncContent(i),c=new A.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&c.parse(a.settings),c.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,r,i){const a=await this.getLocalFileContent(),c=await this.getFormattingOptions(),s=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const o=r?this.getSettingsSyncContent(r):null,l=await this.getIgnoredSettings();let h=null,C=!1,M=!1,O=!1;if(s){let k=a?a.value.toString().trim():"{}";k=k||"{}",this.validateContent(k),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,p.merge)(k,s.settings,o?o.settings:null,l,[],c);h=F.localContent||F.remoteContent,C=F.localContent!==null,M=F.remoteContent!==null,O=F.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),h=a.value.toString().trim()||"{}",this.validateContent(h),M=!0);const U={content:h,localChange:C?2:0,remoteChange:M?2:0,hasConflicts:O};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const r=this.getSettingsSyncContent(t);if(r===null)return!0;const i=await this.getLocalFileContent(),a=i?i.value.toString().trim():"",c=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,p.merge)(a||"{}",r.settings,r.settings,c,[],s).remoteContent!==null}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,p.updateIgnoredSettings)(t.previewResult.content,"{}",a,i):null}}async getAcceptResult(t,r,i,a){const c=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",s,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",s,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,p.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",s,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:c}=i[0][0];let{content:s,localChange:o,remoteChange:l}=i[0][1];if(o===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(s,c,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),l!==0){const h=await this.getFormattingOptions(),C=this.getSettingsSyncContent(t),M=await this.getIgnoredSettings(s);s=(0,p.updateIgnoredSettings)(s,C?C.settings:"{}",M,h),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,m.edit)(t.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,p.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,p.updateIgnoredSettings)(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return S(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:c})=>!!c)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new f.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};w=de([Y(0,b.IFileService),Y(1,P.IEnvironmentService),Y(2,R.IStorageService),Y(3,f.IUserDataSyncStoreService),Y(4,f.IUserDataSyncBackupStoreService),Y(5,f.IUserDataSyncLogService),Y(6,f.IUserDataSyncUtilService),Y(7,T.IConfigurationService),Y(8,f.IUserDataSyncEnablementService),Y(9,I.ITelemetryService),Y(10,E.IExtensionManagementService),Y(11,v.IUriIdentityService)],w),e.SettingsSynchroniser=w;let g=class extends y.AbstractInitializer{constructor(t,r,i,a){super("settings",r,i,t,a)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return S(t)}catch(r){this.logService.error(r)}return null}};g=de([Y(0,b.IFileService),Y(1,P.IEnvironmentService),Y(2,f.IUserDataSyncLogService),Y(3,v.IUriIdentityService)],g),e.SettingsInitializer=g}),define(re[242],se([0,1,17,3,28,18,14,15,21,22,32,44,235,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let m=class extends I.AbstractSynchroniser{constructor(d,S,w,g,u,t,r,i,a,c){super("snippets",S,d,w,g,u,i,a,t,r,c);this.version=1,this.snippetsFolder=d.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(d,S,w){const g=await this.getSnippetsFileContents(),u=this.toSnippetsContents(g),t=d.syncData?this.parseSnippets(d.syncData):null;S=S===null&&w?d:S;const r=S&&S.syncData?this.parseSnippets(S.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,v.merge)(u,t,r);return this.getResourcePreviews(i,g,t||{})}async hasRemoteChanged(d){const S=d.syncData?this.parseSnippets(d.syncData):null;if(S===null)return!0;const w=await this.getSnippetsFileContents(),g=this.toSnippetsContents(w),u=(0,v.merge)(g,S,S);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(d,S){return d.previewResult}async getAcceptResult(d,S,w,g){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return w===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:w,localChange:w===null?d.fileContent!==null?3:0:2,remoteChange:w===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(d,S,w,g){const u=w.map(([t,r])=>({...t,acceptResult:r}));u.every(({localChange:t,remoteChange:r})=>t===0&&r===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,g)),u.some(({remoteChange:t})=>t!==0)&&(d=await this.updateRemoteSnippets(u,d,g)),S?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of u)try{await this.fileService.del(t)}catch{}}getResourcePreviews(d,S,w){const g=new Map;for(const u of Object.keys(d.local.added)){const t={content:d.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};g.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.local.updated)){const t={content:d.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.remote.added)){const t={content:d.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.remote.updated)){const t={content:d.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.conflicts){const t={content:S[u]?S[u].value.toString():null,hasConflicts:!0,localChange:S[u]?2:1,remoteChange:w[u]?2:1};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(S))if(!g.has(u)){const t={content:S[u]?S[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:w[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:d}){let S=await super.resolveContent(d);if(S){const w=this.parseSyncData(S);if(w){const g=this.parseSnippets(w),u=[];for(const t of Object.keys(g)){const r=this.extUri.joinPath(d,t),i=this.extUri.joinPath(this.snippetsFolder,t),a=await this.fileService.exists(i);u.push({resource:r,comparableResource:a?i:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(d){if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(d);let S=await super.resolveContent(d);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(d)),S){const w=this.parseSyncData(S);if(w)return this.parseSnippets(w)[this.extUri.basename(d)]||null}return null}async hasLocalData(){try{const d=await this.getSnippetsFileContents();if(Object.keys(d).length)return!0}catch{}return!1}async updateLocalBackup(d){const S={};for(const w of d)w.fileContent&&(S[this.extUri.basename(w.localResource)]=w.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(d,S){for(const{fileContent:w,acceptResult:g,localResource:u,remoteResource:t,localChange:r}of d)if(r!==0){const i=t?this.extUri.basename(t):this.extUri.basename(u),a=this.extUri.joinPath(this.snippetsFolder,i);r===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(a)),await this.fileService.del(a),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(a))):r===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(a)),await this.fileService.createFile(a,D.VSBuffer.fromString(g.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(a))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(a)),await this.fileService.writeFile(a,D.VSBuffer.fromString(g.content),S?void 0:w),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(a)))}}async updateRemoteSnippets(d,S,w){const g=S.syncData?this.parseSnippets(S.syncData):{},u=(0,L.deepClone)(g);for(const{acceptResult:t,localResource:r,remoteResource:i,remoteChange:a}of d)if(a!==0){const c=r?this.extUri.basename(r):this.extUri.basename(i);a===3?delete u[c]:u[c]=t.content}return(0,v.areSame)(g,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(u),w?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(d){return JSON.parse(d.content)}toSnippetsContents(d){const S={};for(const w of Object.keys(d))S[w]=d[w].value.toString();return S}async getSnippetsFileContents(){const d={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(w){if(w instanceof P.FileOperationError&&w.fileOperationResult===1)return d;throw w}for(const w of S.children||[]){const g=w.resource,u=this.extUri.extname(g);if(u===".json"||u===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,g),r=await this.fileService.readFile(g);d[t]=r}}return d}};m=de([Y(0,A.IEnvironmentService),Y(1,P.IFileService),Y(2,E.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncBackupStoreService),Y(5,y.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,y.IUserDataSyncEnablementService),Y(8,b.ITelemetryService),Y(9,R.IUriIdentityService)],m),e.SnippetsSynchroniser=m;let p=class extends I.AbstractInitializer{constructor(d,S,w,g){super("snippets",S,w,d,g)}async doInitialize(d){const S=d.syncData?JSON.parse(d.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(S)){const u=S[g];if(u){const t=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(t,D.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(d)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};p=de([Y(0,P.IFileService),Y(1,A.IEnvironmentService),Y(2,y.IUserDataSyncLogService),Y(3,R.IUriIdentityService)],p),e.SnippetsInitializer=p}),define(re[243],se([0,1,17,18,14,15,21,22,32,44,25]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function I(p,f){try{return JSON.parse(p).tasks}catch(d){return f.error(d),null}}e.getTasksContentFromSyncContent=I;let v=class extends b.AbstractFileSynchroniser{constructor(f,d,S,w,g,u,t,r,i,a){super(a.extUri.joinPath(a.extUri.dirname(t.settingsResource),"tasks.json"),"tasks",u,t,r,f,d,g,i,S,w,a);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.localResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:R.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(f,d,S,w){const g=f.syncData?I(f.syncData.content,this.logService):null;d=d===null&&S?f:d;const u=d?.syncData?I(d.syncData.content,this.logService):null,t=await this.getLocalFileContent();let r=null,i=!1,a=!1,c=!1;if(g){const o=t?t.value.toString():null;if(!u||u!==o||u!==g){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const l=m(o,g,u);r=l.content,c=l.hasConflicts,i=l.hasLocalChanged,a=l.hasRemoteChanged}}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),r=t.value.toString(),a=!0);const s={content:r,localChange:i?t?2:1:0,remoteChange:a?2:0,hasConflicts:c};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:s.localChange,remoteResource:this.remoteResource,remoteContent:g,remoteChange:s.remoteChange,previewResource:this.previewResource,previewResult:s,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(f){const d=f?.syncData?I(f.syncData.content,this.logService):null;if(d===null)return!0;const S=await this.getLocalFileContent(),w=S?S.value.toString():null,g=m(w,d,d);return g.hasLocalChanged||g.hasRemoteChanged}async getMergeResult(f,d){return f.previewResult}async getAcceptResult(f,d,S,w){if(this.extUri.isEqual(d,this.localResource))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(d,this.remoteResource))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(d,this.previewResource))return S===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:S,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async applyResult(f,d,S,w){const{fileContent:g}=S[0][0];let{content:u,localChange:t,remoteChange:r}=S[0][1];if(t===0&&r===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),t!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),g&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(g.value.toString()))),await this.updateLocalFileContent(u||"{}",g,w),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),r!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(u||"{}"));f=await this.updateRemoteUserData(i,w?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}d?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:f}){const d=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(f,"tasks.json"),comparableResource:d}]}async resolveContent(f){if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f))return this.resolvePreviewContent(f);let d=await super.resolveContent(f);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(f)),d){const S=this.parseSyncData(d);if(S)switch(this.extUri.basename(f)){case"tasks.json":return I(S.content,this.logService)}}return null}toTasksSyncContent(f){return{tasks:f}}};v=de([Y(0,R.IUserDataSyncStoreService),Y(1,R.IUserDataSyncBackupStoreService),Y(2,R.IUserDataSyncLogService),Y(3,n.IConfigurationService),Y(4,R.IUserDataSyncEnablementService),Y(5,T.IFileService),Y(6,L.IEnvironmentService),Y(7,A.IStorageService),Y(8,P.ITelemetryService),Y(9,E.IUriIdentityService)],v),e.TasksSynchroniser=v;let y=class extends b.AbstractInitializer{constructor(f,d,S,w){super("tasks",d,S,f,w);this.uriIdentityService=w,this.tasksResource=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(this.environmentService.settingsResource),"tasks.json")}async doInitialize(f){const d=f.syncData?I(f.syncData.content,this.logService):null;if(!d){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(d)),await this.updateLastSyncUserData(f)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};y=de([Y(0,T.IFileService),Y(1,L.IEnvironmentService),Y(2,R.IUserDataSyncLogService),Y(3,E.IUriIdentityService)],y),e.TasksInitializer=y;function m(p,f,d){if(p===null&&f===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(p===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const S=d!==p,w=d!==f;return!S&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:S&&!w?{content:p,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!S?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:p,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[69],se([0,1,3,2,6,25]),function(X,e,D,n,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(E,b){super();this.userDataSyncStoreService=E,this.logService=b,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};A=de([Y(0,T.IUserDataSyncStoreService),Y(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(re[244],se([0,1,5,17,59,2,20,18,14,15,25]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends T.Disposable{constructor(y,m,p,f){super();this.environmentService=y,this.fileService=m,this.configurationService=p,this.logService=f,R.ALL_SYNC_RESOURCES.forEach(d=>this.cleanUpBackup(d))}async getAllRefs(y){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),p=await this.fileService.resolve(m);return p.children?p.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort().reverse().map(d=>({ref:d.name,created:this.getCreationTime(d)})):[]}async resolveContent(y,m){if(!m){const p=await this.getAllRefs(y);p.length&&(m=p[p.length-1].ref)}if(m){const p=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,m);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(y,m){const p=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),f=(0,A.joinPath)(p,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,n.VSBuffer.fromString(m))}catch(d){this.logService.error(d)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const m=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(m))return}catch{return}const p=await this.fileService.resolve(m);if(p.children){const f=p.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=f.filter(g=>Date.now()-this.getCreationTime(g)>d);const w=f.length-S.length;w<10&&(S=S.slice(10-w)),await D.Promises.settled(S.map(async g=>{this.logService.info("Deleting from backup",g.resource.path),await this.fileService.del(g.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};I=de([Y(0,E.IEnvironmentService),Y(1,b.IFileService),Y(2,P.IConfigurationService),Y(3,R.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(re[245],se([0,1,3,2,4,14,21,22,25]),function(X,e,D,n,L,T,A,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let R=class extends n.Disposable{constructor(v,y,m,p){super();this.storageService=v,this.telemetryService=y,this.environmentService=m,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(f=>this.onDidStorageChange(f)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:v}),this.storageService.store(b,v,0,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,E.getEnablementKey)(v),0,!0)}setResourceEnablement(v,y){if(this.isResourceEnabled(v)!==y){const m=(0,E.getEnablementKey)(v);this.storeResourceEnablement(m,y)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,y){this.storageService.store(v,y,0,L.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==0)return;if(b===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=E.ALL_SYNC_RESOURCES.filter(m=>(0,E.getEnablementKey)(m)===v.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};R=de([Y(0,A.IStorageService),Y(1,P.ITelemetryService),Y(2,T.IEnvironmentService),Y(3,E.IUserDataSyncStoreManagementService)],R),e.UserDataSyncEnablementService=R}),define(re[246],se([0,1,2,7]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(v){this.service=v}listen(v,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(v,y,m){switch(y){case"triggerSync":return this.service.triggerSync(m[0],m[1],m[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(m[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class T{constructor(v){this.service=v}listen(v,y){throw new Error(`Event not found: ${y}`)}call(v,y,m){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(m[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(m[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(v,y,m){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(m[0],m[1]);case"setEnablements":return this.service.setEnablements(m)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class E{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(v,y,m){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(m)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class b{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(v,y,m){switch(y){case"switch":return this.service.switch(m[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class R extends D.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:n.URI.revive(v.url),type:v.type,defaultUrl:n.URI.revive(v.defaultUrl),insidersUrl:n.URI.revive(v.insidersUrl),stableUrl:n.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(re[247],se([0,1,14,8]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};L=de([Y(0,n.ILoggerService),Y(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(re[70],se([0,1,3,2,4,26,158,14,15,6,24,46,21,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const m="sync.currentMachineName",p="Safari",f="Chrome",d="Edge",S="Firefox",w="Android";function g(r){switch(r){case p:case f:case d:case S:case w:case(0,L.PlatformToString)(0):return!0}return!1}e.isWebPlatform=g;function u(){return L.isSafari?p:L.isChrome?f:L.isEdge?d:L.isFirefox?S:L.isAndroid?w:(0,L.PlatformToString)(L.isWeb?0:L.platform)}let t=class et extends n.Disposable{constructor(i,a,c,s,o,l){super();this.storageService=c,this.userDataSyncStoreService=s,this.logService=o,this.productService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(i,a,c)}async getMachines(i){const a=await this.currentMachineIdPromise;return(await this.readMachinesData(i)).machines.map(s=>({...s,isCurrent:s.id===a}))}async addCurrentMachine(i){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(i);c.machines.some(({id:s})=>s===a)||(c.machines.push({id:a,name:this.computeCurrentMachineName(c.machines),platform:u()}),await this.writeMachinesData(c))}async removeCurrentMachine(i){const a=await this.currentMachineIdPromise,c=await this.readMachinesData(i),s=c.machines.filter(({id:o})=>o!==a);s.length!==c.machines.length&&(c.machines=s,await this.writeMachinesData(c))}async renameMachine(i,a,c){const s=await this.readMachinesData(c),o=s.machines.find(({id:l})=>l===i);if(o){o.name=a,await this.writeMachinesData(s);const l=await this.currentMachineIdPromise;i===l&&this.storageService.store(m,a,0,1)}}async setEnablements(i){const a=await this.readMachinesData();for(const[c,s]of i){const o=a.machines.find(l=>l.id===c);o&&(o.disabled=s?void 0:!0)}await this.writeMachinesData(a)}computeCurrentMachineName(i){const a=this.storageService.get(m,0);if(a)return a;const c=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,s=new RegExp(`${(0,T.escapeRegExpCharacters)(c)}\\s#(\\d+)`);let o=0;for(const l of i){const h=s.exec(l.name),C=h?parseInt(h[1]):0;o=C>o?C:o}return`${c} #${o+1}`}async readMachinesData(i){this.userData=await this.readUserData(i);const a=this.parse(this.userData);if(a.version!==et.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return a}async writeMachinesData(i){const a=JSON.stringify(i),c=await this.userDataSyncStoreService.write(et.RESOURCE,a,this.userData?.ref||null);this.userData={ref:c,content:a},this._onDidChange.fire()}async readUserData(i){if(this.userData){const a=i&&i.latest?i.latest[et.RESOURCE]:void 0;if(this.userData.ref===a)return this.userData;if(a===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(a){this.logService.error(a)}return{version:et.VERSION,machines:[]}}};t.VERSION=1,t.RESOURCE="machines",t=de([Y(0,P.IEnvironmentService),Y(1,E.IFileService),Y(2,v.IStorageService),Y(3,y.IUserDataSyncStoreService),Y(4,y.IUserDataSyncLogService),Y(5,R.IProductService)],t),e.UserDataSyncMachinesService=t}),define(re[248],se([0,1,5,59,37,9,3,2,4,20,7,156,24,21,22,25,69,70]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const S="sync.disableMachineEventually",w="sync.sessionId",g="sync.storeUrl",u="sync.productQuality";let t=class extends P.Disposable{constructor(a,c,s,o,l,h,C,M,O,U){super();this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=o,this.userDataSyncService=l,this.logService=h,this.userDataSyncAccountService=C,this.telemetryService=M,this.userDataSyncMachinesService=O,this.storageService=U,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=a.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(c.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,c.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=c.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(C.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const a=this.storageService.get(g,0);return a?R.URI.parse(a):void 0}set syncUrl(a){a?this.storageService.store(g,a.toString(),0,1):this.storageService.remove(g,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(a){a?this.storageService.store(u,a,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:a,message:c}=this.isAutoSyncEnabled();a?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(c&&this.logService.info(c),this.autoSync.clear()):c&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(c))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(a,c,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(w,0),a?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(o){if(c)this.logService.error(o),this.updateEnablement(!1);else throw o}}updateEnablement(a){this.userDataSyncEnablementService.isEnabled()!==a&&(this.userDataSyncEnablementService.setEnablement(a),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(a){if(!a){this.successiveFailures=0;return}const c=p.UserDataSyncError.toUserDataSyncError(a);c instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:c.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),c.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):c.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):c.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):c.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):c.code==="UpgradeRequired"||c.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):c.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with newer version than of client. Requires client upgrade.`)):c.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${c.resource} content with older version than of client. Requires server reset.`)):c.code==="ServiceChanged"||c.code==="DefaultServiceChanged"?E.isWeb&&c.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(c),this.successiveFailures++),this._onError.fire(c)}async disableMachineEventually(){this.storageService.store(S,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(S,0,!1)}stopDisableMachineEventually(){this.storageService.remove(S,0)}async triggerSync(a,c,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(c&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...a),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};t=de([Y(0,v.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncEnablementService),Y(4,p.IUserDataSyncService),Y(5,p.IUserDataSyncLogService),Y(6,f.IUserDataSyncAccountService),Y(7,m.ITelemetryService),Y(8,d.IUserDataSyncMachinesService),Y(9,y.IStorageService)],t),e.UserDataAutoSyncService=t;class r extends P.Disposable{constructor(a,c,s,o,l,h,C,M){super();this.lastSyncUrl=a,this.interval=c,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncService=l,this.userDataSyncMachinesService=h,this.logService=C,this.storageService=M,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(a,c){const s=(0,D.createCancelablePromise)(async o=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,T.isCancellationError)(l))return}return this.doSync(a,c,o)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const a=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),c=this.userDataSyncStoreManagementService.userDataSyncStore;return!!c&&!!a&&(!(0,b.isEqual)(c.defaultUrl,a.defaultUrl)||!(0,b.isEqual)(c.insidersUrl,a.insidersUrl)||!(0,b.isEqual)(c.stableUrl,a.stableUrl))}async doSync(a,c,s){this.logService.info(`Auto Sync: Triggered by ${a}`),this._onDidStartSync.fire();let o;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,c),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const l=this.storageService.get(w,0);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const h=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const C=h.find(M=>M.isCurrent);if(C?.disabled)throw new p.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new p.UserDataAutoSyncError((0,L.toErrorMessage)(M),M instanceof p.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(w,this.manifest.session,0,1),s.isCancellationRequested)return;C||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),o=l}this._onDidFinishSync.fire(o)}register(a){return super._register(a)}}r.INTERVAL_SYNCING="Interval"}),define(re[249],se([0,1,16,5,37,3,2,20,13,30,18,29,6,21,22,236,238,239,241,242,243,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const t="sync.lastSyncTime";let r=class extends A.Disposable{constructor(o,l,h,C,M,O,U,k){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=l,this.instantiationService=h,this.configurationService=C,this.logService=M,this.telemetryService=O,this.storageService=U,this.userDataSyncEnablementService=k,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(t,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,l){this.checkEnablement();const h=(0,b.generateUuid)();try{const k=(0,u.createSyncHeaders)(h);l&&(k["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,k)}catch(k){const F=u.UserDataSyncError.toUserDataSyncError(k);throw this.reportUserDataSyncError(F,h),F}let C=!1;const M=this,O=this.getEnabledSynchronizers();let U;return{manifest:o,async run(){if(C)throw new Error("Can run a task only once");return U=(0,n.createCancelablePromise)(k=>M.sync(O,o,h,k)),U.finally(()=>U=void 0)},async stop(){if(U&&U.cancel(),M.status!=="idle")return M.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,b.generateUuid)(),l=(0,u.createSyncHeaders)(o);let h;try{h=await this.userDataSyncStoreService.manifest(null,l)}catch(O){const U=u.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(U,o),U}await this.resetLocal();const C=this.getEnabledSynchronizers(),M=async()=>{await this.stop(C),await this.resetLocal()};return new i(o,h,l,C,M,this.configurationService,this.logService)}async sync(o,l,h,C){if(C.isCancellationRequested||!o.length)return;const M=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,u.createSyncHeaders)(h);for(const U of o){if(C.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(U.resource))return;try{await U.sync(l,O)}catch(k){let F=!1;if(k instanceof u.UserDataSyncError)switch(k.code){case"TooLarge":k=new u.UserDataSyncError(k.message,k.code,U.resource),F=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":F=!0;break}const _=u.UserDataSyncError.toUserDataSyncError(k);if(this.reportUserDataSyncError(_,h),F)throw _;this.logService.error(k),this.logService.error(`${U.resource}: ${(0,L.toErrorMessage)(k)}`),this._syncErrors.push([U.resource,_])}}this.logService.info(`Sync done. Took ${new Date().getTime()-M}ms`),this.updateLastSyncTime()}catch(O){const U=u.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(U,h),U}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const l of o)try{l.status!=="idle"&&await l.stop()}catch(h){this.logService.error(h)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(o))return!0})}async accept(o,l,h,C){this.checkEnablement(),await this.performSynchronizerAction(async M=>{if(M.resource===o)return await M.accept(l,h),C&&await M.apply(!1,(0,u.createSyncHeaders)((0,b.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async l=>{const h=await l.resolveContent(o);if(h)return h})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async h=>{if(h.resource===o)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async h=>{if(h.resource===o)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,l){return await this.performSynchronizerAction(async C=>{if(C.resource===o)return C.getAssociatedResources(l)})||[]}async getMachineId(o,l){return await this.performSynchronizerAction(async C=>{if(C.resource===o)return await C.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(t,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(l){this.logService.error(`${o.resource}: ${(0,L.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const l=new A.DisposableStore;try{const h=this.synchronizers.value||l.add(this.instantiationService.createInstance(a,()=>{},()=>{},()=>{})),C=[...h.enabled,...h.disabled.map(M=>l.add(h.createSynchronizer(M)))];for(const M of C){const O=await o(M);if(!(0,E.isUndefined)(O))return O}return null}finally{l.dispose()}}setStatus(o){const l=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const l=this.computeStatus(o);this.setStatus(l)}updateConflicts(o){const l=this.computeConflicts(o);(0,D.equals)(this._conflicts,l,([h,C],[M,O])=>h===h&&(0,D.equals)(C,O,(U,k)=>(0,P.isEqual)(U.previewResource,k.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(l))}computeConflicts(o){return o.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(c)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(l=>l.status==="hasConflicts")?"hasConflicts":o.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(t,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,l){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof u.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof u.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(a,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([Y(0,u.IUserDataSyncStoreService),Y(1,u.IUserDataSyncStoreManagementService),Y(2,v.IInstantiationService),Y(3,R.IConfigurationService),Y(4,u.IUserDataSyncLogService),Y(5,m.ITelemetryService),Y(6,y.IStorageService),Y(7,u.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class i extends A.Disposable{constructor(o,l,h,C,M,O,U){super();this.id=o,this.manifest=l,this.syncHeaders=h,this.synchronisers=C,this.onStop=M,this.configurationService=O,this.logService=U,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,l){try{return await this.performAction(o,h=>h.accept(o,l))}catch(h){throw this.logService.error(h),h}}async merge(o){try{return o?await this.performAction(o,l=>l.merge(o)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(o){try{return await this.performAction(o,l=>l.discard(o))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,l]of this.previews)for(const h of l.resourcePreviews)h.mergeState==="conflict"&&o.push(h.previewResource);for(const l of o)await this.discard(l);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[l,h]of this.previews){this.synchronizingResources.push([l,h.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(O=>O.resource===l);for(const O of h.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await C.merge(O.previewResource);const M=await C.apply(!1,this.syncHeaders);M&&o.push(this.toSyncResourcePreview(C.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(C=>C.resource===o);for(const C of l.resourcePreviews)await h.accept(C.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(C=>C.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(C=>C.resource===o);for(const C of l.resourcePreviews)await h.accept(C.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(C=>C[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:H,previewResource:ne,remoteResource:K})=>(0,P.isEqual)(o,H)||(0,P.isEqual)(o,ne)||(0,P.isEqual)(o,K)));if(h===-1)return this.previews;const[C,M]=this.previews[h],O=M.resourcePreviews.find(({localResource:$,remoteResource:H,previewResource:ne})=>(0,P.isEqual)($,o)||(0,P.isEqual)(H,o)||(0,P.isEqual)(ne,o));if(!O)return this.previews;let U=this.synchronizingResources.find($=>$[0]===C);U||(U=[C,[]],this.synchronizingResources.push(U)),U[1].some($=>(0,P.isEqual)($,O.localResource))||(U[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const k=this.synchronisers.find($=>$.resource===this.previews[h][0]),F=await l(k);F?this.previews.splice(h,1,this.toSyncResourcePreview(k.resource,F)):this.previews.splice(h,1);const _=this.synchronizingResources.findIndex($=>$[0]===C);return this.synchronizingResources[_][1].splice(U[1].findIndex($=>(0,P.isEqual)($,O.localResource)),1),U[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[l,h]of this.previews){this.synchronizingResources.push([l,h.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const C=this.synchronisers.find(O=>O.resource===l);let M=h;for(const O of h.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(M=await C.merge(O.previewResource));M&&o.push(this.toSyncResourcePreview(C.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const l=[],h=await this.getUserDataSyncConfiguration();for(const C of this.synchronisers){if(o.isCancellationRequested)return[];const M=await C.preview(this.manifest,h,this.syncHeaders);M&&l.push(this.toSyncResourcePreview(C.resource,M))}return l}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(h=>h instanceof S.SettingsSynchroniser);if(l){const h=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...h}}return o}toSyncResourcePreview(o,l){return[o,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(c)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let a=class extends A.Disposable{constructor(o,l,h,C,M,O,U){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=l,this.onDidChangeLocal=h,this.userDataSyncEnablementService=C,this.instantiationService=M,this.extensionGalleryService=O,this.logService=U,this._enabled=[],this._register(C.onDidChangeResourceEnablement(([k,F])=>this.onDidChangeResourceEnablement(k,F))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,k])=>k.dispose())));for(const k of u.ALL_SYNC_RESOURCES)C.isResourceEnabled(k)&&this.registerSynchronizer(k)}get enabled(){return this._enabled.sort((o,l)=>o[1]-l[1]).map(([o])=>o)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,l){l?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([M])=>M.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,h=l.add(this.createSynchronizer(o));l.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const C=this.getOrder(o);this._enabled.push([h,C,l])}deRegisterSynchronizer(o){const l=this._enabled.findIndex(([h])=>h.resource===o);if(l!==-1){const h=this._enabled.splice(l,1);for(const[C,,M]of h){if(C.status!=="idle"){const O=C.conflicts.length>0;C.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}M.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(S.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(w.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(g.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(f.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(p.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};a=de([Y(3,u.IUserDataSyncEnablementService),Y(4,v.IInstantiationService),Y(5,I.IExtensionGalleryService),Y(6,u.IUserDataSyncLogService)],a);function c(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(re[250],se([0,1,3,2,13,7,25]),function(X,e,D,n,L,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(I,v){this.service=I,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(I,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(I,v,y){try{return await this._call(I,v,y)}catch(m){throw this.logService.error(m),m}}async _call(I,v,y){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],T.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:T.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:T.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const m=v.substring("manualSync/".length),p=y[0],f=this.getManualSyncTask(p);switch(y=y.slice(1),m){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(y[0]),y[1]);case"merge":return f.merge(T.URI.revive(y[0]));case"discard":return f.discard(T.URI.revive(y[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(I){const v=this.manualSyncTasks.get(this.createKey(I));if(!v)throw new Error(`Manual sync taks not found: ${I}`);return v.manualSyncTask}async createManualSyncTask(){const I=new n.DisposableStore,v=I.add(await this.service.createManualSyncTask());return I.add(v.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:y}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:I}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(I){I.dispose();const v=this.createKey(I.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=P;class E extends n.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,y,m){return I.call(v,y,m).then(null,p=>{throw A.UserDataSyncError.toUserDataSyncError(p)})},listen(v,y){return I.listen(v,y)}},this.channel.call("_getInitialData").then(([v,y,m])=>{this.updateStatus(v),this.updateConflicts(y),m&&this.updateLastSyncTime(m),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([y,m])=>[y,A.UserDataSyncError.toUserDataSyncError(m)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:v,status:y}=await this.channel.call("createManualSyncTask"),m=this,p=new b(I,v,y,{async call(f,d,S){return m.channel.call(`manualSync/${f}`,[I,...(0,L.isArray)(d)?d:[d]],S)},listen(f,d){return D.Event.map(D.Event.filter(m.channel.listen(`manualSync/${f}`,d),S=>!p.isDiposed()&&S.manualSyncTaskId===I),S=>S.data)}});return p}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,v,y,m){return this.channel.call("accept",[I,v,y,m])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:y,uri:m})=>({created:y,uri:T.URI.revive(m)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:y,uri:m})=>({created:y,uri:T.URI.revive(m)}))}async getAssociatedResources(I,v){return(await this.channel.call("getAssociatedResources",[I,v])).map(({resource:m,comparableResource:p})=>({resource:T.URI.revive(m),comparableResource:T.URI.revive(p)}))}async getMachineId(I,v){return this.channel.call("getMachineId",[I,v])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([v,y])=>[v,y.map(m=>({...m,localResource:T.URI.revive(m.localResource),remoteResource:T.URI.revive(m.remoteResource),previewResource:T.URI.revive(m.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=E;class b extends n.Disposable{constructor(I,v,y,m){super();this.id=I,this.manifest=v,this._disposed=!1,this._status=y;const p=this;this.channel={async call(f,d,S){try{const w=await m.call(f,d,S);return p.isDiposed()||(p._status=await m.call("_getStatus")),w}catch(w){throw A.UserDataSyncError.toUserDataSyncError(w)}},listen(f,d){return m.listen(f,d)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,v){const y=await this.channel.call("accept",[I,v]);return this.deserializePreviews(y)}async merge(I){const v=await this.channel.call("merge",[I]);return this.deserializePreviews(v)}async discard(I){const v=await this.channel.call("discard",[I]);return this.deserializePreviews(v)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([v,y])=>[v,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(m=>({...m,localResource:T.URI.revive(m.localResource),remoteResource:T.URI.revive(m.remoteResource),previewResource:T.URI.revive(m.previewResource),acceptedResource:T.URI.revive(m.acceptedResource)}))}])}}}),define(re[251],se([0,1,5,23,9,3,2,110,4,20,13,7,30,18,14,15,24,43,46,21,25]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,c=1e3*60*5;let s=class extends A.Disposable{constructor(O,U,k){super();this.productService=O,this.configurationService=U,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(k.onDidChangeValue,F=>F.key===g.SYNC_SERVICE_URL_TYPE&&F.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(g.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(g.SYNC_SERVICE_URL_TYPE,O,0,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[g.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(g.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,U){O=E.isWeb&&O?.web?{...O,...O.web}:O;const k={...O||{},...U||{}};if(k&&(0,R.isString)(k.url)&&(0,R.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(F=>(0,R.isArray)(k.authenticationProviders[F].scopes))){const F=k,_=!!F.canSwitch&&!U?.url,$=F.url===F.insidersUrl?"insiders":"stable",H=(_?this.userDataSyncStoreType:void 0)||$,ne=U?.url||(H==="insiders"?F.insidersUrl:H==="stable"?F.stableUrl:F.url);return{url:I.URI.parse(ne),type:H,defaultType:$,defaultUrl:I.URI.parse(F.url),stableUrl:I.URI.parse(F.stableUrl),insidersUrl:I.URI.parse(F.insidersUrl),canSwitch:_,authenticationProviders:Object.keys(F.authenticationProviders).reduce((K,N)=>(K.push({id:N,scopes:F.authenticationProviders[N].scopes}),K),[])}}}};s=de([Y(0,f.IProductService),Y(1,y.IConfigurationService),Y(2,w.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let o=class extends s{constructor(O,U,k){super(O,U,k);const F=this.storageService.get(u,0);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const _=this.productService[g.CONFIGURATION_SYNC_STORE_KEY];_?this.storageService.store(u,JSON.stringify(_),0,1):this.storageService.remove(u,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};o=de([Y(0,f.IProductService),Y(1,y.IConfigurationService),Y(2,w.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let l=class extends A.Disposable{constructor(O,U,k,F,_,$,H){super();this.requestService=k,this.logService=F,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,S.getServiceMachineId)(_,$,H).then(ne=>{const K={"X-Client-Name":`${U.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(K["X-Client-Commit"]=U.commit),K}),this.session=new C(a,c,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,U){this.authToken={token:O,type:U}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),k={},F=await this.request(U.toString(),{type:"GET",headers:k},[],n.CancellationToken.None);return(await(0,d.asJson)(F)||[]).map(({url:$,created:H})=>({ref:(0,b.relativePath)(U,U.with({path:$})),created:H*1e3}))}async resolveContent(O,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,U).toString(),F={};F["Cache-Control"]="no-cache";const _=await this.request(k,{type:"GET",headers:F},[],n.CancellationToken.None);return await(0,d.asTextOrError)(_)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),k={};await this.request(U,{type:"DELETE",headers:k},[],n.CancellationToken.None)}async read(O,U,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();k={...k},k["Cache-Control"]="no-cache",U&&(k["If-None-Match"]=U.ref);const _=await this.request(F,{type:"GET",headers:k},[304],n.CancellationToken.None);let $=null;if(_.res.statusCode===304&&($=U),$===null){const H=_.res.headers.etag;if(!H)throw new g.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",_.res.statusCode,_.res.headers[g.HEADER_OPERATION_ID]);const ne=await(0,d.asTextOrError)(_);if(!ne&&_.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",F,"EmptyResponse",_.res.statusCode,_.res.headers[g.HEADER_OPERATION_ID]);$={ref:H,content:ne}}return $}async write(O,U,k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();F={...F},F["Content-Type"]=P.Mimes.text,k&&(F["If-Match"]=k);const $=await this.request(_,{type:"POST",data:U,headers:F},[],n.CancellationToken.None),H=$.res.headers.etag;if(!H)throw new g.UserDataSyncStoreError("Server did not return the ref",_,"NoRef",$.res.statusCode,$.res.headers[g.HEADER_OPERATION_ID]);return H}async manifest(O,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",O&&(U["If-None-Match"]=O.ref);const F=await this.request(k,{type:"GET",headers:U},[304],n.CancellationToken.None);let _=null;if(F.res.statusCode===304&&(_=O),!_){const H=F.res.headers.etag;if(!H)throw new g.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",F.res.statusCode,F.res.headers[g.HEADER_OPERATION_ID]);const ne=await(0,d.asTextOrError)(F);if(!ne&&F.res.statusCode===304)throw new g.UserDataSyncStoreError("Empty response",k,"EmptyResponse",F.res.statusCode,F.res.headers[g.HEADER_OPERATION_ID]);ne&&(_={...JSON.parse(ne),ref:H})}const $=this.storageService.get(r,0);return $&&_&&$!==_.session&&this.clearSession(),_===null&&$&&this.clearSession(),_&&this.storageService.store(r,_.session,0,1),_}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:U},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,U,k,F){if(!this.authToken)throw new g.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const _=await this.commonHeadersPromise;U.headers={...U.headers||{},..._,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:O,type:U.type,headers:{...U.headers,authorization:void 0}});let $;try{$=await this.session.request(O,U,F)}catch(N){if(!(N instanceof g.UserDataSyncStoreError)){let W="RequestFailed";const x=(0,L.getErrorMessage)(N).toLowerCase();x.includes("xhr timeout")?W="RequestTimeout":x.includes("protocol")&&x.includes("not supported")?W="RequestProtocolNotSupported":x.includes("request path contains unescaped characters")?W="RequestPathNotEscaped":x.includes("headers must be an object")?W="RequestHeadersNotObject":(0,L.isCancellationError)(N)&&(W="RequestCanceled"),N=new g.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,W,void 0,void 0)}throw this.logService.info("Request failed",O),N}const H=$.res.headers[g.HEADER_OPERATION_ID],ne={url:O,status:$.res.statusCode,"execution-id":U.headers[g.HEADER_EXECUTION_ID],"operation-id":H},K=(0,d.isSuccess)($)||$.res.statusCode&&k.indexOf($.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",ne):this.logService.info("Request failed",ne),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new g.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",$.res.statusCode,H);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",$.res.statusCode,H);if($.res.statusCode===410)throw new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",$.res.statusCode,H);if($.res.statusCode===412)throw new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",$.res.statusCode,H);if($.res.statusCode===413)throw new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",$.res.statusCode,H);if($.res.statusCode===426)throw new g.UserDataSyncStoreError(`${U.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",$.res.statusCode,H);if($.res.statusCode===429){const N=$.res.headers["retry-after"];throw N?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(N)*1e3)),new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",$.res.statusCode,H)):new g.UserDataSyncStoreError(`${U.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",$.res.statusCode,H)}if(!K)throw new g.UserDataSyncStoreError("Server returned "+$.res.statusCode,O,"Unknown",$.res.statusCode,H);return $}addSessionHeaders(O){let U=this.storageService.get(i,0);U===void 0&&(U=(0,v.generateUuid)(),this.storageService.store(i,U,0,1)),O["X-Machine-Session-Id"]=U;const k=this.storageService.get(r,0);k!==void 0&&(O["X-User-Session-Id"]=k)}};l=de([Y(1,f.IProductService),Y(2,d.IRequestService),Y(3,g.IUserDataSyncLogService),Y(4,m.IEnvironmentService),Y(5,p.IFileService),Y(6,w.IStorageService)],l),e.UserDataSyncStoreClient=l;let h=class extends l{constructor(O,U,k,F,_,$,H){super(O.userDataSyncStore?.url,U,k,F,_,$,H);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};h=de([Y(0,g.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,d.IRequestService),Y(3,g.IUserDataSyncLogService),Y(4,m.IEnvironmentService),Y(5,p.IFileService),Y(6,w.IStorageService)],h),e.UserDataSyncStoreService=h;class C{constructor(O,U,k,F){this.limit=O,this.interval=U,this.requestService=k,this.logService=F,this.requests=[],this.startTime=void 0}request(O,U,k){if(this.isExpired()&&this.reset(),U.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new g.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(U,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=C}),define(re[252],se([0,1,3,63,24,21,22,248,25,69,70]),function(X,e,D,n,L,T,A,P,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends P.UserDataAutoSyncService{constructor(y,m,p,f,d,S,w,g,u,t,r){super(y,m,p,f,d,w,g,u,t,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(S.onDidFocusWindow,()=>"windowFocus"),D.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(i,a)=>i?[...i,a]:[a],1e3)(i=>this.triggerSync(i,!0,!1)))}};I=de([Y(0,L.IProductService),Y(1,E.IUserDataSyncStoreManagementService),Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncEnablementService),Y(4,E.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,E.IUserDataSyncLogService),Y(7,b.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,R.IUserDataSyncMachinesService),Y(10,T.IStorageService)],I),e.UserDataAutoSyncService=I}),define(re[253],se([0,1,5,3,2]),function(X,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:E,getActiveWindowId:b}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(P,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(re[106],se([0,1,51,5,10,13,27,132,265,266]),function(X,e,D,n,L,T,A,P,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class R extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=R;function I(u){const t=u.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function v(u){if(u instanceof R)return u;let t;return/end of central directory record signature not found/.test(u.message)&&(t="CorruptZip"),new R(t,u)}function y(u,t,r,i,a,c){const s=L.dirname(t),o=L.join(i,s);if(!o.startsWith(i))return Promise.reject(new Error(P.localize(0,null,t)));const l=L.join(i,t);let h;return c.onCancellationRequested(()=>{h&&h.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((C,M)=>{if(!c.isCancellationRequested)try{h=(0,D.createWriteStream)(l,{mode:r}),h.once("close",()=>C()),h.once("error",M),u.once("error",M),u.pipe(h)}catch(O){M(O)}}))}function m(u,t,r,i){let a=(0,n.createCancelablePromise)(()=>Promise.resolve()),c=0;return i.onCancellationRequested(()=>{a.cancel(),u.close()}),new Promise((s,o)=>{const l=new n.Sequencer,h=C=>{C.isCancellationRequested||(c++,u.readEntry())};u.once("error",o),u.once("close",()=>a.then(()=>{i.isCancellationRequested||u.entryCount===c?s():o(new R("Incomplete",new Error(P.localize(1,null,c,u.entryCount))))},o)),u.readEntry(),u.on("entry",C=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(C.fileName)){h(i);return}const M=C.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const k=L.join(t,M);a=(0,n.createCancelablePromise)(F=>A.Promises.mkdir(k,{recursive:!0}).then(()=>h(F)).then(void 0,o));return}const O=f(u,C),U=I(C);a=(0,n.createCancelablePromise)(k=>l.queue(()=>O.then(F=>y(F,M,U,t,r,k).then(()=>h(k)))).then(null,o))})})}function p(u,t=!1){return new Promise((r,i)=>{(0,E.open)(u,t?{lazyEntries:!0}:void 0,(a,c)=>{a?i(v(a)):r((0,T.assertIsDefined)(c))})})}function f(u,t){return new Promise((r,i)=>{u.openReadStream(t,(a,c)=>{a?i(v(a)):r((0,T.assertIsDefined)(c))})})}function d(u,t){return new Promise((r,i)=>{const a=new b.ZipFile;t.forEach(s=>{s.contents?a.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&a.addFile(s.localPath,s.path)}),a.end();const c=(0,D.createWriteStream)(u);a.outputStream.pipe(c),a.outputStream.once("error",i),c.once("error",i),c.once("finish",()=>r(u))})}e.zip=d;function S(u,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let c=p(u,!0);return r.overwrite&&(c=c.then(s=>A.Promises.rm(t).then(()=>s))),c.then(s=>m(s,t,{sourcePathRegex:a},i))}e.extract=S;function w(u,t){return p(u).then(r=>new Promise((i,a)=>{r.on("entry",c=>{c.fileName===t&&f(r,c).then(s=>i(s),s=>a(s))}),r.once("close",()=>a(new Error(P.localize(2,null,t))))}))}function g(u,t){return w(u,t).then(r=>new Promise((i,a)=>{const c=[];r.once("error",a),r.on("data",s=>c.push(s)),r.on("end",()=>i(Buffer.concat(c)))}))}e.buffer=g}),define(re[254],se([0,1,106,141]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(T){return(0,D.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(re[255],se([0,1,5,37,9,2,19,10,4,20,52,13,7,30,27,106,140,89,14,215,29,31,66,195,181,254,196,230,61,15,6,8,24,22,32]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u,t,r,i,a,c,s,o,l,h,C,M,O,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let k=class extends w.AbstractExtensionManagementService{constructor(N,W,x,J,G,Q,Z,q,B){super(N,W,x,q);this.environmentService=J,this.downloadService=G,this.fileService=Z;const j=this._register(Q.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(Q.createInstance(F,V=>j.postUninstall(V))),this.manifestCache=this._register(new c.ExtensionsManifestCache(J,this)),this.extensionsDownloader=this._register(Q.createInstance(r.ExtensionsDownloader));const z=this._register(new s.ExtensionsWatcher(this,Z,J,x,B));this._register(z.onDidChangeExtensionsByAnotherSource(({added:V,removed:ee})=>{V.length&&this._onDidInstallExtensions.fire(V.map(ie=>({identifier:ie.identifier,operation:1,local:ie}))),ee.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(N){this.logService.trace("ExtensionManagementService#zip",N.identifier.id);const W=await this.collectFiles(N),x=await(0,p.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)()).fsPath,W);return v.URI.file(x)}async unzip(N){return this.logService.trace("ExtensionManagementService#unzip",N.toString()),(await this.install(N)).identifier}async getManifest(N){const W=await this.downloadVsix(N),x=P.resolve(W.fsPath);return(0,a.getManifest)(x)}getInstalled(N=null){return this.extensionsScanner.scanExtensions(N)}async install(N,W={}){this.logService.trace("ExtensionManagementService#install",N.toString());const x=await this.downloadVsix(N),J=await(0,a.getManifest)(P.resolve(x.fsPath));if(J.engines&&J.engines.vscode&&!(0,o.isEngineValid)(J.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,u.getGalleryExtensionId)(J.publisher,J.name),this.productService.version));return this.installExtension(J,x,W)}async updateMetadata(N,W){this.logService.trace("ExtensionManagementService#updateMetadata",N.identifier.id);const x={...W};return W.isPreReleaseVersion&&(x.preRelease=!0),N=await this.extensionsScanner.updateMetadata(N,x),this.manifestCache.invalidate(),N}async updateExtensionScope(N,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",N.identifier.id),N=await this.extensionsScanner.updateMetadata(N,{isMachineScoped:W}),this.manifestCache.invalidate(),N}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(N){if(N.scheme===A.Schemas.file)return N;const W=(0,b.joinPath)(this.environmentService.tmpDir,(0,y.generateUuid)());return await this.downloadService.download(N,W),W}createInstallExtensionTask(N,W,x){return v.URI.isUri(W)?new H(N,W,x,this.galleryService,this.extensionsScanner,this.logService):new $(W,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(N,W){return new ne(N,W,this.extensionsScanner)}async collectFiles(N){const W=async J=>{let G=await m.Promises.readdir(J);G=G.map(q=>P.join(J,q));const Q=await Promise.all(G.map(q=>m.Promises.stat(q)));let Z=Promise.resolve([]);return Q.forEach((q,B)=>{const j=G[B];q.isFile()&&(Z=Z.then(z=>[...z,j])),q.isDirectory()&&(Z=Z.then(z=>W(j).then(V=>[...z,...V])))}),Z};return(await W(N.location.fsPath)).map(J=>({path:`extension/${P.relative(N.location.fsPath,J)}`,localPath:J}))}};k=de([Y(0,g.IExtensionGalleryService),Y(1,O.ITelemetryService),Y(2,C.ILogService),Y(3,S.INativeEnvironmentService),Y(4,d.IDownloadService),Y(5,h.IInstantiationService),Y(6,l.IFileService),Y(7,M.IProductService),Y(8,U.IUriIdentityService)],k),e.ExtensionManagementService=k;let F=class extends T.Disposable{constructor(N,W,x,J){super();this.beforeRemovingExtension=N,this.fileService=W,this.extensionsScannerService=x,this.logService=J,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(N){const W={includeInvalid:!0};let x=[];return N===null||N===0?x.push(...await this.extensionsScannerService.scanAllExtensions(W)):N===1&&x.push(...await this.extensionsScannerService.scanUserExtensions(W)),x=N!==null?x.filter(J=>J.type===N):x,Promise.all(x.map(J=>this.toLocalExtension(J)))}async scanUserExtensions(N){const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!N,includeInvalid:!0});return Promise.all(W.map(x=>this.toLocalExtension(x)))}async extractUserExtension(N,W,x,J){const G=N.toString(),Q=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),Z=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,G);try{await m.Promises.rm(Z)}catch{throw new g.ExtensionManagementError(f.localize(1,null,Z,N.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(N,W,Q,J),await this.extensionsScannerService.updateMetadata(v.URI.file(Q),{...x,installedTimestamp:Date.now()});try{await this.rename(N,Q,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(q){try{await m.Promises.rm(Q)}catch{}if(q.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",N.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(q)}. Deleted from extracted location`,Q),q}return this.scanLocalExtension(v.URI.file(Z),1)}async updateMetadata(N,W){return await this.extensionsScannerService.updateMetadata(N.location,W),this.scanLocalExtension(N.location,N.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...N){const W=N.map(x=>u.ExtensionKey.create(x));await this.withUninstalledExtensions(x=>{W.forEach(J=>x[J.toString()]=!0)})}async setInstalled(N){await this.withUninstalledExtensions(J=>delete J[N.toString()]);const x=(await this.scanUserExtensions(!0)).find(J=>u.ExtensionKey.create(J).equals(N))||null;return x?this.updateMetadata(x,{installedTimestamp:Date.now()}):null}async removeExtension(N,W){this.logService.trace(`Deleting ${W} extension from disk`,N.identifier.id,N.location.fsPath),await m.Promises.rm(N.location.fsPath),this.logService.info("Deleted from disk",N.identifier.id,N.location.fsPath)}async removeUninstalledExtension(N){await this.removeExtension(N,"uninstalled"),await this.withUninstalledExtensions(W=>delete W[u.ExtensionKey.create(N).toString()])}async withUninstalledExtensions(N){return this.uninstalledFileLimiter.queue(async()=>{let W;try{W=await m.Promises.readFile(this.uninstalledPath,"utf8")}catch(J){if(J.code!=="ENOENT")throw J}let x={};if(W)try{x=JSON.parse(W)}catch{}return N&&(N(x),Object.keys(x).length?await m.Promises.writeFile(this.uninstalledPath,JSON.stringify(x)):await m.Promises.rm(this.uninstalledPath)),x})}async extractAtLocation(N,W,x,J){this.logService.trace(`Started extracting the extension from ${W} to ${x}`);try{await m.Promises.rm(x)}catch(G){throw new g.ExtensionManagementError(this.joinErrors(G).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(W,x,{sourcePath:"extension",overwrite:!0},J),this.logService.info(`Extracted extension to ${x}:`,N.id)}catch(G){try{await m.Promises.rm(x)}catch{}let Q=g.ExtensionManagementErrorCode.Extract;throw G instanceof p.ExtractError&&(G.type==="CorruptZip"?Q=g.ExtensionManagementErrorCode.CorruptZip:G.type==="Incomplete"&&(Q=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(G.message,Q)}}async rename(N,W,x,J){try{await m.Promises.rename(W,x)}catch(G){if(E.isWindows&&G&&G.code==="EPERM"&&Date.now()<J)return this.logService.info(`Failed renaming ${W} to ${x} with 'EPERM' error. Trying again...`,N.id),this.rename(N,W,x,J);throw new g.ExtensionManagementError(G.message||f.localize(2,null,W,x),G.code||g.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(N,W){const x=await this.extensionsScannerService.scanExistingExtension(N,W,{includeInvalid:!0});if(x)return this.toLocalExtension(x);throw new Error(f.localize(3,null,N.path))}async toLocalExtension(N){const W=await this.fileService.resolve(N.location);let x,J;return W.children&&(x=W.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,J=W.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:N.identifier,type:N.type,isBuiltin:N.isBuiltin||!!N.metadata?.isBuiltin,location:N.location,manifest:N.manifest,targetPlatform:N.targetPlatform,validations:N.validations,isValid:N.isValid,readmeUrl:x,changelogUrl:J,publisherDisplayName:N.metadata?.publisherDisplayName||null,publisherId:N.metadata?.publisherId||null,isMachineScoped:!!N.metadata?.isMachineScoped,isPreReleaseVersion:!!N.metadata?.isPreReleaseVersion,preRelease:!!N.metadata?.preRelease,installedTimestamp:N.metadata?.installedTimestamp,updated:!!N.metadata?.updated}}async removeUninstalledExtensions(){const N=await this.getUninstalledExtensions(),W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),x=new Set;for(const Q of W)N[u.ExtensionKey.create(Q).toString()]||x.add(Q.identifier.id.toLowerCase());const J=(0,u.groupByExtension)(W,Q=>Q.identifier);await D.Promises.settled(J.map(async Q=>{const Z=Q.sort((q,B)=>R.rcompare(q.manifest.version,B.manifest.version))[0];x.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const G=W.filter(Q=>N[u.ExtensionKey.create(Q).toString()]);await D.Promises.settled(G.map(Q=>this.removeUninstalledExtension(Q)))}async removeOutdatedExtensions(){const N=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=[],x=await this.extensionsScannerService.getTargetPlatform(),J=(0,u.groupByExtension)(N,G=>G.identifier);W.push(...J.map(G=>G.sort((Q,Z)=>{const q=R.rcompare(Q.manifest.version,Z.manifest.version);return q!==0?q:Q.targetPlatform===x?-1:1}).slice(1)).flat()),await D.Promises.settled(W.map(G=>this.removeExtension(G,"outdated")))}joinErrors(N){const W=Array.isArray(N)?N:[N];return W.length===1?W[0]instanceof Error?W[0]:new Error(W[0]):W.reduce((x,J)=>new Error(`${x.message}${x.message?",":""}${J instanceof Error?J.message:J}`),new Error(""))}};F=de([Y(1,l.IFileService),Y(2,t.IExtensionsScannerService),Y(3,C.ILogService)],F);class _ extends w.AbstractExtensionTask{constructor(N,W,x,J,G){super();this.identifier=N,this.source=W,this.options=x,this.extensionsScanner=J,this.logService=G,this._operation=2}get operation(){return(0,I.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(N,W){try{const x=await this.unsetUninstalledAndGetLocal(N.key);if(x)return N.metadata?this.extensionsScanner.updateMetadata(x,N.metadata):x}catch{throw E.isMacintosh?new g.ExtensionManagementError(f.localize(4,null),g.ExtensionManagementErrorCode.Internal):new g.ExtensionManagementError(f.localize(5,null),g.ExtensionManagementErrorCode.Internal)}return this.extract(N,W)}async unsetUninstalledAndGetLocal(N){if(!await this.isUninstalled(N))return null;this.logService.trace("Removing the extension from uninstalled list:",N.id);const x=await this.extensionsScanner.setInstalled(N);return this.logService.info("Removed the extension from uninstalled list:",N.id),x}async isUninstalled(N){return!!(await this.extensionsScanner.getUninstalledExtensions())[N.toString()]}async extract({zipPath:N,key:W,metadata:x},J){let G=await this.extensionsScanner.extractUserExtension(W,N,x,J);return this.logService.info("Extracting completed.",W.id),G}}class $ extends _{constructor(N,W,x,J,G){super(N.identifier,N,W,J,G);this.gallery=N,this.extensionsDownloader=x}async doRun(N){const x=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,u.areSameExtensions)(G.identifier,this.gallery.identifier));x&&(this._operation=3);const J=await this.downloadInstallableExtension(this.gallery,this._operation);J.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,J.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin,J.metadata.isSystem=x?.type===0?!0:void 0,J.metadata.updated=!!x,J.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,J.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,I.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:x?.preRelease);try{const G=await this.installExtension(J,N);return x&&(x.targetPlatform!==G.targetPlatform||R.neq(x.manifest.version,G.manifest.version))&&await this.extensionsScanner.setUninstalled(x),G}catch(G){throw await this.deleteDownloadedVSIX(J.zipPath),G}}async deleteDownloadedVSIX(N){try{await this.extensionsDownloader.delete(v.URI.file(N))}catch(W){this.logService.warn("Error while deleting the downloaded vsix",N.toString(),(0,L.getErrorMessage)(W))}}async downloadInstallableExtension(N,W){const x={id:N.identifier.uuid,publisherId:N.publisherId,publisherDisplayName:N.publisherDisplayName,targetPlatform:N.properties.targetPlatform};let J;try{this.logService.trace("Started downloading extension:",N.identifier.id),J=(await this.extensionsDownloader.downloadExtension(N,W)).fsPath,this.logService.info("Downloaded extension:",N.identifier.id,J)}catch(G){throw new g.ExtensionManagementError((0,w.joinErrors)(G).message,g.ExtensionManagementErrorCode.Download)}try{return await(0,a.getManifest)(J),{zipPath:J,key:u.ExtensionKey.create(N),metadata:x}}catch(G){throw await this.deleteDownloadedVSIX(J),new g.ExtensionManagementError((0,w.joinErrors)(G).message,g.ExtensionManagementErrorCode.Invalid)}}}class H extends _{constructor(N,W,x,J,G,Q){super({id:(0,u.getGalleryExtensionId)(N.publisher,N.name)},W,x,G,Q);this.manifest=N,this.location=W,this.galleryService=J}async doRun(N){const W=new u.ExtensionKey(this.identifier,this.manifest.version),J=(await this.extensionsScanner.scanExtensions(1)).find(Q=>(0,u.areSameExtensions)(this.identifier,Q.identifier)),G=await this.getMetadata(this.identifier.id,this.manifest.version,N);if(G.isMachineScoped=this.options.isMachineScoped||J?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||J?.isBuiltin,J)if(this._operation=3,W.equals(new u.ExtensionKey(J.identifier,J.manifest.version)))try{await this.extensionsScanner.removeExtension(J,"existing")}catch{throw new Error(f.localize(6,null,this.manifest.displayName||this.manifest.name))}else R.gt(J.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(J);else{const Q=await this.unsetUninstalledAndGetLocal(W);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),key:W,metadata:G},N)}async getMetadata(N,W,x){try{let[J]=await this.galleryService.getExtensions([{id:N,version:W}],x);if(J||([J]=await this.galleryService.getExtensions([{id:N}],x)),J)return{id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class ne extends w.AbstractExtensionTask{constructor(N,W,x){super();this.extension=N,this.options=W,this.extensionsScanner=x}async doRun(N){const W=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const J=u.ExtensionKey.create(this.extension);W.push(...x.filter(G=>J.equals(u.ExtensionKey.create(G))))}else W.push(...x.filter(J=>(0,u.areSameExtensions)(J.identifier,this.extension.identifier)));if(!W.length)throw new Error(f.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...W),this.options.remove)for(const J of W)try{N.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(J)}catch(G){throw new Error(f.localize(9,null,(0,n.toErrorMessage)(G)))}}}}),define(re[256],se([0,1,91,58,35,17,9,3,2,10,4,30,36,82,267]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(C,M=""){this.debugLabel=M,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,A.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(C,M){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,M)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(C){const M=O=>{this.traceSocketEvent("read",O),C(T.VSBuffer.wrap(O))};return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(C){const M=O=>{this.traceSocketEvent("close",{hadError:O}),C({type:0,hadError:O,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(C){const M=()=>{this.traceSocketEvent("nodeEndReceived"),C()};return this.socket.on("end",M),{dispose:()=>this.socket.off("end",M)}}write(C){if(!this.socket.destroyed)try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,A.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,A.onUnexpectedError)(M)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,M)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=p;var f;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var d;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(d||(d={}));class S extends E.Disposable{constructor(C,M,O,U){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:M,inflateBytesLength:O?.byteLength||0,recordInflateBytes:U}),this._flowManager=this._register(new w(this,M,O,U,this._onData,(k,F)=>this._write(k,F))),this._register(this._flowManager.onError(k=>{console.error(k),(0,A.onUnexpectedError)(k),this._onClose.fire({type:0,hadError:!0,error:k})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(k=>this._acceptChunk(k))),this._register(this.socket.onClose(k=>this._onClose.fire(k)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(C,M){this.socket.traceSocketEvent(C,M)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this._onData.event(C)}onClose(C){return this._onClose.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){this._flowManager.writeMessage(C)}_write(C,M){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let O=2;C.byteLength<126?O+=0:C.byteLength<2**16?O+=2:O+=8;const U=T.VSBuffer.alloc(O);if(M?U.writeUInt8(194,0):U.writeUInt8(130,0),C.byteLength<126)U.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){U.writeUInt8(126,1);let k=1;U.writeUInt8(C.byteLength>>>8&255,++k),U.writeUInt8(C.byteLength>>>0&255,++k)}else{U.writeUInt8(127,1);let k=1;U.writeUInt8(0,++k),U.writeUInt8(0,++k),U.writeUInt8(0,++k),U.writeUInt8(0,++k),U.writeUInt8(C.byteLength>>>24&255,++k),U.writeUInt8(C.byteLength>>>16&255,++k),U.writeUInt8(C.byteLength>>>8&255,++k),U.writeUInt8(C.byteLength>>>0&255,++k)}this.socket.write(T.VSBuffer.concat([U,C]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(C){if(C.byteLength!==0){for(this._incomingData.acceptChunk(C);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),O=M.readUInt8(0),U=(O&128)>>>7,k=(O&64)>>>6,F=M.readUInt8(1),_=(F&128)>>>7,$=F&127;this._state.state=2,this._state.readLen=2+(_?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=U,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(k)),this._state.firstFrameOfMessage=Boolean(U),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),O=M.readUInt8(1),U=(O&128)>>>7;let k=O&127,F=1;k===126?k=M.readUInt8(++F)*2**8+M.readUInt8(++F):k===127&&(k=M.readUInt8(++F)*0+M.readUInt8(++F)*0+M.readUInt8(++F)*0+M.readUInt8(++F)*0+M.readUInt8(++F)*2**24+M.readUInt8(++F)*2**16+M.readUInt8(++F)*2**8+M.readUInt8(++F));let _=0;U&&(_=M.readUInt8(++F)*2**24+M.readUInt8(++F)*2**16+M.readUInt8(++F)*2**8+M.readUInt8(++F)),this._state.state=3,this._state.readLen=k,this._state.mask=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",M),t(M,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",M),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(M,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class w extends E.Disposable{constructor(C,M,O,U,k,F){super();this._tracer=C,this._onData=k,this._writeFn=F,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,M?(this._zlibInflateStream=this._register(new g(this._tracer,U,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(_=>this._onError.fire(_))),this._register(this._zlibDeflateStream.onError(_=>this._onError.fire(_)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(C){this._writeQueue.push(C),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const C=this._writeQueue.shift();if(this._zlibDeflateStream){const M=await this._deflateMessage(this._zlibDeflateStream,C);this._writeFn(M,!0)}else this._writeFn(C,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(C,M){return new Promise((O,U)=>{C.write(M),C.flush(k=>O(k))})}acceptFrame(C,M,O){this._readQueue.push({data:C,isCompressed:M,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const C=this._readQueue.shift();if(this._zlibInflateStream&&C.isCompressed){const M=await this._inflateFrame(this._zlibInflateStream,C.data,C.isLastFrameOfMessage);this._onData.fire(M)}else this._onData.fire(C.data)}this._isProcessingReadQueue=!1}}_inflateFrame(C,M,O){return new Promise((U,k)=>{C.write(M),O&&C.write(T.VSBuffer.fromByteArray([0,0,255,255])),C.flush(F=>U(F))})}}class g extends E.Disposable{constructor(C,M,O,U){super();this._tracer=C,this._recordInflateBytes=M,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=m.createInflateRaw(U),this._zlibInflate.on("error",k=>{this._tracer.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibInflate.on("data",k=>{this._tracer.traceSocketEvent("zlibInflateData",k),this._pendingInflateData.push(T.VSBuffer.wrap(k))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(C){this._recordInflateBytes&&this._recordedInflateBytes.push(C.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",C),this._zlibInflate.write(C.buffer)}flush(C){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const M=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,C(M)})}}class u extends E.Disposable{constructor(C,M){super();this._tracer=C,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=m.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(T.VSBuffer.wrap(O))})}write(C){this._tracer.traceSocketEvent("zlibDeflateWrite",C.buffer),this._zlibDeflate.write(C.buffer)}flush(C){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let M=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.byteLength-4),C(M)})}}function t(h,C){if(C===0)return;let M=h.byteLength>>>2;for(let $=0;$<M;$++){const H=h.readUInt32BE($*4);h.writeUInt32BE(H^C,$*4)}let O=M*4,U=h.byteLength-O;const k=C>>>24&255,F=C>>>16&255,_=C>>>8&255;U>=1&&h.writeUInt8(h.readUInt8(O)^k,O),U>=2&&h.writeUInt8(h.readUInt8(O+1)^F,O+1),U>=3&&h.writeUInt8(h.readUInt8(O+2)^_,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function i(){const h=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let C;return e.XDG_RUNTIME_DIR?C=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):C=(0,b.join)((0,L.tmpdir)(),`vscode-ipc-${h}.sock`),c(C),C}e.createRandomIPCHandle=i;function a(h,C,M){const O=(0,D.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${M}-${C}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${M}-${C}.sock`):U=(0,b.join)(h,`${M}-${C}.sock`),c(U),U}e.createStaticIPCHandle=a;function c(h){const C=r[R.platform];typeof C=="number"&&h.length>=C&&console.warn(`WARNING: IPC handle "${h}" is longer than ${C} chars, try a shorter --user-data-dir`)}class s extends v.IPCServer{constructor(C){super(s.toClientConnectionEvent(C));this.server=C}static toClientConnectionEvent(C){const M=P.Event.fromNodeEventEmitter(C,"connection");return P.Event.map(M,O=>({protocol:new y.Protocol(new p(O,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function o(h){return new Promise((C,M)=>{const O=(0,n.createServer)();O.on("error",M),O.listen(h,()=>{O.removeListener("error",M),C(new s(O))})})}e.serve=o;function l(h,C){return new Promise((M,O)=>{const U=(0,n.createConnection)(h,()=>{U.removeListener("error",O),M(y.Client.fromSocket(new p(U,`ipc-client${C}`),C))});U.once("error",O)})}e.connect=l}),define(re[257],se([0,1,58,256]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,T,A,P,E,b){const R=v=>b(v,void 0),I=D.createConnection({host:L,port:T},()=>{I.removeListener("error",R);const v=Buffer.alloc(16);for(let f=0;f<16;f++)v[f]=Math.round(Math.random()*256);const y=v.toString("base64"),m=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${T}${A}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];I.write(m.join(`\r
`)+`\r
\r
`);const p=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",p),b(void 0,new n.NodeSocket(I,E)))};I.on("data",p)});I.setNoDelay(!0),I.once("error",R)}}}),define(re[258],se([0,1,58,120,257,5,2,18,8,24,199,68,99]),function(X,e,D,n,L,T,A,P,E,b,R,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(S,w,g,u,t){let r;for(let i=3;i&&(r&&r.dispose(),r=await new m(S,w,g,u,t).waitForReady(),!(t&&n.BROWSER_RESTRICTED_PORTS[t]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));i--);return r}class m extends A.Disposable{constructor(w,g,u,t,r){super();this.defaultTunnelHost=g,this.suggestedLocalPort=r,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=w,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(g=>{g()})}async waitForReady(){let w=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),g=null;return this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address(),g||(w=0,this._server.listen(w,this.defaultTunnelHost),await this._barrier.wait(),g=this._server.address()),this.tunnelLocalPort=g.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${g.port}`,this}async _onConnection(w){w.pause();const g=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,R.connectRemoteAgentTunnel)(this._options,g,this.tunnelRemotePort),t=u.getSocket().socket,r=u.readEntireBuffer();u.dispose(),r.byteLength>0&&w.write(r.buffer),w.on("end",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),t.end()}),w.on("close",()=>t.end()),w.on("error",()=>{w.localAddress&&this._socketsDispose.delete(w.localAddress),t.destroy()}),t.on("end",()=>w.end()),t.on("close",()=>w.end()),t.on("error",()=>{w.destroy()}),w.pipe(t),t.pipe(w),w.localAddress&&this._socketsDispose.set(w.localAddress,()=>{w.end(),t.end()})}}let p=class extends I.AbstractTunnelService{constructor(w,g,u,t,r){super(g);this.socketFactory=w,this.signService=u,this.productService=t,this.configurationService=r}get defaultTunnelHost(){const w=this.configurationService.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(w,g,u,t,r,i,a){const c=this.getTunnelFromMap(g,u);if(c)return++c.refcount,c.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,g,u,t,r,i,a);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${g}:${u} on local port ${t}.`);const s={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:w,signService:this.signService,logService:this.logService,ipcLogger:null},o=y(s,this.defaultTunnelHost,g,u,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(g,u,o),o}}};p=de([Y(1,E.ILogService),Y(2,v.ISignService),Y(3,b.IProductService),Y(4,P.IConfigurationService)],p),e.BaseTunnelService=p;let f=class extends p{constructor(w,g,u,t){super(L.nodeSocketFactory,w,g,u,t)}};f=de([Y(0,E.ILogService),Y(1,v.ISignService),Y(2,b.IProductService),Y(3,P.IConfigurationService)],f),e.TunnelService=f;let d=class extends A.Disposable{constructor(w,g,u,t){super();this.logService=w,this.productService=g,this.signService=u,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(w,g,u,t,r,i,a,c){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${t} on local port ${r}.`),!this._tunnelServices.has(w)){const s=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(w,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(w))})}return this._tunnelServices.get(w).openTunnel(g,u,t,r,i,a,c)}};d=de([Y(0,E.ILogService),Y(1,b.IProductService),Y(2,v.ISignService),Y(3,P.IConfigurationService)],d),e.SharedTunnelsService=d}),define(re[268],se([0,1,83,35,37,9,2,19,20,7,36,123,187,210,188,178,179,180,166,169,18,192,88,214,89,202,14,206,209,218,29,168,216,255,90,164,15,183,185,53,6,175,93,176,177,62,198,8,94,63,95,24,201,43,21,212,213,22,100,101,102,47,219,220,103,222,228,67,105,25,69,244,246,247,70,245,249,250,251,252,253,99,208,68,258,200,229,98,205,32,231,4,232,170,190,189,66,197,186,55]),function(X,e,D,n,L,T,A,P,E,b,R,I,v,y,m,p,f,d,S,w,g,u,t,r,i,a,c,s,o,l,h,C,M,O,U,k,F,_,$,H,ne,K,N,W,x,J,G,Q,Z,q,B,j,z,V,ee,ie,ae,fe,pe,we,ge,Ee,Ce,Re,_e,je,Ge,Ke,oe,le,ue,be,Ie,Ue,Le,Fe,Ae,Oe,te,ce,he,me,ye,ve,Pe,ke,Te,De,ze,Ne,qe,tt,Pt,vt,It,pt,Rt,Dt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends A.Disposable{constructor(Se){super();this.configuration=Se,this.server=this._register(new I.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const Se=()=>this.dispose();process.once("exit",Se),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Me="vscode:electron-main->shared-process=disposeWorker",$e=(Be,Xe)=>this.onDisposeWorker(Xe);D.ipcRenderer.on(Me,$e),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Me,$e)))}onDisposeWorker(Se){this.sharedProcessWorkerService?.disposeWorker(Se)}async open(){const Se=await this.initServices();(0,le.registerConfiguration)(),Se.invokeFunction(Me=>{const $e=Me.get(Q.ILogService);$e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler($e)}),this._register((0,A.combinedDisposable)(Se.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),Se.createInstance(m.LanguagePackCachedDataCleaner),Se.createInstance(d.StorageDataCleaner,this.configuration.backupWorkspacesPath),Se.createInstance(f.LogsDataCleaner),Se.createInstance(p.LocalizationsUpdater),Se.createInstance(y.ExtensionsCleaner)))}async initServices(){const Se=new N.ServiceCollection,Me={_serviceBrand:void 0,...B.default};Se.set(j.IProductService,Me);const $e=new R.StaticRouter(Ve=>Ve==="main"),Be=new W.MessagePortMainProcessService(this.server,$e);Se.set(x.IMainProcessService,Be);const Xe=this.configuration.policiesData?new kt.PolicyChannelClient(this.configuration.policiesData,Be.getChannel("policy")):new St.NullPolicyService;Se.set(St.IPolicyService,Xe);const We=new s.SharedProcessEnvironmentService(this.configuration.args,Me);Se.set(c.INativeEnvironmentService,We);const rt=new Z.LogLevelChannelClient(this.server.getChannel("logLevel",$e)),Ze=new Z.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Be.getChannel("logger"));Se.set(Q.ILoggerService,Ze);const at=this._register(new Q.MultiplexLogService([this._register(new Q.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,E.joinPath)(b.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this._register(new Z.FollowerLogService(rt,at));Se.set(Q.ILogService,xe),this.sharedProcessWorkerService=new ze.SharedProcessWorkerService(xe),Se.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ye=this._register(new _.FileService(xe));Se.set(F.IFileService,Ye);const ct=this._register(new $.DiskFileSystemProvider(xe));Ye.registerProvider(P.Schemas.file,ct);const lt=this._register(new Pt.FileUserDataProvider(P.Schemas.file,this._register(new vt.DiskFileSystemProviderClient(Be.getChannel(vt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:tt.isLinux})),P.Schemas.vscodeUserData,xe));Ye.registerProvider(P.Schemas.vscodeUserData,lt);const Je=this._register(new u.ConfigurationService(We.settingsResource,Ye,Xe,xe));Se.set(g.IConfigurationService,Je);const nt=new ie.NativeStorageService(void 0,Be,We);Se.set(ee.IStorageService,nt),this._register((0,A.toDisposable)(()=>nt.flush())),await Promise.all([Je.initialize(),nt.initialize()]),Se.set(Ne.IUriIdentityService,new qe.UriIdentityService(Ye)),Se.set(V.IRequestService,new H.SyncDescriptor(z.RequestService)),Se.set(S.IChecksumService,new H.SyncDescriptor(w.ChecksumService)),Se.set(pt.IV8InspectProfilingService,new H.SyncDescriptor(It.InspectProfilingService));const st=R.ProxyChannel.toService(Be.getChannel("nativeHost"),{context:this.configuration.windowId});Se.set(q.INativeHostService,st),Se.set(i.IDownloadService,new H.SyncDescriptor(a.DownloadService));const ut=this._register(new he.ActiveWindowManager(st)),ht=new R.StaticRouter(Ve=>ut.getActiveClientId().then(dt=>Ve===dt));Se.set(U.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let ot;const it=[];if((0,Ee.supportsTelemetry)(Me,We)){const Ve=new we.TelemetryLogAppender(Ze,We);it.push(Ve);const{installSourcePath:dt}=We;if(Me.aiConfig&&Me.aiConfig.asimovKey){const Et=new Ce.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,A.toDisposable)(()=>Et.flush())),it.push(Et)}ot=new ge.TelemetryService({appenders:it,commonProperties:(0,ae.resolveCommonProperties)(Ye,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,dt),sendErrorTelemetry:!0,piiPaths:(0,Ee.getPiiPathsFromEnvironment)(We)},Je,Me)}else{ot=Ee.NullTelemetryService;const Ve=Ee.NullAppender;it.push(Ve)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(it)),Se.set(fe.ITelemetryService,ot);const At=new Re.CustomEndpointTelemetryService(Je,ot,Ze,We,Me);Se.set(fe.ICustomEndpointTelemetryService,At),Se.set(Rt.IExtensionsScannerService,new H.SyncDescriptor(Dt.ExtensionsScannerService)),Se.set(h.IExtensionManagementService,new H.SyncDescriptor(O.ExtensionManagementService)),Se.set(h.IExtensionGalleryService,new H.SyncDescriptor(l.ExtensionGalleryService)),Se.set(h.IExtensionTipsService,new H.SyncDescriptor(M.ExtensionTipsService)),Se.set(J.ILanguagePackService,new H.SyncDescriptor(G.NativeLanguagePackService)),Se.set(t.IDiagnosticsService,new H.SyncDescriptor(r.DiagnosticsService)),Se.set(ue.IUserDataSyncAccountService,new H.SyncDescriptor(ue.UserDataSyncAccountService)),Se.set(le.IUserDataSyncLogService,new H.SyncDescriptor(Ue.UserDataSyncLogService)),Se.set(le.IUserDataSyncUtilService,new Ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),Se.set(h.IGlobalExtensionEnablementService,new H.SyncDescriptor(o.GlobalExtensionEnablementService)),Se.set(oe.IIgnoredExtensionsManagementService,new H.SyncDescriptor(oe.IgnoredExtensionsManagementService)),Se.set(Ke.IExtensionStorageService,new H.SyncDescriptor(Ke.ExtensionStorageService)),Se.set(le.IUserDataSyncStoreManagementService,new H.SyncDescriptor(te.UserDataSyncStoreManagementService)),Se.set(le.IUserDataSyncStoreService,new H.SyncDescriptor(te.UserDataSyncStoreService)),Se.set(Le.IUserDataSyncMachinesService,new H.SyncDescriptor(Le.UserDataSyncMachinesService)),Se.set(le.IUserDataSyncBackupStoreService,new H.SyncDescriptor(be.UserDataSyncBackupStoreService)),Se.set(le.IUserDataSyncEnablementService,new H.SyncDescriptor(Fe.UserDataSyncEnablementService)),Se.set(le.IUserDataSyncService,new H.SyncDescriptor(Ae.UserDataSyncService));const wt=new Ge.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},Je,We,xe);return wt.initialize(),Se.set(je.ILocalPtyService,this._register(wt)),Se.set(me.ISignService,new H.SyncDescriptor(ye.SignService)),Se.set(ve.ISharedTunnelsService,new H.SyncDescriptor(Pe.SharedTunnelsService)),Se.set(ke.ISharedProcessTunnelService,new H.SyncDescriptor(Te.SharedProcessTunnelService)),new K.InstantiationService(Se)}initChannels(Se){const Me=new C.ExtensionManagementChannel(Se.get(h.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const $e=R.ProxyChannel.fromService(Se.get(J.ILanguagePackService));this.server.registerChannel("languagePacks",$e);const Be=R.ProxyChannel.fromService(Se.get(t.IDiagnosticsService));this.server.registerChannel("diagnostics",Be);const Xe=new C.ExtensionTipsChannel(Se.get(h.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Xe);const We=R.ProxyChannel.fromService(Se.get(S.IChecksumService));this.server.registerChannel("checksum",We);const rt=R.ProxyChannel.fromService(Se.get(pt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",rt);const Ze=new Ie.UserDataSyncMachinesServiceChannel(Se.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const at=R.ProxyChannel.fromService(Se.get(fe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const xe=new Ie.UserDataSyncAccountServiceChannel(Se.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",xe);const Ye=new Ie.UserDataSyncStoreManagementServiceChannel(Se.get(le.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const ct=new Oe.UserDataSyncChannel(Se.get(le.IUserDataSyncService),Se.get(Q.ILogService));this.server.registerChannel("userDataSync",ct);const lt=this._register(Se.get(ne.IInstantiationService).createInstance(ce.UserDataAutoSyncService)),Je=new Ie.UserDataAutoSyncChannel(lt);this.server.registerChannel("userDataAutoSync",Je);const nt=Se.get(je.ILocalPtyService),st=R.ProxyChannel.fromService(nt);this.server.registerChannel(_e.TerminalIpcChannels.LocalPty,st);const ut=R.ProxyChannel.fromService(Se.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=R.ProxyChannel.fromService(Se.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(Se){window.addEventListener("unhandledrejection",Me=>{(0,T.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Me=>{const $e=(0,L.toErrorMessage)(Me,!0);!$e||Se.error(`[uncaught exception in sharedProcess]: ${$e}`)})}}async function Tt(yt){const Se=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4af164ea3a06f701fe3e89a2bcbb421d2026b68f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
