/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/errors","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/node/pfs","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/arrays","vs/platform/workspace/common/workspace","os","vs/base/common/extpath","fs","vs/base/common/strings","vs/base/common/uuid","vs/platform/windows/electron-main/windows","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/common/map","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/platform/state/electron-main/state","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","crypto","net","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/storage/common/storage","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","util","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/policy/node/nativePolicyService","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","path","graceful-fs","vscode-policy-watcher","vs/code/electron-main/main"],x=function(j){for(var e=[],S=0,t=j.length;S<t;S++)e[S]=Z[j[S]];return e};define(Z[110],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(t,R){if(!t)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=S}),define(Z[111],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function S(M){return M?M.replace(/\$\((.*?)\)/g,(b,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(b,f,y){this.id=b,this.definition=f,this.description=y,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(M,b){const f=["codicon","codicon-"+M];return b&&f.push("codicon-modifier-"+b),f}e.getClassNamesArray=R;var L;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function f(k){if(k instanceof t)return["codicon","codicon-"+k.id];const C=b.exec(k.id);if(!C)return f(t.error);let[,m,d]=C;const h=["codicon","codicon-"+m];return d&&h.push("codicon-modifier-"+d.substr(1)),h}M.asClassNameArray=f;function y(k){return f(k).join(" ")}M.asClassName=y;function I(k){return"."+f(k).join(".")}M.asCSSSelector=I})(L=e.CSSIcon||(e.CSSIcon={}))}),define(Z[112],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(b,f){const y=Math.pow(10,f);return Math.round(b*y)/y}class t{constructor(f,y,I,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,y))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=S(Math.max(Math.min(1,k),0),3)}static equals(f,y){return f.r===y.r&&f.g===y.g&&f.b===y.b&&f.a===y.a}}e.RGBA=t;class R{constructor(f,y,I,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,y),0),3),this.l=S(Math.max(Math.min(1,I),0),3),this.a=S(Math.max(Math.min(1,k),0),3)}static equals(f,y){return f.h===y.h&&f.s===y.s&&f.l===y.l&&f.a===y.a}static fromRGBA(f){const y=f.r/255,I=f.g/255,k=f.b/255,C=f.a,m=Math.max(y,I,k),d=Math.min(y,I,k);let h=0,w=0;const p=(d+m)/2,P=m-d;if(P>0){switch(w=Math.min(p<=.5?P/(2*p):P/(2-2*p),1),m){case y:h=(I-k)/P+(I<k?6:0);break;case I:h=(k-y)/P+2;break;case k:h=(y-I)/P+4;break}h*=60,h=Math.round(h)}return new R(h,w,p,C)}static _hue2rgb(f,y,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?f+(y-f)*6*I:I<1/2?y:I<2/3?f+(y-f)*(2/3-I)*6:f}static toRGBA(f){const y=f.h/360,{s:I,l:k,a:C}=f;let m,d,h;if(I===0)m=d=h=k;else{const w=k<.5?k*(1+I):k+I-k*I,p=2*k-w;m=R._hue2rgb(p,w,y+1/3),d=R._hue2rgb(p,w,y),h=R._hue2rgb(p,w,y-1/3)}return new t(Math.round(m*255),Math.round(d*255),Math.round(h*255),C)}}e.HSLA=R;class L{constructor(f,y,I,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,y),0),3),this.v=S(Math.max(Math.min(1,I),0),3),this.a=S(Math.max(Math.min(1,k),0),3)}static equals(f,y){return f.h===y.h&&f.s===y.s&&f.v===y.v&&f.a===y.a}static fromRGBA(f){const y=f.r/255,I=f.g/255,k=f.b/255,C=Math.max(y,I,k),m=Math.min(y,I,k),d=C-m,h=C===0?0:d/C;let w;return d===0?w=0:C===y?w=((I-k)/d%6+6)%6:C===I?w=(k-y)/d+2:w=(y-I)/d+4,new L(Math.round(w*60),h,C,f.a)}static toRGBA(f){const{h:y,s:I,v:k,a:C}=f,m=k*I,d=m*(1-Math.abs(y/60%2-1)),h=k-m;let[w,p,P]=[0,0,0];return y<60?(w=m,p=d):y<120?(w=d,p=m):y<180?(p=m,P=d):y<240?(p=d,P=m):y<300?(w=d,P=m):y<=360&&(w=m,P=d),w=Math.round((w+h)*255),p=Math.round((p+h)*255),P=Math.round((P+h)*255),new t(w,p,P,C)}}e.HSVA=L;class M{constructor(f){if(f)if(f instanceof t)this.rgba=f;else if(f instanceof R)this._hsla=f,this.rgba=R.toRGBA(f);else if(f instanceof L)this._hsva=f,this.rgba=L.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(f){return M.Format.CSS.parseHex(f)||M.red}get hsla(){return this._hsla?this._hsla:R.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:L.fromRGBA(this.rgba)}equals(f){return!!f&&t.equals(this.rgba,f.rgba)&&R.equals(this.hsla,f.hsla)&&L.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=M._relativeLuminanceForComponent(this.rgba.r),y=M._relativeLuminanceForComponent(this.rgba.g),I=M._relativeLuminanceForComponent(this.rgba.b),k=.2126*f+.7152*y+.0722*I;return S(k,4)}static _relativeLuminanceForComponent(f){const y=f/255;return y<=.03928?y/12.92:Math.pow((y+.055)/1.055,2.4)}getContrastRatio(f){const y=this.getRelativeLuminance(),I=f.getRelativeLuminance();return y>I?(y+.05)/(I+.05):(I+.05)/(y+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const y=this.getRelativeLuminance(),I=f.getRelativeLuminance();return y>I}isDarkerThan(f){const y=this.getRelativeLuminance(),I=f.getRelativeLuminance();return y<I}lighten(f){return new M(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new M(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:y,g:I,b:k,a:C}=this.rgba;return new M(new t(y,I,k,C*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const y=f.rgba,I=this.rgba.a,k=y.a,C=I+k*(1-I);if(C<1e-6)return M.transparent;const m=this.rgba.r*I/C+y.r*k*(1-I)/C,d=this.rgba.g*I/C+y.g*k*(1-I)/C,h=this.rgba.b*I/C+y.b*k*(1-I)/C;return new M(new t(m,d,h,C))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:y,g:I,b:k,a:C}=this.rgba;return new M(new t(f.rgba.r-C*(f.rgba.r-y),f.rgba.g-C*(f.rgba.g-I),f.rgba.b-C*(f.rgba.b-k),1))}flatten(...f){const y=f.reduceRight((I,k)=>M._flatten(k,I));return M._flatten(this,y)}static _flatten(f,y){const I=1-f.rgba.a;return new M(new t(I*y.rgba.r+f.rgba.a*f.rgba.r,I*y.rgba.g+f.rgba.a*f.rgba.g,I*y.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(f,y,I){if(f.isLighterThan(y))return f;I=I||.5;const k=f.getRelativeLuminance(),C=y.getRelativeLuminance();return I=I*(C-k)/C,f.lighten(I)}static getDarkerColor(f,y,I){if(f.isDarkerThan(y))return f;I=I||.5;const k=f.getRelativeLuminance(),C=y.getRelativeLuminance();return I=I*(k-C)/k,f.darken(I)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(b){let f;(function(y){let I;(function(k){function C(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:b.Format.CSS.formatRGBA(n)}k.formatRGB=C;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}k.formatRGBA=m;function d(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(n)}k.formatHSL=d;function h(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}k.formatHSLA=h;function w(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function p(n){return`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}`}k.formatHex=p;function P(n,s=!1){return s&&n.rgba.a===1?b.Format.CSS.formatHex(n):`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}${w(Math.round(n.rgba.a*255))}`}k.formatHexA=P;function v(n){return n.isOpaque()?b.Format.CSS.formatHex(n):b.Format.CSS.formatRGBA(n)}k.format=v;function u(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),o=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),a=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new b(new t(i,o,a,1))}if(s===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),o=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),a=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),r=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new b(new t(i,o,a,r/255))}if(s===4){const i=c(n.charCodeAt(1)),o=c(n.charCodeAt(2)),a=c(n.charCodeAt(3));return new b(new t(16*i+i,16*o+o,16*a+a))}if(s===5){const i=c(n.charCodeAt(1)),o=c(n.charCodeAt(2)),a=c(n.charCodeAt(3)),r=c(n.charCodeAt(4));return new b(new t(16*i+i,16*o+o,16*a+a,(16*r+r)/255))}return null}k.parseHex=u;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=y.CSS||(y.CSS={}))})(f=b.Format||(b.Format={}))}(M=e.Color||(e.Color={}))}),define(Z[49],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(M){return(b,f,y)=>{let I=null,k=null;if(typeof y.value=="function"?(I="value",k=y.value):typeof y.get=="function"&&(I="get",k=y.get),!k)throw new Error("not supported");y[I]=M(k,f)}}e.createDecorator=S;function t(M,b,f){let y=null,I=null;if(typeof f.value=="function"?(y="value",I=f.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(y="get",I=f.get),!I)throw new Error("not supported");const k=`$memoize$${b}`;f[y]=function(...C){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,C)}),this[k]}}e.memoize=t;function R(M,b,f){return S((y,I)=>{const k=`$debounce$${I}`,C=`$debounce$result$${I}`;return function(...m){this[C]||(this[C]=f?f():void 0),clearTimeout(this[k]),b&&(this[C]=b(this[C],...m),m=[this[C]]),this[k]=setTimeout(()=>{y.apply(this,m),this[C]=f?f():void 0},M)}})}e.debounce=R;function L(M,b,f){return S((y,I)=>{const k=`$throttle$timer$${I}`,C=`$throttle$result$${I}`,m=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...h){if(this[C]||(this[C]=f?f():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),b&&(this[C]=b(this[C],...h)),this[d])return;const w=this[m]+M;w<=Date.now()?(this[m]=Date.now(),y.apply(this,[this[C]]),this[C]=f?f():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[m]=Date.now(),y.apply(this,[this[C]]),this[C]=f?f():void 0},w-Date.now()))}})}e.throttle=L}),define(Z[15],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=S,e.errorHandler=new S;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function R(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=R;function L(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=L;function M(c){if(c instanceof Error){let{name:n,message:s}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:s,stack:i}}return c}e.transformErrorForSerialization=M;const b="Canceled";function f(c){return c instanceof y?!0:c instanceof Error&&c.name===b&&c.message===b}e.isCancellationError=f;class y extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=y;function I(){const c=new Error(b);return c.name=c.message,c}e.canceled=I;function k(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=k;function C(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=C;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function d(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class w extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=w;class p extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=p;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;class v extends Error{constructor(){super(...arguments);this.logTelemetry=!1}static fromError(n){if(n&&n instanceof v)return n;if(n&&n instanceof Error){const s=new v;return s.name=n.name,s.message=n.message,s.stack=n.stack,s}return new v(n)}}e.ErrorNoTelemetry=v;class u extends Error{constructor(n){super(n||"An unexpected bug occurred.");Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(Z[25],x([0,1,15]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(F,B=0){return F[F.length-(1+B)]}e.tail=t;function R(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=R;function L(F,B,K=(ie,oe)=>ie===oe){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let ie=0,oe=F.length;ie<oe;ie++)if(!K(F[ie],B[ie]))return!1;return!0}e.equals=L;function M(F,B,K){return b(F.length,ie=>K(F[ie],B))}e.binarySearch=M;function b(F,B){let K=0,ie=F-1;for(;K<=ie;){const oe=(K+ie)/2|0,ue=B(oe);if(ue<0)K=oe+1;else if(ue>0)ie=oe-1;else return oe}return-(K+1)}e.binarySearch2=b;function f(F,B){let K=0,ie=F.length;if(ie===0)return 0;for(;K<ie;){const oe=Math.floor((K+ie)/2);B(F[oe])?ie=oe:K=oe+1}return K}e.findFirstInSorted=f;function y(F,B,K){if(F=F|0,F>=B.length)throw new TypeError("invalid index");let ie=B[Math.floor(B.length*Math.random())],oe=[],ue=[],fe=[];for(let Ie of B){const be=K(Ie,ie);be<0?oe.push(Ie):be>0?ue.push(Ie):fe.push(Ie)}return F<oe.length?y(F,oe,K):F<oe.length+fe.length?fe[0]:y(F-(oe.length+fe.length),ue,K)}e.quickSelect=y;function I(F,B){const K=[];let ie;for(const oe of F.slice(0).sort(B))!ie||B(ie[0],oe)!==0?(ie=[oe],K.push(ie)):ie.push(oe);return K}e.groupBy=I;function k(F,B,K){const ie=[];function oe(Ie,be,le){if(be===0&&le.length===0)return;const de=ie[ie.length-1];de&&de.start+de.deleteCount===Ie?(de.deleteCount+=be,de.toInsert.push(...le)):ie.push({start:Ie,deleteCount:be,toInsert:le})}let ue=0,fe=0;for(;;){if(ue===F.length){oe(ue,0,B.slice(fe));break}if(fe===B.length){oe(ue,F.length-ue,[]);break}const Ie=F[ue],be=B[fe],le=K(Ie,be);le===0?(ue+=1,fe+=1):le<0?(oe(ue,1,[]),ue+=1):le>0&&(oe(ue,0,[be]),fe+=1)}return ie}e.sortedDiff=k;function C(F,B,K){const ie=k(F,B,K),oe=[],ue=[];for(const fe of ie)oe.push(...F.slice(fe.start,fe.start+fe.deleteCount)),ue.push(...fe.toInsert);return{removed:oe,added:ue}}e.delta=C;function m(F,B,K){if(K===0)return[];const ie=F.slice(0,K).sort(B);return h(F,B,ie,K,F.length),ie}e.top=m;function d(F,B,K,ie,oe){return K===0?Promise.resolve([]):new Promise((ue,fe)=>{(async()=>{const Ie=F.length,be=F.slice(0,K).sort(B);for(let le=K,de=Math.min(K+ie,Ie);le<Ie;le=de,de=Math.min(de+ie,Ie)){if(le>K&&await new Promise(Ce=>setTimeout(Ce)),oe&&oe.isCancellationRequested)throw new S.CancellationError;h(F,B,be,le,de)}return be})().then(ue,fe)})}e.topAsync=d;function h(F,B,K,ie,oe){for(const ue=K.length;ie<oe;ie++){const fe=F[ie];if(B(fe,K[ue-1])<0){K.pop();const Ie=f(K,be=>B(fe,be)<0);K.splice(Ie,0,fe)}}}function w(F){return F.filter(B=>!!B)}e.coalesce=w;function p(F){let B=0;for(let K=0;K<F.length;K++)F[K]&&(F[B]=F[K],B+=1);F.length=B}e.coalesceInPlace=p;function P(F,B,K){F.splice(K,0,F.splice(B,1)[0])}e.move=P;function v(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=v;function u(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=u;function c(F,B=K=>K){const K=new Set;return F.filter(ie=>{const oe=B(ie);return K.has(oe)?!1:(K.add(oe),!0)})}e.distinct=c;function n(F){const B=new Set;return K=>{const ie=F(K);return B.has(ie)?!1:(B.add(ie),!0)}}e.uniqueFilter=n;function s(F,B){const K=i(F,B);if(K!==-1)return F[K]}e.findLast=s;function i(F,B){for(let K=F.length-1;K>=0;K--){const ie=F[K];if(B(ie))return K}return-1}e.lastIndex=i;function o(F,B){return F.length>0?F[0]:B}e.firstOrDefault=o;function a(F,B){return F.length>0?F[F.length-1]:B}e.lastOrDefault=a;function r(F,B,K=(ie,oe)=>ie===oe){let ie=0;for(let oe=0,ue=Math.min(F.length,B.length);oe<ue&&K(F[oe],B[oe]);oe++)ie++;return ie}e.commonPrefixLength=r;function l(F){return[].concat(...F)}e.flatten=l;function g(F,B){let K=typeof B=="number"?F:0;typeof B=="number"?K=F:(K=0,B=F);const ie=[];if(K<=B)for(let oe=K;oe<B;oe++)ie.push(oe);else for(let oe=K;oe>B;oe--)ie.push(oe);return ie}e.range=g;function E(F,B,K){return F.reduce((ie,oe)=>(ie[B(oe)]=K?K(oe):oe,ie),Object.create(null))}e.index=E;function D(F,B){return F.push(B),()=>W(F,B)}e.insert=D;function W(F,B){const K=F.indexOf(B);if(K>-1)return F.splice(K,1),B}e.remove=W;function O(F,B,K){const ie=F.slice(0,B),oe=F.slice(B);return ie.concat(K,oe)}e.arrayInsert=O;function V(F,B){let K;if(typeof B=="number"){let ie=B;K=()=>{const oe=Math.sin(ie++)*179426549;return oe-Math.floor(oe)}}else K=Math.random;for(let ie=F.length-1;ie>0;ie-=1){const oe=Math.floor(K()*(ie+1)),ue=F[ie];F[ie]=F[oe],F[oe]=ue}}e.shuffle=V;function J(F,B){const K=F.indexOf(B);K>-1&&(F.splice(K,1),F.unshift(B))}e.pushToStart=J;function ne(F,B){const K=F.indexOf(B);K>-1&&(F.splice(K,1),F.push(B))}e.pushToEnd=ne;function Y(F,B){for(const K of B)F.push(K)}e.pushMany=Y;function re(F,B){return Array.isArray(F)?F.map(B):B(F)}e.mapArrayOrNot=re;function ae(F){return Array.isArray(F)?F:[F]}e.asArray=ae;function H(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=H;function $(F,B){for(const K of F){const ie=B(K);if(ie!==void 0)return ie}}e.mapFind=$;function U(F,B,K){const ie=q(F,B),oe=F.length,ue=K.length;F.length=oe+ue;for(let fe=oe-1;fe>=ie;fe--)F[fe+ue]=F[fe];for(let fe=0;fe<ue;fe++)F[fe+ie]=K[fe]}e.insertInto=U;function N(F,B,K,ie){const oe=q(F,B),ue=F.splice(oe,K);return U(F,oe,ie),ue}e.splice=N;function q(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}var ee;(function(F){function B(oe){return oe<0}F.isLessThan=B;function K(oe){return oe>0}F.isGreaterThan=K;function ie(oe){return oe===0}F.isNeitherLessOrGreaterThan=ie,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function Q(F,B){return(K,ie)=>B(F(K),F(ie))}e.compareBy=Q;const X=(F,B)=>F-B;e.numberComparator=X;function T(F,B){if(F.length===0)return;let K=F[0];for(let ie=1;ie<F.length;ie++){const oe=F[ie];B(oe,K)>0&&(K=oe)}return K}e.findMaxBy=T;function A(F,B){if(F.length===0)return;let K=F[0];for(let ie=1;ie<F.length;ie++){const oe=F[ie];B(oe,K)>=0&&(K=oe)}return K}e.findLastMaxBy=A;function _(F,B){return T(F,(K,ie)=>-B(K,ie))}e.findMinBy=_;class z{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let K=this.firstIdx;for(;K<this.items.length&&B(this.items[K]);)K++;const ie=K===this.firstIdx?null:this.items.slice(this.firstIdx,K);return this.firstIdx=K,ie}takeFromEndWhile(B){let K=this.lastIdx;for(;K>=0&&B(this.items[K]);)K--;const ie=K===this.lastIdx?null:this.items.slice(K+1,this.lastIdx+1);return this.lastIdx=K,ie}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}removeLast(){const B=this.items[this.lastIdx];return this.lastIdx--,B}takeCount(B){const K=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,K}}e.ArrayQueue=z}),define(Z[45],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const R=this;let L=!1,M;return function(){return L||(L=!0,M=t.apply(R,arguments)),M}}e.once=S}),define(Z[51],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function R(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}t.is=R;const L=Object.freeze([]);function M(){return L}t.empty=M;function*b(s){yield s}t.single=b;function f(s){return s||L}t.from=f;function y(s){return!s||s[Symbol.iterator]().next().done===!0}t.isEmpty=y;function I(s){return s[Symbol.iterator]().next().value}t.first=I;function k(s,i){for(const o of s)if(i(o))return!0;return!1}t.some=k;function C(s,i){for(const o of s)if(i(o))return o}t.find=C;function*m(s,i){for(const o of s)i(o)&&(yield o)}t.filter=m;function*d(s,i){let o=0;for(const a of s)yield i(a,o++)}t.map=d;function*h(...s){for(const i of s)for(const o of i)yield o}t.concat=h;function*w(s){for(const i of s)for(const o of i)yield o}t.concatNested=w;function p(s,i,o){let a=o;for(const r of s)a=i(a,r);return a}t.reduce=p;function P(s,i){let o=0;for(const a of s)i(a,o++)}t.forEach=P;function*v(s,i,o=s.length){for(i<0&&(i+=s.length),o<0?o+=s.length:o>s.length&&(o=s.length);i<o;i++)yield s[i]}t.slice=v;function u(s,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,s];const a=s[Symbol.iterator]();for(let r=0;r<i;r++){const l=a.next();if(l.done)return[o,t.empty()];o.push(l.value)}return[o,{[Symbol.iterator](){return a}}]}t.consume=u;function c(s){return u(s)[0]}t.collect=c;function n(s,i,o=(a,r)=>a===r){const a=s[Symbol.iterator](),r=i[Symbol.iterator]();for(;;){const l=a.next(),g=r.next();if(l.done!==g.done)return!1;if(l.done)return!0;if(!o(l.value,g.value))return!1}}t.equals=n})(S=e.Iterable||(e.Iterable={}))}),define(Z[46],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function M(n,s=!1){let i=0,o=n.length,a="",r=0,l=16,g=0;function E(Y){let re=0,ae=0;for(;re<Y;){const H=n.charCodeAt(i);if(H>=48&&H<=57)ae=ae*16+H-48;else if(H>=65&&H<=70)ae=ae*16+H-65+10;else if(H>=97&&H<=102)ae=ae*16+H-97+10;else break;i++,re++}return re<Y&&(ae=-1),ae}function D(Y){i=Y,a="",r=0,l=16,g=0}function W(){const Y=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&y(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&y(n.charCodeAt(i)))for(i++;i<n.length&&y(n.charCodeAt(i));)i++;else return g=3,n.substring(Y,i);let re=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&y(n.charCodeAt(i))){for(i++;i<n.length&&y(n.charCodeAt(i));)i++;re=i}else g=3;return n.substring(Y,re)}function O(){let Y="",re=i;for(;;){if(i>=o){Y+=n.substring(re,i),g=2;break}const ae=n.charCodeAt(i);if(ae===34){Y+=n.substring(re,i),i++;break}if(ae===92){if(Y+=n.substring(re,i),i++,i>=o){g=2;break}switch(n.charCodeAt(i++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const $=E(4);$>=0?Y+=String.fromCharCode($):g=4;break}default:g=5}re=i;continue}if(ae>=0&&ae<=31)if(f(ae)){Y+=n.substring(re,i),g=2;break}else g=6;i++}return Y}function V(){if(a="",g=0,r=i,i>=o)return r=o,l=17;let Y=n.charCodeAt(i);if(b(Y)){do i++,a+=String.fromCharCode(Y),Y=n.charCodeAt(i);while(b(Y));return l=15}if(f(Y))return i++,a+=String.fromCharCode(Y),Y===13&&n.charCodeAt(i)===10&&(i++,a+=`
`),l=14;switch(Y){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,a=O(),l=10;case 47:{const re=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<o&&!f(n.charCodeAt(i));)i++;return a=n.substring(re,i),l=12}if(n.charCodeAt(i+1)===42){i+=2;const ae=o-1;let H=!1;for(;i<ae;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,H=!0;break}i++}return H||(i++,g=1),a=n.substring(re,i),l=13}return a+=String.fromCharCode(Y),i++,l=16}case 45:if(a+=String.fromCharCode(Y),i++,i===o||!y(n.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=W(),l=11;default:for(;i<o&&J(Y);)i++,Y=n.charCodeAt(i);if(r!==i){switch(a=n.substring(r,i),a){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return a+=String.fromCharCode(Y),i++,l=16}}function J(Y){if(b(Y)||f(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let Y;do Y=V();while(Y>=12&&Y<=15);return Y}return{setPosition:D,getPosition:()=>i,scan:s?ne:V,getToken:()=>l,getTokenValue:()=>a,getTokenOffset:()=>r,getTokenLength:()=>i-r,getTokenError:()=>g}}e.createScanner=M;function b(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function f(n){return n===10||n===13||n===8232||n===8233}function y(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function k(n,s){const i=[],o=new Object;let a;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(E,D,W,O){r.value=E,r.offset=D,r.length=W,r.type=O,r.colonOffset=void 0,a=r}try{v(n,{onObjectBegin:(E,D)=>{if(s<=E)throw o;a=void 0,l=s>E,i.push("")},onObjectProperty:(E,D,W)=>{if(s<D||(g(E,D,W,"property"),i[i.length-1]=E,s<=D+W))throw o},onObjectEnd:(E,D)=>{if(s<=E)throw o;a=void 0,i.pop()},onArrayBegin:(E,D)=>{if(s<=E)throw o;a=void 0,i.push(0)},onArrayEnd:(E,D)=>{if(s<=E)throw o;a=void 0,i.pop()},onLiteralValue:(E,D,W)=>{if(s<D||(g(E,D,W,c(E)),s<=D+W))throw o},onSeparator:(E,D,W)=>{if(s<=D)throw o;if(E===":"&&a&&a.type==="property")a.colonOffset=D,l=!1,a=void 0;else if(E===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(l=!0,i[i.length-1]=""),a=void 0}}})}catch(E){if(E!==o)throw E}return{path:i,previousNode:a,isAtPropertyKey:l,matches:E=>{let D=0;for(let W=0;D<E.length&&W<i.length;W++)if(E[D]===i[W]||E[D]==="*")D++;else if(E[D]!=="**")return!1;return D===E.length}}}e.getLocation=k;function C(n,s=[],i=L.DEFAULT){let o=null,a=[];const r=[];function l(E){Array.isArray(a)?a.push(E):o!==null&&(a[o]=E)}return v(n,{onObjectBegin:()=>{const E={};l(E),r.push(a),a=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const E=[];l(E),r.push(a),a=E,o=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:l,onError:(E,D,W)=>{s.push({error:E,offset:D,length:W})}},i),a[0]}e.parse=C;function m(n,s=[],i=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function r(E){return o.children.push(E),E}v(n,{onObjectBegin:E=>{o=r({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,D,W)=>{o=r({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:D,length:W,parent:o})},onObjectEnd:(E,D)=>{o.length=E+D-o.offset,o=o.parent,a(E+D)},onArrayBegin:(E,D)=>{o=r({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,D)=>{o.length=E+D-o.offset,o=o.parent,a(E+D)},onLiteralValue:(E,D,W)=>{r({type:c(E),offset:D,length:W,parent:o,value:E}),a(D+W)},onSeparator:(E,D,W)=>{o.type==="property"&&(E===":"?o.colonOffset=D:E===","&&a(D))},onError:(E,D,W)=>{s.push({error:E,offset:D,length:W})}},i);const g=o.children[0];return g&&delete g.parent,g}e.parseTree=m;function d(n,s){if(!n)return;let i=n;for(let o of s)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===o){i=r.children[1],a=!0;break}if(!a)return}else{const a=o;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=d;function h(n){if(!n.parent||!n.parent.children)return[];const s=h(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;s.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&s.push(i)}return s}e.getNodePath=h;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const s=Object.create(null);for(let i of n.children){const o=i.children[1];o&&(s[i.children[0].value]=w(o))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function p(n,s,i=!1){return s>=n.offset&&s<n.offset+n.length||i&&s===n.offset+n.length}e.contains=p;function P(n,s,i=!1){if(p(n,s,i)){const o=n.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=s;a++){const r=P(o[a],s,i);if(r)return r}return n}}e.findNodeAtOffset=P;function v(n,s,i=L.DEFAULT){const o=M(n,!1);function a(X){return X?()=>X(o.getTokenOffset(),o.getTokenLength()):()=>!0}function r(X){return X?T=>X(T,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=a(s.onObjectBegin),g=r(s.onObjectProperty),E=a(s.onObjectEnd),D=a(s.onArrayBegin),W=a(s.onArrayEnd),O=r(s.onLiteralValue),V=r(s.onSeparator),J=a(s.onComment),ne=r(s.onError),Y=i&&i.disallowComments,re=i&&i.allowTrailingComma;function ae(){for(;;){const X=o.scan();switch(o.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:Y||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(X){case 12:case 13:Y?H(10):J();break;case 16:H(1);break;case 15:case 14:break;default:return X}}}function H(X,T=[],A=[]){if(ne(X),T.length+A.length>0){let _=o.getToken();for(;_!==17;){if(T.indexOf(_)!==-1){ae();break}else if(A.indexOf(_)!==-1)break;_=ae()}}}function $(X){const T=o.getTokenValue();return X?O(T):g(T),ae(),!0}function U(){switch(o.getToken()){case 11:{let X=0;try{X=JSON.parse(o.getTokenValue()),typeof X!="number"&&(H(2),X=0)}catch{H(2)}O(X);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return ae(),!0}function N(){return o.getToken()!==10?(H(3,[],[2,5]),!1):($(!1),o.getToken()===6?(V(":"),ae(),Q()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function q(){l(),ae();let X=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(X||H(4,[],[]),V(","),ae(),o.getToken()===2&&re)break}else X&&H(6,[],[]);N()||H(4,[],[2,5]),X=!0}return E(),o.getToken()!==2?H(7,[2],[]):ae(),!0}function ee(){D(),ae();let X=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(X||H(4,[],[]),V(","),ae(),o.getToken()===4&&re)break}else X&&H(6,[],[]);Q()||H(4,[],[4,5]),X=!0}return W(),o.getToken()!==4?H(8,[4],[]):ae(),!0}function Q(){switch(o.getToken()){case 3:return ee();case 1:return q();case 10:return $(!0);default:return U()}}return ae(),o.getToken()===17?i.allowEmptyContent?!0:(H(4,[],[]),!1):Q()?(o.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=v;function u(n,s){let i=M(n),o=[],a,r=0,l;do switch(l=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:r!==l&&o.push(n.substring(r,l)),s!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,s)),r=i.getPosition();break}while(a!==17);return o.join("")}e.stripComments=u;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[113],x([0,1,46]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(y,I,k){let C,m,d,h,w;if(I){for(h=I.offset,w=h+I.length,d=h;d>0&&!f(y,d-1);)d--;let l=w;for(;l<y.length&&!f(y,l);)l++;m=y.substring(d,l),C=M(m,k)}else m=y,C=0,d=0,h=0,w=y.length;const p=b(k,y);let P=!1,v=0,u;k.insertSpaces?u=L(" ",k.tabSize||4):u="	";const c=(0,S.createScanner)(m,!1);let n=!1;function s(){return p+L(u,C+v)}function i(){let l=c.scan();for(P=!1;l===15||l===14;)P=P||l===14,l=c.scan();return n=l===16||c.getTokenError()!==0,l}const o=[];function a(l,g,E){!n&&g<w&&E>h&&y.substring(g,E)!==l&&o.push({offset:g,length:E-g,content:l})}let r=i();if(r!==17){const l=c.getTokenOffset()+d,g=L(u,C);a(g,d,l)}for(;r!==17;){let l=c.getTokenOffset()+c.getTokenLength()+d,g=i(),E="";for(;!P&&(g===12||g===13);){const W=c.getTokenOffset()+d;a(" ",l,W),l=c.getTokenOffset()+c.getTokenLength()+d,E=g===12?s():"",g=i()}if(g===2)r!==1&&(v--,E=s());else if(g===4)r!==3&&(v--,E=s());else{switch(r){case 3:case 1:v++,E=s();break;case 5:case 12:E=s();break;case 13:P?E=s():E=" ";break;case 6:E=" ";break;case 10:if(g===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?E=" ":g!==5&&g!==17&&(n=!0);break;case 16:n=!0;break}P&&(g===12||g===13)&&(E=s())}const D=c.getTokenOffset()+d;a(E,l,D),r=g}return o}e.format=t;function R(y,I){const k=JSON.stringify(y,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?k.replace(/\r\n|\r|\n/g,I.eol):k}e.toFormattedString=R;function L(y,I){let k="";for(let C=0;C<I;C++)k+=y;return k}function M(y,I){let k=0,C=0;const m=I.tabSize||4;for(;k<y.length;){const d=y.charAt(k);if(d===" ")C++;else if(d==="	")C+=m;else break;k++}return Math.floor(C/m)}function b(y,I){for(let k=0;k<I.length;k++){const C=I.charAt(k);if(C==="\r")return k+1<I.length&&I.charAt(k+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=b;function f(y,I){return`\r
`.indexOf(y.charAt(I))!==-1}e.isEOL=f}),define(Z[114],x([0,1,46,113]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(y,I,k){return L(y,I,void 0,k)}e.removeProperty=R;function L(y,I,k,C,m){const d=I.slice(),h=[],w=(0,S.parseTree)(y,h);let p,P;for(;d.length>0&&(P=d.pop(),p=(0,S.findNodeAtLocation)(w,d),p===void 0&&k!==void 0);)typeof P=="string"?k={[P]:k}:k=[k];if(p)if(p.type==="object"&&typeof P=="string"&&Array.isArray(p.children)){const v=(0,S.findNodeAtLocation)(p,[P]);if(v!==void 0)if(k===void 0){if(!v.parent)throw new Error("Malformed AST");const u=p.children.indexOf(v.parent);let c,n=v.parent.offset+v.parent.length;if(u>0){const s=p.children[u-1];c=s.offset+s.length}else c=p.offset+1,p.children.length>1&&(n=p.children[1].offset);return M(y,{offset:c,length:n-c,content:""},C)}else return M(y,{offset:v.offset,length:v.length,content:JSON.stringify(k)},C);else{if(k===void 0)return[];const u=`${JSON.stringify(P)}: ${JSON.stringify(k)}`,c=m?m(p.children.map(s=>s.children[0].value)):p.children.length;let n;if(c>0){const s=p.children[c-1];n={offset:s.offset+s.length,length:0,content:","+u}}else p.children.length===0?n={offset:p.offset+1,length:0,content:u}:n={offset:p.offset+1,length:0,content:u+","};return M(y,n,C)}}else if(p.type==="array"&&typeof P=="number"&&Array.isArray(p.children))if(k!==void 0){const v=`${JSON.stringify(k)}`;let u;if(p.children.length===0||P===0)u={offset:p.offset+1,length:0,content:p.children.length===0?v:v+","};else{const c=P===-1||P>p.children.length?p.children.length:P,n=p.children[c-1];u={offset:n.offset+n.length,length:0,content:","+v}}return M(y,u,C)}else{const v=P,u=p.children[v];let c;if(p.children.length===1)c={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===v){const n=p.children[v-1],s=n.offset+n.length,i=p.offset+p.length;c={offset:s,length:i-2-s,content:""}}else c={offset:u.offset,length:p.children[v+1].offset-u.offset,content:""};return M(y,c,C)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${p.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return M(y,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(k)},C)}}e.setProperty=L;function M(y,I,k){let C=b(y,I),m=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;m>0&&!(0,t.isEOL)(C,m-1);)m--;for(;d<C.length&&!(0,t.isEOL)(C,d);)d++}const h=(0,t.format)(C,{offset:m,length:d-m},k);for(let p=h.length-1;p>=0;p--){const P=h[p];C=b(C,P),m=Math.min(m,P.offset),d=Math.max(d,P.offset+P.length),d+=P.content.length-P.length}const w=y.length-(C.length-d)-m;return[{offset:m,length:w,content:C.substring(m,d)}]}e.withFormatting=M;function b(y,I){return y.substring(0,I.offset)+I.content+y.substring(I.offset+I.length)}e.applyEdit=b;function f(y,I){let k=I.slice(0).sort((m,d)=>{const h=m.offset-d.offset;return h===0?m.length-d.length:h}),C=y.length;for(let m=k.length-1;m>=0;m--){let d=k[m];if(d.offset+d.length<=C)y=b(y,d);else throw new Error("Overlapping edit");C=d.offset}return y}e.applyEdits=f}),define(Z[115],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new S(()=>R(this.getValue()))}}e.Lazy=S}),define(Z[2],x([0,1,45,51]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function M(a){L=a}if(e.setDisposableTracker=M,R){const a="__is_disposable_tracked__";M(new class{trackDisposable(r){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(l)},3e3)}setParent(r,l){if(r&&r!==P.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==P.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function b(a){return L?.trackDisposable(a),a}function f(a){L?.markAsDisposed(a)}function y(a,r){L?.setParent(a,r)}function I(a,r){if(!!L)for(const l of a)L.setParent(l,r)}function k(a){return L?.markAsSingleton(a),a}e.markAsSingleton=k;class C extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=C;function m(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=m;function d(a){if(t.Iterable.is(a)){let r=[];for(const l of a)if(l)try{l.dispose()}catch(g){r.push(g)}if(r.length===1)throw r[0];if(r.length>1)throw new C(r);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=d;function h(...a){const r=w(()=>d(a));return I(a,r),r}e.combinedDisposable=h;function w(a){const r=b({dispose:(0,S.once)(()=>{f(r),a()})});return r}e.toDisposable=w;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return y(r,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new p,b(this),y(this._store,this)}dispose(){f(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&y(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&y(r,null),r}}e.MutableDisposable=v;class u{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(r){let l=r;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,f(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(r,...l){let g=this.references.get(r);g||(g={counter:0,object:this.createReferencedObject(r,...l)},this.references.set(r,g));const{object:E}=g,D=(0,S.once)(()=>{--g.counter==0&&(this.destroyReferencedObject(r,g.object),this.references.delete(r))});return g.counter++,{object:E,dispose:D}}}e.ReferenceCollection=n;class s{constructor(r){this.referenceCollection=r}async acquire(r,...l){const g=this.referenceCollection.acquire(r,...l);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(E){throw g.dispose(),E}}}e.AsyncReferenceCollection=s;class i{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=i;function o(a){const r=new p;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=o}),define(Z[116],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(L){this.element=L,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let L=this._first;for(;L!==S.Undefined;){const M=L.next;L.prev=S.Undefined,L.next=S.Undefined,L=M}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,M){const b=new S(L);if(this._first===S.Undefined)this._first=b,this._last=b;else if(M){const y=this._last;this._last=b,b.prev=y,y.next=b}else{const y=this._first;this._first=b,b.next=y,y.prev=b}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(b))}}shift(){if(this._first!==S.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==S.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==S.Undefined&&L.next!==S.Undefined){const M=L.prev;M.next=L.next,L.next.prev=M}else L.prev===S.Undefined&&L.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):L.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):L.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==S.Undefined;)yield L.element,L=L.next}}e.LinkedList=t}),function(){function j(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function M(f){L.push(f,Date.now())}function b(){const f=[];for(let y=0;y<L.length;y+=2)f.push({name:L[y],startTime:L[y+1]});return f}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))L.push({name:M.name,startTime:Math.round(R+M.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function S(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),define(Z[4],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const S="en";let t=!1,R=!1,L=!1,M=!1,b=!1,f=!1,y=!1,I=!1,k=!1,C,m=S,d,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const p=typeof w?.versions?.electron=="string",P=p&&w?.type==="renderer";if(typeof navigator=="object"&&!P)h=navigator.userAgent,t=h.indexOf("Windows")>=0,R=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,f=!0,C=navigator.language,m=C;else if(typeof w=="object"){t=w.platform==="win32",R=w.platform==="darwin",L=w.platform==="linux",M=L&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,y=p,k=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=S,m=S;const r=w.env.VSCODE_NLS_CONFIG;if(r)try{const l=JSON.parse(r),g=l.availableLanguages["*"];C=l.locale,m=g||S,d=l._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var v;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function u(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let c=0;R?c=1:t?c=3:L&&(c=2),e.isWindows=t,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=M,e.isNative=b,e.isElectron=y,e.isWeb=f,e.isWebWorker=f&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isCI=k,e.platform=c,e.userAgent=h,e.language=m;var n;(function(r){function l(){return e.language}r.value=l;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=g;function E(){return e.language==="en"}r.isDefault=E})(n=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){let r=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let E=0,D=r.length;E<D;E++){const W=r[E];if(W.id===g.data.vscodeScheduleAsyncWork){r.splice(E,1),W.callback();return}}});let l=0;return g=>{const E=++l;r.push({id:E,callback:g}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return r=>setTimeout(r)})();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:t?1:3;let i=!0,o=!1;function a(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,i=new Uint16Array(r.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[35],x([0,1,4]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const R=S.globals.vscode.process;t={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Z[9],x([0,1,35]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,R=97,L=90,M=122,b=46,f=47,y=92,I=58,k=63;class C extends Error{constructor(u,c,n){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const i=u.indexOf(".")!==-1?"property":"argument";let o=`The "${u}" ${i} ${s} of type ${c}`;o+=`. Received type ${typeof n}`;super(o);this.code="ERR_INVALID_ARG_TYPE"}}function m(v,u){if(typeof v!="string")throw new C(u,"string",v)}function d(v){return v===f||v===y}function h(v){return v===f}function w(v){return v>=t&&v<=L||v>=R&&v<=M}function p(v,u,c,n){let s="",i=0,o=-1,a=0,r=0;for(let l=0;l<=v.length;++l){if(l<v.length)r=v.charCodeAt(l);else{if(n(r))break;r=f}if(n(r)){if(!(o===l-1||a===1))if(a===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==b||s.charCodeAt(s.length-2)!==b){if(s.length>2){const g=s.lastIndexOf(c);g===-1?(s="",i=0):(s=s.slice(0,g),i=s.length-1-s.lastIndexOf(c)),o=l,a=0;continue}else if(s.length!==0){s="",i=0,o=l,a=0;continue}}u&&(s+=s.length>0?`${c}..`:"..",i=2)}else s.length>0?s+=`${c}${v.slice(o+1,l)}`:s=v.slice(o+1,l),i=l-o-1;o=l,a=0}else r===b&&a!==-1?++a:a=-1}return s}function P(v,u){if(u===null||typeof u!="object")throw new C("pathObject","Object",u);const c=u.dir||u.root,n=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${n}`:`${c}${v}${n}`:n}e.win32={resolve(...v){let u="",c="",n=!1;for(let s=v.length-1;s>=-1;s--){let i;if(s>=0){if(i=v[s],m(i,"path"),i.length===0)continue}else u.length===0?i=S.cwd():(i=S.env[`=${u}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==u.toLowerCase()&&i.charCodeAt(2)===y)&&(i=`${u}\\`));const o=i.length;let a=0,r="",l=!1;const g=i.charCodeAt(0);if(o===1)d(g)&&(a=1,l=!0);else if(d(g))if(l=!0,d(i.charCodeAt(1))){let E=2,D=E;for(;E<o&&!d(i.charCodeAt(E));)E++;if(E<o&&E!==D){const W=i.slice(D,E);for(D=E;E<o&&d(i.charCodeAt(E));)E++;if(E<o&&E!==D){for(D=E;E<o&&!d(i.charCodeAt(E));)E++;(E===o||E!==D)&&(r=`\\\\${W}\\${i.slice(D,E)}`,a=E)}}}else a=1;else w(g)&&i.charCodeAt(1)===I&&(r=i.slice(0,2),a=2,o>2&&d(i.charCodeAt(2))&&(l=!0,a=3));if(r.length>0)if(u.length>0){if(r.toLowerCase()!==u.toLowerCase())continue}else u=r;if(n){if(u.length>0)break}else if(c=`${i.slice(a)}\\${c}`,n=l,l&&u.length>0)break}return c=p(c,!n,"\\",d),n?`${u}\\${c}`:`${u}${c}`||"."},normalize(v){m(v,"path");const u=v.length;if(u===0)return".";let c=0,n,s=!1;const i=v.charCodeAt(0);if(u===1)return h(i)?"\\":v;if(d(i))if(s=!0,d(v.charCodeAt(1))){let a=2,r=a;for(;a<u&&!d(v.charCodeAt(a));)a++;if(a<u&&a!==r){const l=v.slice(r,a);for(r=a;a<u&&d(v.charCodeAt(a));)a++;if(a<u&&a!==r){for(r=a;a<u&&!d(v.charCodeAt(a));)a++;if(a===u)return`\\\\${l}\\${v.slice(r)}\\`;a!==r&&(n=`\\\\${l}\\${v.slice(r,a)}`,c=a)}}}else c=1;else w(i)&&v.charCodeAt(1)===I&&(n=v.slice(0,2),c=2,u>2&&d(v.charCodeAt(2))&&(s=!0,c=3));let o=c<u?p(v.slice(c),!s,"\\",d):"";return o.length===0&&!s&&(o="."),o.length>0&&d(v.charCodeAt(u-1))&&(o+="\\"),n===void 0?s?`\\${o}`:o:s?`${n}\\${o}`:`${n}${o}`},isAbsolute(v){m(v,"path");const u=v.length;if(u===0)return!1;const c=v.charCodeAt(0);return d(c)||u>2&&w(c)&&v.charCodeAt(1)===I&&d(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let u,c;for(let i=0;i<v.length;++i){const o=v[i];m(o,"path"),o.length>0&&(u===void 0?u=c=o:u+=`\\${o}`)}if(u===void 0)return".";let n=!0,s=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++s;const i=c.length;i>1&&d(c.charCodeAt(1))&&(++s,i>2&&(d(c.charCodeAt(2))?++s:n=!1))}if(n){for(;s<u.length&&d(u.charCodeAt(s));)s++;s>=2&&(u=`\\${u.slice(s)}`)}return e.win32.normalize(u)},relative(v,u){if(m(v,"from"),m(u,"to"),v===u)return"";const c=e.win32.resolve(v),n=e.win32.resolve(u);if(c===n||(v=c.toLowerCase(),u=n.toLowerCase(),v===u))return"";let s=0;for(;s<v.length&&v.charCodeAt(s)===y;)s++;let i=v.length;for(;i-1>s&&v.charCodeAt(i-1)===y;)i--;const o=i-s;let a=0;for(;a<u.length&&u.charCodeAt(a)===y;)a++;let r=u.length;for(;r-1>a&&u.charCodeAt(r-1)===y;)r--;const l=r-a,g=o<l?o:l;let E=-1,D=0;for(;D<g;D++){const O=v.charCodeAt(s+D);if(O!==u.charCodeAt(a+D))break;O===y&&(E=D)}if(D!==g){if(E===-1)return n}else{if(l>g){if(u.charCodeAt(a+D)===y)return n.slice(a+D+1);if(D===2)return n.slice(a+D)}o>g&&(v.charCodeAt(s+D)===y?E=D:D===2&&(E=3)),E===-1&&(E=0)}let W="";for(D=s+E+1;D<=i;++D)(D===i||v.charCodeAt(D)===y)&&(W+=W.length===0?"..":"\\..");return a+=E,W.length>0?`${W}${n.slice(a,r)}`:(n.charCodeAt(a)===y&&++a,n.slice(a,r))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const u=e.win32.resolve(v);if(u.length<=2)return v;if(u.charCodeAt(0)===y){if(u.charCodeAt(1)===y){const c=u.charCodeAt(2);if(c!==k&&c!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(w(u.charCodeAt(0))&&u.charCodeAt(1)===I&&u.charCodeAt(2)===y)return`\\\\?\\${u}`;return v},dirname(v){m(v,"path");const u=v.length;if(u===0)return".";let c=-1,n=0;const s=v.charCodeAt(0);if(u===1)return d(s)?v:".";if(d(s)){if(c=n=1,d(v.charCodeAt(1))){let a=2,r=a;for(;a<u&&!d(v.charCodeAt(a));)a++;if(a<u&&a!==r){for(r=a;a<u&&d(v.charCodeAt(a));)a++;if(a<u&&a!==r){for(r=a;a<u&&!d(v.charCodeAt(a));)a++;if(a===u)return v;a!==r&&(c=n=a+1)}}}}else w(s)&&v.charCodeAt(1)===I&&(c=u>2&&d(v.charCodeAt(2))?3:2,n=c);let i=-1,o=!0;for(let a=u-1;a>=n;--a)if(d(v.charCodeAt(a))){if(!o){i=a;break}}else o=!1;if(i===-1){if(c===-1)return".";i=c}return v.slice(0,i)},basename(v,u){u!==void 0&&m(u,"ext"),m(v,"path");let c=0,n=-1,s=!0,i;if(v.length>=2&&w(v.charCodeAt(0))&&v.charCodeAt(1)===I&&(c=2),u!==void 0&&u.length>0&&u.length<=v.length){if(u===v)return"";let o=u.length-1,a=-1;for(i=v.length-1;i>=c;--i){const r=v.charCodeAt(i);if(d(r)){if(!s){c=i+1;break}}else a===-1&&(s=!1,a=i+1),o>=0&&(r===u.charCodeAt(o)?--o==-1&&(n=i):(o=-1,n=a))}return c===n?n=a:n===-1&&(n=v.length),v.slice(c,n)}for(i=v.length-1;i>=c;--i)if(d(v.charCodeAt(i))){if(!s){c=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":v.slice(c,n)},extname(v){m(v,"path");let u=0,c=-1,n=0,s=-1,i=!0,o=0;v.length>=2&&v.charCodeAt(1)===I&&w(v.charCodeAt(0))&&(u=n=2);for(let a=v.length-1;a>=u;--a){const r=v.charCodeAt(a);if(d(r)){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),r===b?c===-1?c=a:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||s===-1||o===0||o===1&&c===s-1&&c===n+1?"":v.slice(c,s)},format:P.bind(null,"\\"),parse(v){m(v,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return u;const c=v.length;let n=0,s=v.charCodeAt(0);if(c===1)return d(s)?(u.root=u.dir=v,u):(u.base=u.name=v,u);if(d(s)){if(n=1,d(v.charCodeAt(1))){let E=2,D=E;for(;E<c&&!d(v.charCodeAt(E));)E++;if(E<c&&E!==D){for(D=E;E<c&&d(v.charCodeAt(E));)E++;if(E<c&&E!==D){for(D=E;E<c&&!d(v.charCodeAt(E));)E++;E===c?n=E:E!==D&&(n=E+1)}}}}else if(w(s)&&v.charCodeAt(1)===I){if(c<=2)return u.root=u.dir=v,u;if(n=2,d(v.charCodeAt(2))){if(c===3)return u.root=u.dir=v,u;n=3}}n>0&&(u.root=v.slice(0,n));let i=-1,o=n,a=-1,r=!0,l=v.length-1,g=0;for(;l>=n;--l){if(s=v.charCodeAt(l),d(s)){if(!r){o=l+1;break}continue}a===-1&&(r=!1,a=l+1),s===b?i===-1?i=l:g!==1&&(g=1):i!==-1&&(g=-1)}return a!==-1&&(i===-1||g===0||g===1&&i===a-1&&i===o+1?u.base=u.name=v.slice(o,a):(u.name=v.slice(o,i),u.base=v.slice(o,a),u.ext=v.slice(i,a))),o>0&&o!==n?u.dir=v.slice(0,o-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let u="",c=!1;for(let n=v.length-1;n>=-1&&!c;n--){const s=n>=0?v[n]:S.cwd();m(s,"path"),s.length!==0&&(u=`${s}/${u}`,c=s.charCodeAt(0)===f)}return u=p(u,!c,"/",h),c?`/${u}`:u.length>0?u:"."},normalize(v){if(m(v,"path"),v.length===0)return".";const u=v.charCodeAt(0)===f,c=v.charCodeAt(v.length-1)===f;return v=p(v,!u,"/",h),v.length===0?u?"/":c?"./":".":(c&&(v+="/"),u?`/${v}`:v)},isAbsolute(v){return m(v,"path"),v.length>0&&v.charCodeAt(0)===f},join(...v){if(v.length===0)return".";let u;for(let c=0;c<v.length;++c){const n=v[c];m(n,"path"),n.length>0&&(u===void 0?u=n:u+=`/${n}`)}return u===void 0?".":e.posix.normalize(u)},relative(v,u){if(m(v,"from"),m(u,"to"),v===u||(v=e.posix.resolve(v),u=e.posix.resolve(u),v===u))return"";const c=1,n=v.length,s=n-c,i=1,o=u.length-i,a=s<o?s:o;let r=-1,l=0;for(;l<a;l++){const E=v.charCodeAt(c+l);if(E!==u.charCodeAt(i+l))break;E===f&&(r=l)}if(l===a)if(o>a){if(u.charCodeAt(i+l)===f)return u.slice(i+l+1);if(l===0)return u.slice(i+l)}else s>a&&(v.charCodeAt(c+l)===f?r=l:l===0&&(r=0));let g="";for(l=c+r+1;l<=n;++l)(l===n||v.charCodeAt(l)===f)&&(g+=g.length===0?"..":"/..");return`${g}${u.slice(i+r)}`},toNamespacedPath(v){return v},dirname(v){if(m(v,"path"),v.length===0)return".";const u=v.charCodeAt(0)===f;let c=-1,n=!0;for(let s=v.length-1;s>=1;--s)if(v.charCodeAt(s)===f){if(!n){c=s;break}}else n=!1;return c===-1?u?"/":".":u&&c===1?"//":v.slice(0,c)},basename(v,u){u!==void 0&&m(u,"ext"),m(v,"path");let c=0,n=-1,s=!0,i;if(u!==void 0&&u.length>0&&u.length<=v.length){if(u===v)return"";let o=u.length-1,a=-1;for(i=v.length-1;i>=0;--i){const r=v.charCodeAt(i);if(r===f){if(!s){c=i+1;break}}else a===-1&&(s=!1,a=i+1),o>=0&&(r===u.charCodeAt(o)?--o==-1&&(n=i):(o=-1,n=a))}return c===n?n=a:n===-1&&(n=v.length),v.slice(c,n)}for(i=v.length-1;i>=0;--i)if(v.charCodeAt(i)===f){if(!s){c=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":v.slice(c,n)},extname(v){m(v,"path");let u=-1,c=0,n=-1,s=!0,i=0;for(let o=v.length-1;o>=0;--o){const a=v.charCodeAt(o);if(a===f){if(!s){c=o+1;break}continue}n===-1&&(s=!1,n=o+1),a===b?u===-1?u=o:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||n===-1||i===0||i===1&&u===n-1&&u===c+1?"":v.slice(u,n)},format:P.bind(null,"/"),parse(v){m(v,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return u;const c=v.charCodeAt(0)===f;let n;c?(u.root="/",n=1):n=0;let s=-1,i=0,o=-1,a=!0,r=v.length-1,l=0;for(;r>=n;--r){const g=v.charCodeAt(r);if(g===f){if(!a){i=r+1;break}continue}o===-1&&(a=!1,o=r+1),g===b?s===-1?s=r:l!==1&&(l=1):s!==-1&&(l=-1)}if(o!==-1){const g=i===0&&c?1:i;s===-1||l===0||l===1&&s===o-1&&s===i+1?u.base=u.name=v.slice(g,o):(u.name=v.slice(g,s),u.base=v.slice(g,o),u.ext=v.slice(s,o))}return i>0?u.dir=v.slice(0,i-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[71],x([0,1,4]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var R;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(b,...f){const y=f.reduce((C,m)=>(C[m]=!0,C),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(C=>!y[C]).forEach(C=>{for(let m=0;m<I.length;m++)if(C.search(I[m])!==-1){delete b[C];break}})}e.sanitizeProcessEnvironment=L;function M(b){!b||(delete b.DEBUG,S.isMacintosh&&delete b.DYLD_LIBRARY_PATH,S.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(Z[72],x([0,1,4]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class R{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new R(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=R}),define(Z[3],x([0,1,15,45,2,116,72]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let b=!1,f=!1;var y;(function(r){r.None=()=>R.Disposable.None;function l(T){if(f){const{onListenerDidAdd:A}=T,_=d.create();let z=0;T.onListenerDidAdd=()=>{++z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),A?.()}}}function g(T){return(A,_=null,z)=>{let F=!1,B;return B=T(K=>{if(!F)return B?B.dispose():F=!0,A.call(_,K)},null,z),F&&B.dispose(),B}}r.once=g;function E(T,A,_){return ne((z,F=null,B)=>T(K=>z.call(F,A(K)),null,B),_)}r.map=E;function D(T,A,_){return ne((z,F=null,B)=>T(K=>{A(K),z.call(F,K)},null,B),_)}r.forEach=D;function W(T,A,_){return ne((z,F=null,B)=>T(K=>A(K)&&z.call(F,K),null,B),_)}r.filter=W;function O(T){return T}r.signal=O;function V(...T){return(A,_=null,z)=>(0,R.combinedDisposable)(...T.map(F=>F(B=>A.call(_,B),null,z)))}r.any=V;function J(T,A,_,z){let F=_;return E(T,B=>(F=A(F,B),F),z)}r.reduce=J;function ne(T,A){let _;const z={onFirstListenerAdd(){_=T(F.fire,F)},onLastListenerRemove(){_.dispose()}};A||l(z);const F=new w(z);return A&&A.add(F),F.event}function Y(T,A,_=100,z=!1,F,B){let K,ie,oe,ue=0;const fe={leakWarningThreshold:F,onFirstListenerAdd(){K=T(be=>{ue++,ie=A(ie,be),z&&!oe&&(Ie.fire(ie),ie=void 0),clearTimeout(oe),oe=setTimeout(()=>{const le=ie;ie=void 0,oe=void 0,(!z||ue>1)&&Ie.fire(le),ue=0},_)})},onLastListenerRemove(){K.dispose()}};B||l(fe);const Ie=new w(fe);return B&&B.add(Ie),Ie.event}r.debounce=Y;function re(T,A=(z,F)=>z===F,_){let z=!0,F;return W(T,B=>{const K=z||!A(B,F);return z=!1,F=B,K},_)}r.latch=re;function ae(T,A,_){return[r.filter(T,A,_),r.filter(T,z=>!A(z),_)]}r.split=ae;function H(T,A=!1,_=[]){let z=_.slice(),F=T(ie=>{z?z.push(ie):K.fire(ie)});const B=()=>{z&&z.forEach(ie=>K.fire(ie)),z=null},K=new w({onFirstListenerAdd(){F||(F=T(ie=>K.fire(ie)))},onFirstListenerDidAdd(){z&&(A?setTimeout(B):B())},onLastListenerRemove(){F&&F.dispose(),F=null}});return K.event}r.buffer=H;class ${constructor(A){this.event=A}map(A){return new $(E(this.event,A))}forEach(A){return new $(D(this.event,A))}filter(A){return new $(W(this.event,A))}reduce(A,_){return new $(J(this.event,A,_))}latch(){return new $(re(this.event))}debounce(A,_=100,z=!1,F){return new $(Y(this.event,A,_,z,F))}on(A,_,z){return this.event(A,_,z)}once(A,_,z){return g(this.event)(A,_,z)}}function U(T){return new $(T)}r.chain=U;function N(T,A,_=z=>z){const z=(...ie)=>K.fire(_(...ie)),F=()=>T.on(A,z),B=()=>T.removeListener(A,z),K=new w({onFirstListenerAdd:F,onLastListenerRemove:B});return K.event}r.fromNodeEventEmitter=N;function q(T,A,_=z=>z){const z=(...ie)=>K.fire(_(...ie)),F=()=>T.addEventListener(A,z),B=()=>T.removeEventListener(A,z),K=new w({onFirstListenerAdd:F,onLastListenerRemove:B});return K.event}r.fromDOMEventEmitter=q;function ee(T){return new Promise(A=>g(T)(A))}r.toPromise=ee;function Q(T,A){return A(void 0),T(_=>A(_))}r.runAndSubscribe=Q;function X(T,A){let _=null;function z(B){_?.dispose(),_=new R.DisposableStore,A(B,_)}z(void 0);const F=T(B=>z(B));return(0,R.toDisposable)(()=>{F.dispose(),_?.dispose()})}r.runAndSubscribeWithStore=X})(y=e.Event||(e.Event={}));class I{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${I._idPool++}`}start(l){this._stopWatch=new M.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let k=-1;function C(r){const l=k;return k=r,{dispose(){k=l}}}e.setGlobalLeakWarningThreshold=C;class m{constructor(l,g=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,g){let E=k;if(typeof this.customThreshold=="number"&&(E=this.customThreshold),E<=0||g<E)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let W,O=0;for(const[V,J]of this._stacks)(!W||O<J)&&(W=V,O=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${O}):`),console.warn(W)}return()=>{const W=this._stacks.get(l.value)||0;this._stacks.set(l.value,W-1)}}}class d{constructor(l){this.value=l}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(l,g,E){this.callback=l,this.callbackThis=g,this.stack=E,this.subscription=new R.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class w{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=k>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const g of l)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,g,E)=>{this._listeners||(this._listeners=new L.LinkedList);const D=this._listeners.isEmpty();D&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let W,O;this._leakageMon&&this._listeners.size>=30&&(O=d.create(),W=this._leakageMon.check(O,this._listeners.size+1)),b&&(O=O??d.create());const V=new h(l,g,O),J=this._listeners.push(V);D&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,g);const ne=V.subscription.set(()=>{W&&W(),this._disposed||(J(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return E instanceof R.DisposableStore?E.add(ne):Array.isArray(E)&&E.push(ne),ne}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P);for(let g of this._listeners)this._deliveryQueue.push(this,g,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class p{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(l,g,E){this._queue.push(new v(l,g,E))}clear(l){const g=new L.LinkedList;for(const E of this._queue)E.emitter!==l&&g.push(E);this._queue=g}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(g){(0,S.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=p;class P extends p{clear(l){this._queue.clear()}}class v{constructor(l,g,E){this.emitter=l,this.listener=g,this.event=E}}class u extends w{async fireAsync(l,g,E){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const D of this._listeners)this._asyncDeliveryQueue.push([D,l]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[D,W]=this._asyncDeliveryQueue.shift(),O=[],V={...W,token:g,waitUntil:J=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");E&&(J=E(J,D.callback)),O.push(J)}};try{D.invoke(V)}catch(J){(0,S.onUnexpectedError)(J);continue}Object.freeze(O),await Promise.allSettled(O).then(J=>{for(const ne of J)ne.status==="rejected"&&(0,S.onUnexpectedError)(ne.reason)})}}}}e.AsyncEmitter=u;class c extends w{constructor(l){super(l);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class n extends c{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=n;class s extends w{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]})}}e.MicrotaskEmitter=s;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const g={event:l,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const E=()=>{this.hasListeners&&this.unhook(g);const D=this.events.indexOf(g);this.events.splice(D,1)};return(0,R.toDisposable)((0,t.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(g=>this.emitter.fire(g))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.buffers=[]}wrapEvent(l){return(g,E,D)=>l(W=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>g.call(E,W)):g.call(E,W)},void 0,D)}bufferEvents(l){const g=[];this.buffers.push(g);const E=l();return this.buffers.pop(),g.forEach(D=>D()),E}}e.EventBufferer=o;class a{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=R.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(Z[23],x([0,1,3]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(b,f){const y=setTimeout(b.bind(f),0);return{dispose(){clearTimeout(y)}}});var R;(function(b){function f(y){return y===b.None||y===b.Cancelled||y instanceof L?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=f,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=M}),define(Z[117],x([0,1,23]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new S.CancellationTokenSource,f=this.task(b.token);return this.result={promise:f,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=t;class R{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const f=JSON.stringify(b);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=R;class L{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const f=this.fn(b);return this._map.set(b,f),f}}e.CachedFunction=L}),define(Z[86],x([0,1,3,2]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=M=>({onDidChange:S.Event.None,value:M});e.staticObservableValue=R;class L extends t.Disposable{constructor(b){super();this._value=b,this.changeEmitter=this._register(new S.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=L}),define(Z[52],x([0,1,15,2]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(u){const c=u;return c?typeof c.read=="function":!1}e.isReadable=R;function L(u){const c=u;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function M(u){const c=u;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=M;function b(u,c){return new f(u,c)}e.newWriteableStream=b;class f{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,S.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const i=s.indexOf(n);i>=0&&s.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(u,c){const n=[];let s;for(;(s=u.read())!==null;)n.push(s);return c(n)}e.consumeReadable=y;function I(u,c,n){const s=[];let i;for(;(i=u.read())!==null&&s.length<n;)s.push(i);return i===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return u.read()}}}e.peekReadable=I;function k(u,c){return new Promise((n,s)=>{const i=[];C(u,{onData:o=>{c&&i.push(o)},onError:o=>{c?s(o):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=k;function C(u,c){let n=!1;return u.on("error",s=>{n||c.onError(s)}),u.on("end",()=>{n||c.onEnd()}),u.on("data",s=>{n||c.onData(s)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=C;function m(u,c){return new Promise((n,s)=>{const i=new t.DisposableStore,o=[],a=g=>{if(o.push(g),o.length>c)return i.dispose(),u.pause(),n({stream:u,buffer:o,ended:!1})},r=g=>s(g),l=()=>n({stream:u,buffer:o,ended:!0});i.add((0,t.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),i.add((0,t.toDisposable)(()=>u.removeListener("end",l))),u.on("end",l),i.add((0,t.toDisposable)(()=>u.removeListener("data",a))),u.on("data",a)})}e.peekStream=m;function d(u,c){const n=b(c);return n.end(u),n}e.toStream=d;function h(){const u=b(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=h;function w(u){let c=!1;return{read:()=>c?null:(c=!0,u)}}e.toReadable=w;function p(u,c,n){const s=b(n);return C(u,{onData:i=>s.write(c.data(i)),onError:i=>s.error(c.error?c.error(i):i),onEnd:()=>s.end()}),s}e.transform=p;function P(u,c,n){let s=!1;return{read:()=>{const i=c.read();return s?i:(s=!0,i!==null?n([u,i]):u)}}}e.prefixedReadable=P;function v(u,c,n){let s=!1;const i=b(n);return C(c,{onData:o=>s?i.write(o):(s=!0,i.write(n([u,o]))),onError:o=>i.error(o),onEnd:()=>{s||(s=!0,i.write(u)),i.end()}}),i}e.prefixedStream=v}),define(Z[18],x([0,1,52]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let R,L;class M{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return t?new M(Buffer.allocUnsafe(g)):new M(new Uint8Array(g))}static wrap(g){return t&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new M(g)}static fromString(g,E){return!(E?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(g)):(R||(R=new TextEncoder),new M(R.encode(g)))}static fromByteArray(g){const E=M.alloc(g.length);for(let D=0,W=g.length;D<W;D++)E.buffer[D]=g[D];return E}static concat(g,E){if(typeof E=="undefined"){E=0;for(let O=0,V=g.length;O<V;O++)E+=g[O].byteLength}const D=M.alloc(E);let W=0;for(let O=0,V=g.length;O<V;O++){const J=g[O];D.set(J,W),W+=J.byteLength}return D}clone(){const g=M.alloc(this.byteLength);return g.set(this),g}toString(){return t?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(g,E){return new M(this.buffer.subarray(g,E))}set(g,E){if(g instanceof M)this.buffer.set(g.buffer,E);else if(g instanceof Uint8Array)this.buffer.set(g,E);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),E);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return y(this.buffer,g)}writeUInt32BE(g,E){I(this.buffer,g,E)}readUInt32LE(g){return k(this.buffer,g)}writeUInt32LE(g,E){C(this.buffer,g,E)}readUInt8(g){return m(this.buffer,g)}writeUInt8(g,E){d(this.buffer,g,E)}}e.VSBuffer=M;function b(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0}e.readUInt16LE=b;function f(l,g,E){l[E+0]=g&255,g=g>>>8,l[E+1]=g&255}e.writeUInt16LE=f;function y(l,g){return l[g]*2**24+l[g+1]*2**16+l[g+2]*2**8+l[g+3]}e.readUInt32BE=y;function I(l,g,E){l[E+3]=g,g=g>>>8,l[E+2]=g,g=g>>>8,l[E+1]=g,g=g>>>8,l[E]=g}e.writeUInt32BE=I;function k(l,g){return l[g+0]<<0>>>0|l[g+1]<<8>>>0|l[g+2]<<16>>>0|l[g+3]<<24>>>0}e.readUInt32LE=k;function C(l,g,E){l[E+0]=g&255,g=g>>>8,l[E+1]=g&255,g=g>>>8,l[E+2]=g&255,g=g>>>8,l[E+3]=g&255}e.writeUInt32LE=C;function m(l,g){return l[g]}e.readUInt8=m;function d(l,g,E){l[E]=g}e.writeUInt8=d;function h(l){return S.consumeReadable(l,g=>M.concat(g))}e.readableToBuffer=h;function w(l){return S.toReadable(l)}e.bufferToReadable=w;function p(l){return S.consumeStream(l,g=>M.concat(g))}e.streamToBuffer=p;async function P(l){return l.ended?M.concat(l.buffer):M.concat([...l.buffer,await p(l.stream)])}e.bufferedStreamToBuffer=P;function v(l){return S.toStream(l,g=>M.concat(g))}e.bufferToStream=v;function u(l){return S.transform(l,{data:g=>typeof g=="string"?M.fromString(g):M.wrap(g)},g=>M.concat(g))}e.streamToBufferReadableStream=u;function c(l){return S.newWriteableStream(g=>M.concat(g),l)}e.newWriteableBufferStream=c;function n(l,g){return S.prefixedReadable(l,g,E=>M.concat(E))}e.prefixedBufferReadable=n;function s(l,g){return S.prefixedStream(l,g,E=>M.concat(E))}e.prefixedBufferStream=s;function i(l){let g=0,E=0,D=0;const W=new Uint8Array(Math.floor(l.length/4*3)),O=J=>{switch(E){case 3:W[D++]=g|J,E=0;break;case 2:W[D++]=g|J>>>2,g=J<<6,E=3;break;case 1:W[D++]=g|J>>>4,g=J<<4,E=2;break;default:g=J<<2,E=1}};for(let J=0;J<l.length;J++){const ne=l.charCodeAt(J);if(ne>=65&&ne<=90)O(ne-65);else if(ne>=97&&ne<=122)O(ne-97+26);else if(ne>=48&&ne<=57)O(ne-48+52);else if(ne===43||ne===45)O(62);else if(ne===47||ne===95)O(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${l[J]}`)}}const V=D;for(;E>0;)O(0);return M.wrap(W).slice(0,V)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:l},g=!0,E=!1){const D=E?a:o;let W="";const O=l.byteLength%3;let V=0;for(;V<l.byteLength-O;V+=3){const J=l[V+0],ne=l[V+1],Y=l[V+2];W+=D[J>>>2],W+=D[(J<<4|ne>>>4)&63],W+=D[(ne<<2|Y>>>6)&63],W+=D[Y&63]}if(O===1){const J=l[V+0];W+=D[J>>>2],W+=D[J<<4&63],g&&(W+="==")}else if(O===2){const J=l[V+0],ne=l[V+1];W+=D[J>>>2],W+=D[(J<<4|ne>>>4)&63],W+=D[ne<<2&63],g&&(W+="=")}return W}e.encodeBase64=r}),define(Z[30],x([0,1,117,115]),function(j,e,S,t){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=L;const M=/{(\d+)}/g;function b(G,...se){return se.length===0?G:G.replace(M,function(ce,we){const ye=parseInt(we,10);return isNaN(ye)||ye<0||ye>=se.length?ce:se[ye]})}e.format=b;const f=/{([^}]+)}/g;function y(G,se){return G.replace(f,(ce,we)=>se[we]??ce)}e.format2=y;function I(G){return G.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=I;function k(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function C(G,se){let ce=0;const we=se.charCodeAt(0);for(let ye=G.length-1;ye>=0;ye--)G.charCodeAt(ye)===we&&ce++;return ce}e.count=C;function m(G,se,ce="\u2026"){return G.length<=se?G:`${G.substr(0,se)}${ce}`}e.truncate=m;function d(G,se=" "){const ce=h(G,se);return w(ce,se)}e.trim=d;function h(G,se){if(!G||!se)return G;const ce=se.length;if(ce===0||G.length===0)return G;let we=0;for(;G.indexOf(se,we)===we;)we=we+ce;return G.substring(we)}e.ltrim=h;function w(G,se){if(!G||!se)return G;const ce=se.length,we=G.length;if(ce===0||we===0)return G;let ye=we,Me=-1;for(;Me=G.lastIndexOf(se,ye-1),!(Me===-1||Me+ce!==ye);){if(Me===0)return"";ye=Me}return G.substring(0,ye)}e.rtrim=w;function p(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function P(G){return G.replace(/\*/g,"")}e.stripWildcards=P;function v(G,se,ce={}){if(!G)throw new Error("Cannot create regex from empty string");se||(G=k(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(G,we)}e.createRegExp=v;function u(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=n;function s(G){return G.split(/\r\n|\r|\n/)}e.splitLines=s;function i(G){for(let se=0,ce=G.length;se<ce;se++){const we=G.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=i;function o(G,se=0,ce=G.length){for(let we=se;we<ce;we++){const ye=G.charCodeAt(we);if(ye!==32&&ye!==9)return G.substring(se,we)}return G.substring(se,ce)}e.getLeadingWhitespace=o;function a(G,se=G.length-1){for(let ce=se;ce>=0;ce--){const we=G.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function r(G,se,ce){let we=[],ye=0;for(const Me of G.matchAll(se)){if(we.push(G.slice(ye,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");ye=Me.index+Me[0].length,we.push(ce(Me[0],...Me.slice(1),Me.index,G,Me.groups))}return we.push(G.slice(ye)),Promise.all(we).then(Me=>Me.join(""))}e.replaceAsync=r;function l(G,se){return G<se?-1:G>se?1:0}e.compare=l;function g(G,se,ce=0,we=G.length,ye=0,Me=se.length){for(;ce<we&&ye<Me;ce++,ye++){let Je=G.charCodeAt(ce),Be=se.charCodeAt(ye);if(Je<Be)return-1;if(Je>Be)return 1}const ze=we-ce,xe=Me-ye;return ze<xe?-1:ze>xe?1:0}e.compareSubstring=g;function E(G,se){return D(G,se,0,G.length,0,se.length)}e.compareIgnoreCase=E;function D(G,se,ce=0,we=G.length,ye=0,Me=se.length){for(;ce<we&&ye<Me;ce++,ye++){let Je=G.charCodeAt(ce),Be=se.charCodeAt(ye);if(Je===Be)continue;if(Je>=128||Be>=128)return g(G.toLowerCase(),se.toLowerCase(),ce,we,ye,Me);W(Je)&&(Je-=32),W(Be)&&(Be-=32);const Ke=Je-Be;if(Ke!==0)return Ke}const ze=we-ce,xe=Me-ye;return ze<xe?-1:ze>xe?1:0}e.compareSubstringIgnoreCase=D;function W(G){return G>=97&&G<=122}e.isLowerAsciiLetter=W;function O(G){return G>=65&&G<=90}e.isUpperAsciiLetter=O;function V(G,se){return G.length===se.length&&D(G,se)===0}e.equalsIgnoreCase=V;function J(G,se){const ce=se.length;return se.length>G.length?!1:D(G,se,0,ce)===0}e.startsWithIgnoreCase=J;function ne(G,se){let ce,we=Math.min(G.length,se.length);for(ce=0;ce<we;ce++)if(G.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=ne;function Y(G,se){let ce,we=Math.min(G.length,se.length);const ye=G.length-1,Me=se.length-1;for(ce=0;ce<we;ce++)if(G.charCodeAt(ye-ce)!==se.charCodeAt(Me-ce))return ce;return we}e.commonSuffixLength=Y;function re(G){return 55296<=G&&G<=56319}e.isHighSurrogate=re;function ae(G){return 56320<=G&&G<=57343}e.isLowSurrogate=ae;function H(G,se){return(G-55296<<10)+(se-56320)+65536}e.computeCodePoint=H;function $(G,se,ce){const we=G.charCodeAt(ce);if(re(we)&&ce+1<se){const ye=G.charCodeAt(ce+1);if(ae(ye))return H(we,ye)}return we}e.getNextCodePoint=$;function U(G,se){const ce=G.charCodeAt(se-1);if(ae(ce)&&se>1){const we=G.charCodeAt(se-2);if(re(we))return H(we,ce)}return ce}class N{constructor(se,ce=0){this._str=se,this._len=se.length,this._offset=ce}get offset(){return this._offset}setOffset(se){this._offset=se}prevCodePoint(){const se=U(this._str,this._offset);return this._offset-=se>=65536?2:1,se}nextCodePoint(){const se=$(this._str,this._len,this._offset);return this._offset+=se>=65536?2:1,se}eol(){return this._offset>=this._len}}e.CodePointIterator=N;class q{constructor(se,ce=0){this._iterator=new N(se,ce)}get offset(){return this._iterator.offset}nextGraphemeLength(){const se=Ue.getInstance(),ce=this._iterator,we=ce.offset;let ye=se.getGraphemeBreakType(ce.nextCodePoint());for(;!ce.eol();){const Me=ce.offset,ze=se.getGraphemeBreakType(ce.nextCodePoint());if(Te(ye,ze)){ce.setOffset(Me);break}ye=ze}return ce.offset-we}prevGraphemeLength(){const se=Ue.getInstance(),ce=this._iterator,we=ce.offset;let ye=se.getGraphemeBreakType(ce.prevCodePoint());for(;ce.offset>0;){const Me=ce.offset,ze=se.getGraphemeBreakType(ce.prevCodePoint());if(Te(ze,ye)){ce.setOffset(Me);break}ye=ze}return we-ce.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function ee(G,se){return new q(G,se).nextGraphemeLength()}e.nextCharLength=ee;function Q(G,se){return new q(G,se).prevGraphemeLength()}e.prevCharLength=Q;function X(G,se){se>0&&ae(G.charCodeAt(se))&&se--;const ce=se+ee(G,se);return[ce-Q(G,ce),ce]}e.getCharContainingOffset=X;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(G){return T.test(G)}e.containsRTL=A;const _=/^[\t\n\r\x20-\x7E]*$/;function z(G){return _.test(G)}e.isBasicASCII=z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=F;function B(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=B;function K(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=K;function ie(G,se){if(G.length<se)return G;const ce=/\b/g;let we=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return G.substring(we).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function Ie(G){return G&&(G=G.replace(oe,""),G=G.replace(ue,""),G=G.replace(fe,"")),G}e.removeAnsiEscapeCodes=Ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function le(G){return be(G)?G.substr(1):G}e.stripUTF8BOM=le;function de(G,se){if(!G||!se||G.length<se.length)return!1;const ce=se.length,we=G.toLowerCase();let ye=0,Me=-1;for(;ye<ce;){const ze=we.indexOf(se[ye],Me+1);if(ze<0)return!1;Me=ze,ye++}return!0}e.fuzzyContains=de;function Ce(G,se=!1){return G?(se&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ce;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function Se(G,se=1){if(se===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=Se;function De(G){const se=90-65+1;return G=G%(2*se),G<se?String.fromCharCode(97+G):String.fromCharCode(65+G-se)}e.singleLetterHash=De;function Re(G){return Ue.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Re;function Te(G,se){return G===0?se!==5&&se!==7:G===2&&se===3?!1:G===4||G===2||G===3||se===4||se===2||se===3?!0:!(G===8&&(se===8||se===9||se===11||se===12)||(G===11||G===9)&&(se===9||se===10)||(G===12||G===10)&&se===10||se===5||se===13||se===7||G===1||G===13&&se===14||G===6&&se===6)}var Ae;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ae=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Ve()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let ye=1;for(;ye<=we;)if(se<ce[3*ye])ye=2*ye;else if(se>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Ue._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(G,se){if(G===0)return 0;const ce=$e(G,se);if(ce!==void 0)return ce;const we=new N(se,G);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=Qe;function $e(G,se){const ce=new N(se,G);let we=ce.prevCodePoint();for(;Xe(we)||we===65039||we===8419;){if(ce.offset===0)return;we=ce.prevCodePoint()}if(!K(we))return;let ye=ce.offset;return ye>0&&ce.prevCodePoint()===8205&&(ye=ce.offset),ye}function Xe(G){return 127995<=G&&G<=127999}var rt;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Ge{constructor(se){this.confusableDictionary=se}static getInstance(se){return Ge.cache.get(Array.from(se))}static getLocales(){return Ge._locales.getValue()}isAmbiguous(se){return this.confusableDictionary.has(se)}getPrimaryConfusable(se){return this.confusableDictionary.get(se)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ge,R=Ge,Ge.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.cache=new S.LRUCachedFunction(G=>{function se(Be){const Ke=new Map;for(let Ye=0;Ye<Be.length;Ye+=2)Ke.set(Be[Ye],Be[Ye+1]);return Ke}function ce(Be,Ke){const Ye=new Map(Be);for(const[st,ct]of Ke)Ye.set(st,ct);return Ye}function we(Be,Ke){if(!Be)return Ke;const Ye=new Map;for(const[st,ct]of Be)Ke.has(st)&&Ye.set(st,ct);return Ye}const ye=R.ambiguousCharacterData.getValue();let Me=G.filter(Be=>!Be.startsWith("_")&&Be in ye);Me.length===0&&(Me=["_default"]);let ze;for(const Be of Me){const Ke=se(ye[Be]);ze=we(ze,Ke)}const xe=se(ye._common),Je=ce(xe,ze);return new Ge(Je)}),Ge._locales=new t.Lazy(()=>Object.keys(Ge.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class nt{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(nt.getRawData())),this._data}static isInvisibleCharacter(se){return nt.getData().has(se)}static get codePoints(){return nt.getData()}}e.InvisibleCharacters=nt,nt._data=void 0}),define(Z[73],x([0,1,30]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(p){return R(p,0)}e.hash=t;function R(p,P){switch(typeof p){case"object":return p===null?L(349,P):Array.isArray(p)?f(p,P):y(p,P);case"string":return b(p,P);case"boolean":return M(p,P);case"number":return L(p,P);case"undefined":return L(937,P);default:return L(617,P)}}e.doHash=R;function L(p,P){return(P<<5)-P+p|0}e.numberHash=L;function M(p,P){return L(p?433:863,P)}function b(p,P){P=L(149417,P);for(let v=0,u=p.length;v<u;v++)P=L(p.charCodeAt(v),P);return P}e.stringHash=b;function f(p,P){return P=L(104579,P),p.reduce((v,u)=>R(u,v),P)}function y(p,P){return P=L(181387,P),Object.keys(p).sort().reduce((v,u)=>(v=b(u,v),R(p[u],v)),P)}class I{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=R(P,this._value),this._value}}e.Hasher=I;var k;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function C(p,P,v=32){const u=v-P,c=~((1<<u)-1);return(p<<P|(c&p)>>>u)>>>0}function m(p,P=0,v=p.byteLength,u=0){for(let c=0;c<v;c++)p[P+c]=u}function d(p,P,v="0"){for(;p.length<P;)p=v+p;return p}function h(p,P=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(v=>v.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),P/4)}e.toHexString=h;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const v=P.length;if(v===0)return;const u=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,s,i;for(n!==0?(s=n,i=-1,n=0):(s=P.charCodeAt(0),i=0);;){let o=s;if(S.isHighSurrogate(s))if(i+1<v){const a=P.charCodeAt(i+1);S.isLowSurrogate(a)?(i++,o=S.computeCodePoint(s,a)):o=65533}else{n=s;break}else S.isLowSurrogate(s)&&(o=65533);if(c=this._push(u,c,o),i++,i<v)s=P.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(P,v,u){return u<128?P[v++]=u:u<2048?(P[v++]=192|(u&1984)>>>6,P[v++]=128|(u&63)>>>0):u<65536?(P[v++]=224|(u&61440)>>>12,P[v++]=128|(u&4032)>>>6,P[v++]=128|(u&63)>>>0):(P[v++]=240|(u&1835008)>>>18,P[v++]=128|(u&258048)>>>12,P[v++]=128|(u&4032)>>>6,P[v++]=128|(u&63)>>>0),v>=64&&(this._step(),v-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),v}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=w._bigBlock32,v=this._buffDV;for(let l=0;l<64;l+=4)P.setUint32(l,v.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)P.setUint32(l,C(P.getUint32(l-12,!1)^P.getUint32(l-32,!1)^P.getUint32(l-56,!1)^P.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,n=this._h2,s=this._h3,i=this._h4,o,a,r;for(let l=0;l<80;l++)l<20?(o=c&n|~c&s,a=1518500249):l<40?(o=c^n^s,a=1859775393):l<60?(o=c&n|c&s|n&s,a=2400959708):(o=c^n^s,a=3395469782),r=C(u,5)+o+i+a+P.getUint32(l*4,!1)&4294967295,i=s,s=n,n=C(c,30),c=u,u=r;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))});var Lt=this&&this.__classPrivateFieldSet||function(j,e,S,t,R){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!R:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?R.call(j,S):R?R.value=S:e.set(j,S),S},it=this&&this.__classPrivateFieldGet||function(j,e,S,t){if(S==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!t:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?t:S==="a"?t.call(j):t?t.value:e.get(j)};define(Z[36],x([0,1,25,30]),function(j,e,S,t){"use strict";var R,L,M,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,r,l){let g=a.get(r);return g===void 0&&(g=l,a.set(r,g)),g}e.getOrSet=f;function y(a){const r=[];return a.forEach((l,g)=>{r.push(`${g} => ${l}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=y;function I(a){const r=[];return a.forEach(l=>{r.push(l)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=I;class k{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const l=r.charCodeAt(0),g=this._value.charCodeAt(this._pos);return l-g}value(){return this._value[this._pos]}}e.StringIterator=k;class C{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class m{constructor(r=!0,l=!0){this._splitOnBackslash=r,this._caseSensitive=l}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let l=r.length-1;l>=0;l--,this._valueLen--){const g=this._value.charCodeAt(l);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class h{constructor(r,l){this._ignorePathCasing=r,this._ignoreQueryAndFragment=l,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(p||(p={}));class P{constructor(r){this._iter=r}static forUris(r=()=>!1,l=()=>!1){return new P(new h(r,l))}static forPaths(r=!1){return new P(new m(void 0,!r))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new C)}clear(){this._root=void 0}fill(r,l){if(l){const g=l.slice(0);(0,S.shuffle)(g);for(let E of g)this.set(E,r)}else{const g=r.slice(0);(0,S.shuffle)(g);for(let E of g)this.set(E[0],E[1])}}set(r,l){const g=this._iter.reset(r);let E;this._root||(this._root=new w,this._root.segment=g.value());const D=[];for(E=this._root;;){const O=g.cmp(E.segment);if(O>0)E.left||(E.left=new w,E.left.segment=g.value()),D.push([-1,E]),E=E.left;else if(O<0)E.right||(E.right=new w,E.right.segment=g.value()),D.push([1,E]),E=E.right;else if(g.hasNext())g.next(),E.mid||(E.mid=new w,E.mid.segment=g.value()),D.push([0,E]),E=E.mid;else break}const W=E.value;E.value=l,E.key=r;for(let O=D.length-1;O>=0;O--){const V=D[O][1];V.updateHeight();const J=V.balanceFactor();if(J<-1||J>1){const ne=D[O][0],Y=D[O+1][0];if(ne===1&&Y===1)D[O][1]=V.rotateLeft();else if(ne===-1&&Y===-1)D[O][1]=V.rotateRight();else if(ne===1&&Y===-1)V.right=D[O+1][1]=D[O+1][1].rotateRight(),D[O][1]=V.rotateLeft();else if(ne===-1&&Y===1)V.left=D[O+1][1]=D[O+1][1].rotateLeft(),D[O][1]=V.rotateRight();else throw new Error;if(O>0)switch(D[O-1][0]){case-1:D[O-1][1].left=D[O][1];break;case 1:D[O-1][1].right=D[O][1];break;case 0:D[O-1][1].mid=D[O][1];break}else this._root=D[0][1]}}return W}get(r){return this._getNode(r)?.value}_getNode(r){const l=this._iter.reset(r);let g=this._root;for(;g;){const E=l.cmp(g.segment);if(E>0)g=g.left;else if(E<0)g=g.right;else if(l.hasNext())l.next(),g=g.mid;else break}return g}has(r){const l=this._getNode(r);return!(l?.value===void 0&&l?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,l){const g=this._iter.reset(r),E=[];let D=this._root;for(;D;){const W=g.cmp(D.segment);if(W>0)E.push([-1,D]),D=D.left;else if(W<0)E.push([1,D]),D=D.right;else if(g.hasNext())g.next(),E.push([0,D]),D=D.mid;else break}if(!!D){if(l?(D.left=void 0,D.mid=void 0,D.right=void 0,D.height=1):(D.key=void 0,D.value=void 0),!D.mid&&!D.value)if(D.left&&D.right){const W=this._min(D.right),{key:O,value:V,segment:J}=W;this._delete(W.key,!1),D.key=O,D.value=V,D.segment=J}else{const W=D.left??D.right;if(E.length>0){const[O,V]=E[E.length-1];switch(O){case-1:V.left=W;break;case 0:V.mid=W;break;case 1:V.right=W;break}}else this._root=W}for(let W=E.length-1;W>=0;W--){const O=E[W][1];O.updateHeight();const V=O.balanceFactor();if(V>1?(O.right.balanceFactor()>=0||(O.right=O.right.rotateRight()),E[W][1]=O.rotateLeft()):V<-1&&(O.left.balanceFactor()<=0||(O.left=O.left.rotateLeft()),E[W][1]=O.rotateRight()),W>0)switch(E[W-1][0]){case-1:E[W-1][1].left=E[W][1];break;case 1:E[W-1][1].right=E[W][1];break;case 0:E[W-1][1].mid=E[W][1];break}else this._root=E[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const l=this._iter.reset(r);let g=this._root,E;for(;g;){const D=l.cmp(g.segment);if(D>0)g=g.left;else if(D<0)g=g.right;else if(l.hasNext())l.next(),E=g.value||E,g=g.mid;else break}return g&&g.value||E}findSuperstr(r){const l=this._iter.reset(r);let g=this._root;for(;g;){const E=l.cmp(g.segment);if(E>0)g=g.left;else if(E<0)g=g.right;else if(l.hasNext())l.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(r){for(const[l,g]of this)r(g,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=l=>{if(!l)return!0;const g=l.balanceFactor();return g<-1||g>1?!1:r(l.left)&&r(l.right)};return r(this._root)}}e.TernarySearchTree=P;class v{constructor(r,l){this.uri=r,this.value=l}}class u{constructor(r,l){this[R]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=l??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,l){return this.map.set(this.toKey(r),new v(r,l)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,l){typeof l!="undefined"&&(r=r.bind(l));for(let[g,E]of this.map)r(E.value,E.uri,this)}*values(){for(let r of this.map.values())yield r.value}*keys(){for(let r of this.map.values())yield r.uri}*entries(){for(let r of this.map.values())yield[r.uri,r.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=u,u.defaultToKey=a=>a.toString();class c{constructor(r,l){this[L]="ResourceSet",!r||typeof r=="function"?this._map=new u(r):(this._map=new u(l),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,l){this._map.forEach((g,E)=>r.call(l,E,E,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var n;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(n=e.Touch||(e.Touch={}));class s{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,l=0){const g=this._map.get(r);if(!!g)return l!==0&&this.touch(g,l),g.value}set(r,l,g=0){let E=this._map.get(r);if(E)E.value=l,g!==0&&this.touch(E,g);else{switch(E={key:r,value:l,next:void 0,previous:void 0},g){case 0:this.addItemLast(E);break;case 1:this.addItemFirst(E);break;case 2:this.addItemLast(E);break;default:this.addItemLast(E);break}this._map.set(r,E),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const l=this._map.get(r);if(!!l)return this._map.delete(r),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,l){const g=this._state;let E=this._head;for(;E;){if(l?r.bind(l)(E.value,E.key,this):r(E.value,E.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const r=this,l=this._state;let g=this._head;const E={[Symbol.iterator](){return E},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(g){const D={value:g.key,done:!1};return g=g.next,D}else return{value:void 0,done:!0}}};return E}values(){const r=this,l=this._state;let g=this._head;const E={[Symbol.iterator](){return E},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(g){const D={value:g.value,done:!1};return g=g.next,D}else return{value:void 0,done:!0}}};return E}entries(){const r=this,l=this._state;let g=this._head;const E={[Symbol.iterator](){return E},next(){if(r._state!==l)throw new Error("LinkedMap got modified during iteration.");if(g){const D={value:[g.key,g.value],done:!1};return g=g.next,D}else return{value:void 0,done:!0}}};return E}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let l=this._head,g=this.size;for(;l&&g>r;)this._map.delete(l.key),l=l.next,g--;this._head=l,this._size=g,l&&(l.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const l=r.next,g=r.previous;if(!l||!g)throw new Error("Invalid list");l.previous=g,g.next=l}r.next=void 0,r.previous=void 0,this._state++}touch(r,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(r===this._head)return;const g=r.next,E=r.previous;r===this._tail?(E.next=void 0,this._tail=E):(g.previous=E,E.next=g),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(l===2){if(r===this._tail)return;const g=r.next,E=r.previous;r===this._head?(g.previous=void 0,this._head=g):(g.previous=E,E.next=g),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((l,g)=>{r.push([g,l])}),r}fromJSON(r){this.clear();for(const[l,g]of r)this.set(l,g)}}e.LinkedMap=s;class i extends s{constructor(r,l=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,l=2){return super.get(r,l)}peek(r){return super.get(r,0)}set(r,l){return super.set(r,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class o{constructor(r){b.set(this,void 0),Lt(this,b,r,"f")}get size(){return it(this,b,"f").size}forEach(r,l){it(this,b,"f").forEach(r,l)}get(r){return it(this,b,"f").get(r)}has(r){return it(this,b,"f").has(r)}entries(){return it(this,b,"f").entries()}keys(){return it(this,b,"f").keys()}values(){return it(this,b,"f").values()}[(b=new WeakMap,Symbol.iterator)](){return it(this,b,"f").entries()}}e.ReadonlyMapView=o}),define(Z[74],x([0,1,36]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function R(y){return f(y,"NFC",t)}e.normalizeNFC=R;const L=new S.LRUCache(1e4);function M(y){return f(y,"NFD",L)}e.normalizeNFD=M;const b=/[^\u0000-\u0080]/;function f(y,I,k){if(!y)return y;const C=k.get(y);if(C)return C;let m;return b.test(y)?m=y.normalize(I):m=y,k.set(y,m),m}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(I){return M(I).replace(y,"")}}()}),define(Z[11],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(l){return Array.isArray(l)}e.isArray=S;function t(l){return typeof l=="string"}e.isString=t;function R(l){return Array.isArray(l)&&l.every(g=>t(g))}e.isStringArray=R;function L(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=L;function M(l){return typeof l=="object"&&(l instanceof Uint8Array||l instanceof Uint16Array||l instanceof Uint32Array||l instanceof Float32Array||l instanceof Float64Array||l instanceof Int8Array||l instanceof Int16Array||l instanceof Int32Array||l instanceof BigInt64Array||l instanceof BigUint64Array||l instanceof Uint8ClampedArray)}e.isTypedArray=M;function b(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=b;function f(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=f;function y(l){return l===!0||l===!1}e.isBoolean=y;function I(l){return typeof l=="undefined"}e.isUndefined=I;function k(l){return!C(l)}e.isDefined=k;function C(l){return I(l)||l===null}e.isUndefinedOrNull=C;function m(l,g){if(!l)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=m;function d(l){if(C(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=d;function h(...l){const g=[];for(let E=0;E<l.length;E++){const D=l[E];if(C(D))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);g.push(D)}return g}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function p(l){if(!L(l))return!1;for(let g in l)if(w.call(l,g))return!1;return!0}e.isEmptyObject=p;function P(l){return typeof l=="function"}e.isFunction=P;function v(...l){return l.length>0&&l.every(P)}e.areFunctions=v;function u(l,g){const E=Math.min(l.length,g.length);for(let D=0;D<E;D++)c(l[D],g[D])}e.validateConstraints=u;function c(l,g){if(t(g)){if(typeof l!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(P(g)){try{if(l instanceof g)return}catch{}if(!C(l)&&l.constructor===g||g.length===1&&g.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function n(l){let g=[],E=Object.getPrototypeOf(l);for(;Object.prototype!==E;)g=g.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return g}e.getAllPropertyNames=n;function s(l){const g=[];for(const E of n(l))typeof l[E]=="function"&&g.push(E);return g}e.getAllMethodNames=s;function i(l,g){const E=W=>function(){const O=Array.prototype.slice.call(arguments,0);return g(W,O)};let D={};for(const W of l)D[W]=E(W);return D}e.createProxyObject=i;function o(l){return l===null?void 0:l}e.withNullAsUndefined=o;function a(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=a;function r(l,g="Unreachable"){throw new Error(g)}e.assertNever=r}),define(Z[28],x([0,1,9,4,30,11]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(a){return a===47||a===92}e.isPathSeparator=M;function b(a){return a.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=b;function f(a){return a.indexOf("/")===-1&&(a=b(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=f;function y(a,r=S.posix.sep){if(!a)return"";const l=a.length,g=a.charCodeAt(0);if(M(g)){if(M(a.charCodeAt(1))&&!M(a.charCodeAt(2))){let D=3;const W=D;for(;D<l&&!M(a.charCodeAt(D));D++);if(W!==D&&!M(a.charCodeAt(D+1))){for(D+=1;D<l;D++)if(M(a.charCodeAt(D)))return a.slice(0,D+1).replace(/[\\/]/g,r)}}return r}else if(p(g)&&a.charCodeAt(1)===58)return M(a.charCodeAt(2))?a.slice(0,2)+r:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<l;E++)if(M(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.getRoot=y;function I(a){if(!t.isWindows||!a||a.length<5)return!1;let r=a.charCodeAt(0);if(r!==92||(r=a.charCodeAt(1),r!==92))return!1;let l=2;const g=l;for(;l<a.length&&(r=a.charCodeAt(l),r!==92);l++);return!(g===l||(r=a.charCodeAt(l+1),isNaN(r)||r===92))}e.isUNC=I;const k=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(a,r=t.isWindows){const l=r?k:C;return!(!a||a.length===0||/^\s+$/.test(a)||(l.lastIndex=0,l.test(a))||r&&m.test(a)||a==="."||a===".."||r&&a[a.length-1]==="."||r&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=d;function h(a,r,l){const g=a===r;return!l||g?g:!a||!r?!1:(0,R.equalsIgnoreCase)(a,r)}e.isEqual=h;function w(a,r,l,g=S.sep){if(a===r)return!0;if(!a||!r||r.length>a.length)return!1;if(l){if(!(0,R.startsWithIgnoreCase)(a,r))return!1;if(r.length===a.length)return!0;let D=r.length;return r.charAt(r.length-1)===g&&D--,a.charAt(D)===g}return r.charAt(r.length-1)!==g&&(r+=g),a.indexOf(r)===0}e.isEqualOrParent=w;function p(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=p;function P(a,r){return t.isWindows&&a.endsWith(":")&&(a+=S.sep),(0,S.isAbsolute)(a)||(a=(0,S.join)(r,a)),a=(0,S.normalize)(a),t.isWindows?(a=(0,R.rtrim)(a,S.sep),a.endsWith(":")&&(a+=S.sep)):(a=(0,R.rtrim)(a,S.sep),a||(a=S.sep)),a}e.sanitizeFilePath=P;function v(a){const r=(0,S.normalize)(a);return t.isWindows?a.length>3?!1:u(r)&&(a.length===2||r.charCodeAt(2)===92):r===S.posix.sep}e.isRootOrDriveLetter=v;function u(a,r=t.isWindows){return r?p(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(a){return u(a)?a[0]:void 0}e.getDriveLetter=c;function n(a,r,l){return r.length>a.length?-1:a===r?0:(l&&(a=a.toLowerCase(),r=r.toLowerCase()),a.indexOf(r))}e.indexOfPath=n;function s(a){const r=a.split(":");let l,g,E;for(const D of r){const W=Number(D);(0,L.isNumber)(W)?g===void 0?g=W:E===void 0&&(E=W):l=l?[l,D].join(":"):D}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:g!==void 0?g:void 0,column:E!==void 0?E:g!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,r,l=8){let g="";for(let D=0;D<l;D++)g+=i.charAt(Math.floor(Math.random()*i.length));let E;return r?E=`${r}-${g}`:E=g,a?(0,S.join)(a,E):E}e.randomPath=o}),define(Z[47],x([0,1,11]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const w=Array.isArray(h)?[]:{};return Object.keys(h).forEach(p=>{h[p]&&typeof h[p]=="object"?w[p]=t(h[p]):w[p]=h[p]}),w}e.deepClone=t;function R(h){if(!h||typeof h!="object")return h;const w=[h];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const P in p)if(L.call(p,P)){const v=p[P];typeof v=="object"&&!Object.isFrozen(v)&&!(0,S.isTypedArray)(v)&&w.push(v)}}return h}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function M(h,w){return b(h,w,new Set)}e.cloneAndChange=M;function b(h,w,p){if((0,S.isUndefinedOrNull)(h))return h;const P=w(h);if(typeof P!="undefined")return P;if((0,S.isArray)(h)){const v=[];for(const u of h)v.push(b(u,w,p));return v}if((0,S.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const v={};for(let u in h)L.call(h,u)&&(v[u]=b(h[u],w,p));return p.delete(h),v}return h}function f(h,w,p=!0){return(0,S.isObject)(h)?((0,S.isObject)(w)&&Object.keys(w).forEach(P=>{P in h?p&&((0,S.isObject)(h[P])&&(0,S.isObject)(w[P])?f(h[P],w[P],p):h[P]=w[P]):h[P]=w[P]}),h):w}e.mixin=f;function y(h,w){if(h===w)return!0;if(h==null||w===null||w===void 0||typeof h!=typeof w||typeof h!="object"||Array.isArray(h)!==Array.isArray(w))return!1;let p,P;if(Array.isArray(h)){if(h.length!==w.length)return!1;for(p=0;p<h.length;p++)if(!y(h[p],w[p]))return!1}else{const v=[];for(P in h)v.push(P);v.sort();const u=[];for(P in w)u.push(P);if(u.sort(),!y(v,u))return!1;for(p=0;p<v.length;p++)if(!y(h[v[p]],w[v[p]]))return!1}return!0}e.equals=y;function I(h){const w=new Set;return JSON.stringify(h,(p,P)=>{if((0,S.isObject)(P)||Array.isArray(P)){if(w.has(P))return"[Circular]";w.add(P)}return P})}e.safeStringify=I;function k(h,w,p){const P=w(h);return typeof P=="undefined"?p:P}e.getOrDefault=k;function C(h,w){const p=Object.create(null);return!h||!w||Object.keys(w).forEach(v=>{const u=h[v],c=w[v];y(u,c)||(p[v]=c)}),p}e.distinct=C;function m(h,w){const p=w.toLowerCase(),P=Object.keys(h).find(v=>v.toLowerCase()===p);return P?h[P]:h[w]}e.getCaseInsensitive=m;function d(h,w){const p=Object.create(null);for(const[P,v]of Object.entries(h))w(P,v)&&(p[P]=v);return p}e.filter=d}),define(Z[7],x([0,1,9,4]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,M=/^\/\//;function b(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!R.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,o){return!i&&!o?"file":i}function y(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const I="",k="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(o,a,r,l,g,E=!1){typeof o=="object"?(this.scheme=o.scheme||I,this.authority=o.authority||I,this.path=o.path||I,this.query=o.query||I,this.fragment=o.fragment||I):(this.scheme=f(o,E),this.authority=a||I,this.path=y(this.scheme,r||I),this.query=l||I,this.fragment=g||I,b(this,E))}static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return v(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:r,path:l,query:g,fragment:E}=o;return a===void 0?a=this.scheme:a===null&&(a=I),r===void 0?r=this.authority:r===null&&(r=I),l===void 0?l=this.path:l===null&&(l=I),g===void 0?g=this.query:g===null&&(g=I),E===void 0?E=this.fragment:E===null&&(E=I),a===this.scheme&&r===this.authority&&l===this.path&&g===this.query&&E===this.fragment?this:new h(a,r,l,g,E)}static parse(o,a=!1){const r=C.exec(o);return r?new h(r[2]||I,s(r[4]||I),s(r[5]||I),s(r[7]||I),s(r[9]||I),a):new h(I,I,I,I,I)}static file(o){let a=I;if(t.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const r=o.indexOf(k,2);r===-1?(a=o.substring(2),o=k):(a=o.substring(2,r),o=o.substring(r)||k)}return new h("file",a,o,I,I)}static from(o){const a=new h(o.scheme,o.authority,o.path,o.query,o.fragment);return b(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let r;return t.isWindows&&o.scheme==="file"?r=m.file(S.win32.join(v(o,!0),...a)).path:r=S.posix.join(o.path,...a),o.with({path:r})}toString(o=!1){return u(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const a=new h(o);return a._formatted=o.external,a._fsPath=o._sep===d?o.fsPath:null,a}}else return o}}e.URI=m;const d=t.isWindows?1:void 0;class h extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(o=!1){return o?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(i,o){let a,r=-1;for(let l=0;l<i.length;l++){const g=i.charCodeAt(l);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||o&&g===47)r!==-1&&(a+=encodeURIComponent(i.substring(r,l)),r=-1),a!==void 0&&(a+=i.charAt(l));else{a===void 0&&(a=i.substr(0,l));const E=w[g];E!==void 0?(r!==-1&&(a+=encodeURIComponent(i.substring(r,l)),r=-1),a+=E):r===-1&&(r=l)}}return r!==-1&&(a+=encodeURIComponent(i.substring(r))),a!==void 0?a:i}function P(i){let o;for(let a=0;a<i.length;a++){const r=i.charCodeAt(a);r===35||r===63?(o===void 0&&(o=i.substr(0,a)),o+=w[r]):o!==void 0&&(o+=i[a])}return o!==void 0?o:i}function v(i,o){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=v;function u(i,o){const a=o?P:p;let r="",{scheme:l,authority:g,path:E,query:D,fragment:W}=i;if(l&&(r+=l,r+=":"),(g||l==="file")&&(r+=k,r+=k),g){let O=g.indexOf("@");if(O!==-1){const V=g.substr(0,O);g=g.substr(O+1),O=V.indexOf(":"),O===-1?r+=a(V,!1):(r+=a(V.substr(0,O),!1),r+=":",r+=a(V.substr(O+1),!1)),r+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?r+=a(g,!1):(r+=a(g.substr(0,O),!1),r+=g.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}r+=a(E,!0)}return D&&(r+="?",r+=a(D,!1)),W&&(r+="#",r+=o?W:p(W,!1)),r}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,o=>c(o)):i}}),define(Z[118],x([0,1,7]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(y){const I=y;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function R(y){const I=[];let k;try{const C=JSON.parse(y.arguments),m=C[C.length-1];m&&m.__$stack&&(C.pop(),k=m.__$stack),I.push(...C)}catch{I.push("Unable to log remote console arguments",y.arguments)}return{args:I,stack:k}}e.parse=R;function L(y){if(typeof y!="string")return L(R(y).stack);const I=y;if(I){const k=M(I),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(C&&C.length===4)return{uri:S.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=L;function M(y){if(!y)return y;const I=y.indexOf(`
`);return I===-1?y:y.substring(0,I)}function b(y,I){const{args:k,stack:C}=R(y),m=typeof k[0]=="string"&&k.length===1;let d=M(C);d&&(d=`(${d.trim()})`);let h=[];if(typeof k[0]=="string"?d&&m?h=[`%c[${I}] %c${k[0]} %c${d}`,f("blue"),f(""),f("grey")]:h=[`%c[${I}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:h=[`%c[${I}]%`,f("blue"),...k],d&&!m&&h.push(d),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,h)}e.log=b;function f(y){return`color: ${y}`}}),define(Z[119],x([0,1,18,30,7]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(y){return JSON.stringify(y,b)}e.stringify=L;function M(y){let I=JSON.parse(y);return I=f(I),I}e.parse=M;function b(y,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function f(y,I=0){if(!y||I>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return R.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 14:return new Date(y.source)}if(y instanceof S.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let k=0;k<y.length;++k)y[k]=f(y[k],I+1);else for(const k in y)Object.hasOwnProperty.call(y,k)&&(y[k]=f(y[k],I+1))}return y}e.revive=f}),define(Z[10],x([0,1,4,7]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}setServerRootPath(f){this._remoteResourcesPath=`${f}/${R.vscodeRemoteResource}`}set(f,y,I){this._hosts[f]=y,this._ports[f]=I}setConnectionToken(f,y){this._connectionTokens[f]=y}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(f){if(this._delegate)return this._delegate(f);const y=f.authority;let I=this._hosts[y];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const k=this._ports[y],C=this._connectionTokens[y];let m=`path=${encodeURIComponent(f.path)}`;return typeof C=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),t.URI.from({scheme:S.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${I}:${k}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new L;class M{asBrowserUri(f,y){const I=this.toUri(f,y);return I.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===R.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${R.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?I.with({scheme:R.vscodeFileResource,authority:I.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(f,y){const I=this.toUri(f,y);return I.scheme===R.vscodeFileResource?I.with({scheme:R.file,authority:I.authority!==M.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(f,y){return t.URI.isUri(f)?f:t.URI.parse(y.toUrl(f))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(Z[16],x([0,1,28,10,9,4,30,7]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(m){return(0,b.uriToFsPath)(m,!0)}e.originalFSPath=f;class y{constructor(d){this._ignorePathCasing=d}compare(d,h,w=!1){return d===h?0:(0,M.compare)(this.getComparisonKey(d,w),this.getComparisonKey(h,w))}isEqual(d,h,w=!1){return d===h?!0:!d||!h?!1:this.getComparisonKey(d,w)===this.getComparisonKey(h,w)}getComparisonKey(d,h=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,h,w=!1){if(d.scheme===h.scheme){if(d.scheme===t.Schemas.file)return S.isEqualOrParent(f(d),f(h),this._ignorePathCasing(d))&&d.query===h.query&&(w||d.fragment===h.fragment);if((0,e.isEqualAuthority)(d.authority,h.authority))return S.isEqualOrParent(d.path,h.path,this._ignorePathCasing(d),"/")&&d.query===h.query&&(w||d.fragment===h.fragment)}return!1}joinPath(d,...h){return b.URI.joinPath(d,...h)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let h;return d.scheme===t.Schemas.file?h=b.URI.file(R.dirname(f(d))).path:(h=R.posix.dirname(d.path),d.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),h="/")),d.with({path:h})}normalizePath(d){if(!d.path.length)return d;let h;return d.scheme===t.Schemas.file?h=b.URI.file(R.normalize(f(d))).path:h=R.posix.normalize(d.path),d.with({path:h})}relativePath(d,h){if(d.scheme!==h.scheme||!(0,e.isEqualAuthority)(d.authority,h.authority))return;if(d.scheme===t.Schemas.file){const P=R.relative(f(d),f(h));return L.isWindows?S.toSlashes(P):P}let w=d.path||"/",p=h.path||"/";if(this._ignorePathCasing(d)){let P=0;for(const v=Math.min(w.length,p.length);P<v&&!(w.charCodeAt(P)!==p.charCodeAt(P)&&w.charAt(P).toLowerCase()!==p.charAt(P).toLowerCase());P++);w=p.substr(0,P)+w.substr(P)}return R.posix.relative(w,p)}resolvePath(d,h){if(d.scheme===t.Schemas.file){const w=b.URI.file(R.resolve(f(d),h));return d.with({authority:w.authority,path:w.path})}return h=S.toPosixPath(h),d.with({path:R.posix.resolve(d.path,h)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,h){return d===h||d!==void 0&&h!==void 0&&(0,M.equalsIgnoreCase)(d,h)}hasTrailingPathSeparator(d,h=R.sep){if(d.scheme===t.Schemas.file){const w=f(d);return w.length>S.getRoot(w).length&&w[w.length-1]===h}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,h=R.sep){return(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,h=R.sep){let w=!1;if(d.scheme===t.Schemas.file){const p=f(d);w=p!==void 0&&p.length===S.getRoot(p).length&&p[p.length-1]===h}else{h="/";const p=d.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,h)?d.with({path:d.path+"/"}):d}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(m=>m.scheme===t.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new y(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(m,d){const h=[];for(let w=0;w<m.length;w++){const p=d(m[w]);m.some((P,v)=>v===w?!1:(0,e.isEqualOrParent)(p,d(P)))||h.push(m[w])}return h}e.distinctParents=I;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function d(h){const w=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(v=>{const[u,c]=v.split(":");u&&c&&w.set(u,c)});const P=h.path.substring(0,h.path.indexOf(";"));return P&&w.set(m.META_DATA_MIME,P),w}m.parseMetaData=d})(k=e.DataUri||(e.DataUri={}));function C(m,d,h){if(d){let w=m.path;return w&&w[0]!==R.posix.sep&&(w=R.posix.sep+w),m.with({scheme:h,authority:d,path:w})}return m.with({scheme:h})}e.toLocalResource=C}),define(Z[8],x([0,1,23,15,3,2,16,4]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(T){return!!T&&typeof T.then=="function"}e.isThenable=f;function y(T){const A=new S.CancellationTokenSource,_=T(A.token),z=new Promise((F,B)=>{const K=A.token.onCancellationRequested(()=>{K.dispose(),A.dispose(),B(new t.CancellationError)});Promise.resolve(_).then(ie=>{K.dispose(),A.dispose(),F(ie)},ie=>{K.dispose(),A.dispose(),B(ie)})});return new class{cancel(){A.cancel()}then(F,B){return z.then(F,B)}catch(F){return this.then(void 0,F)}finally(F){return z.finally(F)}}}e.createCancelablePromise=y;function I(T,A,_){return new Promise((z,F)=>{const B=A.onCancellationRequested(()=>{B.dispose(),z(_)});T.then(z,F).finally(()=>B.dispose())})}e.raceCancellation=I;function k(T,A){return new Promise((_,z)=>{const F=A.onCancellationRequested(()=>{F.dispose(),z(new t.CancellationError)});T.then(_,z).finally(()=>F.dispose())})}e.raceCancellationError=k;async function C(T){let A=-1;const _=T.map((F,B)=>F.then(K=>(A=B,K))),z=await Promise.race(_);return T.forEach((F,B)=>{B!==A&&F.cancel()}),z}e.raceCancellablePromises=C;function m(T,A,_){let z;const F=setTimeout(()=>{z?.(void 0),_?.()},A);return Promise.race([T.finally(()=>clearTimeout(F)),new Promise(B=>z=B)])}e.raceTimeout=m;function d(T){return new Promise((A,_)=>{const z=T();f(z)?z.then(A,_):A(z)})}e.asPromise=d;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const _=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(_,_).then(z)})}return new Promise((_,z)=>{this.queuedPromise.then(_,z)})}return this.activePromise=A(),new Promise((_,z)=>{this.activePromise.then(F=>{this.activePromise=null,_(F)},F=>{this.activePromise=null,z(F)})})}}e.Throttler=h;class w{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=w;class p{constructor(){this.promiseMap=new Map}queue(A,_){const F=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.promiseMap.get(A)===F&&this.promiseMap.delete(A)});return this.promiseMap.set(A,F),F}}e.SequencerByKey=p;const P=(T,A)=>{let _=!0;const z=setTimeout(()=>{_=!1,A()},T);return{isTriggered:()=>_,dispose:()=>{clearTimeout(z),_=!1}}},v=T=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,T())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,_=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,B)=>{this.doResolve=F,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=_===e.MicrotaskDelay?v(z):P(_,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(A){this.delayer=new u(A),this.throttler=new h}trigger(A,_){return this.delayer.trigger(()=>this.throttler.queue(A),_)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((A,_)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class s extends n{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function i(T,A){return A?new Promise((_,z)=>{const F=setTimeout(()=>{B.dispose(),_()},T),B=A.onCancellationRequested(()=>{clearTimeout(F),B.dispose(),z(new t.CancellationError)})}):y(_=>i(T,_))}e.timeout=i;function o(T,A=0){const _=setTimeout(T,A);return(0,L.toDisposable)(()=>clearTimeout(_))}e.disposableTimeout=o;function a(T){const A=[];let _=0;const z=T.length;function F(){return _<z?T[_++]():null}function B(K){K!=null&&A.push(K);const ie=F();return ie?ie.then(B):Promise.resolve(A)}return Promise.resolve(null).then(B)}e.sequence=a;function r(T,A=z=>!!z,_=null){let z=0;const F=T.length,B=()=>{if(z>=F)return Promise.resolve(_);const K=T[z++];return Promise.resolve(K()).then(oe=>A(oe)?Promise.resolve(oe):B())};return B()}e.first=r;function l(T,A=z=>!!z,_=null){if(T.length===0)return Promise.resolve(_);let z=T.length;const F=()=>{z=-1;for(const B of T)B.cancel?.()};return new Promise((B,K)=>{for(const ie of T)ie.then(oe=>{--z>=0&&A(oe)?(F(),B(oe)):z===0&&B(_)}).catch(oe=>{--z>=0&&(F(),K(oe))})})}e.firstParallel=l;class g{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((_,z)=>{this.outstandingPromises.push({factory:A,c:_,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const _=A.factory();_.then(A.c,A.e),_.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class E extends g{constructor(){super(1)}}e.Queue=E;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new U;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,_=M.extUri){const z=_.getComparisonKey(A);let F=this.queues.get(z);return F||(F=new E,R.Event.once(F.onDrained)(()=>{F?.dispose(),this.queues.delete(z),this.onDidQueueDrain()}),this.queues.set(z,F)),F}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class W{constructor(A,_){this._token=-1,typeof A=="function"&&typeof _=="number"&&this.setIfNotSet(A,_)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,_){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},_)}setIfNotSet(A,_){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},_))}}e.TimeoutTimer=W;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,_){this.cancel(),this._token=setInterval(()=>{A()},_)}}e.IntervalTimer=O;class V{constructor(A,_){this.timeoutToken=-1,this.runner=A,this.timeout=_,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=V;class J{constructor(A,_){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=_,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=J;class ne extends V{constructor(A,_){super(A,_);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ne;class Y extends L.Disposable{constructor(A,_){super();this.options=A,this.handler=_,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new V(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Y,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,b.setTimeout0)(()=>{if(A)return;const _=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(T,A)=>{const _=requestIdleCallback(T,typeof A=="number"?{timeout:A}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(_))}}}}();class re{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(_){this._error=_}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=re;async function ae(T,A,_){let z;for(let F=0;F<_;F++)try{return await T()}catch(B){z=B,await i(A)}throw z}e.retry=ae;class H{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,_,z){return this._pending={taskId:A,cancel:()=>z?.(),promise:_},_.then(()=>this.donePending(A),()=>this.donePending(A)),_}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let _,z;const F=new Promise((B,K)=>{_=B,z=K});this._next={run:A,promise:F,promiseResolve:_,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=H;class ${constructor(A,_=()=>Date.now()){this.interval=A,this.nowFn=_,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,_)=>{this.completeCallback=A,this.errorCallback=_})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(_=>{this.completeCallback(A),this.resolved=!0,_()})}error(A){return new Promise(_=>{this.errorCallback(A),this.rejected=!0,_()})}cancel(){new Promise(A=>{this.errorCallback(new t.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=U;var N;(function(T){async function A(z){let F;const B=await Promise.all(z.map(K=>K.then(ie=>ie,ie=>{F||(F=ie)})));if(typeof F!="undefined")throw F;return B}T.settled=A;function _(z){return new Promise(async(F,B)=>{try{await z(F,B)}catch(K){B(K)}})}T.withAsyncBody=_})(N=e.Promises||(e.Promises={}));var q;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(q||(q={}));class ee{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const _={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(A(_)),this.resolve()}catch(z){this.reject(z)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}static fromArray(A){return new ee(_=>{_.emitMany(A)})}static fromPromise(A){return new ee(async _=>{_.emitMany(await A)})}static fromPromises(A){return new ee(async _=>{await Promise.all(A.map(async z=>_.emitOne(await z)))})}static merge(A){return new ee(async _=>{await Promise.all(A.map(async z=>{for await(const F of z)_.emitOne(F)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,_){return new ee(async z=>{for await(const F of A)z.emitOne(_(F))})}map(A){return ee.map(this,A)}static filter(A,_){return new ee(async z=>{for await(const F of A)_(F)&&z.emitOne(F)})}filter(A){return ee.filter(this,A)}static coalesce(A){return ee.filter(A,_=>!!_)}coalesce(){return ee.coalesce(this)}static async toPromise(A){const _=[];for await(const z of A)_.push(z);return _}toPromise(){return ee.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class Q extends ee{constructor(A,_){super(_);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function X(T){const A=new S.CancellationTokenSource,_=T(A.token);return new Q(A,async z=>{const F=A.token.onCancellationRequested(()=>{F.dispose(),A.dispose(),z.reject(new t.CancellationError)});try{for await(const B of _){if(A.token.isCancellationRequested)return;z.emitOne(B)}F.dispose(),A.dispose()}catch(B){F.dispose(),A.dispose(),z.reject(B)}})}e.createCancelableAsyncIterable=X}),define(Z[87],x([0,1,25,8,28,36,9,4,30]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",k="[^/\\\\]",C=/\//g;function m(U,N){switch(U){case 0:return"";case 1:return`${k}*?`;default:return`(?:${I}|${k}+${I}${N?`|${I}${k}+`:""})*?`}}function d(U,N){if(!U)return[];const q=[];let ee=!1,Q=!1,X="";for(const T of U){switch(T){case N:if(!ee&&!Q){q.push(X),X="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}X+=T}return X&&q.push(X),q}e.splitGlobAware=d;function h(U){if(!U)return"";let N="";const q=d(U,e.GLOB_SPLIT);if(q.every(ee=>ee===e.GLOBSTAR))N=".*";else{let ee=!1;q.forEach((Q,X)=>{if(Q===e.GLOBSTAR){if(ee)return;N+=m(2,X===q.length-1)}else{let T=!1,A="",_=!1,z="";for(const F of Q){if(F!=="}"&&T){A+=F;continue}if(_&&(F!=="]"||!z)){let B;F==="-"?B=F:(F==="^"||F==="!")&&!z?B="^":F===e.GLOB_SPLIT?B="":B=(0,f.escapeRegExpCharacters)(F),z+=B;continue}switch(F){case"{":T=!0;continue;case"[":_=!0;continue;case"}":{N+=`(?:${d(A,",").map(ie=>h(ie)).join("|")})`,T=!1,A="";break}case"]":{N+="["+z+"]",_=!1,z="";break}case"?":N+=k;continue;case"*":N+=m(1);continue;default:N+=(0,f.escapeRegExpCharacters)(F)}}X<q.length-1&&(q[X+1]!==e.GLOBSTAR||X+2<q.length)&&(N+=I)}ee=Q===e.GLOBSTAR})}return N}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),s=function(){return!1},i=function(){return null};function o(U,N){if(!U)return i;let q;typeof U!="string"?q=U.pattern:q=U,q=q.trim();const ee=`${q}_${!!N.trimForExclusions}`;let Q=n.get(ee);if(Q)return a(Q,U);let X;return w.test(q)?Q=l(q.substr(4),q):(X=p.exec(r(q,N)))?Q=g(X[1],q):(N.trimForExclusions?v:P).test(q)?Q=E(q,N):(X=u.exec(r(q,N)))?Q=D(X[1].substr(1),q,!0):(X=c.exec(r(q,N)))?Q=D(X[1],q,!1):Q=W(q),n.set(ee,Q),a(Q,U)}function a(U,N){if(typeof N=="string")return U;const q=function(ee,Q){return(0,R.isEqualOrParent)(ee,N.base,!b.isLinux)?U(ee.substr(N.base.length+1),Q):null};return q.allBasenames=U.allBasenames,q.allPaths=U.allPaths,q.basenames=U.basenames,q.patterns=U.patterns,q}function r(U,N){return N.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function l(U,N){return function(q,ee){return typeof q=="string"&&q.endsWith(U)?N:null}}function g(U,N){const q=`/${U}`,ee=`\\${U}`,Q=function(T,A){return typeof T!="string"?null:A?A===U?N:null:T===U||T.endsWith(q)||T.endsWith(ee)?N:null},X=[U];return Q.basenames=X,Q.patterns=[N],Q.allBasenames=X,Q}function E(U,N){const q=H(U.slice(1,-1).split(",").map(A=>o(A,N)).filter(A=>A!==i),U),ee=q.length;if(!ee)return i;if(ee===1)return q[0];const Q=function(A,_){for(let z=0,F=q.length;z<F;z++)if(q[z](A,_))return U;return null},X=q.find(A=>!!A.allBasenames);X&&(Q.allBasenames=X.allBasenames);const T=q.reduce((A,_)=>_.allPaths?A.concat(_.allPaths):A,[]);return T.length&&(Q.allPaths=T),Q}function D(U,N,q){const ee=M.sep===M.posix.sep,Q=ee?U:U.replace(C,M.sep),X=M.sep+Q,T=M.posix.sep+U;let A;return q?A=function(_,z){return typeof _=="string"&&(_===Q||_.endsWith(X)||!ee&&(_===U||_.endsWith(T)))?N:null}:A=function(_,z){return typeof _=="string"&&(_===Q||!ee&&_===U)?N:null},A.allPaths=[(q?"*/":"./")+U],A}function W(U){try{const N=new RegExp(`^${h(U)}$`);return function(q){return N.lastIndex=0,typeof q=="string"&&N.test(q)?U:null}}catch{return i}}function O(U,N,q){return!U||typeof N!="string"?!1:V(U)(N,void 0,q)}e.match=O;function V(U,N={}){if(!U)return s;if(typeof U=="string"||J(U)){const q=o(U,N);if(q===i)return s;const ee=function(Q,X){return!!q(Q,X)};return q.allBasenames&&(ee.allBasenames=q.allBasenames),q.allPaths&&(ee.allPaths=q.allPaths),ee}return re(U,N)}e.parse=V;function J(U){const N=U;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=J;function ne(U){return U.allBasenames||[]}e.getBasenameTerms=ne;function Y(U){return U.allPaths||[]}e.getPathTerms=Y;function re(U,N){const q=H(Object.getOwnPropertyNames(U).map(A=>ae(A,U[A],N)).filter(A=>A!==i)),ee=q.length;if(!ee)return i;if(!q.some(A=>!!A.requiresSiblings)){if(ee===1)return q[0];const A=function(F,B){let K;for(let ie=0,oe=q.length;ie<oe;ie++){const ue=q[ie](F,B);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(K||(K=[]),K.push(ue))}return K?(async()=>{for(const ie of K){const oe=await ie;if(typeof oe=="string")return oe}return null})():null},_=q.find(F=>!!F.allBasenames);_&&(A.allBasenames=_.allBasenames);const z=q.reduce((F,B)=>B.allPaths?F.concat(B.allPaths):F,[]);return z.length&&(A.allPaths=z),A}const Q=function(A,_,z){let F,B;for(let K=0,ie=q.length;K<ie;K++){const oe=q[K];oe.requiresSiblings&&z&&(_||(_=(0,M.basename)(A)),F||(F=_.substr(0,_.length-(0,M.extname)(A).length)));const ue=oe(A,_,F,z);if(typeof ue=="string")return ue;(0,t.isThenable)(ue)&&(B||(B=[]),B.push(ue))}return B?(async()=>{for(const K of B){const ie=await K;if(typeof ie=="string")return ie}return null})():null},X=q.find(A=>!!A.allBasenames);X&&(Q.allBasenames=X.allBasenames);const T=q.reduce((A,_)=>_.allPaths?A.concat(_.allPaths):A,[]);return T.length&&(Q.allPaths=T),Q}function ae(U,N,q){if(N===!1)return i;const ee=o(U,q);if(ee===i)return i;if(typeof N=="boolean")return ee;if(N){const Q=N.when;if(typeof Q=="string"){const X=(T,A,_,z)=>{if(!z||!ee(T,A))return null;const F=Q.replace("$(basename)",_),B=z(F);return(0,t.isThenable)(B)?B.then(K=>K?U:null):B?U:null};return X.requiresSiblings=!0,X}}return ee}function H(U,N){const q=U.filter(A=>!!A.basenames);if(q.length<2)return U;const ee=q.reduce((A,_)=>{const z=_.basenames;return z?A.concat(z):A},[]);let Q;if(N){Q=[];for(let A=0,_=ee.length;A<_;A++)Q.push(N)}else Q=q.reduce((A,_)=>{const z=_.patterns;return z?A.concat(z):A},[]);const X=function(A,_){if(typeof A!="string")return null;if(!_){let F;for(F=A.length;F>0;F--){const B=A.charCodeAt(F-1);if(B===47||B===92)break}_=A.substr(F)}const z=ee.indexOf(_);return z!==-1?Q[z]:null};X.basenames=ee,X.patterns=Q,X.allBasenames=ee;const T=U.filter(A=>!A.basenames);return T.push(X),T}function $(U,N){return(0,S.equals)(U,N,(q,ee)=>typeof q=="string"&&typeof ee=="string"?q===ee:typeof q!="string"&&typeof ee!="string"?q.base===ee.base&&q.pattern===ee.pattern:!1)}e.patternsEquals=$}),define(Z[33],x([0,1,25,28,10,9,4,16,30,7]),function(j,e,S,t,R,L,M,b,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(r,l){const{os:g,tildify:E,relative:D}=l;if(D){const V=k(r,D,g);if(typeof V=="string")return V}let W=r.fsPath;if(g===1&&!M.isWindows?W=W.replace(/\//g,"\\"):g!==1&&M.isWindows&&(W=W.replace(/\\/g,"/")),g!==1&&E?.userHome){let V=E.userHome.fsPath,J;r.scheme!==E.userHome.scheme&&r.path.startsWith(L.posix.sep)?J=E.userHome.with({path:r.path}).fsPath:J=r.fsPath,W=h(J,V,g)}return(g===1?L.win32:L.posix).normalize(m(W,g===1))}e.getPathLabel=I;function k(r,l,g){const E=g===1?L.win32:L.posix,D=g===3?b.extUri:b.extUriIgnorePathCase,W=l.getWorkspace(),O=(0,S.firstOrDefault)(W.folders);if(!O)return;r.scheme!==O.uri.scheme&&r.path.startsWith(L.posix.sep)&&(r=O.uri.with({path:r.path}));const V=l.getWorkspaceFolder(r);if(!V)return;let J;if(D.isEqual(V.uri,r)?J="":J=D.relativePath(V.uri,r)??"",J&&(J=E.normalize(J)),W.folders.length>1&&!l.noPrefix){const ne=V.name?V.name:D.basenameOrAuthority(V.uri);J=J?`${ne} \u2022 ${J}`:ne}return J}function C(r){if(!r)return;typeof r=="string"&&(r=y.URI.file(r));const l=(0,b.basename)(r)||(r.scheme===R.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,t.isRootOrDriveLetter)(l)?m(l):l}e.getBaseLabel=C;function m(r,l=M.isWindows){return(0,t.hasDriveLetter)(r,l)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=m;let d=Object.create(null);function h(r,l,g=M.OS){if(g===1||!r||!l)return r;let E=d.original===l?d.normalized:void 0;E||(E=l,M.isWindows&&(E=(0,t.toSlashes)(E)),E=`${(0,f.rtrim)(E,L.posix.sep)}${L.posix.sep}`,d={original:l,normalized:E});let D=r;return M.isWindows&&(D=(0,t.toSlashes)(D)),(g===3?D.startsWith(E):(0,f.startsWithIgnoreCase)(D,E))?`~/${D.substr(E.length)}`:r}e.tildify=h;function w(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=w;const p="\u2026",P="\\\\",v="~";function u(r,l=L.sep){const g=new Array(r.length);let E=!1;for(let D=0;D<r.length;D++){let W=r[D];if(W===""){g[D]=`.${l}`;continue}if(!W){g[D]=W;continue}E=!0;let O="",V=W;V.indexOf(P)===0?(O=V.substr(0,V.indexOf(P)+P.length),V=V.substr(V.indexOf(P)+P.length)):V.indexOf(l)===0?(O=V.substr(0,V.indexOf(l)+l.length),V=V.substr(V.indexOf(l)+l.length)):V.indexOf(v)===0&&(O=V.substr(0,V.indexOf(v)+v.length),V=V.substr(V.indexOf(v)+v.length));const J=V.split(l);for(let ne=1;E&&ne<=J.length;ne++)for(let Y=J.length-ne;E&&Y>=0;Y--){E=!1;let re=J.slice(Y,Y+ne).join(l);for(let ae=0;!E&&ae<r.length;ae++)if(ae!==D&&r[ae]&&r[ae].indexOf(re)>-1){const H=Y+ne===J.length,$=Y>0&&r[ae].indexOf(l)>-1?l+re:re,U=r[ae].endsWith($);E=!H||U}if(!E){let ae="";(J[0].endsWith(":")||O!=="")&&(Y===1&&(Y=0,ne++,re=J[0]+l+re),Y>0&&(ae=J[0]+l),ae=O+ae),Y>0&&(ae=ae+p+l),ae=ae+re,Y+ne<J.length&&(ae=ae+l+p),g[D]=ae}}E&&(g[D]=W)}return g}e.shorten=u;var c;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function n(r,l=Object.create(null)){const g=[];let E=!1,D="";for(const W of r)if(W==="$"||E&&W==="{")D&&g.push({value:D,type:c.TEXT}),D="",E=!0;else if(W==="}"&&E){const O=l[D];if(typeof O=="string")O.length&&g.push({value:O,type:c.VARIABLE});else if(O){const V=g[g.length-1];(!V||V.type!==c.SEPARATOR)&&g.push({value:O.label,type:c.SEPARATOR})}D="",E=!1}else D+=W;return D&&!E&&g.push({value:D,type:c.TEXT}),g.filter((W,O)=>{if(W.type===c.SEPARATOR){const V=g[O-1],J=g[O+1];return[V,J].every(ne=>ne&&(ne.type===c.VARIABLE||ne.type===c.TEXT)&&ne.value.length>0)}return!0}).map(W=>W.value).join("")}e.template=n;function s(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function i(r,l){return M.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function o(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=o;function a(r){const l=r.indexOf("/")!==-1?L.posix:L.win32,g=l.basename(r),E=l.dirname(r);return g.length?{name:g,parentPath:E}:{name:E,parentPath:""}}e.splitName=a}),define(Z[120],x([0,1,7]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const C=this._uriTransformer.transformIncoming(k);return C===k?k:t(S.URI.from(C))}transformOutgoing(k){const C=this._uriTransformer.transformOutgoing(k);return C===k?k:t(S.URI.from(C))}transformOutgoingURI(k){const C=this._uriTransformer.transformOutgoing(k);return C===k?k:S.URI.from(C)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,k,C){if(!I||C>200)return null;if(typeof I=="object"){if(I instanceof S.URI)return k.transformOutgoing(I);for(let m in I)if(Object.hasOwnProperty.call(I,m)){const d=L(I[m],k,C+1);d!==null&&(I[m]=d)}}return null}function M(I,k){const C=L(I,k,0);return C===null?I:C}e.transformOutgoingURIs=M;function b(I,k,C,m){if(!I||m>200)return null;if(typeof I=="object"){if(I.$mid===1)return C?S.URI.revive(k.transformIncoming(I)):k.transformIncoming(I);for(let d in I)if(Object.hasOwnProperty.call(I,d)){const h=b(I[d],k,C,m+1);h!==null&&(I[d]=h)}}return null}function f(I,k){const C=b(I,k,!1,0);return C===null?I:C}e.transformIncomingURIs=f;function y(I,k){const C=b(I,k,!0,0);return C===null?I:C}e.transformAndReviveIncomingURIs=y}),define(Z[31],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(R){return S.test(R)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(b){for(let f=0;f<b.length;f++)b[f]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,y="";return y+=M[L[f++]],y+=M[L[f++]],y+=M[L[f++]],y+=M[L[f++]],y+="-",y+=M[L[f++]],y+=M[L[f++]],y+="-",y+=M[L[f++]],y+=M[L[f++]],y+="-",y+=M[L[f++]],y+=M[L[f++]],y+="-",y+=M[L[f++]],y+=M[L[f++]],y+=M[L[f++]],y+=M[L[f++]],y+=M[L[f++]],y+=M[L[f++]],y}}()}),define(Z[121],x([0,1,62,29,45]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function L(M,b){if(await new Promise((I,k)=>{const C=t.createReadStream(M),m=S.createHash("sha1");C.pipe(m);const d=(0,R.once)((h,w)=>{C.removeAllListeners(),m.removeAllListeners(),h?k(h):I(w)});C.once("error",d),C.once("end",d),m.once("error",d),m.once("data",h=>d(void 0,h.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=L}),define(Z[122],x([0,1,123]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(L="utf8"){this.stringDecoder=new S.StringDecoder(L),this.remaining=null}write(L){const M=[],b=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(b.length<1)return M;let f=0,y,I=f;for(;I<b.length;)if(y=b.charCodeAt(I),y===13||y===10){if(M.push(b.substring(f,I)),I++,I<b.length){const k=y;y=b.charCodeAt(I),(k===13&&y===10||k===10&&y===13)&&I++}f=I}else I++;return this.remaining=f<b.length?b.substr(f):null,M}end(){return this.remaining}}e.LineDecoder=t}),define(Z[124],x([0,1,27]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(M){const b=M.replace(/\-/g,":").toLowerCase();return!t.has(b)}function L(){const M=(0,S.networkInterfaces)();for(let b in M){const f=M[b];if(f){for(const{mac:y}of f)if(R(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(Z[75],x([0,1,27,15,36,31,124]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,k=0;const C=(0,S.networkInterfaces)();for(let m in C){const d=C[m];if(d)for(const{mac:h,internal:w}of d)w||(k+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(I+=1))}this._value=k>0?I/k:0}return this._value}};let b;async function f(){return b||(b=(async()=>await y()||L.generateUuid())()),b}e.getMachineId=f;async function y(){try{const I=await new Promise((C,m)=>{j(["crypto"],C,m)}),k=(0,M.getMac)();return I.createHash("sha256").update(k,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(Z[21],x([0,1,29,27,125,8,28,74,9,4,16,7]),function(j,e,S,t,R,L,M,b,f,y,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function m(Y,re=C.UNLINK){if((0,M.isRootOrDriveLetter)(Y))throw new Error("rimraf - will refuse to recursively delete root");return re===C.UNLINK?h(Y):d(Y)}async function d(Y){try{const re=(0,M.randomPath)((0,t.tmpdir)());try{await S.promises.rename(Y,re)}catch{return h(Y)}h(re).catch(ae=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function h(Y){return(0,R.promisify)(S.rm)(Y,{recursive:!0,force:!0,maxRetries:3})}function w(Y){if((0,M.isRootOrDriveLetter)(Y))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(Y,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function p(Y,re){return u(await(re?P(Y):(0,R.promisify)(S.readdir)(Y)))}async function P(Y){try{return await(0,R.promisify)(S.readdir)(Y,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const re=[],ae=await p(Y);for(const H of ae){let $=!1,U=!1,N=!1;try{const q=await e.Promises.lstat((0,f.join)(Y,H));$=q.isFile(),U=q.isDirectory(),N=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}re.push({name:H,isFile:()=>$,isDirectory:()=>U,isSymbolicLink:()=>N})}return re}function v(Y){return u(S.readdirSync(Y))}e.readdirSync=v;function u(Y){return Y.map(re=>typeof re=="string"?y.isMacintosh?(0,b.normalizeNFC)(re):re:(re.name=y.isMacintosh?(0,b.normalizeNFC)(re.name):re.name,re))}async function c(Y){const re=await p(Y),ae=[];for(const H of re)await s.existsDirectory((0,f.join)(Y,H))&&ae.push(H);return ae}function n(Y,re=1e3){return new Promise(ae=>{let H=!1;const $=setInterval(()=>{H||(H=!0,S.access(Y,U=>{H=!1,U&&(clearInterval($),ae(void 0))}))},re)})}e.whenDeleted=n;var s;(function(Y){async function re($){let U;try{if(U=await e.Promises.lstat($),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(y.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw q}throw N}}Y.stat=re;async function ae($){try{const{stat:U,symbolicLink:N}=await Y.stat($);return U.isFile()&&N?.dangling!==!0}catch{}return!1}Y.existsFile=ae;async function H($){try{const{stat:U,symbolicLink:N}=await Y.stat($);return U.isDirectory()&&N?.dangling!==!0}catch{}return!1}Y.existsDirectory=H})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new L.ResourceQueue;function o(Y,re,ae){return i.queueFor(k.URI.file(Y),I.extUriBiasedIgnorePathCase).queue(()=>{const H=g(ae);return new Promise(($,U)=>r(Y,re,H,N=>N?U(N):$()))})}let a=!0;function r(Y,re,ae,H){if(!a)return S.writeFile(Y,re,{mode:ae.mode,flag:ae.flag},H);S.open(Y,ae.flag,ae.mode,($,U)=>{if($)return H($);S.writeFile(U,re,N=>{if(N)return S.close(U,()=>H(N));S.fdatasync(U,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),a=!1),S.close(U,ee=>H(ee))))})})}function l(Y,re,ae){const H=g(ae);if(!a)return S.writeFileSync(Y,re,{mode:H.mode,flag:H.flag});const $=S.openSync(Y,H.flag,H.mode);try{S.writeFileSync($,re);try{S.fdatasyncSync($)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),a=!1}}finally{S.closeSync($)}}e.writeFileSync=l;function g(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function E(Y,re){if(Y!==re)try{await e.Promises.rename(Y,re)}catch(ae){if(Y.toLowerCase()!==re.toLowerCase()&&ae.code==="EXDEV"||Y.endsWith("."))await D(Y,re,{preserveSymlinks:!1}),await m(Y,C.MOVE);else throw ae}}async function D(Y,re,ae){return O(Y,re,{root:{source:Y,target:re},options:ae,handledSourcePaths:new Set})}const W=511;async function O(Y,re,ae){if(ae.handledSourcePaths.has(Y))return;ae.handledSourcePaths.add(Y);const{stat:H,symbolicLink:$}=await s.stat(Y);if($){if(ae.options.preserveSymlinks)try{return await ne(Y,re,ae)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if($.dangling)return}return H.isDirectory()?V(Y,re,H.mode&W,ae):J(Y,re,H.mode&W)}async function V(Y,re,ae,H){await e.Promises.mkdir(re,{recursive:!0,mode:ae});const $=await p(Y);for(const U of $)await O((0,f.join)(Y,U),(0,f.join)(re,U),H)}async function J(Y,re,ae){await e.Promises.copyFile(Y,re),await e.Promises.chmod(re,ae)}async function ne(Y,re,ae){let H=await e.Promises.readlink(Y);(0,M.isEqualOrParent)(H,ae.root.source,!y.isLinux)&&(H=(0,f.join)(ae.root.target,H.substr(ae.root.source.length+1))),await e.Promises.symlink(H,re)}e.Promises=new class{get access(){return(0,R.promisify)(S.access)}get stat(){return(0,R.promisify)(S.stat)}get lstat(){return(0,R.promisify)(S.lstat)}get utimes(){return(0,R.promisify)(S.utimes)}get read(){return(Y,re,ae,H,$)=>new Promise((U,N)=>{S.read(Y,re,ae,H,$,(q,ee,Q)=>q?N(q):U({bytesRead:ee,buffer:Q}))})}get readFile(){return(0,R.promisify)(S.readFile)}get write(){return(Y,re,ae,H,$)=>new Promise((U,N)=>{S.write(Y,re,ae,H,$,(q,ee,Q)=>q?N(q):U({bytesWritten:ee,buffer:Q}))})}get appendFile(){return(0,R.promisify)(S.appendFile)}get fdatasync(){return(0,R.promisify)(S.fdatasync)}get truncate(){return(0,R.promisify)(S.truncate)}get rename(){return(0,R.promisify)(S.rename)}get copyFile(){return(0,R.promisify)(S.copyFile)}get open(){return(0,R.promisify)(S.open)}get close(){return(0,R.promisify)(S.close)}get symlink(){return(0,R.promisify)(S.symlink)}get readlink(){return(0,R.promisify)(S.readlink)}get chmod(){return(0,R.promisify)(S.chmod)}get mkdir(){return(0,R.promisify)(S.mkdir)}get unlink(){return(0,R.promisify)(S.unlink)}get rmdir(){return(0,R.promisify)(S.rmdir)}get realpath(){return(0,R.promisify)(S.realpath)}async exists(Y){try{return await e.Promises.access(Y),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return c}get writeFile(){return o}get rm(){return m}get move(){return E}get copy(){return D}}}),define(Z[88],x([0,1,29,9,4,30,21]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(C){if(R.isLinux)return C;const m=(0,t.dirname)(C);if(C===m)return C;const d=((0,t.basename)(C)||C).toLowerCase();try{const w=(0,M.readdirSync)(m).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=b(m);if(p)return(0,t.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const P=b(m);if(P)return(0,t.join)(P,w[p])}}}catch{}return null}e.realcaseSync=b;async function f(C){if(R.isLinux)return C;const m=(0,t.dirname)(C);if(C===m)return C;const d=((0,t.basename)(C)||C).toLowerCase();try{const w=(await M.Promises.readdir(m)).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=await f(m);if(p)return(0,t.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const P=await f(m);if(P)return(0,t.join)(P,w[p])}}}catch{}return null}e.realcase=f;async function y(C){try{return await M.Promises.realpath(C)}catch{const d=k(C);return await M.Promises.access(d,S.constants.R_OK),d}}e.realpath=y;function I(C){try{return S.realpathSync(C)}catch{const d=k(C);return S.accessSync(d,S.constants.R_OK),d}}e.realpathSync=I;function k(C){return(0,L.rtrim)((0,t.normalize)(C),t.sep)}}),define(Z[89],x([0,1,63]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(b,f,y,I=1){let k=!1;return new Promise(C=>{const m=setTimeout(()=>{if(!k)return k=!0,C(0)},y);R(b,f,I,d=>{if(!k)return k=!0,clearTimeout(m),C(d)})})}e.findFreePort=t;function R(b,f,y,I){if(f===0)return I(0);const k=new S.Socket;k.once("connect",()=>(M(k),R(b+y,f-1,y,I))),k.once("data",()=>{}),k.once("error",C=>(M(k),C.code!=="ECONNREFUSED"?R(b+y,f-1,y,I):I(b))),k.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(b,f,y){let I=!1,k,C=1;const m=S.createServer({pauseOnConnect:!0});function d(h,w){I||(I=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),w(h))}return new Promise(h=>{k=setTimeout(()=>{d(0,h)},y),m.on("listening",()=>{d(b,h)}),m.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&C<f?(b++,C++,m.listen(b,"127.0.0.1")):d(0,h)}),m.on("close",()=>{d(0,h)}),m.listen(b,"127.0.0.1")})}e.findFreePortFaster=L;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(f){console.error(f)}}}),define(Z[126],x([0,1,27,9,21]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,M=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var f;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(f||(f={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class k{constructor(c,n,s){this.exePath=c,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function C({useAlternateBitness:u=!1}={}){return u?y===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:c=!1}={}){const n=C({useAlternateBitness:u});if(!n)return null;const s=t.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let i=-1,o=null;for(const l of await R.Promises.readdir(s)){let g=-1;if(c){const D=l.indexOf("-");if(D<0)continue;const W=l.substring(0,D);if(!L.test(W)||l.substring(D+1)!=="preview")continue;g=parseInt(W,10)}else{if(!L.test(l))continue;g=parseInt(l,10)}if(g<=i)continue;const E=t.join(s,l,"pwsh.exe");!await R.SymlinkSupport.existsFile(E)||(o=E,i=g)}if(!o)return null;const a=n.includes("x86")?" (x86)":"",r=c?" Preview":"";return new k(o,`PowerShell${r}${a}`,!0)}async function d({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=u?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const i of await R.Promises.readdir(c))if(n.test(i)){const o=t.join(c,i,"pwsh.exe");return new k(o,s)}return null}function h(){const u=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new k(u,".NET Core PowerShell Global Tool")}function w(){const u=t.join(process.env.windir,y===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(u,"Windows PowerShell",!0)}async function*p(){let u=await m();u&&(yield u),u=await m({useAlternateBitness:!0}),u&&(yield u),u=await d(),u&&(yield u),u=h(),u&&(yield u),u=await m({findPreview:!0}),u&&(yield u),u=await d({findPreview:!0}),u&&(yield u),u=await m({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=w(),u&&(yield u)}async function*P(){for await(const u of p())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=P;async function v(){for await(const u of P())return u;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Z[90],x([0,1,39,10]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(M){return new Promise((b,f)=>{let y;const I=new Map;function k(m,d,h,w,p){const P=I.get(d);if(m===M||P){const v={name:C(h),cmd:h,pid:m,ppid:d,load:w,mem:p};I.set(m,v),m===M&&(y=v),P&&(P.children||(P.children=[]),P.children.push(v),P.children.length>1&&(P.children=P.children.sort((u,c)=>u.pid-c.pid)))}}function C(m){const d=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,P=/--crashes-directory/,v=/\\pipe\\winpty-control/,u=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(P.exec(m))return"electron-crash-reporter";if(v.exec(m))return"winpty-process";if(u.exec(m))return"console-window-host (Windows internal process)";let n=c.exec(m);if(n&&n.length===2)return n[1]==="renderer"?d.exec(m)?"shared-process":h.exec(m)?"issue-reporter":w.exec(m)?"process-explorer":"window":n[1]==="utility"&&p.exec(m)?"utility-network-service":n[1];const s=/[a-zA-Z-]+\.js/g;let i="";do n=s.exec(m),n&&(i+=n+" ");while(n);return i&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${i}`:m}if(process.platform==="win32"){const m=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,h)=>{j(["windows-process-tree"],d,h)}).then(d=>{d.getProcessList(M,h=>{if(!h){f(new Error(`Root process ${M} not found`));return}d.getProcessCpuUsage(h,w=>{const p=new Map;w.forEach(P=>{const v=m(P.commandLine||"");p.set(P.pid,{name:C(v),cmd:v,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),y=p.get(M),y?(p.forEach(P=>{const v=p.get(P.ppid);v&&(v.children||(v.children=[]),v.children.push(P))}),p.forEach(P=>{P.children&&(P.children=P.children.sort((v,u)=>v.pid-u.pid))}),b(y)):f(new Error(`Root process ${M} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let m=function(){let d=[y];const h=[];for(;d.length;){const p=d.shift();p&&(h.push(p.pid),p.children&&(d=d.concat(p.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);w+=" "+h.join(" "),(0,S.exec)(w,{},(p,P,v)=>{if(p||v)f(p||new Error(v.toString()));else{const u=P.toString().split(`
`);for(let c=0;c<h.length;c++){const n=I.get(h[c]);n.load=parseFloat(u[c])}if(!y){f(new Error(`Root process ${M} not found`));return}b(y)}})};(0,S.exec)("which ps",{},(d,h,w)=>{if(d||w)if(process.platform!=="linux")f(d||new Error(w.toString()));else{const p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,S.exec)(p,{},(P,v,u)=>{P||u?f(P||new Error(u.toString())):(L(v,k),m())})}else{const p=h.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${p} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,u,c)=>{v||c&&!c.includes("screen size is bogus")?f(v||new Error(c.toString())):(L(u,k),process.platform==="linux"?m():y?b(y):f(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=R;function L(M,b){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=M.toString().split(`
`);for(const I of y){const k=f.exec(I.trim());k&&k.length===6&&b(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(Z[127],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"});var he=this&&this.__decorate||function(j,e,S,t){var R=arguments.length,L=R<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(j,e,S,t);else for(var b=j.length-1;b>=0;b--)(M=j[b])&&(L=(R<3?M(L):R>3?M(e,S,L):M(e,S))||L);return R>3&&L&&Object.defineProperty(e,S,L),L};define(Z[40],x([0,1,25,8,18,23,49,15,3,2,119,30,11]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function d(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function w(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(p||(p={}));class P{constructor(N){this.buffer=N,this.pos=0}read(N){const q=this.buffer.slice(this.pos,this.pos+N);return this.pos+=q.byteLength,q}}class v{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(N){this.buffers.push(N)}}var u;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(u||(u={}));function c(U){const N=R.VSBuffer.alloc(4);return N.writeUInt32BE(U,0),N}function n(U){return U.read(4).readUInt32BE(0)}function s(U){const N=R.VSBuffer.alloc(1);return N.writeUInt8(U,0),N}const i={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object)},o=typeof Buffer!="undefined";function a(U,N){if(typeof N=="undefined")U.write(i.Undefined);else if(typeof N=="string"){const q=R.VSBuffer.fromString(N);U.write(i.String),U.write(c(q.byteLength)),U.write(q)}else if(o&&Buffer.isBuffer(N)){const q=R.VSBuffer.wrap(N);U.write(i.Buffer),U.write(c(q.byteLength)),U.write(q)}else if(N instanceof R.VSBuffer)U.write(i.VSBuffer),U.write(c(N.byteLength)),U.write(N);else if(Array.isArray(N)){U.write(i.Array),U.write(c(N.length));for(const q of N)a(U,q)}else{const q=R.VSBuffer.fromString(JSON.stringify(N));U.write(i.Object),U.write(c(q.byteLength)),U.write(q)}}function r(U){switch(U.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return U.read(n(U)).toString();case u.Buffer:return U.read(n(U)).buffer;case u.VSBuffer:return U.read(n(U));case u.Array:{const q=n(U),ee=[];for(let Q=0;Q<q;Q++)ee.push(r(U));return ee}case u.Object:return JSON.parse(U.read(n(U)).toString())}}class l{constructor(N,q,ee=null,Q=1e3){this.protocol=N,this.ctx=q,this.logger=ee,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(N,q){this.channels.set(N,q),setTimeout(()=>this.flushPendingRequests(N),0)}sendResponse(N){switch(N.type){case 200:{const q=this.send([N.type]);this.logger?.logOutgoing(q,0,1,w(N.type));return}case 201:case 202:case 204:case 203:{const q=this.send([N.type,N.id],N.data);this.logger?.logOutgoing(q,N.id,1,w(N.type),N.data);return}}}send(N,q=void 0){const ee=new v;return a(ee,N),a(ee,q),this.sendBuffer(ee.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onRawMessage(N){const q=new P(N),ee=r(q),Q=r(q),X=ee[0];switch(X){case 100:return this.logger?.logIncoming(N.byteLength,ee[1],1,`${d(X)}: ${ee[2]}.${ee[3]}`,Q),this.onPromise({type:X,id:ee[1],channelName:ee[2],name:ee[3],arg:Q});case 102:return this.logger?.logIncoming(N.byteLength,ee[1],1,`${d(X)}: ${ee[2]}.${ee[3]}`,Q),this.onEventListen({type:X,id:ee[1],channelName:ee[2],name:ee[3],arg:Q});case 101:return this.logger?.logIncoming(N.byteLength,ee[1],1,`${d(X)}`),this.disposeActiveRequest({type:X,id:ee[1]});case 103:return this.logger?.logIncoming(N.byteLength,ee[1],1,`${d(X)}`),this.disposeActiveRequest({type:X,id:ee[1]})}}onPromise(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const ee=new L.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,N.name,N.arg,ee.token)}catch(A){Q=Promise.reject(A)}const X=N.id;Q.then(A=>{this.sendResponse({id:X,data:A,type:201}),this.activeRequests.delete(N.id)},A=>{A instanceof Error?this.sendResponse({id:X,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:X,data:A,type:203}),this.activeRequests.delete(N.id)});const T=(0,y.toDisposable)(()=>ee.cancel());this.activeRequests.set(N.id,T)}onEventListen(N){const q=this.channels.get(N.channelName);if(!q){this.collectPendingRequest(N);return}const ee=N.id,X=q.listen(this.ctx,N.name,N.arg)(T=>this.sendResponse({id:ee,data:T,type:204}));this.activeRequests.set(N.id,X)}disposeActiveRequest(N){const q=this.activeRequests.get(N.id);q&&(q.dispose(),this.activeRequests.delete(N.id))}collectPendingRequest(N){let q=this.pendingRequests.get(N.channelName);q||(q=[],this.pendingRequests.set(N.channelName,q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.sendResponse({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:N,timeoutTimer:ee})}flushPendingRequests(N){const q=this.pendingRequests.get(N);if(q){for(const ee of q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(N)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var g;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(N,q=null){this.protocol=N,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=q}getChannel(N){const q=this;return{call(ee,Q,X){return q.isDisposed?Promise.reject(b.canceled()):q.requestPromise(N,ee,Q,X)},listen(ee,Q){return q.isDisposed?f.Event.None:q.requestEvent(N,ee,Q)}}}requestPromise(N,q,ee,Q=L.CancellationToken.None){const X=this.lastRequestId++,A={id:X,type:100,channelName:N,name:q,arg:ee};if(Q.isCancellationRequested)return Promise.reject(b.canceled());let _;return new Promise((F,B)=>{if(Q.isCancellationRequested)return B(b.canceled());const K=()=>{const fe=Ie=>{switch(Ie.type){case 201:this.handlers.delete(X),F(Ie.data);break;case 202:{this.handlers.delete(X);const be=new Error(Ie.data.message);be.stack=Ie.data.stack,be.name=Ie.data.name,B(be);break}case 203:this.handlers.delete(X),B(Ie.data);break}};this.handlers.set(X,fe),this.sendRequest(A)};let ie=null;this.state===p.Idle?K():(ie=(0,t.createCancelablePromise)(fe=>this.whenInitialized()),ie.then(()=>{ie=null,K()}));const oe=()=>{ie?(ie.cancel(),ie=null):this.sendRequest({id:X,type:101}),B(b.canceled())},ue=Q.onCancellationRequested(oe);_=(0,y.combinedDisposable)((0,y.toDisposable)(oe),ue),this.activeRequests.add(_)}).finally(()=>{this.activeRequests.delete(_)})}requestEvent(N,q,ee){const Q=this.lastRequestId++,T={id:Q,type:102,channelName:N,name:q,arg:ee};let A=null;const _=new f.Emitter({onFirstListenerAdd:()=>{A=(0,t.createCancelablePromise)(F=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(_),this.sendRequest(T)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(_),this.sendRequest({id:Q,type:103}))}}),z=F=>_.fire(F.data);return this.handlers.set(Q,z),_.event}sendRequest(N){switch(N.type){case 100:case 102:{const q=this.send([N.type,N.id,N.channelName,N.name],N.arg);this.logger&&this.logger.logOutgoing(q,N.id,0,`${d(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const q=this.send([N.type,N.id]);this.logger&&this.logger.logOutgoing(q,N.id,0,d(N.type));return}}}send(N,q=void 0){const ee=new v;return a(ee,N),a(ee,q),this.sendBuffer(ee.buffer)}sendBuffer(N){try{return this.protocol.send(N),N.byteLength}catch{return 0}}onBuffer(N){const q=new P(N),ee=r(q),Q=r(q),X=ee[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(N.byteLength,0,0,w(X)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(N.byteLength,ee[1],0,w(X),Q),this.onResponse({type:ee[0],id:ee[1],data:Q})}}onResponse(N){if(N.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(N.id);q&&q(N)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,y.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([M.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class D{constructor(N){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,N(({protocol:q,onDidClientDisconnect:ee})=>{f.Event.once(q.onMessage)(X=>{const T=new P(X),A=r(T),_=new l(q,A),z=new E(q);this.channels.forEach((B,K)=>_.registerChannel(K,B));const F={channelServer:_,channelClient:z,ctx:A};this._connections.add(F),this._onDidAddConnection.fire(F),ee(()=>{_.dispose(),z.dispose(),this._connections.delete(F),this._onDidRemoveConnection.fire(F)})})})}get connections(){const N=[];return this._connections.forEach(q=>N.push(q)),N}getChannel(N,q){const ee=this;return{call(Q,X,T){let A;if((0,C.isFunction)(q)){let z=(0,S.getRandomElement)(ee.connections.filter(q));A=z?Promise.resolve(z):f.Event.toPromise(f.Event.filter(ee.onDidAddConnection,q))}else A=q.routeCall(ee,Q,X);const _=A.then(z=>z.channelClient.getChannel(N));return O(_).call(Q,X,T)},listen(Q,X){if((0,C.isFunction)(q))return ee.getMulticastEvent(N,q,Q,X);const T=q.routeEvent(ee,Q,X).then(A=>A.channelClient.getChannel(N));return O(T).listen(Q,X)}}}getMulticastEvent(N,q,ee,Q){const X=this;let T=new y.DisposableStore;const A=new f.Emitter({onFirstListenerAdd:()=>{T=new y.DisposableStore;const _=new f.EventMultiplexer,z=new Map,F=K=>{const oe=K.channelClient.getChannel(N).listen(ee,Q),ue=_.add(oe);z.set(K,ue)},B=K=>{const ie=z.get(K);!ie||(ie.dispose(),z.delete(K))};X.connections.filter(q).forEach(F),f.Event.filter(X.onDidAddConnection,q)(F,void 0,T),X.onDidRemoveConnection(B,void 0,T),_.event(A.fire,A,T),T.add(_)},onLastListenerRemove:()=>{T.dispose()}});return A.event}registerChannel(N,q){this.channels.set(N,q),this._connections.forEach(ee=>{ee.channelServer.registerChannel(N,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class W{constructor(N,q,ee=null){const Q=new v;a(Q,q),N.send(Q.buffer),this.channelClient=new E(N,ee),this.channelServer=new l(N,q,ee)}getChannel(N){return this.channelClient.getChannel(N)}registerChannel(N,q){this.channelServer.registerChannel(N,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function O(U){return{call(N,q,ee){return U.then(Q=>Q.call(N,q,ee))},listen(N,q){const ee=new f.Relay;return U.then(Q=>ee.input=Q.listen(N,q)),ee.event}}}e.getDelayedChannel=O;function V(U){let N=!1;return{call(q,ee,Q){return N?U.call(q,ee,Q):(0,t.timeout)(0).then(()=>N=!0).then(()=>U.call(q,ee,Q))},listen(q,ee){if(N)return U.listen(q,ee);const Q=new f.Relay;return(0,t.timeout)(0).then(()=>N=!0).then(()=>Q.input=U.listen(q,ee)),Q.event}}}e.getNextTickChannel=V;class J{constructor(N){this.fn=N}routeCall(N){return this.route(N)}routeEvent(N){return this.route(N)}async route(N){for(const q of N.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await f.Event.toPromise(N.onDidAddConnection),await this.route(N)}}e.StaticRouter=J;var ne;(function(U){function N(X,T){const A=X,_=T&&T.disableMarshalling,z=new Map;for(const F in A)ee(F)&&z.set(F,f.Event.buffer(A[F],!0));return new class{listen(F,B,K){const ie=z.get(B);if(ie)return ie;if(Q(B)){const oe=A[B];if(typeof oe=="function")return oe.call(A,K)}throw new Error(`Event not found: ${B}`)}call(F,B,K){const ie=A[B];if(typeof ie=="function"){if(!_&&Array.isArray(K))for(let oe=0;oe<K.length;oe++)K[oe]=(0,I.revive)(K[oe]);return ie.apply(A,K)}throw new Error(`Method not found: ${B}`)}}}U.fromService=N;function q(X,T){const A=T&&T.disableMarshalling;return new Proxy({},{get(_,z){if(typeof z=="string")return T?.properties?.has(z)?T.properties.get(z):Q(z)?function(F){return X.listen(z,F)}:ee(z)?X.listen(z):async function(...F){let B;T&&!(0,C.isUndefinedOrNull)(T.context)?B=[T.context,...F]:B=F;const K=await X.call(z,B);return A?K:(0,I.revive)(K)};throw new Error(`Property not found: ${String(z)}`)}})}U.toService=q;function ee(X){return X[0]==="o"&&X[1]==="n"&&k.isUpperAsciiLetter(X.charCodeAt(2))}function Q(X){return/^onDynamic/.test(X)&&k.isUpperAsciiLetter(X.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let N=U.toString();if(N!=="[object Object]")return N}return U}function ae(U){return Array.isArray(U)?U.map(re):re(U)}function H(U,N,q,ee,Q,X,T){T=ae(T);const A=Y[Q],_=A[ee%A.length];let z=[`%c[${U}]%c[${String(N).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${_}`];/\($/.test(X)?(z=z.concat(T),z.push(")")):z.push(T),console.log.apply(console,z)}e.logWithColors=H;class ${constructor(N,q){this._outgoingPrefix=N,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(N,q,ee,Q,X){this._totalOutgoing+=N,H(this._outgoingPrefix,this._totalOutgoing,N,q,ee,Q,X)}logIncoming(N,q,ee,Q,X){this._totalIncoming+=N,H(this._incomingPrefix,this._totalIncoming,N,q,ee,Q,X)}}e.IPCLogger=$}),define(Z[128],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(R,L){this.sender=R,this.onMessage=L}send(R){try{this.sender.send("vscode:message",R.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(Z[129],x([0,1,18,3,40]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(f){this.port=f,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",y=>S.VSBuffer.wrap(y.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class M extends R.IPCClient{constructor(f,y){const I=new L(f);super(I,y);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Z[91],x([0,1,18,3,2,40]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(o){o.enableDiagnostics=!1,o.records=[];const a=new WeakMap;let r=0;function l(E,D){if(!a.has(E)){const W=String(++r);a.set(E,W)}return a.get(E)}function g(E,D,W,O){if(!o.enableDiagnostics)return;const V=l(E,D);if(O instanceof S.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const J=S.VSBuffer.alloc(O.byteLength);J.set(O),o.records.push({timestamp:Date.now(),id:V,label:D,type:W,buff:J})}else o.records.push({timestamp:Date.now(),id:V,label:D,type:W,data:O})}o.traceSocketEvent=g})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function I(){return y||(y=S.VSBuffer.alloc(0)),y}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,r){if(a===0)return I();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const D=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=a),D}if(this._chunks[0].byteLength>a){const D=this._chunks[0].slice(0,a);return r&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),D}let l=S.VSBuffer.alloc(a),g=0,E=0;for(;a>0;){const D=this._chunks[E];if(D.byteLength>a){const W=D.slice(0,a);l.set(W,g),g+=a,r&&(this._chunks[E]=D.slice(a),this._totalLength-=a),a-=a}else l.set(D,g),g+=D.byteLength,r?(this._chunks.shift(),this._totalLength-=D.byteLength):E++,a-=D.byteLength}return l}}e.ChunkStream=k;var C;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume"})(C||(C={}));function m(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(a,r,l,g){this.type=a,this.id=r,this.ack=l,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends R.Disposable{constructor(a){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,g=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",r),this._onMessage.fire(new h(l,g,E,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(a){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=S.VSBuffer.alloc(13);r.writeUInt8(a.type,0),r.writeUInt32BE(a.id,1),r.writeUInt32BE(a.ack,5),r.writeUInt32BE(a.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",a.data),this._writeSoon(r,a.data)}_bufferAdd(a,r){const l=this._totalLength===0;return this._data.push(a,r),this._totalLength+=a.byteLength+r.byteLength,l}_bufferTake(){const a=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,r){this._bufferAdd(a,r)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const a=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this._socket.write(a)}}class P extends R.Disposable{constructor(a){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new h(1,0,0,a))}}e.Protocol=P;class v extends L.IPCClient{constructor(a,r,l=null){super(a,r,l);this.protocol=a}static fromSocket(a,r){return new v(new P(a),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=v;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(a){this.data=a,this.next=null}}class n{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],r=0,l=this._first;for(;l;)a[r++]=l.data,l=l.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const r=new c(a);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class s{constructor(){this.lastRuns=[];const a=Date.now();for(let r=0;r<s._HISTORY_LENGTH;r++)this.lastRuns[r]=a-1e3*r;setInterval(()=>{for(let r=s._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const a=Date.now(),r=(1+s._HISTORY_LENGTH)*1e3;let l=0;for(let g=0;g<s._HISTORY_LENGTH;g++)a-this.lastRuns[g]<=r&&l++;return 1-l/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class i{constructor(a,r=null,l=s.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=a,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),r&&this._socketReader.acceptChunk(r)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new h(5,0,0,I());this._socketWriter.write(a),this._socketWriter.flush()}sendPause(){const a=new h(7,0,0,I());this._socketWriter.write(a)}sendResume(){const a=new h(8,0,0,I());this._socketWriter.write(a)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,r){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=a,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,I());this._socketWriter.write(a);const r=this._outgoingUnackMsg.toArray();for(let l=0,g=r.length;l<g;l++)this._socketWriter.write(r[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new h(6,0,0,I())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data);break}case 2:{this._onControlMessage.fire(a.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const r=this._outgoingUnackMsg.toArray();for(let l=0,g=r.length;l<g;l++)this._socketWriter.write(r[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,r,this._incomingAckId,a);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(a){const r=new h(2,0,0,a);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const a=this._outgoingUnackMsg.peek(),r=Date.now()-a.writtenTime,l=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(r>=2e4&&l>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const E=Math.max(2e4-r,2e4-l,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new h(3,0,this._incomingAckId,I());this._socketWriter.write(a)}}e.PersistentProtocol=i}),define(Z[38],x([0,1,13,15]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class R{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,b){const f=(y,...I)=>{this.validateEvent(M,y)&&b(y,...I)};return this.mapListenerToWrapper.set(b,f),S.ipcMain.on(M,f),this}once(M,b){return S.ipcMain.once(M,(f,...y)=>{this.validateEvent(M,f)&&b(f,...y)}),this}handle(M,b){return S.ipcMain.handle(M,(f,...y)=>this.validateEvent(M,f)?b(f,...y):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return S.ipcMain.removeHandler(M),this}removeListener(M,b){const f=this.mapListenerToWrapper.get(b);return f&&(S.ipcMain.removeListener(M,f),this.mapListenerToWrapper.delete(b)),this}validateEvent(M,b){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const f=b.senderFrame,y=f.url;if(!y)return!0;let I="unknown";try{I=new URL(y).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${y}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${I}'.`),!1):f.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new R}),define(Z[130],x([0,1,13,38,11,127]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(L.CONTEXT_MENU_CHANNEL,(f,y,I,k,C)=>{const m=b(f,k,I);m.popup({window:(0,R.withNullAsUndefined)(S.BrowserWindow.fromWebContents(f.sender)),x:C?C.x:void 0,y:C?C.y:void 0,positioningItem:C?C.positioningItem:void 0,callback:()=>{m&&f.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,y)}})})}e.registerContextMenuListener=M;function b(f,y,I){const k=new S.Menu;return I.forEach(C=>{let m;C.type==="separator"?m=new S.MenuItem({type:C.type}):Array.isArray(C.submenu)?m=new S.MenuItem({submenu:b(f,y,C.submenu),label:C.label}):m=new S.MenuItem({label:C.label,type:C.type,accelerator:C.accelerator,checked:C.checked,enabled:C.enabled,visible:C.visible,click:(d,h,w)=>f.sender.send(y,C.id,w)}),k.append(m)}),k}}),define(Z[131],x([0,1,38,18,3,2,40,128]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(I,k){const C=R.Event.fromNodeEventEmitter(S.validatedIpcMain,k,(d,h)=>({event:d,message:h})),m=R.Event.filter(C,({event:d})=>d.sender.id===I);return R.Event.map(m,({message:d})=>d&&t.VSBuffer.wrap(d))}class y extends M.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const k=R.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:C})=>C);return R.Event.map(k,C=>{const m=C.id,d=y.Clients.get(m);d&&d.dispose();const h=new R.Emitter;y.Clients.set(m,(0,L.toDisposable)(()=>h.fire()));const w=f(m,"vscode:message"),p=R.Event.any(R.Event.signal(f(m,"vscode:disconnect")),h.event);return{protocol:new b.Protocol(C,w),onDidClientDisconnect:p}})}}e.Server=y,y.Clients=new Map}),define(Z[92],x([0,1,38,3,31,129]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends L.Client{constructor(y,I){super({addEventListener:(k,C)=>y.addListener(k,C),removeEventListener:(k,C)=>y.removeListener(k,C),postMessage:k=>y.postMessage(k),start:()=>y.start(),close:()=>y.close()},I)}}e.Client=M;async function b(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,R.generateUuid)();f.webContents.send("vscode:createMessageChannel",y);const I=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(C,m)=>({nonce:m,port:C.ports[0]})),{port:k}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,C=>C.nonce===y)));return k}e.connect=b}),define(Z[93],x([0,1,8,3,2,11]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function b(k){const C=k;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var f;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class y extends R.Disposable{constructor(C,m=Object.create(null)){super();this.database=C,this.options=m,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(C=>this.onDidChangeItemsExternal(C)))}onDidChangeItemsExternal(C){C.changed?.forEach((m,d)=>this.accept(d,m)),C.deleted?.forEach(m=>this.accept(m,void 0))}accept(C,m){if(this.state===f.Closed)return;let d=!1;(0,L.isUndefinedOrNull)(m)?d=this.cache.delete(C):this.cache.get(C)!==m&&(this.cache.set(C,m),d=!0),d&&this._onDidChangeStorage.fire(C)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(C,m){const d=this.cache.get(C);return(0,L.isUndefinedOrNull)(d)?m:d}getBoolean(C,m){const d=this.get(C);return(0,L.isUndefinedOrNull)(d)?m:d==="true"}getNumber(C,m){const d=this.get(C);return(0,L.isUndefinedOrNull)(d)?m:parseInt(d,10)}async set(C,m){if(this.state===f.Closed)return;if((0,L.isUndefinedOrNull)(m))return this.delete(C);const d=String(m);if(this.cache.get(C)!==d)return this.cache.set(C,d),this.pendingInserts.set(C,d),this.pendingDeletes.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async delete(C){if(!(this.state===f.Closed||!this.cache.delete(C)))return this.pendingDeletes.has(C)||this.pendingDeletes.add(C),this.pendingInserts.delete(C),this._onDidChangeStorage.fire(C),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const C={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(C).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(C){if(!!this.hasPending)return this.doFlush(C)}async doFlush(C){return this.flushDelayer.trigger(()=>this.flushPending(),C)}async whenFlushed(){if(!!this.hasPending)return new Promise(C=>this.whenFlushedCallbacks.push(C))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(C){C.insert&&C.insert.forEach((m,d)=>this.items.set(d,m)),C.delete&&C.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=I}),define(Z[132],x([0,1,8,3,36,9,21]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(I,k=Object.create(null)){this.path=I,this.options=k,this.name=(0,L.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,k=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(m=>k.set(m.key,m.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${k.size} rows`),k}async updateItems(I){const k=await this.whenConnected;return this.doUpdateItems(k,I)}doUpdateItems(I,k){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${k.insert?(0,R.mapToString)(k.insert):"0"}), delete(${k.delete?(0,R.setToString)(k.delete):"0"})`),this.transaction(I,()=>{const C=k.insert,m=k.delete;if(C&&C.size>0){const d=[];d.push([]);let h=0;C.forEach((w,p)=>{let P=d[h];P.length>b.MAX_HOST_PARAMETERS&&(h++,P=[],d.push(P)),P.push(p,w)}),d.forEach(w=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,p=>p.run(w),()=>{const p=[];let P=0;return C.forEach((v,u)=>{p.push(u),P+=v.length}),`Keys: ${p.join(", ")} Length: ${P}`})})}if(m&&m.size){const d=[];d.push([]);let h=0;m.forEach(w=>{let p=d[h];p.length>b.MAX_HOST_PARAMETERS&&(h++,p=[],d.push(p)),p.push(w)}),d.forEach(w=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,p=>p.run(w),()=>{const p=[];return m.forEach(P=>{p.push(P)}),`Keys: ${p.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const k=await this.whenConnected;return this.doClose(k,I)}doClose(I,k){return new Promise((C,m)=>{I.db.close(d=>(d&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${d}`),this.path===b.IN_MEMORY_PATH?C():!I.isErroneous&&!I.isInMemory?this.backup().then(C,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),C())):typeof k=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const w=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:k()}).then(()=>w(),p=>(w(),Promise.reject(p)))})).then(C,m):m(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return M.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const k=await this.whenConnected,C=await this.get(k,I?"PRAGMA integrity_check":"PRAGMA quick_check"),m=I?C.integrity_check:C.quick_check;return k.isErroneous?`${m} (last error: ${k.lastError})`:k.isInMemory?`${m} (in-memory!)`:m}async connect(I,k=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${k})`);try{return await this.doConnect(I)}catch(C){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${C}`),C.code==="SQLITE_BUSY"&&k)return await(0,S.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await M.Promises.unlink(I);try{await M.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(m){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${m}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(I,k){I.isErroneous=!0,I.lastError=k,this.logger.error(k)}doConnect(I){return new Promise((k,C)=>{new Promise((m,d)=>{j(["@vscode/sqlite3"],m,d)}).then(m=>{const d={db:new(this.logger.isTracing?m.verbose().Database:m.Database)(I,h=>h?d.db?d.db.close(()=>C(h)):C(h):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(d),w=>d.db.close(()=>C(w)))),isInMemory:I===b.IN_MEMORY_PATH};d.db.on("error",h=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&d.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},C)})}exec(I,k){return new Promise((C,m)=>{I.db.exec(k,d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${d}`),m(d)):C())})}get(I,k){return new Promise((C,m)=>{I.db.get(k,(d,h)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${d}`),m(d)):C(h))})}all(I,k){return new Promise((C,m)=>{I.db.all(k,(d,h)=>d?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${d}`),m(d)):C(h))})}transaction(I,k){return new Promise((C,m)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),k(),I.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${d}`),m(d)):C())})})}prepare(I,k,C,m){const d=I.db.prepare(k),h=w=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${w} (${k}). Details: ${m()}`)};d.on("error",h),C(d),d.finalize(w=>{w&&h(w),d.removeListener("error",h)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class f{constructor(I){I&&typeof I.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace&&this.logTrace(I)}error(I){this.logError&&this.logError(I)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[133],x([14,12]),function(j,e){return j.create("vs/base/common/date",e)}),define(Z[134],x([0,1,133]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,R=t*60,L=R*24,M=L*7,b=L*30,f=L*365;function y(k,C,m){typeof k!="number"&&(k=k.getTime());const d=Math.round((new Date().getTime()-k)/1e3);if(d<-30)return(0,S.localize)(0,null,y(new Date().getTime()+d*1e3,!1));if(d<30)return(0,S.localize)(1,null);let h;return d<t?(h=d,C?h===1?m?(0,S.localize)(2,null,h):(0,S.localize)(3,null,h):m?(0,S.localize)(4,null,h):(0,S.localize)(5,null,h):h===1?m?(0,S.localize)(6,null,h):(0,S.localize)(7,null,h):m?(0,S.localize)(8,null,h):(0,S.localize)(9,null,h)):d<R?(h=Math.floor(d/t),C?h===1?m?(0,S.localize)(10,null,h):(0,S.localize)(11,null,h):m?(0,S.localize)(12,null,h):(0,S.localize)(13,null,h):h===1?m?(0,S.localize)(14,null,h):(0,S.localize)(15,null,h):m?(0,S.localize)(16,null,h):(0,S.localize)(17,null,h)):d<L?(h=Math.floor(d/R),C?h===1?m?(0,S.localize)(18,null,h):(0,S.localize)(19,null,h):m?(0,S.localize)(20,null,h):(0,S.localize)(21,null,h):h===1?m?(0,S.localize)(22,null,h):(0,S.localize)(23,null,h):m?(0,S.localize)(24,null,h):(0,S.localize)(25,null,h)):d<M?(h=Math.floor(d/L),C?h===1?(0,S.localize)(26,null,h):(0,S.localize)(27,null,h):h===1?(0,S.localize)(28,null,h):(0,S.localize)(29,null,h)):d<b?(h=Math.floor(d/M),C?h===1?m?(0,S.localize)(30,null,h):(0,S.localize)(31,null,h):m?(0,S.localize)(32,null,h):(0,S.localize)(33,null,h):h===1?m?(0,S.localize)(34,null,h):(0,S.localize)(35,null,h):m?(0,S.localize)(36,null,h):(0,S.localize)(37,null,h)):d<f?(h=Math.floor(d/b),C?h===1?m?(0,S.localize)(38,null,h):(0,S.localize)(39,null,h):m?(0,S.localize)(40,null,h):(0,S.localize)(41,null,h):h===1?m?(0,S.localize)(42,null,h):(0,S.localize)(43,null,h):m?(0,S.localize)(44,null,h):(0,S.localize)(45,null,h)):(h=Math.floor(d/f),C?h===1?m?(0,S.localize)(46,null,h):(0,S.localize)(47,null,h):m?(0,S.localize)(48,null,h):(0,S.localize)(49,null,h):h===1?m?(0,S.localize)(50,null,h):(0,S.localize)(51,null,h):m?(0,S.localize)(52,null,h):(0,S.localize)(53,null,h))}e.fromNow=y;function I(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Z[135],x([14,12]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Z[41],x([0,1,25,11,135]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(k,C){return C&&(k.stack||k.stacktrace)?R.localize(0,null,b(k),M(k.stack)||M(k.stacktrace)):b(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function b(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function f(k=null,C=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const m=S.coalesce(k),d=f(m[0],C);return m.length>1?R.localize(4,null,d,m.length):d}if(t.isString(k))return k;if(k.detail){const m=k.detail;if(m.error)return L(m.error,C);if(m.exception)return L(m.exception,C)}return k.stack?L(k,C):k.message?k.message:R.localize(5,null)}e.toErrorMessage=f;function y(k){const C=k;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=y;function I(k,C){let m;return typeof k=="string"?m=new Error(k):m=k,m.actions=C,m}e.createErrorWithActions=I}),define(Z[136],x([14,12]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Z[76],x([0,1,39,28,10,47,9,4,35,71,11,122,21,136]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return y.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return y.TerminateResponseCode}});function d(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(c,n){if(b.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};n&&(s.cwd=n);const i=S.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],s);return new Promise(o=>{i.once("error",a=>{o({success:!1,error:a})}),i.once("exit",(a,r)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?d(s.status):1})}else if(b.isLinux||b.isMacintosh)try{const s=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{S.execFile(s,[c.pid.toString()],{encoding:"utf8",shell:!0},(o,a,r)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function w(c=f.env){return c.comspec||"cmd.exe"}e.getWindowsShell=w;class p{constructor(n,s,i,o){if(s!==void 0&&i!==void 0&&o!==void 0)this.cmd=n,this.args=s,this.shell=i,this.options=o;else{const a=n;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(f.env).forEach(r=>{a[r]=f.env[r]}),Object.keys(this.options.env).forEach(r=>{a[r]=this.options.env[r]}),this.options.env=a}}getSanitizedCommand(){let n=this.cmd.toLowerCase();const s=n.lastIndexOf(M.sep);return s!==-1&&(n=n.substring(s+1)),p.WellKnowCommands[n]?n:"other"}start(n){return b.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(f.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(s=>{let i,o;const a=new Promise((r,l)=>{i=r,o=l});if(s){let r=this.cmd;this.args&&(r=r+" "+this.args.join(" ")),this.childProcess=S.exec(r,this.options,(l,g,E)=>{this.childProcess=null;const D=l;D&&D.killed?o({killed:this.terminateRequested,stdout:g.toString(),stderr:E.toString()}):this.handleExec(i,n,l,g,E)})}else{let r=null;const l=g=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(g,i,n,o);const E={terminated:this.terminateRequested};I.isNumber(g)&&(E.cmdCode=g),i(E)};if(this.shell&&b.isWindows){const g=L.deepClone(this.options);g.windowsVerbatimArguments=!0,g.detached=!1;let E=!1,D=!1;const W=[];let O=this.ensureQuotes(this.cmd);W.push(O.value),E=O.quoted,this.args&&this.args.forEach(J=>{O=this.ensureQuotes(J),W.push(O.value),D=D&&O.quoted});const V=["/s","/c"];E?D?V.push('"'+W.join(" ")+'"'):W.length>1?V.push('"'+W[0]+'" '+W.slice(1).join(" ")):V.push('"'+W[0]+'"'):V.push(W.join(" ")),r=S.spawn(w(),V,g)}else this.cmd&&(r=S.spawn(this.cmd,this.args,this.options));r&&(this.childProcess=r,this.childProcessPromise=Promise.resolve(r),this.pidResolve&&(this.pidResolve(I.isNumber(r.pid)?r.pid:-1),this.pidResolve=void 0),r.on("error",g=>{this.childProcess=null,o({terminated:this.terminateRequested,error:g})}),r.pid&&(this.childProcess.on("close",l),this.handleSpawn(r,i,n,o,!0)))}return a})}handleClose(n,s,i,o){}ensureQuotes(n){return p.regexp.test(n)?{value:'"'+n+'"',quoted:!0}:{value:n,quoted:n.length>0&&n[0]==='"'&&n[n.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(n=>n.pid,n=>-1):new Promise(n=>{this.pidResolve=n})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(n=>(this.terminateRequested=!0,h(n,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),n=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(n=>{if(!this.shell||!b.isWindows)return n(!1);const s=S.spawn(w(),["/s","/c"]);s.on("error",i=>n(!0)),s.on("exit",i=>n(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class P extends p{constructor(n,s,i,o){super(n,s,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(n,s,i,o,a){[o,a].forEach((r,l)=>{const g=new k.LineDecoder;g.write(r).forEach(W=>{s({line:W,source:l===0?0:1})});const D=g.end();D&&s({line:D,source:l===0?0:1})}),n({terminated:this.terminateRequested,error:i})}handleSpawn(n,s,i,o,a){const r=new k.LineDecoder,l=new k.LineDecoder;n.stdout.on("data",g=>{r.write(g).forEach(D=>i({line:D,source:0}))}),n.stderr.on("data",g=>{l.write(g).forEach(D=>i({line:D,source:1}))}),this.stdoutLineDecoder=r,this.stderrLineDecoder=l}handleClose(n,s,i,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const r=this.stderrLineDecoder?this.stderrLineDecoder.end():null;r&&i({line:r,source:1})}}e.LineProcess=P;function v(c){let n=[],s=!1;const i=function(o){if(s){n.push(o);return}(!c.send(o,r=>{if(r&&console.error(r),s=!1,n.length>0){const l=n.slice(0);n=[],l.forEach(g=>i(g))}})||b.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=v;var u;(function(c){async function n(s,i,o){if(M.isAbsolute(s))return s;if(i===void 0&&(i=f.cwd()),M.dirname(s)!=="."||(o===void 0&&I.isString(f.env.PATH)&&(o=f.env.PATH.split(M.delimiter)),o===void 0||o.length===0))return M.join(i,s);async function r(l){if(await C.Promises.exists(l)){let g;try{g=await C.Promises.stat(l)}catch(E){E.message.startsWith("EACCES")&&(g=await C.Promises.lstat(l))}return g?!g.isDirectory():!1}return!1}for(let l of o){let g;if(M.isAbsolute(l)?g=M.join(l,s):g=M.join(i,l,s),await r(g))return g;let E=g+".com";if(await r(E)||(E=g+".exe",await r(E)))return E}return M.join(i,s)}c.findExecutable=n})(u=e.win32||(e.win32={}))}),define(Z[137],x([0,1,27,4,126,76]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(m,d){return m===1?t.isWindows?k():L.getWindowsShell(d):y(m,d)}e.getSystemShell=M;function b(m,d){return m===1?t.isWindows?C(d):L.getWindowsShell(d):y(m,d)}e.getSystemShellSync=b;let f=null;function y(m,d){if(t.isLinux&&m===2||t.isMacintosh&&m===3)return"/bin/bash";if(!f){let h;if(t.isWindows)h="/bin/bash";else{if(h=d.SHELL,!h)try{h=(0,S.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}f=h}return f}let I=null;async function k(){return I||(I=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),I}function C(m){if(I)return I;const d=t.isWindows&&parseFloat((0,S.release)())>=10,h=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${m.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?w:L.getWindowsShell(m)}}),define(Z[138],x([0,1,39,8,18,23,118,15,3,2,47,76,71,40]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends m.ChannelServer{constructor(p){super({send:P=>{try{process.send&&process.send(P.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",P=>R.VSBuffer.wrap(Buffer.from(P,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class h{constructor(p,P){this.modulePath=p,this.options=P,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=P&&P.timeout?P.timeout:6e4;this.disposeDelayer=new t.Delayer(v),this.child=null,this._client=null}getChannel(p){const P=this;return{call(v,u,c){return P.requestPromise(p,v,u,c)},listen(v,u){return P.requestEvent(p,v,u)}}}requestPromise(p,P,v,u=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),n=(0,t.createCancelablePromise)(o=>c.call(P,v,o)),s=u.onCancellationRequested(()=>n.cancel()),i=(0,y.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(p,P,v){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let u;const c=new f.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(p).listen(P,v)(c.fire,c),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],P=Object.create(null);P.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(P.env={...P.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(P.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(P.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(P.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),P.execArgv===void 0&&(P.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,C.removeDangerousEnvVariables)(P.env),this.child=(0,S.fork)(this.modulePath,p,P);const v=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,M.isRemoteConsoleLog)(a)){(0,M.log)(a,`IPC Library: ${this.options.serverName}`);return}v.fire(R.VSBuffer.wrap(Buffer.from(a,"base64")))});const c=this.options.useQueue?(0,k.createQueuedSender)(this.child):this.child,n=a=>this.child&&this.child.connected&&c.send(a.buffer.toString("base64")),s=v.event,i={send:n,onMessage:s};this._client=new m.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,r)=>{process.removeListener("exit",o),this.activeRequests.forEach(l=>(0,y.dispose)(l)),this.activeRequests.clear(),a!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:r})})}return this._client}getCachedChannel(p){let P=this.channels.get(p);return P||(P=this.client.getChannel(p),this.channels.set(p,P)),P}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(Z[139],x([14,12]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Z[140],x([14,12]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[141],x([14,12]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[142],x([14,12]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Z[143],x([14,12]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Z[144],x([14,12]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[145],x([14,12]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Z[146],x([14,12]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Z[147],x([14,12]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Z[148],x([14,12]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[149],x([14,12]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[150],x([14,12]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[151],x([14,12]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[152],x([14,12]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[153],x([14,12]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Z[154],x([14,12]),function(j,e){return j.create("vs/platform/shell/node/shellEnv",e)}),define(Z[155],x([14,12]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[156],x([14,12]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[157],x([14,12]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Z[158],x([14,12]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[159],x([14,12]),function(j,e){return j.create("vs/platform/workspace/common/workspace",e)}),define(Z[160],x([14,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[161],x([14,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[162],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(R){return R&&R.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(R){return R&&R.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(Z[163],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function S(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=S}),define(Z[164],x([0,1,3,2]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class R{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(b,f,y){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(b,f,y){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=R,R.ChannelName="extensionhostdebugservice";class L extends t.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,f,y){this.channel.call("attach",[b,f,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,f){this.channel.call("terminate",[b,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,f){return this.channel.call("openExtensionDevelopmentHostWindow",[b,f])}}e.ExtensionHostDebugChannelClient=L}),define(Z[165],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class S{constructor(R){this.machineId=R}encryption(){return new Promise((R,L)=>j(["vscode-encrypt"],R,L))}async encrypt(R){try{return(await this.encryption()).encrypt(this.machineId,R)}catch{return R}}async decrypt(R){try{return(await this.encryption()).decrypt(this.machineId,R)}catch{return R}}}e.EncryptionMainService=S}),define(Z[166],x([0,1,134,49,10,9,35,16,7]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(h,w,p){this._args=h,this.paths=w,this.productService=p}get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",j).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(f.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=M.env.VSCODE_PORTABLE;return h?f.URI.file((0,L.join)(h,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.resolve)(h):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,L.resolve)(h):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.resolve)(h);const w=M.env.VSCODE_EXTENSIONS;if(w)return w;const p=M.env.VSCODE_PORTABLE;return p?(0,L.join)(p,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(w=>/^[^:/?#]+?:\/\//.test(w)?f.URI.parse(w):f.URI.file((0,L.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,L.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=M.env.VSCODE_PORTABLE;return h?f.URI.file((0,L.join)(h,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}he([t.memoize],y.prototype,"appRoot",null),he([t.memoize],y.prototype,"userHome",null),he([t.memoize],y.prototype,"userDataPath",null),he([t.memoize],y.prototype,"appSettingsHome",null),he([t.memoize],y.prototype,"tmpDir",null),he([t.memoize],y.prototype,"cacheHome",null),he([t.memoize],y.prototype,"userRoamingDataHome",null),he([t.memoize],y.prototype,"settingsResource",null),he([t.memoize],y.prototype,"userDataSyncHome",null),he([t.memoize],y.prototype,"userDataSyncLogResource",null),he([t.memoize],y.prototype,"sync",null),he([t.memoize],y.prototype,"machineSettingsResource",null),he([t.memoize],y.prototype,"globalStorageHome",null),he([t.memoize],y.prototype,"workspaceStorageHome",null),he([t.memoize],y.prototype,"localHistoryHome",null),he([t.memoize],y.prototype,"keybindingsResource",null),he([t.memoize],y.prototype,"keyboardLayoutResource",null),he([t.memoize],y.prototype,"argvResource",null),he([t.memoize],y.prototype,"snippetsHome",null),he([t.memoize],y.prototype,"isExtensionDevelopment",null),he([t.memoize],y.prototype,"untitledWorkspacesHome",null),he([t.memoize],y.prototype,"installSourcePath",null),he([t.memoize],y.prototype,"builtinExtensionsPath",null),he([t.memoize],y.prototype,"extensionsPath",null),he([t.memoize],y.prototype,"extensionDevelopmentLocationURI",null),he([t.memoize],y.prototype,"extensionDevelopmentKind",null),he([t.memoize],y.prototype,"extensionTestsLocationURI",null),he([t.memoize],y.prototype,"debugExtensionHost",null),he([t.memoize],y.prototype,"serviceMachineIdResource",null),he([t.memoize],y.prototype,"telemetryLogResource",null),he([t.memoize],y.prototype,"disableWorkspaceTrust",null),he([t.memoize],y.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=y;function I(d,h){return m(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=I;function k(d,h){return m(d["inspect-search"],d["inspect-brk-search"],5876,h,d.extensionEnvironment)}e.parseSearchPort=k;function C(d,h){return m(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,h,d.extensionEnvironment)}e.parsePtyHostPort=C;function m(d,h,w,p,P,v){const c=Number(h||d)||(p?null:w),n=c?Boolean(!!h):!1;let s;if(v)try{s=JSON.parse(v)}catch{}return{port:c,break:n,debugId:P,env:s}}}),define(Z[94],x([0,1,246,4,142]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(18,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(28,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(d,h,w=M){const p={},P=["_"],v=[];for(let s in h){const i=h[s];i.alias&&(p[s]=i.alias),i.type==="string"||i.type==="string[]"?(P.push(s),i.deprecates&&P.push(...i.deprecates)):i.type==="boolean"&&(v.push(s),i.deprecates&&v.push(...i.deprecates))}const u=S(d,{string:P,boolean:v,alias:p}),c={},n=u;c._=u._.map(s=>String(s)).filter(s=>s.length>0),delete n._;for(let s in h){const i=h[s];i.alias&&delete n[i.alias];let o=n[s];if(i.deprecates)for(const a of i.deprecates)n.hasOwnProperty(a)&&(o||(o=n[a],o&&w.onDeprecatedOption(a,i.deprecationMessage||(0,R.localize)(33,null,s))),delete n[a]);if(typeof o!="undefined"){if(i.type==="string[]"){if(Array.isArray(o)||(o=[o]),!i.allowEmptyValue){const a=o.filter(r=>r.length>0);a.length!==o.length&&(w.onEmptyValue(s),o=a.length>0?a:void 0)}}else i.type==="string"&&(Array.isArray(o)?(o=o.pop(),w.onMultipleValues(s,o)):!o&&!i.allowEmptyValue&&(w.onEmptyValue(s),o=void 0));c[s]=o,i.deprecationMessage&&w.onDeprecatedOption(s,i.deprecationMessage)}delete n[s]}for(let s in n)w.onUnknownOption(s);return c}e.parseArgs=b;function f(d,h){let w="";return h.args&&(Array.isArray(h.args)?w=` <${h.args.join("> <")}>`:w=` <${h.args}>`),h.alias?`-${h.alias} --${d}${w}`:`--${d}${w}`}function y(d,h){let w=0,p=[];for(const c in d){const n=d[c],s=f(c,n);w=Math.max(w,s.length),p.push([s,n.description])}let P=w+2+1;if(h-P<25)return p.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let v=h-P-1,u=[];for(const c of p){let n=c[0],s=k(c[1],v),i=I(P-n.length-2);u.push("  "+n+i+s[0]);for(let o=1;o<s.length;o++)u.push(I(P)+s[o])}return u}e.formatOptions=y;function I(d){return" ".repeat(d)}function k(d,h){let w=[];for(;d.length;){let p=d.length<h?d.length:d.lastIndexOf(" ",h),P=d.slice(0,p).trim();d=d.slice(p),w.push(P)}return w}function C(d,h,w,p,P){const v=process.stdout.isTTY&&process.stdout.columns||80,u=P?.noInputFiles!==!0?`[${(0,R.localize)(34,null)}...]`:"",c=[`${d} ${w}`];c.push(""),c.push(`${(0,R.localize)(35,null)}: ${h} [${(0,R.localize)(36,null)}]${u}`),c.push(""),P?.noPipe!==!0&&(t.isWindows?c.push((0,R.localize)(37,null,h)):c.push((0,R.localize)(38,null,h)),c.push(""));const n={};for(const s in p){const i=p[s];if(i.description&&i.cat){let o=n[i.cat];o||(n[i.cat]=o={}),o[s]=i}}for(let s in n){const i=s;let o=n[i];o&&(c.push(L[i]),c.push(...y(o,v)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=C;function m(d,h){return`${d||(0,R.localize)(39,null)}
${h||(0,R.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=m}),define(Z[167],x([0,1,63,164,94]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends t.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,f,y){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1]):super.call(b,f,y)}async openExtensionDevelopmentHostWindow(b,f){const y=(0,R.parseArgs)(b,R.OPTIONS);y.debugRenderer=f;const I=y.extensionDevelopmentPath;if(!I)return{success:!1};const[k]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:y});if(!f)return{success:!0};const C=k.win;if(!C)return{success:!0};const m=C.webContents.debugger;let d=m.isAttached()?1/0:0;const h=(0,S.createServer)(w=>{d++==0&&m.attach();let p=!1;const P=c=>{p||w.write(JSON.stringify(c)+"\0")},v=(c,n,s,i)=>P({method:n,params:s,sessionId:i});C.on("close",()=>{m.removeListener("message",v),w.end(),p=!0}),m.addListener("message",v);let u=Buffer.alloc(0);w.on("data",c=>{u=Buffer.concat([u,c]);for(let n=u.indexOf(0);n!==-1;n=u.indexOf(0)){let s;try{const i=u.slice(0,n).toString("utf8");u=u.slice(n+1),s=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}m.sendCommand(s.method,s.params,s.sessionId).then(i=>P({id:s.id,sessionId:s.sessionId,result:i})).catch(i=>P({id:s.id,sessionId:s.sessionId,error:{code:0,message:i.message}}))}}),w.on("error",c=>{console.error("error on cdp pipe:",c)}),w.on("close",()=>{p=!0,--d==0&&m.detach()})});return await new Promise(w=>h.listen(0,w)),C.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(Z[53],x([0,1,247,143,94]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function M(C,m){const d={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,p)=>{console.warn((0,t.localize)(1,null,w,p))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,p)=>{console.warn((0,t.localize)(3,null,w,p))}},h=(0,R.parseArgs)(C,R.OPTIONS,m?d:void 0);return h.goto&&h._.forEach(w=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),h["max-memory"]&&S(parseInt(h["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),h}function b(C){const m=C.findIndex(d=>!/^-/.test(d));if(m>-1)return[...C.slice(0,m),...C.slice(m+1)]}function f(C){let[,...m]=C;process.env.VSCODE_DEV&&(m=b(m)||[]);const d=!k(process.env);return M(m,d)}e.parseMainProcessArgv=f;function y(C){const[,,...m]=C;return M(m,!0)}e.parseCLIProcessArgv=y;function I(C,...m){const d=C.indexOf("--");return d===-1?C.push(...m):C.splice(d,0,...m),C}e.addArg=I;function k(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),function(){"use strict";function j(e,S,t,R){function L(b){const f=M(b),y=[f];return e.isAbsolute(f)||y.unshift(R),e.resolve(...y)}function M(b){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,t);const I=b["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(k,"AppData","Roaming")}break;case"darwin":y=e.join(S.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,t)}return{getUserDataPath:L}}if(typeof define=="function")define(Z[168],x([0,248,27,10,16,35]),function(e,S,t,R,L,M){const b=L.dirname(R.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(L.joinPath(b,"package.json").fsPath);return j(S,t,f.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),t=require("os");module.exports=j(S,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[169],x([0,1,27,166,168]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends t.AbstractNativeEnvironmentService{constructor(b,f){super(b,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,R.getUserDataPath)(b)},f)}}e.NativeEnvironmentService=L}),define(Z[170],x([0,1,29,27,28]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function L(M){const b=(0,R.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(b,""),M&&console.log(`Marker file for --wait created: ${b}`),b}catch(f){M&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=L}),define(Z[171],x([0,1,18,31]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,M,b){let f=b&&b.get("storage.serviceMachineId",0)||null;if(f)return f;try{const I=(await M.readFile(L.serviceMachineIdResource)).value.toString();f=(0,t.isUUID)(I)?I:null}catch{f=null}if(!f){f=(0,t.generateUuid)();try{await M.writeFile(L.serviceMachineIdResource,S.VSBuffer.fromString(f))}catch{}}return b&&b.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=R}),define(Z[77],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(R,L=[],M=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=S}),define(Z[172],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=S;class t{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let M of this._nodes.values())M.outgoing.size===0&&L.push(M);return L}insertEdge(L,M){const b=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(M);b.outgoing.set(this._hashFn(M),f),f.incoming.set(this._hashFn(L),b)}removeNode(L){const M=this._hashFn(L);this._nodes.delete(M);for(let b of this._nodes.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(L){const M=this._hashFn(L);let b=this._nodes.get(M);return b||(b=new S(L),this._nodes.set(M,b)),b}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[M,b]of this._nodes)L.push(`${M}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,M]of this._nodes){const b=new Set([L]),f=this._findCycle(M,b);if(f)return f}}_findCycle(L,M){for(let[b,f]of L.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const y=this._findCycle(f,M);if(y)return y;M.delete(b)}}}e.Graph=t}),define(Z[5],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(f){return f[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(S=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function t(M,b,f){b[S.DI_TARGET]===b?b[S.DI_DEPENDENCIES].push({id:M,index:f}):(b[S.DI_DEPENDENCIES]=[{id:M,index:f}],b[S.DI_TARGET]=b)}function R(M){if(S.serviceIds.has(M))return S.serviceIds.get(M);const b=function(f,y,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(b,f,I)};return b.toString=()=>M,S.serviceIds.set(M,b),b}e.createDecorator=R;function L(M){return M}e.refineServiceDecorator=L}),define(Z[54],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(Z[17],x([0,1,11,7,5]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationOverrides=L;function M(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||S.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var b;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function y(p,P){const v=Object.create(null);for(let u in p)I(v,u,p[u],P);return v}e.toValuesTree=y;function I(p,P,v,u){const c=P.split("."),n=c.pop();let s=p;for(let i=0;i<c.length;i++){let o=c[i],a=s[o];switch(typeof a){case"undefined":a=s[o]=Object.create(null);break;case"object":break;default:u(`Ignoring ${P} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(a)}`);return}s=a}if(typeof s=="object"&&s!==null)try{s[n]=v}catch{u(`Ignoring ${P} as ${c.join(".")} is ${JSON.stringify(s)}`)}else u(`Ignoring ${P} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=I;function k(p,P){const v=P.split(".");C(p,v)}e.removeFromValueTree=k;function C(p,P){const v=P.shift();if(P.length===0){delete p[v];return}if(Object.keys(p).indexOf(v)!==-1){const u=p[v];typeof u=="object"&&!Array.isArray(u)&&(C(u,P),Object.keys(u).length===0&&delete p[v])}}function m(p,P,v){function u(s,i){let o=s;for(const a of i){if(typeof o!="object"||o===null)return;o=o[a]}return o}const c=P.split("."),n=u(p,c);return typeof n=="undefined"?v:n}e.getConfigurationValue=m;function d(p,P,v){Object.keys(P).forEach(u=>{u!=="__proto__"&&(u in p?S.isObject(p[u])&&S.isObject(P[u])?d(p[u],P[u],v):v&&(p[u]=P[u]):p[u]=P[u])})}e.merge=d;function h(p,P,v){const u=p.inspect(P),c=p.inspect(v);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=h;function w(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(Z[64],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(L,M){return this.secretVault[L]?.[M]??null}async setPassword(L,M,b){this.secretVault[L]=this.secretVault[L]??{},this.secretVault[L][M]=b}async deletePassword(L,M){return this.secretVault[L]?.[M]?(delete this.secretVault[L][M],Object.keys(this.secretVault[L]).length===0&&delete this.secretVault[L],!0):!1}async findPassword(L){return JSON.stringify(this.secretVault[L])??null}async findCredentials(L){const M=[];for(const b of Object.keys(this.secretVault[L]||{}))M.push({account:b,password:this.secretVault[L][b]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(Z[78],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=t;class R{async getPerformanceInfo(M,b){return{}}async getSystemInfo(M,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,b){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=R}),define(Z[95],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(Z[55],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[173],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(Z[174],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[96],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(Z[175],x([0,1,39,10,9,4,71,21,76,144,96]),function(j,e,S,t,R,L,M,b,f,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=y.localize(0,null);class C{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends C{openTerminal(u,c){return this.spawnTerminal(S,u,f.getWindowsShell(),c)}spawnTerminal(u,c,n,s){const i=c.windowsExec||m.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=R.basename(i).toLowerCase();if(o==="cmder"||o==="cmder.exe")return u.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),(o==="wt"||o==="wt.exe")&&a.push("-d ."),new Promise((r,l)=>{const g=w(process),E=u.spawn(n,a,{cwd:s,env:g});E.on("error",l),E.on("exit",()=>r())})}runInTerminal(u,c,n,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,r)=>{const l=`"${c} - ${k}"`,g=`""${n.join('" "')}" & pause"`,E=["/c","start",l,"/wait",o,"/c",g],D=Object.assign({},w(process),s);Object.keys(D).filter(V=>D[V]===null).forEach(V=>delete D[V]);const W={cwd:c,env:D,windowsVerbatimArguments:!0};S.spawn(m.CMD,E,W).on("error",V=>{r(p(V))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class d extends C{openTerminal(u,c){return this.spawnTerminal(S,u,c)}runInTerminal(u,c,n,s,i){const o=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((a,r)=>{if(o===I.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const l=o===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,j).fsPath,"-t",u||k,"-w",c];for(let O of n)E.push("-a"),E.push(O);if(s){const O=Object.assign({},w(process),s);for(let V in O){const J=O[V];J===null?(E.push("-u"),E.push(V)):(E.push("-e"),E.push(`${V}=${J}`))}}let D="";const W=S.spawn(d.OSASCRIPT,E);W.on("error",O=>{r(p(O))}),W.stderr.on("data",O=>{D+=O.toString()}),W.on("exit",O=>{if(O===0)a(void 0);else if(D){const V=D.split(`
`,1);r(new Error(V[0]))}else r(new Error(y.localize(1,null,l,O)))})}else r(new Error(y.localize(2,null,o)))})}spawnTerminal(u,c,n){const s=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const a=["-a",s];n&&a.push(n);const r=w(process),l=u.spawn("/usr/bin/open",a,{cwd:n,env:r});l.on("error",o),l.on("exit",()=>i())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class h extends C{openTerminal(u,c){return this.spawnTerminal(S,u,c)}runInTerminal(u,c,n,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((a,r)=>{let l=[];o.then(g=>{g.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const E=`${P(n)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;l.push(`''${E}''`);const D=Object.assign({},w(process),s);Object.keys(D).filter(J=>D[J]===null).forEach(J=>delete D[J]);const W={cwd:c,env:D};let O="";const V=S.spawn(g,l,W);V.on("error",J=>{r(p(J))}),V.stderr.on("data",J=>{O+=J.toString()}),V.on("exit",J=>{if(J===0)a(void 0);else if(O){const ne=O.split(`
`,1);r(new Error(ne[0]))}else r(new Error(y.localize(4,null,g,J)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!L.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await b.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,n){const s=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(a=>{const r=w(process),l=u.spawn(a,[],{cwd:n,env:r});l.on("error",o),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=y.localize(3,null);function w(v){const u={...v.env};return(0,M.sanitizeProcessEnvironment)(u),u}function p(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(y.localize(5,null,v.path)):v}function P(v){let u="";for(let c of v)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(Z[19],x([0,1,15,36,9,30,11,7,146,5]),function(j,e,S,t,R,L,M,b,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I($){return $.create===!0}e.isFileOpenForWriteOptions=I;var k;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(k=e.FileType||(e.FileType={}));var C;(function($){$[$.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var m;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d($){return!!($.capabilities&2)}e.hasReadWriteCapability=d;function h($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=h;function w($){return!!($.capabilities&32768)}e.hasFileCloneCapability=w;function p($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function P($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=P;function v($){return d($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var u;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(U,N){super(U);this.code=N}}e.FileSystemProviderError=c;function n($,U){const N=new c($.toString(),U);return i(N,U),N}e.createFileSystemProviderError=n;function s($){return $||n((0,f.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=s;function i($,U){return $.name=U?`${U} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function o($){if(!$)return u.Unknown;if($ instanceof c)return $.code;const U=/^(.+) \(FileSystemError\)$/.exec($.name);if(!U)return u.Unknown;switch(U[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=o;function a($){if($ instanceof W)return $.fileOperationResult;switch(o($)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class l{constructor(U,N,q){this.resource=U,this.operation=N,this.target=q}isOperation(U){return this.operation===U}}e.FileOperationEvent=l;var g;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(g=e.FileChangeType||(e.FileChangeType={}));class E{constructor(U,N){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const q=new Map;for(const ee of U){const Q=q.get(ee.type);switch(Q?Q.push([ee.resource,ee]):q.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,Q]of q)switch(ee){case 1:this.added=t.TernarySearchTree.forUris(()=>N),this.added.fill(Q);break;case 0:this.updated=t.TernarySearchTree.forUris(()=>N),this.updated.fill(Q);break;case 2:this.deleted=t.TernarySearchTree.forUris(()=>N),this.deleted.fill(Q);break}}contains(U,...N){return this.doContains(U,{includeChildren:!1},...N)}affects(U,...N){return this.doContains(U,{includeChildren:!0},...N)}doContains(U,N,...q){if(!U)return!1;const ee=q.length>0;return!!((!ee||q.includes(1))&&(this.added?.get(U)||N.includeChildren&&this.added?.findSuperstr(U))||(!ee||q.includes(0))&&(this.updated?.get(U)||N.includeChildren&&this.updated?.findSuperstr(U))||(!ee||q.includes(2))&&(this.deleted?.findSubstr(U)||N.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=E;function D($,U,N){return!$||!U||$===U||U.length>$.length?!1:(U.charAt(U.length-1)!==R.sep&&(U+=R.sep),N?(0,L.startsWithIgnoreCase)($,U):$.indexOf(U)===0)}e.isParent=D;class W extends S.ErrorNoTelemetry{constructor(U,N,q){super(U);this.fileOperationResult=N,this.options=q}}e.FileOperationError=W;class O extends W{constructor(U,N,q){super(U,2,q);this.stat=N}}e.NotModifiedSinceFileOperationError=O;var V;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ne($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=ne;async function Y($,U){if(!U.hasProvider(b.URI.from({scheme:$.scheme})))return new Promise(N=>{const q=U.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===$.scheme&&ee.added&&(q.dispose(),N())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(U){return(0,M.isNumber)(U)||(U=0),U<re.KB?(0,f.localize)(1,null,U.toFixed(0)):U<re.MB?(0,f.localize)(2,null,(U/re.KB).toFixed(2)):U<re.GB?(0,f.localize)(3,null,(U/re.MB).toFixed(2)):U<re.TB?(0,f.localize)(4,null,(U/re.GB).toFixed(2)):(0,f.localize)(5,null,(U/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var ae;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(ae=e.Arch||(e.Arch={}));function H($){return{maxFileSize:$===0?300*re.MB:16*re.GB,maxHeapSize:$===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=H}),define(Z[176],x([0,1,18,41,15,3,2,52,7,31,19]),function(j,e,S,t,R,L,M,b,f,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class k extends M.Disposable{constructor(m,d){super();this.channel=m,this.extraCapabilities=d,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,y.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,d){const{buffer:h}=await this.channel.call("readFile",[m,d]);return h}readFileStream(m,d,h){const w=(0,b.newWriteableStream)(P=>S.VSBuffer.concat(P.map(v=>S.VSBuffer.wrap(v))).buffer),p=this.channel.listen("readFileStream",[m,d])(P=>{if(P instanceof S.VSBuffer)w.write(P.buffer);else{if(P==="end")w.end();else{let v=P;v instanceof Error||(v=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(v),I.FileSystemProviderErrorCode.Unknown)),w.error(v),w.end()}p.dispose()}});return h.onCancellationRequested(()=>{w.error((0,R.canceled)()),w.end(),p.dispose()}),w}writeFile(m,d,h){return this.channel.call("writeFile",[m,S.VSBuffer.wrap(d),h])}open(m,d){return this.channel.call("open",[m,d])}close(m){return this.channel.call("close",[m])}async read(m,d,h,w,p){const[P,v]=await this.channel.call("read",[m,d,p]);return h.set(P.buffer.slice(0,v),w),v}write(m,d,h,w,p){return this.channel.call("write",[m,d,S.VSBuffer.wrap(h),w,p])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,d){return this.channel.call("delete",[m,d])}rename(m,d,h){return this.channel.call("rename",[m,d,h])}copy(m,d,h){return this.channel.call("copy",[m,d,h])}cloneFile(m,d){return this.channel.call("cloneFile",[m,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const d=m;this._onDidChange.fire(d.map(h=>({resource:f.URI.revive(h.resource),type:h.type})))}else{const d=m;this._onDidWatchError.fire(d)}}))}watch(m,d){const h=(0,y.generateUuid)();return this.channel.call("watch",[this.sessionId,h,m,d]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=k}),define(Z[97],x([0,1,18,15,147,19]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(I,k,C,m,d,h){let w;try{await b(I,k,C,m,d,h)}catch(p){w=p}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w!="undefined"&&C.error(w),C.end()}}e.readFileIntoStream=M;async function b(I,k,C,m,d,h){f(h);const w=await I.open(k,{create:!1});try{f(h);let p=0,P=0,v=d&&typeof d.length=="number"?d.length:void 0,u=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof v=="number"?v:d.bufferSize)),c=d&&typeof d.position=="number"?d.position:0,n=0;do P=await I.read(w,c,u.buffer,n,u.byteLength-n),c+=P,n+=P,p+=P,typeof v=="number"&&(v-=P),n===u.byteLength&&(await C.write(m(u)),u=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof v=="number"?v:d.bufferSize)),n=0);while(P>0&&(typeof v!="number"||v>0)&&f(h)&&y(p,d));if(n>0){let s=n;typeof v=="number"&&(s=Math.min(n,v)),C.write(m(u.slice(0,s)))}}catch(p){throw(0,L.ensureFileSystemProviderError)(p)}finally{await I.close(w)}}function f(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function y(I,k){if(k?.limits){if(typeof k.limits.memory=="number"&&I>k.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&I>k.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[65],x([0,1,87,2,9,4,7,19]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function f(w){return w.recursive===!0}e.isRecursiveWatchRequest=f;class y extends t.Disposable{constructor(p,P,v,u){super();this.onFileChanges=p,this.onLogMessage=P,this.verboseLogging=v,this.options=u,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new t.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(P=>this.onFileChanges(P))),p.add(this.watcher.onDidLogMessage(P=>this.onLogMessage(P))),p.add(this.watcher.onDidError(P=>this.onError(P)))}onError(p){this.options.restartOnError?this.restartCounter<y.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=y,y.MAX_RESTARTS=5;class I extends y{constructor(p,P,v){super(p,P,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class k extends y{constructor(p,P,v){super(p,P,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=k;function C(w){return w.map(p=>({type:p.type,resource:M.URI.file(p.path)}))}e.toFileChanges=C;function m(w){const p=new h;for(const P of w)p.processEvent(P);return p.coalesce()}e.coalesceEvents=m;function d(w,p){const P=[];for(const v of p){let u=v;typeof u=="string"&&!u.startsWith(S.GLOBSTAR)&&!(0,R.isAbsolute)(u)&&(u={base:w,pattern:u}),P.push((0,S.parse)(u))}return P}e.parseWatcherPatterns=d;class h{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return L.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const P=this.mapPathToChange.get(this.toKey(p));let v=!1;if(P){const u=P.type,c=p.type;P.path!==p.path&&(p.type===2||p.type===1)?v=!0:u===1&&c===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(P)):u===2&&c===1?P.type=0:u===1&&c===0||(P.type=c)}else v=!0;v&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],P=[];return Array.from(this.coalesced).filter(v=>v.type!==2?(p.push(v),!1):!0).sort((v,u)=>v.path.length-u.path.length).filter(v=>P.some(u=>(0,b.isParent)(v.path,u,!L.isLinux))?!1:(P.push(v.path),!0)).concat(p)}}}),define(Z[177],x([0,1,29,8,23,28,2,74,9,4,88,21,65]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends M.Disposable{constructor(w,p,P,v){super();this.request=w,this.onDidFilesChange=p,this.onLogMessage=P,this.verboseLogging=v,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(m.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,C.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,C.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await k.Promises.stat(w);this._register(await this.doWatch(w,p.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let p=w.path;try{p=await k.Promises.realpath(w.path),w.path===p&&(p=await(0,I.realcase)(w.path)??w.path),w.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${p})`)}catch{}return p}async doWatch(w,p){if(y.isMacintosh&&(0,L.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const P=new R.CancellationTokenSource(this.cts.token);let v=new M.DisposableStore;try{const u=(0,f.basename)(w),c=(0,S.watch)(w);v.add((0,M.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${w}'`);const n=new Set;if(p)try{for(const i of await k.Promises.readdir(w))n.add(i)}catch(i){this.error(i)}const s=new Map;v.add((0,M.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),c.on("error",(i,o)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),c.on("change",(i,o)=>{if(P.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${o}`);let a="";if(o&&(a=o.toString(),y.isMacintosh&&(a=(0,b.normalizeNFC)(a))),!(!a||i!=="change"&&i!=="rename"))if(p)if(i==="rename"){s.get(a)?.dispose();const r=setTimeout(async()=>{if(s.delete(a),a===u&&!await k.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,f.join)(w,a));if(P.token.isCancellationRequested)return;let g;l?n.has(a)?g=0:(g=1,n.add(a)):(n.delete(a),g=2),this.onFileChange({path:(0,f.join)(this.request.path,a),type:g})},m.FILE_DELETE_HANDLER_DELAY);s.set(a,(0,M.toDisposable)(()=>clearTimeout(r)))}else{let r;n.has(a)?r=0:(r=1,n.add(a)),this.onFileChange({path:(0,f.join)(this.request.path,a),type:r})}else if(i==="rename"||a!==u){const r=setTimeout(async()=>{const l=await k.Promises.exists(w);P.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),v.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},m.FILE_DELETE_HANDLER_DELAY);v.clear(),v.add((0,M.toDisposable)(()=>clearTimeout(r)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await k.Promises.exists(w)&&!P.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${u.toString()})`)}return(0,M.toDisposable)(()=>{P.dispose(!0),v.dispose()})}async onFileChange(w,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!p&&this.excludes.some(P=>P(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(P=>P(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const v=(0,C.coalesceEvents)(P);if(v.length>0){if(this.verboseLogging)for(const c of v)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(v)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${v[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${v.length}, most recent change: ${v[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(y.isLinux)return k.Promises.exists(w);try{const p=(0,f.basename)(w);return(await k.Promises.readdir((0,f.dirname)(w))).some(v=>v===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.FILE_DELETE_HANDLER_DELAY=100,m.FILE_CHANGES_HANDLER_DELAY=50;async function d(h,w,p,P,v=512){const u=await k.Promises.open(h,"r"),c=Buffer.allocUnsafe(v),n=new R.CancellationTokenSource(P);let s,i=!1;const o={path:h,excludes:[],recursive:!1},a=new m(o,r=>{(async()=>{for(const{type:l}of r)if(l===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await k.Promises.read(u,c,0,v,null);if(!g||n.token.isCancellationRequested)break;w(c.slice(0,g))}}catch(g){s=new Error(g),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,p(),new Promise((r,l)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await k.Promises.close(u)}catch(g){s=new Error(g)}s?l(s):r()})})}e.watchFileContents=d}),define(Z[178],x([0,1,3,87,2,4,177]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends R.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new S.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=S.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(y){const I=this.normalizeRequests(y),k=I.filter(m=>{const d=this.watchers.get(m.path);return d?!(0,t.patternsEquals)(d.request.excludes,m.excludes)||!(0,t.patternsEquals)(d.request.includes,m.includes):!0}),C=Array.from(this.watchers.values()).filter(({request:m})=>!I.find(d=>d.path===m.path&&(0,t.patternsEquals)(d.excludes,m.excludes)&&(0,t.patternsEquals)(d.includes,m.includes))).map(({request:m})=>m.path);k.length&&this.trace(`Request to start watching: ${k.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?m.includes:"<all>"})`).join(",")}`),C.length&&this.trace(`Request to stop watching: ${C.join(",")}`);for(const m of C)this.stopWatching(m);for(const m of k)this.startWatching(m)}startWatching(y){const I=new M.NodeJSFileWatcherLibrary(y,C=>this._onDidChangeFile.fire(C),C=>this._onDidLogMessage.fire(C),this.verboseLogging),k={request:y,instance:I};this.watchers.set(y.path,k)}async stop(){for(const[y]of this.watchers)this.stopWatching(y);this.watchers.clear()}stopWatching(y){const I=this.watchers.get(y);I&&(this.watchers.delete(y),I.instance.dispose())}normalizeRequests(y){const I=new Map;for(const k of y){const C=L.isLinux?k.path:k.path.toLowerCase();I.set(C,k)}return Array.from(I.values())}async setVerboseLogging(y){this.verboseLogging=y;for(const[,I]of this.watchers)I.instance.setVerboseLogging(y)}trace(y){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(y)})}toMessage(y,I){return I?`[File Watcher (node.js)] ${y} (path: ${I.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=b}),define(Z[179],x([0,1,65,178]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends S.AbstractNonRecursiveWatcherClient{constructor(M,b,f){super(M,b,f);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(Z[180],x([0,1,10,40,138,65]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends L.AbstractUniversalWatcherClient{constructor(f,y,I){super(f,y,I);this.init()}createWatcher(f){const y=f.add(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(y.onDidProcessExit(({code:I,signal:k})=>this.onError(`terminated by itself with code ${I}, signal: ${k}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(Z[79],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...R){this._entries=new Map;for(let[L,M]of R)this.set(L,M)}set(R,L){const M=this._entries.get(R);return this._entries.set(R,L),M}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=S}),define(Z[181],x([0,1,8,15,77,172,5,79]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const f=!1;class y extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class I{constructor(d=new b.ServiceCollection,h=!1,w){this._activeInstantiations=new Set,this._services=d,this._strict=h,this._parent=w,this._services.set(M.IInstantiationService,this)}createChild(d){return new I(d,this._strict,this)}invokeFunction(d,...h){let w=C.traceInvocation(d),p=!1;try{return d({get:v=>{if(p)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(v,w);if(!u)throw new Error(`[invokeFunction] unknown service '${v}'`);return u}},...h)}finally{p=!0,w.stop()}}createInstance(d,...h){let w,p;return d instanceof R.SyncDescriptor?(w=C.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(h),w)):(w=C.traceCreation(d),p=this._createInstance(d,h,w)),w.stop(),p}_createInstance(d,h=[],w){let p=M._util.getServiceDependencies(d).sort((u,c)=>u.index-c.index),P=[];for(const u of p){let c=this._getOrCreateServiceInstance(u.id,w);c||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${u.id}.`,!1),P.push(c)}let v=p.length>0?p[0].index:h.length;if(h.length!==v){console.trace(`[createInstance] First service dependency of ${d.name} at position ${v+1} conflicts with ${h.length} static arguments`);let u=v-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,v)}return new d(...[...h,...P])}_setServiceInstance(d,h){if(this._services.get(d)instanceof R.SyncDescriptor)this._services.set(d,h);else if(this._parent)this._parent._setServiceInstance(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let h=this._services.get(d);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):h}_getOrCreateServiceInstance(d,h){let w=this._getServiceInstanceOrDescriptor(d);return w instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,w,h.branch(d,!0)):(h.branch(d,!1),w)}_safeCreateAndCacheServiceInstance(d,h,w){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,h,w)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,h,w){const p=new L.Graph(u=>u.id.toString());let P=0;const v=[{id:d,desc:h,_trace:w}];for(;v.length;){const u=v.pop();if(p.lookupOrInsertNode(u),P++>1e3)throw new y(p);for(let c of M._util.getServiceDependencies(u.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),n instanceof R.SyncDescriptor){const s={id:c.id,desc:n,_trace:u._trace.branch(c.id,!0)};p.insertEdge(u,s),v.push(s)}}}for(;;){const u=p.roots();if(u.length===0){if(!p.isEmpty())throw new y(p);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}p.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,h,w=[],p,P){if(this._services.get(d)instanceof R.SyncDescriptor)return this._createServiceInstance(h,w,p,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,h,w,p,P);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(d,h=[],w,p){if(w){const P=new S.IdleValue(()=>this._createInstance(d,h,p));return new Proxy(Object.create(null),{get(v,u){if(u in v)return v[u];let c=P.value,n=c[u];return typeof n!="function"||(n=n.bind(c),v[u]=n),n},set(v,u,c){return P.value[u]=c,!0}})}else return this._createInstance(d,h,p)}_throwIfStrict(d,h){if(h&&console.warn(h),this._strict)throw new Error(d)}}e.InstantiationService=I;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class C{constructor(d,h){this.type=d,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new C(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):C._None}static traceCreation(d){return f?new C(0,d.name):C._None}branch(d,h){let w=new C(2,d.toString());return this._dep.push([d,h,w]),w}stop(){let d=Date.now()-this._start;C._totals+=d;let h=!1;function w(P,v){let u=[],c=new Array(P+1).join("	");for(const[n,s,i]of v._dep)if(s&&i){h=!0,u.push(`${c}CREATES -> ${n}`);let o=w(P+1,i);o&&u.push(o)}else u.push(`${c}uses -> ${n}`);return u.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${C._totals.toFixed(2)}ms)`];(d>2||h)&&console.log(p.join(`
`))}}e.Trace=C,C._None=new class extends C{constructor(){super(-1,null)}stop(){}branch(){return this}},C._totals=0}),define(Z[6],x([0,1,41,3,2,4,5]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function b(){return new Date().toISOString()}var f;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function y(s,i,o){switch(i){case f.Trace:s.trace(o);break;case f.Debug:s.debug(o);break;case f.Info:s.info(o);break;case f.Warning:s.warn(o);break;case f.Error:s.error(o);break;case f.Critical:s.critical(o);break;default:throw new Error("Invalid log level")}}e.log=y;function I(s){let i="";for(let o=0;o<s.length;o++){let a=s[o];if(typeof a=="object")try{a=JSON.stringify(a)}catch{}i+=(o>0?" ":"")+a}return i}e.format=I;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class C extends k{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...o){this.checkLogLevel(f.Trace)&&this.log(f.Trace,I([i,...o]))}debug(i,...o){this.checkLogLevel(f.Debug)&&this.log(f.Debug,I([i,...o]))}info(i,...o){this.checkLogLevel(f.Info)&&this.log(f.Info,I([i,...o]))}warn(i,...o){this.checkLogLevel(f.Warning)&&this.log(f.Warning,I([i,...o]))}error(i,...o){if(this.checkLogLevel(f.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(f.Error,I(a))}else this.log(f.Error,I([i,...o]))}critical(i,...o){this.checkLogLevel(f.Critical)&&this.log(f.Critical,I([i,...o]))}flush(){}}e.AbstractMessageLogger=C;class m extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...o){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...o):console.log(`[main ${b()}]`,i,...o))}debug(i,...o){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...o):console.log(`[main ${b()}]`,i,...o))}info(i,...o){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...o):console.log(`[main ${b()}]`,i,...o))}warn(i,...o){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,i,...o):console.warn(`[main ${b()}]`,i,...o))}error(i,...o){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,i,...o):console.error(`[main ${b()}]`,i,...o))}critical(i,...o){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,i,...o):console.error(`[main ${b()}]`,i,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class d extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...o){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...o)}debug(i,...o){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...o)}info(i,...o){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...o)}warn(i,...o){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...o)}error(i,...o){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...o)}critical(i,...o){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...o)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends k{constructor(i,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(o)}trace(i,...o){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...o])}debug(i,...o){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...o])}info(i,...o){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...o])}warn(i,...o){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...o])}error(i,...o){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...o])}critical(i,...o){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...o])}extractMessage(i){return typeof i=="string"?i:(0,S.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class w extends k{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const o of this.logServices)o.setLevel(i);super.setLevel(i)}trace(i,...o){for(const a of this.logServices)a.trace(i,...o)}debug(i,...o){for(const a of this.logServices)a.debug(i,...o)}info(i,...o){for(const a of this.logServices)a.info(i,...o)}warn(i,...o){for(const a of this.logServices)a.warn(i,...o)}error(i,...o){for(const a of this.logServices)a.error(i,...o)}critical(i,...o){for(const a of this.logServices)a.critical(i,...o)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=w;class p extends R.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...o){this.logger.trace(i,...o)}debug(i,...o){this.logger.debug(i,...o)}info(i,...o){this.logger.info(i,...o)}warn(i,...o){this.logger.warn(i,...o)}error(i,...o){this.logger.error(i,...o)}critical(i,...o){this.logger.critical(i,...o)}flush(){this.logger.flush()}}e.LogService=p;class P extends R.Disposable{constructor(i,o){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,o){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,o?.always?f.Trace:this.logLevel,o),this.loggers.set(i.toString(),a),o?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class v{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...o){}debug(i,...o){}info(i,...o){}warn(i,...o){}error(i,...o){}critical(i,...o){}dispose(){}flush(){}}e.NullLogService=v;function u(s){if(s.verbose)return f.Trace;if(typeof s.logLevel=="string"){const i=c(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(s){switch(s){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=c;function n(s){switch(s){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=n});var te=this&&this.__param||function(j,e){return function(S,t){e(S,t,j)}};define(Z[182],x([0,1,64,3,2,6,4]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let b=class vt extends R.Disposable{constructor(y){super();this.logService=y,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(y,I){let k;try{k=await this.withKeytar()}catch{return null}const C=await k.getPassword(y,I);if(C)try{let{content:m,hasNextChunk:d}=JSON.parse(C);if(!m||!d)return C;let h=1;for(;d;){const w=await k.getPassword(y,`${I}-${h}`),p=JSON.parse(w);m+=p.content,d=p.hasNextChunk,h++}return m}catch{return C}return C}async setPassword(y,I,k){let C;try{C=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}const m=3,d=async(h,w,p)=>{let P=0,v;for(;P<m;)try{await C.setPassword(h,w,p);return}catch(u){v=u,this.logService.warn("Error attempting to set a password: ",u?.message??u),P++,await new Promise(c=>setTimeout(c,200))}throw v};if(M.isWindows&&k.length>vt.MAX_PASSWORD_LENGTH){let h=0,w=0,p=!0;for(;p;){const P=k.substring(h,h+vt.PASSWORD_CHUNK_SIZE);h+=vt.PASSWORD_CHUNK_SIZE,p=k.length-h>0;const v={content:P,hasNextChunk:p};await d(y,w?`${I}-${w}`:I,JSON.stringify(v)),w++}}else await d(y,I,k);this._onDidChangePassword.fire({service:y,account:I})}async deletePassword(y,I){let k;try{k=await this.withKeytar()}catch(d){throw this.surfaceKeytarLoadError?.(d),d}const C=await k.getPassword(y,I);if(!C)return!1;const m=await k.deletePassword(y,I);try{let{content:d,hasNextChunk:h}=JSON.parse(C);if(d&&h){let w=1;for(;h;){const p=`${I}-${w}`,P=await k.getPassword(y,p);await k.deletePassword(y,p),h=JSON.parse(P).hasNextChunk,w++}}}catch{}return m&&this._onDidChangePassword.fire({service:y,account:I}),m}async findPassword(y){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(y)}async findCredentials(y){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(y)}clear(){return this._keytarCache instanceof S.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=he([te(0,L.ILogService)],b),e.BaseCredentialsMainService=b}),define(Z[183],x([0,1,25,8,15,3,2,9,65,6]),function(j,e,S,t,R,L,M,b,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends M.Disposable{constructor(C,m){super();this.logService=C,this.options=m,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(C,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(C,m):this.watchNonRecursive(C,m)}watchUniversal(C,m){const d={path:this.toFilePath(C),excludes:m.excludes,includes:m.includes,recursive:m.recursive},h=(0,S.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(C=>(0,R.onUnexpectedError)(C))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,f.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)})));const C=this.options?.watcher?.recursive?.usePolling;if(C===!0)for(const m of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const m of this.universalPathsToWatch)(0,f.isRecursiveWatchRequest)(m)&&C.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(C,m){const d={path:this.toFilePath(C),excludes:m.excludes,includes:m.includes,recursive:!1},h=(0,S.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(C=>(0,R.onUnexpectedError)(C))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(C=>this._onDidChangeFile.fire((0,f.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===y.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(C){C.type==="error"&&this._onDidWatchError.fire(C.message),this.logService[C.type](C.message)}toFilePath(C){return(0,b.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Z[184],x([0,1,25,8,18,23,3,73,51,2,36,10,66,16,52,145,19,97,6]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends y.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`);const s=new y.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),s.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,y.dispose)(s)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(s){n.push(s)}}),!this.provider.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const s=this.provider.get(c.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return f.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,m.isAbsolutePath)(c))throw new w.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,h.localize)(1,null,c.toString()),s}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(s){throw(0,w.toFileSystemProviderErrorCode)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,w.ensureFileSystemProviderError)(s)}}async doResolveFile(c,n){const s=await this.withProvider(c),i=this.isPathCaseSensitive(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,r=n?.resolveMetadata,l=await s.stat(c);let g;return this.toFileStat(s,c,l,void 0,!!r,(E,D)=>(g||(g=I.TernarySearchTree.forUris(()=>!i),g.set(c,!0),o&&g.fill(!0,o)),g.get(E.resource)||g.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&a?D===1:!1))}async toFileStat(c,n,s,i,o,a){const{providerExtUri:r}=this.getExtUri(c),l={resource:n,name:r.basename(n),isFile:(s.type&w.FileType.File)!=0,isDirectory:(s.type&w.FileType.Directory)!=0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&w.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,w.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(l.isDirectory&&a(l,i)){try{const g=await c.readdir(n),E=await t.Promises.settled(g.map(async([D,W])=>{try{const O=r.joinPath(n,D),V=o?await c.stat(O):{type:W};return await this.toFileStat(c,O,V,g.length,o,a)}catch(O){return this.logService.trace(O),null}}));l.children=(0,S.coalesce)(E)}catch(g){this.logService.trace(g),l.children=[]}return l}return l}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),s=await n.stat(c);return this.toFileStat(n,c,s,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(s){return s}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new w.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=R.VSBuffer.fromString(""),s){await this.doValidateCreateFile(c,s);const i=await this.writeFile(c,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,i)),i}async writeFile(c,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:o}=this.getExtUri(i);try{await this.validateWriteFile(i,c,s)||await this.mkdirp(i,o.dirname(c));let r;if((0,w.hasReadWriteCapability)(i)&&!(n instanceof R.VSBuffer))if((0,d.isReadableStream)(n)){const l=await(0,d.peekStream)(n,3);l.ended?r=R.VSBuffer.concat(l.buffer):r=l}else r=(0,d.peekReadable)(n,l=>R.VSBuffer.concat(l),3);else r=n;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&r instanceof R.VSBuffer?await this.doWriteUnbuffered(i,c,s,r):await this.doWriteBuffered(i,c,s,r instanceof R.VSBuffer?(0,R.bufferToReadable)(r):r),this._onDidRunOperation.fire(new w.FileOperationEvent(c,4))}catch(a){throw new w.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),s)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,s){if(!!s?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(n)));let o;try{o=await c.stat(n)}catch{return}if((o.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,h.localize)(6,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,o),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&s.mtime<o.mtime&&s.etag!==(0,w.etag)({mtime:s.mtime,size:o.size}))throw new w.FileOperationError((0,h.localize)(7,null),3,s);return o}async readFile(c,n,s){const i=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(i,c,n,s):this.doReadFile(i,c,n,s)}async doReadFileAtomic(c,n,s,i){return new Promise((o,a)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(c,n,s,i);o(r)}catch(r){a(r)}})})}async doReadFile(c,n,s,i){const o=await this.doReadFileStream(c,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,R.streamToBuffer)(o.value)}}async readFileStream(c,n,s){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,n,s)}async doReadFileStream(c,n,s,i){const o=new L.CancellationTokenSource(i),a=this.validateReadFile(n,s).then(l=>l,l=>{throw o.cancel(),l});let r;try{return typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&await a,s?.atomic&&(0,w.hasFileAtomicReadCapability)(c)||!((0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasFileReadStreamCapability)(c))||(0,w.hasReadWriteCapability)(c)&&s?.preferUnbuffered?r=this.readFileUnbuffered(c,n,s):(0,w.hasFileReadStreamCapability)(c)?r=this.readFileStreamed(c,n,o.token,s):r=this.readFileBuffered(c,n,o.token,s),{...await a,value:r}}catch(l){r&&await(0,d.consumeStream)(r);const g=(0,h.localize)(8,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(l).toString());throw l instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(g,l.stat,s):new w.FileOperationError(g,(0,w.toFileOperationResult)(l),s)}}readFileStreamed(c,n,s,i=Object.create(null)){const o=c.readFileStream(n,i,s);return(0,d.transform)(o,{data:a=>a instanceof R.VSBuffer?a:R.VSBuffer.wrap(a),error:a=>new w.FileOperationError((0,h.localize)(9,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),i)},a=>R.VSBuffer.concat(a))}readFileBuffered(c,n,s,i=Object.create(null)){const o=(0,R.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,n,o,a=>a,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new w.FileOperationError((0,h.localize)(10,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),i)},s),o}readFileUnbuffered(c,n,s){const i=(0,d.newWriteableStream)(o=>R.VSBuffer.concat(o));return(async()=>{try{let o;s?.atomic&&(0,w.hasFileAtomicReadCapability)(c)?o=await c.readFile(n,{atomic:!0}):o=await c.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.validateReadFileLimits(n,o.byteLength,s),i.end(R.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(c,n){const s=await this.resolve(c,{resolveMetadata:!0});if(s.isDirectory)throw new w.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===s.etag)throw new w.NotModifiedSinceFileOperationError((0,h.localize)(12,null),s,n);return this.validateReadFileLimits(c,s.size,n),s}validateReadFileLimits(c,n,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&n>s.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,n,s){return this.doCanMoveCopy(c,n,"move",s)}async canCopy(c,n,s){return this.doCanMoveCopy(c,n,"copy",s)}async doCanMoveCopy(c,n,s,i){if(c.toString()!==n.toString())try{const o=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,c,a,n,s,i)}catch(o){return o}return!0}async move(c,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(i,c,o,n,"move",!!s),r=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,a==="move"?2:3,r)),r}async copy(c,n,s){const i=await this.withReadProvider(c),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(i,c,o,n,"copy",!!s),r=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,a==="copy"?3:2,r)),r}async doMoveCopy(c,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:r,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,n,s,i,o,a);if(r&&!l&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),o==="copy"){if(c===s&&(0,w.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:a});else{const g=await this.resolve(n);g.isDirectory?await this.doCopyFolder(c,g,s,i):await this.doCopyFile(c,n,s,i)}return o}else return c===s?(await c.rename(n,i,{overwrite:a}),o):(await this.doMoveCopy(c,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,s,i){if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(c,n,s,i);if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(c,n,s,i);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(c,n,s,i);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasReadWriteCapability)(s))return this.doPipeUnbuffered(c,n,s,i)}async doCopyFolder(c,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async o=>{const a=this.getExtUri(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(c,await this.resolve(o.resource),s,a):this.doCopyFile(c,o.resource,s,a)}))}async doValidateMoveCopy(c,n,s,i,o,a){let r=!1;if(c===s){const{providerExtUri:g,isPathCaseSensitive:E}=this.getExtUri(c);if(E||(r=g.isEqual(n,i)),r&&o==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!r&&g.isEqualOrParent(i,n))throw new Error((0,h.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!r){if(!a)throw new w.FileOperationError((0,h.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(c===s){const{providerExtUri:g}=this.getExtUri(c);if(g.isEqualOrParent(n,i))throw new Error((0,h.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:r}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const s=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,s)),s}async mkdirp(c,n){const s=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&w.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(n)));break}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await c.mkdir(n)}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(s){return s}return!0}async doValidateDelete(c,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let o;try{o=await s.stat(c)}catch{}if(o)this.throwIfFileIsReadonly(c,o);else throw new w.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const r=await this.resolve(c);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return s}async del(c,n){const s=await this.doValidateDelete(c,n),i=!!n?.useTrash,o=!!n?.recursive;await s.delete(c,{recursive:o,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(c,1))}async cloneFile(c,n){const s=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(s===i&&this.getExtUri(s).providerExtUri.isEqual(c,n))return;if(s===i&&(0,w.hasFileCloneCapability)(s))return s.cloneFile(c,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const o=this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri);return s===i&&(0,w.hasFileFolderCopyCapability)(s)?o.queue(()=>s.copy(c,n,{overwrite:!0})):o.queue(()=>this.doCopyFile(s,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const s=new y.DisposableStore;let i=!1,o=()=>{i=!0};return s.add((0,y.toDisposable)(()=>o())),(async()=>{try{const a=await this.doWatch(c,n);i?(0,y.dispose)(a):o=()=>(0,y.dispose)(a)}catch(a){this.logService.error(a)}})(),s}async doWatch(c,n){const s=await this.withProvider(c),i=(0,b.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(c),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:s.watch(c,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,y.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,y.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,y.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,s,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const o=await c.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,d.isReadableStream)(i)||(0,d.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,o,i):await this.doWriteReadableBufferedQueued(c,o,i)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await c.close(o)}})}async doWriteStreamBufferedQueued(c,n,s){let i=0,o;if((0,d.isReadableBufferedStream)(s)){if(s.buffer.length>0){const a=R.VSBuffer.concat(s.buffer);await this.doWriteBuffer(c,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,r)=>{(0,d.listenStream)(o,{onData:async l=>{o.pause();try{await this.doWriteBuffer(c,n,l,l.byteLength,i,0)}catch(g){return r(g)}i+=l.byteLength,setTimeout(()=>o.resume())},onError:l=>r(l),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(c,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.doWriteBuffer(c,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(c,n,s,i,o,a){let r=0;for(;r<i;)r+=await c.write(n,o+r,s.buffer,a+r,i-r)}async doWriteUnbuffered(c,n,s,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,s,i))}async doWriteUnbufferedQueued(c,n,s,i){let o;i instanceof R.VSBuffer?o=i:(0,d.isReadableStream)(i)?o=await(0,R.streamToBuffer)(i):(0,d.isReadableBufferedStream)(i)?o=await(0,R.bufferedStreamToBuffer)(i):o=(0,R.readableToBuffer)(i),await c.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(c,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,s,i))}async doPipeBufferedQueued(c,n,s,i){let o,a;try{o=await c.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const r=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,g=0,E=0;do E=await c.read(o,l,r.buffer,g,r.byteLength-g),await this.doWriteBuffer(s,a,r,E,l,g),l+=E,g+=E,g===r.byteLength&&(g=0);while(E>0)}catch(r){throw(0,w.ensureFileSystemProviderError)(r)}finally{await t.Promises.settled([typeof o=="number"?c.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async doPipeUnbuffered(c,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,s,i))}async doPipeUnbufferedQueued(c,n,s,i){return s.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,s,i))}async doPipeUnbufferedToBufferedQueued(c,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await c.readFile(n);await this.doWriteBuffer(s,o,R.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await s.close(o)}}async doPipeBufferedToUnbuffered(c,n,s,i){const o=await(0,R.streamToBuffer)(this.readFileBuffered(c,n,L.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,o)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new w.FileOperationError((0,h.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===k.Schemas.file?c.fsPath:c.toString(!0)}};v=he([te(0,P.ILogService)],v),e.FileService=v}),define(Z[80],x([0,1,29,249,8,36,18,3,28,2,9,4,16,52,21,149,19,97,183,41,180,179]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(s){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(s)}`)}})();class n extends P.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new L.ResourceMap(a=>C.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:a}=await d.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await d.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,C.joinPath)(i,r.name))).type:l=this.toType(r),a.push([r.name,l])}catch(l){this.logService.trace(l)}})),a}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let a;return o?.dangling?a=w.FileType.Unknown:i.isFile()?a=w.FileType.File:i.isDirectory()?a=w.FileType.Directory:a=w.FileType.Unknown,o&&(a|=w.FileType.SymbolicLink),a}async createResourceLock(i){const o=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const r=new R.Barrier;return this.resourceLocks.set(i,r),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,y.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.resourceLocks.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),r.open()})}async readFile(i,o){let a;try{o?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),a=await this.createResourceLock(i));const r=this.toFilePath(i);return await d.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}finally{a?.dispose()}}readFileStream(i,o,a){const r=(0,m.newWriteableStream)(l=>M.VSBuffer.concat(l.map(g=>M.VSBuffer.wrap(g))).buffer);return(0,p.readFileIntoStream)(this,i,r,l=>l.buffer,{...o,bufferSize:256*1024},a),r}async writeFile(i,o,a){let r;try{const l=this.toFilePath(i);if(!a.create||!a.overwrite){if(await d.Promises.exists(l)){if(!a.overwrite)throw(0,w.createFileSystemProviderError)((0,h.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,w.createFileSystemProviderError)((0,h.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(i,{create:!0,unlock:a.unlock}),await this.write(r,0,o,0,o.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof r=="number"&&await this.close(r)}}async open(i,o){const a=this.toFilePath(i);let r;(0,w.isFileOpenForWriteOptions)(o)&&(r=await this.createResourceLock(i));let l;try{if((0,w.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:E}=await d.SymlinkSupport.stat(a);E.mode&128||await d.Promises.chmod(a,E.mode|128)}catch(E){this.logService.trace(E)}let g;if((0,w.isFileOpenForWriteOptions)(o)){if(k.isWindows)try{await d.Promises.truncate(a,0),g="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}g||(g="w")}else g="r";l=await d.Promises.open(a,g)}catch(g){throw r?.dispose(),(0,w.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(i,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(l,0),(0,w.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(l,i),r){const g=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${a})`),this.mapHandleToLock.set(l,r),g&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${a})`),g.dispose())}return l}async close(i){const o=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await d.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}finally{o&&(this.mapHandleToLock.get(i)===o&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,a,r,l){const g=this.normalizePos(i,o);let E=null;try{E=(await d.Promises.read(i,a,r,l,g)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(i,g,E)}return E}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,a){const r=this.mapHandleToPos.get(i);typeof r=="number"&&(typeof o=="number"||(typeof a=="number"?this.mapHandleToPos.set(i,r+a):this.mapHandleToPos.delete(i)))}async write(i,o,a,r,l){return(0,R.retry)(()=>this.doWrite(i,o,a,r,l),100,3)}async doWrite(i,o,a,r,l){const g=this.normalizePos(i,o);let E=null;try{E=(await d.Promises.write(i,a,r,l,g)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),D)}finally{this.updatePos(i,g,E)}return E}async mkdir(i){try{await d.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const a=this.toFilePath(i);o.recursive?await d.Promises.rm(a,d.RimRafMode.MOVE):await d.Promises.unlink(a)}catch(a){throw this.toFileSystemProviderError(a)}}async rename(i,o,a){const r=this.toFilePath(i),l=this.toFilePath(o);if(r!==l)try{await this.validateTargetDeleted(i,o,"move",a.overwrite),await d.Promises.move(r,l)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,h.localize)(2,null,(0,I.basename)(r),(0,I.basename)((0,I.dirname)(l)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,o,a){const r=this.toFilePath(i),l=this.toFilePath(o);if(r!==l)try{await this.validateTargetDeleted(i,o,"copy",a.overwrite),await d.Promises.copy(r,l,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,h.localize)(3,null,(0,I.basename)(r),(0,I.basename)((0,I.dirname)(l)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,o,a,r){const l=this.toFilePath(i),g=this.toFilePath(o);let E=!1;if(!!(this.capabilities&1024)||(E=(0,f.isEqual)(l,g,!0)),E&&a==="copy")throw(0,w.createFileSystemProviderError)((0,h.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!E&&await d.Promises.exists(g)){if(!r)throw(0,w.createFileSystemProviderError)((0,h.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.doCloneFile(i,o,!1)}async doCloneFile(i,o,a){const r=this.toFilePath(i),l=this.toFilePath(o),g=!!(this.capabilities&1024);if((0,f.isEqual)(r,l,!g))return;const E=new y.DisposableStore;try{const[D,W]=await Promise.all([this.createResourceLock(i),this.createResourceLock(o)]);E.add(D),E.add(W),a&&await d.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await d.Promises.copyFile(r,l)}catch(D){if(D.code==="ENOENT"&&!a)return this.doCloneFile(i,o,!0);throw this.toFileSystemProviderError(D)}finally{E.dispose()}}createUniversalWatcher(i,o,a){return new u.UniversalWatcherClient(r=>i(r),r=>o(r),a)}createNonRecursiveWatcher(i,o,a){return new c.NodeJSWatcherClient(r=>i(r),r=>o(r),a)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,o)}async toFileSystemProviderWriteError(i,o){let a=this.toFileSystemProviderError(o);if(i&&a.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.toFilePath(i));r.mode&128||(a=(0,w.createFileSystemProviderError)(o,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return a}}e.DiskFileSystemProvider=n}),define(Z[185],x([0,1,3,80,2,18,52,23]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class f extends R.Disposable{constructor(k,C){super();this.provider=k,this.logService=C,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(k,C,m){const d=this.getUriTransformer(k);switch(C){case"stat":return this.stat(d,m[0]);case"readdir":return this.readdir(d,m[0]);case"open":return this.open(d,m[0],m[1]);case"close":return this.close(m[0]);case"read":return this.read(m[0],m[1],m[2]);case"readFile":return this.readFile(d,m[0],m[1]);case"write":return this.write(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.writeFile(d,m[0],m[1],m[2]);case"rename":return this.rename(d,m[0],m[1],m[2]);case"copy":return this.copy(d,m[0],m[1],m[2]);case"cloneFile":return this.cloneFile(d,m[0],m[1]);case"mkdir":return this.mkdir(d,m[0]);case"delete":return this.delete(d,m[0],m[1]);case"watch":return this.watch(d,m[0],m[1],m[2],m[3]);case"unwatch":return this.unwatch(m[0],m[1])}throw new Error(`IPC Command ${C} not found`)}listen(k,C,m){const d=this.getUriTransformer(k);switch(C){case"fileChange":return this.onFileChange(d,m[0]);case"readFileStream":return this.onReadFileStream(d,m[0],m[1])}throw new Error(`Unknown event ${C}`)}stat(k,C){const m=this.transformIncoming(k,C,!0);return this.provider.stat(m)}readdir(k,C){const m=this.transformIncoming(k,C);return this.provider.readdir(m)}async readFile(k,C,m){const d=this.transformIncoming(k,C,!0),h=await this.provider.readFile(d,m);return L.VSBuffer.wrap(h)}onReadFileStream(k,C,m){const d=this.transformIncoming(k,C,!0),h=new b.CancellationTokenSource,w=new S.Emitter({onLastListenerRemove:()=>{h.cancel()}}),p=this.provider.readFileStream(d,m,h.token);return(0,M.listenStream)(p,{onData:P=>w.fire(L.VSBuffer.wrap(P)),onError:P=>w.fire(P),onEnd:()=>{w.fire("end"),w.dispose(),h.dispose()}}),w.event}writeFile(k,C,m,d){const h=this.transformIncoming(k,C);return this.provider.writeFile(h,m.buffer,d)}open(k,C,m){const d=this.transformIncoming(k,C,!0);return this.provider.open(d,m)}close(k){return this.provider.close(k)}async read(k,C,m){const d=L.VSBuffer.alloc(m),h=0,w=await this.provider.read(k,C,d.buffer,h,m);return[d,w]}write(k,C,m,d,h){return this.provider.write(k,C,m.buffer,d,h)}mkdir(k,C){const m=this.transformIncoming(k,C);return this.provider.mkdir(m)}delete(k,C,m){const d=this.transformIncoming(k,C);return this.provider.delete(d,m)}rename(k,C,m,d){const h=this.transformIncoming(k,C),w=this.transformIncoming(k,m);return this.provider.rename(h,w,d)}copy(k,C,m,d){const h=this.transformIncoming(k,C),w=this.transformIncoming(k,m);return this.provider.copy(h,w,d)}cloneFile(k,C,m){const d=this.transformIncoming(k,C),h=this.transformIncoming(k,m);return this.provider.cloneFile(d,h)}onFileChange(k,C){const m=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(C,this.createSessionFileWatcher(k,m))},onLastListenerRemove:()=>{(0,R.dispose)(this.sessionToWatcher.get(C)),this.sessionToWatcher.delete(C)}});return m.event}async watch(k,C,m,d,h){const w=this.sessionToWatcher.get(C);if(w){const p=this.transformIncoming(k,d),P=w.watch(m,p,h);this.watchRequests.set(C+m,P)}}async unwatch(k,C){const m=k+C,d=this.watchRequests.get(m);d&&((0,R.dispose)(d),this.watchRequests.delete(m))}dispose(){super.dispose();for(const[,k]of this.watchRequests)k.dispose();this.watchRequests.clear();for(const[,k]of this.sessionToWatcher)k.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=f;class y extends R.Disposable{constructor(k,C,m,d){super();this.uriTransformer=k,this.logService=m,this.environmentService=d,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(C)}registerListeners(k){const C=this._register(new S.Emitter);this._register(C.event(m=>{k.fire(m.map(d=>({resource:this.uriTransformer.transformOutgoingURI(d.resource),type:d.type})))})),this._register(this.fileWatcher.onDidChangeFile(m=>C.fire(m))),this._register(this.fileWatcher.onDidWatchError(m=>k.fire(m)))}getRecursiveWatcherOptions(k){}getExtraExcludes(k){}watch(k,C,m){const d=this.getExtraExcludes(this.environmentService);return Array.isArray(d)&&(m.excludes=[...m.excludes,...d]),this.watcherRequests.set(k,this.fileWatcher.watch(C,m)),(0,R.toDisposable)(()=>{(0,R.dispose)(this.watcherRequests.get(k)),this.watcherRequests.delete(k)})}dispose(){super.dispose();for(const[,k]of this.watcherRequests)k.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=y}),define(Z[186],x([0,1,13,148,4,7,19,9,185,120]),function(j,e,S,t,R,L,M,b,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends f.AbstractDiskFileSystemProviderChannel{constructor(m,d,h){super(m,d);this.environmentService=h}getUriTransformer(m){return y.DefaultURITransformer}transformIncoming(m,d){return L.URI.revive(d)}async delete(m,d,h){if(!h.useTrash)return super.delete(m,d,h);const w=this.transformIncoming(m,d),p=(0,b.normalize)(w.fsPath);try{await S.shell.trashItem(p)}catch{throw(0,M.createFileSystemProviderError)(R.isWindows?(0,t.localize)(0,null,(0,b.basename)(p)):(0,t.localize)(1,null,(0,b.basename)(p)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(m,d){return new k(m,d,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class k extends f.AbstractSessionFileWatcher{watch(m,d,h){if(h.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(m,d,h)}}}),define(Z[98],x([0,1,6]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(L,M){switch(M){case S.LogLevel.Trace:return L.trace;case S.LogLevel.Debug:return L.debug;case S.LogLevel.Info:return L.info;case S.LogLevel.Warning:return L.warn;case S.LogLevel.Error:return L.error;case S.LogLevel.Critical:return L.critical;default:throw new Error("Invalid log level")}}class R extends S.AbstractLogger{constructor(M=S.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}set logger(M){this._logger=M;for(const{level:b,args:f}of this.buffer)t(M,b).apply(M,f);this.buffer=[]}_log(M,...b){this._logger?t(this._logger,M).apply(this._logger,b):this.getLevel()<=M&&this.buffer.push({level:M,args:b})}trace(M,...b){this._log(S.LogLevel.Trace,M,...b)}debug(M,...b){this._log(S.LogLevel.Debug,M,...b)}info(M,...b){this._log(S.LogLevel.Info,M,...b)}warn(M,...b){this._log(S.LogLevel.Warning,M,...b)}error(M,...b){this._log(S.LogLevel.Error,M,...b)}critical(M,...b){this._log(S.LogLevel.Critical,M,...b)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=R}),define(Z[187],x([0,1,8,18,16,19,5,98,6]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*L.ByteSize.MB;let I=class extends f.AbstractLogger{constructor(m,d,h,w,p){super();this.name=m,this.resource=d,this.donotUseFormatters=w,this.fileService=p,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new S.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const m=arguments[0];if(m instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=m.stack,this._log(f.LogLevel.Error,(0,f.format)(d))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(m){if(m.fileOperationResult!==3)throw m}}_log(m,d){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>y&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=d:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(m)}] ${d}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(h))})}getCurrentTimestamp(){const m=w=>w<10?`0${w}`:w,d=w=>w<10?`00${w}`:w<100?`0${w}`:w,h=new Date;return`${h.getFullYear()}-${m(h.getMonth()+1)}-${m(h.getDate())} ${m(h.getHours())}:${m(h.getMinutes())}:${m(h.getSeconds())}.${d(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,R.joinPath)((0,R.dirname)(this.resource),`${(0,R.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(m){switch(m){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};I=he([te(4,L.IFileService)],I),e.FileLogger=I;let k=class extends f.AbstractLoggerService{constructor(m,d,h){super(m.getLevel(),m.onDidChangeLogLevel);this.instantiationService=d,this.fileService=h}doCreateLogger(m,d,h){const w=new b.BufferLogService(d);return(0,L.whenProviderRegistered)(m,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(I,h?.name||(0,R.basename)(m),m,w.getLevel(),!!h?.donotUseFormatters)),w}};k=he([te(0,f.ILogService),te(1,M.IInstantiationService),te(2,L.IFileService)],k),e.FileLoggerService=k}),define(Z[188],x([0,1,3,7,6]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(C){this.service=C,this.onDidChangeLogLevel=S.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(C,m,d){switch(m){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=L;class M{constructor(C){this.channel=C}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(C){M.setLevel(this.channel,C)}static setLevel(C,m){return C.call("setLevel",m)}}e.LogLevelChannelClient=M;class b{constructor(C){this.loggerService=C,this.loggers=new Map}listen(C,m){throw new Error(`Event not found: ${m}`)}async call(C,m,d){switch(m){case"createLogger":this.createLogger(t.URI.revive(d[0]),d[1]);return;case"log":return this.log(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${m}`)}createLogger(C,m){this.loggers.set(C.toString(),this.loggerService.createLogger(C,m))}consoleLog(C,m){let d=console.log;switch(C){case R.LogLevel.Error:d=console.error;break;case R.LogLevel.Warning:d=console.warn;break;case R.LogLevel.Info:d=console.info;break}d.call(console,...m)}log(C,m){const d=this.loggers.get(C.toString());if(!d)throw new Error("Create the logger before logging");for(const[h,w]of m)(0,R.log)(d,h,w)}}e.LoggerChannel=b;class f extends R.AbstractLoggerService{constructor(C,m,d){super(C,m);this.channel=d}createConsoleMainLogger(){return new R.AdapterLogger({log:(C,m)=>{this.channel.call("consoleLog",[C,m])}})}doCreateLogger(C,m,d){return new y(this.channel,C,m,d)}}e.LoggerChannelClient=f;class y extends R.AbstractMessageLogger{constructor(C,m,d,h){super(h?.always);this.channel=C,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[m,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(C,m){const d=[[C,m]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(C){this.channel.call("log",[this.file,C])}}class I extends R.LogService{constructor(C,m){super(m);this.parent=C,this._register(C.onDidChangeLogLevel(d=>m.setLevel(d)))}setLevel(C){super.setLevel(C),this.parent.setLevel(C)}}e.FollowerLogService=I}),define(Z[99],x([0,1,19,6]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function R(b,f,y,I,k){try{const C=await new Promise((d,h)=>{j(["spdlog"],d,h)});C.setFlushOn(t.LogLevel.Trace);const m=await C.createAsyncRotatingLogger(b,f,y,I);return k&&m.clearFormatters(),m}catch(C){console.error(C)}return null}function L(b,f,y){switch(f){case t.LogLevel.Trace:b.trace(y);break;case t.LogLevel.Debug:b.debug(y);break;case t.LogLevel.Info:b.info(y);break;case t.LogLevel.Warning:b.warn(y);break;case t.LogLevel.Error:b.error(y);break;case t.LogLevel.Critical:b.critical(y);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(f,y,I,k,C){super();this.buffer=[],this.setLevel(C),this._loggerCreationPromise=this._createSpdLogLogger(f,y,I,k),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}async _createSpdLogLogger(f,y,I,k){const C=I?6:1,m=30/C*S.ByteSize.MB,d=await R(f,y,m,C,k);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:h,message:w}of this.buffer)L(this._logger,h,w);this.buffer=[]}}log(f,y){this._logger?L(this._logger,f,y):this.getLevel()<=f&&this.buffer.push({level:f,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(Z[189],x([0,1,10,16,31,19,187,6,99]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends b.AbstractLoggerService{constructor(k,C){super(k.getLevel(),k.onDidChangeLogLevel);this.fileService=C}doCreateLogger(k,C,m){return k.scheme===S.Schemas.file?new f.SpdLogLogger(m?.name||(0,R.generateUuid)(),k.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,C):new M.FileLogger(m?.name??(0,t.basename)(k),k,C,!!m?.donotUseFormatters,this.fileService)}};y=he([te(0,b.ILogService),te(1,L.IFileService)],y),e.LoggerService=y}),define(Z[190],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function R(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=R;function L(M){return!S(M)&&!t(M)&&!R(M)}e.isMenubarMenuItemAction=L}),define(Z[37],x([0,1,3,51,2,5]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class M extends R.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(y){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...y,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(y),t.Iterable.reduce(this.policies.entries(),(k,[C,m])=>({...k,[C]:m}),{})}getPolicyValue(y){return this.policies.get(y)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(y,[I,k])=>({...y,[I]:{definition:k,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=M;class b{constructor(){this.onDidChange=S.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(Z[191],x([0,1,8,3,51,11,19,6,37]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function y(k,C){const m=[];for(const d of R.Iterable.concat(k.keys(),C.keys()))k.get(d)!==C.get(d)&&m.push(d);return m}let I=class extends f.AbstractPolicyService{constructor(C,m,d){super();this.file=C,this.fileService=m,this.logService=d,this.throttledDelayer=this._register(new S.ThrottledDelayer(500));const h=t.Event.filter(m.onDidFilesChange,w=>w.affects(C));this._register(m.watch(C)),this._register(h(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(C){await this.refresh()}async read(){const C=new Map;try{const m=await this.fileService.readFile(this.file),d=JSON.parse(m.value.toString());if(!(0,L.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const h of Object.keys(d))this.policyDefinitions[h]&&C.set(h,d[h])}catch(m){m.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",m)}return C}async refresh(){const C=await this.read(),m=y(this.policies,C);this.policies=C,m.length>0&&this._onDidChange.fire(m)}};I=he([te(1,M.IFileService),te(2,b.ILogService)],I),e.FilePolicyService=I}),define(Z[192],x([0,1,3,2,37]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(f){this.service=f,this.disposables=new t.DisposableStore}listen(f,y){switch(y){case"onDidChange":return S.Event.map(this.service.onDidChange,I=>I.reduce((k,C)=>({...k,[C]:this.service.getPolicyValue(C)??null}),{}),this.disposables)}throw new Error(`Event not found: ${y}`)}call(f,y,I){switch(y){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${y}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class M extends R.AbstractPolicyService{constructor(f,y){super();this.channel=y;for(const I in f){const{definition:k,value:C}=f[I];this.policyDefinitions[I]=k,C!==void 0&&this.policies.set(I,C)}this.channel.listen("onDidChange")(I=>{for(const k in I){const C=I[k];C===null?this.policies.delete(k):this.policies.set(k,C)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(f){const y=await this.channel.call("registerPolicyDefinitions",f);for(const I in y)this.policies.set(I,y[I])}}e.PolicyChannelClient=M}),define(Z[56],x([0,1,10,4,35,16]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const b=t.globals.vscode.context.configuration();if(b)M=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const b=(0,L.dirname)(S.FileAccess.asFileUri("",j));M=j.__$__nodeRequire((0,L.joinPath)(b,"product.json").fsPath);const f=j.__$__nodeRequire((0,L.joinPath)(b,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:f.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(Z[20],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[193],x([0,1,62,6,20]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let L=class{constructor(b,f){this.productService=b,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(f);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,I,k]=y;let C=this.trustedExtensionUrlPublicKeys.get(b);if(!C){if(C=this.productService.trustedExtensionUrlPublicKeys[b],!C||C.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...C])}const m=Buffer.from(decodeURIComponent(k),"base64");if(m.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=m.slice(0,6),h=m.readUIntBE(0,6),w=Date.now()-h;if(w<0||w>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const p=m.slice(6),P=S.createVerify("SHA256");P.write(d),P.write(Buffer.from(I)),P.end();for(let v=0;v<C.length;v++){let u=C[v];if(u!==null){if(typeof u=="string")try{u=S.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),C[v]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${v+1} for ${b}:`,c),C[v]=null;continue}if(P.verify(u,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};L=he([te(0,R.IProductService),te(1,t.ILogService)],L),e.ExtensionUrlTrustService=L}),define(Z[57],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(Z[194],x([0,1,13,38,2,36,10,9,4,7,31,55,6]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends R.Disposable{constructor(h,w){super();this.logService=w,this.validRoots=L.TernarySearchTree.forPaths(!f.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(h.appRoot),this.addValidFileRoot(h.extensionsPath),this.addValidFileRoot(h.globalStorageHome.fsPath),this.addValidFileRoot(h.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=S.session;h.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(w,p)=>this.handleResourceRequest(w,p)),h.protocol.interceptFileProtocol(M.Schemas.file,(w,p)=>this.handleFileRequest(w,p)),this._register((0,R.toDisposable)(()=>{h.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(h){const w=(0,b.normalize)(h);return this.validRoots.get(w)?R.Disposable.None:(this.validRoots.set(w,!0),(0,R.toDisposable)(()=>this.validRoots.delete(w)))}handleFileRequest(h,w){const p=y.URI.parse(h.url);return this.logService.error(`Refused to load resource ${p.fsPath} from ${M.Schemas.file}: protocol (original URL: ${h.url})`),w({error:-3})}handleResourceRequest(h,w){const p=this.requestToNormalizedFilePath(h);return this.validRoots.findSubstr(p)?w({path:p}):this.validExtensions.has((0,b.extname)(p))?w({path:p}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),w({error:-3}))}requestToNormalizedFilePath(h){const w=y.URI.parse(h.url),p=M.FileAccess.asFileUri(w);return(0,b.normalize)(p.fsPath)}createIPCObjectUrl(){let h;const w=y.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),p=w.toString(),P=async()=>h;return t.validatedIpcMain.handle(p,P),this.logService.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:w,update:v=>h=v,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${p}.`),t.validatedIpcMain.removeHandler(p)}}}};m=he([te(0,k.INativeEnvironmentService),te(1,C.ILogService)],m),e.ProtocolMainService=m}),define(Z[42],x([0,1,110,11]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(M,b){S.ok(t.isString(M)),S.ok(t.isObject(b)),S.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,b)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new R}),define(Z[195],x([0,1,3,42]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,y){this.schemasById[R(f)]=y,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new L;t.Registry.add(e.Extensions.JSONContribution,M)}),define(Z[58],x([0,1,25,3,11,140,17,195,42]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=f.Registry.as(b.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const i=this.doRegisterConfigurations(n,s);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const s=this.doDeregisterConfigurations(n);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:n,remove:s}){const i=[];i.push(...this.doDeregisterConfigurations(s)),i.push(...this.doRegisterConfigurations(n,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(i)})}registerDefaultConfigurations(n){const s=[],i=[];for(const{overrides:o,source:a}of n)for(const r in o)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const l=this.configurationDefaultsOverrides.get(r),g=l?.valuesSources??new Map;if(a)for(const O of Object.keys(o[r]))g.set(O,a);const E={...l?.value||{},...o[r]};this.configurationDefaultsOverrides.set(r,{source:a,value:E,valuesSources:g});const D=(0,M.getLanguageTagSettingPlainKey)(r),W={type:"object",default:E,description:L.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:R.isString(a)?void 0:a,defaultValueSource:a};i.push(...h(r)),this.configurationProperties[r]=W,this.defaultLanguageConfigurationOverridesNode.properties[r]=W}else{this.configurationDefaultsOverrides.set(r,{value:o[r],source:a});const l=this.configurationProperties[r];l&&(this.updatePropertyDefaultValue(r,l),this.updateSchema(r,l))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:i,source:o}of n)for(const a in i){const r=this.configurationDefaultsOverrides.get(a),l=R.isString(o)?o:o?.id,g=R.isString(r?.source)?r?.source:r?.source?.id;if(l===g)if(s.push(a),this.configurationDefaultsOverrides.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const E=this.configurationProperties[a];E&&(this.updatePropertyDefaultValue(a,E),this.updateSchema(a,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const s of n)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,s){const i=[];return n.forEach(o=>{i.push(...this.validateAndRegisterProperties(o,s,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),i}doDeregisterConfigurations(n){const s=[],i=o=>{if(o.properties)for(const a in o.properties){s.push(a);const r=this.configurationProperties[a];r?.policy?.name&&this.policyConfigurations.delete(r.policy.name),delete this.configurationProperties[a],this.removeFromSchema(a,o.properties[a])}o.allOf&&o.allOf.forEach(a=>i(a))};for(const o of n){i(o);const a=this.configurationContributors.indexOf(o);a!==-1&&this.configurationContributors.splice(a,1)}return s}validateAndRegisterProperties(n,s=!0,i,o,a=3){a=R.isUndefinedOrNull(n.scope)?a:n.scope;let r=[],l=n.properties;if(l)for(let E in l){const D=l[E];if(s&&v(E,D)){delete l[E];continue}if(D.source=i,D.defaultDefaultValue=l[E].default,this.updatePropertyDefaultValue(E,D),e.OVERRIDE_PROPERTY_REGEX.test(E)?D.scope=void 0:(D.scope=R.isUndefinedOrNull(D.scope)?a:D.scope,D.restricted=R.isUndefinedOrNull(D.restricted)?!!o?.includes(E):D.restricted),l[E].hasOwnProperty("included")&&!l[E].included){this.excludedConfigurationProperties[E]=l[E],delete l[E];continue}else this.configurationProperties[E]=l[E],l[E].policy?.name&&this.policyConfigurations.set(l[E].policy.name,E);!l[E].deprecationMessage&&l[E].markdownDeprecationMessage&&(l[E].deprecationMessage=l[E].markdownDeprecationMessage),r.push(E)}let g=n.allOf;if(g)for(let E of g)r.push(...this.validateAndRegisterProperties(E,s,i,o,a));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const s=i=>{let o=i.properties;if(o)for(const r in o)this.updateSchema(r,o[r]);let a=i.allOf;a&&a.forEach(s)};s(n)}updateSchema(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.resourceLanguageSettingsSchema.properties[n]=s;break}}removeFromSchema(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const s=`[${n}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,s){const i=this.configurationDefaultsOverrides.get(n);let o=i?.value,a=i?.source;R.isUndefined(o)&&(o=s.defaultDefaultValue,a=void 0),R.isUndefined(o)&&(o=p(s.type)),s.default=o,s.defaultValueSource=a}}const m="\\[([^\\]]+)\\]",d=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=d.exec(c);for(;s?.length;){const i=s[1].trim();i&&n.push(i),s=d.exec(c)}}return(0,S.distinct)(n)}e.overrideIdentifiersFromKey=h;function w(c){return c.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=w;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const P=new C;f.Registry.add(e.Extensions.Configuration,P);function v(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?L.localize(7,null,c):P.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):n.policy?.name&&P.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,c,n.policy?.name,P.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=v;function u(){const c=[],n=P.getConfigurationProperties();for(const s of Object.keys(n))c.push([s,n[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=u}),define(Z[100],x([0,1,25,3,46,2,36,47,11,7,17,58,42]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class m{constructor(s={},i=[],o=[]){this._contents=s,this._keys=i,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(s){return s?(0,I.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const o=this.getContentsForOverrideIdentifer(i);return o?s?(0,I.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return S.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return S.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=b.deepClone(this.contents),o=b.deepClone(this.overrides),a=[...this.keys];for(const r of s){this.mergeContents(i,r.contents);for(const l of r.overrides){const[g]=o.filter(E=>S.equals(E.identifiers,l.identifiers));g?(this.mergeContents(g.contents,l.contents),g.keys.push(...l.keys),g.keys=S.distinct(g.keys)):o.push(b.deepClone(l))}for(const l of r.keys)a.indexOf(l)===-1&&a.push(l)}return new m(i,a,o)}freeze(){return this.frozen=!0,this}clone(){return new m(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const a of S.distinct([...Object.keys(this.contents),...Object.keys(i)])){let r=this.contents[a],l=i[a];l&&(typeof r=="object"&&typeof l=="object"?(r=b.deepClone(r),this.mergeContents(r,l)):r=l),o[a]=r}return new m(o,this.keys,this.overrides)}mergeContents(s,i){for(const o of Object.keys(i)){if(o in s&&f.isObject(s[o])&&f.isObject(i[o])){this.mergeContents(s[o],i[o]);continue}s[o]=b.deepClone(i[o])}}checkAndFreeze(s){return this.frozen&&!Object.isFrozen(s)?b.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,o=null;const a=r=>{r&&(o?this.mergeContents(o,r):o=b.deepClone(r))};for(const r of this.overrides)S.equals(r.identifiers,[s])?i=r.contents:r.identifiers.includes(s)&&a(r.contents);return a(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,I.addToValueTree)(this.contents,s,i,o=>{throw new Error(o)})}removeValue(s){this.removeKey(s)&&(0,I.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let o=0;o<i;o++)s.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!f.isUndefinedOrNull(s)){const o=this.doParseContent(s);this.parseRaw(o,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:o,keys:a,overrides:r,restricted:l}=this.doParseRaw(s,i);this._configurationModel=new m(o,a,r),this._restrictedConfigurations=l||[]}doParseContent(s){let i={},o=null,a=[],r=[],l=[];function g(D){Array.isArray(a)?a.push(D):o!==null&&(a[o]=D)}let E={onObjectBegin:()=>{let D={};g(D),r.push(a),a=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{let D=[];g(D),r.push(a),a=D,o=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:g,onError:(D,W,O)=>{l.push({error:D,offset:W,length:O})}};if(s)try{R.visit(s,E),i=a[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(s,i){const o=C.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),a=this.filter(s,o,!0,i);s=a.raw;const r=(0,I.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),l=Object.keys(s),g=this.toOverrides(s,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:r,keys:l,overrides:g,restricted:a.restricted}}filter(s,i,o,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:s,restricted:[]};const r={},l=[];for(let g in s)if(k.OVERRIDE_PROPERTY_REGEX.test(g)&&o){const E=this.filter(s[g],i,!1,a);r[g]=E.raw,l.push(...E.restricted)}else{const E=i[g],D=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&l.push(g),(D===void 0||a.scopes===void 0||a.scopes.includes(D))&&(a.skipRestricted&&E?.restricted||(r[g]=s[g]))}return{raw:r,restricted:l}}toOverrides(s,i){const o=[];for(const a of Object.keys(s))if(k.OVERRIDE_PROPERTY_REGEX.test(a)){const r={};for(const l in s[a])r[l]=s[a][l];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(a),keys:Object.keys(r),contents:(0,I.toValuesTree)(r,i)})}return o}}e.ConfigurationModelParser=d;class h extends L.Disposable{constructor(s,i,o,a){super();this.userSettingsResource=s,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class w{constructor(s,i,o,a=new m,r=new m,l=new M.ResourceMap,g=new m,E=new M.ResourceMap,D=!0){this._defaultConfiguration=s,this._policyConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=g,this._memoryConfigurationByResource=E,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(s,i,o){return this.getConsolidatedConfigurationModel(s,i,o).getValue(s)}updateValue(s,i,o={}){let a;o.resource?(a=this._memoryConfigurationByResource.get(o.resource),a||(a=new m,this._memoryConfigurationByResource.set(o.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(s):a.setValue(s,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,o){const a=this.getConsolidatedConfigurationModel(s,i,o),r=this.getFolderConfigurationModelForResource(i.resource,o),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,g=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),E=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(s),D=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),V=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,J=r?i.overrideIdentifier?r.freeze().override(i.overrideIdentifier).getValue(s):r.freeze().getValue(s):void 0,ne=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(s):l.getValue(s),Y=a.getValue(s),re=S.distinct(a.overrides.map(ae=>ae.identifiers).flat()).filter(ae=>a.getOverrideValue(s,ae)!==void 0);return{defaultValue:g,policyValue:E,userValue:D,userLocalValue:W,userRemoteValue:O,workspaceValue:V,workspaceFolderValue:J,memoryValue:ne,value:Y,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,policy:E!==void 0?{value:E}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:J!==void 0?{value:r?.freeze().getValue(s),override:i.overrideIdentifier?r?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:l.getValue(s),override:i.overrideIdentifier?l.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(s){this._policyConfiguration=s}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:a,updated:r,removed:l}=u(this._defaultConfiguration,s);i=[...a,...r,...l]}for(const a of i)for(const r of(0,k.overrideIdentifiersFromKey)(a)){const l=this._defaultConfiguration.getKeysForOverrideIdentifier(r),g=s.getKeysForOverrideIdentifier(r),E=[...g.filter(D=>l.indexOf(D)===-1),...l.filter(D=>g.indexOf(D)===-1),...l.filter(D=>!b.equals(this._defaultConfiguration.override(r).getValue(D),s.override(r).getValue(D)))];o.push([r,E])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:a}=u(this._policyConfiguration,s),r=[...i,...o,...a];return r.length&&this.updatePolicyConfiguration(s),{keys:r,overrides:[]}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:a,overrides:r}=u(this.localUserConfiguration,s),l=[...i,...o,...a];return l.length&&this.updateLocalUserConfiguration(s),{keys:l,overrides:r}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:a,overrides:r}=u(this.remoteUserConfiguration,s);let l=[...i,...o,...a];return l.length&&this.updateRemoteUserConfiguration(s),{keys:l,overrides:r}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:a,overrides:r}=u(this.workspaceConfiguration,s);let l=[...i,...o,...a];return l.length&&this.updateWorkspaceConfiguration(s),{keys:l,overrides:r}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:a,updated:r,removed:l,overrides:g}=u(o,i);let E=[...a,...r,...l];return(E.length||!o)&&this.updateFolderConfiguration(s,i),{keys:E,overrides:g}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:a,removed:r,overrides:l}=u(i,void 0);return{keys:[...o,...a,...r],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(s,i,o){let a=this.getConsolidatedConfigurationModelForResource(i,o);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(s)!==void 0&&(a=a.merge(this._policyConfiguration)),a}getConsolidatedConfigurationModelForResource({resource:s},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const a=i.getFolder(s);a&&(o=this.getFolderConsolidatedConfiguration(a.uri)||o);const r=this._memoryConfigurationByResource.get(s);r&&(o=o.merge(r))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(s);a?(i=o.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=o}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:o,overrides:a,keys:r}=this._folderConfigurations.get(i);return s.push([i,{contents:o,overrides:a,keys:r}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>s.add(o))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(a=>i.add(a))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),o=this.parseConfigurationModel(s.policy),a=this.parseConfigurationModel(s.user),r=this.parseConfigurationModel(s.workspace),l=s.folders.reduce((g,E)=>(g.set(y.URI.revive(E[0]),this.parseConfigurationModel(E[1])),g),new M.ResourceMap);return new w(i,o,a,new m,r,l,new m,new M.ResourceMap,!1)}static parseConfigurationModel(s){return new m(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=w;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,i=new Map;for(const a of n)a.keys.forEach(r=>s.add(r)),a.overrides.forEach(([r,l])=>{const g=(0,M.getOrSet)(i,r,new Set);l.forEach(E=>g.add(E))});const o=[];return i.forEach((a,r)=>o.push([r,[...a.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=p;class P{constructor(s,i,o,a){this.change=s,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=a,this._previousConfiguration=void 0;const r=new Set;s.keys.forEach(g=>r.add(g)),s.overrides.forEach(([,g])=>g.forEach(E=>r.add(E))),this.affectedKeys=[...r.values()];const l=new m;this.affectedKeys.forEach(g=>l.setValue(g,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!b.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let o=(0,I.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof o=="object"&&(a=Object.keys(o)[0]);){if(s=s[a],!s)return!1;o=o[a]}return!0}}e.ConfigurationChangeEvent=P;class v extends P{constructor(s,i,o,a){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=o,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=v;function u(n,s){const{added:i,removed:o,updated:a}=c(s,n),r=[],l=n?.getAllOverrideIdentifiers()||[],g=s?.getAllOverrideIdentifiers()||[];if(s){const E=g.filter(D=>!l.includes(D));for(const D of E)r.push([D,s.getKeysForOverrideIdentifier(D)])}if(n){const E=l.filter(D=>!g.includes(D));for(const D of E)r.push([D,n.getKeysForOverrideIdentifier(D)])}if(s&&n){for(const E of l)if(g.includes(E)){const D=c({contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});r.push([E,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:o,updated:a,overrides:r}}function c(n,s){const i=n?s?n.keys.filter(r=>s.keys.indexOf(r)===-1):[...n.keys]:[],o=s?n?s.keys.filter(r=>n.keys.indexOf(r)===-1):[...s.keys]:[],a=[];if(n&&s){for(const r of s.keys)if(n.keys.indexOf(r)!==-1){const l=(0,I.getConfigurationValue)(s.contents,r),g=(0,I.getConfigurationValue)(n.contents,r);b.equals(l,g)||a.push(r)}}return{added:i,removed:o,updated:a}}}),define(Z[196],x([0,1,25,3,2,47,11,17,100,58,6,37,42]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class m extends R.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(C.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(({properties:P,defaultsOverrides:v})=>this.onDidUpdateConfiguration(P,v))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(P,v){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:P})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=m;class d extends f.ConfigurationModel{constructor(P={}){const v=C.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(v),c=Object.create(null),n=[];for(const s in v){const i=P[s],o=i!==void 0?i:v[s].default;(0,b.addToValueTree)(c,s,o,a=>console.error(`Conflict in default settings: ${a}`))}for(const s of Object.keys(c))y.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,y.overrideIdentifiersFromKey)(s),keys:Object.keys(c[s]),contents:(0,b.toValuesTree)(c[s],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,u,n)}}e.DefaultConfigurationModel=d;class h{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new f.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=h;let w=class extends R.Disposable{constructor(P,v,u){super();this.defaultConfiguration=P,this.policyService=v,this.logService=u,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new f.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(P=>this.onDidChangePolicies(P))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:P})=>this.update(await this.registerPolicyDefinitions(P),!0))),this._configurationModel}async registerPolicyDefinitions(P){const v={},u=[],c=C.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(const n of P){const s=c[n];if(!s){u.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}u.push(n),v[s.policy.name]={type:s.type}}}return(0,M.isEmptyObject)(v)||await this.policyService.registerPolicyDefinitions(v),u}onDidChangePolicies(P){const v=C.Registry.as(y.Extensions.Configuration).getPolicyConfigurations(),u=(0,S.coalesce)(P.map(c=>v.get(c)));this.update(u,!0)}update(P,v){const u=C.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const s of P){const i=u[s]?.policy?.name;if(i){const o=this.policyService.getPolicyValue(i);(n?o!==void 0:!(0,L.equals)(this._configurationModel.getValue(s),o))&&c.push([s,o])}else this._configurationModel.getValue(s)!==void 0&&c.push([s,void 0])}if(c.length){const s=this._configurationModel;this._configurationModel=new f.ConfigurationModel;for(const i of s.keys)this._configurationModel.setValue(i,s.getValue(i));for(const[i,o]of c)o===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,o);v&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=he([te(1,k.IPolicyService),te(2,I.ILogService)],w),e.PolicyConfiguration=w}),define(Z[197],x([0,1,8,3,2,16,17,100,196,37]),function(j,e,S,t,R,L,M,b,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends R.Disposable{constructor(C,m,d,h){super();this.settingsResource=C,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new f.DefaultConfiguration),this.policyConfiguration=d instanceof y.NullPolicyService?new f.NullPolicyConfiguration:this._register(new f.PolicyConfiguration(this.defaultConfiguration,d,h)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,m)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:p})=>this.onDidDefaultConfigurationChange(w,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[C,m,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(C,m,d)}getConfigurationData(){return this.configuration.toData()}getValue(C,m){const d=typeof C=="string"?C:void 0,h=(0,M.isConfigurationOverrides)(C)?C:(0,M.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(d,h,void 0)}updateValue(C,m,d,h){return Promise.reject(new Error("not supported"))}inspect(C){return this.configuration.inspect(C,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const C=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(C)}onDidChangeUserConfiguration(C){const m=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(C);this.trigger(d,m,1)}onDidDefaultConfigurationChange(C,m){const d=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(C,m);this.trigger(h,d,6)}onDidPolicyConfigurationChange(C){const m=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(C);this.trigger(d,m,6)}trigger(C,m,d){const h=new b.ConfigurationChangeEvent(C,{data:m},this.configuration);h.source=d,h.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(C){switch(C){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Z[198],x([0,1,15,5]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var R;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends S.ErrorNoTelemetry{constructor(b,f=R.Unknown,y){super(b);this._message=b,this._code=f,this._detail=y,this.isHandled=f===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(b){return b instanceof L&&b._code===R.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof L&&b._code===R.NoResolverFound}static isHandled(b){return b instanceof L&&b.isHandled}}e.RemoteAuthorityResolverError=L}),define(Z[67],x([0,1,10]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(M){return M.scheme===S.Schemas.vscodeRemote?M.authority:void 0}e.getRemoteAuthority=t;function R(M){if(!M)return;const b=M.indexOf("+");return b<0?M:M.substr(0,b)}e.getRemoteName=R;function L(M){return`/${M.quality??"oss"}-${M.commit??"dev"}`}e.getRemoteServerRootPath=L}),define(Z[199],x([0,1,8,18,23,15,3,2,31,91,198,67]),function(j,e,S,t,R,L,M,b,f,y,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var m;(function(Q){Q[Q.Management=1]="Management",Q[Q.ExtensionHost=2]="ExtensionHost",Q[Q.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function d(Q){switch(Q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(Q){const X=new R.CancellationTokenSource;return setTimeout(()=>X.cancel(),Q),X.token}function w(Q,X){if(Q.isCancellationRequested||X.isCancellationRequested)return R.CancellationToken.Cancelled;const T=new R.CancellationTokenSource;return Q.onCancellationRequested(()=>T.cancel()),X.onCancellationRequested(()=>T.cancel()),T.token}class p{constructor(X){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((T,A)=>{this._resolvePromise=T,this._rejectPromise=A}),X.isCancellationRequested?this._timeout():this._disposables.add(X.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(X){this._state==="pending"?this._disposables.add(X):X.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const X=new Error("Time limit reached");return X.code="ETIMEDOUT",X.syscall="connect",X}resolve(X){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(X))}reject(X){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(X))}}function P(Q,X){const T=new p(X);return T.registerDisposable(Q.onControlMessage(A=>{const _=JSON.parse(A.toString()),z=$(_);z?T.reject(z):T.resolve(_)})),T.promise}function v(Q,X,T,A,_,z,F,B){const K=new p(B);return X.connect(T,A,_,z,F,(ie,oe)=>{K.didTimeout?(ie&&Q.error(ie),oe?.dispose()):ie||!oe?K.reject(ie):K.resolve(oe)}),K.promise}function u(Q,X){const T=new p(X);return Q.then(A=>{T.didTimeout||T.resolve(A)},A=>{T.didTimeout||T.reject(A)}),T.promise}async function c(Q,X,T,A){const _=q(Q,X);Q.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let z;try{z=await v(Q.logService,Q.socketFactory,Q.host,Q.port,(0,k.getRemoteServerRootPath)(Q),`reconnectionToken=${Q.reconnectionToken}&reconnection=${Q.reconnectionProtocol?"true":"false"}`,`renderer-${d(X)}-${Q.reconnectionToken}`,A)}catch(oe){throw Q.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),Q.logService.error(oe),oe}Q.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let F,B;Q.reconnectionProtocol?(Q.reconnectionProtocol.beginAcceptReconnection(z,null),F=Q.reconnectionProtocol,B=!1):(F=new y.PersistentProtocol(z,null),B=!0),Q.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const K=await u(Q.signService.createNewMessage((0,f.generateUuid)()),A),ie={type:"auth",auth:Q.connectionToken||"00000000000000000000",data:K.data};F.sendControl(t.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await P(F,w(A,h(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}if(Q.logService.trace(`${_} 4/6. received SignRequest control message.`),!await u(Q.signService.validate(K,oe.signedData),A)){const be=new Error("Refused to connect to unsupported server");throw be.code="VSCODE_CONNECTION_ERROR",be}const fe=await u(Q.signService.sign(oe.data),A),Ie={type:"connectionType",commit:Q.commit,signedData:fe,desiredConnectionType:X};return T&&(Ie.args=T),Q.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),F.sendControl(t.VSBuffer.fromString(JSON.stringify(Ie))),{protocol:F,ownsProtocol:B}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(Q.logService.error(`${_} the handshake timed out. Error:`),Q.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(Q.logService.error(`${_} received error control message when negotiating connection. Error:`),Q.logService.error(oe)),B&&H(F),oe}}async function n(Q,X,T,A){const _=Date.now(),z=q(Q,X),{protocol:F,ownsProtocol:B}=await c(Q,X,T,A),K=new p(A);return K.registerDisposable(F.onControlMessage(ie=>{const oe=JSON.parse(ie.toString()),ue=$(oe);ue?(Q.logService.error(`${z} received error control message when negotiating connection. Error:`),Q.logService.error(ue),B&&H(F),K.reject(ue)):(Q.reconnectionProtocol&&Q.reconnectionProtocol.endAcceptReconnection(),Q.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${ee(_)}!`),K.resolve({protocol:F,firstMessage:oe}))})),K.promise}async function s(Q,X){const{protocol:T}=await n(Q,1,void 0,X);return{protocol:T}}async function i(Q,X,T){const{protocol:A,firstMessage:_}=await n(Q,2,X,T),z=_&&_.debugPort;return{protocol:A,debugPort:z}}async function o(Q,X,T){const A=Date.now(),_=q(Q,3),{protocol:z}=await c(Q,3,X,T);return Q.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ee(A)}!`),z}async function a(Q,X,T){const{host:A,port:_,connectionToken:z}=await Q.addressProvider.getAddress();return{commit:Q.commit,quality:Q.quality,host:A,port:_,connectionToken:z,reconnectionToken:X,reconnectionProtocol:T,socketFactory:Q.socketFactory,signService:Q.signService,logService:Q.logService}}async function r(Q,X,T){try{const A=(0,f.generateUuid)(),_=await a(Q,A,null),{protocol:z}=await s(_,R.CancellationToken.None);return new re(Q,X,T,A,z)}catch(A){throw Q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),Q.logService.error(A),Y.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=r;async function l(Q,X){try{const T=(0,f.generateUuid)(),A=await a(Q,T,null),{protocol:_,debugPort:z}=await i(A,X,R.CancellationToken.None);return new ae(Q,X,T,_,z)}catch(T){throw Q.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),Q.logService.error(T),Y.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentExtensionHost=l;async function g(Q,X,T){const A=await a(Q,(0,f.generateUuid)(),null);return await o(A,{host:X,port:T},R.CancellationToken.None)}e.connectRemoteAgentTunnel=g;function E(Q){return(0,S.createCancelablePromise)(X=>new Promise((T,A)=>{const _=setTimeout(T,Q*1e3);X.onCancellationRequested(()=>{clearTimeout(_),T()})}))}var D;(function(Q){Q[Q.ConnectionLost=0]="ConnectionLost",Q[Q.ReconnectionWait=1]="ReconnectionWait",Q[Q.ReconnectionRunning=2]="ReconnectionRunning",Q[Q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Q[Q.ConnectionGain=4]="ConnectionGain"})(D=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(X,T){this.reconnectionToken=X,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=W;class O{constructor(X,T,A,_){this.reconnectionToken=X,this.millisSinceLastIncomingData=T,this.durationSeconds=A,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class V{constructor(X,T,A){this.reconnectionToken=X,this.millisSinceLastIncomingData=T,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=V;class J{constructor(X,T,A){this.reconnectionToken=X,this.millisSinceLastIncomingData=T,this.attempt=A,this.type=4}}e.ConnectionGainEvent=J;class ne{constructor(X,T,A,_){this.reconnectionToken=X,this.millisSinceLastIncomingData=T,this.attempt=A,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class Y extends b.Disposable{constructor(X,T,A,_,z){super();this._connectionType=X,this._options=T,this.reconnectionToken=A,this.protocol=_,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new J(this.reconnectionToken,0,0)),this._register(_.onSocketClose(F=>{const B=N(this._connectionType,this.reconnectionToken,!0);F?F.type===0?(this._options.logService.info(`${B} received socket close event (hadError: ${F.hadError}).`),F.error&&this._options.logService.error(F.error)):(this._options.logService.info(`${B} received socket close event (wasClean: ${F.wasClean}, code: ${F.code}, reason: ${F.reason}).`),F.event&&this._options.logService.error(F.event)):this._options.logService.info(`${B} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(()=>{const F=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),this._register((0,b.toDisposable)(()=>{const F=Y._instances.indexOf(this);F>=0&&Y._instances.splice(F,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(X,T,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=X,this._permanentFailureAttempt=T,this._permanentFailureHandled=A,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(X=>X._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(X=>X._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||Y._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const X=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${X} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const _=A<T.length?T[A]:T[T.length-1];try{if(_>0){const F=E(_);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,F)),this._options.logService.info(`${X} waiting for ${_} seconds before reconnecting...`);try{await F}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${X} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${X} resolving connection...`);const z=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${X} connecting to ${z.host}:${z.port}...`),await this._reconnect(z,h(C)),this._options.logService.info(`${X} reconnected!`),this._onDidStateChange.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${X} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${X} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${X} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${X} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,L.isCancellationError)(z)){this._options.logService.info(`${X} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${X} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,I.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${X} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(X,T,A){this._reconnectionFailureIsFatal?Y.triggerPermanentFailure(X,T,A):this._gotoPermanentFailure(X,T,A)}_gotoPermanentFailure(X,T,A){this._onDidStateChange.fire(new ne(this.reconnectionToken,X,T,A)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Y,Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class re extends Y{constructor(X,T,A,_,z){super(1,X,_,z,!0);this.client=this._register(new y.Client(z,{remoteAuthority:T,clientId:A},X.ipcLogger))}async _reconnect(X,T){await s(X,T)}}e.ManagementPersistentConnection=re;class ae extends Y{constructor(X,T,A,_,z){super(2,X,A,_,!1);this._startArguments=T,this.debugPort=z}async _reconnect(X,T){await i(X,this._startArguments,T)}}e.ExtensionHostPersistentConnection=ae;function H(Q){try{Q.acceptDisconnect();const X=Q.getSocket();Q.dispose(),X.dispose()}catch(X){(0,L.onUnexpectedError)(X)}}function $(Q){if(Q&&Q.type==="error"){const X=new Error(`Connection error: ${Q.reason}`);return X.code="VSCODE_CONNECTION_ERROR",X}return null}function U(Q,X){for(;Q.length<X;)Q+=" ";return Q}function N(Q,X,T){return`[remote-connection][${U(d(Q),13)}][${X.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function q(Q,X){return`${N(X,Q.reconnectionToken,!!Q.reconnectionProtocol)}[${Q.host}:${Q.port}]`}function ee(Q){return`${Date.now()-Q} ms`}}),define(Z[59],x([0,1,18,153,58,5,42]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function b(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=b;function f(h){return h.res.statusCode===204}async function y(h){return f(h)?null:(await(0,S.streamToBuffer)(h.stream)).toString()}e.asText=y;async function I(h){if(!b(h))throw new Error("Server returned "+h.res.statusCode);return y(h)}e.asTextOrError=I;async function k(h){if(!b(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const p=(await(0,S.streamToBuffer)(h.stream)).toString();try{return JSON.parse(p)}catch(P){throw P.message+=`:
`+p,P}}e.asJson=k;function C(h){d(h)}e.updateProxyConfigurationsScope=C;let m;function d(h){const w=M.Registry.as(R.Extensions.Configuration),p=m;m={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[m],remove:p?[p]:[]})}d(2)}),define(Z[200],x([0,1,201,11]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function R(M,b){return M.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:M.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function L(M,b,f={}){const y=(0,S.parse)(M),I=f.proxyUrl||R(y,b);if(!I)return null;const k=(0,S.parse)(I);if(!/^https?:$/.test(k.protocol||""))return null;const C={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:(0,t.isBoolean)(f.strictSSL)?f.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((m,d)=>{j(["http-proxy-agent"],m,d)}))(C):new(await new Promise((m,d)=>{j(["https-proxy-agent"],m,d)}))(C)}e.getProxyAgent=L}),define(Z[101],x([0,1,39,9,154,23,41,15,4,31,137,53,8]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let d;async function h(p,P,v){return P["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.isLaunchedFromCli)(v)&&!P["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.isLaunchedFromCli)(v)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=C.Promises.withAsyncBody(async(u,c)=>{const n=new L.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),c(new Error((0,R.localize)(0,null)))},m);try{u(await w(p,n.token))}catch(i){!(0,b.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,R.localize)(1,null,(0,M.toErrorMessage)(i)))):u({})}finally{clearTimeout(s),n.dispose()}})),d)}e.getResolvedShellEnv=h;async function w(p,P){const v=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",v);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",u);const c=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(f.OS,s);return p.trace("getUnixShellEnvironment#shell",i),new Promise((o,a)=>{if(P.isCancellationRequested)return a((0,b.canceled)());const r=(0,t.basename)(i);let l,g;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${E} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,g=["-Login","-Command"]):(l=`'${process.execPath}' ${E} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,r==="tcsh"?g=["-ic"]:g=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),l);const D=(0,S.spawn)(i,[...g,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});P.onCancellationRequested(()=>(D.kill(),a((0,b.canceled)()))),D.on("error",V=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(V)),a(V)});const W=[];D.stdout.on("data",V=>W.push(V));const O=[];D.stderr.on("data",V=>O.push(V)),D.on("close",(V,J)=>{const ne=Buffer.concat(W).toString("utf8");p.trace("getUnixShellEnvironment#raw",ne);const Y=Buffer.concat(O).toString("utf8");if(Y.trim()&&p.trace("getUnixShellEnvironment#stderr",Y),V||J)return a(new Error((0,R.localize)(2,null,V,J)));const re=n.exec(ne),ae=re?re[1]:"{}";try{const H=JSON.parse(ae);v?H.ELECTRON_RUN_AS_NODE=v:delete H.ELECTRON_RUN_AS_NODE,u?H.ELECTRON_NO_ATTACH_CONSOLE=u:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",H),o(H)}catch(H){p.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(H)),a(H)}})})}}),define(Z[81],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[202],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>j(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),M=new L.validator;if(M){const b=String(S._nextId++);return this.validators.set(b,M),{id:b,data:M.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const M=this.validators.get(R.id);if(!M)return!1;this.validators.delete(R.id);try{return M.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),M=new L.signer;if(M)return M.sign(R)}catch{}return R}}e.SignService=S,S._nextId=1}),define(Z[48],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(Z[22],x([0,1,13,38,8,3,2,4,35,11,5,6,48]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var m;(function(w){w[w.QUIT=1]="QUIT",w[w.KILL=2]="KILL"})(m=e.ShutdownReason||(e.ShutdownReason={}));var d;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class St extends M.Disposable{constructor(p,P){super();this.logService=p,this.stateMainService=P,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(St.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(St.QUIT_AND_RESTART_KEY)}registerListeners(){const p=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};S.app.addListener("before-quit",p);const P=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",P),S.app.once("will-quit",v=>{this.logService.trace("Lifecycle#app.on(will-quit)"),v.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),S.app.removeListener("before-quit",p),S.app.removeListener("window-all-closed",P),S.app.quit()})})}fireOnWillShutdown(p){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({reason:p,join(v){P.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await R.Promises.settled(P)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===p)return;this.logService.trace(`lifecycle (main): phase changed (value: ${p})`),this._phase=p;const P=this.phaseWhen.get(this._phase);P&&(P.open(),this.phaseWhen.delete(this._phase))}async when(p){if(p<=this._phase)return;let P=this.phaseWhen.get(p);P||(P=new R.Barrier,this.phaseWhen.set(p,P)),await P.wait()}registerWindow(p){const P=new M.DisposableStore;this.windowCounter++,P.add(p.onWillLoad(u=>this._onWillLoadWindow.fire({window:p,workspace:u.workspace,reason:u.reason})));const v=(0,y.assertIsDefined)(p.win);v.on("close",u=>{const c=p.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${p.id}`),u.preventDefault(),this.unload(p,1).then(n=>{if(n){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(p),p.close()})}),v.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.windowCounter--,P.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(p,P){await this.unload(p,3)||p.reload(P)}unload(p,P){const v=this.mapWindowIdToPendingUnload.get(p.id);if(v)return v;const u=this.doUnload(p,P).finally(()=>{this.mapWindowIdToPendingUnload.delete(p.id)});return this.mapWindowIdToPendingUnload.set(p.id,u),u}async doUnload(p,P){if(!p.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${p.id}`);const v=this._quitRequested?2:P;let u=await this.onBeforeUnloadWindowInRenderer(p,v);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.handleWindowUnloadVeto(u)):(await this.onWillUnloadWindowInRenderer(p,v),!1)}handleWindowUnloadVeto(p){return p?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(p){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(p),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(p,P){return new Promise(v=>{const u=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${u}`,n=`vscode:cancel${u}`;t.validatedIpcMain.once(c,()=>{v(!1)}),t.validatedIpcMain.once(n,()=>{v(!0)}),p.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:n,reason:P})})}onWillUnloadWindowInRenderer(p,P){return new Promise(v=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(c,()=>v()),p.send("vscode:onWillUnload",{replyChannel:c,reason:P})})}quit(p){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${p}`),p&&this.stateMainService.setItem(St.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(P=>{this.pendingQuitPromiseResolve=P,this.logService.trace("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.pendingQuitPromise)}async relaunch(p){this.logService.trace("Lifecycle#relaunch()");const P=process.argv.slice(1);if(p?.addArgs&&P.push(...p.addArgs),p?.removeArgs)for(const c of p.removeArgs){const n=P.indexOf(c);n>=0&&P.splice(n,1)}const v=()=>{try{if(b.isWindows){const c=(0,f.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:P})};S.app.once("quit",v),await this.quit(!0)&&S.app.removeListener("quit",v)}async kill(p){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,R.timeout)(1e3),(async()=>{for(const P of S.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let v;P.webContents&&!P.webContents.isDestroyed()?v=new Promise(u=>P.once("closed",u)):v=Promise.resolve(),P.destroy(),await v}})()]),S.app.exit(p)}};h.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",h=he([te(0,k.ILogService),te(1,C.IStateMainService)],h),e.LifecycleMainService=h}),define(Z[203],x([0,1,3,2,5,22]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let M=class extends t.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new S.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((I,k)=>{j(["native-keymap"],I,k)});this._keyboardLayoutData=b(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=he([te(0,L.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function b(f){const y=f.getKeyMap(),I=f.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:I}}}),define(Z[102],x([0,1,8,3,2,66,11,93,5]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var I;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var k;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(k=e.StorageScope||(e.StorageScope={}));var C;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));class m extends R.Disposable{constructor(p={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,P){P===y?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:P,target:this.getKeyTargets(p)[P]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,P,v){return this.getStorage(P)?.get(p,v)}getBoolean(p,P,v){return this.getStorage(P)?.getBoolean(p,v)}getNumber(p,P,v){return this.getStorage(P)?.getNumber(p,v)}store(p,P,v,u){if((0,M.isUndefinedOrNull)(P)){this.remove(p,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,v,u),this.getStorage(v)?.set(p,P)})}remove(p,P){this.withPausedEmitters(()=>{this.updateKeyTarget(p,P,void 0),this.getStorage(P)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,P){const v=[],u=this.getKeyTargets(p);for(const c of Object.keys(u))u[c]===P&&v.push(c);return v}updateKeyTarget(p,P,v){const u=this.getKeyTargets(P);typeof v=="number"?u[p]!==v&&(u[p]=v,this.getStorage(P)?.set(y,JSON.stringify(u))):typeof u[p]=="number"&&(delete u[p],this.getStorage(P)?.set(y,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const P=this.get(y,p);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=I.NONE){this._onWillSaveState.fire({reason:p});const P=this.getStorage(0),v=this.getStorage(1);switch(p){case I.NONE:await S.Promises.settled([P?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await S.Promises.settled([P?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return h(p,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class d extends m{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}e.InMemoryStorageService=d;async function h(w,p,P,v){const u=r=>{try{return JSON.parse(r)}catch{return r}},c=new Map,n=new Map;w.forEach((r,l)=>{c.set(l,r),n.set(l,u(r))});const s=new Map,i=new Map;p.forEach((r,l)=>{s.set(l,r),i.set(l,u(r))}),console.group(`Storage: Global (path: ${P})`);let o=[];c.forEach((r,l)=>{o.push({key:l,value:r})}),console.table(o),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${v})`);let a=[];s.forEach((r,l)=>{a.push({key:l,value:r})}),console.table(a),console.groupEnd(),console.log(i)}e.logStorage=h}),define(Z[204],x([0,1,4,35,7,31]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(y){if(S.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function b(y,I,k,C,m,d,h,w,p,P){const v=Object.create(null);v["common.machineId"]=h,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=m,v.version=d,v["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,S.PlatformToString)(S.platform),v["common.nodePlatform"]=t.platform,v["common.nodeArch"]=C,v["common.product"]=P||"desktop";const u=f(w||[]);u&&(v["common.msftInternal"]=u);let c=0;const n=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),S.isLinuxSnap&&(v["common.snap"]="true");const s=M(k);s&&(v["common.platformDetail"]=s);try{const i=await y.readFile(R.URI.file(p));v["common.source"]=i.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=b;function f(y){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const k=I.toLowerCase();return y.some(C=>k===C)}e.verifyMicrosoftInternalDomain=f}),define(Z[34],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[205],x([0,1,27,51,8,46,10,9,4,7,75,21,90,78,19,20,34]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function P(s,i){const o=`${s}::${i.join(":")}`,a=p.get(o);if(a)return a;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,g=new Map,E=2e4;function D(O,V,J,ne){const Y=V.substring(O.length+1);return R.Promises.withAsyncBody(async re=>{let ae;try{ae=await k.Promises.readdir(V,{withFileTypes:!0})}catch{re();return}if(ne.count>=E){ne.count+=ae.length,ne.maxReached=!0,re();return}let H=ae.length;if(H===0){re();return}let $=ae;ne.count+ae.length>E&&(ne.maxReached=!0,H=E-ne.count,$=ae.slice(0,H)),ne.count+=ae.length;for(const U of $)if(U.isDirectory()){if(J.includes(U.name)||await D(O,(0,b.join)(V,U.name),J,ne),--H==0){re();return}}else{const N=U.name.lastIndexOf(".");if(N>=0){const q=U.name.substring(N+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(Y)!==!1&&q.filePattern.test(U.name)&&g.set(q.tag,(g.get(q.tag)??0)+1);if(--H==0){re();return}}})}const W=R.Promises.withAsyncBody(async O=>{const V={count:0,maxReached:!1};await D(s,s,i,V);const J=await c(s);O({configFiles:v(g),fileTypes:v(l),fileCount:V.count,maxFilesReached:V.maxReached,launchConfigFiles:J})});return p.set(o,W),W}e.collectWorkspaceStats=P;function v(s){return[...t.Iterable.map(s.entries(),([i,o])=>({name:i,count:o}))].sort((i,o)=>o.count-i.count)}function u(){const s={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(s.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),s}e.getMachineInfo=u;async function c(s){try{const i=new Map,o=(0,b.join)(s,".vscode","launch.json"),a=await k.Promises.readFile(o),r=[],l=(0,L.parse)(a.toString(),r);if(r.length)return console.log(`Unable to parse ${o}`),[];if((0,L.getNodeType)(l)==="object"&&l.configurations)for(const g of l.configurations){const E=g.type;E&&(i.has(E)?i.set(E,i.get(E)+1):i.set(E,1))}return v(i)}catch{return[]}}e.collectLaunchConfigs=c;let n=class{constructor(i,o){this.telemetryService=i,this.productService=o}formatMachineInfo(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}formatEnvironment(i){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const a=S.cpus();return a&&a.length>0&&o.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),o.push(`Memory (System):  ${(S.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||o.push(`Load (avg):       ${S.loadavg().map(r=>Math.round(r)).join(", ")}`),o.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,C.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async a=>{let[r,l]=a,g=this.formatProcessList(i,r);return o.forEach(E=>{if((0,m.isRemoteDiagnosticError)(E))g+=`
${E.errorMessage}`,l+=`
${E.errorMessage}`;else if(g+=`

Remote: ${E.hostName}`,E.processes&&(g+=`
${this.formatProcessList(i,E.processes)}`),E.workspaceMetadata){l+=`
|  Remote: ${E.hostName}`;for(const D of Object.keys(E.workspaceMetadata)){const W=E.workspaceMetadata[D];let O=`${W.fileCount} files`;W.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${D}): ${O}`,l+=this.formatWorkspaceStats(W)}}}),{processInfo:g,workspaceInfo:l}})}async getSystemInfo(i,o){const{memory:a,vmHint:r,os:l,cpus:g}=u(),E={os:l,memory:a,cpus:g,vmHint:r,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return f.isWindows||(E.load=`${S.loadavg().map(D=>Math.round(D)).join(", ")}`),f.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(i,o){const a=[];return(0,C.listProcesses)(i.mainPID).then(async r=>(a.push(""),a.push(this.formatEnvironment(i)),a.push(""),a.push(this.formatProcessList(i,r)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(i))),o.forEach(l=>{if((0,m.isRemoteDiagnosticError)(l))a.push(`
${l.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${l.hostName}`),a.push(this.formatMachineInfo(l.machineInfo)),l.processes&&a.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const g of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[g];let D=`${E.fileCount} files`;E.maxFilesReached&&(D=`more than ${D}`),a.push(`Folder (${g}): ${D}`),a.push(this.formatWorkspaceStats(E))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(i){const o=[],a=60;let r=0;const l=(W,O)=>{const V=` ${W}(${O})`;r+V.length>a?(o.push(g),g="|                 ",r=g.length):r+=V.length,g+=V};let g="|      File types:";const E=10;let D=i.fileTypes.length>E?E:i.fileTypes.length;for(let W=0;W<D;W++){const O=i.fileTypes[W];l(O.name,O.count)}if(o.push(g),i.configFiles.length>=0&&(g="|      Conf files:",r=0,i.configFiles.forEach(W=>{l(W.name,W.count)}),o.push(g)),i.launchConfigFiles.length>0){let W="|      Launch Configs:";i.launchConfigFiles.forEach(O=>{W+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),o.push(W)}return o.join(`
`)}expandGPUFeatures(i){const o=Math.max(...Object.keys(i).map(a=>a.length));return Object.keys(i).map(a=>`${a}:  ${" ".repeat(o-a.length)}  ${i[a]}`).join(`
                  `)}formatWorkspaceMetadata(i){const o=[],a=[];return i.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(o.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const g=y.URI.revive(l);if(g.scheme===M.Schemas.file){const E=g.fsPath;a.push(P(E,["node_modules",".git"]).then(D=>{let W=`${D.fileCount} files`;D.maxFilesReached&&(W=`more than ${W}`),o.push(`|    Folder (${(0,b.basename)(E)}): ${W}`),o.push(this.formatWorkspaceStats(D))}).catch(D=>{o.push(`|      Error: Unable to collect workspace stats for folder ${E} (${D.toString()})`)}))}else o.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(r=>o.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(i,o){const a=new Map;i.windows.forEach(l=>a.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(i.mainPID,a,r,o,0),r.join(`
`)}formatProcessItem(i,o,a,r,l){const g=l===0;let E;g?E=r.pid===i?`${this.productService.applicationName} main`:"remote agent":(E=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(E=`${E} (${o.get(r.pid)})`));const D=process.platform==="win32"?r.mem:S.totalmem()*(r.mem/100);a.push(`${r.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(r.children)&&r.children.forEach(W=>this.formatProcessItem(i,o,a,W,l+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:a}of i.folders){const r=y.URI.revive(a);if(r.scheme!==M.Schemas.file)continue;const l=r.fsPath;try{(await P(l,["node_modules",".git"])).fileTypes.forEach(E=>o.add(E.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const a=y.URI.revive(o);if(a.scheme!==M.Schemas.file)continue;const r=a.fsPath;try{const l=await P(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),l.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),l.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};n=he([te(0,w.ITelemetryService),te(1,h.IProductService)],n),e.DiagnosticsService=n}),define(Z[206],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(L){this.appenders=L}listen(L,M){throw new Error(`Event not found: ${M}`)}call(L,M,{eventName:b,data:f}){return this.appenders.forEach(y=>y.log(b,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(L){this.channel=L}log(L,M){return this.channel.call("log",{eventName:L,data:M}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(Z[68],x([0,1,47,86,11,17,34]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(u,c){return Promise.resolve(void 0)}publicLog2(u,c){return this.publicLog(u,c)}publicLogError(u,c){return Promise.resolve(void 0)}publicLogError2(u,c){return this.publicLogError(u,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class f{async publicLog(u,c,n){}async publicLogError(u,c,n){}}e.NullEndpointTelemetryService=f,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(v,u){return u.onDidChangeConfiguration(c=>{c.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(c.source),configurationKeys:w(c.sourceConfig)})})}e.configurationTelemetry=y;function I(v,u){return!(u.disableTelemetry||!v.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=I;function k(v){const u=v.getValue(M.TELEMETRY_SETTING_ID),c=v.getValue("telemetry.enableCrashReporter");if(v.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=k;function C(v){const u=Object.create(null),c=Object.create(null),n=Object.create(null);h(v,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const i=n[s];typeof i=="number"?c[s]=i:typeof i=="boolean"?c[s]=i?1:0:typeof i=="string"?(i.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${i.length}`),u[s]=i.substring(0,8191)):typeof i!="undefined"&&i!==null&&(u[s]=i)}return{properties:u,measurements:c}}e.validateTelemetryData=C;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function d(v){if(!v)return"none";for(const u of m)if(v.startsWith(`${u}+`))return u;return"other"}e.cleanRemoteAuthority=d;function h(v,u,c=0,n){if(!!v)for(let s of Object.getOwnPropertyNames(v)){const i=v[s],o=n?n+s:s;Array.isArray(i)?u[o]=(0,S.safeStringify)(i):i instanceof Date?u[o]=i.toISOString():(0,R.isObject)(i)?c<2?h(i,u,c+1,o+"."):u[o]=(0,S.safeStringify)(i):u[o]=i}}function w(v){if(!v)return[];const u=[];return p(u,"",v),u}function p(v,u,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(n=>p(v,u?`${u}.${n}`:n,c[n])):v.push(u)}function P(v){return[v.appRoot,v.extensionsPath,v.userHome.fsPath,v.tmpDir.fsPath,v.userDataPath]}e.getPiiPathsFromEnvironment=P}),define(Z[207],x([0,1,171,68]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,M,b,f,y,I){const k={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${M.nameShort})`},C=await(0,S.getServiceMachineId)(b,y,I);return(0,t.supportsTelemetry)(M,b)&&(0,t.getTelemetryLevel)(f)===3&&(k["X-Market-User-Id"]=C),k}e.resolveMarketplaceHeaders=R}),define(Z[208],x([0,1,2,47,86,4,30,155,17,58,56,20,42,34,68]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(P,v,u){this._configurationService=v,this._productService=u,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=P.appenders,this._commonProperties=P.commonProperties||Promise.resolve({}),this._piiPaths=P.piiPaths||[],this._sendErrorTelemetry=!!P.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(P,v){this._experimentProperties[P]=v}_updateTelemetryLevel(){let P=(0,d.getTelemetryLevel)(this._configurationService);const v=this._productService.enabledTelemetryLevels;if(v){this._sendErrorTelemetry=this.sendErrorTelemetry?v.error:!1;const u=v.usage?3:v.error?2:0;P=Math.min(P,u)}this.telemetryLevel.value=P}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const P=await this._commonProperties;let v=P.sessionID,u=P["common.machineId"],c=P["common.firstSessionDate"],n=P["common.msftInternal"];return{sessionId:v,machineId:u,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(P,v,u,c){return this.telemetryLevel.value<v?Promise.resolve(void 0):this._commonProperties.then(n=>{u=(0,t.mixin)(u,n),u=(0,t.mixin)(u,this._experimentProperties),u=(0,t.cloneAndChange)(u,s=>{if(typeof s=="string")return this._cleanupInfo(s,c)}),this._appenders.forEach(s=>s.log(P,u))},n=>{console.error(n)})}publicLog(P,v,u){return this._log(P,3,v,u)}publicLog2(P,v,u){return this.publicLog(P,v,u)}publicLogError(P,v){return this._sendErrorTelemetry?this._log(P,2,v,!0):Promise.resolve(void 0)}publicLogError2(P,v){return this.publicLogError(P,v)}_anonymizeFilePaths(P){let v=P;const u=[];for(let i of this._cleanupPatterns)for(;;){const o=i.exec(P);if(!o)break;u.push([o.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(v="";;){const i=n.exec(P);if(!i)break;!c.test(i[0])&&u.every(([o,a])=>i.index<o||i.index>=a)&&(v+=P.substring(s,i.index)+"<REDACTED: user-file-path>",s=n.lastIndex)}return s<P.length&&(v+=P.substr(s)),v}_removePropertiesWithPossibleUserInfo(P){if(!P)return P;const v=P.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of u)if(c.regex.test(v))return`<REDACTED: ${c.label}>`;return P}_cleanupInfo(P,v){let u=P;v&&(u=this._anonymizeFilePaths(u));for(let c of this._cleanupPatterns)u=u.replace(c,"");return u=this._removePropertiesWithPossibleUserInfo(u),u}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=he([te(1,f.IConfigurationService),te(2,k.IProductService)],h),e.TelemetryService=h;function w(){const p=(0,b.localize)(0,null,I.default.nameLong),P=I.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=L.isWeb?"":(0,b.localize)(3,null),u=(0,b.localize)(4,null),c=(0,b.localize)(5,null),n=(0,b.localize)(6,null),s=(0,b.localize)(7,null),i=`
|       | ${u} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,b.localize)(8,null);return`
${p} ${P} ${v}

&nbsp;

${s}
${i}

&nbsp;

${o}
`}C.Registry.as(y.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(y.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,b.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,b.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[209],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(L){return L===S.HIGH_CONTRAST_DARK||L===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function R(L){return L===S.DARK||L===S.HIGH_CONTRAST_DARK}e.isDark=R}),define(Z[210],x([0,1,111,3,2,5,42,209]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var f;(function(w){function p(P){return P&&typeof P=="object"&&typeof P.id=="string"}w.isThemeColor=p})(f=e.ThemeColor||(e.ThemeColor={}));function y(w){return{id:w}}e.themeColorFromId=y;var I;(function(w){function p(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||f.isThemeColor(o.color))}w.isThemeIcon=p;const P=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function v(o){const a=P.exec(o);if(!a)return;let[,r]=a;return{id:r}}w.fromString=v;function u(o){return{id:o}}w.fromId=u;function c(o,a){let r=o.id;const l=r.lastIndexOf("~");return l!==-1&&(r=r.substring(0,l)),a&&(r=`${r}~${a}`),{id:r}}w.modify=c;function n(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}w.getModifier=n;function s(o,a){return o.id===a.id&&o.color?.id===a.color?.id}w.isEqual=s;function i(o,a){return{id:o.id,color:a?y(a):void 0}}w.asThemeIcon=i,w.asClassNameArray=S.CSSIcon.asClassNameArray,w.asClassName=S.CSSIcon.asClassName,w.asCSSSelector=S.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function k(w){switch(w){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,R.toDisposable)(()=>{const P=this.themingParticipants.indexOf(p);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new C;M.Registry.add(e.Extensions.ThemingContribution,m);function d(w){return m.onColorThemeChange(w)}e.registerThemingParticipant=d;class h extends R.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,P){let v=this.theme.getColor(p);return v&&P&&(v=P(v,this.theme)),v?v.toString():null}}e.Themable=h}),define(Z[60],x([0,1,13,3,2,4,17,5,48]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const y="#FFFFFF",I="#1E1E1E",k="#000000",C="#FFFFFF",m="theme",d="themeBackground",h="windowSplash";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let w=class extends R.Disposable{constructor(P,v){super();this.stateMainService=P,this.configurationService=v,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,S.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(L.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors!==S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const P=this.getColorScheme();if(P.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return P.dark?k:C;let v=this.stateMainService.getItem(d,null);if(!v)switch(this.stateMainService.getItem(m,"vs-dark").split(" ")[0]){case"vs":v=y;break;case"hc-black":v=k;break;case"hc-light":v=C;break;default:v=I}return L.isMacintosh&&v.toUpperCase()===I&&(v="#171717"),v}saveWindowSplash(P,v){this.stateMainService.setItems([{key:m,data:v.baseTheme},{key:d,data:v.colorInfo.background},{key:h,data:v}]),typeof P=="number"&&this.updateBackgroundColor(P,v)}updateBackgroundColor(P,v){for(const u of S.BrowserWindow.getAllWindows())if(u.id===P){u.setBackgroundColor(v.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(h)}};w=he([te(0,f.IStateMainService),te(1,M.IConfigurationService)],w),e.ThemeMainService=w}),define(Z[103],x([0,1,3,4,5,6]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var M;(function(d){d.Http="http",d.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function y(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=y,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=k;function C(d,h){return h?h!==1&&d<1024:!t.isWindows&&d<1024}e.isPortPrivileged=C;let m=class{constructor(h){this.logService=h,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],w=Array.from(this._tunnels.values());for(let p of w){const P=Array.from(p.values());for(let v of P){const u=await v.value;u&&h.push(u)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:w}of h.values())await w.then(p=>p?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,w,p,P,v=!1,u,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${p} on local port ${P}.`),!h)return;if(w||(w="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.retainOrCreateTunnel(h,w,p,P,v,u,c);return n?n.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==w||s.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const w=this._tunnels.get(h.tunnelRemoteHost);if(w){const p=w.get(h.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,p))}}}}async tryDisposeTunnel(h,w,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${w}.`);const P=p.value.then(async v=>{v&&(await v.dispose(!0),this._onTunnelClosed.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(w),P}}async closeTunnel(h,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${w} `);const p=this._tunnels.get(h);if(p&&p.has(w)){const P=p.get(w);P.refcount=0,await this.tryDisposeTunnel(h,w,P)}}addTunnelToMap(h,w,p){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(w,{refcount:1,value:p})}async removeEmptyTunnelFromMap(h,w){const p=this._tunnels.get(h);p&&(await p.get(w)||p.delete(w),p.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,w){let p=[h];I(h)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):k(h)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const P=p.map(v=>this._tunnels.get(v));for(const v of P){const u=v?.get(w);if(u)return u}}canTunnel(h){return!!y(h)}createWithProvider(h,w,p,P,v,u,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${p} on local port ${P}.`);const n=p;this._factoryInProgress.add(n);const i={elevationRequired:v?C(P===void 0?p:P):!1},o={remoteAddress:{host:w,port:p},localAddressPort:P,privacy:u,public:u?u!==b.Private:void 0,protocol:c},a=h.forwardPort(o,i);return a?(this.addTunnelToMap(w,p,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(n)})):this._factoryInProgress.delete(n),a}};m=he([te(0,L.ILogService)],m),e.AbstractTunnelService=m}),define(Z[43],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(t=e.StateType||(e.StateType={}));var R;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap"})(R=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(L,M)=>({type:"idle",updateType:L,error:M}),CheckingForUpdates:L=>({type:"checking for updates",explicit:L}),AvailableForDownload:L=>({type:"available for download",update:L}),Downloading:L=>({type:"downloading",update:L}),Downloaded:L=>({type:"downloaded",update:L}),Updating:L=>({type:"updating",update:L}),Ready:L=>({type:"ready",update:L})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(Z[211],x([0,1,4,156,58,42]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[212],x([0,1,3,43]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class R{constructor(b){this.service=b}listen(b,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(b,f,y){switch(f){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=R;class L{constructor(b){this.channel=b,this._onStateChange=new S.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=L}),define(Z[104],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(Z[213],x([0,1,7]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(b){this.handler=b}listen(b,f){throw new Error(`Event not found: ${f}`)}call(b,f,y){switch(f){case"handleURL":return this.handler.handleURL(S.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=t;class R{constructor(b){this.channel=b}handleURL(b,f){return this.channel.call("handleURL",[b.toJSON(),f])}}e.URLHandlerChannelClient=R;class L{constructor(b){this.next=b}async routeCall(b,f,y,I){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(y){const k=S.URI.revive(y);if(k&&k.query){const C=/\bwindowId=(\d+)/.exec(k.query);if(C){const m=C[1],d=new RegExp(`window:${m}`),h=b.connections.find(w=>d.test(w.ctx));if(h)return h}}}return this.next.routeCall(b,f,y,I)}routeEvent(b,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=L}),define(Z[214],x([0,1,8,2,7,20]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,I){const k=[...this.handlers.values()];return(0,S.first)(k.map(C=>()=>C.handleURL(y,I)),void 0,!1).then(C=>C||!1)}registerHandler(y){return this.handlers.add(y),(0,t.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=M;let b=class extends M{constructor(y){super();this.productService=y}create(y){let{authority:I,path:k,query:C,fragment:m}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&k&&k.indexOf("/")!==0&&(k=`/${k}`),R.URI.from({scheme:this.productService.urlProtocol,authority:I,path:k,query:C,fragment:m})}};b=he([te(0,L.IProductService)],b),e.NativeURLService=b}),define(Z[215],x([0,1,13,8,3,2,4,7]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(I){try{return b.URI.parse(I)}catch{return null}}class y{constructor(k,C,m,d,h){if(this.urlService=C,this.uris=[],this.retryCount=0,this.flushDisposable=L.Disposable.None,this.disposables=new L.DisposableStore,this.uris=k,M.isWindows){const P=d.isBuilt?[]:[`"${d.appRoot}"`];P.push("--open-url","--"),S.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,P)}const w=R.Event.map(R.Event.fromNodeEventEmitter(S.app,"open-url",(P,v)=>({event:P,url:v})),({event:P,url:v})=>(P.preventDefault(),v));this.disposables.add(w(P=>{const v=f(P);!v||this.urlService.open(v,{originalUrl:P})})),m.getWindows().filter(P=>P.isReady).length>0?this.flush():R.Event.once(m.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const k=[];for(const C of this.uris)await this.urlService.open(C.uri,{originalUrl:C.url})||k.push(C);k.length!==0&&(this.uris=k,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(Z[216],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(Z[217],x([0,1,13,2,10,7]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);S.protocol.registerFileProtocol(R.Schemas.vscodeWebview,f)}handleWebviewRequest(f,y){try{const I=L.URI.parse(f.url),k=M.validWebviewFilePaths.get(I.path);if(typeof k=="string"){const C=`vs/workbench/contrib/webview/browser/pre/${k}`,m=R.FileAccess.asFileUri(C,j);return y(decodeURIComponent(m.fsPath))}else return y({error:-10})}catch{}return y({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(Z[69],x([0,1,4]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function R(I){return!!I.folderUri}e.isFolderToOpen=R;function L(I){return!!I.fileUri}e.isFileToOpen=L;function M(I){const k=b(I),C=I.getValue("window.menuBarVisibility");return C==="default"||k==="native"&&C==="compact"||S.isMacintosh&&S.isNative?"classic":C}e.getMenuBarVisibility=M;function b(I){if(S.isWeb)return"custom";const k=I.getValue("window");if(k){if(S.isMacintosh&&k.nativeTabs===!0||S.isMacintosh&&k.nativeFullScreen===!1)return"native";const d=I.getValue("workbench.colorCustomizations");if(d?.["window.activeBorder"]||d?.["window.inactiveBorder"])return"custom";const h=k.titleBarStyle;if(h==="native"||h==="custom")return h}return S.isLinux?"native":"custom"}e.getTitleBarStyle=b;function f(I,k){return!S.isWindows||S.isWeb||!k.isBuilt||b(I)==="native"?!1:I.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=f;function y(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=y}),define(Z[105],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const R=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=R;var L;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(L=e.WindowMode||(e.WindowMode={}));var M;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.CRASHED=2]="CRASHED",b[b.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(Z[32],x([0,1,5]),function(j,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(R){R[R.CLI=0]="CLI",R[R.DOCK=1]="DOCK",R[R.MENU=2]="MENU",R[R.DIALOG=3]="DIALOG",R[R.DESKTOP=4]="DESKTOP",R[R.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(Z[218],x([0,1,13,23,3,73,2,31,64,95,6,20,32]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var m;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(m||(m={}));let d=class extends M.Disposable{constructor(w,p,P,v,u){super();this.logService=w,this.windowsMainService=p,this.credentialsService=P,this.encryptionMainService=v,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=m.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=R.Event.fromNodeEventEmitter(S.app,"login",(p,P,v,u,c)=>({event:p,webContents:P,req:v,authInfo:u,callback:c}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:p,req:P,callback:v}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===m.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}v(u?.username,u?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(w);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const p=String((0,L.hash)({scheme:w.scheme,host:w.host,port:w.port}));let P,v;try{const s=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(s){const i=JSON.parse(await this.encryptionMainService.decrypt(s));P=i.username,v=i.password}}catch(s){this.logService.error(s)}if(this.state!==m.StoredCredentialsUsed&&typeof P=="string"&&typeof v=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=m.StoredCredentialsUsed,{username:P,password:v};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:w,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??v,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=m.LoginDialogShown;const n=await new Promise(s=>{const i=async(o,a,r)=>{if(a===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",i),r){const l={username:r.username,password:r.password};try{if(r.remember){const g=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p,g)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(g){this.logService.error(g)}s({username:l.username,password:l.password})}else s(void 0)};u.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};d=he([te(0,I.ILogService),te(1,C.IWindowsMainService),te(2,f.ICredentialsMainService),te(3,y.IEncryptionMainService),te(4,k.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[219],x([0,1,64,6,55,20,32,182]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let f=class extends b.BaseCredentialsMainService{constructor(I,k,C,m){super(I);this.environmentMainService=k,this.productService=C,this.windowsMainService=m,this.surfaceKeytarLoadError=d=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new S.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((k,C)=>{j(["keytar"],k,C)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};f=he([te(0,t.ILogService),te(1,R.INativeEnvironmentService),te(2,L.IProductService),te(3,M.IWindowsMainService)],f),e.CredentialsNativeMainService=f}),define(Z[220],x([0,1,15,2,3,6,22,72,39,123,8,10,47,4,35,13,32]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const p=h.UtilityProcess,P=typeof p!="undefined";let v=class Dt{constructor(s,i,o){this._logService=s,this._windowsMainService=o,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(a=>{this._shutdown=!0,a.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(s){const i=this._extHosts.get(s);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(s){return this._getExtHost(s).onStdout}onDynamicStderr(s){return this._getExtHost(s).onStderr}onDynamicMessage(s){return this._getExtHost(s).onMessage}onDynamicError(s){return this._getExtHost(s).onError}onDynamicExit(s){return this._getExtHost(s).onExit}async canUseUtilityProcess(){return P}async createExtensionHost(s){if(this._shutdown)throw(0,S.canceled)();const i=String(++Dt._lastId);let o;if(s){if(!P)throw new Error("Cannot use UtilityProcess!");o=new c(i,this._logService,this._windowsMainService)}else o=new u(i,this._logService);return this._extHosts.set(i,o),o.onExit(({pid:a,code:r,signal:l})=>{this._logService.info(`Extension host with pid ${a} exited with code: ${r}, signal: ${l}.`),setTimeout(()=>{o.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(s,i){if(this._shutdown)throw(0,S.canceled)();return this._getExtHost(s).start(i)}async enableInspectPort(s){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(s);return i?i.enableInspectPort():!1}async kill(s){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(s);!i||i.kill()}async _killAllNow(){for(const[,s]of this._extHosts)s.kill()}async _waitForAllExit(s){const i=[];for(const[,o]of this._extHosts)i.push(o.waitForExit(s));return I.Promises.settled(i).then(()=>{})}};v._lastId=0,v=he([te(0,L.ILogService),te(1,M.ILifecycleMainService),te(2,w.IWindowsMainService)],v),e.ExtensionHostStarter=v;let u=class extends t.Disposable{constructor(s,i){super();this.id=s,this._logService=i,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(s){m.isCI&&this._logService.info("Calling fork to start extension host...");const i=b.StopWatch.create(!1);this._process=(0,f.fork)(k.FileAccess.asFileUri("bootstrap-fork",j).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,C.mixin)({cwd:(0,d.cwd)()},s));const o=i.elapsed(),a=this._process.pid;this._logService.info(`Starting extension host with pid ${a} (fork() took ${o} ms).`);const r=new y.StringDecoder("utf-8");this._process.stdout?.on("data",g=>{const E=typeof g=="string"?g:r.write(g);this._onStdout.fire(E)});const l=new y.StringDecoder("utf-8");this._process.stderr?.on("data",g=>{const E=typeof g=="string"?g:l.write(g);this._onStderr.fire(E)}),this._process.on("message",g=>{this._onMessage.fire(g)}),this._process.on("error",g=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(g)})}),this._process.on("exit",(g,E)=>{this._hasExited=!0,this._onExit.fire({pid:a,code:g,signal:E})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):m.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(s){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([R.Event.toPromise(this.onExit),(0,I.timeout)(s)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${s}ms.`),this._process.kill())}};u=he([te(1,L.ILogService)],u);let c=class extends t.Disposable{constructor(s,i,o){super();this.id=s,this._logService=i,this._windowsMainService=o,this.onStdout=R.Event.None,this.onStderr=R.Event.None,this.onError=R.Event.None,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(s){const i=this._windowsMainService.getWindowById(s.responseWindowId);if(!i){this._logService.info("Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...");return}const o=i.win;if(!o||o.isDestroyed()||o.webContents.isDestroyed()){this._logService.info("Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...");return}const a=`extensionHost${this.id}`,r=k.FileAccess.asFileUri("bootstrap-fork.js",j).fsPath,l=["--type=extensionHost","--skipWorkspaceStorageLock"],g=s.execArgv||[],E={...s.env};for(const V of Object.keys(E))E[V]=String(E[V]);this._logService.info("Creating new UtilityProcess to start extension host..."),this._process=new p(r,l,{serviceName:a,env:E,execArgv:g}),this._process.on("spawn",()=>{this._logService.info("Utility process emits spawn!")}),this._process.on("exit",V=>{this._logService.info("Utility process emits exit!"),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:V,signal:""})});const D=(V,J)=>{J.type==="Utility"&&J.name===a&&(this._logService.info("Utility process emits exit!"),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:J.exitCode,signal:""}))};h.app.on("child-process-gone",D),this._register((0,t.toDisposable)(()=>{h.app.off("child-process-gone",D)}));const{port1:W,port2:O}=new h.MessageChannelMain;this._process.postMessage("port",null,[O]),o.webContents.postMessage(s.responseChannel,s.responseNonce,[W])}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):m.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(s){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([R.Event.toPromise(this.onExit),(0,I.timeout)(s)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${s}ms.`),this._process.kill())}};c=he([te(1,L.ILogService),te(2,w.IWindowsMainService)],c)}),define(Z[221],x([0,1,13,3,2,217,32]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends R.Disposable{constructor(y){super();this.windowsMainService=y,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new L.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(y,I){let k;if(typeof y.windowId=="number"){const{windowId:C}=y,m=this.windowsMainService.getWindowById(C);if(!m?.win)throw new Error(`Invalid windowId: ${C}`);k=m.win.webContents}else{const{webContentsId:C}=y;if(k=S.webContents.fromId(C),!k)throw new Error(`Invalid webContentsId: ${C}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(I)}async findInFrame(y,I,k,C){const d=this.getFrameByName(y,I);if(typeof d.findInFrame=="function"){d.findInFrame(k,{findNext:C.findNext,forward:C.forward});const h=(w,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),d.removeListener("found-in-frame",h))};d.on("found-in-frame",h)}}async stopFindInFrame(y,I,k){const m=this.getFrameByName(y,I);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}getFrameByName(y,I){const k=this.windowsMainService.getWindowById(y.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${y}`);const C=k.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===I);if(!C)throw new Error(`Unknown frame: ${I}`);return C}};b=he([te(0,M.IWindowsMainService)],b),e.WebviewMainService=b}),define(Z[222],x([0,1,8,3,2]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:f,getActiveWindowId:y}){super();this.disposables=this._register(new R.DisposableStore),t.Event.latch(t.Event.any(b,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,S.createCancelablePromise)(()=>y()),(async()=>{try{const k=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:k}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(Z[26],x([0,1,159,9,36,16,7,5,10]),function(j,e,S,t,R,L,M,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function y(i){const o=i;return typeof o?.id=="string"&&M.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=y;function I(i){if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=I;function k(i){const o=i;return typeof o?.id=="string"&&M.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=k;function C(i){const o=i;if(o?.uri)return{id:o.id,uri:M.URI.revive(o.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:M.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=C;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function d(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=d;function h(i){const o=i;return!!(o&&typeof o=="object"&&M.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=h;class w{constructor(o,a,r,l,g){this._id=o,this._transient=r,this._configuration=l,this._ignorePathCasing=g,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=a}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class p{constructor(o,a){this.raw=a,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,L.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function P(i){return new p({uri:i,index:0,name:(0,L.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=P,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(i,o){return L.extUriBiasedIgnorePathCase.isEqualOrParent(i,o.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(i){let o;return M.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=c;function n(i,o){return!u(i,o)&&!c(i)}e.isSavedWorkspace=n;function s(i){return(typeof i=="string"?(0,t.extname)(i):(0,L.extname)(i))===v}e.hasWorkspaceFileExtension=s}),define(Z[50],x([0,1,13,8,73,33,2,74,4,11,21,141,5,6,26]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,C.createDecorator)("dialogMainService");let h=class{constructor(p){this.logService=p,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(p,P){return this.doPick({...p,pickFolders:!0,pickFiles:!0,title:(0,k.localize)(0,null)},P)}pickFolder(p,P){return this.doPick({...p,pickFolders:!0,title:(0,k.localize)(1,null)},P)}pickFile(p,P){return this.doPick({...p,pickFiles:!0,title:(0,k.localize)(2,null)},P)}pickWorkspace(p,P){const v=(0,k.localize)(3,null),u=(0,L.mnemonicButtonLabel)((0,k.localize)(4,null)),c=d.WORKSPACE_FILTER;return this.doPick({...p,pickFiles:!0,title:v,filters:c,buttonLabel:u},P)}async doPick(p,P){const v={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(v.properties=void 0,p.pickFiles&&p.pickFolders&&(v.properties=["multiSelections","openDirectory","openFile","createDirectory"])),v.properties||(v.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&v.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(v,(0,y.withNullAsUndefined)(P||S.BrowserWindow.getFocusedWindow()));if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}getWindowDialogQueue(p){if(p){let P=this.windowDialogQueues.get(p.id);return P||(P=new t.Queue,this.windowDialogQueues.set(p.id,P)),P}else return this.noWindowDialogueQueue}showMessageBox(p,P){return this.getWindowDialogQueue(P).queue(async()=>P?S.dialog.showMessageBox(P,p):S.dialog.showMessageBox(p))}async showSaveDialog(p,P){const v=this.acquireFileDialogLock(p,P);if(!v)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(P).queue(async()=>{let u;return P?u=await S.dialog.showSaveDialog(P,p):u=await S.dialog.showSaveDialog(p),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,M.dispose)(v)}}normalizePath(p){return p&&f.isMacintosh&&(p=(0,b.normalizeNFC)(p)),p}normalizePaths(p){return p.map(P=>this.normalizePath(P))}async showOpenDialog(p,P){p.defaultPath&&(await I.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const v=this.acquireFileDialogLock(p,P);if(!v)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(P).queue(async()=>{let u;return P?u=await S.dialog.showOpenDialog(P,p):u=await S.dialog.showOpenDialog(p),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,M.dispose)(v)}}acquireFileDialogLock(p,P){if(!P)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",p);let v=this.windowFileDialogLocks.get(P.id);v||(v=new Set,this.windowFileDialogLocks.set(P.id,v));const u=(0,R.hash)(p);if(!v.has(u))return this.logService.trace("[DialogMainService]: new file dialog lock created",p),v.add(u),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",p),v?.delete(u),v?.size===0&&this.windowFileDialogLocks.delete(P.id)})}};h=he([te(0,m.ILogService)],h),e.DialogMainService=h}),define(Z[223],x([0,1,3,2,26]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class L extends t.Disposable{constructor(b,f){super();this.logService=b,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new S.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(S.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(b,f)=>(b?b.push(f):b=[f],b),L.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(b))}))}serializeGlobalStorageEvents(b){const f=new Map,y=new Set;return b.forEach(I=>{const k=this.storageMainService.globalStorage.get(I.key);typeof k=="string"?f.set(I.key,k):y.add(I.key)}),{changed:Array.from(f.entries()),deleted:Array.from(y.values())}}listen(b,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(b,f,y){const I=(0,R.reviveIdentifier)(y.workspace),k=await this.withStorageInitialized(I);switch(f){case"getItems":return Array.from(k.items.entries());case"updateItems":{const C=y;if(C.insert)for(const[m,d]of C.insert)k.set(m,d);C.delete&&C.delete.forEach(m=>k.delete(m));break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(b){const f=b?this.storageMainService.workspaceStorage(b):this.storageMainService.globalStorage;try{await f.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${b?"workspace":"global"} storage due to ${y}`)}return f}}e.StorageDatabaseChannel=L,L.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[224],x([0,1,25,8,3,2,9,72,7,21,93,132,6,102,34,26]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends L.Disposable{constructor(c,n){super();this.logService=c,this.fileService=n,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new R.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const c=await this.doCreate();this._storage.dispose(),this._storage=c,this._register(c.onDidChangeStorage(s=>this._onDidChangeStorage.fire({key:s}))),await this.doInit(c);const n=c.getBoolean(m.IS_NEW_KEY);n===void 0?c.set(m.IS_NEW_KEY,!0):n&&c.set(m.IS_NEW_KEY,!1)}catch(c){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===C.LogLevel.Trace?c=>this.logService.trace(c):void 0,logError:c=>this.logService.error(c)}}doInit(c){return c.init()}get items(){return this._storage.items}get(c,n){return this._storage.get(c,n)}set(c,n){return this._storage.set(c,n)}delete(c){return this._storage.delete(c)}async close(){const c=new b.StopWatch(!1);await this.doClose(),c.stop(),c.elapsed()>w.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(c),this._onDidCloseStorage.fire()}async logSlowClose(c){if(!!this.path)try{const n=(0,S.top)(Array.from(this._storage.items.entries()).map(([i,o])=>({key:i,length:o.length})),(i,o)=>o.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),s=(await this.fileService.stat(f.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${s}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}w.LOG_SLOW_CLOSE_THRESHOLD=2e3;class p extends w{constructor(c,n,s,i){super(n,i);this.options=c,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.globalStorageHome.fsPath,p.STORAGE_NAME)}async doCreate(){return new I.Storage(new k.SQLiteStorageDatabase(this.path??k.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}async doInit(c){await super.doInit(c),this.updateTelemetryState(c)}updateTelemetryState(c){c.get(d.firstSessionDateStorageKey,void 0)===void 0&&c.set(d.firstSessionDateStorageKey,new Date().toUTCString());const s=c.get(d.currentSessionDateStorageKey,void 0),i=new Date().toUTCString();c.set(d.lastSessionDateStorageKey,typeof s=="undefined"?null:s),c.set(d.currentSessionDateStorageKey,i)}}e.GlobalStorageMain=p,p.STORAGE_NAME="state.vscdb";class P extends w{constructor(c,n,s,i,o){super(s,o);this.workspace=c,this.options=n,this.environmentService=i}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,P.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:c,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new k.SQLiteStorageDatabase(c,{logging:this.createLoggingOptions()}),{hint:n?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:k.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,M.join)(c,P.WORKSPACE_STORAGE_NAME);return await y.Promises.exists(c)?{storageFilePath:n,wasCreated:!1}:(await y.Promises.mkdir(c,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(c),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(c){let n;if((0,h.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,h.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const s=(0,M.join)(c,P.WORKSPACE_META_NAME);await y.Promises.exists(s)||await y.Promises.writeFile(s,JSON.stringify(n,void 0,2))}catch(s){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.WorkspaceStorageMain=P,P.WORKSPACE_STORAGE_NAME="state.vscdb",P.WORKSPACE_META_NAME="workspace.json";class v extends w{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=v}),define(Z[106],x([0,1,16,7,26]),function(j,e,S,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function L(f,y,I){for(const C of f){const m=C.openedWorkspace;if((0,R.isWorkspaceIdentifier)(m)){const d=I(m);if(d){if(d.folders.some(h=>S.extUriBiasedIgnorePathCase.isEqualOrParent(y,h.uri)))return C}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(y,m.configPath))return C}}const k=f.filter(C=>(0,R.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(y,C.openedWorkspace.uri));if(k.length)return k.sort((C,m)=>-(C.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=L;function M(f,y){for(const I of f)if((0,R.isWorkspaceIdentifier)(I.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,y)||(0,R.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,y))return I}e.findWindowOnWorkspaceOrFolder=M;function b(f,y){const I=k=>y.some(C=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(C),t.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(C=>I(C)))return k}e.findWindowOnExtensionDevelopmentPath=b}),define(Z[225],x([0,1,13,2,4,16,7,17,22,6,48,32,105,26]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class It extends t.Disposable{constructor(u,c,n,s,i){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=n,this.logService=s,this.configurationService=i,this._state=h(this.stateMainService.getItem(It.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){S.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.toWindowState(s))}const c=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const n=p(u);this.stateMainService.setItem(It.windowsStateStorageKey,n),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",n)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(n=>{const s=(0,m.isWorkspaceIdentifier)(u.openedWorkspace)&&n.workspace?.id===u.openedWorkspace.id,i=(0,m.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&n.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(n.folderUri,u.openedWorkspace.uri);(s||i)&&(n.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,m.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),n=this.configurationService.getValue("window");let s;return c.hasDefaultState?s=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),s&&R.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(s=!1)),c.mode===3&&!s&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=u.workspace;if((0,m.isWorkspaceIdentifier)(r)){const g=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===r.id).map(E=>E.uiState);if(g.length)return g[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(r)){const g=this.state.openedWindows.filter(E=>E.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(E.folderUri,r.uri)).map(E=>E.uiState);if(g.length)return g[0]}else if(u.backupPath){const g=this.state.openedWindows.filter(E=>E.backupPath===u.backupPath).map(E=>E.uiState);if(g.length)return g[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let n;const s=S.screen.getAllDisplays();if(s.length===1)n=s[0];else{if(R.isMacintosh){const r=S.screen.getCursorScreenPoint();n=S.screen.getDisplayNearestPoint(r)}!n&&c&&(n=S.screen.getDisplayMatching(c.getBounds())),n||(n=S.screen.getPrimaryDisplay()||s[0])}let i=(0,C.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const o=this.configurationService.getValue("window");let a=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&c){const r=c.serializeWindowState();r.mode===3?i.mode=3:i=r,a=i.mode!==3&&o.newWindowDimensions==="offset"}}return a&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===u.x||n.y===u.y);)u.x+=30,u.y+=30;return u}};d.windowsStateStorageKey="windowsState",d=he([te(0,k.IWindowsMainService),te(1,I.IStateMainService),te(2,f.ILifecycleMainService),te(3,y.ILogService),te(4,b.IConfigurationService)],d),e.WindowsStateHandler=d;function h(v){const u={openedWindows:[]},c=v||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=w(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=w(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(n=>w(n))),u}e.restoreWindowsState=h;function w(v){const u={uiState:v.uiState};return v.backupPath&&(u.backupPath=v.backupPath),v.remoteAuthority&&(u.remoteAuthority=v.remoteAuthority),v.folder&&(u.folderUri=M.URI.parse(v.folder)),v.workspaceIdentifier&&(u.workspace={id:v.workspaceIdentifier.id,configPath:M.URI.parse(v.workspaceIdentifier.configURIPath)}),u}function p(v){return{lastActiveWindow:v.lastActiveWindow&&P(v.lastActiveWindow),lastPluginDevelopmentHostWindow:v.lastPluginDevelopmentHostWindow&&P(v.lastPluginDevelopmentHostWindow),openedWindows:v.openedWindows.map(u=>P(u))}}e.getWindowsStateStoreData=p;function P(v){return{workspaceIdentifier:v.workspace&&{id:v.workspace.id,configURIPath:v.workspace.configPath.toString()},folder:v.folderUri&&v.folderUri.toString(),backupPath:v.backupPath,remoteAuthority:v.remoteAuthority,uiState:v.uiState}}}),define(Z[82],x([0,1,28,46,114,33,10,9,4,16,7,5,67,26]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,k.createDecorator)("workspacesService");function d(E){return E.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function h(E){return E.hasOwnProperty("folderUri")}e.isRecentFolder=h;function w(E){return E.hasOwnProperty("fileUri")}e.isRecentFile=w;function p(E){return P(E)||v(E)}e.isStoredWorkspaceFolder=p;function P(E){const D=E;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function v(E){const D=E;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function u(E,D,W,O,V=!f.isWindows,J){if(E.scheme!==O.scheme)return{name:W,uri:E.toString(!0)};let ne=D?void 0:J.relativePath(O,E);if(ne!==void 0)ne.length===0?ne=".":f.isWindows&&E.scheme===M.Schemas.file&&!V&&(ne=ne.replace(/\//g,"\\"));else if(E.scheme===M.Schemas.file)ne=E.fsPath,f.isWindows&&(ne=(0,L.normalizeDriveLetter)(ne),V&&(ne=(0,S.toSlashes)(ne)));else{if(!J.isEqualAuthority(E.authority,O.authority))return{name:W,uri:E.toString(!0)};ne=E.path}return{name:W,path:ne}}e.getStoredWorkspaceFolder=u;function c(E,D,W){let O=[],V=new Set;const J=W.dirname(D);for(let ne of E){let Y;if(P(ne))ne.path&&(Y=W.resolvePath(J,ne.path));else if(v(ne))try{Y=I.URI.parse(ne.uri),Y.path[0]!=="/"&&(Y=Y.with({path:"/"+Y.path}))}catch(re){console.warn(re)}if(Y){let re=W.getComparisonKey(Y);if(!V.has(re)){V.add(re);const ae=ne.name||W.basenameOrAuthority(Y);O.push(new m.WorkspaceFolder({uri:Y,name:ae,index:O.length},ne))}}}return O}e.toWorkspaceFolders=c;function n(E,D,W,O,V){let J=s(D,E);const ne=V.dirname(D),Y=V.dirname(O),re=[],ae=i(J.folders);for(const N of J.folders){const q=P(N)?V.resolvePath(ne,N.path):I.URI.parse(N.uri);let ee;W?ee=!1:ee=!P(N)||(0,b.isAbsolute)(N.path),re.push(u(q,ee,N.name,Y,ae,V))}const H={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},$=R.setProperty(E,["folders"],re,H);let U=R.applyEdits(E,$);return(0,y.isEqualAuthority)(J.remoteAuthority,(0,C.getRemoteAuthority)(O))&&(U=R.applyEdits(U,R.removeProperty(U,["remoteAuthority"],H))),U}e.rewriteWorkspaceFileForNewLocation=n;function s(E,D){let W=t.parse(D);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(O=>p(O));else throw new Error(`${E} looks like an invalid workspace file.`);return W}function i(E){return f.isWindows?E.some(D=>P(D)&&D.path.indexOf("/")>=0):!0}e.useSlashForPath=i;function o(E){return E.workspace&&typeof E.workspace=="object"&&typeof E.workspace.id=="string"&&typeof E.workspace.configPath=="string"}function a(E){return typeof E.folderUri=="string"}function r(E){return typeof E.fileUri=="string"}function l(E,D){const W={workspaces:[],files:[]};if(E){const O=function(J,ne){for(let Y=0;Y<J.length;Y++)try{ne(J[Y],Y)}catch(re){D.warn(`Error restoring recent entry ${JSON.stringify(J[Y])}: ${re.toString()}. Skip entry.`)}},V=E;Array.isArray(V.entries)&&O(V.entries,J=>{const ne=J.label,Y=J.remoteAuthority;o(J)?W.workspaces.push({label:ne,remoteAuthority:Y,workspace:{id:J.workspace.id,configPath:I.URI.parse(J.workspace.configPath)}}):a(J)?W.workspaces.push({label:ne,remoteAuthority:Y,folderUri:I.URI.parse(J.folderUri)}):r(J)&&W.files.push({label:ne,remoteAuthority:Y,fileUri:I.URI.parse(J.fileUri)})})}return W}e.restoreRecentlyOpened=l;function g(E){const D={entries:[]};for(const W of E.workspaces)h(W)?D.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):D.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of E.files)D.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return D}e.toStoreData=g}),define(Z[107],x([0,1,62,29,10,4,16]),function(j,e,S,t,R,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(y){function I(){let k=y.scheme===R.Schemas.file?(0,M.originalFSPath)(y):y.toString();return L.isLinux||(k=k.toLowerCase()),(0,S.createHash)("md5").update(k).digest("hex")}return{id:I(),configPath:y}}e.getWorkspaceIdentifier=b;function f(y,I){function k(){if(y.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(y.toString()).digest("hex");if(!I)try{I=(0,t.statSync)(y.fsPath)}catch{return}let m;return L.isLinux?m=I.ino:L.isMacintosh?m=I.birthtime.getTime():L.isWindows&&(typeof I.birthtimeMs=="number"?m=Math.floor(I.birthtimeMs):m=I.birthtime.getTime()),(0,S.createHash)("md5").update(y.fsPath).update(m?String(m):"").digest("hex")}const C=k();if(typeof C=="string")return{id:C,uri:y}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[226],x([0,1,37,8,250,2]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends S.AbstractPolicyService{constructor(f){super();this.productName=f,this.throttler=new t.Throttler,this.watcher=this._register(new L.MutableDisposable)}async initializePolicies(f){await this.throttler.queue(()=>new Promise((y,I)=>{try{this.watcher.value=(0,R.createWatcher)(this.productName,f,k=>{for(const C in k){const m=k[C];m===void 0?this.policies.delete(C):this.policies.set(C,m)}this._onDidChange.fire(Object.keys(k)),y()})}catch(k){I(k)}}))}}e.NativePolicyService=M}),define(Z[83],x([0,1,62,63,27,18,15,3,2,9,4,31,40,91,227]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(D,W=""){this.debugLabel=W,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,M.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(D,W){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(D){const W=O=>{this.traceSocketEvent("read",O),D(L.VSBuffer.wrap(O))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(D){const W=O=>{this.traceSocketEvent("close",{hadError:O}),D({type:0,hadError:O,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(D){const W=()=>{this.traceSocketEvent("nodeEndReceived"),D()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(D){if(!this.socket.destroyed)try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,M.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=h;var w;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var p;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(p||(p={}));class P extends f.Disposable{constructor(D,W,O,V){super();this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:O?.byteLength||0,recordInflateBytes:V}),this._flowManager=this._register(new v(this,W,O,V,this._onData,(J,ne)=>this._write(J,ne))),this._register(this._flowManager.onError(J=>{console.error(J),(0,M.onUnexpectedError)(J),this._onClose.fire({type:0,hadError:!0,error:J})})),this._incomingData=new m.ChunkStream,this._register(this.socket.onData(J=>this._acceptChunk(J))),this._register(this.socket.onClose(J=>this._onClose.fire(J)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(D,W){this.socket.traceSocketEvent(D,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this._onData.event(D)}onClose(D){return this._onClose.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){this._flowManager.writeMessage(D)}_write(D,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let O=2;D.byteLength<126?O+=0:D.byteLength<2**16?O+=2:O+=8;const V=L.VSBuffer.alloc(O);if(W?V.writeUInt8(194,0):V.writeUInt8(130,0),D.byteLength<126)V.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){V.writeUInt8(126,1);let J=1;V.writeUInt8(D.byteLength>>>8&255,++J),V.writeUInt8(D.byteLength>>>0&255,++J)}else{V.writeUInt8(127,1);let J=1;V.writeUInt8(0,++J),V.writeUInt8(0,++J),V.writeUInt8(0,++J),V.writeUInt8(0,++J),V.writeUInt8(D.byteLength>>>24&255,++J),V.writeUInt8(D.byteLength>>>16&255,++J),V.writeUInt8(D.byteLength>>>8&255,++J),V.writeUInt8(D.byteLength>>>0&255,++J)}this.socket.write(L.VSBuffer.concat([V,D]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(D){if(D.byteLength!==0){for(this._incomingData.acceptChunk(D);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),O=W.readUInt8(0),V=(O&128)>>>7,J=(O&64)>>>6,ne=W.readUInt8(1),Y=(ne&128)>>>7,re=ne&127;this._state.state=2,this._state.readLen=2+(Y?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=V,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(J)),this._state.firstFrameOfMessage=Boolean(V),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),O=W.readUInt8(1),V=(O&128)>>>7;let J=O&127,ne=1;J===126?J=W.readUInt8(++ne)*2**8+W.readUInt8(++ne):J===127&&(J=W.readUInt8(++ne)*0+W.readUInt8(++ne)*0+W.readUInt8(++ne)*0+W.readUInt8(++ne)*0+W.readUInt8(++ne)*2**24+W.readUInt8(++ne)*2**16+W.readUInt8(++ne)*2**8+W.readUInt8(++ne));let Y=0;V&&(Y=W.readUInt8(++ne)*2**24+W.readUInt8(++ne)*2**16+W.readUInt8(++ne)*2**8+W.readUInt8(++ne)),this._state.state=3,this._state.readLen=J,this._state.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),n(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class v extends f.Disposable{constructor(D,W,O,V,J,ne){super();this._tracer=D,this._onData=J,this._writeFn=ne,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new u(this._tracer,V,O,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Y=>this._onError.fire(Y))),this._register(this._zlibDeflateStream.onError(Y=>this._onError.fire(Y)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(D){this._writeQueue.push(D),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const D=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,D);this._writeFn(W,!0)}else this._writeFn(D,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(D,W){return new Promise((O,V)=>{D.write(W),D.flush(J=>O(J))})}acceptFrame(D,W,O){this._readQueue.push({data:D,isCompressed:W,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const D=this._readQueue.shift();if(this._zlibInflateStream&&D.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,D.data,D.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(D.data)}this._isProcessingReadQueue=!1}}_inflateFrame(D,W,O){return new Promise((V,J)=>{D.write(W),O&&D.write(L.VSBuffer.fromByteArray([0,0,255,255])),D.flush(ne=>V(ne))})}}class u extends f.Disposable{constructor(D,W,O,V){super();this._tracer=D,this._recordInflateBytes=W,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=d.createInflateRaw(V),this._zlibInflate.on("error",J=>{this._tracer.traceSocketEvent("zlibInflateError",{message:J?.message,code:J?.code}),this._onError.fire(J)}),this._zlibInflate.on("data",J=>{this._tracer.traceSocketEvent("zlibInflateData",J),this._pendingInflateData.push(L.VSBuffer.wrap(J))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(D){this._recordInflateBytes&&this._recordedInflateBytes.push(D.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",D),this._zlibInflate.write(D.buffer)}flush(D){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,D(W)})}}class c extends f.Disposable{constructor(D,W){super();this._tracer=D,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(L.VSBuffer.wrap(O))})}write(D){this._tracer.traceSocketEvent("zlibDeflateWrite",D.buffer),this._zlibDeflate.write(D.buffer)}flush(D){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),D(W)})}}function n(E,D){if(D===0)return;let W=E.byteLength>>>2;for(let re=0;re<W;re++){const ae=E.readUInt32BE(re*4);E.writeUInt32BE(ae^D,re*4)}let O=W*4,V=E.byteLength-O;const J=D>>>24&255,ne=D>>>16&255,Y=D>>>8&255;V>=1&&E.writeUInt8(E.readUInt8(O)^J,O),V>=2&&E.writeUInt8(E.readUInt8(O+1)^ne,O+1),V>=3&&E.writeUInt8(E.readUInt8(O+2)^Y,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function i(){const E=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;let D;return e.XDG_RUNTIME_DIR?D=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${E}.sock`):D=(0,y.join)((0,R.tmpdir)(),`vscode-ipc-${E}.sock`),a(D),D}e.createRandomIPCHandle=i;function o(E,D,W){const O=(0,S.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${W}-${D}-sock`;let V;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?V=(0,y.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${W}-${D}.sock`):V=(0,y.join)(E,`${W}-${D}.sock`),a(V),V}e.createStaticIPCHandle=o;function a(E){const D=s[I.platform];typeof D=="number"&&E.length>=D&&console.warn(`WARNING: IPC handle "${E}" is longer than ${D} chars, try a shorter --user-data-dir`)}class r extends C.IPCServer{constructor(D){super(r.toClientConnectionEvent(D));this.server=D}static toClientConnectionEvent(D){const W=b.Event.fromNodeEventEmitter(D,"connection");return b.Event.map(W,O=>({protocol:new m.Protocol(new h(O,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function l(E){return new Promise((D,W)=>{const O=(0,t.createServer)();O.on("error",W),O.listen(E,()=>{O.removeListener("error",W),D(new r(O))})})}e.serve=l;function g(E,D){return new Promise((W,O)=>{const V=(0,t.createConnection)(E,()=>{V.removeListener("error",O),W(m.Client.fromSocket(new h(V,`ipc-client${D}`),D))});V.once("error",O)})}e.connect=g}),define(Z[24],x([0,1,49,9,83,55,169,5]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(L.IEnvironmentService);class f extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,R.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([S.memoize],f.prototype,"cachedLanguagesPath",null),he([S.memoize],f.prototype,"backupHome",null),he([S.memoize],f.prototype,"backupWorkspacesPath",null),he([S.memoize],f.prototype,"mainIPCHandle",null),he([S.memoize],f.prototype,"mainLockfile",null),he([S.memoize],f.prototype,"sandbox",null),he([S.memoize],f.prototype,"disableUpdates",null),he([S.memoize],f.prototype,"disableKeytar",null),he([S.memoize],f.prototype,"codeCachePath",null),he([S.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[228],x([0,1,62,29,28,10,9,4,16,7,21,163,17,24,19,6,162,26]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let P=class{constructor(u,c,n){this.configurationService=c,this.logService=n,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,i)=>(0,R.isEqual)(s,i,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await I.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:y.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let n=[];try{Array.isArray(u.folderWorkspaceInfos)?n=u.folderWorkspaceInfos.map(s=>({folderUri:y.URI.parse(s.folderUri),remoteAuthority:s.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(n=u.folderURIWorkspaces.map(s=>({folderUri:y.URI.parse(s),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(n),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(s=>u.workspace.id===s.workspace.id)||(this.workspaces.push(u),this.saveSync());const n=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(n,c),n}moveBackupFolderSync(u,c){if(t.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),t.existsSync(c))try{t.renameSync(c,u)}catch(n){this.logService.error(`Backup: Could not move backup folder to new location: ${n.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,n=this.workspaces.findIndex(s=>s.workspace.id===c);n!==-1&&(this.workspaces.splice(n,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(n=>this.backupUriComparer.isEqual(u,n.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const n=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,n))||(this.emptyWindows.push({backupFolder:n,remoteAuthority:c}),this.saveSync()),this.getBackupPath(n)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,M.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,n=[];for(let s of u){const i=s.workspace;if(!(0,p.isWorkspaceIdentifier)(i))return[];if(!c.has(i.id)){c.add(i.id);const o=this.getBackupPath(i.id);await this.doHasBackups(o)?i.configPath.scheme!==L.Schemas.file||await I.Promises.exists(i.configPath.fsPath)?n.push(s):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return n}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],n=new Set;for(let s of u){const i=s.folderUri,o=this.backupUriComparer.getComparisonKey(i);if(!n.has(o)){n.add(o);const a=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(a)?i.scheme!==L.Schemas.file||await I.Promises.exists(i.fsPath)?c.push(s):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],n=new Set;for(let s of u){const i=s.backupFolder;if(typeof i!="string")return[];if(!n.has(i)){n.add(i);const o=this.getBackupPath(i);await this.doHasBackups(o)?c.push(s):await this.deleteStaleBackup(o)}}return c}async deleteStaleBackup(u){try{await I.Promises.exists(u)&&await I.Promises.rm(u,I.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));)c=this.getRandomEmptyWindowId();const n=this.getBackupPath(c);try{await I.Promises.rename(u,n)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));)c=this.getRandomEmptyWindowId();const n=this.getBackupPath(c);try{t.renameSync(u,n)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,k.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,w.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await I.Promises.readdir(u);for(const n of c)try{if((await I.Promises.readdir((0,M.join)(u,n))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,I.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await I.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let n;return c.scheme===L.Schemas.file?n=b.isLinux?c.fsPath:c.fsPath.toLowerCase():n=c.toString().toLowerCase(),(0,S.createHash)("md5").update(n).digest("hex")}};P=he([te(0,m.IEnvironmentMainService),te(1,C.IConfigurationService),te(2,h.ILogService)],P),e.BackupMainService=P}),define(Z[229],x([0,1,63,83]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,M,b,f,y){const I=C=>y(C,void 0),k=S.createConnection({host:R,port:L},()=>{k.removeListener("error",I);const C=Buffer.alloc(16);for(let w=0;w<16;w++)C[w]=Math.round(Math.random()*256);const m=C.toString("base64"),d=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}${M}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];k.write(d.join(`\r
`)+`\r
\r
`);const h=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(k.off("data",h),y(void 0,new t.NodeSocket(k,f)))};k.on("data",h)});k.setNoDelay(!0),k.once("error",I)}}}),define(Z[230],x([0,1,201,8,18,15,2,11,17,55,101,6,200,227]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends M.Disposable{constructor(w,p,P){super();this.environmentService=p,this.logService=P,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,p){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:P,strictSSL:v}=this;let u;try{u=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",s))}const c={...process.env,...u},n=w.agent?w.agent:await(0,C.getProxyAgent)(w.url||"",c,{proxyUrl:P,strictSSL:v});w.agent=n,w.strictSSL=v,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const s=await this._request(w,p);return this.logService.trace("RequestService#request (node) - success",w.url),s}catch(s){throw this.logService.trace("RequestService#request (node) - error",w.url,s),s}}async getNodeRequest(w){return((0,S.parse)(w.url).protocol==="https:"?await new Promise((v,u)=>{j(["https"],v,u)}):await new Promise((v,u)=>{j(["http"],v,u)})).request}_request(w,p){return t.Promises.withAsyncBody(async(P,v)=>{let u;const c=(0,S.parse)(w.url),n=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),s={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,b.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(s.auth=w.user+":"+w.password),u=n(s,i=>{const o=(0,b.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this._request({...w,url:i.headers.location,followRedirects:o-1},p).then(P,v);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,m.createGunzip)())),P({res:i,stream:(0,R.streamToBufferReadableStream)(a)})}}),u.on("error",v),w.timeout&&u.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&u.write(w.data),u.end(),p.onCancellationRequested(()=>{u.abort(),v((0,L.canceled)())})})}async resolveProxy(w){}};d=he([te(0,f.IConfigurationService),te(1,y.INativeEnvironmentService),te(2,k.ILogService)],d),e.RequestService=d}),define(Z[231],x([0,1,13,230]),function(j,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function R(M){return S.net.request}class L extends t.RequestService{request(b,f){return super.request({...b||{},getRawRequest:R},f)}}e.RequestMainService=L}),define(Z[232],x([0,1,13,38,8,3,2,10,11,92,24,22,6,56,57,60,41,37]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let P=class extends M.Disposable{constructor(u,c,n,s,i,o,a,r){super();this.machineId=u,this.userEnv=c,this.environmentMainService=n,this.lifecycleMainService=s,this.logService=i,this.policyService=o,this.themeMainService=a,this.protocolMainService=r,this.firstWindowConnectionBarrier=new R.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(u,c)=>this.onWindowConnection(u,c)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(u,c)=>this.onWorkerConnection(u,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(u,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const n=await this.connect();if(u.sender.isDestroyed())return n.close();u.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[n])}onWorkerConnection(u,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const n=new M.DisposableStore,s=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,c),n.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},i=S.BrowserWindow.fromId(c.reply.windowId);if(!i||i.isDestroyed()||i.webContents.isDestroyed()||!c.reply.channel){s("unavailable");return}n.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===i)(()=>s("load"))),n.add(L.Event.fromNodeEventEmitter(i,"closed")(()=>s("closed"))),i.webContents.postMessage(c.reply.channel,c.reply.nonce,u.ports)}onWillShutdown(){const u=this.window;!u||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(u.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{u.close()}catch{}this.window=void 0},0))}send(u,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${u}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(u,...c)}catch(n){this.logService.warn(`Error sending IPC message to channel '${u}' of shared process: ${(0,w.toErrorMessage)(n)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(u=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),u()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(u=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),u()}))})()),this._whenIpcReady}createWindow(){const u=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new S.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${u.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),u.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default,policiesData:this.policyService.serialize()}),this.window.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=u=>{this.logService.trace("SharedProcess#close prevented"),u.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(u,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(u,c,n)=>this._onDidError.fire({type:3,details:{reason:n,exitCode:c}})))}async connect(){await this.whenIpcReady;const u=(0,f.assertIsDefined)(this.window);return(0,y.connect)(u)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const u=this.window;return u?!u.isDestroyed()&&!u.webContents.isDestroyed():!1}};P=he([te(2,I.IEnvironmentMainService),te(3,k.ILifecycleMainService),te(4,C.ILogService),te(5,p.IPolicyService),te(6,h.IThemeMainService),te(7,d.IProtocolMainService)],P),e.SharedProcess=P}),define(Z[233],x([0,1,8,18,9,16,11,7,21,24,19,6]),function(j,e,S,t,R,L,M,b,f,y,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class C{constructor(h,w,p){this.storagePath=h,this.logService=w,this.fileService=p,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new S.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(h){h.fileOperationResult!==1&&this.logService.error(h)}}getItem(h,w){const p=this.storage[h];return(0,M.isUndefinedOrNull)(p)?w:p}setItem(h,w){this.setItems([{key:h,data:w}])}setItems(h){let w=!1;for(const{key:p,data:P}of h)this.storage[p]!==P&&((0,M.isUndefinedOrNull)(P)?(0,M.isUndefined)(this.storage[p])||(this.storage[p]=void 0,w=!0):(this.storage[p]=P,w=!0));w&&this.save()}removeItem(h){(0,M.isUndefined)(this.storage[h])||(this.storage[h]=void 0,this.save())}async save(h){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),h)}async doSave(){if(!this.initializing)return;await this.initializing;const h=JSON.stringify(this.storage,null,4);if(h!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(h)),this.lastSavedStorageContents=h}catch(w){this.logService.error(w)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=C;let m=class Pt{constructor(h,w,p){this.environmentMainService=h,this.logService=w,this.legacyStateFilePath=b.URI.file((0,R.join)(this.environmentMainService.userDataPath,Pt.STATE_FILE)),this.stateFilePath=(0,L.joinPath)(this.environmentMainService.globalStorageHome,Pt.STATE_FILE),this.fileStorage=new C(this.stateFilePath,w,p)}async init(){try{await f.Promises.move(this.legacyStateFilePath.fsPath,this.stateFilePath.fsPath)}catch(h){h.code!=="ENOENT"&&this.logService.error(h)}return this.fileStorage.init()}getItem(h,w){return this.fileStorage.getItem(h,w)}setItem(h,w){this.fileStorage.setItem(h,w)}setItems(h){this.fileStorage.setItems(h)}removeItem(h){this.fileStorage.removeItem(h)}close(){return this.fileStorage.close()}};m.STATE_FILE="storage.json",m=he([te(0,y.IEnvironmentMainService),te(1,k.ILogService),te(2,I.IFileService)],m),e.StateMainService=m}),define(Z[84],x([0,1,45,2,55,24,19,5,22,6,102,224]),function(j,e,S,t,R,L,M,b,f,y,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let C=class extends t.Disposable{constructor(h,w,p,P){super();this.logService=h,this.environmentService=w,this.lifecycleMainService=p,this.fileService=P,this.shutdownReason=void 0,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(h=>{h.workspace&&this.workspaceStorage(h.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(h=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=h.reason,h.join(this.globalStorage.close());for(const[,w]of this.mapWorkspaceToStorage)h.join(w.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const h=new k.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService,this.fileService);return(0,S.once)(h.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),h}workspaceStorage(h){let w=this.mapWorkspaceToStorage.get(h.id);return w||(this.logService.trace(`StorageMainService: creating workspace storage (${h.id})`),w=this.createWorkspaceStorage(h),this.mapWorkspaceToStorage.set(h.id,w),(0,S.once)(w.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${h.id})`),this.mapWorkspaceToStorage.delete(h.id)})),w}createWorkspaceStorage(h){return this.shutdownReason===2?new k.InMemoryStorageMain(this.logService,this.fileService):new k.WorkspaceStorageMain(h,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};C=he([te(0,y.ILogService),te(1,R.IEnvironmentService),te(2,f.ILifecycleMainService),te(3,M.IFileService)],C),e.StorageMainService=C,e.IGlobalStorageMainService=(0,b.createDecorator)("globalStorageMainService");let m=class extends I.AbstractStorageService{constructor(h,w){super();this.environmentMainService=h,this.storageMainService=w,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(h){switch(h){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(h){return h===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};m=he([te(0,L.IEnvironmentMainService),te(1,e.IStorageMainService)],m),e.GlobalStorageMainService=m}),define(Z[234],x([0,1,63,89,229,8,2,17,6,20,199,103,81]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function m(P,v,u,c,n){let s;for(let i=3;i&&(s&&s.dispose(),s=await new d(P,v,u,c,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));i--);return s}class d extends M.Disposable{constructor(v,u,c,n,s){super();this.defaultTunnelHost=u,this.suggestedLocalPort=s,this.privacy=k.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=v,this._server=S.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let v=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(v=0,this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(v){v.pause();const u=(0,k.isLocalhost)(this.tunnelRemoteHost)||(0,k.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),n=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&v.write(s.buffer),v.on("end",()=>{v.localAddress&&this._socketsDispose.delete(v.localAddress),n.end()}),v.on("close",()=>n.end()),v.on("error",()=>{v.localAddress&&this._socketsDispose.delete(v.localAddress),n.destroy()}),n.on("end",()=>v.end()),n.on("close",()=>v.end()),n.on("error",()=>{v.destroy()}),v.pipe(n),n.pipe(v),v.localAddress&&this._socketsDispose.set(v.localAddress,()=>{v.end(),n.end()})}}let h=class extends k.AbstractTunnelService{constructor(v,u,c,n,s){super(u);this.socketFactory=v,this.signService=c,this.productService=n,this.configurationService=s}get defaultTunnelHost(){const v=this.configurationService.getValue("remote.localPortHost");return!v||v==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(v,u,c,n,s,i,o){const a=this.getTunnelFromMap(u,c);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,n,s,i,o);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${n}.`);const r={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},l=m(r,this.defaultTunnelHost,u,c,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};h=he([te(1,f.ILogService),te(2,C.ISignService),te(3,y.IProductService),te(4,b.IConfigurationService)],h),e.BaseTunnelService=h;let w=class extends h{constructor(v,u,c,n){super(R.nodeSocketFactory,v,u,c,n)}};w=he([te(0,f.ILogService),te(1,C.ISignService),te(2,y.IProductService),te(3,b.IConfigurationService)],w),e.TunnelService=w;let p=class extends M.Disposable{constructor(v,u,c,n){super();this.logService=v,this.productService=u,this.signService=c,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(v,u,c,n,s,i,o,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${n} on local port ${s}.`),!this._tunnelServices.has(v)){const r=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(r),this._tunnelServices.set(v,r),r.onTunnelClosed(async()=>{(await r.tunnels).length===0&&(r.dispose(),this._tunnelServices.delete(v))})}return this._tunnelServices.get(v).openTunnel(u,c,n,s,i,o,a)}};p=he([te(0,f.ILogService),te(1,y.IProductService),te(2,C.ISignService),te(3,b.IConfigurationService)],p),e.SharedTunnelsService=p}),define(Z[85],x([0,1,8,23,3,17,24,22,6,20,59,43]),function(j,e,S,t,R,L,M,b,f,y,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function C(d,h,w){return`${w.updateUrl}/api/update/${d}/${h}/${w.commit}`}e.createUpdateURL=C;let m=class{constructor(h,w,p,P,v,u){this.lifecycleMainService=h,this.configurationService=w,this.environmentMainService=p,this.requestService=P,this.logService=v,this.productService=u,this._state=k.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),w=this.getProductQuality(h);if(!w){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(k.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getUpdateMode(){return(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,S.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}getUpdateType(){return 1}doQuitAndInstall(){}};m=he([te(0,b.ILifecycleMainService),te(1,L.IConfigurationService),te(2,M.IEnvironmentMainService),te(3,I.IRequestService),te(4,f.ILogService),te(5,y.IProductService)],m),e.AbstractUpdateService=m}),define(Z[235],x([0,1,13,49,3,2,17,24,22,6,20,59,34,43,85]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends d.AbstractUpdateService{constructor(p,P,v,u,c,n,s){super(p,P,u,c,n,s);this.telemetryService=v,this.disposables=new L.DisposableStore}get onRawError(){return R.Event.fromNodeEventEmitter(S.autoUpdater,"error",(p,P)=>P)}get onRawUpdateNotAvailable(){return R.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return R.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(p,P,v)=>({url:P,version:v,productVersion:v}))}get onRawUpdateDownloaded(){return R.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(p,P,v,u)=>({releaseNotes:P,version:v,productVersion:v,date:u}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const v=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(m.State.Idle(1,v))}buildUpdateFeedUrl(p){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const v=(0,d.createUpdateURL)(P,p,this.productService);try{S.autoUpdater.setFeedURL({url:v})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return v}doCheckForUpdates(p){this.setState(m.State.CheckingForUpdates(p)),S.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(m.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(m.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(m.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([t.memoize],h.prototype,"onRawError",null),he([t.memoize],h.prototype,"onRawUpdateNotAvailable",null),he([t.memoize],h.prototype,"onRawUpdateAvailable",null),he([t.memoize],h.prototype,"onRawUpdateDownloaded",null),h=he([te(0,f.ILifecycleMainService),te(1,M.IConfigurationService),te(2,C.ITelemetryService),te(3,b.IEnvironmentMainService),te(4,k.IRequestService),te(5,y.ILogService),te(6,I.IProductService)],h),e.DarwinUpdateService=h}),define(Z[236],x([0,1,39,29,8,3,9,24,22,6,34,43]),function(j,e,S,t,R,L,M,b,f,y,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let C=class{constructor(h,w,p){if(this.lifecycleMainService=h,this.logService=p,this._state=k.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(k.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,R.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};C=he([te(0,f.ILifecycleMainService),te(1,b.IEnvironmentMainService),te(2,y.ILogService)],C);let m=class extends C{constructor(h,w,p,P,v,u){super(p,P,v);this.snap=h,this.snapRevision=w,this.telemetryService=u;const c=(0,t.watch)(M.dirname(this.snap)),n=L.Event.fromNodeEventEmitter(c,"change",(a,r)=>r),s=L.Event.filter(n,a=>a==="current"),o=L.Event.debounce(s,(a,r)=>r,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{o.dispose(),c.close()})}doCheckForUpdates(){this.setState(k.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(k.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(k.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((p,P)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(v,u)=>v?P(v):p(u))),w=M.basename(h);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};m=he([te(2,f.ILifecycleMainService),te(3,b.IEnvironmentMainService),te(4,y.ILogService),te(5,I.ITelemetryService)],m),e.SnapUpdateService=m}),define(Z[44],x([0,1,13,29,3,46,33,2,10,9,4,16,11,21,161,54,50,24,5,6,20,106,26,82,107]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let o=class extends b.Disposable{constructor(r,l,g,E,D){super();this.environmentMainService=r,this.logService=l,this.backupMainService=g,this.dialogMainService=E,this.productService=D,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new R.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new R.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,l=>(0,t.readFileSync)(l,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,l=>m.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(r,l){if(!!this.isWorkspacePath(r)&&r.scheme===f.Schemas.file)try{const g=l(r.fsPath);return g instanceof Promise?g.then(E=>this.doResolveWorkspace(r,E),E=>{}):this.doResolveWorkspace(r,g)}catch{return}}isWorkspacePath(r){return(0,n.isUntitledWorkspace)(r,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,l){try{const g=this.doParseStoredWorkspace(r,l),E=(0,i.getWorkspaceIdentifier)(r);return{id:E.id,configPath:E.configPath,folders:(0,s.toWorkspaceFolders)(g.folders,E.configPath,k.extUriBiasedIgnorePathCase),remoteAuthority:g.remoteAuthority,transient:g.transient}}catch(g){this.logService.warn(g.toString())}}doParseStoredWorkspace(r,l){const g=(0,L.parse)(l);if(g&&Array.isArray(g.folders))g.folders=g.folders.filter(E=>(0,s.isStoredWorkspaceFolder)(E));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return g}async createUntitledWorkspace(r,l){const{workspace:g,storedWorkspace:E}=this.newUntitledWorkspace(r,l),D=g.configPath.fsPath;return await m.Promises.mkdir((0,y.dirname)(D),{recursive:!0}),await m.Promises.writeFile(D,JSON.stringify(E,null,"	")),g}createUntitledWorkspaceSync(r,l){const{workspace:g,storedWorkspace:E}=this.newUntitledWorkspace(r,l),D=g.configPath.fsPath;return(0,t.mkdirSync)((0,y.dirname)(D),{recursive:!0}),(0,m.writeFileSync)(D,JSON.stringify(E,null,"	")),g}newUntitledWorkspace(r=[],l){const g=(Date.now()+Math.round(Math.random()*1e3)).toString(),E=(0,k.joinPath)(this.untitledWorkspacesHome,g),D=(0,k.joinPath)(E,n.UNTITLED_WORKSPACE_NAME),W=[];for(const O of r)W.push((0,s.getStoredWorkspaceFolder)(O.uri,!0,O.name,E,!I.isWindows,k.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(D),storedWorkspace:{folders:W,remoteAuthority:l}}}async getWorkspaceIdentifier(r){return(0,i.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,n.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const l=(0,k.originalFSPath)(r.configPath);try{(0,m.rimrafSync)((0,y.dirname)(l));const g=(0,y.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,t.existsSync)(g)&&(0,m.writeFileSync)((0,y.join)(g,"obsolete"),"")}catch(g){this.logService.warn(`Unable to delete untitled workspace ${l} (${g}).`)}}getUntitledWorkspacesSync(){const r=[];try{const l=(0,m.readdirSync)(this.untitledWorkspacesHome.fsPath).map(g=>(0,k.joinPath)(this.untitledWorkspacesHome,g,n.UNTITLED_WORKSPACE_NAME));for(const g of l){const E=(0,i.getWorkspaceIdentifier)(g),D=this.resolveLocalWorkspaceSync(g);D?r.push({workspace:E,remoteAuthority:D.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(E)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return r}async enterWorkspace(r,l,g){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,l,g))return;const D=this.doEnterWorkspace(r,(0,i.getWorkspaceIdentifier)(g));if(!!D)return this._onDidEnterWorkspace.fire({window:r,workspace:D.workspace}),D}async isValidTargetWorkspacePath(r,l,g){if(!g)return!0;if((0,n.isWorkspaceIdentifier)(r.openedWorkspace)&&k.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,g))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,g)){const E={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,k.basename)(g)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(E,(0,C.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,l){if(!r.config)return;r.focus();let g;return r.config.extensionDevelopmentPath||(g=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,n.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=l,r.config.backupPath=g,{workspace:l,backupPath:g}}};o=he([te(0,p.IEnvironmentMainService),te(1,v.ILogService),te(2,h.IBackupMainService),te(3,w.IDialogMainService),te(4,u.IProductService)],o),e.WorkspacesManagementMainService=o}),define(Z[108],x([0,1,38,23,5,32,26,44]),function(j,e,S,t,R,L,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let f=class{constructor(I,k){this.windowsMainService=I,this.workspacesManagementMainService=k}async getRemoteDiagnostics(I){const k=this.windowsMainService.getWindows();return(await Promise.all(k.map(m=>new Promise(d=>{const h=m.remoteAuthority;if(h){const w=`vscode:getDiagnosticInfoResponse${m.id}`,p={includeProcesses:I.includeProcesses,folders:I.includeWorkspaceMetadata?this.getFolderURIs(m):void 0};m.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:w,args:p}),S.validatedIpcMain.once(w,(P,v)=>{v||d({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),d(v)}),setTimeout(()=>{d({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else d(void 0)})))).filter(m=>!!m)}getFolderURIs(I){const k=[],C=I.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(C))k.push(C.uri);else if((0,M.isWorkspaceIdentifier)(C)){const m=this.workspacesManagementMainService.resolveLocalWorkspaceSync(C.configPath);m&&m.folders.forEach(h=>{k.push(h.uri)})}return k}};f=he([te(0,L.IWindowsMainService),te(1,b.IWorkspacesManagementMainService)],f),e.DiagnosticsMainService=f}),define(Z[109],x([0,1,13,25,4,11,7,21,17,53,5,6,104,32,26,44]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let w=class{constructor(P,v,u,c,n){this.logService=P,this.windowsMainService=v,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=n}async start(P,v){this.logService.trace("Received data from other instance: ",P,v),R.isMacintosh&&S.app.focus({steal:!0});const u=this.parseOpenUrl(P);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:n,url:s}of u)this.urlService.open(n,{originalUrl:s})})}else return this.startOpenWindow(P,v)}parseOpenUrl(P){return P["open-url"]&&P._urls&&P._urls.length>0?(0,t.coalesce)(P._urls.map(v=>{try{return{uri:M.URI.parse(v),url:v}}catch{return null}})):[]}async startOpenWindow(P,v){const u=(0,y.isLaunchedFromCli)(v)?0:4;let c=[];const n=P.wait&&P.waitMarkerFilePath?M.URI.file(P.waitMarkerFilePath):void 0,s=P.remote||void 0,i={context:u,cli:P,userEnv:v,waitMarkerFileURI:n,remoteAuthority:s};if(P.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(P.extensionDevelopmentPath,i);else if(!P._.length&&!P["folder-uri"]&&!P["file-uri"]){let o=!1;if(P["new-window"]||P["unity-launch"])o=!0;else if(P["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!R.isMacintosh}if(o)c=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const a=this.windowsMainService.getLastActiveWindow();a?(this.windowsMainService.openExistingWindow(a,i),c=[a]):c=this.windowsMainService.open({...i,forceEmpty:!0})}}else c=this.windowsMainService.open({...i,forceNewWindow:P["new-window"],preferNewWindow:!P["reuse-window"]&&!P.wait,forceReuseWindow:P["reuse-window"],diffMode:P.diff,addMode:P.add,noRecentEntry:!!P["skip-add-to-recently-opened"],gotoLineMode:P.goto});if(n&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,b.whenDeleted)(n.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const P=[];return S.BrowserWindow.getAllWindows().forEach(v=>{const u=this.windowsMainService.getWindowById(v.id);u?P.push(this.codeWindowToInfo(u)):P.push(this.browserWindowToInfo(v))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:P,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}getFolderURIs(P){const v=[],u=P.openedWorkspace;if((0,d.isSingleFolderWorkspaceIdentifier)(u))v.push(u.uri);else if((0,d.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(s=>{v.push(s.uri)})}return v}codeWindowToInfo(P){const v=this.getFolderURIs(P),u=(0,L.assertIsDefined)(P.win);return this.browserWindowToInfo(u,v,P.remoteAuthority)}browserWindowToInfo(P,v=[],u){return{pid:P.webContents.getOSProcessId(),title:P.getTitle(),folderURIs:v,remoteAuthority:u}}};w=he([te(0,k.ILogService),te(1,m.IWindowsMainService),te(2,C.IURLService),te(3,h.IWorkspacesManagementMainService),te(4,f.IConfigurationService)],w),e.LaunchMainService=w}),define(Z[61],x([0,1,39,13,27,125,49,3,33,2,10,9,4,7,88,75,21,89,152,50,24,5,22,6,20,60,32,26,44]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n,s,i,o,a,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let g=class extends y.Disposable{constructor(D,W,O,V,J,ne,Y,re,ae){super();this.sharedProcess=D,this.windowsMainService=W,this.dialogMainService=O,this.lifecycleMainService=V,this.environmentMainService=J,this.logService=ne,this.productService=Y,this.themeMainService=re,this.workspacesManagementMainService=ae,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,H=>H.id),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(H,$)=>$.id),H=>!!this.windowsMainService.getWindowById(H)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(H,$)=>$.id),H=>!!this.windowsMainService.getWindowById(H)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(H,$)=>$.id),H=>!!this.windowsMainService.getWindowById(H)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),H=>!!H),H=>H.id),b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(H,$)=>$.id),H=>!!this.windowsMainService.getWindowById(H))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(H,$,U)=>U),H=>!(Array.isArray(H)&&H.length===1&&H[0]==="workArea")),b.Event.fromNodeEventEmitter(t.screen,"display-added"),b.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(D){return this.windowsMainService.getWindowCount()}async getActiveWindowId(D){const W=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(D,W,O){return Array.isArray(W)?this.doOpenWindow(D,W,O):this.doOpenEmptyWindow(D,W)}async doOpenWindow(D,W,O=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:D,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:O.forceNewWindow,forceReuseWindow:O.forceReuseWindow,preferNewWindow:O.preferNewWindow,diffMode:O.diffMode,addMode:O.addMode,gotoLineMode:O.gotoLineMode,noRecentEntry:O.noRecentEntry,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:O.remoteAuthority||void 0})}async doOpenEmptyWindow(D,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:D},W)}async toggleFullScreen(D){const W=this.windowById(D);W&&W.toggleFullScreen()}async handleTitleDoubleClick(D){const W=this.windowById(D);W&&W.handleTitleDoubleClick()}async isMaximized(D){const W=this.windowById(D);return W?.win?W.win.isMaximized():!1}async maximizeWindow(D){const W=this.windowById(D);W?.win&&W.win.maximize()}async unmaximizeWindow(D){const W=this.windowById(D);W?.win&&W.win.unmaximize()}async minimizeWindow(D){const W=this.windowById(D);W?.win&&W.win.minimize()}async updateTitleBarOverlay(D,W,O){const V=this.windowById(D);V?.win&&V.win.setTitleBarOverlay({color:W,symbolColor:O})}async focusWindow(D,W){W&&typeof W.windowId=="number"&&(D=W.windowId);const O=this.windowById(D);O&&O.focus({force:W?.force??!1})}async setMinimumSize(D,W,O){const V=this.windowById(D);if(V?.win){const[J,ne]=V.win.getSize(),[Y,re]=V.win.getMinimumSize(),[ae,H]=[W??Y,O??re],[$,U]=[Math.max(J,ae),Math.max(ne,H)];(Y!==ae||re!==H)&&V.win.setMinimumSize(ae,H),(J!==$||ne!==U)&&V.win.setSize($,U)}}async saveWindowSplash(D,W){this.themeMainService.saveWindowSplash(D,W)}async installShellCommand(D){const{source:W,target:O}=await this.getShellCommandLink();try{const{symbolicLink:V}=await w.SymlinkSupport.stat(W);if(V&&!V.dangling){const J=await(0,d.realpath)(W);if(O===J)return}await w.Promises.unlink(W)}catch(V){if(V.code!=="ENOENT")throw V}try{await w.Promises.symlink(O,W)}catch(V){if(V.code!=="EACCES"&&V.code!=="ENOENT")throw V;const{response:J}=await this.showMessageBox(D,{title:this.productService.nameLong,type:"info",message:(0,P.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,P.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,P.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(J===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${O}' '${W}'\\" with administrator privileges"`;await(0,L.promisify)(S.exec)(ne)}catch{throw new Error((0,P.localize)(3,null,W))}}}async uninstallShellCommand(D){const{source:W}=await this.getShellCommandLink();try{await w.Promises.unlink(W)}catch(O){switch(O.code){case"EACCES":{const{response:V}=await this.showMessageBox(D,{title:this.productService.nameLong,type:"info",message:(0,P.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,P.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,P.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(V===0)try{const J=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,L.promisify)(S.exec)(J)}catch{throw new Error((0,P.localize)(7,null,W))}break}case"ENOENT":break;default:throw O}}}async getShellCommandLink(){const D=(0,k.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(D))throw new Error((0,P.localize)(8,null,D));return{source:W,target:D}}async showMessageBox(D,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(D))}async showSaveDialog(D,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(D))}async showOpenDialog(D,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(D))}toBrowserWindow(D){const W=this.windowById(D);if(W?.win)return W.win}async pickFileFolderAndOpen(D,W){const O=await this.dialogMainService.pickFileFolder(W);O&&this.doOpenPicked(await Promise.all(O.map(async V=>await w.SymlinkSupport.existsDirectory(V)?{folderUri:m.URI.file(V)}:{fileUri:m.URI.file(V)})),W,D)}async pickFolderAndOpen(D,W){const O=await this.dialogMainService.pickFolder(W);O&&this.doOpenPicked(O.map(V=>({folderUri:m.URI.file(V)})),W,D)}async pickFileAndOpen(D,W){const O=await this.dialogMainService.pickFile(W);O&&this.doOpenPicked(O.map(V=>({fileUri:m.URI.file(V)})),W,D)}async pickWorkspaceAndOpen(D,W){const O=await this.dialogMainService.pickWorkspace(W);O&&this.doOpenPicked(O.map(V=>({workspaceUri:m.URI.file(V)})),W,D)}doOpenPicked(D,W,O){this.windowsMainService.open({context:3,contextWindowId:O,cli:this.environmentMainService.args,urisToOpen:D,forceNewWindow:W.forceNewWindow})}async showItemInFolder(D,W){t.shell.showItemInFolder(W)}async setRepresentedFilename(D,W){const O=this.windowById(D);O&&O.setRepresentedFilename(W)}async setDocumentEdited(D,W){const O=this.windowById(D);O&&O.setDocumentEdited(W)}async openExternal(D,W){return C.isLinuxSnap?this.safeSnapOpenExternal(W):t.shell.openExternal(W),!0}safeSnapOpenExternal(D){const W=process.env.GDK_PIXBUF_MODULE_FILE,O=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(D),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=O}moveItemToTrash(D,W){return t.shell.trashItem(W)}async isAdmin(){let D;return C.isWindows?D=(await new Promise((W,O)=>{j(["native-is-elevated"],W,O)}))():D=process.getuid()===0,D}async writeElevated(D,W,O,V){const J=await new Promise((ne,Y)=>{j(["@vscode/sudo-prompt"],ne,Y)});return new Promise((ne,Y)=>{const re=[`"${this.cliPath}"`];V?.unlock&&re.push("--file-chmod"),re.push("--file-write",`"${W.fsPath}"`,`"${O.fsPath}"`);const ae={name:this.productService.nameLong.replace("-",""),icns:C.isMacintosh&&this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};J.exec(re.join(" "),ae,(H,$,U)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),H?Y(H):ne(void 0)})})}get cliPath(){return C.isWindows?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):C.isLinux?this.environmentMainService.isBuilt?(0,k.join)((0,k.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,k.join)(this.environmentMainService.appRoot,"bin","code"):(0,k.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(D,W,O){process.kill(W,O)}async readClipboardText(D,W){return t.clipboard.readText(W)}async writeClipboardText(D,W,O){return t.clipboard.writeText(W,O)}async readClipboardFindText(D){return t.clipboard.readFindText()}async writeClipboardFindText(D,W){return t.clipboard.writeFindText(W)}async writeClipboardBuffer(D,W,O,V){return t.clipboard.writeBuffer(W,Buffer.from(O),V)}async readClipboardBuffer(D,W){return t.clipboard.readBuffer(W)}async hasClipboard(D,W,O){return t.clipboard.has(W,O)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(D,W){const O=this.windowById(D);O&&O.updateTouchBar(W)}async notifyReady(D){const W=this.windowById(D);W&&W.setReady()}async relaunch(D,W){return this.lifecycleMainService.relaunch(W)}async reload(D,W){const O=this.windowById(D);if(O){if((0,r.isWorkspaceIdentifier)(O.openedWorkspace)){const V=O.openedWorkspace.configPath;if(V.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(V))?.transient)return this.openWindow(O.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(O,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(D){this.closeWindowById(D,D)}async closeWindowById(D,W){const O=this.windowById(W);if(O?.win)return O.win.close()}async quit(D){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(D,W){await this.lifecycleMainService.kill(W)}async resolveProxy(D,W){const V=this.windowById(D)?.win?.webContents?.session;if(V)return V.resolveProxy(W)}findFreePort(D,W,O,V,J=1){return(0,p.findFreePort)(W,O,V,J)}async openDevTools(D,W){const O=this.windowById(D);O?.win&&O.win.webContents.openDevTools(W)}async toggleDevTools(D){const W=this.windowById(D);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(D,W){const O=this.windowById(D);O?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&O.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(D,W,O,V){if(!C.isWindows)return;const J=await new Promise((ne,Y)=>{j(["@vscode/windows-registry"],ne,Y)});try{return J.GetStringRegKey(W,O,V)}catch{return}}windowById(D){if(typeof D=="number")return this.windowsMainService.getWindowById(D)}};he([M.memoize],g.prototype,"cliPath",null),g=he([te(1,a.IWindowsMainService),te(2,v.IDialogMainService),te(3,n.ILifecycleMainService),te(4,u.IEnvironmentMainService),te(5,s.ILogService),te(6,i.IProductService),te(7,o.IThemeMainService),te(8,l.IWorkspacesManagementMainService)],g),e.NativeHostMainService=g}),define(Z[237],x([0,1,13,38,27,33,2,10,4,90,150,78,108,50,24,5,109,6,61,56,20,57,69]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,h.createDecorator)("issueMainService");let s=class Rt{constructor(o,a,r,l,g,E,D,W,O,V){this.userEnv=o,this.environmentMainService=a,this.launchMainService=r,this.logService=l,this.diagnosticsService=g,this.diagnosticsMainService=E,this.dialogMainService=D,this.nativeHostMainService=W,this.protocolMainService=O,this.productService=V,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async o=>{const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(a,r);this.safeSend(o,"vscode:issueSystemInfoResponse",l)}),t.validatedIpcMain.on("vscode:listProcesses",async o=>{const a=[];try{const r=await this.launchMainService.getMainProcessId();a.push({name:(0,I.localize)(0,null),rootProcess:await(0,y.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(g=>{(0,k.isRemoteDiagnosticError)(g)?a.push({name:g.hostName,rootProcess:g}):g.processes&&a.push({name:g.hostName,rootProcess:g.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(o,"vscode:listProcessesResponse",a)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async o=>{const a={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,L.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(a,this.issueReporterWindow);this.safeSend(o,"vscode:issueReporterClipboardResponse",r.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async o=>{const a=await this.getPerformanceInfo();this.safeSend(o,"vscode:issuePerformanceInfoResponse",a)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const o={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,L.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(o,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(o,a)=>{const{id:r,from:l,args:g}=a;let E;switch(l){case"issueReporter":E=this.issueReporterParentWindow;break;case"processExplorer":E=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}E&&E.webContents.send("vscode:runAction",{id:r,from:l,args:g})}),t.validatedIpcMain.on("vscode:openExternal",(o,a)=>{this.nativeHostMainService.openExternal(void 0,a)}),t.validatedIpcMain.on("vscode:closeIssueReporter",o=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",o=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async o=>{const a=await this.launchMainService.getMainProcessInfo();this.safeSend(o,"vscode:windowsInfoResponse",a.windows)})}safeSend(o,a,...r){o.sender.isDestroyed()||o.sender.send(a,...r)}async openReporter(o){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const a=new M.DisposableStore,r=a.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,r,{backgroundColor:o.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:o,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:v.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,a.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,a.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(o){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const a=new M.DisposableStore,r=a.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,r,{backgroundColor:o.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:o.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:o,product:v.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,a.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,a.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(o){o.isMinimized()&&o.restore(),o.focus()}createBrowserWindow(o,a,r,l){const g=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:r.title,backgroundColor:r.backgroundColor||Rt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`,`--vscode-window-kind=${l}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,n.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop,experimentalDarkMode:!0});return g.setMenuBarVisibility(!1),g}async getSystemStatus(){const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(o,a)}getWindowPosition(o,a,r){let l;const g=S.screen.getAllDisplays();if(g.length===1)l=g[0];else{if(f.isMacintosh){const W=S.screen.getCursorScreenPoint();l=S.screen.getDisplayNearestPoint(W)}!l&&o&&(l=S.screen.getDisplayMatching(o.getBounds())),l||(l=S.screen.getPrimaryDisplay()||g[0])}const E={width:a,height:r},D=l.bounds;return E.x=D.x+D.width/2-E.width/2,E.y=D.y+D.height/2-E.height/2,D.width>0&&D.height>0&&(E.x<D.x&&(E.x=D.x),E.y<D.y&&(E.y=D.y),E.x>D.x+D.width&&(E.x=D.x),E.y>D.y+D.height&&(E.y=D.y),E.width>D.width&&(E.width=D.width),E.height>D.height&&(E.height=D.height)),E}async getPerformanceInfo(){try{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(o,a)}catch(o){throw this.logService.warn("issueService#getPerformanceInfo ",o.message),o}}};s.DEFAULT_BACKGROUND_COLOR="#1E1E1E",s=he([te(1,d.IEnvironmentMainService),te(2,w.ILaunchMainService),te(3,p.ILogService),te(4,k.IDiagnosticsService),te(5,C.IDiagnosticsMainService),te(6,m.IDialogMainService),te(7,P.INativeHostMainService),te(8,c.IProtocolMainService),te(9,u.IProductService)],s),e.IssueMainService=s}),define(Z[238],x([0,1,23,17,24,22,6,61,20,59,34,43,85]),function(j,e,S,t,R,L,M,b,f,y,I,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let m=class extends C.AbstractUpdateService{constructor(h,w,p,P,v,u,c,n){super(h,w,P,v,u,n);this.telemetryService=p,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,C.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(k.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},S.CancellationToken.None).then(y.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(k.State.Idle(1))):this.setState(k.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const p=h?w.message||w:void 0;this.setState(k.State.Idle(1,p))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(k.State.Idle(1))}};m=he([te(0,L.ILifecycleMainService),te(1,t.IConfigurationService),te(2,I.ITelemetryService),te(3,R.IEnvironmentMainService),te(4,y.IRequestService),te(5,M.ILogService),te(6,b.INativeHostMainService),te(7,f.IProductService)],m),e.LinuxUpdateService=m}),define(Z[239],x([0,1,39,29,27,8,23,49,9,7,121,21,17,24,19,22,6,61,20,59,34,43,85]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(r,l=1e3){for(;!r();)await(0,L.timeout)(l)}let i;function o(){return typeof i=="undefined"&&(i=t.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),i}let a=class extends n.AbstractUpdateService{constructor(l,g,E,D,W,O,V,J,ne){super(l,g,D,W,O,ne);this.telemetryService=E,this.fileService=V,this.nativeHostMainService=J}get cachePath(){const l=f.join((0,R.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return k.Promises.mkdir(l,{recursive:!0}).then(()=>l)}buildUpdateFeedUrl(l){let g="win32";return process.arch!=="ia32"&&(g+=`-${process.arch}`),o()===1?g+="-archive":this.productService.target==="user"&&(g+="-user"),(0,n.createUpdateURL)(g,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},M.CancellationToken.None).then(v.asJson).then(g=>{const E=o();return!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(E)),Promise.resolve(null)):E===1?(this.setState(c.State.AvailableForDownload(g)),Promise.resolve(null)):(this.setState(c.State.Downloading(g)),this.cleanup(g.version).then(()=>this.getUpdatePackagePath(g.version).then(D=>k.Promises.exists(D).then(W=>{if(W)return Promise.resolve(D);const O=g.url,V=g.hash,J=`${D}.tmp`;return this.requestService.request({url:O},M.CancellationToken.None).then(ne=>this.fileService.writeFile(y.URI.file(J),ne.stream)).then(V?()=>(0,I.checksum)(J,g.hash):()=>{}).then(()=>k.Promises.rename(J,D)).then(()=>D)})).then(D=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:D},W&&g.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(g)):this.setState(c.State.Ready(g))})))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const E=l?g.message||g:void 0;this.setState(c.State.Idle(o(),E))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(o()))}async getUpdatePackagePath(l){const g=await this.cachePath;return f.join(g,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const g=l?O=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(O):()=>!0,E=await this.cachePath,W=(await k.Promises.readdir(E)).filter(g).map(async O=>{try{await k.Promises.unlink(f.join(E,O))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const g=await this.cachePath;this.availableUpdate.updateFilePath=f.join(g,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await k.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(o()))});const D=`${this.productService.win32MutexName}-ready`,W=await new Promise((O,V)=>{j(["windows-mutex"],O,V)});s(()=>W.isActive(D)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};he([b.memoize],a.prototype,"cachePath",null),a=he([te(0,h.ILifecycleMainService),te(1,C.IConfigurationService),te(2,u.ITelemetryService),te(3,m.IEnvironmentMainService),te(4,v.IRequestService),te(5,w.ILogService),te(6,d.IFileService),te(7,p.INativeHostMainService),te(8,P.IProductService)],a),e.Win32UpdateService=a}),define(Z[240],x([0,1,13,8,23,41,3,33,2,10,9,66,4,7,157,54,17,50,24,53,19,22,6,20,57,207,84,34,210,60,69,32,26,44,105,112,37]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n,s,i,o,a,r,l,g,E,D,W,O,V,J,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.NAVIGATING=1]="NAVIGATING",ae[ae.READY=2]="READY"})(Y||(Y={}));let re=class extends f.Disposable{constructor(H,$,U,N,q,ee,Q,X,T,A,_,z,F,B,K,ie,oe){super();this.logService=$,this.environmentMainService=U,this.policyService=N,this.fileService=q,this.globalStorageMainService=ee,this.storageMainService=Q,this.configurationService=X,this.themeMainService=T,this.workspacesManagementMainService=A,this.backupMainService=_,this.telemetryService=z,this.dialogMainService=F,this.lifecycleMainService=B,this.productService=K,this.protocolMainService=ie,this.windowsMainService=oe,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ue,fe]=this.restoreWindowState(H.state);this.windowState=ue,this.logService.trace("window#ctor: using window state",ue);const Ie=this.windowState.mode===0||this.windowState.mode===3,be=this.configurationService.getValue("window"),le={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:E.WindowMinimumSize.WIDTH,minHeight:E.WindowMinimumSize.HEIGHT,show:!Ie,title:this.productService.nameLong,webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,E.zoomLevelToZoomFactor)(be?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};C.isLinux?le.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):C.isWindows&&!this.environmentMainService.isBuilt&&(le.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),C.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1),C.isMacintosh&&(le.acceptFirstMouse=!0,be?.clickThroughInactive===!1&&(le.acceptFirstMouse=!1));const de=C.isMacintosh&&be?.nativeTabs===!0;de&&(le.tabbingIdentifier=this.productService.nameShort);const Ce=(0,E.getTitleBarStyle)(this.configurationService)==="custom";if(Ce&&(le.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,C.isMacintosh||(le.frame=!1),(0,E.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const me=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Se=J.Color.fromHex(me).isDarker()?"#FFFFFF":"#000000";le.titleBarOverlay={height:29,color:me,symbolColor:Se}}if((0,k.mark)("code/willCreateCodeBrowserWindow"),this._win=new S.BrowserWindow(le),(0,k.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),C.isMacintosh&&Ce&&this._win.setSheetOffset(22),C.isMacintosh&&fe&&(!de||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(me=>typeof me=="number")){const me=this.windowState;this._win.setBounds({width:me.width,height:me.height,x:me.x,y:me.y})}Ie&&((0,k.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),(!this._win.isVisible()||C.isMacintosh&&!this._win.isFocused())&&this._win.show(),(0,k.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(H){C.isMacintosh?this._win.setRepresentedFilename(H):this.representedFilename=H}getRepresentedFilename(){return C.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(H){C.isMacintosh&&this._win.setDocumentEdited(H),this.documentEdited=H}isDocumentEdited(){return C.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(H){C.isMacintosh&&H?.force&&S.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(H=>{if(this.isReady)return H(this);this.whenReadyCallbacks.push(H)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(H=>{function $(){U.dispose(),N.dispose(),H()}const U=this.onDidClose(()=>$()),N=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,U)=>this.onWindowError(2,U)),this._win.webContents.on("did-fail-load",($,U,N)=>this.onWindowError(3,{reason:N,exitCode:U})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this._config&&(this._config.maximized=!0),S.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this._config&&(this._config.maximized=!1),S.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",R.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",R.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async($,U)=>{const N=await this.getMarketplaceHeaders();U({cancel:!1,requestHeaders:Object.assign($.requestHeaders,N)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,o.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(H,$){switch(H){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${$?.reason||"<unknown>"}, code: ${$?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${$?.reason||"<unknown>"}, code: ${$?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:H,reason:$?.reason,code:$?.exitCode}),H){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(H===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,d.localize)(5,null):void 0},this._win);if(U.response!==1){const N=U.response===0;this.destroyWindow(N,U.checkboxChecked)}}else if(H===2){let U;$?U=(0,d.localize)(7,null,$.reason,$.exitCode??"<unknown>"):U=(0,d.localize)(6,null);const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,b.mnemonicButtonLabel)((0,d.localize)(9,null))],message:U,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,d.localize)(11,null):void 0},this._win),q=N.response===0;this.destroyWindow(q,N.checkboxChecked)}break}}async destroyWindow(H,$){const U=this._config?.workspace;if($&&U)try{const N=this.storageMainService.workspaceStorage(U);await N.init(),N.delete("memento/workbench.parts.editor"),await N.close()}catch(N){this.logService.error(N)}if(this._onDidDestroy.fire(),this._win?.destroy(),H&&this._config){let N,q;(0,W.isSingleFolderWorkspaceIdentifier)(U)?N={folderUri:U.uri}:(0,W.isWorkspaceIdentifier)(U)?N={workspaceUri:U.configPath}:q=!0;const[ee]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:N?[N]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});ee.focus()}}onDidDeleteUntitledWorkspace(H){this._config?.workspace?.id===H.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;$?.endsWith("/")&&($=$.substr(0,$.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=U;const N=$||"",q=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${q}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:q,pacScript:""})}}addTabbedWindow(H){C.isMacintosh&&H.win&&this._win.addTabbedWindow(H.win)}load(H,$=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(H,$),this.readyState===0?this._config=H:this.pendingLoadConfig=H,this.readyState=1,this._win.loadURL(y.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:H.workspace,reason:$.isReload?3:U?2:1})}updateConfiguration(H,$){const U=(this._config??this.pendingLoadConfig)?.userEnv;if(U){const N=(0,v.isLaunchedFromCli)(U)&&!(0,v.isLaunchedFromCli)(H.userEnv),q=this.isExtensionDevelopmentHost;(N||q)&&(H.userEnv={...U,...H.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(H.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(H["disable-extensions"]=$.disableExtensions),H.fullscreen=this.isFullScreen,H.maximized=this._win.isMaximized(),H.partsSplash=this.themeMainService.getWindowSplash(),(0,k.mark)("code/willOpenNewWindow"),H.perfMarks=(0,k.getMarks)(),this.configObjectUrl.update(H)}async reload(H){const $=Object.assign({},this._config);$.workspace=await this.validateWorkspaceBeforeReload($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToWait,this.isExtensionDevelopmentHost&&H&&($.verbose=H.verbose,$.debugId=H.debugId,$.extensionEnvironment=H.extensionEnvironment,$["inspect-extensions"]=H["inspect-extensions"],$["inspect-brk-extensions"]=H["inspect-brk-extensions"],$["extensions-dir"]=H["extensions-dir"]),$.isInitialStartup=!1,$.policiesData=this.policyService.serialize(),this.load($,{isReload:!0,disableExtensions:H?.["disable-extensions"]})}async validateWorkspaceBeforeReload(H){if((0,W.isWorkspaceIdentifier)(H.workspace)){const $=H.workspace.configPath;if($.scheme===y.Schemas.file&&!await this.fileService.exists($))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(H.workspace)){const $=H.workspace.uri;if($.scheme===y.Schemas.file&&!await this.fileService.exists($))return}return H.workspace}serializeWindowState(){if(!this._win)return(0,V.defaultWindowState)();if(this.isFullScreen){let U;try{U=S.screen.getDisplayMatching(this.getBounds())}catch{}const N=(0,V.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||N.width,height:this.windowState.height||N.height,x:this.windowState.x||0,y:this.windowState.y||0}}const H=Object.create(null);let $;if(!C.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?H.mode=0:H.mode=1,$===1||$===0){let U;$===1?U=this.getBounds():U=this._win.getNormalBounds(),H.x=U.x,H.y=U.y,H.width=U.width,H.height=U.height}return H}restoreWindowState(H){(0,k.mark)("code/willRestoreCodeWindowState");let $=!1;if(H)try{const U=S.screen.getAllDisplays();$=U.length>1,H=this.validateWindowState(H,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,k.mark)("code/didRestoreCodeWindowState"),[H||(0,V.defaultWindowState)(),$]}validateWindowState(H,$){if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,H),typeof H.x!="number"||typeof H.y!="number"||typeof H.width!="number"||typeof H.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(H.width<=0||H.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const q=this.getWorkingArea($[0]);if(q){let ee=function(){!H||typeof H.x!="number"||typeof H.y!="number"||!q||(H.x<q.x&&(H.x=q.x),H.y<q.y&&(H.y=q.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",q),ee(),H.width>q.width&&(H.width=q.width),H.height>q.height&&(H.height=q.height),H.x>q.x+q.width-128&&(H.x=q.x+q.width-H.width),H.y>q.y+q.height-128&&(H.y=q.y+q.height-H.height),ee()}return H}if(H.display&&H.mode===3){const q=$.find(ee=>ee.id===H.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const ee=(0,V.defaultWindowState)(3);return ee.x=q.bounds.x,ee.y=q.bounds.y,ee}}let U,N;try{U=S.screen.getDisplayMatching({x:H.x,y:H.y,width:H.width,height:H.height}),N=this.getWorkingArea(U)}catch{}if(U&&N&&H.x+H.width>N.x&&H.y+H.height>N.y&&H.x<N.x+N.width&&H.y<N.y+N.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",N),H}getWorkingArea(H){if(H.workArea.width>0&&H.workArea.height>0)return H.workArea;if(H.bounds.width>0&&H.bounds.height>0)return H.bounds}getBounds(){const[H,$]=this._win.getPosition(),[U,N]=this._win.getSize();return{x:H,y:$,width:U,height:N}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(H){this.useNativeFullScreen()?this.setNativeFullScreen(H):this.setSimpleFullScreen(H),this.sendWhenReady(H?"vscode:enterFullScreen":"vscode:leaveFullScreen",R.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(H){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(H)}setSimpleFullScreen(H){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(H),this._win.webContents.focus()}useNativeFullScreen(){const H=this.configurationService.getValue("window");return!H||typeof H.nativeFullScreen!="boolean"||H.nativeTabs?!0:H.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let H=(0,E.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(H)<0&&(H="classic"),H}setMenuBarVisibility(H,$=!0){C.isMacintosh||(H==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,d.localize)(12,null)),H==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(H)}):this.doSetMenuBarVisibility(H))}doSetMenuBarVisibility(H){const $=this.isFullScreen;switch(H){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(C.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(H,$,...U){this.isReady?this.send(H,...U):this.ready().then(()=>{$.isCancellationRequested||this.send(H,...U)})}send(H,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${H}' for window that is destroyed`);return}try{this._win.webContents.send(H,...$)}catch(U){this.logService.warn(`Error sending IPC message to channel '${H}' of window ${this._id}: ${(0,L.toErrorMessage)(U)}`)}}}updateTouchBar(H){!C.isMacintosh||this.touchBarGroups.forEach(($,U)=>{const N=H[U];$.segments=this.createTouchBarGroupSegments(N)})}createTouchBar(){if(!!C.isMacintosh){for(let H=0;H<10;H++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(H=[]){const $=this.createTouchBarGroupSegments(H),U=new S.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",R.CancellationToken.None,{id:U.segments[N].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(H=[]){return H.map(U=>{let N;U.icon&&!l.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===y.Schemas.file&&(N=S.nativeImage.createFromPath(m.URI.revive(U.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let q;return typeof U.title=="string"?q=U.title:q=U.title.value,{id:U.id,label:N?void 0:q,icon:N}})}dispose(){super.dispose(),this._win=null}};re=he([te(1,n.ILogService),te(2,P.IEnvironmentMainService),te(3,ne.IPolicyService),te(4,u.IFileService),te(5,a.IGlobalStorageMainService),te(6,a.IStorageMainService),te(7,w.IConfigurationService),te(8,g.IThemeMainService),te(9,O.IWorkspacesManagementMainService),te(10,h.IBackupMainService),te(11,r.ITelemetryService),te(12,p.IDialogMainService),te(13,c.ILifecycleMainService),te(14,s.IProductService),te(15,i.IProtocolMainService),te(16,D.IWindowsMainService)],re),e.CodeWindow=re}),define(Z[70],x([0,1,13,25,8,3,33,2,10,4,16,7,21,160,5,22,6,84,82,26,44]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let c=class Ze extends b.Disposable{constructor(s,i,o,a){super();this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=o,this.globalStorageMainService=a,this._onDidChangeRecentlyOpened=this._register(new L.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new R.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){const i=[],o=[];for(let a of s)if((0,P.isRecentWorkspace)(a))!this.workspacesManagementMainService.isUntitledWorkspace(a.workspace)&&this.indexOfWorkspace(i,a.workspace)===-1&&i.push(a);else if((0,P.isRecentFolder)(a))this.indexOfFolder(i,a.folderUri)===-1&&i.push(a);else{const r=this.indexOfFile(o,a.fileUri)>=0,l=a.fileUri.scheme===f.Schemas.file&&Ze.COMMON_FILES_FILTER.indexOf((0,I.basename)(a.fileUri))>=0;!r&&!l&&(o.push(a),y.isWindows&&a.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(a.fileUri.fsPath))}await this.addEntriesFromStorage(i,o),i.length>Ze.MAX_TOTAL_RECENT_ENTRIES&&(i.length=Ze.MAX_TOTAL_RECENT_ENTRIES),o.length>Ze.MAX_TOTAL_RECENT_ENTRIES&&(o.length=Ze.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:o}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(s){const i=l=>{const g=this.location(l);for(const E of s)if(I.extUriBiasedIgnorePathCase.isEqual(E,g))return!1;return!0},o=await this.getRecentlyOpened(),a=o.workspaces.filter(i),r=o.files.filter(i);(a.length!==o.workspaces.length||r.length!==o.files.length)&&(await this.saveRecentlyOpened({files:r,workspaces:a}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(s){const i=[],o=[];if(s){const r=s.config?.workspace;(0,v.isWorkspaceIdentifier)(r)&&!this.workspacesManagementMainService.isUntitledWorkspace(r)?i.push({workspace:r,remoteAuthority:s.remoteAuthority}):(0,v.isSingleFolderWorkspaceIdentifier)(r)&&i.push({folderUri:r.uri,remoteAuthority:s.remoteAuthority})}const a=s?.config?.filesToOpenOrCreate;if(a)for(let r of a){const l=r.fileUri;l&&this.indexOfFile(o,l)===-1&&o.push({fileUri:l})}return await this.addEntriesFromStorage(i,o),{workspaces:i,files:o}}async addEntriesFromStorage(s,i){let o=await this.getRecentlyOpenedFromStorage();for(let a of o.workspaces){let r=(0,P.isRecentFolder)(a)?this.indexOfFolder(s,a.folderUri):this.indexOfWorkspace(s,a.workspace);r>=0?s[r].label=s[r].label||a.label:s.push(a)}for(let a of o.files){let r=this.indexOfFile(i,a.fileUri);r>=0?i[r].label=i[r].label||a.label:i.push(a)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let s;const i=this.globalStorageMainService.get(Ze.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{s=JSON.parse(i)}catch(o){this.logService.error("Unexpected error parsing opened paths list",o)}return(0,P.restoreRecentlyOpened)(s,this.logService)}async saveRecentlyOpened(s){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(Ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,P.toStoreData)(s)),0,1)}location(s){return(0,P.isRecentFolder)(s)?s.folderUri:(0,P.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,i){return s.findIndex(o=>(0,P.isRecentWorkspace)(o)&&o.workspace.id===i.id)}indexOfFolder(s,i){return s.findIndex(o=>(0,P.isRecentFolder)(o)&&I.extUriBiasedIgnorePathCase.isEqual(o.folderUri,i))}indexOfFile(s,i){return s.findIndex(o=>I.extUriBiasedIgnorePathCase.isEqual(o.fileUri,i))}async handleWindowsJumpList(){!y.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!y.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let r of S.app.getJumpListSettings().removedItems){const l=r.args;if(l){const g=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);g&&i.push(k.URI.parse(g[2]))}}await this.removeRecentlyOpened(i);let o=!1;const a=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,Ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(r=>{const l=(0,P.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:g,description:E}=this.getWindowsJumpListLabel(l,r.label);let D;return k.URI.isUri(l)?D=`--folder-uri "${l.toString()}"`:(o=!0,D=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:g.substr(0,255),description:E.substr(0,255),program:process.execPath,args:D,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&s.push({type:"custom",name:o?(0,m.localize)(2,null):(0,m.localize)(3,null),items:a})}s.push({type:"recent"});try{S.app.setJumpList(s)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(s,i){if(i)return{title:(0,M.splitName)(i).name,description:i};if(k.URI.isUri(s))return{title:(0,I.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,m.localize)(4,null),description:""};let o=(0,I.basename)(s.configPath);return o.endsWith(v.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-v.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,o),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,M.normalizeDriveLetter)(s.fsPath):s.toString()}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;S.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),i=[];let o=0;for(let r=0;r<s.workspaces.length&&o<Ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;r++){const l=this.location(s.workspaces[r]);if(l.scheme===f.Schemas.file){const g=(0,I.originalFSPath)(l);await C.Promises.exists(g)&&(i.push(g),o++)}}const a=[];for(let r=0;r<s.files.length&&o<Ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;r++){const l=this.location(s.files[r]);if(l.scheme===f.Schemas.file){const g=(0,I.originalFSPath)(l);if(Ze.COMMON_FILES_FILTER.includes((0,I.basename)(l))||i.includes(g))continue;await C.Promises.exists(g)&&(a.push(g),o++)}}a.reverse().forEach(r=>S.app.addRecentDocument(r)),i.reverse().forEach(r=>S.app.addRecentDocument(r))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=he([te(0,w.ILogService),te(1,u.IWorkspacesManagementMainService),te(2,h.ILifecycleMainService),te(3,p.IGlobalStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(Z[241],x([0,1,13,8,23,33,4,7,151,17,24,22,6,190,61,20,48,34,43,69,32,70]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let s=class kt{constructor(a,r,l,g,E,D,W,O,V,J,ne){this.updateService=a,this.configurationService=r,this.windowsMainService=l,this.environmentMainService=g,this.telemetryService=E,this.workspacesHistoryMainService=D,this.stateMainService=W,this.lifecycleMainService=O,this.logService=V,this.nativeHostMainService=J,this.productService=ne,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,v.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateMainService.getItem(kt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(D,W,O)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(D,W,O)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(D,W,O)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(D,W,O)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(D,W,O)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(O),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const r=this.productService.requestFeatureUrl;r&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(r,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const g=this.productService.licenseUrl;g&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const D=g.indexOf("?")>0?"&":"?";this.openUrl(`${g}${D}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(g,"openLicenseUrl")});const E=this.productService.privacyStatementUrl;E&&g&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(E,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,r){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateMainService.setItem(kt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!M.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=S.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(M.isMacintosh?new S.Menu:null);return}const r=new S.Menu;let l;if(M.isMacintosh){const E=new S.Menu;l=new S.MenuItem({label:this.productService.nameShort,submenu:E}),this.setMacApplicationMenu(E),r.append(l)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const E=new S.Menu;E.append(new S.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(E)}if(this.shouldDrawMenu("File")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:E});this.setMenuById(E,"File"),r.append(D)}if(this.shouldDrawMenu("Edit")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:E});this.setMenuById(E,"Edit"),r.append(D)}if(this.shouldDrawMenu("Selection")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:E});this.setMenuById(E,"Selection"),r.append(D)}if(this.shouldDrawMenu("View")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:E});this.setMenuById(E,"View"),r.append(D)}if(this.shouldDrawMenu("Go")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:E});this.setMenuById(E,"Go"),r.append(D)}if(this.shouldDrawMenu("Run")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:E});this.setMenuById(E,"Run"),r.append(D)}if(this.shouldDrawMenu("Terminal")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:E});this.setMenuById(E,"Terminal"),r.append(D)}let g;if(this.shouldDrawMenu("Window")){const E=new S.Menu;g=new S.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:E,role:"window"}),this.setMacWindowMenu(E)}if(g&&r.append(g),this.shouldDrawMenu("Help")){const E=new S.Menu,D=new S.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:E,role:"help"});this.setMenuById(E,"Help"),r.append(D)}r.items&&r.items.length>0?S.Menu.setApplicationMenu(r):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const r=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let g;if(this.shouldDrawMenu("Preferences")){const Y=new S.Menu;this.setMenuById(Y,"Preferences"),g=new S.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Y})}const E=new S.Menu,D=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:E}),W=new S.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),O=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),V=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),J=new S.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:async(Y,re,ae)=>{const H=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||H?.isMinimized())&&await this.confirmBeforeQuit(ae)&&this.nativeHostMainService.quit(void 0)}})),ne=[r];ne.push(...l),g&&ne.push(i(),g),ne.push(i(),D,i(),W,O,V,i(),J),ne.forEach(Y=>a.append(Y))}async confirmBeforeQuit(a){if(this.windowsMainService.getWindowCount()===0)return!0;const r=this.configurationService.getValue("window.confirmBeforeClose");if(r==="always"||r==="keyboardOnly"&&this.isKeyboardEvent(a)){const l={title:this.productService.nameLong,type:"question",buttons:[(0,L.mnemonicButtonLabel)(f.localize(17,null)),(0,L.mnemonicButtonLabel)(f.localize(18,null))],message:f.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:g}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,l);return g===0}return!0}shouldDrawMenu(a){if(!M.isMacintosh&&(0,v.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,r){r.forEach(l=>{if((0,m.isMenubarMenuItemSeparator)(l))a.append(i());else if((0,m.isMenubarMenuItemSubmenu)(l)){const g=new S.Menu,E=new S.MenuItem({label:this.mnemonicLabel(l.label),submenu:g});this.setMenu(g,l.submenu.items),a.append(E)}else(0,m.isMenubarMenuItemRecentAction)(l)?a.append(this.createOpenRecentMenuItem(l)):(0,m.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?a.append(new S.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):a.append(this.createMenuItem(l.label,l.id,!1,l.checked)):a.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):a.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(a,r){this.menubarMenus&&this.menubarMenus[r]&&this.setMenu(a,this.menubarMenus[r].items)}insertCheckForUpdatesItems(a){const r=this.getUpdateMenuItems();r.length&&(r.forEach(l=>a.append(l)),a.append(i()))}createOpenRecentMenuItem(a){const r=b.URI.revive(a.uri),l=a.id,g=l==="openRecentFile"?{fileUri:r}:l==="openRecentWorkspace"?{workspaceUri:r}:{folderUri:r};return new S.MenuItem(this.likeAction(l,{label:a.label,click:(E,D,W)=>{const O=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[g],forceNewWindow:O,gotoLineMode:!1,remoteAuthority:a.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([r])}},!1))}isOptionClick(a){return!!(a&&(!M.isMacintosh&&(a.ctrlKey||a.shiftKey)||M.isMacintosh&&(a.metaKey||a.altKey)))}isKeyboardEvent(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}createRoleMenuItem(a,r,l){const g={label:this.mnemonicLabel(a),role:l,enabled:!0};return new S.MenuItem(this.withKeybinding(r,g))}setMacWindowMenu(a){const r=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),g=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),E=this.createMenuItem(f.localize(23,null),"workbench.action.switchWindow"),D=[];this.currentEnableNativeTabs&&(D.push(i()),D.push(this.createMenuItem(f.localize(24,null),"workbench.action.newWindowTab")),D.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),D.push(this.createRoleMenuItem(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),D.push(this.createRoleMenuItem(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),D.push(this.createRoleMenuItem(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[r,l,i(),E,...D,i(),g].forEach(W=>a.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(f.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,r,l,g){const E=this.mnemonicLabel(a),D=typeof r=="function"?r:(ne,Y,re)=>{const ae=ne?ne.userSettingsLabel:null;let H=r;Array.isArray(r)&&(H=this.isOptionClick(re)?r[1]:r[0]),ae&&re.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ae}):this.runActionInRenderer({type:"commandId",commandId:H})},W=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,O=typeof g=="boolean"?g:!1,V={label:E,click:D,enabled:W};O&&(V.type="checkbox",V.checked=O);let J;return typeof r=="string"?J=r:Array.isArray(r)&&(J=r[0]),M.isMacintosh&&(J==="editor.action.clipboardCutAction"?V.role="cut":J==="editor.action.clipboardCopyAction"?V.role="copy":J==="editor.action.clipboardPasteAction"&&(V.role="paste"),J==="undo"?V.click=this.makeContextAwareClickHandler(D,{inDevTools:ne=>ne.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?V.click=this.makeContextAwareClickHandler(D,{inDevTools:ne=>ne.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(V.click=this.makeContextAwareClickHandler(D,{inDevTools:ne=>ne.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(J,V))}makeContextAwareClickHandler(a,r){return(l,g,E)=>{const D=S.BrowserWindow.getFocusedWindow();if(!D)return r.inNoWindow();if(D.webContents.isDevToolsFocused()&&D.webContents.devToolsWebContents)return r.inDevTools(D.webContents.devToolsWebContents);a(l,g||D,E)}}runActionInRenderer(a){let r=S.BrowserWindow.getFocusedWindow();if(!r){const g=this.windowsMainService.getLastActiveWindow();g?.isMinimized()&&(r=g.win)}const l=r?this.windowsMainService.getWindowById(r.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",a),M.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const g={id:a.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",R.CancellationToken.None,g)}else{const g={userSettingsLabel:a.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",R.CancellationToken.None,g)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,r){const l=typeof a=="string"?this.keybindings[a]:void 0;if(l?.label){if(l.isNative!==!1)r.accelerator=l.label,r.userSettingsLabel=l.userSettingsLabel;else if(typeof r.label=="string"){const g=r.label.indexOf("[");g>=0?r.label=`${r.label.substr(0,g)} [${l.label}]`:r.label=`${r.label} [${l.label}]`}}else r.accelerator=void 0;return r}likeAction(a,r,l=!r.accelerator){l&&(r=this.withKeybinding(a,r));const g=r.click;return r.click=(E,D,W)=>{this.reportMenuActionTelemetry(a),g&&g(E,D,W)},r}openUrl(a,r){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(r)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:n})}mnemonicLabel(a){return(0,L.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=he([te(0,P.IUpdateService),te(1,y.IConfigurationService),te(2,u.IWindowsMainService),te(3,I.IEnvironmentMainService),te(4,p.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,w.IStateMainService),te(7,k.ILifecycleMainService),te(8,C.ILogService),te(9,d.INativeHostMainService),te(10,h.IProductService)],s),e.Menubar=s;function i(){return new S.MenuItem({type:"separator"})}}),define(Z[242],x([0,1,5,22,6,241]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let M=class{constructor(f,y,I){this.instantiationService=f,this.lifecycleMainService=y,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(L.Menubar)}async updateMenubar(f,y){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(y,f)}};M=he([te(0,S.IInstantiationService),te(1,t.ILifecycleMainService),te(2,R.ILogService)],M),e.MenubarMainService=M}),define(Z[243],x([0,1,13,29,27,25,23,3,28,45,33,2,10,9,66,4,35,16,11,7,158,54,17,50,24,19,5,22,6,56,20,57,67,48,69,240,106,225,26,107,70,44,60,37]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n,s,i,o,a,r,l,g,E,D,W,O,V,J,ne,Y,re,ae,H,$,U,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(X){return(0,re.isWorkspaceIdentifier)(X?.workspace)}function ee(X){return(0,re.isSingleFolderWorkspaceIdentifier)(X?.workspace)}let Q=class at extends k.Disposable{constructor(T,A,_,z,F,B,K,ie,oe,ue,fe,Ie,be,le,de,Ce,me){super();this.machineId=T,this.initialUserEnv=A,this.logService=_,this.stateMainService=z,this.policyService=F,this.environmentMainService=B,this.lifecycleMainService=K,this.backupMainService=ie,this.configurationService=oe,this.workspacesHistoryMainService=ue,this.workspacesManagementMainService=fe,this.instantiationService=Ie,this.dialogMainService=be,this.fileService=le,this.productService=de,this.protocolMainService=Ce,this.themeMainService=me,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Y.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const A=new k.DisposableStore;if(A.add(b.Event.any(T.onDidClose,T.onDidDestroy)(()=>A.dispose())),T.config.extensionDevelopmentPath)for(const _ of T.config.extensionDevelopmentPath)A.add(this.protocolMainService.addValidFileRoot(_));T.config.extensionTestsPath&&A.add(this.protocolMainService.addValidFileRoot(T.config.extensionTestsPath))}}))}openEmptyWindow(T,A){let _=this.environmentMainService.args;const z=A?.remoteAuthority||void 0,F=!0,B=A?.forceReuseWindow,K=!B;return this.open({...T,cli:_,forceEmpty:F,forceNewWindow:K,forceReuseWindow:B,remoteAuthority:z})}openExistingWindow(T,A){T.focus(),this.handleWaitMarkerFile(A,[T])}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const A=[],_=[],z=[],F=[],B=[];let K,ie=0;const oe=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const be of oe)ee(be)?T.addMode?A.push(be):_.push(be):q(be)?z.push(be):be.fileUri?(K||(K={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:be.remoteAuthority}),K.filesToOpenOrCreate.push(be)):be.backupPath?B.push({backupFolder:(0,m.basename)(be.backupPath),remoteAuthority:be.remoteAuthority}):ie++;T.diffMode&&K&&K.filesToOpenOrCreate.length>=2&&(K.filesToDiff=K.filesToOpenOrCreate.slice(0,2),K.filesToOpenOrCreate=[]),K&&T.waitMarkerFileURI&&(K.filesToWait={paths:[...K.filesToDiff,...K.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?(F.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),z.push(...F),B.push(...this.backupMainService.getEmptyWindowBackupPaths())):B.length=0;const{windows:ue,filesOpenedInWindow:fe}=this.doOpen(T,z,_,B,ie,K,A);if(this.logService.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${_.length}, emptyToRestore: ${B.length}, emptyToOpen: ${ie})`),ue.length>1)if(fe)fe.focus();else{const be=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let le=!0,de=!0;if(be){const Ce=ue.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),le=!1,de=!1)}if(le)for(let Ce=ue.length-1;Ce>=0;Ce--){const me=ue[Ce];if(!(me.openedWorkspace&&F.some(Se=>me.openedWorkspace&&Se.workspace.id===me.openedWorkspace.id)||me.backupPath&&B.some(Se=>me.backupPath&&Se.backupFolder===(0,m.basename)(me.backupPath)))){me.focus(),de=!1;break}}de&&ue[ue.length-1].focus()}const Ie=K&&K.filesToDiff.length>0;if(!ue.some(be=>be.isExtensionDevelopmentHost)&&!Ie&&!T.noRecentEntry){const be=[];for(const le of oe)q(le)&&!le.transient?be.push({label:le.label,workspace:le.workspace,remoteAuthority:le.remoteAuthority}):ee(le)?be.push({label:le.label,folderUri:le.workspace.uri,remoteAuthority:le.remoteAuthority}):le.fileUri&&be.push({label:le.label,fileUri:le.fileUri,remoteAuthority:le.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(be)}return this.handleWaitMarkerFile(T,ue),ue}handleWaitMarkerFile(T,A){const _=T.waitMarkerFileURI;T.context===0&&_&&A.length===1&&A[0]&&(async()=>{await A[0].whenClosedOrLoaded;try{await this.fileService.del(_)}catch{}})()}doOpen(T,A,_,z,F,B,K){const ie=[];let oe;function ue(me,Se){ie.push(me),Se&&(oe=me,B=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:Ie}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&K.length>0){const me=K[0].remoteAuthority,Se=this.getLastActiveWindowForAuthority(me);Se&&ue(this.doAddFoldersToExistingWindow(Se,K.map(De=>De.workspace.uri)))}const be=_.length+A.length+z.length;if(B&&be===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0],Se=this.getWindows().filter(Re=>B&&(0,p.isEqualAuthority)(Re.remoteAuthority,B.remoteAuthority));let De;me?.fileUri&&!Ie&&((T.context===4||T.context===0||T.context===1)&&(De=(0,ne.findWindowOnFile)(Se,me.fileUri,Re=>Re.configPath.scheme===C.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),De||(De=this.doGetLastActiveWindow(Se))),De?(0,re.isWorkspaceIdentifier)(De.openedWorkspace)?A.push({workspace:De.openedWorkspace,remoteAuthority:De.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(De.openedWorkspace)?_.push({workspace:De.openedWorkspace,remoteAuthority:De.remoteAuthority}):ue(this.doOpenFilesInExistingWindow(T,De,B),!0):ue(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const le=(0,L.distinct)(A,me=>me.workspace.id);if(le.length>0){const me=(0,L.coalesce)(le.map(Se=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.configPath)));if(me.length>0){const Se=me[0],De=(0,p.isEqualAuthority)(B?.remoteAuthority,Se.remoteAuthority)?B:void 0;ue(this.doOpenFilesInExistingWindow(T,Se,De),!!De),fe=!0}le.forEach(Se=>{if(me.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===Se.workspace.id))return;const De=Se.remoteAuthority,Re=(0,p.isEqualAuthority)(B?.remoteAuthority,De)?B:void 0;ue(this.doOpenFolderOrWorkspace(T,Se,fe,Re),!!Re),fe=!0})}const de=(0,L.distinct)(_,me=>p.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(de.length>0){const me=(0,L.coalesce)(de.map(Se=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Se.workspace.uri)));if(me.length>0){const Se=me[0],De=(0,p.isEqualAuthority)(B?.remoteAuthority,Se.remoteAuthority)?B:void 0;ue(this.doOpenFilesInExistingWindow(T,Se,De),!!De),fe=!0}de.forEach(Se=>{if(me.some(Te=>(0,re.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,Se.workspace.uri)))return;const De=Se.remoteAuthority,Re=(0,p.isEqualAuthority)(B?.remoteAuthority,De)?B:void 0;ue(this.doOpenFolderOrWorkspace(T,Se,fe,Re),!!Re),fe=!0})}const Ce=(0,L.distinct)(z,me=>me.backupFolder);if(Ce.length>0&&Ce.forEach(me=>{const Se=me.remoteAuthority,De=(0,p.isEqualAuthority)(B?.remoteAuthority,Se)?B:void 0;ue(this.doOpenEmpty(T,!0,Se,De,me),!!De),fe=!0}),ie.length===0||B){B&&!F&&F++;const me=B?B.remoteAuthority:T.remoteAuthority;for(let Se=0;Se<F;Se++)ue(this.doOpenEmpty(T,fe,me,B),!!B),fe=!0}return{windows:(0,L.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(T,A,_){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),A.focus();const z={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToWait:_?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return A.sendWhenReady("vscode:openFiles",M.CancellationToken.None,z),A}doAddFoldersToExistingWindow(T,A){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:A}),T.focus();const _={foldersToAdd:A};return T.sendWhenReady("vscode:addFolders",M.CancellationToken.None,_),T}doOpenEmpty(T,A,_,z,F){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!F,remoteAuthority:_,filesToOpen:z,forceNewWindow:A});let B;return!A&&typeof T.contextWindowId=="number"&&(B=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:_,forceNewWindow:A,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:z,windowToUse:B,emptyWindowBackupInfo:F})}doOpenFolderOrWorkspace(T,A,_,z,F){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:A,filesToOpen:z}),!_&&!F&&typeof T.contextWindowId=="number"&&(F=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:A.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:A.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:z,windowToUse:F})}getPathsToOpen(T){let A,_=!1,z=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(A=this.doExtractPathsFromAPI(T),_=!0):T.forceEmpty?A=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(A=this.doExtractPathsFromCLI(T.cli),A.length===0&&A.push(Object.create(null)),_=!0):(A=this.doGetPathsFromLastSession(),A.length===0&&A.push(Object.create(null)),z=!0),!T.addMode&&_){const F=A.filter(B=>ee(B));if(F.length>1){const B=F[0].remoteAuthority;if(F.every(K=>(0,p.isEqualAuthority)(K.remoteAuthority,B))){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(F.map(ie=>({uri:ie.workspace.uri})));A.push({workspace:K,remoteAuthority:B}),A=A.filter(ie=>!ee(ie))}}}return T.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&A.unshift(...this.doGetPathsFromLastSession().filter(F=>q(F)||ee(F)||F.backupPath)),A}doExtractPathsFromAPI(T){const A=[],_={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const z of(0,L.coalesce)(T.urisToOpen||[])){const F=this.resolveOpenable(z,_);if(F)F.label=z.label,A.push(F);else{const B=this.resourceFromOpenable(z),K={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:B.scheme===C.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:B.scheme===C.Schemas.file?(0,u.localize)(3,null,(0,I.getPathLabel)(B,{os:h.OS,tildify:this.environmentMainService})):(0,u.localize)(4,null,B.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(K,(0,P.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}}return A}doExtractPathsFromCLI(T){const A=[],_={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},z=T["folder-uri"];if(z)for(const K of z){const ie=this.cliArgToUri(K);if(ie){const oe=this.resolveOpenable({folderUri:ie},_);oe&&A.push(oe)}}const F=T["file-uri"];if(F)for(const K of F){const ie=this.cliArgToUri(K);if(ie){const oe=this.resolveOpenable((0,re.hasWorkspaceFileExtension)(K)?{workspaceUri:ie}:{fileUri:ie},_);oe&&A.push(oe)}}const B=T._;for(const K of B){const ie=_.remoteAuthority?this.doResolvePathRemote(K,_):this.doResolveFilePath(K,_);ie&&A.push(ie)}return A}cliArgToUri(T){try{const A=v.URI.parse(T);if(!A.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return A}catch(A){this.logService.error(`Invalid URI input string: ${T}, ${A.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":{const A=[];T!=="one"&&A.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&A.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const z of A)if(z.workspace){const F=this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});q(F)&&_.push(F)}else if(z.folderUri){const F=this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});ee(F)&&_.push(F)}else T!=="folders"&&z.backupPath&&_.push({backupPath:z.backupPath,remoteAuthority:z.remoteAuthority});return _}}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}resolveOpenable(T,A=Object.create(null)){let _=this.resourceFromOpenable(T);return _.scheme===C.Schemas.file?((0,V.isFileToOpen)(T)&&(A={...A,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(_.fsPath,A)):this.doResolveRemoteOpenable(T,A)}doResolveRemoteOpenable(T,A){let _=this.resourceFromOpenable(T);const z=(0,W.getRemoteAuthority)(_)||A.remoteAuthority;if(_=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(_)),(0,V.isFileToOpen)(T)){if(A.gotoLineMode){const{path:F,line:B,column:K}=(0,f.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:F}),options:{selection:B?{startLineNumber:B,startColumn:K||1}:void 0},remoteAuthority:z}}return{fileUri:_,remoteAuthority:z}}else if((0,V.isWorkspaceToOpen)(T))return{workspace:(0,ae.getWorkspaceIdentifier)(_),remoteAuthority:z};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:z}}resourceFromOpenable(T){return(0,V.isWorkspaceToOpen)(T)?T.workspaceUri:(0,V.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,A){let _,z;A.gotoLineMode&&({path:T,line:_,column:z}=(0,f.parseLineAndColumnAware)(T)),T=(0,f.sanitizeFilePath)((0,m.normalize)(T),(0,w.cwd)());try{const F=(0,t.statSync)(T);if(F.isFile()){if(!A.forceOpenWorkspaceAsFile){const B=this.workspacesManagementMainService.resolveLocalWorkspaceSync(v.URI.file(T));if(B)return B.transient&&A.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:o.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:v.URI.file(T),type:o.FileType.File,exists:!0,options:{selection:_?{startLineNumber:_,startColumn:z||1}:void 0}}}else{if(F.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(v.URI.file(T),F),type:o.FileType.Directory,exists:!0};if(!h.isWindows&&T==="/dev/null")return{fileUri:v.URI.file(T),type:o.FileType.File,exists:!0}}}catch{const B=v.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([B]),A.ignoreFileNotFound)return{fileUri:B,type:o.FileType.File,exists:!1}}}doResolvePathRemote(T,A){const _=T.charCodeAt(0),z=A.remoteAuthority;let F,B;A.gotoLineMode&&({path:T,line:F,column:B}=(0,f.parseLineAndColumnAware)(T)),_!==47&&((0,f.isWindowsDriveLetter)(_)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,f.toSlashes)(T)),T=`/${T}`);const K=v.URI.from({scheme:C.Schemas.vscodeRemote,authority:z,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(T))return A.forceOpenWorkspaceAsFile?{fileUri:K,options:{selection:F?{startLineNumber:F,startColumn:B||1}:void 0},remoteAuthority:A.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(K),remoteAuthority:z};if(A.gotoLineMode||m.posix.basename(T).indexOf(".")!==-1)return{fileUri:K,options:{selection:F?{startLineNumber:F,startColumn:B||1}:void 0},remoteAuthority:z}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(K),remoteAuthority:z}}shouldOpenNewWindow(T){const A=this.configurationService.getValue("window"),_=A?.openFoldersInNewWindow||"default",z=A?.openFilesInNewWindow||"off";let F=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(_==="on"||_==="off")&&(F=_==="on");let B=!1;return T.forceNewWindow||T.forceReuseWindow?B=!!T.forceNewWindow&&!T.forceReuseWindow:(h.isMacintosh?T.context===1&&(B=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!T.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(B=z==="on")),{openFolderInNewWindow:!!F,openFilesInNewWindow:B}}openExtensionDevelopmentHostWindow(T,A){const _=(0,ne.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(_)return this.lifecycleMainService.reload(_,A.cli),_.focus(),[_];let z=A.cli["folder-uri"]||[],F=A.cli["file-uri"]||[],B=A.cli._;if(!B.length&&!z.length&&!F.length&&!A.cli.extensionTestsPath){const ue=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,fe=ue&&(ue.workspace||ue.folderUri);fe&&(v.URI.isUri(fe)?fe.scheme===C.Schemas.file?B=[fe.fsPath]:z=[fe.toString()]:fe.configPath.scheme===C.Schemas.file?B=[(0,p.originalFSPath)(fe.configPath)]:F=[fe.configPath.toString()])}let K=A.remoteAuthority;for(const ue of T)if(ue.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const fe=v.URI.parse(ue),Ie=(0,W.getRemoteAuthority)(fe);Ie&&(K?(0,p.isEqualAuthority)(Ie,K)||this.logService.error("more than one extension development path authority"):K=Ie)}B=B.filter(ue=>{const fe=v.URI.file(ue);return(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:(0,p.isEqualAuthority)((0,W.getRemoteAuthority)(fe),K)}),z=z.filter(ue=>{const fe=this.cliArgToUri(ue);return fe&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,p.isEqualAuthority)((0,W.getRemoteAuthority)(fe),K):!1}),F=F.filter(ue=>{const fe=this.cliArgToUri(ue);return fe&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe)?!1:fe?(0,p.isEqualAuthority)((0,W.getRemoteAuthority)(fe),K):!1}),A.cli._=B,A.cli["folder-uri"]=z,A.cli["file-uri"]=F;const ie=!B.length&&!z.length&&!F.length,oe={context:A.context,cli:A.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:A.userEnv,noRecentEntry:!0,waitMarkerFileURI:A.waitMarkerFileURI,remoteAuthority:K};return this.open(oe)}openInBrowserWindow(T){const A=this.configurationService.getValue("window"),_={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,m.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:g.default,isInitialStartup:T.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof A?.zoomLevel=="number"?A.zoomLevel:void 0,autoDetectHighContrast:A?.autoDetectHighContrast??!0,autoDetectColorScheme:A?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let z;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(z=T.windowToUse||this.getLastActiveWindow(),z&&z.focus()),z){const F=z.config;!_.extensionDevelopmentPath&&F&&!!F.extensionDevelopmentPath&&(_.extensionDevelopmentPath=F.extensionDevelopmentPath,_.verbose=F.verbose,_["inspect-brk-extensions"]=F["inspect-brk-extensions"],_.debugId=F.debugId,_.extensionEnvironment=F.extensionEnvironment,_["inspect-extensions"]=F["inspect-extensions"],_["extensions-dir"]=F["extensions-dir"])}else{const F=this.windowsStateHandler.getNewWindowState(_);(0,d.mark)("code/willCreateCodeWindow");const B=z=this.instantiationService.createInstance(J.CodeWindow,{state:F,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(B)}at.WINDOWS.push(B),this._onDidOpenWindow.fire(B),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,y.once)(B.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(B)),(0,y.once)(B.onDidClose)(()=>this.onWindowClosed(B)),(0,y.once)(B.onDidDestroy)(()=>this._onDidDestroyWindow.fire(B));const K=(0,P.assertIsDefined)(B.win?.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(B)),this.lifecycleMainService.registerWindow(B)}return _.windowId=z.id,z.isReady?this.lifecycleMainService.unload(z,4).then(F=>{F||this.doOpenInBrowserWindow(z,_,T)}):this.doOpenInBrowserWindow(z,_,T),z}doOpenInBrowserWindow(T,A,_){if(!A.extensionDevelopmentPath)if((0,re.isWorkspaceIdentifier)(A.workspace))A.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:A.workspace,remoteAuthority:A.remoteAuthority});else if((0,re.isSingleFolderWorkspaceIdentifier)(A.workspace))A.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:A.workspace.uri,remoteAuthority:A.remoteAuthority});else{const z=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;A.backupPath=this.backupMainService.registerEmptyWindowBackupSync(z,A.remoteAuthority)}T.load(A)}onWindowClosed(T){const A=at.WINDOWS.indexOf(T);at.WINDOWS.splice(A,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=S.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(A=>(0,p.isEqualAuthority)(A.remoteAuthority,T)))}doGetLastActiveWindow(T){const A=Math.max.apply(Math,T.map(_=>_.lastFocusTime));return T.find(_=>_.lastFocusTime===A)}sendToFocused(T,...A){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(T,M.CancellationToken.None,...A)}sendToAll(T,A,_){for(const z of this.getWindows())_&&_.indexOf(z.id)>=0||z.sendWhenReady(T,M.CancellationToken.None,A)}getWindows(){return at.WINDOWS}getWindowCount(){return at.WINDOWS.length}getWindowById(T){const A=this.getWindows().filter(_=>_.id===T);return(0,L.firstOrDefault)(A)}getWindowByWebContents(T){const A=S.BrowserWindow.fromWebContents(T);if(!!A)return this.getWindowById(A.id)}};Q.WINDOWS=[],Q=he([te(2,l.ILogService),te(3,O.IStateMainService),te(4,N.IPolicyService),te(5,i.IEnvironmentMainService),te(6,r.ILifecycleMainService),te(7,c.IBackupMainService),te(8,n.IConfigurationService),te(9,H.IWorkspacesHistoryMainService),te(10,$.IWorkspacesManagementMainService),te(11,a.IInstantiationService),te(12,s.IDialogMainService),te(13,o.IFileService),te(14,E.IProductService),te(15,D.IProtocolMainService),te(16,U.IThemeMainService)],Q),e.WindowsMainService=Q}),define(Z[244],x([0,1,54,32,70,44]),function(j,e,S,t,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(f,y,I,k){this.workspacesManagementMainService=f,this.windowsMainService=y,this.workspacesHistoryMainService=I,this.backupMainService=k,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,y){const I=this.windowsMainService.getWindowById(f);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(f,y,I){return this.workspacesManagementMainService.createUntitledWorkspace(y,I)}deleteUntitledWorkspace(f,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(f,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}removeRecentlyOpened(f,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=he([te(0,L.IWorkspacesManagementMainService),te(1,t.IWindowsMainService),te(2,R.IWorkspacesHistoryMainService),te(3,S.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Z[245],x([0,1,13,38,29,27,18,41,15,28,45,46,33,2,10,9,4,11,7,31,75,130,40,131,92,218,139,54,228,17,64,167,78,108,50,95,165,24,53,101,173,193,174,220,96,175,176,19,186,80,77,5,79,237,203,109,22,6,188,242,61,20,67,232,81,48,223,84,204,34,206,208,68,43,212,235,238,236,239,104,213,214,215,216,221,32,243,222,26,82,70,244,44,219,37,192]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n,s,i,o,a,r,l,g,E,D,W,O,V,J,ne,Y,re,ae,H,$,U,N,q,ee,Q,X,T,A,_,z,F,B,K,ie,oe,ue,fe,Ie,be,le,de,Ce,me,Se,De,Re,Te,Ae,Ue,Ve,Qe,$e,Xe,rt,Ge,nt,G,se,ce,we,ye,Me,ze,xe,Je,Be,Ke,Ye,st,ct,Mt,At,Wt,Tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let yt=class extends m.Disposable{constructor(ge,ve,Ee,pe,ke,Oe,Le,We,Pe,Fe){super();this.mainProcessNodeIpcServer=ge,this.userEnv=ve,this.mainInstantiationService=Ee,this.logService=pe,this.environmentMainService=ke,this.lifecycleMainService=Oe,this.configurationService=Le,this.stateMainService=We,this.fileService=Pe,this.productService=Fe,this.configureSession(),this.registerListeners()}configureSession(){const ge=Pe=>Pe?.startsWith(`${d.Schemas.vscodeWebview}://`),ve=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Pe,Fe,_e,He)=>ge(He.requestingUrl)?_e(ve.has(Fe)):_e(!1)),S.session.defaultSession.setPermissionCheckHandler((Pe,Fe,_e,He)=>ge(He.requestingUrl)?ve.has(Fe):!1);const Ee=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),pe=Pe=>{for(let Fe=Pe;Fe;Fe=Fe.parent)if(Fe.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},ke=Pe=>Pe.resourceType==="xhr"||pe(Pe.frame),Oe=Pe=>{const Fe=Pe.frame;if(!Fe||!this.windowsMainService)return!1;const _e=S.BrowserWindow.getAllWindows();for(const He of _e)if(Fe.processId===He.webContents.mainFrame.processId)return!0;return!1},Le=(Pe,Fe)=>{if(Pe.path!=="/index.html")return!0;const _e=Fe.frame;if(!_e||!this.windowsMainService)return!1;for(const He of this.windowsMainService.getWindows())if(He.win&&_e.processId===He.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Pe,Fe)=>{const _e=P.URI.parse(Pe.url);return _e.scheme===d.Schemas.vscodeWebview&&!Le(_e,Pe)?(this.logService.error("Blocked vscode-webview request",Pe.url),Fe({cancel:!0})):_e.scheme===d.Schemas.vscodeFileResource&&!Oe(Pe)?(this.logService.error("Blocked vscode-file request",Pe.url),Fe({cancel:!0})):_e.path.endsWith(".svg")&&!Ee.has(_e.scheme)?Fe({cancel:!ke(Pe)}):Fe({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Pe,Fe)=>{const _e=Pe.responseHeaders,He=_e["content-type"]||_e["Content-Type"];if(He&&Array.isArray(He)){const et=P.URI.parse(Pe.url);if(et.path.endsWith(".svg")&&Ee.has(et.scheme))return _e["Content-Type"]=["image/svg+xml"],Fe({cancel:!1,responseHeaders:_e});if(!et.path.endsWith(d.Schemas.vscodeRemoteResource)&&He.some(lt=>lt.toLowerCase().includes("image/svg")))return Fe({cancel:!ke(Pe)})}return Fe({cancel:!1})});const We=S.session.defaultSession;typeof We.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&We.setCodeCachePath((0,h.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,f.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,f.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,f.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(Ee,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),S.app.on("activate",(Ee,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Ee,pe)=>{pe.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),pe.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let ge=[],ve;S.app.on("open-file",(Ee,pe)=>{this.logService.trace("app#open-file: ",pe),Ee.preventDefault(),ge.push(this.getWindowOpenableFromPathSync(pe)),ve!==void 0&&(clearTimeout(ve),ve=void 0),ve=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ge,gotoLineMode:!1,preferNewWindow:!0}),ge=[],ve=void 0},100)}),S.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Ee=>{const pe=this.windowsMainService?.getWindowByWebContents(Ee.sender);let ke,Oe;return pe?.config?(ke=pe.config,Oe={...process.env,...pe.config.userEnv}):(ke=this.environmentMainService.args,Oe=process.env),this.resolveShellEnvironment(ke,Oe,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Ee,pe,ke)=>{const Oe=this.validateNlsPath([pe]);if(!Oe||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Oe,M.VSBuffer.fromString(ke))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Ee,...pe)=>{const ke=this.validateNlsPath(pe);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(ge){let ve;for(const Ee of ge)typeof Ee=="string"&&(typeof ve!="string"?ve=Ee:ve=(0,h.join)(ve,Ee));if(!(typeof ve!="string"||!(0,h.isAbsolute)(ve)||!(0,y.isEqualOrParent)(ve,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return P.URI.file(ve)}onUnexpectedError(ge){if(ge){const ve={message:`[uncaught exception in main]: ${ge.message}`,stack:ge.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ve))}this.logService.error(`[uncaught exception in main]: ${ge}`),ge.stack&&this.logService.error(ge.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ge=this.productService.win32AppUserModelId;w.isWindows&&ge&&S.app.setAppUserModelId(ge);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const ve=new s.Server;this.lifecycleMainService.onWillShutdown(Pe=>{Pe.reason===2&&ve.dispose()}),this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:pe,sharedProcessReady:ke,sharedProcessClient:Oe}=this.setupSharedProcess(Ee),Le=await this.initServices(Ee,pe,ke);this._register(Le.createInstance(o.ProxyAuthHandler)),Le.invokeFunction(Pe=>this.initChannels(Pe,ve,Oe));const We=Le.invokeFunction(Pe=>this.openFirstWindow(Pe,ve));Le.invokeFunction(Pe=>this.afterWindowOpen(Pe,pe)),this.environmentMainService.args.trace&&Le.invokeFunction(Pe=>this.stopTracingEventually(Pe,We))}async resolveMachineId(){let ge=this.stateMainService.getItem(Ae.machineIdKey);return(!ge||w.isMacintosh&&ge==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ge=await(0,u.getMachineId)(),this.stateMainService.setItem(Ae.machineIdKey,ge)),ge}setupSharedProcess(ge){const ve=this._register(this.mainInstantiationService.createInstance(Ce.SharedProcess,ge,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ve.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(ke,"main")})(),pe=(async()=>(await ve.whenReady(),Ee))();return{sharedProcess:ve,sharedProcessReady:pe,sharedProcessClient:Ee}}async initServices(ge,ve,Ee){const pe=new F.ServiceCollection;switch(process.platform){case"win32":pe.set($e.IUpdateService,new _.SyncDescriptor(G.Win32UpdateService));break;case"linux":w.isLinuxSnap?pe.set($e.IUpdateService,new _.SyncDescriptor(nt.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set($e.IUpdateService,new _.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":pe.set($e.IUpdateService,new _.SyncDescriptor(rt.DarwinUpdateService));break}pe.set(xe.IWindowsMainService,new _.SyncDescriptor(Je.WindowsMainService,[ge,this.userEnv])),pe.set(V.IDialogMainService,new _.SyncDescriptor(V.DialogMainService)),pe.set(ie.ILaunchMainService,new _.SyncDescriptor(ie.LaunchMainService)),pe.set(O.IDiagnosticsMainService,new _.SyncDescriptor(O.DiagnosticsMainService)),pe.set(W.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Ee.then(Oe=>Oe.getChannel("diagnostics"))))),pe.set(B.IIssueMainService,new _.SyncDescriptor(B.IssueMainService,[this.userEnv])),pe.set(J.IEncryptionMainService,new _.SyncDescriptor(ne.EncryptionMainService,[ge])),pe.set(K.IKeyboardLayoutMainService,new _.SyncDescriptor(K.KeyboardLayoutMainService)),pe.set(be.INativeHostMainService,new _.SyncDescriptor(be.NativeHostMainService,[ve])),pe.set(E.ICredentialsMainService,new _.SyncDescriptor(At.CredentialsNativeMainService)),pe.set(Me.IWebviewManagerService,new _.SyncDescriptor(ze.WebviewMainService)),pe.set(Ye.IWorkspacesService,new _.SyncDescriptor(ct.WorkspacesMainService)),pe.set(Mt.IWorkspacesManagementMainService,new _.SyncDescriptor(Mt.WorkspacesManagementMainService)),pe.set(st.IWorkspacesHistoryMainService,new _.SyncDescriptor(st.WorkspacesHistoryMainService)),pe.set(Ie.IMenubarMainService,new _.SyncDescriptor(Ie.MenubarMainService)),pe.set(H.IExtensionUrlTrustService,new _.SyncDescriptor($.ExtensionUrlTrustService)),pe.set(U.IExtensionHostStarter,new _.SyncDescriptor(N.ExtensionHostStarter)),pe.set(Re.IStorageMainService,new _.SyncDescriptor(Re.StorageMainService)),pe.set(Re.IGlobalStorageMainService,new _.SyncDescriptor(Re.GlobalStorageMainService)),w.isWindows?pe.set(q.IExternalTerminalMainService,new _.SyncDescriptor(ee.WindowsExternalTerminalService)):w.isMacintosh?pe.set(q.IExternalTerminalMainService,new _.SyncDescriptor(ee.MacExternalTerminalService)):w.isLinux&&pe.set(q.IExternalTerminalMainService,new _.SyncDescriptor(ee.LinuxExternalTerminalService));const ke=new l.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(r.IBackupMainService,ke),pe.set(se.IURLService,new _.SyncDescriptor(we.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const Oe=(0,n.getDelayedChannel)(Ee.then(_e=>_e.getChannel("telemetryAppender"))),Le=new Ue.TelemetryAppenderClient(Oe),We=(0,Te.resolveCommonProperties)(this.fileService,(0,L.release)(),(0,L.hostname)(),process.arch,this.productService.commit,this.productService.version,ge,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=(0,Qe.getPiiPathsFromEnvironment)(this.environmentMainService),Fe={appenders:[Le],commonProperties:We,piiPaths:Pe,sendErrorTelemetry:!0};pe.set(Ae.ITelemetryService,new _.SyncDescriptor(Ve.TelemetryService,[Fe]))}else pe.set(Ae.ITelemetryService,Qe.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(ge,ve,Ee){const pe=n.ProxyChannel.fromService(ge.get(ie.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe);const ke=n.ProxyChannel.fromService(ge.get(O.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",ke);const Oe=new Tt.PolicyChannel(ge.get(Wt.IPolicyService));ve.registerChannel("policy",Oe),Ee.then(je=>je.registerChannel("policy",Oe));const Le=this.fileService.getProvider(d.Schemas.file);(0,p.assertType)(Le instanceof A.DiskFileSystemProvider);const We=new T.DiskFileSystemProviderChannel(Le,this.logService,this.environmentMainService);ve.registerChannel(Q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,We),Ee.then(je=>je.registerChannel(Q.LOCAL_FILE_SYSTEM_CHANNEL_NAME,We));const Pe=new Xe.UpdateChannel(ge.get($e.IUpdateService));ve.registerChannel("update",Pe);const Fe=n.ProxyChannel.fromService(ge.get(B.IIssueMainService));ve.registerChannel("issue",Fe);const _e=n.ProxyChannel.fromService(ge.get(J.IEncryptionMainService));ve.registerChannel("encryption",_e);const He=n.ProxyChannel.fromService(ge.get(E.ICredentialsMainService));ve.registerChannel("credentials",He);const et=n.ProxyChannel.fromService(ge.get(me.ISignService));ve.registerChannel("sign",et);const lt=n.ProxyChannel.fromService(ge.get(K.IKeyboardLayoutMainService));ve.registerChannel("keyboardLayout",lt),this.nativeHostMainService=ge.get(be.INativeHostMainService);const mt=n.ProxyChannel.fromService(this.nativeHostMainService);ve.registerChannel("nativeHost",mt),Ee.then(je=>je.registerChannel("nativeHost",mt));const qe=n.ProxyChannel.fromService(ge.get(Ye.IWorkspacesService));ve.registerChannel("workspaces",qe);const wt=n.ProxyChannel.fromService(ge.get(Ie.IMenubarMainService));ve.registerChannel("menubar",wt);const ut=n.ProxyChannel.fromService(ge.get(se.IURLService));ve.registerChannel("url",ut);const ht=n.ProxyChannel.fromService(ge.get(H.IExtensionUrlTrustService));ve.registerChannel("extensionUrlTrust",ht);const pt=n.ProxyChannel.fromService(ge.get(Me.IWebviewManagerService));ve.registerChannel("webview",pt);const dt=this._register(new De.StorageDatabaseChannel(this.logService,ge.get(Re.IStorageMainService)));ve.registerChannel("storage",dt),Ee.then(je=>je.registerChannel("storage",dt));const ft=n.ProxyChannel.fromService(ge.get(q.IExternalTerminalMainService));ve.registerChannel("externalTerminal",ft);const ot=new fe.LogLevelChannel(ge.get(ue.ILogService));ve.registerChannel("logLevel",ot),Ee.then(je=>je.registerChannel("logLevel",ot));const gt=new fe.LoggerChannel(ge.get(ue.ILoggerService));ve.registerChannel("logger",gt),Ee.then(je=>je.registerChannel("logger",gt));const Ne=new D.ElectronExtensionHostDebugBroadcastChannel(ge.get(xe.IWindowsMainService));ve.registerChannel("extensionhostdebugservice",Ne);const tt=n.ProxyChannel.fromService(ge.get(U.IExtensionHostStarter));ve.registerChannel(U.ipcExtensionHostStarterChannelName,tt)}openFirstWindow(ge,ve){const Ee=this.windowsMainService=ge.get(xe.IWindowsMainService),pe=ge.get(se.IURLService),ke=ge.get(be.INativeHostMainService);this.lifecycleMainService.phase=2;const Oe=[],Le=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ne=>{try{return{uri:P.URI.parse(Ne),url:Ne}}catch{return}}).filter(Ne=>{if(!Ne||this.shouldBlockURI(Ne.uri))return!1;const tt=this.getWindowOpenableFromProtocolLink(Ne.uri);return tt?(Oe.push(tt),!1):!0}),We=this,Pe=this.environmentMainService,Fe=this.productService,_e=this.logService;pe.registerHandler({async handleURL(Ne,tt){if(_e.trace("app#handleURL: ",Ne.toString(!0),tt),Ne.scheme===Fe.urlProtocol&&Ne.path==="workspace"&&(Ne=Ne.with({authority:"file",path:P.URI.parse(Ne.query).path,query:""})),We.shouldBlockURI(Ne))return!0;let je=!1;const bt=new URLSearchParams(Ne.query);bt.get("windowId")==="_blank"&&(bt.delete("windowId"),Ne=Ne.with({query:bt.toString()}),je=!0),je||(je=w.isMacintosh&&Ee.getWindowCount()===0);const Et=We.getWindowOpenableFromProtocolLink(Ne);if(_e.trace("app#handleURL: windowOpenableFromProtocolLink = ",Et),Et){const[Ct]=Ee.open({context:5,cli:{...Pe.args},urisToOpen:[Et],forceNewWindow:je,gotoLineMode:!0});return Ct.focus(),!0}if(je){const[Ct]=Ee.open({context:5,cli:{...Pe.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(Ne)});return await Ct.ready(),pe.open(Ne,tt)}return!1}});const He=this._register(new Be.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),et=new n.StaticRouter(Ne=>He.getActiveClientId().then(tt=>Ne===tt)),lt=new ce.URLHandlerRouter(et),mt=ve.getChannel("urlHandler",lt);pe.registerHandler(new ce.URLHandlerChannelClient(mt)),this._register(new ye.ElectronURLListener(Le,pe,Ee,this.environmentMainService,this.productService));const qe=this.environmentMainService.args,wt=global.macOpenFiles,ut=(0,re.isLaunchedFromCli)(process.env)?0:4,ht=qe._.length,pt=!!qe["folder-uri"],dt=!!qe["file-uri"],ft=qe["skip-add-to-recently-opened"]===!0,ot=qe.wait&&qe.waitMarkerFilePath?P.URI.file(qe.waitMarkerFilePath):void 0,gt=qe.remote||void 0;return Oe.length>0?Ee.open({context:ut,cli:qe,urisToOpen:Oe,gotoLineMode:!0,initialStartup:!0}):qe["new-window"]&&!ht&&!pt&&!dt?Ee.open({context:ut,cli:qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:ft,waitMarkerFileURI:ot,initialStartup:!0,remoteAuthority:gt}):wt.length&&!ht&&!pt&&!dt?Ee.open({context:1,cli:qe,urisToOpen:wt.map(Ne=>this.getWindowOpenableFromPathSync(Ne)),noRecentEntry:ft,waitMarkerFileURI:ot,initialStartup:!0}):Ee.open({context:ut,cli:qe,forceNewWindow:qe["new-window"]||!ht&&qe["unity-launch"],diffMode:qe.diff,noRecentEntry:ft,waitMarkerFileURI:ot,gotoLineMode:qe.goto,initialStartup:!0,remoteAuthority:gt})}shouldBlockURI(ge){return!!(ge.authority===d.Schemas.file&&w.isWindows&&S.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,C.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,C.getPathLabel)(ge,{os:w.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ge){if(!!ge.path){if(ge.authority===d.Schemas.file){const ve=P.URI.file(ge.fsPath);return(0,Ke.hasWorkspaceFileExtension)(ve)?{workspaceUri:ve}:{fileUri:ve}}else if(ge.authority===d.Schemas.vscodeRemote){const ve=ge.path.indexOf(h.posix.sep,1);if(ve!==-1){const Ee=ge.path.substring(1,ve),pe=ge.path.substring(ve),ke=P.URI.from({scheme:d.Schemas.vscodeRemote,authority:Ee,path:pe,query:ge.query,fragment:ge.fragment});return(0,Ke.hasWorkspaceFileExtension)(pe)?{workspaceUri:ke}:/:[\d]+$/.test(pe)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(ge){try{if((0,R.statSync)(ge).isDirectory())return{folderUri:P.URI.file(ge)};if((0,Ke.hasWorkspaceFileExtension)(ge))return{workspaceUri:P.URI.file(ge)}}catch{}return{fileUri:P.URI.file(ge)}}async afterWindowOpen(ge,ve){this.lifecycleMainService.phase=3;let Ee=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const pe=ge.get(Ae.ITelemetryService);this._register(ve.onDidError(({type:Le,details:We})=>{let Pe;switch(Le){case 1:Pe="SharedProcess: detected unresponsive window";break;case 2:Pe=`SharedProcess: crashed (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break;case 3:Pe=`SharedProcess: failed to load (detail: ${We?.reason??"<unknown>"}, code: ${We?.exitCode??"<unknown>"})`;break}(0,f.onUnexpectedError)(new Error(Pe)),pe.publicLog2("sharedprocesserror",{type:Le,reason:We?.reason,code:We?.exitCode,visible:ve.isVisible(),shuttingdown:Ee})}));const ke=this.productService.win32MutexName;if(w.isWindows&&ke)try{const Le=j.__$__nodeRequire("windows-mutex").Mutex,We=new Le(ke);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>We.release())}catch(Le){this.logService.error(Le)}S.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(Le,We)=>{We({url:Le.url.replace(/^vscode-remote-resource:/,"http:"),method:Le.method})});const Oe=ge.get($e.IUpdateService);(Oe instanceof G.Win32UpdateService||Oe instanceof Ge.LinuxUpdateService||Oe instanceof rt.DarwinUpdateService)&&Oe.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const We=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,k.stripComments)(We))["enable-crash-reporter"]===void 0){const _e=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,v.generateUuid)()}"`,"}"],et=We.substring(0,We.length-2).concat(`,
`,He.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(et))}}catch(Le){this.logService.error(Le)}}async resolveShellEnvironment(ge,ve,Ee){try{return await(0,ae.getResolvedShellEnv)(this.logService,ge,ve)}catch(pe){const ke=(0,b.toErrorMessage)(pe);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(ge,ve){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=ge.get(V.IDialogMainService);let pe=!1;const ke=async Le=>{if(pe)return;pe=!0;const We=await S.contentTracing.stopRecording(`${(0,y.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Le?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${We}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,a.localize)(4,null),detail:(0,a.localize)(5,null,We),buttons:[(0,C.mnemonicButtonLabel)((0,a.localize)(6,null))],defaultId:0,noLink:!0},(0,p.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))},Oe=setTimeout(()=>ke(!0),3e4);Promise.all(ve.map(Le=>Le.ready())).then(()=>{clearTimeout(Oe),ke(!1)})}};yt=he([te(2,z.IInstantiationService),te(3,ue.ILogService),te(4,Y.IEnvironmentMainService),te(5,oe.ILifecycleMainService),te(6,g.IConfigurationService),te(7,Se.IStateMainService),te(8,X.IFileService),te(9,le.IProductService)],yt),e.CodeApplication=yt}),define(Z[251],x([0,1,13,29,7,25,8,41,15,28,45,33,10,9,66,4,35,30,21,40,83,245,12,17,197,205,24,53,170,19,184,80,77,181,79,22,98,6,189,99,56,20,57,194,103,234,59,231,81,202,48,233,68,60,37,226,191,2,211]),function(j,e,S,t,R,L,M,b,f,y,I,k,C,m,d,h,w,p,P,v,u,c,n,s,i,o,a,r,l,g,E,D,W,O,V,J,ne,Y,re,ae,H,$,U,N,q,ee,Q,X,T,A,_,z,F,B,K,ie,oe,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class fe{main(){try{this.startup()}catch(le){console.error(le.message),S.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[le,de,Ce,me,Se,De,Re,Te]=this.createServices();try{try{await this.initServices(Ce,me,Se,De)}catch(Ae){throw this.handleStartupDataDirError(Ce,Te.nameLong,Ae),Ae}await le.invokeFunction(async Ae=>{const Ue=Ae.get(Y.ILogService),Ve=Ae.get(J.ILifecycleMainService),Qe=Ae.get(g.IFileService),$e=await this.claimInstance(Ue,Ce,Ve,le,Te,!0);return P.Promises.writeFile(Ce.mainLockfile,String(process.pid)).catch(Xe=>{Ue.warn(`Error writing main lockfile: ${Xe.stack}`)}),Re.logger=new ae.SpdLogLogger("main",(0,m.join)(Ce.logsPath,"main.log"),!0,!1,Re.getLevel()),(0,I.once)(Ve.onWillShutdown)(Xe=>{Qe.dispose(),Se.dispose(),Xe.join(P.Promises.unlink(Ce.mainLockfile).catch(()=>{}))}),le.createInstance(c.CodeApplication,$e,de).startup()})}catch(Ae){le.invokeFunction(this.quit,Ae)}}createServices(){const le=new V.ServiceCollection,de=new ue.DisposableStore;process.once("exit",()=>de.dispose());const Ce={_serviceBrand:void 0,...H.default};le.set($.IProductService,Ce);const me=new a.EnvironmentMainService(this.resolveArgs(),Ce),Se=this.patchEnvironment(me);le.set(a.IEnvironmentMainService,me);const De=new ne.BufferLogService,Re=de.add(new Y.MultiplexLogService([new Y.ConsoleMainLogger((0,Y.getLogLevel)(me)),De]));le.set(Y.ILogService,Re);const Te=new E.FileService(Re);le.set(g.IFileService,Te);const Ae=new D.DiskFileSystemProvider(Re);Te.registerProvider(C.Schemas.file,Ae),le.set(Y.ILoggerService,new re.LoggerService(Re,Te));const Ue=h.isWindows&&Ce.win32RegValueName?de.add(new ie.NativePolicyService(Ce.win32RegValueName)):me.policyFile?de.add(new oe.FilePolicyService(me.policyFile,Te,Re)):new K.NullPolicyService;le.set(K.IPolicyService,Ue);const Ve=new i.ConfigurationService(me.settingsResource,Te,Ue,Re);le.set(s.IConfigurationService,Ve),le.set(J.ILifecycleMainService,new W.SyncDescriptor(J.LifecycleMainService));const Qe=new z.StateMainService(me,Re,Te);return le.set(_.IStateMainService,Qe),le.set(Q.IRequestService,new W.SyncDescriptor(X.RequestMainService)),le.set(B.IThemeMainService,new W.SyncDescriptor(B.ThemeMainService)),le.set(T.ISignService,new W.SyncDescriptor(A.SignService)),le.set(q.ITunnelService,new W.SyncDescriptor(ee.TunnelService)),le.set(U.IProtocolMainService,new W.SyncDescriptor(N.ProtocolMainService)),[new O.InstantiationService(le,!0),Se,me,Ue,Ve,Qe,De,Ce]}patchEnvironment(le){const de={VSCODE_IPC_HOOK:le.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ce=>{const me=process.env[Ce];typeof me=="string"&&(de[Ce]=me)}),Object.assign(process.env,de),de}initServices(le,de,Ce,me){return M.Promises.settled([Promise.all([le.extensionsPath,le.codeCachePath,le.logsPath,le.globalStorageHome.fsPath,le.workspaceStorageHome.fsPath,le.localHistoryHome.fsPath,le.backupHome].map(Se=>Se?P.Promises.mkdir(Se,{recursive:!0}):void 0)),Ce.initialize(),me.init()])}async claimInstance(le,de,Ce,me,Se,De){let Re;try{(0,d.mark)("code/willStartMainServer"),Re=await(0,u.serve)(de.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,I.once)(Ce.onWillShutdown)(()=>Re.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.handleStartupDataDirError(de,Se.nameLong,Te),Te;let Ae;try{Ae=await(0,u.connect)(de.mainIPCHandle,"main")}catch($e){if(!De||h.isWindows||$e.code!=="ECONNREFUSED")throw $e.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,Se.nameShort),(0,n.localize)(1,null),Se.nameLong),$e;try{(0,t.unlinkSync)(de.mainIPCHandle)}catch(Xe){throw le.warn("Could not delete obsolete instance handle",Xe),Xe}return this.claimInstance(le,de,Ce,me,Se,!1)}if(de.extensionTestsLocationURI&&!de.debugExtensionHost.break){const $e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw le.error($e),Ae.dispose(),new Error($e)}let Ue;!de.args.wait&&!de.args.status&&(Ue=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,Se.nameShort),(0,n.localize)(3,null),Se.nameLong)},1e4));const Ve=v.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Qe=v.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(de.args.status)return me.invokeFunction(async()=>{const $e=new o.DiagnosticsService(F.NullTelemetryService,Se),Xe=await Ve.getMainProcessInfo(),rt=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await $e.getDiagnostics(Xe,rt);throw console.log(Ge),new f.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Ve,le),le.trace("Sending env to running instance..."),await Ve.start(de.args,process.env),Ae.dispose(),Ue&&clearTimeout(Ue),new f.ExpectedError("Sent env to running instance. Terminating...")}if(de.args.status)throw le.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}handleStartupDataDirError(le,de,Ce){if(Ce.code==="EACCES"||Ce.code==="EPERM"){const me=(0,L.coalesce)([le.userDataPath,le.extensionsPath,u.XDG_RUNTIME_DIR]).map(Se=>(0,k.getPathLabel)(R.URI.file(Se),{os:h.OS,tildify:le}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,b.toErrorMessage)(Ce),me.join(`
`)),de)}}showStartupWarningDialog(le,de,Ce){S.dialog.showMessageBoxSync({title:Ce,type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,n.localize)(6,null))],message:le,detail:de,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(le,de){if(h.isWindows){const Ce=await le.getMainProcessId();de.trace("Sending some foreground love to the running instance:",Ce);try{(await new Promise((me,Se)=>{j(["windows-foreground-love"],me,Se)})).allowSetForegroundWindow(Ce)}catch(me){de.error(me)}}}quit(le,de){const Ce=le.get(Y.ILogService),me=le.get(J.ILifecycleMainService);let Se=0;de&&(de.isExpected?de.message&&Ce.trace(de.message):(Se=1,de.stack?Ce.error(de.stack):Ce.error(`Startup error: ${de.toString()}`))),me.kill(Se)}resolveArgs(){const le=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(le.wait&&!le.waitMarkerFilePath){const de=(0,l.createWaitMarkerFile)(le.verbose);de&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",de),le.waitMarkerFilePath=de)}return le}validatePaths(le){if(le["open-url"]&&(le._urls=le._,le._=[]),!le.remote){const de=this.doValidatePaths(le._,le.goto);le._=de}return le}doValidatePaths(le,de){const Ce=(0,w.cwd)(),me=le.map(Re=>{let Te=String(Re),Ae;de&&(Ae=(0,y.parseLineAndColumnAware)(Te),Te=Ae.path),Te&&(Te=this.preparePath(Ce,Te));const Ue=(0,y.sanitizeFilePath)(Te,Ce),Ve=(0,m.basename)(Ue);return Ve&&!(0,y.isValidBasename)(Ve)?null:de&&Ae?(Ae.path=Ue,this.toPath(Ae)):Ue}),Se=h.isWindows||h.isMacintosh,De=(0,L.distinct)(me,Re=>Re&&Se?Re.toLowerCase():Re||"");return(0,L.coalesce)(De)}preparePath(le,de){return h.isWindows&&(de=(0,p.rtrim)(de,'"')),de=(0,p.trim)((0,p.trim)(de," "),"	"),h.isWindows&&(de=(0,m.resolve)(le,de),de=(0,p.rtrim)(de,".")),de}toPath(le){const de=[le.path];return typeof le.line=="number"&&de.push(String(le.line)),typeof le.column=="number"&&de.push(String(le.column)),de.join(":")}}new fe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4af164ea3a06f701fe3e89a2bcbb421d2026b68f/core/vs/code/electron-main/main.js.map
